use ::prelude::*;
DEFINE_IID!(IID_ILowLevelDevicesAggregateProvider, 2805880348, 43713, 20167, 168, 82, 71, 159, 112, 96, 208, 31);
RT_INTERFACE!{interface ILowLevelDevicesAggregateProvider(ILowLevelDevicesAggregateProviderVtbl): IInspectable(IInspectableVtbl) [IID_ILowLevelDevicesAggregateProvider] {
    fn get_AdcControllerProvider(&self, out: *mut *mut adc::provider::IAdcControllerProvider) -> HRESULT,
    fn get_PwmControllerProvider(&self, out: *mut *mut pwm::provider::IPwmControllerProvider) -> HRESULT,
    fn get_GpioControllerProvider(&self, out: *mut *mut gpio::provider::IGpioControllerProvider) -> HRESULT,
    fn get_I2cControllerProvider(&self, out: *mut *mut i2c::provider::II2cControllerProvider) -> HRESULT,
    fn get_SpiControllerProvider(&self, out: *mut *mut spi::provider::ISpiControllerProvider) -> HRESULT
}}
impl ILowLevelDevicesAggregateProvider {
    #[inline] pub unsafe fn get_adc_controller_provider(&self) -> Result<ComPtr<adc::provider::IAdcControllerProvider>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AdcControllerProvider)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pwm_controller_provider(&self) -> Result<ComPtr<pwm::provider::IPwmControllerProvider>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PwmControllerProvider)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gpio_controller_provider(&self) -> Result<ComPtr<gpio::provider::IGpioControllerProvider>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_GpioControllerProvider)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_i2c_controller_provider(&self) -> Result<ComPtr<i2c::provider::II2cControllerProvider>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_I2cControllerProvider)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_spi_controller_provider(&self) -> Result<ComPtr<spi::provider::ISpiControllerProvider>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SpiControllerProvider)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ILowLevelDevicesAggregateProviderFactory, 2596580086, 13427, 18014, 150, 213, 54, 40, 26, 44, 87, 175);
RT_INTERFACE!{static interface ILowLevelDevicesAggregateProviderFactory(ILowLevelDevicesAggregateProviderFactoryVtbl): IInspectable(IInspectableVtbl) [IID_ILowLevelDevicesAggregateProviderFactory] {
    fn Create(&self, adc: *mut adc::provider::IAdcControllerProvider, pwm: *mut pwm::provider::IPwmControllerProvider, gpio: *mut gpio::provider::IGpioControllerProvider, i2c: *mut i2c::provider::II2cControllerProvider, spi: *mut spi::provider::ISpiControllerProvider, out: *mut *mut LowLevelDevicesAggregateProvider) -> HRESULT
}}
impl ILowLevelDevicesAggregateProviderFactory {
    #[inline] pub unsafe fn create(&self, adc: &adc::provider::IAdcControllerProvider, pwm: &pwm::provider::IPwmControllerProvider, gpio: &gpio::provider::IGpioControllerProvider, i2c: &i2c::provider::II2cControllerProvider, spi: &spi::provider::ISpiControllerProvider) -> Result<ComPtr<LowLevelDevicesAggregateProvider>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, adc as *const _ as *mut _, pwm as *const _ as *mut _, gpio as *const _ as *mut _, i2c as *const _ as *mut _, spi as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class LowLevelDevicesAggregateProvider: ILowLevelDevicesAggregateProvider}
impl RtActivatable<ILowLevelDevicesAggregateProviderFactory> for LowLevelDevicesAggregateProvider {}
impl LowLevelDevicesAggregateProvider {
    #[inline] pub fn create(adc: &adc::provider::IAdcControllerProvider, pwm: &pwm::provider::IPwmControllerProvider, gpio: &gpio::provider::IGpioControllerProvider, i2c: &i2c::provider::II2cControllerProvider, spi: &spi::provider::ISpiControllerProvider) -> Result<ComPtr<LowLevelDevicesAggregateProvider>> { unsafe {
        <Self as RtActivatable<ILowLevelDevicesAggregateProviderFactory>>::get_activation_factory().create(adc, pwm, gpio, i2c, spi)
    }}
}
DEFINE_CLSID!(LowLevelDevicesAggregateProvider(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,76,111,119,76,101,118,101,108,68,101,118,105,99,101,115,65,103,103,114,101,103,97,116,101,80,114,111,118,105,100,101,114,0]) [CLSID_LowLevelDevicesAggregateProvider]);
DEFINE_IID!(IID_ILowLevelDevicesController, 784481748, 6043, 17886, 155, 57, 58, 224, 37, 39, 222, 82);
RT_INTERFACE!{interface ILowLevelDevicesController(ILowLevelDevicesControllerVtbl): IInspectable(IInspectableVtbl) [IID_ILowLevelDevicesController] {
    
}}
DEFINE_IID!(IID_ILowLevelDevicesControllerStatics, 155095658, 64715, 17300, 166, 151, 25, 222, 99, 124, 45, 179);
RT_INTERFACE!{static interface ILowLevelDevicesControllerStatics(ILowLevelDevicesControllerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ILowLevelDevicesControllerStatics] {
    fn get_DefaultProvider(&self, out: *mut *mut ILowLevelDevicesAggregateProvider) -> HRESULT,
    fn put_DefaultProvider(&self, value: *mut ILowLevelDevicesAggregateProvider) -> HRESULT
}}
impl ILowLevelDevicesControllerStatics {
    #[inline] pub unsafe fn get_default_provider(&self) -> Result<ComPtr<ILowLevelDevicesAggregateProvider>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DefaultProvider)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_default_provider(&self, value: &ILowLevelDevicesAggregateProvider) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DefaultProvider)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class LowLevelDevicesController: ILowLevelDevicesController}
impl RtActivatable<ILowLevelDevicesControllerStatics> for LowLevelDevicesController {}
impl LowLevelDevicesController {
    #[inline] pub fn get_default_provider() -> Result<ComPtr<ILowLevelDevicesAggregateProvider>> { unsafe {
        <Self as RtActivatable<ILowLevelDevicesControllerStatics>>::get_activation_factory().get_default_provider()
    }}
    #[inline] pub fn set_default_provider(value: &ILowLevelDevicesAggregateProvider) -> Result<()> { unsafe {
        <Self as RtActivatable<ILowLevelDevicesControllerStatics>>::get_activation_factory().set_default_provider(value)
    }}
}
DEFINE_CLSID!(LowLevelDevicesController(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,76,111,119,76,101,118,101,108,68,101,118,105,99,101,115,67,111,110,116,114,111,108,108,101,114,0]) [CLSID_LowLevelDevicesController]);
pub mod adc { // Windows.Devices.Adc
use ::prelude::*;
RT_ENUM! { enum AdcChannelMode: i32 {
    SingleEnded (AdcChannelMode_SingleEnded) = 0, Differential (AdcChannelMode_Differential) = 1,
}}
DEFINE_IID!(IID_IAdcController, 712434864, 43158, 16921, 134, 182, 234, 140, 220, 233, 143, 86);
RT_INTERFACE!{interface IAdcController(IAdcControllerVtbl): IInspectable(IInspectableVtbl) [IID_IAdcController] {
    fn get_ChannelCount(&self, out: *mut i32) -> HRESULT,
    fn get_ResolutionInBits(&self, out: *mut i32) -> HRESULT,
    fn get_MinValue(&self, out: *mut i32) -> HRESULT,
    fn get_MaxValue(&self, out: *mut i32) -> HRESULT,
    fn get_ChannelMode(&self, out: *mut AdcChannelMode) -> HRESULT,
    fn put_ChannelMode(&self, value: AdcChannelMode) -> HRESULT,
    fn IsChannelModeSupported(&self, channelMode: AdcChannelMode, out: *mut bool) -> HRESULT,
    fn OpenChannel(&self, channelNumber: i32, out: *mut *mut AdcChannel) -> HRESULT
}}
impl IAdcController {
    #[inline] pub unsafe fn get_channel_count(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ChannelCount)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_resolution_in_bits(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ResolutionInBits)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_min_value(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_value(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_channel_mode(&self) -> Result<AdcChannelMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ChannelMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_channel_mode(&self, value: AdcChannelMode) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ChannelMode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_channel_mode_supported(&self, channelMode: AdcChannelMode) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsChannelModeSupported)(self as *const _ as *mut _, channelMode, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn open_channel(&self, channelNumber: i32) -> Result<ComPtr<AdcChannel>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).OpenChannel)(self as *const _ as *mut _, channelNumber, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class AdcChannel: IAdcChannel}
DEFINE_IID!(IID_IAdcControllerStatics, 3437858316, 504, 18577, 188, 59, 190, 83, 239, 39, 156, 164);
RT_INTERFACE!{static interface IAdcControllerStatics(IAdcControllerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IAdcControllerStatics] {
    fn GetControllersAsync(&self, provider: *mut provider::IAdcProvider, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<AdcController>>) -> HRESULT
}}
impl IAdcControllerStatics {
    #[inline] pub unsafe fn get_controllers_async(&self, provider: &provider::IAdcProvider) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<AdcController>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetControllersAsync)(self as *const _ as *mut _, provider as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class AdcController: IAdcController}
impl RtActivatable<IAdcControllerStatics2> for AdcController {}
impl RtActivatable<IAdcControllerStatics> for AdcController {}
impl AdcController {
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<AdcController>>> { unsafe {
        <Self as RtActivatable<IAdcControllerStatics2>>::get_activation_factory().get_default_async()
    }}
    #[inline] pub fn get_controllers_async(provider: &provider::IAdcProvider) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<AdcController>>>> { unsafe {
        <Self as RtActivatable<IAdcControllerStatics>>::get_activation_factory().get_controllers_async(provider)
    }}
}
DEFINE_CLSID!(AdcController(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,100,99,46,65,100,99,67,111,110,116,114,111,108,108,101,114,0]) [CLSID_AdcController]);
DEFINE_IID!(IID_IAdcControllerStatics2, 2730048285, 38779, 20314, 165, 254, 166, 171, 175, 254, 100, 132);
RT_INTERFACE!{static interface IAdcControllerStatics2(IAdcControllerStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IAdcControllerStatics2] {
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<AdcController>) -> HRESULT
}}
impl IAdcControllerStatics2 {
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<AdcController>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAdcChannel, 67892244, 9608, 19030, 171, 239, 115, 162, 96, 172, 198, 10);
RT_INTERFACE!{interface IAdcChannel(IAdcChannelVtbl): IInspectable(IInspectableVtbl) [IID_IAdcChannel] {
    fn get_Controller(&self, out: *mut *mut AdcController) -> HRESULT,
    fn ReadValue(&self, out: *mut i32) -> HRESULT,
    fn ReadRatio(&self, out: *mut f64) -> HRESULT
}}
impl IAdcChannel {
    #[inline] pub unsafe fn get_controller(&self) -> Result<ComPtr<AdcController>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Controller)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn read_value(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).ReadValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn read_ratio(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).ReadRatio)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
pub mod provider { // Windows.Devices.Adc.Provider
use ::prelude::*;
RT_ENUM! { enum ProviderAdcChannelMode: i32 {
    SingleEnded (ProviderAdcChannelMode_SingleEnded) = 0, Differential (ProviderAdcChannelMode_Differential) = 1,
}}
DEFINE_IID!(IID_IAdcControllerProvider, 3193198632, 33133, 19941, 160, 72, 171, 160, 105, 88, 170, 168);
RT_INTERFACE!{interface IAdcControllerProvider(IAdcControllerProviderVtbl): IInspectable(IInspectableVtbl) [IID_IAdcControllerProvider] {
    fn get_ChannelCount(&self, out: *mut i32) -> HRESULT,
    fn get_ResolutionInBits(&self, out: *mut i32) -> HRESULT,
    fn get_MinValue(&self, out: *mut i32) -> HRESULT,
    fn get_MaxValue(&self, out: *mut i32) -> HRESULT,
    fn get_ChannelMode(&self, out: *mut ProviderAdcChannelMode) -> HRESULT,
    fn put_ChannelMode(&self, value: ProviderAdcChannelMode) -> HRESULT,
    fn IsChannelModeSupported(&self, channelMode: ProviderAdcChannelMode, out: *mut bool) -> HRESULT,
    fn AcquireChannel(&self, channel: i32) -> HRESULT,
    fn ReleaseChannel(&self, channel: i32) -> HRESULT,
    fn ReadValue(&self, channelNumber: i32, out: *mut i32) -> HRESULT
}}
impl IAdcControllerProvider {
    #[inline] pub unsafe fn get_channel_count(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ChannelCount)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_resolution_in_bits(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ResolutionInBits)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_min_value(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_value(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_channel_mode(&self) -> Result<ProviderAdcChannelMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ChannelMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_channel_mode(&self, value: ProviderAdcChannelMode) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ChannelMode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_channel_mode_supported(&self, channelMode: ProviderAdcChannelMode) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsChannelModeSupported)(self as *const _ as *mut _, channelMode, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn acquire_channel(&self, channel: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).AcquireChannel)(self as *const _ as *mut _, channel);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn release_channel(&self, channel: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).ReleaseChannel)(self as *const _ as *mut _, channel);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn read_value(&self, channelNumber: i32) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).ReadValue)(self as *const _ as *mut _, channelNumber, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAdcProvider, 680867432, 37721, 19543, 188, 136, 226, 117, 232, 22, 56, 201);
RT_INTERFACE!{interface IAdcProvider(IAdcProviderVtbl): IInspectable(IInspectableVtbl) [IID_IAdcProvider] {
    fn GetControllers(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<IAdcControllerProvider>) -> HRESULT
}}
impl IAdcProvider {
    #[inline] pub unsafe fn get_controllers(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<IAdcControllerProvider>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetControllers)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
} // Windows.Devices.Adc.Provider
} // Windows.Devices.Adc
pub mod gpio { // Windows.Devices.Gpio
use ::prelude::*;
RT_ENUM! { enum GpioSharingMode: i32 {
    Exclusive (GpioSharingMode_Exclusive) = 0, SharedReadOnly (GpioSharingMode_SharedReadOnly) = 1,
}}
RT_ENUM! { enum GpioOpenStatus: i32 {
    PinOpened (GpioOpenStatus_PinOpened) = 0, PinUnavailable (GpioOpenStatus_PinUnavailable) = 1, SharingViolation (GpioOpenStatus_SharingViolation) = 2, MuxingConflict (GpioOpenStatus_MuxingConflict) = 3, UnknownError (GpioOpenStatus_UnknownError) = 4,
}}
RT_ENUM! { enum GpioPinDriveMode: i32 {
    Input (GpioPinDriveMode_Input) = 0, Output (GpioPinDriveMode_Output) = 1, InputPullUp (GpioPinDriveMode_InputPullUp) = 2, InputPullDown (GpioPinDriveMode_InputPullDown) = 3, OutputOpenDrain (GpioPinDriveMode_OutputOpenDrain) = 4, OutputOpenDrainPullUp (GpioPinDriveMode_OutputOpenDrainPullUp) = 5, OutputOpenSource (GpioPinDriveMode_OutputOpenSource) = 6, OutputOpenSourcePullDown (GpioPinDriveMode_OutputOpenSourcePullDown) = 7,
}}
RT_ENUM! { enum GpioPinValue: i32 {
    Low (GpioPinValue_Low) = 0, High (GpioPinValue_High) = 1,
}}
RT_ENUM! { enum GpioPinEdge: i32 {
    FallingEdge (GpioPinEdge_FallingEdge) = 0, RisingEdge (GpioPinEdge_RisingEdge) = 1,
}}
RT_ENUM! { enum GpioChangePolarity: i32 {
    Falling (GpioChangePolarity_Falling) = 0, Rising (GpioChangePolarity_Rising) = 1, Both (GpioChangePolarity_Both) = 2,
}}
RT_STRUCT! { struct GpioChangeRecord {
    RelativeTime: super::super::foundation::TimeSpan, Edge: GpioPinEdge,
}}
RT_STRUCT! { struct GpioChangeCount {
    Count: u64, RelativeTime: super::super::foundation::TimeSpan,
}}
DEFINE_IID!(IID_IGpioPinValueChangedEventArgs, 825731809, 28733, 16473, 189, 36, 181, 178, 93, 255, 184, 78);
RT_INTERFACE!{interface IGpioPinValueChangedEventArgs(IGpioPinValueChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IGpioPinValueChangedEventArgs] {
    fn get_Edge(&self, out: *mut GpioPinEdge) -> HRESULT
}}
impl IGpioPinValueChangedEventArgs {
    #[inline] pub unsafe fn get_edge(&self) -> Result<GpioPinEdge> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Edge)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class GpioPinValueChangedEventArgs: IGpioPinValueChangedEventArgs}
RT_CLASS!{class GpioPin: IGpioPin}
DEFINE_IID!(IID_IGpioController, 675287779, 29793, 18076, 168, 188, 97, 214, 157, 8, 165, 60);
RT_INTERFACE!{interface IGpioController(IGpioControllerVtbl): IInspectable(IInspectableVtbl) [IID_IGpioController] {
    fn get_PinCount(&self, out: *mut i32) -> HRESULT,
    fn OpenPin(&self, pinNumber: i32, out: *mut *mut GpioPin) -> HRESULT,
    fn OpenPinWithSharingMode(&self, pinNumber: i32, sharingMode: GpioSharingMode, out: *mut *mut GpioPin) -> HRESULT,
    fn TryOpenPin(&self, pinNumber: i32, sharingMode: GpioSharingMode, pin: *mut *mut GpioPin, openStatus: *mut GpioOpenStatus, out: *mut bool) -> HRESULT
}}
impl IGpioController {
    #[inline] pub unsafe fn get_pin_count(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PinCount)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn open_pin(&self, pinNumber: i32) -> Result<ComPtr<GpioPin>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).OpenPin)(self as *const _ as *mut _, pinNumber, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn open_pin_with_sharing_mode(&self, pinNumber: i32, sharingMode: GpioSharingMode) -> Result<ComPtr<GpioPin>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).OpenPinWithSharingMode)(self as *const _ as *mut _, pinNumber, sharingMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_open_pin(&self, pinNumber: i32, sharingMode: GpioSharingMode) -> Result<(ComPtr<GpioPin>, GpioOpenStatus, bool)> {
        let mut pin = null_mut(); let mut openStatus = zeroed(); let mut out = zeroed();
        let hr = ((*self.lpVtbl).TryOpenPin)(self as *const _ as *mut _, pinNumber, sharingMode, &mut pin, &mut openStatus, &mut out);
        if hr == S_OK { Ok((ComPtr::wrap(pin), openStatus, out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGpioControllerStatics, 785839150, 31479, 16662, 149, 51, 196, 61, 153, 161, 251, 100);
RT_INTERFACE!{static interface IGpioControllerStatics(IGpioControllerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGpioControllerStatics] {
    fn GetDefault(&self, out: *mut *mut GpioController) -> HRESULT
}}
impl IGpioControllerStatics {
    #[inline] pub unsafe fn get_default(&self) -> Result<ComPtr<GpioController>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefault)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GpioController: IGpioController}
impl RtActivatable<IGpioControllerStatics> for GpioController {}
impl RtActivatable<IGpioControllerStatics2> for GpioController {}
impl GpioController {
    #[inline] pub fn get_default() -> Result<ComPtr<GpioController>> { unsafe {
        <Self as RtActivatable<IGpioControllerStatics>>::get_activation_factory().get_default()
    }}
    #[inline] pub fn get_controllers_async(provider: &provider::IGpioProvider) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<GpioController>>>> { unsafe {
        <Self as RtActivatable<IGpioControllerStatics2>>::get_activation_factory().get_controllers_async(provider)
    }}
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<GpioController>>> { unsafe {
        <Self as RtActivatable<IGpioControllerStatics2>>::get_activation_factory().get_default_async()
    }}
}
DEFINE_CLSID!(GpioController(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,71,112,105,111,46,71,112,105,111,67,111,110,116,114,111,108,108,101,114,0]) [CLSID_GpioController]);
DEFINE_IID!(IID_IGpioControllerStatics2, 2435546400, 27812, 16646, 163, 115, 255, 253, 52, 107, 14, 91);
RT_INTERFACE!{static interface IGpioControllerStatics2(IGpioControllerStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IGpioControllerStatics2] {
    fn GetControllersAsync(&self, provider: *mut provider::IGpioProvider, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<GpioController>>) -> HRESULT,
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<GpioController>) -> HRESULT
}}
impl IGpioControllerStatics2 {
    #[inline] pub unsafe fn get_controllers_async(&self, provider: &provider::IGpioProvider) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<GpioController>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetControllersAsync)(self as *const _ as *mut _, provider as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<GpioController>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGpioChangeReaderFactory, 2841218803, 14606, 17434, 157, 28, 232, 222, 11, 45, 240, 223);
RT_INTERFACE!{static interface IGpioChangeReaderFactory(IGpioChangeReaderFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IGpioChangeReaderFactory] {
    fn Create(&self, pin: *mut GpioPin, out: *mut *mut GpioChangeReader) -> HRESULT,
    fn CreateWithCapacity(&self, pin: *mut GpioPin, minCapacity: i32, out: *mut *mut GpioChangeReader) -> HRESULT
}}
impl IGpioChangeReaderFactory {
    #[inline] pub unsafe fn create(&self, pin: &GpioPin) -> Result<ComPtr<GpioChangeReader>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, pin as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_with_capacity(&self, pin: &GpioPin, minCapacity: i32) -> Result<ComPtr<GpioChangeReader>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWithCapacity)(self as *const _ as *mut _, pin as *const _ as *mut _, minCapacity, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GpioChangeReader: IGpioChangeReader}
impl RtActivatable<IGpioChangeReaderFactory> for GpioChangeReader {}
impl GpioChangeReader {
    #[inline] pub fn create(pin: &GpioPin) -> Result<ComPtr<GpioChangeReader>> { unsafe {
        <Self as RtActivatable<IGpioChangeReaderFactory>>::get_activation_factory().create(pin)
    }}
    #[inline] pub fn create_with_capacity(pin: &GpioPin, minCapacity: i32) -> Result<ComPtr<GpioChangeReader>> { unsafe {
        <Self as RtActivatable<IGpioChangeReaderFactory>>::get_activation_factory().create_with_capacity(pin, minCapacity)
    }}
}
DEFINE_CLSID!(GpioChangeReader(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,71,112,105,111,46,71,112,105,111,67,104,97,110,103,101,82,101,97,100,101,114,0]) [CLSID_GpioChangeReader]);
DEFINE_IID!(IID_IGpioChangeCounterFactory, 343774390, 2718, 16652, 180, 250, 248, 159, 64, 82, 8, 77);
RT_INTERFACE!{static interface IGpioChangeCounterFactory(IGpioChangeCounterFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IGpioChangeCounterFactory] {
    fn Create(&self, pin: *mut GpioPin, out: *mut *mut GpioChangeCounter) -> HRESULT
}}
impl IGpioChangeCounterFactory {
    #[inline] pub unsafe fn create(&self, pin: &GpioPin) -> Result<ComPtr<GpioChangeCounter>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, pin as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GpioChangeCounter: IGpioChangeCounter}
impl RtActivatable<IGpioChangeCounterFactory> for GpioChangeCounter {}
impl GpioChangeCounter {
    #[inline] pub fn create(pin: &GpioPin) -> Result<ComPtr<GpioChangeCounter>> { unsafe {
        <Self as RtActivatable<IGpioChangeCounterFactory>>::get_activation_factory().create(pin)
    }}
}
DEFINE_CLSID!(GpioChangeCounter(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,71,112,105,111,46,71,112,105,111,67,104,97,110,103,101,67,111,117,110,116,101,114,0]) [CLSID_GpioChangeCounter]);
DEFINE_IID!(IID_IGpioPin, 299479175, 44974, 18320, 158, 233, 224, 234, 201, 66, 210, 1);
RT_INTERFACE!{interface IGpioPin(IGpioPinVtbl): IInspectable(IInspectableVtbl) [IID_IGpioPin] {
    fn add_ValueChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<GpioPin, GpioPinValueChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ValueChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_DebounceTimeout(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn put_DebounceTimeout(&self, value: super::super::foundation::TimeSpan) -> HRESULT,
    fn get_PinNumber(&self, out: *mut i32) -> HRESULT,
    fn get_SharingMode(&self, out: *mut GpioSharingMode) -> HRESULT,
    fn IsDriveModeSupported(&self, driveMode: GpioPinDriveMode, out: *mut bool) -> HRESULT,
    fn GetDriveMode(&self, out: *mut GpioPinDriveMode) -> HRESULT,
    fn SetDriveMode(&self, value: GpioPinDriveMode) -> HRESULT,
    fn Write(&self, value: GpioPinValue) -> HRESULT,
    fn Read(&self, out: *mut GpioPinValue) -> HRESULT
}}
impl IGpioPin {
    #[inline] pub unsafe fn add_value_changed(&self, handler: &super::super::foundation::TypedEventHandler<GpioPin, GpioPinValueChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ValueChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_value_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ValueChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_debounce_timeout(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DebounceTimeout)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_debounce_timeout(&self, value: super::super::foundation::TimeSpan) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DebounceTimeout)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pin_number(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PinNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sharing_mode(&self) -> Result<GpioSharingMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SharingMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_drive_mode_supported(&self, driveMode: GpioPinDriveMode) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsDriveModeSupported)(self as *const _ as *mut _, driveMode, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_drive_mode(&self) -> Result<GpioPinDriveMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).GetDriveMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_drive_mode(&self, value: GpioPinDriveMode) -> Result<()> {
        let hr = ((*self.lpVtbl).SetDriveMode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn write(&self, value: GpioPinValue) -> Result<()> {
        let hr = ((*self.lpVtbl).Write)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn read(&self) -> Result<GpioPinValue> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).Read)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGpioChangeReader, 180127839, 57393, 18664, 133, 144, 112, 222, 120, 54, 60, 109);
RT_INTERFACE!{interface IGpioChangeReader(IGpioChangeReaderVtbl): IInspectable(IInspectableVtbl) [IID_IGpioChangeReader] {
    fn get_Capacity(&self, out: *mut i32) -> HRESULT,
    fn get_Length(&self, out: *mut i32) -> HRESULT,
    fn get_IsEmpty(&self, out: *mut bool) -> HRESULT,
    fn get_IsOverflowed(&self, out: *mut bool) -> HRESULT,
    fn put_Polarity(&self, value: GpioChangePolarity) -> HRESULT,
    fn get_Polarity(&self, out: *mut GpioChangePolarity) -> HRESULT,
    fn get_IsStarted(&self, out: *mut bool) -> HRESULT,
    fn Start(&self) -> HRESULT,
    fn Stop(&self) -> HRESULT,
    fn Clear(&self) -> HRESULT,
    fn GetNextItem(&self, out: *mut GpioChangeRecord) -> HRESULT,
    fn PeekNextItem(&self, out: *mut GpioChangeRecord) -> HRESULT,
    fn GetAllItems(&self, out: *mut *mut super::super::foundation::collections::IVector<GpioChangeRecord>) -> HRESULT,
    fn WaitForItemsAsync(&self, count: i32, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT
}}
impl IGpioChangeReader {
    #[inline] pub unsafe fn get_capacity(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Capacity)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_length(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Length)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_empty(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsEmpty)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_overflowed(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsOverflowed)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_polarity(&self, value: GpioChangePolarity) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Polarity)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_polarity(&self) -> Result<GpioChangePolarity> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Polarity)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_started(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStarted)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Stop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn clear(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Clear)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_next_item(&self) -> Result<GpioChangeRecord> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).GetNextItem)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn peek_next_item(&self) -> Result<GpioChangeRecord> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).PeekNextItem)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_all_items(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<GpioChangeRecord>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetAllItems)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn wait_for_items_async(&self, count: i32) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).WaitForItemsAsync)(self as *const _ as *mut _, count, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGpioChangeCounter, 3411984606, 26625, 17407, 128, 61, 69, 118, 98, 138, 139, 38);
RT_INTERFACE!{interface IGpioChangeCounter(IGpioChangeCounterVtbl): IInspectable(IInspectableVtbl) [IID_IGpioChangeCounter] {
    fn put_Polarity(&self, value: GpioChangePolarity) -> HRESULT,
    fn get_Polarity(&self, out: *mut GpioChangePolarity) -> HRESULT,
    fn get_IsStarted(&self, out: *mut bool) -> HRESULT,
    fn Start(&self) -> HRESULT,
    fn Stop(&self) -> HRESULT,
    fn Read(&self, out: *mut GpioChangeCount) -> HRESULT,
    fn Reset(&self, out: *mut GpioChangeCount) -> HRESULT
}}
impl IGpioChangeCounter {
    #[inline] pub unsafe fn set_polarity(&self, value: GpioChangePolarity) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Polarity)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_polarity(&self) -> Result<GpioChangePolarity> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Polarity)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_started(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStarted)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Stop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn read(&self) -> Result<GpioChangeCount> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).Read)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn reset(&self) -> Result<GpioChangeCount> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).Reset)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
pub mod provider { // Windows.Devices.Gpio.Provider
use ::prelude::*;
RT_ENUM! { enum ProviderGpioSharingMode: i32 {
    Exclusive (ProviderGpioSharingMode_Exclusive) = 0, SharedReadOnly (ProviderGpioSharingMode_SharedReadOnly) = 1,
}}
RT_ENUM! { enum ProviderGpioPinDriveMode: i32 {
    Input (ProviderGpioPinDriveMode_Input) = 0, Output (ProviderGpioPinDriveMode_Output) = 1, InputPullUp (ProviderGpioPinDriveMode_InputPullUp) = 2, InputPullDown (ProviderGpioPinDriveMode_InputPullDown) = 3, OutputOpenDrain (ProviderGpioPinDriveMode_OutputOpenDrain) = 4, OutputOpenDrainPullUp (ProviderGpioPinDriveMode_OutputOpenDrainPullUp) = 5, OutputOpenSource (ProviderGpioPinDriveMode_OutputOpenSource) = 6, OutputOpenSourcePullDown (ProviderGpioPinDriveMode_OutputOpenSourcePullDown) = 7,
}}
RT_ENUM! { enum ProviderGpioPinValue: i32 {
    Low (ProviderGpioPinValue_Low) = 0, High (ProviderGpioPinValue_High) = 1,
}}
RT_ENUM! { enum ProviderGpioPinEdge: i32 {
    FallingEdge (ProviderGpioPinEdge_FallingEdge) = 0, RisingEdge (ProviderGpioPinEdge_RisingEdge) = 1,
}}
DEFINE_IID!(IID_IGpioPinProviderValueChangedEventArgsFactory, 1053494105, 22156, 17298, 178, 74, 138, 89, 169, 2, 177, 241);
RT_INTERFACE!{static interface IGpioPinProviderValueChangedEventArgsFactory(IGpioPinProviderValueChangedEventArgsFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IGpioPinProviderValueChangedEventArgsFactory] {
    fn Create(&self, edge: ProviderGpioPinEdge, out: *mut *mut GpioPinProviderValueChangedEventArgs) -> HRESULT
}}
impl IGpioPinProviderValueChangedEventArgsFactory {
    #[inline] pub unsafe fn create(&self, edge: ProviderGpioPinEdge) -> Result<ComPtr<GpioPinProviderValueChangedEventArgs>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, edge, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GpioPinProviderValueChangedEventArgs: IGpioPinProviderValueChangedEventArgs}
impl RtActivatable<IGpioPinProviderValueChangedEventArgsFactory> for GpioPinProviderValueChangedEventArgs {}
impl GpioPinProviderValueChangedEventArgs {
    #[inline] pub fn create(edge: ProviderGpioPinEdge) -> Result<ComPtr<GpioPinProviderValueChangedEventArgs>> { unsafe {
        <Self as RtActivatable<IGpioPinProviderValueChangedEventArgsFactory>>::get_activation_factory().create(edge)
    }}
}
DEFINE_CLSID!(GpioPinProviderValueChangedEventArgs(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,71,112,105,111,46,80,114,111,118,105,100,101,114,46,71,112,105,111,80,105,110,80,114,111,118,105,100,101,114,86,97,108,117,101,67,104,97,110,103,101,100,69,118,101,110,116,65,114,103,115,0]) [CLSID_GpioPinProviderValueChangedEventArgs]);
DEFINE_IID!(IID_IGpioPinProviderValueChangedEventArgs, 849794802, 15707, 17613, 143, 190, 19, 166, 159, 46, 219, 36);
RT_INTERFACE!{interface IGpioPinProviderValueChangedEventArgs(IGpioPinProviderValueChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IGpioPinProviderValueChangedEventArgs] {
    fn get_Edge(&self, out: *mut ProviderGpioPinEdge) -> HRESULT
}}
impl IGpioPinProviderValueChangedEventArgs {
    #[inline] pub unsafe fn get_edge(&self) -> Result<ProviderGpioPinEdge> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Edge)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGpioPinProvider, 1110723767, 27324, 16639, 156, 231, 115, 184, 83, 1, 185, 0);
RT_INTERFACE!{interface IGpioPinProvider(IGpioPinProviderVtbl): IInspectable(IInspectableVtbl) [IID_IGpioPinProvider] {
    fn add_ValueChanged(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<IGpioPinProvider, GpioPinProviderValueChangedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ValueChanged(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn get_DebounceTimeout(&self, out: *mut ::rt::gen::windows::foundation::TimeSpan) -> HRESULT,
    fn put_DebounceTimeout(&self, value: ::rt::gen::windows::foundation::TimeSpan) -> HRESULT,
    fn get_PinNumber(&self, out: *mut i32) -> HRESULT,
    fn get_SharingMode(&self, out: *mut ProviderGpioSharingMode) -> HRESULT,
    fn IsDriveModeSupported(&self, driveMode: ProviderGpioPinDriveMode, out: *mut bool) -> HRESULT,
    fn GetDriveMode(&self, out: *mut ProviderGpioPinDriveMode) -> HRESULT,
    fn SetDriveMode(&self, value: ProviderGpioPinDriveMode) -> HRESULT,
    fn Write(&self, value: ProviderGpioPinValue) -> HRESULT,
    fn Read(&self, out: *mut ProviderGpioPinValue) -> HRESULT
}}
impl IGpioPinProvider {
    #[inline] pub unsafe fn add_value_changed(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<IGpioPinProvider, GpioPinProviderValueChangedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ValueChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_value_changed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ValueChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_debounce_timeout(&self) -> Result<::rt::gen::windows::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DebounceTimeout)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_debounce_timeout(&self, value: ::rt::gen::windows::foundation::TimeSpan) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DebounceTimeout)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pin_number(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PinNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sharing_mode(&self) -> Result<ProviderGpioSharingMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SharingMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_drive_mode_supported(&self, driveMode: ProviderGpioPinDriveMode) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsDriveModeSupported)(self as *const _ as *mut _, driveMode, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_drive_mode(&self) -> Result<ProviderGpioPinDriveMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).GetDriveMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_drive_mode(&self, value: ProviderGpioPinDriveMode) -> Result<()> {
        let hr = ((*self.lpVtbl).SetDriveMode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn write(&self, value: ProviderGpioPinValue) -> Result<()> {
        let hr = ((*self.lpVtbl).Write)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn read(&self) -> Result<ProviderGpioPinValue> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).Read)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGpioControllerProvider, 2903625415, 6634, 19233, 135, 79, 185, 26, 237, 74, 37, 219);
RT_INTERFACE!{interface IGpioControllerProvider(IGpioControllerProviderVtbl): IInspectable(IInspectableVtbl) [IID_IGpioControllerProvider] {
    fn get_PinCount(&self, out: *mut i32) -> HRESULT,
    fn OpenPinProvider(&self, pin: i32, sharingMode: ProviderGpioSharingMode, out: *mut *mut IGpioPinProvider) -> HRESULT
}}
impl IGpioControllerProvider {
    #[inline] pub unsafe fn get_pin_count(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PinCount)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn open_pin_provider(&self, pin: i32, sharingMode: ProviderGpioSharingMode) -> Result<ComPtr<IGpioPinProvider>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).OpenPinProvider)(self as *const _ as *mut _, pin, sharingMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGpioProvider, 1156065031, 2250, 17226, 175, 224, 214, 21, 128, 68, 111, 126);
RT_INTERFACE!{interface IGpioProvider(IGpioProviderVtbl): IInspectable(IInspectableVtbl) [IID_IGpioProvider] {
    fn GetControllers(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<IGpioControllerProvider>) -> HRESULT
}}
impl IGpioProvider {
    #[inline] pub unsafe fn get_controllers(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<IGpioControllerProvider>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetControllers)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
} // Windows.Devices.Gpio.Provider
} // Windows.Devices.Gpio
pub mod i2c { // Windows.Devices.I2c
use ::prelude::*;
RT_ENUM! { enum I2cBusSpeed: i32 {
    StandardMode (I2cBusSpeed_StandardMode) = 0, FastMode (I2cBusSpeed_FastMode) = 1,
}}
RT_ENUM! { enum I2cTransferStatus: i32 {
    FullTransfer (I2cTransferStatus_FullTransfer) = 0, PartialTransfer (I2cTransferStatus_PartialTransfer) = 1, SlaveAddressNotAcknowledged (I2cTransferStatus_SlaveAddressNotAcknowledged) = 2, ClockStretchTimeout (I2cTransferStatus_ClockStretchTimeout) = 3, UnknownError (I2cTransferStatus_UnknownError) = 4,
}}
RT_ENUM! { enum I2cSharingMode: i32 {
    Exclusive (I2cSharingMode_Exclusive) = 0, Shared (I2cSharingMode_Shared) = 1,
}}
RT_STRUCT! { struct I2cTransferResult {
    Status: I2cTransferStatus, BytesTransferred: u32,
}}
DEFINE_IID!(IID_II2cConnectionSettingsFactory, 2176157363, 38547, 16817, 162, 67, 222, 212, 246, 230, 105, 38);
RT_INTERFACE!{static interface II2cConnectionSettingsFactory(II2cConnectionSettingsFactoryVtbl): IInspectable(IInspectableVtbl) [IID_II2cConnectionSettingsFactory] {
    fn Create(&self, slaveAddress: i32, out: *mut *mut I2cConnectionSettings) -> HRESULT
}}
impl II2cConnectionSettingsFactory {
    #[inline] pub unsafe fn create(&self, slaveAddress: i32) -> Result<ComPtr<I2cConnectionSettings>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, slaveAddress, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class I2cConnectionSettings: II2cConnectionSettings}
impl RtActivatable<II2cConnectionSettingsFactory> for I2cConnectionSettings {}
impl I2cConnectionSettings {
    #[inline] pub fn create(slaveAddress: i32) -> Result<ComPtr<I2cConnectionSettings>> { unsafe {
        <Self as RtActivatable<II2cConnectionSettingsFactory>>::get_activation_factory().create(slaveAddress)
    }}
}
DEFINE_CLSID!(I2cConnectionSettings(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,73,50,99,46,73,50,99,67,111,110,110,101,99,116,105,111,110,83,101,116,116,105,110,103,115,0]) [CLSID_I2cConnectionSettings]);
DEFINE_IID!(IID_II2cConnectionSettings, 4074443527, 43887, 17977, 167, 103, 84, 83, 109, 195, 70, 15);
RT_INTERFACE!{interface II2cConnectionSettings(II2cConnectionSettingsVtbl): IInspectable(IInspectableVtbl) [IID_II2cConnectionSettings] {
    fn get_SlaveAddress(&self, out: *mut i32) -> HRESULT,
    fn put_SlaveAddress(&self, value: i32) -> HRESULT,
    fn get_BusSpeed(&self, out: *mut I2cBusSpeed) -> HRESULT,
    fn put_BusSpeed(&self, value: I2cBusSpeed) -> HRESULT,
    fn get_SharingMode(&self, out: *mut I2cSharingMode) -> HRESULT,
    fn put_SharingMode(&self, value: I2cSharingMode) -> HRESULT
}}
impl II2cConnectionSettings {
    #[inline] pub unsafe fn get_slave_address(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SlaveAddress)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_slave_address(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SlaveAddress)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bus_speed(&self) -> Result<I2cBusSpeed> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BusSpeed)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_bus_speed(&self, value: I2cBusSpeed) -> Result<()> {
        let hr = ((*self.lpVtbl).put_BusSpeed)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sharing_mode(&self) -> Result<I2cSharingMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SharingMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_sharing_mode(&self, value: I2cSharingMode) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SharingMode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_II2cDeviceStatics, 2443394019, 29492, 17682, 150, 188, 251, 174, 148, 89, 245, 246);
RT_INTERFACE!{static interface II2cDeviceStatics(II2cDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_II2cDeviceStatics] {
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromFriendlyName(&self, friendlyName: HSTRING, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, settings: *mut I2cConnectionSettings, out: *mut *mut super::super::foundation::IAsyncOperation<I2cDevice>) -> HRESULT
}}
impl II2cDeviceStatics {
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_friendly_name(&self, friendlyName: &HStringArg) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromFriendlyName)(self as *const _ as *mut _, friendlyName.get(), &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg, settings: &I2cConnectionSettings) -> Result<ComPtr<super::super::foundation::IAsyncOperation<I2cDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), settings as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class I2cDevice: II2cDevice}
impl RtActivatable<II2cDeviceStatics> for I2cDevice {}
impl I2cDevice {
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<II2cDeviceStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn get_device_selector_from_friendly_name(friendlyName: &HStringArg) -> Result<HString> { unsafe {
        <Self as RtActivatable<II2cDeviceStatics>>::get_activation_factory().get_device_selector_from_friendly_name(friendlyName)
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg, settings: &I2cConnectionSettings) -> Result<ComPtr<super::super::foundation::IAsyncOperation<I2cDevice>>> { unsafe {
        <Self as RtActivatable<II2cDeviceStatics>>::get_activation_factory().from_id_async(deviceId, settings)
    }}
}
DEFINE_CLSID!(I2cDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,73,50,99,46,73,50,99,68,101,118,105,99,101,0]) [CLSID_I2cDevice]);
DEFINE_IID!(IID_II2cController, 3297423794, 34720, 16742, 142, 62, 180, 184, 249, 124, 215, 41);
RT_INTERFACE!{interface II2cController(II2cControllerVtbl): IInspectable(IInspectableVtbl) [IID_II2cController] {
    fn GetDevice(&self, settings: *mut I2cConnectionSettings, out: *mut *mut I2cDevice) -> HRESULT
}}
impl II2cController {
    #[inline] pub unsafe fn get_device(&self, settings: &I2cConnectionSettings) -> Result<ComPtr<I2cDevice>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDevice)(self as *const _ as *mut _, settings as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_II2cControllerStatics, 1090257765, 24325, 20094, 132, 189, 16, 13, 184, 224, 174, 197);
RT_INTERFACE!{static interface II2cControllerStatics(II2cControllerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_II2cControllerStatics] {
    fn GetControllersAsync(&self, provider: *mut provider::II2cProvider, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<I2cController>>) -> HRESULT,
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<I2cController>) -> HRESULT
}}
impl II2cControllerStatics {
    #[inline] pub unsafe fn get_controllers_async(&self, provider: &provider::II2cProvider) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<I2cController>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetControllersAsync)(self as *const _ as *mut _, provider as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<I2cController>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class I2cController: II2cController}
impl RtActivatable<II2cControllerStatics> for I2cController {}
impl I2cController {
    #[inline] pub fn get_controllers_async(provider: &provider::II2cProvider) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<I2cController>>>> { unsafe {
        <Self as RtActivatable<II2cControllerStatics>>::get_activation_factory().get_controllers_async(provider)
    }}
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<I2cController>>> { unsafe {
        <Self as RtActivatable<II2cControllerStatics>>::get_activation_factory().get_default_async()
    }}
}
DEFINE_CLSID!(I2cController(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,73,50,99,46,73,50,99,67,111,110,116,114,111,108,108,101,114,0]) [CLSID_I2cController]);
DEFINE_IID!(IID_II2cDevice, 2251735350, 47557, 20336, 148, 73, 204, 70, 220, 111, 87, 235);
RT_INTERFACE!{interface II2cDevice(II2cDeviceVtbl): IInspectable(IInspectableVtbl) [IID_II2cDevice] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ConnectionSettings(&self, out: *mut *mut I2cConnectionSettings) -> HRESULT,
    fn Write(&self, bufferSize: u32, buffer: *mut u8) -> HRESULT,
    fn WritePartial(&self, bufferSize: u32, buffer: *mut u8, out: *mut I2cTransferResult) -> HRESULT,
    fn Read(&self, bufferSize: u32, buffer: *mut u8) -> HRESULT,
    fn ReadPartial(&self, bufferSize: u32, buffer: *mut u8, out: *mut I2cTransferResult) -> HRESULT,
    fn WriteRead(&self, writeBufferSize: u32, writeBuffer: *mut u8, readBufferSize: u32, readBuffer: *mut u8) -> HRESULT,
    fn WriteReadPartial(&self, writeBufferSize: u32, writeBuffer: *mut u8, readBufferSize: u32, readBuffer: *mut u8, out: *mut I2cTransferResult) -> HRESULT
}}
impl II2cDevice {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_connection_settings(&self) -> Result<ComPtr<I2cConnectionSettings>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ConnectionSettings)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn write(&self, buffer: &[u8]) -> Result<()> {
        let hr = ((*self.lpVtbl).Write)(self as *const _ as *mut _, buffer.len() as u32, buffer.as_ptr() as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn write_partial(&self, buffer: &[u8]) -> Result<I2cTransferResult> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).WritePartial)(self as *const _ as *mut _, buffer.len() as u32, buffer.as_ptr() as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn read(&self, bufferSize: u32, buffer: *mut u8) -> Result<()> {
        let hr = ((*self.lpVtbl).Read)(self as *const _ as *mut _, bufferSize, buffer);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn read_partial(&self, bufferSize: u32, buffer: *mut u8) -> Result<I2cTransferResult> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).ReadPartial)(self as *const _ as *mut _, bufferSize, buffer, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn write_read(&self, writeBuffer: &[u8], readBufferSize: u32, readBuffer: *mut u8) -> Result<()> {
        let hr = ((*self.lpVtbl).WriteRead)(self as *const _ as *mut _, writeBuffer.len() as u32, writeBuffer.as_ptr() as *mut _, readBufferSize, readBuffer);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn write_read_partial(&self, writeBuffer: &[u8], readBufferSize: u32, readBuffer: *mut u8) -> Result<I2cTransferResult> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).WriteReadPartial)(self as *const _ as *mut _, writeBuffer.len() as u32, writeBuffer.as_ptr() as *mut _, readBufferSize, readBuffer, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
pub mod provider { // Windows.Devices.I2c.Provider
use ::prelude::*;
RT_ENUM! { enum ProviderI2cBusSpeed: i32 {
    StandardMode (ProviderI2cBusSpeed_StandardMode) = 0, FastMode (ProviderI2cBusSpeed_FastMode) = 1,
}}
RT_ENUM! { enum ProviderI2cTransferStatus: i32 {
    FullTransfer (ProviderI2cTransferStatus_FullTransfer) = 0, PartialTransfer (ProviderI2cTransferStatus_PartialTransfer) = 1, SlaveAddressNotAcknowledged (ProviderI2cTransferStatus_SlaveAddressNotAcknowledged) = 2,
}}
RT_ENUM! { enum ProviderI2cSharingMode: i32 {
    Exclusive (ProviderI2cSharingMode_Exclusive) = 0, Shared (ProviderI2cSharingMode_Shared) = 1,
}}
RT_STRUCT! { struct ProviderI2cTransferResult {
    Status: ProviderI2cTransferStatus, BytesTransferred: u32,
}}
DEFINE_IID!(IID_IProviderI2cConnectionSettings, 3923463732, 58640, 17591, 128, 157, 242, 248, 91, 85, 83, 57);
RT_INTERFACE!{interface IProviderI2cConnectionSettings(IProviderI2cConnectionSettingsVtbl): IInspectable(IInspectableVtbl) [IID_IProviderI2cConnectionSettings] {
    fn get_SlaveAddress(&self, out: *mut i32) -> HRESULT,
    fn put_SlaveAddress(&self, value: i32) -> HRESULT,
    fn get_BusSpeed(&self, out: *mut ProviderI2cBusSpeed) -> HRESULT,
    fn put_BusSpeed(&self, value: ProviderI2cBusSpeed) -> HRESULT,
    fn get_SharingMode(&self, out: *mut ProviderI2cSharingMode) -> HRESULT,
    fn put_SharingMode(&self, value: ProviderI2cSharingMode) -> HRESULT
}}
impl IProviderI2cConnectionSettings {
    #[inline] pub unsafe fn get_slave_address(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SlaveAddress)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_slave_address(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SlaveAddress)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bus_speed(&self) -> Result<ProviderI2cBusSpeed> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BusSpeed)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_bus_speed(&self, value: ProviderI2cBusSpeed) -> Result<()> {
        let hr = ((*self.lpVtbl).put_BusSpeed)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sharing_mode(&self) -> Result<ProviderI2cSharingMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SharingMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_sharing_mode(&self, value: ProviderI2cSharingMode) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SharingMode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class ProviderI2cConnectionSettings: IProviderI2cConnectionSettings}
DEFINE_IID!(IID_II2cControllerProvider, 1640151938, 17680, 16739, 168, 124, 78, 21, 169, 85, 137, 128);
RT_INTERFACE!{interface II2cControllerProvider(II2cControllerProviderVtbl): IInspectable(IInspectableVtbl) [IID_II2cControllerProvider] {
    fn GetDeviceProvider(&self, settings: *mut ProviderI2cConnectionSettings, out: *mut *mut II2cDeviceProvider) -> HRESULT
}}
impl II2cControllerProvider {
    #[inline] pub unsafe fn get_device_provider(&self, settings: &ProviderI2cConnectionSettings) -> Result<ComPtr<II2cDeviceProvider>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceProvider)(self as *const _ as *mut _, settings as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_II2cProvider, 1863518270, 48994, 20450, 169, 90, 240, 137, 153, 102, 152, 24);
RT_INTERFACE!{interface II2cProvider(II2cProviderVtbl): IInspectable(IInspectableVtbl) [IID_II2cProvider] {
    fn GetControllersAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<::rt::gen::windows::foundation::collections::IVectorView<II2cControllerProvider>>) -> HRESULT
}}
impl II2cProvider {
    #[inline] pub unsafe fn get_controllers_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<::rt::gen::windows::foundation::collections::IVectorView<II2cControllerProvider>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetControllersAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_II2cDeviceProvider, 2905876052, 22504, 17726, 131, 41, 209, 228, 71, 209, 3, 169);
RT_INTERFACE!{interface II2cDeviceProvider(II2cDeviceProviderVtbl): IInspectable(IInspectableVtbl) [IID_II2cDeviceProvider] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn Write(&self, bufferSize: u32, buffer: *mut u8) -> HRESULT,
    fn WritePartial(&self, bufferSize: u32, buffer: *mut u8, out: *mut ProviderI2cTransferResult) -> HRESULT,
    fn Read(&self, bufferSize: u32, buffer: *mut u8) -> HRESULT,
    fn ReadPartial(&self, bufferSize: u32, buffer: *mut u8, out: *mut ProviderI2cTransferResult) -> HRESULT,
    fn WriteRead(&self, writeBufferSize: u32, writeBuffer: *mut u8, readBufferSize: u32, readBuffer: *mut u8) -> HRESULT,
    fn WriteReadPartial(&self, writeBufferSize: u32, writeBuffer: *mut u8, readBufferSize: u32, readBuffer: *mut u8, out: *mut ProviderI2cTransferResult) -> HRESULT
}}
impl II2cDeviceProvider {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn write(&self, buffer: &[u8]) -> Result<()> {
        let hr = ((*self.lpVtbl).Write)(self as *const _ as *mut _, buffer.len() as u32, buffer.as_ptr() as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn write_partial(&self, buffer: &[u8]) -> Result<ProviderI2cTransferResult> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).WritePartial)(self as *const _ as *mut _, buffer.len() as u32, buffer.as_ptr() as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn read(&self, bufferSize: u32, buffer: *mut u8) -> Result<()> {
        let hr = ((*self.lpVtbl).Read)(self as *const _ as *mut _, bufferSize, buffer);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn read_partial(&self, bufferSize: u32, buffer: *mut u8) -> Result<ProviderI2cTransferResult> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).ReadPartial)(self as *const _ as *mut _, bufferSize, buffer, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn write_read(&self, writeBuffer: &[u8], readBufferSize: u32, readBuffer: *mut u8) -> Result<()> {
        let hr = ((*self.lpVtbl).WriteRead)(self as *const _ as *mut _, writeBuffer.len() as u32, writeBuffer.as_ptr() as *mut _, readBufferSize, readBuffer);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn write_read_partial(&self, writeBuffer: &[u8], readBufferSize: u32, readBuffer: *mut u8) -> Result<ProviderI2cTransferResult> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).WriteReadPartial)(self as *const _ as *mut _, writeBuffer.len() as u32, writeBuffer.as_ptr() as *mut _, readBufferSize, readBuffer, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
} // Windows.Devices.I2c.Provider
} // Windows.Devices.I2c
pub mod pwm { // Windows.Devices.Pwm
use ::prelude::*;
RT_ENUM! { enum PwmPulsePolarity: i32 {
    ActiveHigh (PwmPulsePolarity_ActiveHigh) = 0, ActiveLow (PwmPulsePolarity_ActiveLow) = 1,
}}
DEFINE_IID!(IID_IPwmController, 3294583941, 53992, 17103, 155, 214, 207, 94, 208, 41, 230, 167);
RT_INTERFACE!{interface IPwmController(IPwmControllerVtbl): IInspectable(IInspectableVtbl) [IID_IPwmController] {
    fn get_PinCount(&self, out: *mut i32) -> HRESULT,
    fn get_ActualFrequency(&self, out: *mut f64) -> HRESULT,
    fn SetDesiredFrequency(&self, desiredFrequency: f64, out: *mut f64) -> HRESULT,
    fn get_MinFrequency(&self, out: *mut f64) -> HRESULT,
    fn get_MaxFrequency(&self, out: *mut f64) -> HRESULT,
    fn OpenPin(&self, pinNumber: i32, out: *mut *mut PwmPin) -> HRESULT
}}
impl IPwmController {
    #[inline] pub unsafe fn get_pin_count(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PinCount)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_actual_frequency(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ActualFrequency)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_desired_frequency(&self, desiredFrequency: f64) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).SetDesiredFrequency)(self as *const _ as *mut _, desiredFrequency, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_min_frequency(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinFrequency)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_frequency(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxFrequency)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn open_pin(&self, pinNumber: i32) -> Result<ComPtr<PwmPin>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).OpenPin)(self as *const _ as *mut _, pinNumber, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PwmPin: IPwmPin}
DEFINE_IID!(IID_IPwmControllerStatics, 1113832865, 35142, 17412, 189, 72, 129, 221, 18, 74, 244, 217);
RT_INTERFACE!{static interface IPwmControllerStatics(IPwmControllerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IPwmControllerStatics] {
    fn GetControllersAsync(&self, provider: *mut provider::IPwmProvider, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PwmController>>) -> HRESULT
}}
impl IPwmControllerStatics {
    #[inline] pub unsafe fn get_controllers_async(&self, provider: &provider::IPwmProvider) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PwmController>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetControllersAsync)(self as *const _ as *mut _, provider as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PwmController: IPwmController}
impl RtActivatable<IPwmControllerStatics> for PwmController {}
impl RtActivatable<IPwmControllerStatics2> for PwmController {}
impl RtActivatable<IPwmControllerStatics3> for PwmController {}
impl PwmController {
    #[inline] pub fn get_controllers_async(provider: &provider::IPwmProvider) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PwmController>>>> { unsafe {
        <Self as RtActivatable<IPwmControllerStatics>>::get_activation_factory().get_controllers_async(provider)
    }}
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<PwmController>>> { unsafe {
        <Self as RtActivatable<IPwmControllerStatics2>>::get_activation_factory().get_default_async()
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IPwmControllerStatics3>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn get_device_selector_from_friendly_name(friendlyName: &HStringArg) -> Result<HString> { unsafe {
        <Self as RtActivatable<IPwmControllerStatics3>>::get_activation_factory().get_device_selector_from_friendly_name(friendlyName)
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PwmController>>> { unsafe {
        <Self as RtActivatable<IPwmControllerStatics3>>::get_activation_factory().from_id_async(deviceId)
    }}
}
DEFINE_CLSID!(PwmController(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,119,109,46,80,119,109,67,111,110,116,114,111,108,108,101,114,0]) [CLSID_PwmController]);
DEFINE_IID!(IID_IPwmControllerStatics2, 1157389087, 61721, 19421, 151, 173, 247, 110, 249, 134, 115, 109);
RT_INTERFACE!{static interface IPwmControllerStatics2(IPwmControllerStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IPwmControllerStatics2] {
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<PwmController>) -> HRESULT
}}
impl IPwmControllerStatics2 {
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PwmController>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPwmControllerStatics3, 2992117873, 553, 17220, 174, 63, 155, 124, 208, 230, 107, 148);
RT_INTERFACE!{static interface IPwmControllerStatics3(IPwmControllerStatics3Vtbl): IInspectable(IInspectableVtbl) [IID_IPwmControllerStatics3] {
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromFriendlyName(&self, friendlyName: HSTRING, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<PwmController>) -> HRESULT
}}
impl IPwmControllerStatics3 {
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_friendly_name(&self, friendlyName: &HStringArg) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromFriendlyName)(self as *const _ as *mut _, friendlyName.get(), &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PwmController>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPwmPin, 580333000, 50895, 18465, 183, 249, 198, 69, 79, 182, 175, 121);
RT_INTERFACE!{interface IPwmPin(IPwmPinVtbl): IInspectable(IInspectableVtbl) [IID_IPwmPin] {
    fn get_Controller(&self, out: *mut *mut PwmController) -> HRESULT,
    fn GetActiveDutyCyclePercentage(&self, out: *mut f64) -> HRESULT,
    fn SetActiveDutyCyclePercentage(&self, dutyCyclePercentage: f64) -> HRESULT,
    fn get_Polarity(&self, out: *mut PwmPulsePolarity) -> HRESULT,
    fn put_Polarity(&self, value: PwmPulsePolarity) -> HRESULT,
    fn Start(&self) -> HRESULT,
    fn Stop(&self) -> HRESULT,
    fn get_IsStarted(&self, out: *mut bool) -> HRESULT
}}
impl IPwmPin {
    #[inline] pub unsafe fn get_controller(&self) -> Result<ComPtr<PwmController>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Controller)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_active_duty_cycle_percentage(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).GetActiveDutyCyclePercentage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_active_duty_cycle_percentage(&self, dutyCyclePercentage: f64) -> Result<()> {
        let hr = ((*self.lpVtbl).SetActiveDutyCyclePercentage)(self as *const _ as *mut _, dutyCyclePercentage);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_polarity(&self) -> Result<PwmPulsePolarity> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Polarity)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_polarity(&self, value: PwmPulsePolarity) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Polarity)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Stop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_started(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStarted)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
pub mod provider { // Windows.Devices.Pwm.Provider
use ::prelude::*;
DEFINE_IID!(IID_IPwmControllerProvider, 318789947, 58083, 16548, 183, 217, 72, 223, 240, 55, 122, 82);
RT_INTERFACE!{interface IPwmControllerProvider(IPwmControllerProviderVtbl): IInspectable(IInspectableVtbl) [IID_IPwmControllerProvider] {
    fn get_PinCount(&self, out: *mut i32) -> HRESULT,
    fn get_ActualFrequency(&self, out: *mut f64) -> HRESULT,
    fn SetDesiredFrequency(&self, frequency: f64, out: *mut f64) -> HRESULT,
    fn get_MaxFrequency(&self, out: *mut f64) -> HRESULT,
    fn get_MinFrequency(&self, out: *mut f64) -> HRESULT,
    fn AcquirePin(&self, pin: i32) -> HRESULT,
    fn ReleasePin(&self, pin: i32) -> HRESULT,
    fn EnablePin(&self, pin: i32) -> HRESULT,
    fn DisablePin(&self, pin: i32) -> HRESULT,
    fn SetPulseParameters(&self, pin: i32, dutyCycle: f64, invertPolarity: bool) -> HRESULT
}}
impl IPwmControllerProvider {
    #[inline] pub unsafe fn get_pin_count(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PinCount)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_actual_frequency(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ActualFrequency)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_desired_frequency(&self, frequency: f64) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).SetDesiredFrequency)(self as *const _ as *mut _, frequency, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_frequency(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxFrequency)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_min_frequency(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinFrequency)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn acquire_pin(&self, pin: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).AcquirePin)(self as *const _ as *mut _, pin);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn release_pin(&self, pin: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).ReleasePin)(self as *const _ as *mut _, pin);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn enable_pin(&self, pin: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).EnablePin)(self as *const _ as *mut _, pin);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn disable_pin(&self, pin: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).DisablePin)(self as *const _ as *mut _, pin);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_pulse_parameters(&self, pin: i32, dutyCycle: f64, invertPolarity: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).SetPulseParameters)(self as *const _ as *mut _, pin, dutyCycle, invertPolarity);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPwmProvider, 2737836584, 21233, 18352, 147, 73, 102, 186, 67, 210, 89, 2);
RT_INTERFACE!{interface IPwmProvider(IPwmProviderVtbl): IInspectable(IInspectableVtbl) [IID_IPwmProvider] {
    fn GetControllers(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<IPwmControllerProvider>) -> HRESULT
}}
impl IPwmProvider {
    #[inline] pub unsafe fn get_controllers(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<IPwmControllerProvider>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetControllers)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
} // Windows.Devices.Pwm.Provider
} // Windows.Devices.Pwm
pub mod spi { // Windows.Devices.Spi
use ::prelude::*;
RT_ENUM! { enum SpiMode: i32 {
    Mode0 (SpiMode_Mode0) = 0, Mode1 (SpiMode_Mode1) = 1, Mode2 (SpiMode_Mode2) = 2, Mode3 (SpiMode_Mode3) = 3,
}}
RT_ENUM! { enum SpiSharingMode: i32 {
    Exclusive (SpiSharingMode_Exclusive) = 0, Shared (SpiSharingMode_Shared) = 1,
}}
DEFINE_IID!(IID_ISpiConnectionSettingsFactory, 4288219166, 4292, 17591, 159, 234, 167, 72, 181, 164, 111, 49);
RT_INTERFACE!{static interface ISpiConnectionSettingsFactory(ISpiConnectionSettingsFactoryVtbl): IInspectable(IInspectableVtbl) [IID_ISpiConnectionSettingsFactory] {
    fn Create(&self, chipSelectLine: i32, out: *mut *mut SpiConnectionSettings) -> HRESULT
}}
impl ISpiConnectionSettingsFactory {
    #[inline] pub unsafe fn create(&self, chipSelectLine: i32) -> Result<ComPtr<SpiConnectionSettings>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, chipSelectLine, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SpiConnectionSettings: ISpiConnectionSettings}
impl RtActivatable<ISpiConnectionSettingsFactory> for SpiConnectionSettings {}
impl SpiConnectionSettings {
    #[inline] pub fn create(chipSelectLine: i32) -> Result<ComPtr<SpiConnectionSettings>> { unsafe {
        <Self as RtActivatable<ISpiConnectionSettingsFactory>>::get_activation_factory().create(chipSelectLine)
    }}
}
DEFINE_CLSID!(SpiConnectionSettings(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,112,105,46,83,112,105,67,111,110,110,101,99,116,105,111,110,83,101,116,116,105,110,103,115,0]) [CLSID_SpiConnectionSettings]);
DEFINE_IID!(IID_ISpiConnectionSettings, 1384358783, 63797, 19359, 167, 167, 58, 120, 144, 175, 165, 206);
RT_INTERFACE!{interface ISpiConnectionSettings(ISpiConnectionSettingsVtbl): IInspectable(IInspectableVtbl) [IID_ISpiConnectionSettings] {
    fn get_ChipSelectLine(&self, out: *mut i32) -> HRESULT,
    fn put_ChipSelectLine(&self, value: i32) -> HRESULT,
    fn get_Mode(&self, out: *mut SpiMode) -> HRESULT,
    fn put_Mode(&self, value: SpiMode) -> HRESULT,
    fn get_DataBitLength(&self, out: *mut i32) -> HRESULT,
    fn put_DataBitLength(&self, value: i32) -> HRESULT,
    fn get_ClockFrequency(&self, out: *mut i32) -> HRESULT,
    fn put_ClockFrequency(&self, value: i32) -> HRESULT,
    fn get_SharingMode(&self, out: *mut SpiSharingMode) -> HRESULT,
    fn put_SharingMode(&self, value: SpiSharingMode) -> HRESULT
}}
impl ISpiConnectionSettings {
    #[inline] pub unsafe fn get_chip_select_line(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ChipSelectLine)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_chip_select_line(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ChipSelectLine)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_mode(&self) -> Result<SpiMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Mode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_mode(&self, value: SpiMode) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Mode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_data_bit_length(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DataBitLength)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_data_bit_length(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DataBitLength)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_clock_frequency(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ClockFrequency)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_clock_frequency(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ClockFrequency)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sharing_mode(&self) -> Result<SpiSharingMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SharingMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_sharing_mode(&self, value: SpiSharingMode) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SharingMode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISpiBusInfo, 2569618506, 21746, 18630, 185, 82, 156, 50, 252, 2, 198, 105);
RT_INTERFACE!{interface ISpiBusInfo(ISpiBusInfoVtbl): IInspectable(IInspectableVtbl) [IID_ISpiBusInfo] {
    fn get_ChipSelectLineCount(&self, out: *mut i32) -> HRESULT,
    fn get_MinClockFrequency(&self, out: *mut i32) -> HRESULT,
    fn get_MaxClockFrequency(&self, out: *mut i32) -> HRESULT,
    fn get_SupportedDataBitLengths(&self, out: *mut *mut super::super::foundation::collections::IVectorView<i32>) -> HRESULT
}}
impl ISpiBusInfo {
    #[inline] pub unsafe fn get_chip_select_line_count(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ChipSelectLineCount)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_min_clock_frequency(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinClockFrequency)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_clock_frequency(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxClockFrequency)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_data_bit_lengths(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<i32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedDataBitLengths)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SpiBusInfo: ISpiBusInfo}
DEFINE_IID!(IID_ISpiDeviceStatics, 2725832025, 22304, 19775, 189, 147, 86, 245, 255, 90, 88, 121);
RT_INTERFACE!{static interface ISpiDeviceStatics(ISpiDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ISpiDeviceStatics] {
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromFriendlyName(&self, friendlyName: HSTRING, out: *mut HSTRING) -> HRESULT,
    fn GetBusInfo(&self, busId: HSTRING, out: *mut *mut SpiBusInfo) -> HRESULT,
    fn FromIdAsync(&self, busId: HSTRING, settings: *mut SpiConnectionSettings, out: *mut *mut super::super::foundation::IAsyncOperation<SpiDevice>) -> HRESULT
}}
impl ISpiDeviceStatics {
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_friendly_name(&self, friendlyName: &HStringArg) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromFriendlyName)(self as *const _ as *mut _, friendlyName.get(), &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bus_info(&self, busId: &HStringArg) -> Result<ComPtr<SpiBusInfo>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetBusInfo)(self as *const _ as *mut _, busId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, busId: &HStringArg, settings: &SpiConnectionSettings) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SpiDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, busId.get(), settings as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SpiDevice: ISpiDevice}
impl RtActivatable<ISpiDeviceStatics> for SpiDevice {}
impl SpiDevice {
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<ISpiDeviceStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn get_device_selector_from_friendly_name(friendlyName: &HStringArg) -> Result<HString> { unsafe {
        <Self as RtActivatable<ISpiDeviceStatics>>::get_activation_factory().get_device_selector_from_friendly_name(friendlyName)
    }}
    #[inline] pub fn get_bus_info(busId: &HStringArg) -> Result<ComPtr<SpiBusInfo>> { unsafe {
        <Self as RtActivatable<ISpiDeviceStatics>>::get_activation_factory().get_bus_info(busId)
    }}
    #[inline] pub fn from_id_async(busId: &HStringArg, settings: &SpiConnectionSettings) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SpiDevice>>> { unsafe {
        <Self as RtActivatable<ISpiDeviceStatics>>::get_activation_factory().from_id_async(busId, settings)
    }}
}
DEFINE_CLSID!(SpiDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,112,105,46,83,112,105,68,101,118,105,99,101,0]) [CLSID_SpiDevice]);
DEFINE_IID!(IID_ISpiController, 2832451625, 39061, 16729, 169, 52, 135, 65, 241, 238, 109, 39);
RT_INTERFACE!{interface ISpiController(ISpiControllerVtbl): IInspectable(IInspectableVtbl) [IID_ISpiController] {
    fn GetDevice(&self, settings: *mut SpiConnectionSettings, out: *mut *mut SpiDevice) -> HRESULT
}}
impl ISpiController {
    #[inline] pub unsafe fn get_device(&self, settings: &SpiConnectionSettings) -> Result<ComPtr<SpiDevice>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDevice)(self as *const _ as *mut _, settings as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISpiControllerStatics, 223488482, 5003, 20040, 185, 100, 79, 47, 121, 185, 197, 162);
RT_INTERFACE!{static interface ISpiControllerStatics(ISpiControllerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ISpiControllerStatics] {
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<SpiController>) -> HRESULT,
    fn GetControllersAsync(&self, provider: *mut provider::ISpiProvider, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<SpiController>>) -> HRESULT
}}
impl ISpiControllerStatics {
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SpiController>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_controllers_async(&self, provider: &provider::ISpiProvider) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<SpiController>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetControllersAsync)(self as *const _ as *mut _, provider as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SpiController: ISpiController}
impl RtActivatable<ISpiControllerStatics> for SpiController {}
impl SpiController {
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<SpiController>>> { unsafe {
        <Self as RtActivatable<ISpiControllerStatics>>::get_activation_factory().get_default_async()
    }}
    #[inline] pub fn get_controllers_async(provider: &provider::ISpiProvider) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<SpiController>>>> { unsafe {
        <Self as RtActivatable<ISpiControllerStatics>>::get_activation_factory().get_controllers_async(provider)
    }}
}
DEFINE_CLSID!(SpiController(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,112,105,46,83,112,105,67,111,110,116,114,111,108,108,101,114,0]) [CLSID_SpiController]);
DEFINE_IID!(IID_ISpiDevice, 97858925, 4534, 19769, 132, 213, 149, 223, 180, 201, 242, 206);
RT_INTERFACE!{interface ISpiDevice(ISpiDeviceVtbl): IInspectable(IInspectableVtbl) [IID_ISpiDevice] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ConnectionSettings(&self, out: *mut *mut SpiConnectionSettings) -> HRESULT,
    fn Write(&self, bufferSize: u32, buffer: *mut u8) -> HRESULT,
    fn Read(&self, bufferSize: u32, buffer: *mut u8) -> HRESULT,
    fn TransferSequential(&self, writeBufferSize: u32, writeBuffer: *mut u8, readBufferSize: u32, readBuffer: *mut u8) -> HRESULT,
    fn TransferFullDuplex(&self, writeBufferSize: u32, writeBuffer: *mut u8, readBufferSize: u32, readBuffer: *mut u8) -> HRESULT
}}
impl ISpiDevice {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_connection_settings(&self) -> Result<ComPtr<SpiConnectionSettings>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ConnectionSettings)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn write(&self, buffer: &[u8]) -> Result<()> {
        let hr = ((*self.lpVtbl).Write)(self as *const _ as *mut _, buffer.len() as u32, buffer.as_ptr() as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn read(&self, bufferSize: u32, buffer: *mut u8) -> Result<()> {
        let hr = ((*self.lpVtbl).Read)(self as *const _ as *mut _, bufferSize, buffer);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn transfer_sequential(&self, writeBuffer: &[u8], readBufferSize: u32, readBuffer: *mut u8) -> Result<()> {
        let hr = ((*self.lpVtbl).TransferSequential)(self as *const _ as *mut _, writeBuffer.len() as u32, writeBuffer.as_ptr() as *mut _, readBufferSize, readBuffer);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn transfer_full_duplex(&self, writeBuffer: &[u8], readBufferSize: u32, readBuffer: *mut u8) -> Result<()> {
        let hr = ((*self.lpVtbl).TransferFullDuplex)(self as *const _ as *mut _, writeBuffer.len() as u32, writeBuffer.as_ptr() as *mut _, readBufferSize, readBuffer);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
pub mod provider { // Windows.Devices.Spi.Provider
use ::prelude::*;
RT_ENUM! { enum ProviderSpiMode: i32 {
    Mode0 (ProviderSpiMode_Mode0) = 0, Mode1 (ProviderSpiMode_Mode1) = 1, Mode2 (ProviderSpiMode_Mode2) = 2, Mode3 (ProviderSpiMode_Mode3) = 3,
}}
RT_ENUM! { enum ProviderSpiSharingMode: i32 {
    Exclusive (ProviderSpiSharingMode_Exclusive) = 0, Shared (ProviderSpiSharingMode_Shared) = 1,
}}
DEFINE_IID!(IID_IProviderSpiConnectionSettingsFactory, 1715825498, 3193, 17379, 159, 60, 229, 151, 128, 172, 24, 250);
RT_INTERFACE!{static interface IProviderSpiConnectionSettingsFactory(IProviderSpiConnectionSettingsFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IProviderSpiConnectionSettingsFactory] {
    fn Create(&self, chipSelectLine: i32, out: *mut *mut ProviderSpiConnectionSettings) -> HRESULT
}}
impl IProviderSpiConnectionSettingsFactory {
    #[inline] pub unsafe fn create(&self, chipSelectLine: i32) -> Result<ComPtr<ProviderSpiConnectionSettings>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, chipSelectLine, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class ProviderSpiConnectionSettings: IProviderSpiConnectionSettings}
impl RtActivatable<IProviderSpiConnectionSettingsFactory> for ProviderSpiConnectionSettings {}
impl ProviderSpiConnectionSettings {
    #[inline] pub fn create(chipSelectLine: i32) -> Result<ComPtr<ProviderSpiConnectionSettings>> { unsafe {
        <Self as RtActivatable<IProviderSpiConnectionSettingsFactory>>::get_activation_factory().create(chipSelectLine)
    }}
}
DEFINE_CLSID!(ProviderSpiConnectionSettings(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,112,105,46,80,114,111,118,105,100,101,114,46,80,114,111,118,105,100,101,114,83,112,105,67,111,110,110,101,99,116,105,111,110,83,101,116,116,105,110,103,115,0]) [CLSID_ProviderSpiConnectionSettings]);
DEFINE_IID!(IID_IProviderSpiConnectionSettings, 4127409488, 42306, 20160, 150, 1, 164, 221, 104, 248, 105, 123);
RT_INTERFACE!{interface IProviderSpiConnectionSettings(IProviderSpiConnectionSettingsVtbl): IInspectable(IInspectableVtbl) [IID_IProviderSpiConnectionSettings] {
    fn get_ChipSelectLine(&self, out: *mut i32) -> HRESULT,
    fn put_ChipSelectLine(&self, value: i32) -> HRESULT,
    fn get_Mode(&self, out: *mut ProviderSpiMode) -> HRESULT,
    fn put_Mode(&self, value: ProviderSpiMode) -> HRESULT,
    fn get_DataBitLength(&self, out: *mut i32) -> HRESULT,
    fn put_DataBitLength(&self, value: i32) -> HRESULT,
    fn get_ClockFrequency(&self, out: *mut i32) -> HRESULT,
    fn put_ClockFrequency(&self, value: i32) -> HRESULT,
    fn get_SharingMode(&self, out: *mut ProviderSpiSharingMode) -> HRESULT,
    fn put_SharingMode(&self, value: ProviderSpiSharingMode) -> HRESULT
}}
impl IProviderSpiConnectionSettings {
    #[inline] pub unsafe fn get_chip_select_line(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ChipSelectLine)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_chip_select_line(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ChipSelectLine)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_mode(&self) -> Result<ProviderSpiMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Mode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_mode(&self, value: ProviderSpiMode) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Mode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_data_bit_length(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DataBitLength)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_data_bit_length(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DataBitLength)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_clock_frequency(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ClockFrequency)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_clock_frequency(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ClockFrequency)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sharing_mode(&self) -> Result<ProviderSpiSharingMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SharingMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_sharing_mode(&self, value: ProviderSpiSharingMode) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SharingMode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISpiControllerProvider, 3244844292, 718, 16934, 163, 133, 79, 17, 251, 4, 180, 27);
RT_INTERFACE!{interface ISpiControllerProvider(ISpiControllerProviderVtbl): IInspectable(IInspectableVtbl) [IID_ISpiControllerProvider] {
    fn GetDeviceProvider(&self, settings: *mut ProviderSpiConnectionSettings, out: *mut *mut ISpiDeviceProvider) -> HRESULT
}}
impl ISpiControllerProvider {
    #[inline] pub unsafe fn get_device_provider(&self, settings: &ProviderSpiConnectionSettings) -> Result<ComPtr<ISpiDeviceProvider>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceProvider)(self as *const _ as *mut _, settings as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISpiProvider, 2528403938, 30676, 18638, 170, 160, 117, 113, 90, 131, 98, 207);
RT_INTERFACE!{interface ISpiProvider(ISpiProviderVtbl): IInspectable(IInspectableVtbl) [IID_ISpiProvider] {
    fn GetControllersAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<::rt::gen::windows::foundation::collections::IVectorView<ISpiControllerProvider>>) -> HRESULT
}}
impl ISpiProvider {
    #[inline] pub unsafe fn get_controllers_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<::rt::gen::windows::foundation::collections::IVectorView<ISpiControllerProvider>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetControllersAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISpiDeviceProvider, 219952195, 12363, 16476, 180, 247, 245, 171, 16, 116, 70, 30);
RT_INTERFACE!{interface ISpiDeviceProvider(ISpiDeviceProviderVtbl): IInspectable(IInspectableVtbl) [IID_ISpiDeviceProvider] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ConnectionSettings(&self, out: *mut *mut ProviderSpiConnectionSettings) -> HRESULT,
    fn Write(&self, bufferSize: u32, buffer: *mut u8) -> HRESULT,
    fn Read(&self, bufferSize: u32, buffer: *mut u8) -> HRESULT,
    fn TransferSequential(&self, writeBufferSize: u32, writeBuffer: *mut u8, readBufferSize: u32, readBuffer: *mut u8) -> HRESULT,
    fn TransferFullDuplex(&self, writeBufferSize: u32, writeBuffer: *mut u8, readBufferSize: u32, readBuffer: *mut u8) -> HRESULT
}}
impl ISpiDeviceProvider {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_connection_settings(&self) -> Result<ComPtr<ProviderSpiConnectionSettings>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ConnectionSettings)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn write(&self, buffer: &[u8]) -> Result<()> {
        let hr = ((*self.lpVtbl).Write)(self as *const _ as *mut _, buffer.len() as u32, buffer.as_ptr() as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn read(&self, bufferSize: u32, buffer: *mut u8) -> Result<()> {
        let hr = ((*self.lpVtbl).Read)(self as *const _ as *mut _, bufferSize, buffer);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn transfer_sequential(&self, writeBuffer: &[u8], readBufferSize: u32, readBuffer: *mut u8) -> Result<()> {
        let hr = ((*self.lpVtbl).TransferSequential)(self as *const _ as *mut _, writeBuffer.len() as u32, writeBuffer.as_ptr() as *mut _, readBufferSize, readBuffer);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn transfer_full_duplex(&self, writeBuffer: &[u8], readBufferSize: u32, readBuffer: *mut u8) -> Result<()> {
        let hr = ((*self.lpVtbl).TransferFullDuplex)(self as *const _ as *mut _, writeBuffer.len() as u32, writeBuffer.as_ptr() as *mut _, readBufferSize, readBuffer);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
} // Windows.Devices.Spi.Provider
} // Windows.Devices.Spi
pub mod printers { // Windows.Devices.Printers
use ::prelude::*;
DEFINE_IID!(IID_IPrint3DDeviceStatics, 4259537418, 26573, 16823, 163, 68, 81, 80, 161, 253, 117, 181);
RT_INTERFACE!{static interface IPrint3DDeviceStatics(IPrint3DDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IPrint3DDeviceStatics] {
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<Print3DDevice>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT
}}
impl IPrint3DDeviceStatics {
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Print3DDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Print3DDevice: IPrint3DDevice}
impl RtActivatable<IPrint3DDeviceStatics> for Print3DDevice {}
impl Print3DDevice {
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Print3DDevice>>> { unsafe {
        <Self as RtActivatable<IPrint3DDeviceStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IPrint3DDeviceStatics>>::get_activation_factory().get_device_selector()
    }}
}
DEFINE_CLSID!(Print3DDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,114,105,110,116,101,114,115,46,80,114,105,110,116,51,68,68,101,118,105,99,101,0]) [CLSID_Print3DDevice]);
DEFINE_IID!(IID_IPrint3DDevice, 68959513, 38675, 17058, 152, 19, 125, 195, 51, 116, 40, 211);
RT_INTERFACE!{interface IPrint3DDevice(IPrint3DDeviceVtbl): IInspectable(IInspectableVtbl) [IID_IPrint3DDevice] {
    fn get_PrintSchema(&self, out: *mut *mut PrintSchema) -> HRESULT
}}
impl IPrint3DDevice {
    #[inline] pub unsafe fn get_print_schema(&self) -> Result<ComPtr<PrintSchema>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PrintSchema)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PrintSchema: IPrintSchema}
DEFINE_IID!(IID_IPrintSchema, 3266937622, 9912, 19451, 129, 56, 159, 150, 44, 34, 163, 91);
RT_INTERFACE!{interface IPrintSchema(IPrintSchemaVtbl): IInspectable(IInspectableVtbl) [IID_IPrintSchema] {
    #[cfg(feature="windows-storage")] fn GetDefaultPrintTicketAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::storage::streams::IRandomAccessStreamWithContentType>) -> HRESULT,
    #[cfg(feature="windows-storage")] fn GetCapabilitiesAsync(&self, constrainTicket: *mut super::super::storage::streams::IRandomAccessStreamWithContentType, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::storage::streams::IRandomAccessStreamWithContentType>) -> HRESULT,
    #[cfg(feature="windows-storage")] fn MergeAndValidateWithDefaultPrintTicketAsync(&self, deltaTicket: *mut super::super::storage::streams::IRandomAccessStreamWithContentType, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::storage::streams::IRandomAccessStreamWithContentType>) -> HRESULT
}}
impl IPrintSchema {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_default_print_ticket_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::storage::streams::IRandomAccessStreamWithContentType>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultPrintTicketAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_capabilities_async(&self, constrainTicket: &super::super::storage::streams::IRandomAccessStreamWithContentType) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::storage::streams::IRandomAccessStreamWithContentType>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCapabilitiesAsync)(self as *const _ as *mut _, constrainTicket as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn merge_and_validate_with_default_print_ticket_async(&self, deltaTicket: &super::super::storage::streams::IRandomAccessStreamWithContentType) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::storage::streams::IRandomAccessStreamWithContentType>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).MergeAndValidateWithDefaultPrintTicketAsync)(self as *const _ as *mut _, deltaTicket as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
pub mod extensions { // Windows.Devices.Printers.Extensions
use ::prelude::*;
RT_ENUM! { enum Print3DWorkflowStatus: i32 {
    Abandoned (Print3DWorkflowStatus_Abandoned) = 0, Canceled (Print3DWorkflowStatus_Canceled) = 1, Failed (Print3DWorkflowStatus_Failed) = 2, Slicing (Print3DWorkflowStatus_Slicing) = 3, Submitted (Print3DWorkflowStatus_Submitted) = 4,
}}
RT_ENUM! { enum Print3DWorkflowDetail: i32 {
    Unknown (Print3DWorkflowDetail_Unknown) = 0, ModelExceedsPrintBed (Print3DWorkflowDetail_ModelExceedsPrintBed) = 1, UploadFailed (Print3DWorkflowDetail_UploadFailed) = 2, InvalidMaterialSelection (Print3DWorkflowDetail_InvalidMaterialSelection) = 3, InvalidModel (Print3DWorkflowDetail_InvalidModel) = 4, ModelNotManifold (Print3DWorkflowDetail_ModelNotManifold) = 5, InvalidPrintTicket (Print3DWorkflowDetail_InvalidPrintTicket) = 6,
}}
DEFINE_IID!(IID_IPrint3DWorkflowPrintRequestedEventArgs, 435734616, 23240, 19285, 138, 95, 230, 21, 103, 218, 251, 77);
RT_INTERFACE!{interface IPrint3DWorkflowPrintRequestedEventArgs(IPrint3DWorkflowPrintRequestedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPrint3DWorkflowPrintRequestedEventArgs] {
    fn get_Status(&self, out: *mut Print3DWorkflowStatus) -> HRESULT,
    fn SetExtendedStatus(&self, value: Print3DWorkflowDetail) -> HRESULT,
    fn SetSource(&self, source: *mut IInspectable) -> HRESULT,
    fn SetSourceChanged(&self, value: bool) -> HRESULT
}}
impl IPrint3DWorkflowPrintRequestedEventArgs {
    #[inline] pub unsafe fn get_status(&self) -> Result<Print3DWorkflowStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_extended_status(&self, value: Print3DWorkflowDetail) -> Result<()> {
        let hr = ((*self.lpVtbl).SetExtendedStatus)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_source(&self, source: &IInspectable) -> Result<()> {
        let hr = ((*self.lpVtbl).SetSource)(self as *const _ as *mut _, source as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_source_changed(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).SetSourceChanged)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPrint3DWorkflowPrinterChangedEventArgs, 1159881730, 38396, 18503, 147, 179, 19, 77, 191, 92, 96, 247);
RT_INTERFACE!{interface IPrint3DWorkflowPrinterChangedEventArgs(IPrint3DWorkflowPrinterChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPrint3DWorkflowPrinterChangedEventArgs] {
    fn get_NewDeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl IPrint3DWorkflowPrinterChangedEventArgs {
    #[inline] pub unsafe fn get_new_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_NewDeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Print3DWorkflowPrintRequestedEventArgs: IPrint3DWorkflowPrintRequestedEventArgs}
RT_CLASS!{class Print3DWorkflowPrinterChangedEventArgs: IPrint3DWorkflowPrinterChangedEventArgs}
DEFINE_IID!(IID_IPrint3DWorkflow, 3312415933, 13929, 19046, 171, 66, 200, 21, 25, 48, 205, 52);
RT_INTERFACE!{interface IPrint3DWorkflow(IPrint3DWorkflowVtbl): IInspectable(IInspectableVtbl) [IID_IPrint3DWorkflow] {
    fn get_DeviceID(&self, out: *mut HSTRING) -> HRESULT,
    fn GetPrintModelPackage(&self, out: *mut *mut IInspectable) -> HRESULT,
    fn get_IsPrintReady(&self, out: *mut bool) -> HRESULT,
    fn put_IsPrintReady(&self, value: bool) -> HRESULT,
    fn add_PrintRequested(&self, eventHandler: *mut ::rt::gen::windows::foundation::TypedEventHandler<Print3DWorkflow, Print3DWorkflowPrintRequestedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_PrintRequested(&self, eventCookie: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT
}}
impl IPrint3DWorkflow {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceID)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_print_model_package(&self) -> Result<ComPtr<IInspectable>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetPrintModelPackage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_print_ready(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsPrintReady)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_print_ready(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsPrintReady)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_print_requested(&self, eventHandler: &::rt::gen::windows::foundation::TypedEventHandler<Print3DWorkflow, Print3DWorkflowPrintRequestedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_PrintRequested)(self as *const _ as *mut _, eventHandler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_print_requested(&self, eventCookie: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_PrintRequested)(self as *const _ as *mut _, eventCookie);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class Print3DWorkflow: IPrint3DWorkflow}
DEFINE_IID!(IID_IPrint3DWorkflow2, 2728838479, 35521, 18712, 151, 65, 227, 79, 48, 4, 35, 158);
RT_INTERFACE!{interface IPrint3DWorkflow2(IPrint3DWorkflow2Vtbl): IInspectable(IInspectableVtbl) [IID_IPrint3DWorkflow2] {
    fn add_PrinterChanged(&self, eventHandler: *mut ::rt::gen::windows::foundation::TypedEventHandler<Print3DWorkflow, Print3DWorkflowPrinterChangedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_PrinterChanged(&self, eventCookie: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT
}}
impl IPrint3DWorkflow2 {
    #[inline] pub unsafe fn add_printer_changed(&self, eventHandler: &::rt::gen::windows::foundation::TypedEventHandler<Print3DWorkflow, Print3DWorkflowPrinterChangedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_PrinterChanged)(self as *const _ as *mut _, eventHandler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_printer_changed(&self, eventCookie: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_PrinterChanged)(self as *const _ as *mut _, eventCookie);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPrintTaskConfigurationSaveRequestedDeferral, 3914978664, 63273, 17572, 135, 29, 189, 6, 40, 105, 106, 51);
RT_INTERFACE!{interface IPrintTaskConfigurationSaveRequestedDeferral(IPrintTaskConfigurationSaveRequestedDeferralVtbl): IInspectable(IInspectableVtbl) [IID_IPrintTaskConfigurationSaveRequestedDeferral] {
    fn Complete(&self) -> HRESULT
}}
impl IPrintTaskConfigurationSaveRequestedDeferral {
    #[inline] pub unsafe fn complete(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Complete)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class PrintTaskConfigurationSaveRequestedDeferral: IPrintTaskConfigurationSaveRequestedDeferral}
DEFINE_IID!(IID_IPrintTaskConfigurationSaveRequest, 4004458443, 25118, 19298, 172, 119, 178, 129, 204, 224, 141, 96);
RT_INTERFACE!{interface IPrintTaskConfigurationSaveRequest(IPrintTaskConfigurationSaveRequestVtbl): IInspectable(IInspectableVtbl) [IID_IPrintTaskConfigurationSaveRequest] {
    fn Cancel(&self) -> HRESULT,
    fn Save(&self, printerExtensionContext: *mut IInspectable) -> HRESULT,
    fn GetDeferral(&self, out: *mut *mut PrintTaskConfigurationSaveRequestedDeferral) -> HRESULT,
    fn get_Deadline(&self, out: *mut ::rt::gen::windows::foundation::DateTime) -> HRESULT
}}
impl IPrintTaskConfigurationSaveRequest {
    #[inline] pub unsafe fn cancel(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Cancel)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn save(&self, printerExtensionContext: &IInspectable) -> Result<()> {
        let hr = ((*self.lpVtbl).Save)(self as *const _ as *mut _, printerExtensionContext as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_deferral(&self) -> Result<ComPtr<PrintTaskConfigurationSaveRequestedDeferral>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeferral)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_deadline(&self) -> Result<::rt::gen::windows::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Deadline)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class PrintTaskConfigurationSaveRequest: IPrintTaskConfigurationSaveRequest}
DEFINE_IID!(IID_IPrintTaskConfigurationSaveRequestedEventArgs, 3765184633, 3425, 18744, 145, 208, 150, 164, 91, 238, 132, 121);
RT_INTERFACE!{interface IPrintTaskConfigurationSaveRequestedEventArgs(IPrintTaskConfigurationSaveRequestedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPrintTaskConfigurationSaveRequestedEventArgs] {
    fn get_Request(&self, out: *mut *mut PrintTaskConfigurationSaveRequest) -> HRESULT
}}
impl IPrintTaskConfigurationSaveRequestedEventArgs {
    #[inline] pub unsafe fn get_request(&self) -> Result<ComPtr<PrintTaskConfigurationSaveRequest>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Request)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PrintTaskConfigurationSaveRequestedEventArgs: IPrintTaskConfigurationSaveRequestedEventArgs}
DEFINE_IID!(IID_IPrintTaskConfiguration, 3821151313, 15012, 18565, 146, 64, 49, 31, 95, 143, 190, 157);
RT_INTERFACE!{interface IPrintTaskConfiguration(IPrintTaskConfigurationVtbl): IInspectable(IInspectableVtbl) [IID_IPrintTaskConfiguration] {
    fn get_PrinterExtensionContext(&self, out: *mut *mut IInspectable) -> HRESULT,
    fn add_SaveRequested(&self, eventHandler: *mut ::rt::gen::windows::foundation::TypedEventHandler<PrintTaskConfiguration, PrintTaskConfigurationSaveRequestedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SaveRequested(&self, eventCookie: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT
}}
impl IPrintTaskConfiguration {
    #[inline] pub unsafe fn get_printer_extension_context(&self) -> Result<ComPtr<IInspectable>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PrinterExtensionContext)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_save_requested(&self, eventHandler: &::rt::gen::windows::foundation::TypedEventHandler<PrintTaskConfiguration, PrintTaskConfigurationSaveRequestedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SaveRequested)(self as *const _ as *mut _, eventHandler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_save_requested(&self, eventCookie: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SaveRequested)(self as *const _ as *mut _, eventCookie);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class PrintTaskConfiguration: IPrintTaskConfiguration}
DEFINE_IID!(IID_IPrintNotificationEventDetails, 3759033482, 18472, 19873, 139, 184, 134, 114, 223, 133, 21, 231);
RT_INTERFACE!{interface IPrintNotificationEventDetails(IPrintNotificationEventDetailsVtbl): IInspectable(IInspectableVtbl) [IID_IPrintNotificationEventDetails] {
    fn get_PrinterName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_EventData(&self, out: *mut HSTRING) -> HRESULT,
    fn put_EventData(&self, value: HSTRING) -> HRESULT
}}
impl IPrintNotificationEventDetails {
    #[inline] pub unsafe fn get_printer_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PrinterName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_event_data(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_EventData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_event_data(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_EventData)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class PrintNotificationEventDetails: IPrintNotificationEventDetails}
DEFINE_IID!(IID_IPrintExtensionContextStatic, 3876429761, 65401, 19108, 140, 155, 12, 147, 174, 223, 222, 138);
RT_INTERFACE!{static interface IPrintExtensionContextStatic(IPrintExtensionContextStaticVtbl): IInspectable(IInspectableVtbl) [IID_IPrintExtensionContextStatic] {
    fn FromDeviceId(&self, deviceId: HSTRING, out: *mut *mut IInspectable) -> HRESULT
}}
impl IPrintExtensionContextStatic {
    #[inline] pub unsafe fn from_device_id(&self, deviceId: &HStringArg) -> Result<ComPtr<IInspectable>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromDeviceId)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{static class PrintExtensionContext}
impl RtActivatable<IPrintExtensionContextStatic> for PrintExtensionContext {}
impl PrintExtensionContext {
    #[inline] pub fn from_device_id(deviceId: &HStringArg) -> Result<ComPtr<IInspectable>> { unsafe {
        <Self as RtActivatable<IPrintExtensionContextStatic>>::get_activation_factory().from_device_id(deviceId)
    }}
}
DEFINE_CLSID!(PrintExtensionContext(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,114,105,110,116,101,114,115,46,69,120,116,101,110,115,105,111,110,115,46,80,114,105,110,116,69,120,116,101,110,115,105,111,110,67,111,110,116,101,120,116,0]) [CLSID_PrintExtensionContext]);
} // Windows.Devices.Printers.Extensions
} // Windows.Devices.Printers
pub mod custom { // Windows.Devices.Custom
use ::prelude::*;
DEFINE_IID!(IID_IKnownDeviceTypesStatics, 3998513602, 21576, 17882, 173, 27, 36, 148, 140, 35, 144, 148);
RT_INTERFACE!{static interface IKnownDeviceTypesStatics(IKnownDeviceTypesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IKnownDeviceTypesStatics] {
    fn get_Unknown(&self, out: *mut u16) -> HRESULT
}}
impl IKnownDeviceTypesStatics {
    #[inline] pub unsafe fn get_unknown(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Unknown)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{static class KnownDeviceTypes}
impl RtActivatable<IKnownDeviceTypesStatics> for KnownDeviceTypes {}
impl KnownDeviceTypes {
    #[inline] pub fn get_unknown() -> Result<u16> { unsafe {
        <Self as RtActivatable<IKnownDeviceTypesStatics>>::get_activation_factory().get_unknown()
    }}
}
DEFINE_CLSID!(KnownDeviceTypes(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,67,117,115,116,111,109,46,75,110,111,119,110,68,101,118,105,99,101,84,121,112,101,115,0]) [CLSID_KnownDeviceTypes]);
RT_ENUM! { enum IOControlAccessMode: i32 {
    Any (IOControlAccessMode_Any) = 0, Read (IOControlAccessMode_Read) = 1, Write (IOControlAccessMode_Write) = 2, ReadWrite (IOControlAccessMode_ReadWrite) = 3,
}}
RT_ENUM! { enum IOControlBufferingMethod: i32 {
    Buffered (IOControlBufferingMethod_Buffered) = 0, DirectInput (IOControlBufferingMethod_DirectInput) = 1, DirectOutput (IOControlBufferingMethod_DirectOutput) = 2, Neither (IOControlBufferingMethod_Neither) = 3,
}}
DEFINE_IID!(IID_IIOControlCode, 244668903, 24776, 17269, 167, 97, 127, 136, 8, 6, 108, 96);
RT_INTERFACE!{interface IIOControlCode(IIOControlCodeVtbl): IInspectable(IInspectableVtbl) [IID_IIOControlCode] {
    fn get_AccessMode(&self, out: *mut IOControlAccessMode) -> HRESULT,
    fn get_BufferingMethod(&self, out: *mut IOControlBufferingMethod) -> HRESULT,
    fn get_Function(&self, out: *mut u16) -> HRESULT,
    fn get_DeviceType(&self, out: *mut u16) -> HRESULT,
    fn get_ControlCode(&self, out: *mut u32) -> HRESULT
}}
impl IIOControlCode {
    #[inline] pub unsafe fn get_access_mode(&self) -> Result<IOControlAccessMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AccessMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_buffering_method(&self) -> Result<IOControlBufferingMethod> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BufferingMethod)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_function(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Function)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_type(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DeviceType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_control_code(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ControlCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IIOControlCodeFactory, 2238348528, 19473, 17582, 175, 198, 184, 212, 162, 18, 120, 143);
RT_INTERFACE!{static interface IIOControlCodeFactory(IIOControlCodeFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IIOControlCodeFactory] {
    fn CreateIOControlCode(&self, deviceType: u16, function: u16, accessMode: IOControlAccessMode, bufferingMethod: IOControlBufferingMethod, out: *mut *mut IOControlCode) -> HRESULT
}}
impl IIOControlCodeFactory {
    #[inline] pub unsafe fn create_iocontrol_code(&self, deviceType: u16, function: u16, accessMode: IOControlAccessMode, bufferingMethod: IOControlBufferingMethod) -> Result<ComPtr<IOControlCode>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateIOControlCode)(self as *const _ as *mut _, deviceType, function, accessMode, bufferingMethod, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class IOControlCode: IIOControlCode}
impl RtActivatable<IIOControlCodeFactory> for IOControlCode {}
impl IOControlCode {
    #[inline] pub fn create_iocontrol_code(deviceType: u16, function: u16, accessMode: IOControlAccessMode, bufferingMethod: IOControlBufferingMethod) -> Result<ComPtr<IOControlCode>> { unsafe {
        <Self as RtActivatable<IIOControlCodeFactory>>::get_activation_factory().create_iocontrol_code(deviceType, function, accessMode, bufferingMethod)
    }}
}
DEFINE_CLSID!(IOControlCode(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,67,117,115,116,111,109,46,73,79,67,111,110,116,114,111,108,67,111,100,101,0]) [CLSID_IOControlCode]);
RT_ENUM! { enum DeviceAccessMode: i32 {
    Read (DeviceAccessMode_Read) = 0, Write (DeviceAccessMode_Write) = 1, ReadWrite (DeviceAccessMode_ReadWrite) = 2,
}}
RT_ENUM! { enum DeviceSharingMode: i32 {
    Shared (DeviceSharingMode_Shared) = 0, Exclusive (DeviceSharingMode_Exclusive) = 1,
}}
DEFINE_IID!(IID_ICustomDeviceStatics, 3357672210, 61260, 18097, 165, 142, 238, 179, 8, 220, 137, 23);
RT_INTERFACE!{static interface ICustomDeviceStatics(ICustomDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ICustomDeviceStatics] {
    fn GetDeviceSelector(&self, classGuid: Guid, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, desiredAccess: DeviceAccessMode, sharingMode: DeviceSharingMode, out: *mut *mut super::super::foundation::IAsyncOperation<CustomDevice>) -> HRESULT
}}
impl ICustomDeviceStatics {
    #[inline] pub unsafe fn get_device_selector(&self, classGuid: Guid) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, classGuid, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg, desiredAccess: DeviceAccessMode, sharingMode: DeviceSharingMode) -> Result<ComPtr<super::super::foundation::IAsyncOperation<CustomDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), desiredAccess, sharingMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class CustomDevice: ICustomDevice}
impl RtActivatable<ICustomDeviceStatics> for CustomDevice {}
impl CustomDevice {
    #[inline] pub fn get_device_selector(classGuid: Guid) -> Result<HString> { unsafe {
        <Self as RtActivatable<ICustomDeviceStatics>>::get_activation_factory().get_device_selector(classGuid)
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg, desiredAccess: DeviceAccessMode, sharingMode: DeviceSharingMode) -> Result<ComPtr<super::super::foundation::IAsyncOperation<CustomDevice>>> { unsafe {
        <Self as RtActivatable<ICustomDeviceStatics>>::get_activation_factory().from_id_async(deviceId, desiredAccess, sharingMode)
    }}
}
DEFINE_CLSID!(CustomDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,67,117,115,116,111,109,46,67,117,115,116,111,109,68,101,118,105,99,101,0]) [CLSID_CustomDevice]);
DEFINE_IID!(IID_ICustomDevice, 3710919967, 50315, 17341, 188, 177, 222, 200, 143, 21, 20, 62);
RT_INTERFACE!{interface ICustomDevice(ICustomDeviceVtbl): IInspectable(IInspectableVtbl) [IID_ICustomDevice] {
    #[cfg(feature="windows-storage")] fn get_InputStream(&self, out: *mut *mut super::super::storage::streams::IInputStream) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_OutputStream(&self, out: *mut *mut super::super::storage::streams::IOutputStream) -> HRESULT,
    #[cfg(feature="windows-storage")] fn SendIOControlAsync(&self, ioControlCode: *mut IIOControlCode, inputBuffer: *mut super::super::storage::streams::IBuffer, outputBuffer: *mut super::super::storage::streams::IBuffer, out: *mut *mut super::super::foundation::IAsyncOperation<u32>) -> HRESULT,
    #[cfg(feature="windows-storage")] fn TrySendIOControlAsync(&self, ioControlCode: *mut IIOControlCode, inputBuffer: *mut super::super::storage::streams::IBuffer, outputBuffer: *mut super::super::storage::streams::IBuffer, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT
}}
impl ICustomDevice {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_input_stream(&self) -> Result<ComPtr<super::super::storage::streams::IInputStream>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_InputStream)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_output_stream(&self) -> Result<ComPtr<super::super::storage::streams::IOutputStream>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_OutputStream)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn send_iocontrol_async(&self, ioControlCode: &IIOControlCode, inputBuffer: &super::super::storage::streams::IBuffer, outputBuffer: &super::super::storage::streams::IBuffer) -> Result<ComPtr<super::super::foundation::IAsyncOperation<u32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).SendIOControlAsync)(self as *const _ as *mut _, ioControlCode as *const _ as *mut _, inputBuffer as *const _ as *mut _, outputBuffer as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn try_send_iocontrol_async(&self, ioControlCode: &IIOControlCode, inputBuffer: &super::super::storage::streams::IBuffer, outputBuffer: &super::super::storage::streams::IBuffer) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TrySendIOControlAsync)(self as *const _ as *mut _, ioControlCode as *const _ as *mut _, inputBuffer as *const _ as *mut _, outputBuffer as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
} // Windows.Devices.Custom
pub mod smartcards { // Windows.Devices.SmartCards
use ::prelude::*;
RT_ENUM! { enum SmartCardReaderKind: i32 {
    Any (SmartCardReaderKind_Any) = 0, Generic (SmartCardReaderKind_Generic) = 1, Tpm (SmartCardReaderKind_Tpm) = 2, Nfc (SmartCardReaderKind_Nfc) = 3, Uicc (SmartCardReaderKind_Uicc) = 4, EmbeddedSE (SmartCardReaderKind_EmbeddedSE) = 5,
}}
RT_ENUM! { enum SmartCardReaderStatus: i32 {
    Disconnected (SmartCardReaderStatus_Disconnected) = 0, Ready (SmartCardReaderStatus_Ready) = 1, Exclusive (SmartCardReaderStatus_Exclusive) = 2,
}}
RT_ENUM! { enum SmartCardStatus: i32 {
    Disconnected (SmartCardStatus_Disconnected) = 0, Ready (SmartCardStatus_Ready) = 1, Shared (SmartCardStatus_Shared) = 2, Exclusive (SmartCardStatus_Exclusive) = 3, Unresponsive (SmartCardStatus_Unresponsive) = 4,
}}
RT_ENUM! { enum SmartCardPinCharacterPolicyOption: i32 {
    Allow (SmartCardPinCharacterPolicyOption_Allow) = 0, RequireAtLeastOne (SmartCardPinCharacterPolicyOption_RequireAtLeastOne) = 1, Disallow (SmartCardPinCharacterPolicyOption_Disallow) = 2,
}}
DEFINE_IID!(IID_ISmartCardReaderStatics, 272368865, 41418, 18674, 162, 129, 91, 111, 102, 154, 241, 7);
RT_INTERFACE!{static interface ISmartCardReaderStatics(ISmartCardReaderStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ISmartCardReaderStatics] {
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorWithKind(&self, kind: SmartCardReaderKind, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<SmartCardReader>) -> HRESULT
}}
impl ISmartCardReaderStatics {
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_with_kind(&self, kind: SmartCardReaderKind) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorWithKind)(self as *const _ as *mut _, kind, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardReader>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SmartCardReader: ISmartCardReader}
impl RtActivatable<ISmartCardReaderStatics> for SmartCardReader {}
impl SmartCardReader {
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<ISmartCardReaderStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn get_device_selector_with_kind(kind: SmartCardReaderKind) -> Result<HString> { unsafe {
        <Self as RtActivatable<ISmartCardReaderStatics>>::get_activation_factory().get_device_selector_with_kind(kind)
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardReader>>> { unsafe {
        <Self as RtActivatable<ISmartCardReaderStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
}
DEFINE_CLSID!(SmartCardReader(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,109,97,114,116,67,97,114,100,115,46,83,109,97,114,116,67,97,114,100,82,101,97,100,101,114,0]) [CLSID_SmartCardReader]);
DEFINE_IID!(IID_ISmartCardReader, 276083936, 21698, 19952, 129, 122, 20, 193, 67, 120, 240, 108);
RT_INTERFACE!{interface ISmartCardReader(ISmartCardReaderVtbl): IInspectable(IInspectableVtbl) [IID_ISmartCardReader] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Name(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Kind(&self, out: *mut SmartCardReaderKind) -> HRESULT,
    fn GetStatusAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<SmartCardReaderStatus>) -> HRESULT,
    fn FindAllCardsAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<SmartCard>>) -> HRESULT,
    fn add_CardAdded(&self, handler: *mut super::super::foundation::TypedEventHandler<SmartCardReader, CardAddedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_CardAdded(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_CardRemoved(&self, handler: *mut super::super::foundation::TypedEventHandler<SmartCardReader, CardRemovedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_CardRemoved(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl ISmartCardReader {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Name)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_kind(&self) -> Result<SmartCardReaderKind> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Kind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardReaderStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetStatusAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn find_all_cards_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<SmartCard>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FindAllCardsAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_card_added(&self, handler: &super::super::foundation::TypedEventHandler<SmartCardReader, CardAddedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_CardAdded)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_card_added(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_CardAdded)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_card_removed(&self, handler: &super::super::foundation::TypedEventHandler<SmartCardReader, CardRemovedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_CardRemoved)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_card_removed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_CardRemoved)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class SmartCard: ISmartCard}
RT_CLASS!{class CardAddedEventArgs: ICardAddedEventArgs}
RT_CLASS!{class CardRemovedEventArgs: ICardRemovedEventArgs}
DEFINE_IID!(IID_ICardAddedEventArgs, 414969752, 61835, 19923, 177, 24, 223, 178, 200, 226, 60, 198);
RT_INTERFACE!{interface ICardAddedEventArgs(ICardAddedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_ICardAddedEventArgs] {
    fn get_SmartCard(&self, out: *mut *mut SmartCard) -> HRESULT
}}
impl ICardAddedEventArgs {
    #[inline] pub unsafe fn get_smart_card(&self) -> Result<ComPtr<SmartCard>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SmartCard)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ICardRemovedEventArgs, 355670703, 8919, 18757, 175, 201, 3, 180, 111, 66, 166, 205);
RT_INTERFACE!{interface ICardRemovedEventArgs(ICardRemovedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_ICardRemovedEventArgs] {
    fn get_SmartCard(&self, out: *mut *mut SmartCard) -> HRESULT
}}
impl ICardRemovedEventArgs {
    #[inline] pub unsafe fn get_smart_card(&self) -> Result<ComPtr<SmartCard>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SmartCard)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmartCard, 460425329, 25652, 17396, 181, 90, 106, 41, 98, 56, 112, 170);
RT_INTERFACE!{interface ISmartCard(ISmartCardVtbl): IInspectable(IInspectableVtbl) [IID_ISmartCard] {
    fn get_Reader(&self, out: *mut *mut SmartCardReader) -> HRESULT,
    fn GetStatusAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<SmartCardStatus>) -> HRESULT,
    #[cfg(feature="windows-storage")] fn GetAnswerToResetAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::storage::streams::IBuffer>) -> HRESULT
}}
impl ISmartCard {
    #[inline] pub unsafe fn get_reader(&self) -> Result<ComPtr<SmartCardReader>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reader)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetStatusAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_answer_to_reset_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::storage::streams::IBuffer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetAnswerToResetAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmartCardProvisioningStatics, 327690312, 3347, 20080, 151, 53, 81, 218, 236, 165, 37, 79);
RT_INTERFACE!{static interface ISmartCardProvisioningStatics(ISmartCardProvisioningStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ISmartCardProvisioningStatics] {
    fn FromSmartCardAsync(&self, card: *mut SmartCard, out: *mut *mut super::super::foundation::IAsyncOperation<SmartCardProvisioning>) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-storage")] fn RequestVirtualSmartCardCreationAsync(&self, friendlyName: HSTRING, administrativeKey: *mut super::super::storage::streams::IBuffer, pinPolicy: *mut SmartCardPinPolicy, out: *mut *mut super::super::foundation::IAsyncOperation<SmartCardProvisioning>) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy2(&self) -> (),
    #[cfg(feature="windows-storage")] fn RequestVirtualSmartCardCreationAsyncWithCardId(&self, friendlyName: HSTRING, administrativeKey: *mut super::super::storage::streams::IBuffer, pinPolicy: *mut SmartCardPinPolicy, cardId: Guid, out: *mut *mut super::super::foundation::IAsyncOperation<SmartCardProvisioning>) -> HRESULT,
    fn RequestVirtualSmartCardDeletionAsync(&self, card: *mut SmartCard, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT
}}
impl ISmartCardProvisioningStatics {
    #[inline] pub unsafe fn from_smart_card_async(&self, card: &SmartCard) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardProvisioning>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromSmartCardAsync)(self as *const _ as *mut _, card as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn request_virtual_smart_card_creation_async(&self, friendlyName: &HStringArg, administrativeKey: &super::super::storage::streams::IBuffer, pinPolicy: &SmartCardPinPolicy) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardProvisioning>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestVirtualSmartCardCreationAsync)(self as *const _ as *mut _, friendlyName.get(), administrativeKey as *const _ as *mut _, pinPolicy as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn request_virtual_smart_card_creation_async_with_card_id(&self, friendlyName: &HStringArg, administrativeKey: &super::super::storage::streams::IBuffer, pinPolicy: &SmartCardPinPolicy, cardId: Guid) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardProvisioning>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestVirtualSmartCardCreationAsyncWithCardId)(self as *const _ as *mut _, friendlyName.get(), administrativeKey as *const _ as *mut _, pinPolicy as *const _ as *mut _, cardId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn request_virtual_smart_card_deletion_async(&self, card: &SmartCard) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestVirtualSmartCardDeletionAsync)(self as *const _ as *mut _, card as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SmartCardProvisioning: ISmartCardProvisioning}
impl RtActivatable<ISmartCardProvisioningStatics2> for SmartCardProvisioning {}
impl RtActivatable<ISmartCardProvisioningStatics> for SmartCardProvisioning {}
impl SmartCardProvisioning {
    #[cfg(feature="windows-storage")] #[inline] pub fn request_attested_virtual_smart_card_creation_async(friendlyName: &HStringArg, administrativeKey: &super::super::storage::streams::IBuffer, pinPolicy: &SmartCardPinPolicy) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardProvisioning>>> { unsafe {
        <Self as RtActivatable<ISmartCardProvisioningStatics2>>::get_activation_factory().request_attested_virtual_smart_card_creation_async(friendlyName, administrativeKey, pinPolicy)
    }}
    #[cfg(feature="windows-storage")] #[inline] pub fn request_attested_virtual_smart_card_creation_async_with_card_id(friendlyName: &HStringArg, administrativeKey: &super::super::storage::streams::IBuffer, pinPolicy: &SmartCardPinPolicy, cardId: Guid) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardProvisioning>>> { unsafe {
        <Self as RtActivatable<ISmartCardProvisioningStatics2>>::get_activation_factory().request_attested_virtual_smart_card_creation_async_with_card_id(friendlyName, administrativeKey, pinPolicy, cardId)
    }}
    #[inline] pub fn from_smart_card_async(card: &SmartCard) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardProvisioning>>> { unsafe {
        <Self as RtActivatable<ISmartCardProvisioningStatics>>::get_activation_factory().from_smart_card_async(card)
    }}
    #[cfg(feature="windows-storage")] #[inline] pub fn request_virtual_smart_card_creation_async(friendlyName: &HStringArg, administrativeKey: &super::super::storage::streams::IBuffer, pinPolicy: &SmartCardPinPolicy) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardProvisioning>>> { unsafe {
        <Self as RtActivatable<ISmartCardProvisioningStatics>>::get_activation_factory().request_virtual_smart_card_creation_async(friendlyName, administrativeKey, pinPolicy)
    }}
    #[cfg(feature="windows-storage")] #[inline] pub fn request_virtual_smart_card_creation_async_with_card_id(friendlyName: &HStringArg, administrativeKey: &super::super::storage::streams::IBuffer, pinPolicy: &SmartCardPinPolicy, cardId: Guid) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardProvisioning>>> { unsafe {
        <Self as RtActivatable<ISmartCardProvisioningStatics>>::get_activation_factory().request_virtual_smart_card_creation_async_with_card_id(friendlyName, administrativeKey, pinPolicy, cardId)
    }}
    #[inline] pub fn request_virtual_smart_card_deletion_async(card: &SmartCard) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> { unsafe {
        <Self as RtActivatable<ISmartCardProvisioningStatics>>::get_activation_factory().request_virtual_smart_card_deletion_async(card)
    }}
}
DEFINE_CLSID!(SmartCardProvisioning(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,109,97,114,116,67,97,114,100,115,46,83,109,97,114,116,67,97,114,100,80,114,111,118,105,115,105,111,110,105,110,103,0]) [CLSID_SmartCardProvisioning]);
RT_CLASS!{class SmartCardPinPolicy: ISmartCardPinPolicy}
impl RtActivatable<IActivationFactory> for SmartCardPinPolicy {}
DEFINE_CLSID!(SmartCardPinPolicy(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,109,97,114,116,67,97,114,100,115,46,83,109,97,114,116,67,97,114,100,80,105,110,80,111,108,105,99,121,0]) [CLSID_SmartCardPinPolicy]);
DEFINE_IID!(IID_ISmartCardProvisioningStatics2, 877119144, 51616, 19414, 181, 13, 37, 31, 78, 141, 58, 98);
RT_INTERFACE!{static interface ISmartCardProvisioningStatics2(ISmartCardProvisioningStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_ISmartCardProvisioningStatics2] {
    #[cfg(feature="windows-storage")] fn RequestAttestedVirtualSmartCardCreationAsync(&self, friendlyName: HSTRING, administrativeKey: *mut super::super::storage::streams::IBuffer, pinPolicy: *mut SmartCardPinPolicy, out: *mut *mut super::super::foundation::IAsyncOperation<SmartCardProvisioning>) -> HRESULT,
    #[cfg(feature="windows-storage")] fn RequestAttestedVirtualSmartCardCreationAsyncWithCardId(&self, friendlyName: HSTRING, administrativeKey: *mut super::super::storage::streams::IBuffer, pinPolicy: *mut SmartCardPinPolicy, cardId: Guid, out: *mut *mut super::super::foundation::IAsyncOperation<SmartCardProvisioning>) -> HRESULT
}}
impl ISmartCardProvisioningStatics2 {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn request_attested_virtual_smart_card_creation_async(&self, friendlyName: &HStringArg, administrativeKey: &super::super::storage::streams::IBuffer, pinPolicy: &SmartCardPinPolicy) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardProvisioning>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestAttestedVirtualSmartCardCreationAsync)(self as *const _ as *mut _, friendlyName.get(), administrativeKey as *const _ as *mut _, pinPolicy as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn request_attested_virtual_smart_card_creation_async_with_card_id(&self, friendlyName: &HStringArg, administrativeKey: &super::super::storage::streams::IBuffer, pinPolicy: &SmartCardPinPolicy, cardId: Guid) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardProvisioning>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestAttestedVirtualSmartCardCreationAsyncWithCardId)(self as *const _ as *mut _, friendlyName.get(), administrativeKey as *const _ as *mut _, pinPolicy as *const _ as *mut _, cardId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmartCardProvisioning, 435088829, 8107, 18300, 183, 18, 26, 44, 90, 241, 253, 110);
RT_INTERFACE!{interface ISmartCardProvisioning(ISmartCardProvisioningVtbl): IInspectable(IInspectableVtbl) [IID_ISmartCardProvisioning] {
    fn get_SmartCard(&self, out: *mut *mut SmartCard) -> HRESULT,
    fn GetIdAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<Guid>) -> HRESULT,
    fn GetNameAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<HString>) -> HRESULT,
    fn GetChallengeContextAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<SmartCardChallengeContext>) -> HRESULT,
    fn RequestPinChangeAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn RequestPinResetAsync(&self, handler: *mut SmartCardPinResetHandler, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT
}}
impl ISmartCardProvisioning {
    #[inline] pub unsafe fn get_smart_card(&self) -> Result<ComPtr<SmartCard>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SmartCard)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_id_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Guid>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetIdAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_name_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetNameAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_challenge_context_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardChallengeContext>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetChallengeContextAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn request_pin_change_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestPinChangeAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn request_pin_reset_async(&self, handler: &SmartCardPinResetHandler) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestPinResetAsync)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SmartCardChallengeContext: ISmartCardChallengeContext}
DEFINE_IID!(IID_SmartCardPinResetHandler, 328031808, 62396, 19036, 180, 29, 75, 78, 246, 132, 226, 55);
RT_DELEGATE!{delegate SmartCardPinResetHandler(SmartCardPinResetHandlerVtbl, SmartCardPinResetHandlerImpl) [IID_SmartCardPinResetHandler] {
    fn Invoke(&self, sender: *mut SmartCardProvisioning, request: *mut SmartCardPinResetRequest) -> HRESULT
}}
impl SmartCardPinResetHandler {
    #[inline] pub unsafe fn invoke(&self, sender: &SmartCardProvisioning, request: &SmartCardPinResetRequest) -> Result<()> {
        let hr = ((*self.lpVtbl).Invoke)(self as *const _ as *mut _, sender as *const _ as *mut _, request as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class SmartCardPinResetRequest: ISmartCardPinResetRequest}
DEFINE_IID!(IID_ISmartCardProvisioning2, 285026539, 16249, 19302, 155, 124, 17, 193, 73, 183, 208, 188);
RT_INTERFACE!{interface ISmartCardProvisioning2(ISmartCardProvisioning2Vtbl): IInspectable(IInspectableVtbl) [IID_ISmartCardProvisioning2] {
    fn GetAuthorityKeyContainerNameAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<HString>) -> HRESULT
}}
impl ISmartCardProvisioning2 {
    #[inline] pub unsafe fn get_authority_key_container_name_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetAuthorityKeyContainerNameAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmartCardPinResetRequest, 318651469, 24505, 20110, 159, 246, 97, 244, 117, 18, 79, 239);
RT_INTERFACE!{interface ISmartCardPinResetRequest(ISmartCardPinResetRequestVtbl): IInspectable(IInspectableVtbl) [IID_ISmartCardPinResetRequest] {
    #[cfg(feature="windows-storage")] fn get_Challenge(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT,
    fn get_Deadline(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn GetDeferral(&self, out: *mut *mut SmartCardPinResetDeferral) -> HRESULT,
    #[cfg(feature="windows-storage")] fn SetResponse(&self, response: *mut super::super::storage::streams::IBuffer) -> HRESULT
}}
impl ISmartCardPinResetRequest {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_challenge(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Challenge)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_deadline(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Deadline)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_deferral(&self) -> Result<ComPtr<SmartCardPinResetDeferral>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeferral)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_response(&self, response: &super::super::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).SetResponse)(self as *const _ as *mut _, response as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class SmartCardPinResetDeferral: ISmartCardPinResetDeferral}
DEFINE_IID!(IID_ISmartCardPinResetDeferral, 415845036, 30725, 16388, 133, 228, 187, 239, 172, 143, 104, 132);
RT_INTERFACE!{interface ISmartCardPinResetDeferral(ISmartCardPinResetDeferralVtbl): IInspectable(IInspectableVtbl) [IID_ISmartCardPinResetDeferral] {
    fn Complete(&self) -> HRESULT
}}
impl ISmartCardPinResetDeferral {
    #[inline] pub unsafe fn complete(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Complete)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmartCardPinPolicy, 406643076, 19894, 18497, 172, 158, 42, 193, 243, 155, 115, 4);
RT_INTERFACE!{interface ISmartCardPinPolicy(ISmartCardPinPolicyVtbl): IInspectable(IInspectableVtbl) [IID_ISmartCardPinPolicy] {
    fn get_MinLength(&self, out: *mut u32) -> HRESULT,
    fn put_MinLength(&self, value: u32) -> HRESULT,
    fn get_MaxLength(&self, out: *mut u32) -> HRESULT,
    fn put_MaxLength(&self, value: u32) -> HRESULT,
    fn get_UppercaseLetters(&self, out: *mut SmartCardPinCharacterPolicyOption) -> HRESULT,
    fn put_UppercaseLetters(&self, value: SmartCardPinCharacterPolicyOption) -> HRESULT,
    fn get_LowercaseLetters(&self, out: *mut SmartCardPinCharacterPolicyOption) -> HRESULT,
    fn put_LowercaseLetters(&self, value: SmartCardPinCharacterPolicyOption) -> HRESULT,
    fn get_Digits(&self, out: *mut SmartCardPinCharacterPolicyOption) -> HRESULT,
    fn put_Digits(&self, value: SmartCardPinCharacterPolicyOption) -> HRESULT,
    fn get_SpecialCharacters(&self, out: *mut SmartCardPinCharacterPolicyOption) -> HRESULT,
    fn put_SpecialCharacters(&self, value: SmartCardPinCharacterPolicyOption) -> HRESULT
}}
impl ISmartCardPinPolicy {
    #[inline] pub unsafe fn get_min_length(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinLength)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_min_length(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_MinLength)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_length(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxLength)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_max_length(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_MaxLength)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_uppercase_letters(&self) -> Result<SmartCardPinCharacterPolicyOption> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UppercaseLetters)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_uppercase_letters(&self, value: SmartCardPinCharacterPolicyOption) -> Result<()> {
        let hr = ((*self.lpVtbl).put_UppercaseLetters)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_lowercase_letters(&self) -> Result<SmartCardPinCharacterPolicyOption> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LowercaseLetters)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_lowercase_letters(&self, value: SmartCardPinCharacterPolicyOption) -> Result<()> {
        let hr = ((*self.lpVtbl).put_LowercaseLetters)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_digits(&self) -> Result<SmartCardPinCharacterPolicyOption> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Digits)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_digits(&self, value: SmartCardPinCharacterPolicyOption) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Digits)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_special_characters(&self) -> Result<SmartCardPinCharacterPolicyOption> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SpecialCharacters)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_special_characters(&self, value: SmartCardPinCharacterPolicyOption) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SpecialCharacters)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmartCardConnect, 803178469, 653, 18718, 160, 88, 51, 130, 195, 152, 111, 64);
RT_INTERFACE!{interface ISmartCardConnect(ISmartCardConnectVtbl): IInspectable(IInspectableVtbl) [IID_ISmartCardConnect] {
    fn ConnectAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<SmartCardConnection>) -> HRESULT
}}
impl ISmartCardConnect {
    #[inline] pub unsafe fn connect_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmartCardConnection>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ConnectAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SmartCardConnection: ISmartCardConnection}
DEFINE_IID!(IID_ISmartCardChallengeContext, 422204185, 51652, 18759, 129, 204, 68, 121, 74, 97, 239, 145);
RT_INTERFACE!{interface ISmartCardChallengeContext(ISmartCardChallengeContextVtbl): IInspectable(IInspectableVtbl) [IID_ISmartCardChallengeContext] {
    #[cfg(feature="windows-storage")] fn get_Challenge(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT,
    #[cfg(feature="windows-storage")] fn VerifyResponseAsync(&self, response: *mut super::super::storage::streams::IBuffer, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    #[cfg(feature="windows-storage")] fn ProvisionAsync(&self, response: *mut super::super::storage::streams::IBuffer, formatCard: bool, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    #[cfg(feature="windows-storage")] fn ProvisionAsyncWithNewCardId(&self, response: *mut super::super::storage::streams::IBuffer, formatCard: bool, newCardId: Guid, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    #[cfg(feature="windows-storage")] fn ChangeAdministrativeKeyAsync(&self, response: *mut super::super::storage::streams::IBuffer, newAdministrativeKey: *mut super::super::storage::streams::IBuffer, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT
}}
impl ISmartCardChallengeContext {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_challenge(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Challenge)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn verify_response_async(&self, response: &super::super::storage::streams::IBuffer) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).VerifyResponseAsync)(self as *const _ as *mut _, response as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn provision_async(&self, response: &super::super::storage::streams::IBuffer, formatCard: bool) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ProvisionAsync)(self as *const _ as *mut _, response as *const _ as *mut _, formatCard, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn provision_async_with_new_card_id(&self, response: &super::super::storage::streams::IBuffer, formatCard: bool, newCardId: Guid) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ProvisionAsyncWithNewCardId)(self as *const _ as *mut _, response as *const _ as *mut _, formatCard, newCardId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn change_administrative_key_async(&self, response: &super::super::storage::streams::IBuffer, newAdministrativeKey: &super::super::storage::streams::IBuffer) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ChangeAdministrativeKeyAsync)(self as *const _ as *mut _, response as *const _ as *mut _, newAdministrativeKey as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmartCardConnection, 2128320794, 43034, 18364, 166, 73, 21, 107, 230, 183, 242, 49);
RT_INTERFACE!{interface ISmartCardConnection(ISmartCardConnectionVtbl): IInspectable(IInspectableVtbl) [IID_ISmartCardConnection] {
    #[cfg(feature="windows-storage")] fn TransmitAsync(&self, command: *mut super::super::storage::streams::IBuffer, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::storage::streams::IBuffer>) -> HRESULT
}}
impl ISmartCardConnection {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn transmit_async(&self, command: &super::super::storage::streams::IBuffer) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::storage::streams::IBuffer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TransmitAsync)(self as *const _ as *mut _, command as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
} // Windows.Devices.SmartCards
pub mod power { // Windows.Devices.Power
use ::prelude::*;
DEFINE_IID!(IID_IBattery, 3163115462, 114, 18376, 139, 93, 97, 74, 170, 122, 67, 126);
RT_INTERFACE!{interface IBattery(IBatteryVtbl): IInspectable(IInspectableVtbl) [IID_IBattery] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn GetReport(&self, out: *mut *mut BatteryReport) -> HRESULT,
    fn add_ReportUpdated(&self, handler: *mut super::super::foundation::TypedEventHandler<Battery, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReportUpdated(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IBattery {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report(&self) -> Result<ComPtr<BatteryReport>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetReport)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_report_updated(&self, handler: &super::super::foundation::TypedEventHandler<Battery, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReportUpdated)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_report_updated(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReportUpdated)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class BatteryReport: IBatteryReport}
RT_CLASS!{class Battery: IBattery}
impl RtActivatable<IBatteryStatics> for Battery {}
impl Battery {
    #[inline] pub fn get_aggregate_battery() -> Result<ComPtr<Battery>> { unsafe {
        <Self as RtActivatable<IBatteryStatics>>::get_activation_factory().get_aggregate_battery()
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Battery>>> { unsafe {
        <Self as RtActivatable<IBatteryStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IBatteryStatics>>::get_activation_factory().get_device_selector()
    }}
}
DEFINE_CLSID!(Battery(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,111,119,101,114,46,66,97,116,116,101,114,121,0]) [CLSID_Battery]);
DEFINE_IID!(IID_IBatteryReport, 3380972602, 19987, 16906, 168, 208, 36, 241, 143, 57, 84, 1);
RT_INTERFACE!{interface IBatteryReport(IBatteryReportVtbl): IInspectable(IInspectableVtbl) [IID_IBatteryReport] {
    fn get_ChargeRateInMilliwatts(&self, out: *mut *mut super::super::foundation::IReference<i32>) -> HRESULT,
    fn get_DesignCapacityInMilliwattHours(&self, out: *mut *mut super::super::foundation::IReference<i32>) -> HRESULT,
    fn get_FullChargeCapacityInMilliwattHours(&self, out: *mut *mut super::super::foundation::IReference<i32>) -> HRESULT,
    fn get_RemainingCapacityInMilliwattHours(&self, out: *mut *mut super::super::foundation::IReference<i32>) -> HRESULT,
    #[cfg(feature="windows-system")] fn get_Status(&self, out: *mut super::super::system::power::BatteryStatus) -> HRESULT
}}
impl IBatteryReport {
    #[inline] pub unsafe fn get_charge_rate_in_milliwatts(&self) -> Result<ComPtr<super::super::foundation::IReference<i32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ChargeRateInMilliwatts)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_design_capacity_in_milliwatt_hours(&self) -> Result<ComPtr<super::super::foundation::IReference<i32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DesignCapacityInMilliwattHours)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_full_charge_capacity_in_milliwatt_hours(&self) -> Result<ComPtr<super::super::foundation::IReference<i32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FullChargeCapacityInMilliwattHours)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_remaining_capacity_in_milliwatt_hours(&self) -> Result<ComPtr<super::super::foundation::IReference<i32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_RemainingCapacityInMilliwattHours)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-system")] #[inline] pub unsafe fn get_status(&self) -> Result<super::super::system::power::BatteryStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBatteryStatics, 2043507382, 40542, 17490, 190, 166, 223, 205, 84, 30, 89, 127);
RT_INTERFACE!{static interface IBatteryStatics(IBatteryStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IBatteryStatics] {
    fn get_AggregateBattery(&self, out: *mut *mut Battery) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<Battery>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT
}}
impl IBatteryStatics {
    #[inline] pub unsafe fn get_aggregate_battery(&self) -> Result<ComPtr<Battery>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AggregateBattery)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Battery>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
} // Windows.Devices.Power
pub mod sms { // Windows.Devices.Sms
use ::prelude::*;
RT_ENUM! { enum SmsMessageClass: i32 {
    None (SmsMessageClass_None) = 0, Class0 (SmsMessageClass_Class0) = 1, Class1 (SmsMessageClass_Class1) = 2, Class2 (SmsMessageClass_Class2) = 3, Class3 (SmsMessageClass_Class3) = 4,
}}
RT_ENUM! { enum SmsMessageType: i32 {
    Binary (SmsMessageType_Binary) = 0, Text (SmsMessageType_Text) = 1, Wap (SmsMessageType_Wap) = 2, App (SmsMessageType_App) = 3, Broadcast (SmsMessageType_Broadcast) = 4, Voicemail (SmsMessageType_Voicemail) = 5, Status (SmsMessageType_Status) = 6,
}}
RT_ENUM! { enum CellularClass: i32 {
    None (CellularClass_None) = 0, Gsm (CellularClass_Gsm) = 1, Cdma (CellularClass_Cdma) = 2,
}}
DEFINE_IID!(IID_ISmsMessageBase, 753991216, 65104, 20422, 170, 136, 76, 207, 226, 122, 41, 234);
RT_INTERFACE!{interface ISmsMessageBase(ISmsMessageBaseVtbl): IInspectable(IInspectableVtbl) [IID_ISmsMessageBase] {
    fn get_MessageType(&self, out: *mut SmsMessageType) -> HRESULT,
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_CellularClass(&self, out: *mut CellularClass) -> HRESULT,
    fn get_MessageClass(&self, out: *mut SmsMessageClass) -> HRESULT,
    fn get_SimIccId(&self, out: *mut HSTRING) -> HRESULT
}}
impl ISmsMessageBase {
    #[inline] pub unsafe fn get_message_type(&self) -> Result<SmsMessageType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MessageType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cellular_class(&self) -> Result<CellularClass> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CellularClass)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_message_class(&self) -> Result<SmsMessageClass> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MessageClass)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sim_icc_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SimIccId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_ENUM! { enum SmsDataFormat: i32 {
    Unknown (SmsDataFormat_Unknown) = 0, CdmaSubmit (SmsDataFormat_CdmaSubmit) = 1, GsmSubmit (SmsDataFormat_GsmSubmit) = 2, CdmaDeliver (SmsDataFormat_CdmaDeliver) = 3, GsmDeliver (SmsDataFormat_GsmDeliver) = 4,
}}
RT_ENUM! { enum SmsEncoding: i32 {
    Unknown (SmsEncoding_Unknown) = 0, Optimal (SmsEncoding_Optimal) = 1, SevenBitAscii (SmsEncoding_SevenBitAscii) = 2, Unicode (SmsEncoding_Unicode) = 3, GsmSevenBit (SmsEncoding_GsmSevenBit) = 4, EightBit (SmsEncoding_EightBit) = 5, Latin (SmsEncoding_Latin) = 6, Korean (SmsEncoding_Korean) = 7, IA5 (SmsEncoding_IA5) = 8, ShiftJis (SmsEncoding_ShiftJis) = 9, LatinHebrew (SmsEncoding_LatinHebrew) = 10,
}}
DEFINE_IID!(IID_ISmsTextMessage2, 580966547, 17749, 18261, 181, 161, 231, 253, 132, 149, 95, 141);
RT_INTERFACE!{interface ISmsTextMessage2(ISmsTextMessage2Vtbl): IInspectable(IInspectableVtbl) [IID_ISmsTextMessage2] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_To(&self, out: *mut HSTRING) -> HRESULT,
    fn put_To(&self, value: HSTRING) -> HRESULT,
    fn get_From(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Body(&self, out: *mut HSTRING) -> HRESULT,
    fn put_Body(&self, value: HSTRING) -> HRESULT,
    fn get_Encoding(&self, out: *mut SmsEncoding) -> HRESULT,
    fn put_Encoding(&self, value: SmsEncoding) -> HRESULT,
    fn get_CallbackNumber(&self, out: *mut HSTRING) -> HRESULT,
    fn put_CallbackNumber(&self, value: HSTRING) -> HRESULT,
    fn get_IsDeliveryNotificationEnabled(&self, out: *mut bool) -> HRESULT,
    fn put_IsDeliveryNotificationEnabled(&self, value: bool) -> HRESULT,
    fn get_RetryAttemptCount(&self, out: *mut i32) -> HRESULT,
    fn put_RetryAttemptCount(&self, value: i32) -> HRESULT,
    fn get_TeleserviceId(&self, out: *mut i32) -> HRESULT,
    fn get_ProtocolId(&self, out: *mut i32) -> HRESULT
}}
impl ISmsTextMessage2 {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_to(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_To)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_to(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_To)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_from(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_From)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_body(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Body)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_body(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Body)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_encoding(&self) -> Result<SmsEncoding> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Encoding)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_encoding(&self, value: SmsEncoding) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Encoding)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_callback_number(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_CallbackNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_callback_number(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_CallbackNumber)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_delivery_notification_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDeliveryNotificationEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_delivery_notification_enabled(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsDeliveryNotificationEnabled)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_retry_attempt_count(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RetryAttemptCount)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_retry_attempt_count(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_RetryAttemptCount)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_teleservice_id(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TeleserviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_protocol_id(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ProtocolId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class SmsTextMessage2: ISmsTextMessage2}
impl RtActivatable<IActivationFactory> for SmsTextMessage2 {}
DEFINE_CLSID!(SmsTextMessage2(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,109,115,46,83,109,115,84,101,120,116,77,101,115,115,97,103,101,50,0]) [CLSID_SmsTextMessage2]);
DEFINE_IID!(IID_ISmsWapMessage, 3448993603, 31317, 19771, 144, 33, 242, 46, 2, 45, 9, 197);
RT_INTERFACE!{interface ISmsWapMessage(ISmsWapMessageVtbl): IInspectable(IInspectableVtbl) [IID_ISmsWapMessage] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_To(&self, out: *mut HSTRING) -> HRESULT,
    fn get_From(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ApplicationId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ContentType(&self, out: *mut HSTRING) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy5(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_BinaryBody(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT,
    fn get_Headers(&self, out: *mut *mut super::super::foundation::collections::IMap<HString, HString>) -> HRESULT
}}
impl ISmsWapMessage {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_to(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_To)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_from(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_From)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_application_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ApplicationId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_content_type(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ContentType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_binary_body(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BinaryBody)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_headers(&self) -> Result<ComPtr<super::super::foundation::collections::IMap<HString, HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Headers)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SmsWapMessage: ISmsWapMessage}
DEFINE_IID!(IID_ISmsAppMessage, 3904603284, 54176, 18954, 134, 215, 41, 16, 51, 168, 207, 84);
RT_INTERFACE!{interface ISmsAppMessage(ISmsAppMessageVtbl): IInspectable(IInspectableVtbl) [IID_ISmsAppMessage] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_To(&self, out: *mut HSTRING) -> HRESULT,
    fn put_To(&self, value: HSTRING) -> HRESULT,
    fn get_From(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Body(&self, out: *mut HSTRING) -> HRESULT,
    fn put_Body(&self, value: HSTRING) -> HRESULT,
    fn get_CallbackNumber(&self, out: *mut HSTRING) -> HRESULT,
    fn put_CallbackNumber(&self, value: HSTRING) -> HRESULT,
    fn get_IsDeliveryNotificationEnabled(&self, out: *mut bool) -> HRESULT,
    fn put_IsDeliveryNotificationEnabled(&self, value: bool) -> HRESULT,
    fn get_RetryAttemptCount(&self, out: *mut i32) -> HRESULT,
    fn put_RetryAttemptCount(&self, value: i32) -> HRESULT,
    fn get_Encoding(&self, out: *mut SmsEncoding) -> HRESULT,
    fn put_Encoding(&self, value: SmsEncoding) -> HRESULT,
    fn get_PortNumber(&self, out: *mut i32) -> HRESULT,
    fn put_PortNumber(&self, value: i32) -> HRESULT,
    fn get_TeleserviceId(&self, out: *mut i32) -> HRESULT,
    fn put_TeleserviceId(&self, value: i32) -> HRESULT,
    fn get_ProtocolId(&self, out: *mut i32) -> HRESULT,
    fn put_ProtocolId(&self, value: i32) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_BinaryBody(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT,
    #[cfg(feature="windows-storage")] fn put_BinaryBody(&self, value: *mut super::super::storage::streams::IBuffer) -> HRESULT
}}
impl ISmsAppMessage {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_to(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_To)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_to(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_To)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_from(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_From)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_body(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Body)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_body(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Body)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_callback_number(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_CallbackNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_callback_number(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_CallbackNumber)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_delivery_notification_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDeliveryNotificationEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_delivery_notification_enabled(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsDeliveryNotificationEnabled)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_retry_attempt_count(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RetryAttemptCount)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_retry_attempt_count(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_RetryAttemptCount)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_encoding(&self) -> Result<SmsEncoding> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Encoding)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_encoding(&self, value: SmsEncoding) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Encoding)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_port_number(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PortNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_port_number(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_PortNumber)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_teleservice_id(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TeleserviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_teleservice_id(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_TeleserviceId)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_protocol_id(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ProtocolId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_protocol_id(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ProtocolId)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_binary_body(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BinaryBody)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_binary_body(&self, value: &super::super::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).put_BinaryBody)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class SmsAppMessage: ISmsAppMessage}
impl RtActivatable<IActivationFactory> for SmsAppMessage {}
DEFINE_CLSID!(SmsAppMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,109,115,46,83,109,115,65,112,112,77,101,115,115,97,103,101,0]) [CLSID_SmsAppMessage]);
RT_ENUM! { enum SmsGeographicalScope: i32 {
    None (SmsGeographicalScope_None) = 0, CellWithImmediateDisplay (SmsGeographicalScope_CellWithImmediateDisplay) = 1, LocationArea (SmsGeographicalScope_LocationArea) = 2, Plmn (SmsGeographicalScope_Plmn) = 3, Cell (SmsGeographicalScope_Cell) = 4,
}}
RT_ENUM! { enum SmsBroadcastType: i32 {
    Other (SmsBroadcastType_Other) = 0, CmasPresidential (SmsBroadcastType_CmasPresidential) = 1, CmasExtreme (SmsBroadcastType_CmasExtreme) = 2, CmasSevere (SmsBroadcastType_CmasSevere) = 3, CmasAmber (SmsBroadcastType_CmasAmber) = 4, CmasTest (SmsBroadcastType_CmasTest) = 5, EUAlert1 (SmsBroadcastType_EUAlert1) = 6, EUAlert2 (SmsBroadcastType_EUAlert2) = 7, EUAlert3 (SmsBroadcastType_EUAlert3) = 8, EUAlertAmber (SmsBroadcastType_EUAlertAmber) = 9, EUAlertInfo (SmsBroadcastType_EUAlertInfo) = 10, EtwsEarthquake (SmsBroadcastType_EtwsEarthquake) = 11, EtwsTsunami (SmsBroadcastType_EtwsTsunami) = 12, EtwsTsunamiAndEarthquake (SmsBroadcastType_EtwsTsunamiAndEarthquake) = 13, LatAlertLocal (SmsBroadcastType_LatAlertLocal) = 14,
}}
DEFINE_IID!(IID_ISmsBroadcastMessage, 1974385649, 58551, 18548, 160, 156, 41, 86, 229, 146, 249, 87);
RT_INTERFACE!{interface ISmsBroadcastMessage(ISmsBroadcastMessageVtbl): IInspectable(IInspectableVtbl) [IID_ISmsBroadcastMessage] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_To(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Body(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Channel(&self, out: *mut i32) -> HRESULT,
    fn get_GeographicalScope(&self, out: *mut SmsGeographicalScope) -> HRESULT,
    fn get_MessageCode(&self, out: *mut i32) -> HRESULT,
    fn get_UpdateNumber(&self, out: *mut i32) -> HRESULT,
    fn get_BroadcastType(&self, out: *mut SmsBroadcastType) -> HRESULT,
    fn get_IsEmergencyAlert(&self, out: *mut bool) -> HRESULT,
    fn get_IsUserPopupRequested(&self, out: *mut bool) -> HRESULT
}}
impl ISmsBroadcastMessage {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_to(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_To)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_body(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Body)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_channel(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Channel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_geographical_scope(&self) -> Result<SmsGeographicalScope> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GeographicalScope)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_message_code(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MessageCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_update_number(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UpdateNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_broadcast_type(&self) -> Result<SmsBroadcastType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BroadcastType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_emergency_alert(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsEmergencyAlert)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_user_popup_requested(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsUserPopupRequested)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class SmsBroadcastMessage: ISmsBroadcastMessage}
DEFINE_IID!(IID_ISmsVoicemailMessage, 656056486, 38321, 17663, 188, 184, 184, 253, 215, 224, 139, 195);
RT_INTERFACE!{interface ISmsVoicemailMessage(ISmsVoicemailMessageVtbl): IInspectable(IInspectableVtbl) [IID_ISmsVoicemailMessage] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_To(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Body(&self, out: *mut HSTRING) -> HRESULT,
    fn get_MessageCount(&self, out: *mut *mut super::super::foundation::IReference<i32>) -> HRESULT
}}
impl ISmsVoicemailMessage {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_to(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_To)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_body(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Body)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_message_count(&self) -> Result<ComPtr<super::super::foundation::IReference<i32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_MessageCount)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SmsVoicemailMessage: ISmsVoicemailMessage}
DEFINE_IID!(IID_ISmsStatusMessage, 3872555842, 46859, 18039, 147, 121, 201, 120, 63, 223, 248, 244);
RT_INTERFACE!{interface ISmsStatusMessage(ISmsStatusMessageVtbl): IInspectable(IInspectableVtbl) [IID_ISmsStatusMessage] {
    fn get_To(&self, out: *mut HSTRING) -> HRESULT,
    fn get_From(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Body(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Status(&self, out: *mut i32) -> HRESULT,
    fn get_MessageReferenceNumber(&self, out: *mut i32) -> HRESULT,
    fn get_ServiceCenterTimestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_DischargeTime(&self, out: *mut super::super::foundation::DateTime) -> HRESULT
}}
impl ISmsStatusMessage {
    #[inline] pub unsafe fn get_to(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_To)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_from(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_From)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_body(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Body)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_message_reference_number(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MessageReferenceNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_center_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ServiceCenterTimestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_discharge_time(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DischargeTime)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class SmsStatusMessage: ISmsStatusMessage}
RT_STRUCT! { struct SmsEncodedLength {
    SegmentCount: u32, CharacterCountLastSegment: u32, CharactersPerSegment: u32, ByteCountLastSegment: u32, BytesPerSegment: u32,
}}
RT_ENUM! { enum SmsDeviceStatus: i32 {
    Off (SmsDeviceStatus_Off) = 0, Ready (SmsDeviceStatus_Ready) = 1, SimNotInserted (SmsDeviceStatus_SimNotInserted) = 2, BadSim (SmsDeviceStatus_BadSim) = 3, DeviceFailure (SmsDeviceStatus_DeviceFailure) = 4, SubscriptionNotActivated (SmsDeviceStatus_SubscriptionNotActivated) = 5, DeviceLocked (SmsDeviceStatus_DeviceLocked) = 6, DeviceBlocked (SmsDeviceStatus_DeviceBlocked) = 7,
}}
RT_ENUM! { enum SmsModemErrorCode: i32 {
    Other (SmsModemErrorCode_Other) = 0, MessagingNetworkError (SmsModemErrorCode_MessagingNetworkError) = 1, SmsOperationNotSupportedByDevice (SmsModemErrorCode_SmsOperationNotSupportedByDevice) = 2, SmsServiceNotSupportedByNetwork (SmsModemErrorCode_SmsServiceNotSupportedByNetwork) = 3, DeviceFailure (SmsModemErrorCode_DeviceFailure) = 4, MessageNotEncodedProperly (SmsModemErrorCode_MessageNotEncodedProperly) = 5, MessageTooLarge (SmsModemErrorCode_MessageTooLarge) = 6, DeviceNotReady (SmsModemErrorCode_DeviceNotReady) = 7, NetworkNotReady (SmsModemErrorCode_NetworkNotReady) = 8, InvalidSmscAddress (SmsModemErrorCode_InvalidSmscAddress) = 9, NetworkFailure (SmsModemErrorCode_NetworkFailure) = 10, FixedDialingNumberRestricted (SmsModemErrorCode_FixedDialingNumberRestricted) = 11,
}}
DEFINE_IID!(IID_ISmsSendMessageResult, 3675495154, 30921, 20459, 150, 34, 69, 35, 40, 8, 141, 98);
RT_INTERFACE!{interface ISmsSendMessageResult(ISmsSendMessageResultVtbl): IInspectable(IInspectableVtbl) [IID_ISmsSendMessageResult] {
    fn get_IsSuccessful(&self, out: *mut bool) -> HRESULT,
    fn get_MessageReferenceNumbers(&self, out: *mut *mut super::super::foundation::collections::IVectorView<i32>) -> HRESULT,
    fn get_CellularClass(&self, out: *mut CellularClass) -> HRESULT,
    fn get_ModemErrorCode(&self, out: *mut SmsModemErrorCode) -> HRESULT,
    fn get_IsErrorTransient(&self, out: *mut bool) -> HRESULT,
    fn get_NetworkCauseCode(&self, out: *mut i32) -> HRESULT,
    fn get_TransportFailureCause(&self, out: *mut i32) -> HRESULT
}}
impl ISmsSendMessageResult {
    #[inline] pub unsafe fn get_is_successful(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsSuccessful)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_message_reference_numbers(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<i32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_MessageReferenceNumbers)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cellular_class(&self) -> Result<CellularClass> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CellularClass)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_modem_error_code(&self) -> Result<SmsModemErrorCode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ModemErrorCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_error_transient(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsErrorTransient)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_network_cause_code(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_NetworkCauseCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_transport_failure_cause(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TransportFailureCause)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class SmsSendMessageResult: ISmsSendMessageResult}
DEFINE_IID!(IID_ISmsDevice2Statics, 1707574053, 4145, 18718, 143, 182, 239, 153, 145, 175, 227, 99);
RT_INTERFACE!{static interface ISmsDevice2Statics(ISmsDevice2StaticsVtbl): IInspectable(IInspectableVtbl) [IID_ISmsDevice2Statics] {
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn FromId(&self, deviceId: HSTRING, out: *mut *mut SmsDevice2) -> HRESULT,
    fn GetDefault(&self, out: *mut *mut SmsDevice2) -> HRESULT,
    fn FromParentId(&self, parentDeviceId: HSTRING, out: *mut *mut SmsDevice2) -> HRESULT
}}
impl ISmsDevice2Statics {
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id(&self, deviceId: &HStringArg) -> Result<ComPtr<SmsDevice2>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromId)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default(&self) -> Result<ComPtr<SmsDevice2>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefault)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_parent_id(&self, parentDeviceId: &HStringArg) -> Result<ComPtr<SmsDevice2>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromParentId)(self as *const _ as *mut _, parentDeviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SmsDevice2: ISmsDevice2}
impl RtActivatable<ISmsDevice2Statics> for SmsDevice2 {}
impl SmsDevice2 {
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<ISmsDevice2Statics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn from_id(deviceId: &HStringArg) -> Result<ComPtr<SmsDevice2>> { unsafe {
        <Self as RtActivatable<ISmsDevice2Statics>>::get_activation_factory().from_id(deviceId)
    }}
    #[inline] pub fn get_default() -> Result<ComPtr<SmsDevice2>> { unsafe {
        <Self as RtActivatable<ISmsDevice2Statics>>::get_activation_factory().get_default()
    }}
    #[inline] pub fn from_parent_id(parentDeviceId: &HStringArg) -> Result<ComPtr<SmsDevice2>> { unsafe {
        <Self as RtActivatable<ISmsDevice2Statics>>::get_activation_factory().from_parent_id(parentDeviceId)
    }}
}
DEFINE_CLSID!(SmsDevice2(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,109,115,46,83,109,115,68,101,118,105,99,101,50,0]) [CLSID_SmsDevice2]);
DEFINE_IID!(IID_ISmsDevice2, 3179961363, 58658, 18123, 184, 213, 158, 173, 48, 251, 108, 71);
RT_INTERFACE!{interface ISmsDevice2(ISmsDevice2Vtbl): IInspectable(IInspectableVtbl) [IID_ISmsDevice2] {
    fn get_SmscAddress(&self, out: *mut HSTRING) -> HRESULT,
    fn put_SmscAddress(&self, value: HSTRING) -> HRESULT,
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ParentDeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_AccountPhoneNumber(&self, out: *mut HSTRING) -> HRESULT,
    fn get_CellularClass(&self, out: *mut CellularClass) -> HRESULT,
    fn get_DeviceStatus(&self, out: *mut SmsDeviceStatus) -> HRESULT,
    fn CalculateLength(&self, message: *mut ISmsMessageBase, out: *mut SmsEncodedLength) -> HRESULT,
    fn SendMessageAndGetResultAsync(&self, message: *mut ISmsMessageBase, out: *mut *mut super::super::foundation::IAsyncOperation<SmsSendMessageResult>) -> HRESULT,
    fn add_DeviceStatusChanged(&self, eventHandler: *mut super::super::foundation::TypedEventHandler<SmsDevice2, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_DeviceStatusChanged(&self, eventCookie: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl ISmsDevice2 {
    #[inline] pub unsafe fn get_smsc_address(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SmscAddress)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_smsc_address(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SmscAddress)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_parent_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ParentDeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_account_phone_number(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AccountPhoneNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cellular_class(&self) -> Result<CellularClass> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CellularClass)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_status(&self) -> Result<SmsDeviceStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DeviceStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn calculate_length(&self, message: &ISmsMessageBase) -> Result<SmsEncodedLength> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).CalculateLength)(self as *const _ as *mut _, message as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn send_message_and_get_result_async(&self, message: &ISmsMessageBase) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmsSendMessageResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).SendMessageAndGetResultAsync)(self as *const _ as *mut _, message as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_device_status_changed(&self, eventHandler: &super::super::foundation::TypedEventHandler<SmsDevice2, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_DeviceStatusChanged)(self as *const _ as *mut _, eventHandler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_device_status_changed(&self, eventCookie: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_DeviceStatusChanged)(self as *const _ as *mut _, eventCookie);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmsMessageReceivedTriggerDetails, 735038420, 9815, 16680, 173, 95, 227, 135, 113, 50, 189, 177);
RT_INTERFACE!{interface ISmsMessageReceivedTriggerDetails(ISmsMessageReceivedTriggerDetailsVtbl): IInspectable(IInspectableVtbl) [IID_ISmsMessageReceivedTriggerDetails] {
    fn get_MessageType(&self, out: *mut SmsMessageType) -> HRESULT,
    fn get_TextMessage(&self, out: *mut *mut SmsTextMessage2) -> HRESULT,
    fn get_WapMessage(&self, out: *mut *mut SmsWapMessage) -> HRESULT,
    fn get_AppMessage(&self, out: *mut *mut SmsAppMessage) -> HRESULT,
    fn get_BroadcastMessage(&self, out: *mut *mut SmsBroadcastMessage) -> HRESULT,
    fn get_VoicemailMessage(&self, out: *mut *mut SmsVoicemailMessage) -> HRESULT,
    fn get_StatusMessage(&self, out: *mut *mut SmsStatusMessage) -> HRESULT,
    fn Drop(&self) -> HRESULT,
    fn Accept(&self) -> HRESULT
}}
impl ISmsMessageReceivedTriggerDetails {
    #[inline] pub unsafe fn get_message_type(&self) -> Result<SmsMessageType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MessageType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_text_message(&self) -> Result<ComPtr<SmsTextMessage2>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_TextMessage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_wap_message(&self) -> Result<ComPtr<SmsWapMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_WapMessage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_app_message(&self) -> Result<ComPtr<SmsAppMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AppMessage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_broadcast_message(&self) -> Result<ComPtr<SmsBroadcastMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BroadcastMessage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_voicemail_message(&self) -> Result<ComPtr<SmsVoicemailMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_VoicemailMessage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status_message(&self) -> Result<ComPtr<SmsStatusMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_StatusMessage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn drop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Drop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn accept(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Accept)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class SmsMessageReceivedTriggerDetails: ISmsMessageReceivedTriggerDetails}
RT_ENUM! { enum SmsFilterActionType: i32 {
    AcceptImmediately (SmsFilterActionType_AcceptImmediately) = 0, Drop (SmsFilterActionType_Drop) = 1, Peek (SmsFilterActionType_Peek) = 2, Accept (SmsFilterActionType_Accept) = 3,
}}
DEFINE_IID!(IID_ISmsFilterRule, 1088630702, 45129, 20412, 175, 233, 226, 166, 16, 239, 245, 92);
RT_INTERFACE!{interface ISmsFilterRule(ISmsFilterRuleVtbl): IInspectable(IInspectableVtbl) [IID_ISmsFilterRule] {
    fn get_MessageType(&self, out: *mut SmsMessageType) -> HRESULT,
    fn get_ImsiPrefixes(&self, out: *mut *mut super::super::foundation::collections::IVector<HString>) -> HRESULT,
    fn get_DeviceIds(&self, out: *mut *mut super::super::foundation::collections::IVector<HString>) -> HRESULT,
    fn get_SenderNumbers(&self, out: *mut *mut super::super::foundation::collections::IVector<HString>) -> HRESULT,
    fn get_TextMessagePrefixes(&self, out: *mut *mut super::super::foundation::collections::IVector<HString>) -> HRESULT,
    fn get_PortNumbers(&self, out: *mut *mut super::super::foundation::collections::IVector<i32>) -> HRESULT,
    fn get_CellularClass(&self, out: *mut CellularClass) -> HRESULT,
    fn put_CellularClass(&self, value: CellularClass) -> HRESULT,
    fn get_ProtocolIds(&self, out: *mut *mut super::super::foundation::collections::IVector<i32>) -> HRESULT,
    fn get_TeleserviceIds(&self, out: *mut *mut super::super::foundation::collections::IVector<i32>) -> HRESULT,
    fn get_WapApplicationIds(&self, out: *mut *mut super::super::foundation::collections::IVector<HString>) -> HRESULT,
    fn get_WapContentTypes(&self, out: *mut *mut super::super::foundation::collections::IVector<HString>) -> HRESULT,
    fn get_BroadcastTypes(&self, out: *mut *mut super::super::foundation::collections::IVector<SmsBroadcastType>) -> HRESULT,
    fn get_BroadcastChannels(&self, out: *mut *mut super::super::foundation::collections::IVector<i32>) -> HRESULT
}}
impl ISmsFilterRule {
    #[inline] pub unsafe fn get_message_type(&self) -> Result<SmsMessageType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MessageType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_imsi_prefixes(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ImsiPrefixes)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_ids(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceIds)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sender_numbers(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SenderNumbers)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_text_message_prefixes(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_TextMessagePrefixes)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_port_numbers(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<i32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PortNumbers)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cellular_class(&self) -> Result<CellularClass> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CellularClass)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_cellular_class(&self, value: CellularClass) -> Result<()> {
        let hr = ((*self.lpVtbl).put_CellularClass)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_protocol_ids(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<i32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ProtocolIds)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_teleservice_ids(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<i32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_TeleserviceIds)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_wap_application_ids(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_WapApplicationIds)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_wap_content_types(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_WapContentTypes)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_broadcast_types(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<SmsBroadcastType>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BroadcastTypes)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_broadcast_channels(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<i32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BroadcastChannels)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmsFilterRuleFactory, 12805384, 25238, 20265, 154, 173, 137, 32, 206, 186, 60, 232);
RT_INTERFACE!{static interface ISmsFilterRuleFactory(ISmsFilterRuleFactoryVtbl): IInspectable(IInspectableVtbl) [IID_ISmsFilterRuleFactory] {
    fn CreateFilterRule(&self, messageType: SmsMessageType, out: *mut *mut SmsFilterRule) -> HRESULT
}}
impl ISmsFilterRuleFactory {
    #[inline] pub unsafe fn create_filter_rule(&self, messageType: SmsMessageType) -> Result<ComPtr<SmsFilterRule>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateFilterRule)(self as *const _ as *mut _, messageType, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SmsFilterRule: ISmsFilterRule}
impl RtActivatable<ISmsFilterRuleFactory> for SmsFilterRule {}
impl SmsFilterRule {
    #[inline] pub fn create_filter_rule(messageType: SmsMessageType) -> Result<ComPtr<SmsFilterRule>> { unsafe {
        <Self as RtActivatable<ISmsFilterRuleFactory>>::get_activation_factory().create_filter_rule(messageType)
    }}
}
DEFINE_CLSID!(SmsFilterRule(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,109,115,46,83,109,115,70,105,108,116,101,114,82,117,108,101,0]) [CLSID_SmsFilterRule]);
DEFINE_IID!(IID_ISmsFilterRules, 1313336059, 31181, 18561, 152, 148, 85, 164, 19, 91, 35, 250);
RT_INTERFACE!{interface ISmsFilterRules(ISmsFilterRulesVtbl): IInspectable(IInspectableVtbl) [IID_ISmsFilterRules] {
    fn get_ActionType(&self, out: *mut SmsFilterActionType) -> HRESULT,
    fn get_Rules(&self, out: *mut *mut super::super::foundation::collections::IVector<SmsFilterRule>) -> HRESULT
}}
impl ISmsFilterRules {
    #[inline] pub unsafe fn get_action_type(&self) -> Result<SmsFilterActionType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ActionType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_rules(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<SmsFilterRule>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Rules)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmsFilterRulesFactory, 2694391021, 28206, 17712, 159, 222, 70, 93, 2, 238, 208, 14);
RT_INTERFACE!{static interface ISmsFilterRulesFactory(ISmsFilterRulesFactoryVtbl): IInspectable(IInspectableVtbl) [IID_ISmsFilterRulesFactory] {
    fn CreateFilterRules(&self, actionType: SmsFilterActionType, out: *mut *mut SmsFilterRules) -> HRESULT
}}
impl ISmsFilterRulesFactory {
    #[inline] pub unsafe fn create_filter_rules(&self, actionType: SmsFilterActionType) -> Result<ComPtr<SmsFilterRules>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateFilterRules)(self as *const _ as *mut _, actionType, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SmsFilterRules: ISmsFilterRules}
impl RtActivatable<ISmsFilterRulesFactory> for SmsFilterRules {}
impl SmsFilterRules {
    #[inline] pub fn create_filter_rules(actionType: SmsFilterActionType) -> Result<ComPtr<SmsFilterRules>> { unsafe {
        <Self as RtActivatable<ISmsFilterRulesFactory>>::get_activation_factory().create_filter_rules(actionType)
    }}
}
DEFINE_CLSID!(SmsFilterRules(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,109,115,46,83,109,115,70,105,108,116,101,114,82,117,108,101,115,0]) [CLSID_SmsFilterRules]);
DEFINE_IID!(IID_ISmsMessageRegistrationStatics, 1671451748, 10392, 18296, 160, 60, 111, 153, 73, 7, 214, 58);
RT_INTERFACE!{static interface ISmsMessageRegistrationStatics(ISmsMessageRegistrationStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ISmsMessageRegistrationStatics] {
    fn get_AllRegistrations(&self, out: *mut *mut super::super::foundation::collections::IVectorView<SmsMessageRegistration>) -> HRESULT,
    fn Register(&self, id: HSTRING, filterRules: *mut SmsFilterRules, out: *mut *mut SmsMessageRegistration) -> HRESULT
}}
impl ISmsMessageRegistrationStatics {
    #[inline] pub unsafe fn get_all_registrations(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<SmsMessageRegistration>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AllRegistrations)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn register(&self, id: &HStringArg, filterRules: &SmsFilterRules) -> Result<ComPtr<SmsMessageRegistration>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Register)(self as *const _ as *mut _, id.get(), filterRules as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SmsMessageRegistration: ISmsMessageRegistration}
impl RtActivatable<ISmsMessageRegistrationStatics> for SmsMessageRegistration {}
impl SmsMessageRegistration {
    #[inline] pub fn get_all_registrations() -> Result<ComPtr<super::super::foundation::collections::IVectorView<SmsMessageRegistration>>> { unsafe {
        <Self as RtActivatable<ISmsMessageRegistrationStatics>>::get_activation_factory().get_all_registrations()
    }}
    #[inline] pub fn register(id: &HStringArg, filterRules: &SmsFilterRules) -> Result<ComPtr<SmsMessageRegistration>> { unsafe {
        <Self as RtActivatable<ISmsMessageRegistrationStatics>>::get_activation_factory().register(id, filterRules)
    }}
}
DEFINE_CLSID!(SmsMessageRegistration(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,109,115,46,83,109,115,77,101,115,115,97,103,101,82,101,103,105,115,116,114,97,116,105,111,110,0]) [CLSID_SmsMessageRegistration]);
DEFINE_IID!(IID_ISmsMessageRegistration, 387993662, 62287, 17515, 131, 179, 15, 241, 153, 35, 180, 9);
RT_INTERFACE!{interface ISmsMessageRegistration(ISmsMessageRegistrationVtbl): IInspectable(IInspectableVtbl) [IID_ISmsMessageRegistration] {
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn Unregister(&self) -> HRESULT,
    fn add_MessageReceived(&self, eventHandler: *mut super::super::foundation::TypedEventHandler<SmsMessageRegistration, SmsMessageReceivedTriggerDetails>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_MessageReceived(&self, eventCookie: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl ISmsMessageRegistration {
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn unregister(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Unregister)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_message_received(&self, eventHandler: &super::super::foundation::TypedEventHandler<SmsMessageRegistration, SmsMessageReceivedTriggerDetails>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_MessageReceived)(self as *const _ as *mut _, eventHandler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_message_received(&self, eventCookie: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_MessageReceived)(self as *const _ as *mut _, eventCookie);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmsMessage, 3980156456, 27012, 19207, 129, 29, 141, 89, 6, 237, 60, 234);
RT_INTERFACE!{interface ISmsMessage(ISmsMessageVtbl): IInspectable(IInspectableVtbl) [IID_ISmsMessage] {
    fn get_Id(&self, out: *mut u32) -> HRESULT,
    fn get_MessageClass(&self, out: *mut SmsMessageClass) -> HRESULT
}}
impl ISmsMessage {
    #[inline] pub unsafe fn get_id(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_message_class(&self) -> Result<SmsMessageClass> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MessageClass)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmsBinaryMessage, 1542776851, 15187, 19566, 182, 26, 216, 106, 99, 117, 86, 80);
RT_INTERFACE!{interface ISmsBinaryMessage(ISmsBinaryMessageVtbl): IInspectable(IInspectableVtbl) [IID_ISmsBinaryMessage] {
    fn get_Format(&self, out: *mut SmsDataFormat) -> HRESULT,
    fn put_Format(&self, value: SmsDataFormat) -> HRESULT,
    fn GetData(&self, outSize: *mut u32, out: *mut *mut u8) -> HRESULT,
    fn SetData(&self, valueSize: u32, value: *mut u8) -> HRESULT
}}
impl ISmsBinaryMessage {
    #[inline] pub unsafe fn get_format(&self) -> Result<SmsDataFormat> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Format)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_format(&self, value: SmsDataFormat) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Format)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_data(&self) -> Result<ComArray<u8>> {
        let mut outSize = 0; let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetData)(self as *const _ as *mut _, &mut outSize, &mut out);
        if hr == S_OK { Ok(ComArray::from_raw(outSize, out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_data(&self, value: &[u8]) -> Result<()> {
        let hr = ((*self.lpVtbl).SetData)(self as *const _ as *mut _, value.len() as u32, value.as_ptr() as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class SmsBinaryMessage: ISmsBinaryMessage}
impl RtActivatable<IActivationFactory> for SmsBinaryMessage {}
DEFINE_CLSID!(SmsBinaryMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,109,115,46,83,109,115,66,105,110,97,114,121,77,101,115,115,97,103,101,0]) [CLSID_SmsBinaryMessage]);
DEFINE_IID!(IID_ISmsTextMessage, 3592196172, 42133, 18559, 154, 111, 151, 21, 72, 197, 188, 159);
RT_INTERFACE!{interface ISmsTextMessage(ISmsTextMessageVtbl): IInspectable(IInspectableVtbl) [IID_ISmsTextMessage] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_PartReferenceId(&self, out: *mut u32) -> HRESULT,
    fn get_PartNumber(&self, out: *mut u32) -> HRESULT,
    fn get_PartCount(&self, out: *mut u32) -> HRESULT,
    fn get_To(&self, out: *mut HSTRING) -> HRESULT,
    fn put_To(&self, value: HSTRING) -> HRESULT,
    fn get_From(&self, out: *mut HSTRING) -> HRESULT,
    fn put_From(&self, value: HSTRING) -> HRESULT,
    fn get_Body(&self, out: *mut HSTRING) -> HRESULT,
    fn put_Body(&self, value: HSTRING) -> HRESULT,
    fn get_Encoding(&self, out: *mut SmsEncoding) -> HRESULT,
    fn put_Encoding(&self, value: SmsEncoding) -> HRESULT,
    fn ToBinaryMessages(&self, format: SmsDataFormat, out: *mut *mut super::super::foundation::collections::IVectorView<ISmsBinaryMessage>) -> HRESULT
}}
impl ISmsTextMessage {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_part_reference_id(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PartReferenceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_part_number(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PartNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_part_count(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PartCount)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_to(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_To)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_to(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_To)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_from(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_From)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_from(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_From)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_body(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Body)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_body(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Body)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_encoding(&self) -> Result<SmsEncoding> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Encoding)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_encoding(&self, value: SmsEncoding) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Encoding)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn to_binary_messages(&self, format: SmsDataFormat) -> Result<ComPtr<super::super::foundation::collections::IVectorView<ISmsBinaryMessage>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ToBinaryMessages)(self as *const _ as *mut _, format, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmsTextMessageStatics, 2137572845, 15564, 18339, 140, 85, 56, 13, 59, 1, 8, 146);
RT_INTERFACE!{static interface ISmsTextMessageStatics(ISmsTextMessageStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ISmsTextMessageStatics] {
    fn FromBinaryMessage(&self, binaryMessage: *mut SmsBinaryMessage, out: *mut *mut SmsTextMessage) -> HRESULT,
    fn FromBinaryData(&self, format: SmsDataFormat, valueSize: u32, value: *mut u8, out: *mut *mut SmsTextMessage) -> HRESULT
}}
impl ISmsTextMessageStatics {
    #[inline] pub unsafe fn from_binary_message(&self, binaryMessage: &SmsBinaryMessage) -> Result<ComPtr<SmsTextMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromBinaryMessage)(self as *const _ as *mut _, binaryMessage as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_binary_data(&self, format: SmsDataFormat, value: &[u8]) -> Result<ComPtr<SmsTextMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromBinaryData)(self as *const _ as *mut _, format, value.len() as u32, value.as_ptr() as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SmsTextMessage: ISmsTextMessage}
impl RtActivatable<ISmsTextMessageStatics> for SmsTextMessage {}
impl RtActivatable<IActivationFactory> for SmsTextMessage {}
impl SmsTextMessage {
    #[inline] pub fn from_binary_message(binaryMessage: &SmsBinaryMessage) -> Result<ComPtr<SmsTextMessage>> { unsafe {
        <Self as RtActivatable<ISmsTextMessageStatics>>::get_activation_factory().from_binary_message(binaryMessage)
    }}
    #[inline] pub fn from_binary_data(format: SmsDataFormat, value: &[u8]) -> Result<ComPtr<SmsTextMessage>> { unsafe {
        <Self as RtActivatable<ISmsTextMessageStatics>>::get_activation_factory().from_binary_data(format, value)
    }}
}
DEFINE_CLSID!(SmsTextMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,109,115,46,83,109,115,84,101,120,116,77,101,115,115,97,103,101,0]) [CLSID_SmsTextMessage]);
RT_ENUM! { enum SmsMessageFilter: i32 {
    All (SmsMessageFilter_All) = 0, Unread (SmsMessageFilter_Unread) = 1, Read (SmsMessageFilter_Read) = 2, Sent (SmsMessageFilter_Sent) = 3, Draft (SmsMessageFilter_Draft) = 4,
}}
RT_CLASS!{class DeleteSmsMessageOperation: super::super::foundation::IAsyncAction}
RT_CLASS!{class DeleteSmsMessagesOperation: super::super::foundation::IAsyncAction}
RT_CLASS!{class GetSmsMessageOperation: super::super::foundation::IAsyncOperation<ISmsMessage>}
RT_CLASS!{class GetSmsMessagesOperation: super::super::foundation::IAsyncOperationWithProgress<super::super::foundation::collections::IVectorView<ISmsMessage>, i32>}
DEFINE_IID!(IID_ISmsDeviceMessageStore, 2559177299, 61832, 17447, 141, 84, 206, 12, 36, 35, 197, 193);
RT_INTERFACE!{interface ISmsDeviceMessageStore(ISmsDeviceMessageStoreVtbl): IInspectable(IInspectableVtbl) [IID_ISmsDeviceMessageStore] {
    fn DeleteMessageAsync(&self, messageId: u32, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn DeleteMessagesAsync(&self, messageFilter: SmsMessageFilter, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn GetMessageAsync(&self, messageId: u32, out: *mut *mut super::super::foundation::IAsyncOperation<ISmsMessage>) -> HRESULT,
    fn GetMessagesAsync(&self, messageFilter: SmsMessageFilter, out: *mut *mut super::super::foundation::IAsyncOperationWithProgress<super::super::foundation::collections::IVectorView<ISmsMessage>, i32>) -> HRESULT,
    fn get_MaxMessages(&self, out: *mut u32) -> HRESULT
}}
impl ISmsDeviceMessageStore {
    #[inline] pub unsafe fn delete_message_async(&self, messageId: u32) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).DeleteMessageAsync)(self as *const _ as *mut _, messageId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn delete_messages_async(&self, messageFilter: SmsMessageFilter) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).DeleteMessagesAsync)(self as *const _ as *mut _, messageFilter, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_message_async(&self, messageId: u32) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ISmsMessage>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetMessageAsync)(self as *const _ as *mut _, messageId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_messages_async(&self, messageFilter: SmsMessageFilter) -> Result<ComPtr<super::super::foundation::IAsyncOperationWithProgress<super::super::foundation::collections::IVectorView<ISmsMessage>, i32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetMessagesAsync)(self as *const _ as *mut _, messageFilter, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_messages(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxMessages)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class SmsDeviceMessageStore: ISmsDeviceMessageStore}
RT_CLASS!{class SendSmsMessageOperation: super::super::foundation::IAsyncAction}
DEFINE_IID!(IID_ISmsMessageReceivedEventArgs, 149424792, 47333, 16833, 163, 216, 211, 171, 250, 226, 38, 117);
RT_INTERFACE!{interface ISmsMessageReceivedEventArgs(ISmsMessageReceivedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_ISmsMessageReceivedEventArgs] {
    fn get_TextMessage(&self, out: *mut *mut SmsTextMessage) -> HRESULT,
    fn get_BinaryMessage(&self, out: *mut *mut SmsBinaryMessage) -> HRESULT
}}
impl ISmsMessageReceivedEventArgs {
    #[inline] pub unsafe fn get_text_message(&self) -> Result<ComPtr<SmsTextMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_TextMessage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_binary_message(&self) -> Result<ComPtr<SmsBinaryMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BinaryMessage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SmsMessageReceivedEventArgs: ISmsMessageReceivedEventArgs}
DEFINE_IID!(IID_SmsMessageReceivedEventHandler, 192599049, 60461, 18382, 162, 83, 115, 43, 238, 235, 202, 205);
RT_DELEGATE!{delegate SmsMessageReceivedEventHandler(SmsMessageReceivedEventHandlerVtbl, SmsMessageReceivedEventHandlerImpl) [IID_SmsMessageReceivedEventHandler] {
    fn Invoke(&self, sender: *mut SmsDevice, e: *mut SmsMessageReceivedEventArgs) -> HRESULT
}}
impl SmsMessageReceivedEventHandler {
    #[inline] pub unsafe fn invoke(&self, sender: &SmsDevice, e: &SmsMessageReceivedEventArgs) -> Result<()> {
        let hr = ((*self.lpVtbl).Invoke)(self as *const _ as *mut _, sender as *const _ as *mut _, e as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class SmsDevice: ISmsDevice}
impl RtActivatable<ISmsDeviceStatics> for SmsDevice {}
impl RtActivatable<ISmsDeviceStatics2> for SmsDevice {}
impl SmsDevice {
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<ISmsDeviceStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmsDevice>>> { unsafe {
        <Self as RtActivatable<ISmsDeviceStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmsDevice>>> { unsafe {
        <Self as RtActivatable<ISmsDeviceStatics>>::get_activation_factory().get_default_async()
    }}
    #[inline] pub fn from_network_account_id_async(networkAccountId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmsDevice>>> { unsafe {
        <Self as RtActivatable<ISmsDeviceStatics2>>::get_activation_factory().from_network_account_id_async(networkAccountId)
    }}
}
DEFINE_CLSID!(SmsDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,109,115,46,83,109,115,68,101,118,105,99,101,0]) [CLSID_SmsDevice]);
DEFINE_IID!(IID_SmsDeviceStatusChangedEventHandler, 2552959330, 15831, 17944, 175, 137, 12, 39, 45, 93, 6, 216);
RT_DELEGATE!{delegate SmsDeviceStatusChangedEventHandler(SmsDeviceStatusChangedEventHandlerVtbl, SmsDeviceStatusChangedEventHandlerImpl) [IID_SmsDeviceStatusChangedEventHandler] {
    fn Invoke(&self, sender: *mut SmsDevice) -> HRESULT
}}
impl SmsDeviceStatusChangedEventHandler {
    #[inline] pub unsafe fn invoke(&self, sender: &SmsDevice) -> Result<()> {
        let hr = ((*self.lpVtbl).Invoke)(self as *const _ as *mut _, sender as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class GetSmsDeviceOperation: super::super::foundation::IAsyncOperation<SmsDevice>}
DEFINE_IID!(IID_ISmsDeviceStatics, 4169992170, 55317, 19921, 162, 52, 69, 32, 206, 70, 4, 164);
RT_INTERFACE!{static interface ISmsDeviceStatics(ISmsDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ISmsDeviceStatics] {
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<SmsDevice>) -> HRESULT,
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<SmsDevice>) -> HRESULT
}}
impl ISmsDeviceStatics {
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmsDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmsDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmsDeviceStatics2, 748756103, 2163, 19631, 138, 125, 189, 71, 30, 133, 134, 209);
RT_INTERFACE!{static interface ISmsDeviceStatics2(ISmsDeviceStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_ISmsDeviceStatics2] {
    fn FromNetworkAccountIdAsync(&self, networkAccountId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<SmsDevice>) -> HRESULT
}}
impl ISmsDeviceStatics2 {
    #[inline] pub unsafe fn from_network_account_id_async(&self, networkAccountId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SmsDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromNetworkAccountIdAsync)(self as *const _ as *mut _, networkAccountId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmsDevice, 152539629, 34603, 20204, 156, 114, 171, 17, 98, 123, 52, 236);
RT_INTERFACE!{interface ISmsDevice(ISmsDeviceVtbl): IInspectable(IInspectableVtbl) [IID_ISmsDevice] {
    fn SendMessageAsync(&self, message: *mut ISmsMessage, out: *mut *mut SendSmsMessageOperation) -> HRESULT,
    fn CalculateLength(&self, message: *mut SmsTextMessage, out: *mut SmsEncodedLength) -> HRESULT,
    fn get_AccountPhoneNumber(&self, out: *mut HSTRING) -> HRESULT,
    fn get_CellularClass(&self, out: *mut CellularClass) -> HRESULT,
    fn get_MessageStore(&self, out: *mut *mut SmsDeviceMessageStore) -> HRESULT,
    fn get_DeviceStatus(&self, out: *mut SmsDeviceStatus) -> HRESULT,
    fn add_SmsMessageReceived(&self, eventHandler: *mut SmsMessageReceivedEventHandler, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SmsMessageReceived(&self, eventCookie: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_SmsDeviceStatusChanged(&self, eventHandler: *mut SmsDeviceStatusChangedEventHandler, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SmsDeviceStatusChanged(&self, eventCookie: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl ISmsDevice {
    #[inline] pub unsafe fn send_message_async(&self, message: &ISmsMessage) -> Result<ComPtr<SendSmsMessageOperation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).SendMessageAsync)(self as *const _ as *mut _, message as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn calculate_length(&self, message: &SmsTextMessage) -> Result<SmsEncodedLength> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).CalculateLength)(self as *const _ as *mut _, message as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_account_phone_number(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AccountPhoneNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cellular_class(&self) -> Result<CellularClass> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CellularClass)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_message_store(&self) -> Result<ComPtr<SmsDeviceMessageStore>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_MessageStore)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_status(&self) -> Result<SmsDeviceStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DeviceStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_sms_message_received(&self, eventHandler: &SmsMessageReceivedEventHandler) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SmsMessageReceived)(self as *const _ as *mut _, eventHandler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_sms_message_received(&self, eventCookie: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SmsMessageReceived)(self as *const _ as *mut _, eventCookie);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_sms_device_status_changed(&self, eventHandler: &SmsDeviceStatusChangedEventHandler) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SmsDeviceStatusChanged)(self as *const _ as *mut _, eventHandler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_sms_device_status_changed(&self, eventCookie: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SmsDeviceStatusChanged)(self as *const _ as *mut _, eventCookie);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmsReceivedEventDetails, 1538592533, 58477, 19586, 132, 125, 90, 3, 4, 193, 213, 61);
RT_INTERFACE!{interface ISmsReceivedEventDetails(ISmsReceivedEventDetailsVtbl): IInspectable(IInspectableVtbl) [IID_ISmsReceivedEventDetails] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_MessageIndex(&self, out: *mut u32) -> HRESULT
}}
impl ISmsReceivedEventDetails {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_message_index(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MessageIndex)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISmsReceivedEventDetails2, 1088445574, 42932, 18289, 154, 231, 11, 95, 251, 18, 192, 58);
RT_INTERFACE!{interface ISmsReceivedEventDetails2(ISmsReceivedEventDetails2Vtbl): IInspectable(IInspectableVtbl) [IID_ISmsReceivedEventDetails2] {
    fn get_MessageClass(&self, out: *mut SmsMessageClass) -> HRESULT,
    fn get_BinaryMessage(&self, out: *mut *mut SmsBinaryMessage) -> HRESULT
}}
impl ISmsReceivedEventDetails2 {
    #[inline] pub unsafe fn get_message_class(&self) -> Result<SmsMessageClass> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MessageClass)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_binary_message(&self) -> Result<ComPtr<SmsBinaryMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BinaryMessage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SmsReceivedEventDetails: ISmsReceivedEventDetails}
} // Windows.Devices.Sms
pub mod alljoyn { // Windows.Devices.AllJoyn
use ::prelude::*;
RT_ENUM! { enum AllJoynAuthenticationMechanism: i32 {
    None (AllJoynAuthenticationMechanism_None) = 0, SrpAnonymous (AllJoynAuthenticationMechanism_SrpAnonymous) = 1, SrpLogon (AllJoynAuthenticationMechanism_SrpLogon) = 2, EcdheNull (AllJoynAuthenticationMechanism_EcdheNull) = 3, EcdhePsk (AllJoynAuthenticationMechanism_EcdhePsk) = 4, EcdheEcdsa (AllJoynAuthenticationMechanism_EcdheEcdsa) = 5, EcdheSpeke (AllJoynAuthenticationMechanism_EcdheSpeke) = 6,
}}
DEFINE_IID!(IID_IAllJoynStatusStatics, 3501695358, 3369, 19881, 138, 198, 84, 197, 84, 190, 219, 197);
RT_INTERFACE!{static interface IAllJoynStatusStatics(IAllJoynStatusStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynStatusStatics] {
    fn get_Ok(&self, out: *mut i32) -> HRESULT,
    fn get_Fail(&self, out: *mut i32) -> HRESULT,
    fn get_OperationTimedOut(&self, out: *mut i32) -> HRESULT,
    fn get_OtherEndClosed(&self, out: *mut i32) -> HRESULT,
    fn get_ConnectionRefused(&self, out: *mut i32) -> HRESULT,
    fn get_AuthenticationFailed(&self, out: *mut i32) -> HRESULT,
    fn get_AuthenticationRejectedByUser(&self, out: *mut i32) -> HRESULT,
    fn get_SslConnectFailed(&self, out: *mut i32) -> HRESULT,
    fn get_SslIdentityVerificationFailed(&self, out: *mut i32) -> HRESULT,
    fn get_InsufficientSecurity(&self, out: *mut i32) -> HRESULT,
    fn get_InvalidArgument1(&self, out: *mut i32) -> HRESULT,
    fn get_InvalidArgument2(&self, out: *mut i32) -> HRESULT,
    fn get_InvalidArgument3(&self, out: *mut i32) -> HRESULT,
    fn get_InvalidArgument4(&self, out: *mut i32) -> HRESULT,
    fn get_InvalidArgument5(&self, out: *mut i32) -> HRESULT,
    fn get_InvalidArgument6(&self, out: *mut i32) -> HRESULT,
    fn get_InvalidArgument7(&self, out: *mut i32) -> HRESULT,
    fn get_InvalidArgument8(&self, out: *mut i32) -> HRESULT
}}
impl IAllJoynStatusStatics {
    #[inline] pub unsafe fn get_ok(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ok)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_fail(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Fail)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_operation_timed_out(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_OperationTimedOut)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_other_end_closed(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_OtherEndClosed)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_connection_refused(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ConnectionRefused)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_authentication_failed(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AuthenticationFailed)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_authentication_rejected_by_user(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AuthenticationRejectedByUser)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ssl_connect_failed(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SslConnectFailed)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ssl_identity_verification_failed(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SslIdentityVerificationFailed)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_insufficient_security(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InsufficientSecurity)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_invalid_argument1(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InvalidArgument1)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_invalid_argument2(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InvalidArgument2)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_invalid_argument3(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InvalidArgument3)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_invalid_argument4(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InvalidArgument4)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_invalid_argument5(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InvalidArgument5)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_invalid_argument6(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InvalidArgument6)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_invalid_argument7(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InvalidArgument7)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_invalid_argument8(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InvalidArgument8)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{static class AllJoynStatus}
impl RtActivatable<IAllJoynStatusStatics> for AllJoynStatus {}
impl AllJoynStatus {
    #[inline] pub fn get_ok() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_ok()
    }}
    #[inline] pub fn get_fail() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_fail()
    }}
    #[inline] pub fn get_operation_timed_out() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_operation_timed_out()
    }}
    #[inline] pub fn get_other_end_closed() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_other_end_closed()
    }}
    #[inline] pub fn get_connection_refused() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_connection_refused()
    }}
    #[inline] pub fn get_authentication_failed() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_authentication_failed()
    }}
    #[inline] pub fn get_authentication_rejected_by_user() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_authentication_rejected_by_user()
    }}
    #[inline] pub fn get_ssl_connect_failed() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_ssl_connect_failed()
    }}
    #[inline] pub fn get_ssl_identity_verification_failed() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_ssl_identity_verification_failed()
    }}
    #[inline] pub fn get_insufficient_security() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_insufficient_security()
    }}
    #[inline] pub fn get_invalid_argument1() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_invalid_argument1()
    }}
    #[inline] pub fn get_invalid_argument2() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_invalid_argument2()
    }}
    #[inline] pub fn get_invalid_argument3() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_invalid_argument3()
    }}
    #[inline] pub fn get_invalid_argument4() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_invalid_argument4()
    }}
    #[inline] pub fn get_invalid_argument5() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_invalid_argument5()
    }}
    #[inline] pub fn get_invalid_argument6() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_invalid_argument6()
    }}
    #[inline] pub fn get_invalid_argument7() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_invalid_argument7()
    }}
    #[inline] pub fn get_invalid_argument8() -> Result<i32> { unsafe {
        <Self as RtActivatable<IAllJoynStatusStatics>>::get_activation_factory().get_invalid_argument8()
    }}
}
DEFINE_CLSID!(AllJoynStatus(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,83,116,97,116,117,115,0]) [CLSID_AllJoynStatus]);
RT_ENUM! { enum AllJoynBusAttachmentState: i32 {
    Disconnected (AllJoynBusAttachmentState_Disconnected) = 0, Connecting (AllJoynBusAttachmentState_Connecting) = 1, Connected (AllJoynBusAttachmentState_Connected) = 2, Disconnecting (AllJoynBusAttachmentState_Disconnecting) = 3,
}}
DEFINE_IID!(IID_IAllJoynBusAttachment, 4077515091, 7917, 17091, 162, 14, 67, 109, 65, 254, 98, 246);
RT_INTERFACE!{interface IAllJoynBusAttachment(IAllJoynBusAttachmentVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynBusAttachment] {
    fn get_AboutData(&self, out: *mut *mut AllJoynAboutData) -> HRESULT,
    fn get_ConnectionSpecification(&self, out: *mut HSTRING) -> HRESULT,
    fn get_State(&self, out: *mut AllJoynBusAttachmentState) -> HRESULT,
    fn get_UniqueName(&self, out: *mut HSTRING) -> HRESULT,
    fn PingAsync(&self, uniqueName: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<i32>) -> HRESULT,
    fn Connect(&self) -> HRESULT,
    fn Disconnect(&self) -> HRESULT,
    fn add_StateChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<AllJoynBusAttachment, AllJoynBusAttachmentStateChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_StateChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_AuthenticationMechanisms(&self, out: *mut *mut super::super::foundation::collections::IVector<AllJoynAuthenticationMechanism>) -> HRESULT,
    fn add_CredentialsRequested(&self, handler: *mut super::super::foundation::TypedEventHandler<AllJoynBusAttachment, AllJoynCredentialsRequestedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_CredentialsRequested(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_CredentialsVerificationRequested(&self, handler: *mut super::super::foundation::TypedEventHandler<AllJoynBusAttachment, AllJoynCredentialsVerificationRequestedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_CredentialsVerificationRequested(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_AuthenticationComplete(&self, handler: *mut super::super::foundation::TypedEventHandler<AllJoynBusAttachment, AllJoynAuthenticationCompleteEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_AuthenticationComplete(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IAllJoynBusAttachment {
    #[inline] pub unsafe fn get_about_data(&self) -> Result<ComPtr<AllJoynAboutData>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AboutData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_connection_specification(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ConnectionSpecification)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_state(&self) -> Result<AllJoynBusAttachmentState> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_State)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_unique_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_UniqueName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn ping_async(&self, uniqueName: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<i32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).PingAsync)(self as *const _ as *mut _, uniqueName.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn connect(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Connect)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn disconnect(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Disconnect)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_state_changed(&self, handler: &super::super::foundation::TypedEventHandler<AllJoynBusAttachment, AllJoynBusAttachmentStateChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_StateChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_state_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_StateChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_authentication_mechanisms(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<AllJoynAuthenticationMechanism>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AuthenticationMechanisms)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_credentials_requested(&self, handler: &super::super::foundation::TypedEventHandler<AllJoynBusAttachment, AllJoynCredentialsRequestedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_CredentialsRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_credentials_requested(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_CredentialsRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_credentials_verification_requested(&self, handler: &super::super::foundation::TypedEventHandler<AllJoynBusAttachment, AllJoynCredentialsVerificationRequestedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_CredentialsVerificationRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_credentials_verification_requested(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_CredentialsVerificationRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_authentication_complete(&self, handler: &super::super::foundation::TypedEventHandler<AllJoynBusAttachment, AllJoynAuthenticationCompleteEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_AuthenticationComplete)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_authentication_complete(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_AuthenticationComplete)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class AllJoynAboutData: IAllJoynAboutData}
RT_CLASS!{class AllJoynBusAttachment: IAllJoynBusAttachment}
impl RtActivatable<IAllJoynBusAttachmentFactory> for AllJoynBusAttachment {}
impl RtActivatable<IAllJoynBusAttachmentStatics> for AllJoynBusAttachment {}
impl RtActivatable<IActivationFactory> for AllJoynBusAttachment {}
impl AllJoynBusAttachment {
    #[inline] pub fn create(connectionSpecification: &HStringArg) -> Result<ComPtr<AllJoynBusAttachment>> { unsafe {
        <Self as RtActivatable<IAllJoynBusAttachmentFactory>>::get_activation_factory().create(connectionSpecification)
    }}
    #[inline] pub fn get_default() -> Result<ComPtr<AllJoynBusAttachment>> { unsafe {
        <Self as RtActivatable<IAllJoynBusAttachmentStatics>>::get_activation_factory().get_default()
    }}
    #[inline] pub fn get_watcher(requiredInterfaces: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<super::enumeration::DeviceWatcher>> { unsafe {
        <Self as RtActivatable<IAllJoynBusAttachmentStatics>>::get_activation_factory().get_watcher(requiredInterfaces)
    }}
}
DEFINE_CLSID!(AllJoynBusAttachment(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,66,117,115,65,116,116,97,99,104,109,101,110,116,0]) [CLSID_AllJoynBusAttachment]);
RT_CLASS!{class AllJoynBusAttachmentStateChangedEventArgs: IAllJoynBusAttachmentStateChangedEventArgs}
RT_CLASS!{class AllJoynCredentialsRequestedEventArgs: IAllJoynCredentialsRequestedEventArgs}
RT_CLASS!{class AllJoynCredentialsVerificationRequestedEventArgs: IAllJoynCredentialsVerificationRequestedEventArgs}
RT_CLASS!{class AllJoynAuthenticationCompleteEventArgs: IAllJoynAuthenticationCompleteEventArgs}
DEFINE_IID!(IID_IAllJoynBusAttachment2, 880069406, 9064, 17330, 180, 62, 106, 58, 193, 39, 141, 152);
RT_INTERFACE!{interface IAllJoynBusAttachment2(IAllJoynBusAttachment2Vtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynBusAttachment2] {
    fn GetAboutDataAsync(&self, serviceInfo: *mut AllJoynServiceInfo, out: *mut *mut super::super::foundation::IAsyncOperation<AllJoynAboutDataView>) -> HRESULT,
    #[cfg(not(feature="windows-globalization"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-globalization")] fn GetAboutDataWithLanguageAsync(&self, serviceInfo: *mut AllJoynServiceInfo, language: *mut super::super::globalization::Language, out: *mut *mut super::super::foundation::IAsyncOperation<AllJoynAboutDataView>) -> HRESULT,
    fn add_AcceptSessionJoinerRequested(&self, handler: *mut super::super::foundation::TypedEventHandler<AllJoynBusAttachment, AllJoynAcceptSessionJoinerEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_AcceptSessionJoinerRequested(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_SessionJoined(&self, handler: *mut super::super::foundation::TypedEventHandler<AllJoynBusAttachment, AllJoynSessionJoinedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SessionJoined(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IAllJoynBusAttachment2 {
    #[inline] pub unsafe fn get_about_data_async(&self, serviceInfo: &AllJoynServiceInfo) -> Result<ComPtr<super::super::foundation::IAsyncOperation<AllJoynAboutDataView>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetAboutDataAsync)(self as *const _ as *mut _, serviceInfo as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-globalization")] #[inline] pub unsafe fn get_about_data_with_language_async(&self, serviceInfo: &AllJoynServiceInfo, language: &super::super::globalization::Language) -> Result<ComPtr<super::super::foundation::IAsyncOperation<AllJoynAboutDataView>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetAboutDataWithLanguageAsync)(self as *const _ as *mut _, serviceInfo as *const _ as *mut _, language as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_accept_session_joiner_requested(&self, handler: &super::super::foundation::TypedEventHandler<AllJoynBusAttachment, AllJoynAcceptSessionJoinerEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_AcceptSessionJoinerRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_accept_session_joiner_requested(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_AcceptSessionJoinerRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_session_joined(&self, handler: &super::super::foundation::TypedEventHandler<AllJoynBusAttachment, AllJoynSessionJoinedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SessionJoined)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_session_joined(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SessionJoined)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class AllJoynServiceInfo: IAllJoynServiceInfo}
impl RtActivatable<IAllJoynServiceInfoFactory> for AllJoynServiceInfo {}
impl RtActivatable<IAllJoynServiceInfoStatics> for AllJoynServiceInfo {}
impl AllJoynServiceInfo {
    #[inline] pub fn create(uniqueName: &HStringArg, objectPath: &HStringArg, sessionPort: u16) -> Result<ComPtr<AllJoynServiceInfo>> { unsafe {
        <Self as RtActivatable<IAllJoynServiceInfoFactory>>::get_activation_factory().create(uniqueName, objectPath, sessionPort)
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<AllJoynServiceInfo>>> { unsafe {
        <Self as RtActivatable<IAllJoynServiceInfoStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
}
DEFINE_CLSID!(AllJoynServiceInfo(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,83,101,114,118,105,99,101,73,110,102,111,0]) [CLSID_AllJoynServiceInfo]);
RT_CLASS!{class AllJoynAboutDataView: IAllJoynAboutDataView}
impl RtActivatable<IAllJoynAboutDataViewStatics> for AllJoynAboutDataView {}
impl AllJoynAboutDataView {
    #[inline] pub fn get_data_by_session_port_async(uniqueName: &HStringArg, busAttachment: &AllJoynBusAttachment, sessionPort: u16) -> Result<ComPtr<super::super::foundation::IAsyncOperation<AllJoynAboutDataView>>> { unsafe {
        <Self as RtActivatable<IAllJoynAboutDataViewStatics>>::get_activation_factory().get_data_by_session_port_async(uniqueName, busAttachment, sessionPort)
    }}
    #[cfg(feature="windows-globalization")] #[inline] pub fn get_data_by_session_port_with_language_async(uniqueName: &HStringArg, busAttachment: &AllJoynBusAttachment, sessionPort: u16, language: &super::super::globalization::Language) -> Result<ComPtr<super::super::foundation::IAsyncOperation<AllJoynAboutDataView>>> { unsafe {
        <Self as RtActivatable<IAllJoynAboutDataViewStatics>>::get_activation_factory().get_data_by_session_port_with_language_async(uniqueName, busAttachment, sessionPort, language)
    }}
}
DEFINE_CLSID!(AllJoynAboutDataView(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,65,98,111,117,116,68,97,116,97,86,105,101,119,0]) [CLSID_AllJoynAboutDataView]);
RT_CLASS!{class AllJoynAcceptSessionJoinerEventArgs: IAllJoynAcceptSessionJoinerEventArgs}
impl RtActivatable<IAllJoynAcceptSessionJoinerEventArgsFactory> for AllJoynAcceptSessionJoinerEventArgs {}
impl AllJoynAcceptSessionJoinerEventArgs {
    #[inline] pub fn create(uniqueName: &HStringArg, sessionPort: u16, trafficType: AllJoynTrafficType, proximity: u8, acceptSessionJoiner: &IAllJoynAcceptSessionJoiner) -> Result<ComPtr<AllJoynAcceptSessionJoinerEventArgs>> { unsafe {
        <Self as RtActivatable<IAllJoynAcceptSessionJoinerEventArgsFactory>>::get_activation_factory().create(uniqueName, sessionPort, trafficType, proximity, acceptSessionJoiner)
    }}
}
DEFINE_CLSID!(AllJoynAcceptSessionJoinerEventArgs(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,65,99,99,101,112,116,83,101,115,115,105,111,110,74,111,105,110,101,114,69,118,101,110,116,65,114,103,115,0]) [CLSID_AllJoynAcceptSessionJoinerEventArgs]);
RT_CLASS!{class AllJoynSessionJoinedEventArgs: IAllJoynSessionJoinedEventArgs}
impl RtActivatable<IAllJoynSessionJoinedEventArgsFactory> for AllJoynSessionJoinedEventArgs {}
impl AllJoynSessionJoinedEventArgs {
    #[inline] pub fn create(session: &AllJoynSession) -> Result<ComPtr<AllJoynSessionJoinedEventArgs>> { unsafe {
        <Self as RtActivatable<IAllJoynSessionJoinedEventArgsFactory>>::get_activation_factory().create(session)
    }}
}
DEFINE_CLSID!(AllJoynSessionJoinedEventArgs(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,83,101,115,115,105,111,110,74,111,105,110,101,100,69,118,101,110,116,65,114,103,115,0]) [CLSID_AllJoynSessionJoinedEventArgs]);
DEFINE_IID!(IID_IAllJoynBusAttachmentStatics, 2208124221, 4177, 16599, 135, 42, 141, 1, 65, 17, 91, 31);
RT_INTERFACE!{static interface IAllJoynBusAttachmentStatics(IAllJoynBusAttachmentStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynBusAttachmentStatics] {
    fn GetDefault(&self, out: *mut *mut AllJoynBusAttachment) -> HRESULT,
    fn GetWatcher(&self, requiredInterfaces: *mut super::super::foundation::collections::IIterable<HString>, out: *mut *mut super::enumeration::DeviceWatcher) -> HRESULT
}}
impl IAllJoynBusAttachmentStatics {
    #[inline] pub unsafe fn get_default(&self) -> Result<ComPtr<AllJoynBusAttachment>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefault)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_watcher(&self, requiredInterfaces: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<super::enumeration::DeviceWatcher>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetWatcher)(self as *const _ as *mut _, requiredInterfaces as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynBusAttachmentStateChangedEventArgs, 3626923508, 49194, 16876, 168, 213, 234, 177, 85, 137, 83, 170);
RT_INTERFACE!{interface IAllJoynBusAttachmentStateChangedEventArgs(IAllJoynBusAttachmentStateChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynBusAttachmentStateChangedEventArgs] {
    fn get_State(&self, out: *mut AllJoynBusAttachmentState) -> HRESULT,
    fn get_Status(&self, out: *mut i32) -> HRESULT
}}
impl IAllJoynBusAttachmentStateChangedEventArgs {
    #[inline] pub unsafe fn get_state(&self) -> Result<AllJoynBusAttachmentState> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_State)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynCredentials, 2185646322, 41360, 16561, 171, 171, 52, 158, 194, 68, 223, 170);
RT_INTERFACE!{interface IAllJoynCredentials(IAllJoynCredentialsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynCredentials] {
    fn get_AuthenticationMechanism(&self, out: *mut AllJoynAuthenticationMechanism) -> HRESULT,
    #[cfg(not(feature="windows-security"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-security")] fn get_Certificate(&self, out: *mut *mut super::super::security::cryptography::certificates::Certificate) -> HRESULT,
    #[cfg(not(feature="windows-security"))] fn __Dummy2(&self) -> (),
    #[cfg(feature="windows-security")] fn put_Certificate(&self, value: *mut super::super::security::cryptography::certificates::Certificate) -> HRESULT,
    #[cfg(not(feature="windows-security"))] fn __Dummy3(&self) -> (),
    #[cfg(feature="windows-security")] fn get_PasswordCredential(&self, out: *mut *mut super::super::security::credentials::PasswordCredential) -> HRESULT,
    #[cfg(not(feature="windows-security"))] fn __Dummy4(&self) -> (),
    #[cfg(feature="windows-security")] fn put_PasswordCredential(&self, value: *mut super::super::security::credentials::PasswordCredential) -> HRESULT,
    fn get_Timeout(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn put_Timeout(&self, value: super::super::foundation::TimeSpan) -> HRESULT
}}
impl IAllJoynCredentials {
    #[inline] pub unsafe fn get_authentication_mechanism(&self) -> Result<AllJoynAuthenticationMechanism> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AuthenticationMechanism)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-security")] #[inline] pub unsafe fn get_certificate(&self) -> Result<ComPtr<super::super::security::cryptography::certificates::Certificate>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Certificate)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-security")] #[inline] pub unsafe fn set_certificate(&self, value: &super::super::security::cryptography::certificates::Certificate) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Certificate)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-security")] #[inline] pub unsafe fn get_password_credential(&self) -> Result<ComPtr<super::super::security::credentials::PasswordCredential>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PasswordCredential)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-security")] #[inline] pub unsafe fn set_password_credential(&self, value: &super::super::security::credentials::PasswordCredential) -> Result<()> {
        let hr = ((*self.lpVtbl).put_PasswordCredential)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_timeout(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timeout)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_timeout(&self, value: super::super::foundation::TimeSpan) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Timeout)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class AllJoynCredentials: IAllJoynCredentials}
DEFINE_IID!(IID_IAllJoynCredentialsRequestedEventArgs, 1787290446, 45161, 19328, 158, 26, 65, 188, 131, 124, 101, 210);
RT_INTERFACE!{interface IAllJoynCredentialsRequestedEventArgs(IAllJoynCredentialsRequestedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynCredentialsRequestedEventArgs] {
    fn get_AttemptCount(&self, out: *mut u16) -> HRESULT,
    fn get_Credentials(&self, out: *mut *mut AllJoynCredentials) -> HRESULT,
    fn get_PeerUniqueName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_RequestedUserName(&self, out: *mut HSTRING) -> HRESULT,
    fn GetDeferral(&self, out: *mut *mut super::super::foundation::Deferral) -> HRESULT
}}
impl IAllJoynCredentialsRequestedEventArgs {
    #[inline] pub unsafe fn get_attempt_count(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AttemptCount)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_credentials(&self) -> Result<ComPtr<AllJoynCredentials>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Credentials)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_peer_unique_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PeerUniqueName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_requested_user_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_RequestedUserName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_deferral(&self) -> Result<ComPtr<super::super::foundation::Deferral>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeferral)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynCredentialsVerificationRequestedEventArgs, 2148169234, 47109, 17583, 162, 225, 121, 42, 182, 85, 162, 208);
RT_INTERFACE!{interface IAllJoynCredentialsVerificationRequestedEventArgs(IAllJoynCredentialsVerificationRequestedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynCredentialsVerificationRequestedEventArgs] {
    fn get_AuthenticationMechanism(&self, out: *mut AllJoynAuthenticationMechanism) -> HRESULT,
    fn get_PeerUniqueName(&self, out: *mut HSTRING) -> HRESULT,
    #[cfg(not(feature="windows-security"))] fn __Dummy2(&self) -> (),
    #[cfg(feature="windows-security")] fn get_PeerCertificate(&self, out: *mut *mut super::super::security::cryptography::certificates::Certificate) -> HRESULT,
    #[cfg(not(feature="windows-networking"))] fn __Dummy3(&self) -> (),
    #[cfg(feature="windows-networking")] fn get_PeerCertificateErrorSeverity(&self, out: *mut super::super::networking::sockets::SocketSslErrorSeverity) -> HRESULT,
    #[cfg(not(feature="windows-security"))] fn __Dummy4(&self) -> (),
    #[cfg(feature="windows-security")] fn get_PeerCertificateErrors(&self, out: *mut *mut super::super::foundation::collections::IVectorView<super::super::security::cryptography::certificates::ChainValidationResult>) -> HRESULT,
    #[cfg(not(feature="windows-security"))] fn __Dummy5(&self) -> (),
    #[cfg(feature="windows-security")] fn get_PeerIntermediateCertificates(&self, out: *mut *mut super::super::foundation::collections::IVectorView<super::super::security::cryptography::certificates::Certificate>) -> HRESULT,
    fn Accept(&self) -> HRESULT,
    fn GetDeferral(&self, out: *mut *mut super::super::foundation::Deferral) -> HRESULT
}}
impl IAllJoynCredentialsVerificationRequestedEventArgs {
    #[inline] pub unsafe fn get_authentication_mechanism(&self) -> Result<AllJoynAuthenticationMechanism> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AuthenticationMechanism)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_peer_unique_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PeerUniqueName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-security")] #[inline] pub unsafe fn get_peer_certificate(&self) -> Result<ComPtr<super::super::security::cryptography::certificates::Certificate>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PeerCertificate)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn get_peer_certificate_error_severity(&self) -> Result<super::super::networking::sockets::SocketSslErrorSeverity> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PeerCertificateErrorSeverity)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-security")] #[inline] pub unsafe fn get_peer_certificate_errors(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<super::super::security::cryptography::certificates::ChainValidationResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PeerCertificateErrors)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-security")] #[inline] pub unsafe fn get_peer_intermediate_certificates(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<super::super::security::cryptography::certificates::Certificate>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PeerIntermediateCertificates)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn accept(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Accept)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_deferral(&self) -> Result<ComPtr<super::super::foundation::Deferral>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeferral)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynAuthenticationCompleteEventArgs, 2545184796, 5596, 19283, 182, 164, 125, 19, 67, 0, 215, 191);
RT_INTERFACE!{interface IAllJoynAuthenticationCompleteEventArgs(IAllJoynAuthenticationCompleteEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynAuthenticationCompleteEventArgs] {
    fn get_AuthenticationMechanism(&self, out: *mut AllJoynAuthenticationMechanism) -> HRESULT,
    fn get_PeerUniqueName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Succeeded(&self, out: *mut bool) -> HRESULT
}}
impl IAllJoynAuthenticationCompleteEventArgs {
    #[inline] pub unsafe fn get_authentication_mechanism(&self) -> Result<AllJoynAuthenticationMechanism> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AuthenticationMechanism)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_peer_unique_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PeerUniqueName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_succeeded(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Succeeded)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynBusAttachmentFactory, 1680798116, 44421, 19935, 144, 174, 96, 68, 82, 178, 34, 136);
RT_INTERFACE!{static interface IAllJoynBusAttachmentFactory(IAllJoynBusAttachmentFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynBusAttachmentFactory] {
    fn Create(&self, connectionSpecification: HSTRING, out: *mut *mut AllJoynBusAttachment) -> HRESULT
}}
impl IAllJoynBusAttachmentFactory {
    #[inline] pub unsafe fn create(&self, connectionSpecification: &HStringArg) -> Result<ComPtr<AllJoynBusAttachment>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, connectionSpecification.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynSession, 3906018060, 49364, 16492, 136, 169, 169, 62, 250, 133, 212, 177);
RT_INTERFACE!{interface IAllJoynSession(IAllJoynSessionVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynSession] {
    fn get_Id(&self, out: *mut i32) -> HRESULT,
    fn get_Status(&self, out: *mut i32) -> HRESULT,
    fn RemoveMemberAsync(&self, uniqueName: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<i32>) -> HRESULT,
    fn add_MemberAdded(&self, handler: *mut super::super::foundation::TypedEventHandler<AllJoynSession, AllJoynSessionMemberAddedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_MemberAdded(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_MemberRemoved(&self, handler: *mut super::super::foundation::TypedEventHandler<AllJoynSession, AllJoynSessionMemberRemovedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_MemberRemoved(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_Lost(&self, handler: *mut super::super::foundation::TypedEventHandler<AllJoynSession, AllJoynSessionLostEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Lost(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IAllJoynSession {
    #[inline] pub unsafe fn get_id(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_member_async(&self, uniqueName: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<i32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RemoveMemberAsync)(self as *const _ as *mut _, uniqueName.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_member_added(&self, handler: &super::super::foundation::TypedEventHandler<AllJoynSession, AllJoynSessionMemberAddedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_MemberAdded)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_member_added(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_MemberAdded)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_member_removed(&self, handler: &super::super::foundation::TypedEventHandler<AllJoynSession, AllJoynSessionMemberRemovedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_MemberRemoved)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_member_removed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_MemberRemoved)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_lost(&self, handler: &super::super::foundation::TypedEventHandler<AllJoynSession, AllJoynSessionLostEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Lost)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_lost(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Lost)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class AllJoynSession: IAllJoynSession}
impl RtActivatable<IAllJoynSessionStatics> for AllJoynSession {}
impl AllJoynSession {
    #[inline] pub fn get_from_service_info_async(serviceInfo: &AllJoynServiceInfo) -> Result<ComPtr<super::super::foundation::IAsyncOperation<AllJoynSession>>> { unsafe {
        <Self as RtActivatable<IAllJoynSessionStatics>>::get_activation_factory().get_from_service_info_async(serviceInfo)
    }}
    #[inline] pub fn get_from_service_info_and_bus_attachment_async(serviceInfo: &AllJoynServiceInfo, busAttachment: &AllJoynBusAttachment) -> Result<ComPtr<super::super::foundation::IAsyncOperation<AllJoynSession>>> { unsafe {
        <Self as RtActivatable<IAllJoynSessionStatics>>::get_activation_factory().get_from_service_info_and_bus_attachment_async(serviceInfo, busAttachment)
    }}
}
DEFINE_CLSID!(AllJoynSession(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,83,101,115,115,105,111,110,0]) [CLSID_AllJoynSession]);
RT_CLASS!{class AllJoynSessionMemberAddedEventArgs: IAllJoynSessionMemberAddedEventArgs}
impl RtActivatable<IAllJoynSessionMemberAddedEventArgsFactory> for AllJoynSessionMemberAddedEventArgs {}
impl AllJoynSessionMemberAddedEventArgs {
    #[inline] pub fn create(uniqueName: &HStringArg) -> Result<ComPtr<AllJoynSessionMemberAddedEventArgs>> { unsafe {
        <Self as RtActivatable<IAllJoynSessionMemberAddedEventArgsFactory>>::get_activation_factory().create(uniqueName)
    }}
}
DEFINE_CLSID!(AllJoynSessionMemberAddedEventArgs(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,83,101,115,115,105,111,110,77,101,109,98,101,114,65,100,100,101,100,69,118,101,110,116,65,114,103,115,0]) [CLSID_AllJoynSessionMemberAddedEventArgs]);
RT_CLASS!{class AllJoynSessionMemberRemovedEventArgs: IAllJoynSessionMemberRemovedEventArgs}
impl RtActivatable<IAllJoynSessionMemberRemovedEventArgsFactory> for AllJoynSessionMemberRemovedEventArgs {}
impl AllJoynSessionMemberRemovedEventArgs {
    #[inline] pub fn create(uniqueName: &HStringArg) -> Result<ComPtr<AllJoynSessionMemberRemovedEventArgs>> { unsafe {
        <Self as RtActivatable<IAllJoynSessionMemberRemovedEventArgsFactory>>::get_activation_factory().create(uniqueName)
    }}
}
DEFINE_CLSID!(AllJoynSessionMemberRemovedEventArgs(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,83,101,115,115,105,111,110,77,101,109,98,101,114,82,101,109,111,118,101,100,69,118,101,110,116,65,114,103,115,0]) [CLSID_AllJoynSessionMemberRemovedEventArgs]);
RT_CLASS!{class AllJoynSessionLostEventArgs: IAllJoynSessionLostEventArgs}
impl RtActivatable<IAllJoynSessionLostEventArgsFactory> for AllJoynSessionLostEventArgs {}
impl AllJoynSessionLostEventArgs {
    #[inline] pub fn create(reason: AllJoynSessionLostReason) -> Result<ComPtr<AllJoynSessionLostEventArgs>> { unsafe {
        <Self as RtActivatable<IAllJoynSessionLostEventArgsFactory>>::get_activation_factory().create(reason)
    }}
}
DEFINE_CLSID!(AllJoynSessionLostEventArgs(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,83,101,115,115,105,111,110,76,111,115,116,69,118,101,110,116,65,114,103,115,0]) [CLSID_AllJoynSessionLostEventArgs]);
DEFINE_IID!(IID_IAllJoynSessionStatics, 2651182596, 41068, 18132, 180, 108, 11, 11, 84, 16, 91, 68);
RT_INTERFACE!{static interface IAllJoynSessionStatics(IAllJoynSessionStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynSessionStatics] {
    fn GetFromServiceInfoAsync(&self, serviceInfo: *mut AllJoynServiceInfo, out: *mut *mut super::super::foundation::IAsyncOperation<AllJoynSession>) -> HRESULT,
    fn GetFromServiceInfoAndBusAttachmentAsync(&self, serviceInfo: *mut AllJoynServiceInfo, busAttachment: *mut AllJoynBusAttachment, out: *mut *mut super::super::foundation::IAsyncOperation<AllJoynSession>) -> HRESULT
}}
impl IAllJoynSessionStatics {
    #[inline] pub unsafe fn get_from_service_info_async(&self, serviceInfo: &AllJoynServiceInfo) -> Result<ComPtr<super::super::foundation::IAsyncOperation<AllJoynSession>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetFromServiceInfoAsync)(self as *const _ as *mut _, serviceInfo as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_from_service_info_and_bus_attachment_async(&self, serviceInfo: &AllJoynServiceInfo, busAttachment: &AllJoynBusAttachment) -> Result<ComPtr<super::super::foundation::IAsyncOperation<AllJoynSession>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetFromServiceInfoAndBusAttachmentAsync)(self as *const _ as *mut _, serviceInfo as *const _ as *mut _, busAttachment as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynProducer, 2634565241, 18075, 18778, 167, 16, 172, 80, 241, 35, 6, 159);
RT_INTERFACE!{interface IAllJoynProducer(IAllJoynProducerVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynProducer] {
    fn SetBusObject(&self, busObject: *mut AllJoynBusObject) -> HRESULT
}}
impl IAllJoynProducer {
    #[inline] pub unsafe fn set_bus_object(&self, busObject: &AllJoynBusObject) -> Result<()> {
        let hr = ((*self.lpVtbl).SetBusObject)(self as *const _ as *mut _, busObject as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class AllJoynBusObject: IAllJoynBusObject}
impl RtActivatable<IAllJoynBusObjectFactory> for AllJoynBusObject {}
impl RtActivatable<IActivationFactory> for AllJoynBusObject {}
impl AllJoynBusObject {
    #[inline] pub fn create(objectPath: &HStringArg) -> Result<ComPtr<AllJoynBusObject>> { unsafe {
        <Self as RtActivatable<IAllJoynBusObjectFactory>>::get_activation_factory().create(objectPath)
    }}
    #[inline] pub fn create_with_bus_attachment(objectPath: &HStringArg, busAttachment: &AllJoynBusAttachment) -> Result<ComPtr<AllJoynBusObject>> { unsafe {
        <Self as RtActivatable<IAllJoynBusObjectFactory>>::get_activation_factory().create_with_bus_attachment(objectPath, busAttachment)
    }}
}
DEFINE_CLSID!(AllJoynBusObject(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,66,117,115,79,98,106,101,99,116,0]) [CLSID_AllJoynBusObject]);
DEFINE_IID!(IID_IAllJoynBusObject, 3908928094, 63290, 18700, 136, 4, 4, 224, 38, 100, 48, 71);
RT_INTERFACE!{interface IAllJoynBusObject(IAllJoynBusObjectVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynBusObject] {
    fn Start(&self) -> HRESULT,
    fn Stop(&self) -> HRESULT,
    fn AddProducer(&self, producer: *mut IAllJoynProducer) -> HRESULT,
    fn get_BusAttachment(&self, out: *mut *mut AllJoynBusAttachment) -> HRESULT,
    fn get_Session(&self, out: *mut *mut AllJoynSession) -> HRESULT,
    fn add_Stopped(&self, handler: *mut super::super::foundation::TypedEventHandler<AllJoynBusObject, AllJoynBusObjectStoppedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Stopped(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IAllJoynBusObject {
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Stop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_producer(&self, producer: &IAllJoynProducer) -> Result<()> {
        let hr = ((*self.lpVtbl).AddProducer)(self as *const _ as *mut _, producer as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bus_attachment(&self) -> Result<ComPtr<AllJoynBusAttachment>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BusAttachment)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_session(&self) -> Result<ComPtr<AllJoynSession>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Session)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_stopped(&self, handler: &super::super::foundation::TypedEventHandler<AllJoynBusObject, AllJoynBusObjectStoppedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Stopped)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_stopped(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Stopped)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class AllJoynBusObjectStoppedEventArgs: IAllJoynBusObjectStoppedEventArgs}
impl RtActivatable<IAllJoynBusObjectStoppedEventArgsFactory> for AllJoynBusObjectStoppedEventArgs {}
impl AllJoynBusObjectStoppedEventArgs {
    #[inline] pub fn create(status: i32) -> Result<ComPtr<AllJoynBusObjectStoppedEventArgs>> { unsafe {
        <Self as RtActivatable<IAllJoynBusObjectStoppedEventArgsFactory>>::get_activation_factory().create(status)
    }}
}
DEFINE_CLSID!(AllJoynBusObjectStoppedEventArgs(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,66,117,115,79,98,106,101,99,116,83,116,111,112,112,101,100,69,118,101,110,116,65,114,103,115,0]) [CLSID_AllJoynBusObjectStoppedEventArgs]);
DEFINE_IID!(IID_IAllJoynBusObjectFactory, 741318411, 36354, 20380, 172, 39, 234, 109, 173, 93, 59, 80);
RT_INTERFACE!{static interface IAllJoynBusObjectFactory(IAllJoynBusObjectFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynBusObjectFactory] {
    fn Create(&self, objectPath: HSTRING, out: *mut *mut AllJoynBusObject) -> HRESULT,
    fn CreateWithBusAttachment(&self, objectPath: HSTRING, busAttachment: *mut AllJoynBusAttachment, out: *mut *mut AllJoynBusObject) -> HRESULT
}}
impl IAllJoynBusObjectFactory {
    #[inline] pub unsafe fn create(&self, objectPath: &HStringArg) -> Result<ComPtr<AllJoynBusObject>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, objectPath.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_with_bus_attachment(&self, objectPath: &HStringArg, busAttachment: &AllJoynBusAttachment) -> Result<ComPtr<AllJoynBusObject>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWithBusAttachment)(self as *const _ as *mut _, objectPath.get(), busAttachment as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynServiceInfo, 1287553545, 47422, 16770, 153, 155, 221, 208, 0, 249, 197, 117);
RT_INTERFACE!{interface IAllJoynServiceInfo(IAllJoynServiceInfoVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynServiceInfo] {
    fn get_UniqueName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ObjectPath(&self, out: *mut HSTRING) -> HRESULT,
    fn get_SessionPort(&self, out: *mut u16) -> HRESULT
}}
impl IAllJoynServiceInfo {
    #[inline] pub unsafe fn get_unique_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_UniqueName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_object_path(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ObjectPath)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_session_port(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SessionPort)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynServiceInfoStatics, 1450727178, 24634, 18940, 183, 80, 14, 241, 54, 9, 33, 60);
RT_INTERFACE!{static interface IAllJoynServiceInfoStatics(IAllJoynServiceInfoStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynServiceInfoStatics] {
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<AllJoynServiceInfo>) -> HRESULT
}}
impl IAllJoynServiceInfoStatics {
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<AllJoynServiceInfo>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynServiceInfoFactory, 1971444413, 65027, 20299, 148, 164, 240, 47, 220, 189, 17, 184);
RT_INTERFACE!{static interface IAllJoynServiceInfoFactory(IAllJoynServiceInfoFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynServiceInfoFactory] {
    fn Create(&self, uniqueName: HSTRING, objectPath: HSTRING, sessionPort: u16, out: *mut *mut AllJoynServiceInfo) -> HRESULT
}}
impl IAllJoynServiceInfoFactory {
    #[inline] pub unsafe fn create(&self, uniqueName: &HStringArg, objectPath: &HStringArg, sessionPort: u16) -> Result<ComPtr<AllJoynServiceInfo>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, uniqueName.get(), objectPath.get(), sessionPort, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynAboutDataViewStatics, 1475196552, 3166, 16750, 136, 181, 57, 179, 45, 37, 196, 125);
RT_INTERFACE!{static interface IAllJoynAboutDataViewStatics(IAllJoynAboutDataViewStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynAboutDataViewStatics] {
    fn GetDataBySessionPortAsync(&self, uniqueName: HSTRING, busAttachment: *mut AllJoynBusAttachment, sessionPort: u16, out: *mut *mut super::super::foundation::IAsyncOperation<AllJoynAboutDataView>) -> HRESULT,
    #[cfg(feature="windows-globalization")] fn GetDataBySessionPortWithLanguageAsync(&self, uniqueName: HSTRING, busAttachment: *mut AllJoynBusAttachment, sessionPort: u16, language: *mut super::super::globalization::Language, out: *mut *mut super::super::foundation::IAsyncOperation<AllJoynAboutDataView>) -> HRESULT
}}
impl IAllJoynAboutDataViewStatics {
    #[inline] pub unsafe fn get_data_by_session_port_async(&self, uniqueName: &HStringArg, busAttachment: &AllJoynBusAttachment, sessionPort: u16) -> Result<ComPtr<super::super::foundation::IAsyncOperation<AllJoynAboutDataView>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDataBySessionPortAsync)(self as *const _ as *mut _, uniqueName.get(), busAttachment as *const _ as *mut _, sessionPort, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-globalization")] #[inline] pub unsafe fn get_data_by_session_port_with_language_async(&self, uniqueName: &HStringArg, busAttachment: &AllJoynBusAttachment, sessionPort: u16, language: &super::super::globalization::Language) -> Result<ComPtr<super::super::foundation::IAsyncOperation<AllJoynAboutDataView>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDataBySessionPortWithLanguageAsync)(self as *const _ as *mut _, uniqueName.get(), busAttachment as *const _ as *mut _, sessionPort, language as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynAboutDataView, 1747128607, 25106, 18740, 156, 72, 225, 156, 164, 152, 66, 136);
RT_INTERFACE!{interface IAllJoynAboutDataView(IAllJoynAboutDataViewVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynAboutDataView] {
    fn get_Status(&self, out: *mut i32) -> HRESULT,
    fn get_Properties(&self, out: *mut *mut super::super::foundation::collections::IMapView<HString, IInspectable>) -> HRESULT,
    fn get_AJSoftwareVersion(&self, out: *mut HSTRING) -> HRESULT,
    fn get_AppId(&self, out: *mut Guid) -> HRESULT,
    fn get_DateOfManufacture(&self, out: *mut *mut super::super::foundation::IReference<super::super::foundation::DateTime>) -> HRESULT,
    #[cfg(not(feature="windows-globalization"))] fn __Dummy5(&self) -> (),
    #[cfg(feature="windows-globalization")] fn get_DefaultLanguage(&self, out: *mut *mut super::super::globalization::Language) -> HRESULT,
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_HardwareVersion(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ModelNumber(&self, out: *mut HSTRING) -> HRESULT,
    fn get_SoftwareVersion(&self, out: *mut HSTRING) -> HRESULT,
    #[cfg(not(feature="windows-globalization"))] fn __Dummy10(&self) -> (),
    #[cfg(feature="windows-globalization")] fn get_SupportedLanguages(&self, out: *mut *mut super::super::foundation::collections::IVectorView<super::super::globalization::Language>) -> HRESULT,
    fn get_SupportUrl(&self, out: *mut *mut super::super::foundation::Uri) -> HRESULT,
    fn get_AppName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Description(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DeviceName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Manufacturer(&self, out: *mut HSTRING) -> HRESULT
}}
impl IAllJoynAboutDataView {
    #[inline] pub unsafe fn get_status(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_properties(&self) -> Result<ComPtr<super::super::foundation::collections::IMapView<HString, IInspectable>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Properties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ajsoftware_version(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AJSoftwareVersion)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_app_id(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AppId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_date_of_manufacture(&self) -> Result<ComPtr<super::super::foundation::IReference<super::super::foundation::DateTime>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DateOfManufacture)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-globalization")] #[inline] pub unsafe fn get_default_language(&self) -> Result<ComPtr<super::super::globalization::Language>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DefaultLanguage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_hardware_version(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_HardwareVersion)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_model_number(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ModelNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_software_version(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SoftwareVersion)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-globalization")] #[inline] pub unsafe fn get_supported_languages(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<super::super::globalization::Language>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedLanguages)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_support_url(&self) -> Result<ComPtr<super::super::foundation::Uri>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportUrl)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_app_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AppName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_description(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Description)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_manufacturer(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Manufacturer)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynAboutData, 3853106944, 8098, 18489, 147, 239, 249, 223, 64, 72, 144, 247);
RT_INTERFACE!{interface IAllJoynAboutData(IAllJoynAboutDataVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynAboutData] {
    fn get_IsEnabled(&self, out: *mut bool) -> HRESULT,
    fn put_IsEnabled(&self, value: bool) -> HRESULT,
    fn get_DefaultAppName(&self, out: *mut HSTRING) -> HRESULT,
    fn put_DefaultAppName(&self, value: HSTRING) -> HRESULT,
    fn get_AppNames(&self, out: *mut *mut super::super::foundation::collections::IMap<HString, HString>) -> HRESULT,
    fn get_DateOfManufacture(&self, out: *mut *mut super::super::foundation::IReference<super::super::foundation::DateTime>) -> HRESULT,
    fn put_DateOfManufacture(&self, value: *mut super::super::foundation::IReference<super::super::foundation::DateTime>) -> HRESULT,
    fn get_DefaultDescription(&self, out: *mut HSTRING) -> HRESULT,
    fn put_DefaultDescription(&self, value: HSTRING) -> HRESULT,
    fn get_Descriptions(&self, out: *mut *mut super::super::foundation::collections::IMap<HString, HString>) -> HRESULT,
    fn get_DefaultManufacturer(&self, out: *mut HSTRING) -> HRESULT,
    fn put_DefaultManufacturer(&self, value: HSTRING) -> HRESULT,
    fn get_Manufacturers(&self, out: *mut *mut super::super::foundation::collections::IMap<HString, HString>) -> HRESULT,
    fn get_ModelNumber(&self, out: *mut HSTRING) -> HRESULT,
    fn put_ModelNumber(&self, value: HSTRING) -> HRESULT,
    fn get_SoftwareVersion(&self, out: *mut HSTRING) -> HRESULT,
    fn put_SoftwareVersion(&self, value: HSTRING) -> HRESULT,
    fn get_SupportUrl(&self, out: *mut *mut super::super::foundation::Uri) -> HRESULT,
    fn put_SupportUrl(&self, value: *mut super::super::foundation::Uri) -> HRESULT,
    fn get_AppId(&self, out: *mut Guid) -> HRESULT,
    fn put_AppId(&self, value: Guid) -> HRESULT
}}
impl IAllJoynAboutData {
    #[inline] pub unsafe fn get_is_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_enabled(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsEnabled)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_app_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DefaultAppName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_default_app_name(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DefaultAppName)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_app_names(&self) -> Result<ComPtr<super::super::foundation::collections::IMap<HString, HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AppNames)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_date_of_manufacture(&self) -> Result<ComPtr<super::super::foundation::IReference<super::super::foundation::DateTime>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DateOfManufacture)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_date_of_manufacture(&self, value: &super::super::foundation::IReference<super::super::foundation::DateTime>) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DateOfManufacture)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_description(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DefaultDescription)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_default_description(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DefaultDescription)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_descriptions(&self) -> Result<ComPtr<super::super::foundation::collections::IMap<HString, HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Descriptions)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_manufacturer(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DefaultManufacturer)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_default_manufacturer(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DefaultManufacturer)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_manufacturers(&self) -> Result<ComPtr<super::super::foundation::collections::IMap<HString, HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Manufacturers)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_model_number(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ModelNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_model_number(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ModelNumber)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_software_version(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SoftwareVersion)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_software_version(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SoftwareVersion)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_support_url(&self) -> Result<ComPtr<super::super::foundation::Uri>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportUrl)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_support_url(&self, value: &super::super::foundation::Uri) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SupportUrl)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_app_id(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AppId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_app_id(&self, value: Guid) -> Result<()> {
        let hr = ((*self.lpVtbl).put_AppId)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_ENUM! { enum AllJoynTrafficType: i32 {
    Unknown (AllJoynTrafficType_Unknown) = 0, Messages (AllJoynTrafficType_Messages) = 1, RawUnreliable (AllJoynTrafficType_RawUnreliable) = 2, RawReliable (AllJoynTrafficType_RawReliable) = 4,
}}
DEFINE_IID!(IID_IAllJoynAcceptSessionJoinerEventArgs, 1325093733, 16010, 16983, 143, 16, 83, 156, 224, 213, 108, 15);
RT_INTERFACE!{interface IAllJoynAcceptSessionJoinerEventArgs(IAllJoynAcceptSessionJoinerEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynAcceptSessionJoinerEventArgs] {
    fn get_UniqueName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_SessionPort(&self, out: *mut u16) -> HRESULT,
    fn get_TrafficType(&self, out: *mut AllJoynTrafficType) -> HRESULT,
    fn get_SamePhysicalNode(&self, out: *mut bool) -> HRESULT,
    fn get_SameNetwork(&self, out: *mut bool) -> HRESULT,
    fn Accept(&self) -> HRESULT
}}
impl IAllJoynAcceptSessionJoinerEventArgs {
    #[inline] pub unsafe fn get_unique_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_UniqueName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_session_port(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SessionPort)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_traffic_type(&self) -> Result<AllJoynTrafficType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TrafficType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_same_physical_node(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SamePhysicalNode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_same_network(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SameNetwork)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn accept(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Accept)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynAcceptSessionJoiner, 1302861778, 52509, 16419, 167, 196, 22, 222, 248, 156, 40, 223);
RT_INTERFACE!{interface IAllJoynAcceptSessionJoiner(IAllJoynAcceptSessionJoinerVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynAcceptSessionJoiner] {
    fn Accept(&self) -> HRESULT
}}
impl IAllJoynAcceptSessionJoiner {
    #[inline] pub unsafe fn accept(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Accept)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynAcceptSessionJoinerEventArgsFactory, 3024313280, 24901, 17054, 132, 219, 213, 191, 231, 114, 177, 79);
RT_INTERFACE!{static interface IAllJoynAcceptSessionJoinerEventArgsFactory(IAllJoynAcceptSessionJoinerEventArgsFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynAcceptSessionJoinerEventArgsFactory] {
    fn Create(&self, uniqueName: HSTRING, sessionPort: u16, trafficType: AllJoynTrafficType, proximity: u8, acceptSessionJoiner: *mut IAllJoynAcceptSessionJoiner, out: *mut *mut AllJoynAcceptSessionJoinerEventArgs) -> HRESULT
}}
impl IAllJoynAcceptSessionJoinerEventArgsFactory {
    #[inline] pub unsafe fn create(&self, uniqueName: &HStringArg, sessionPort: u16, trafficType: AllJoynTrafficType, proximity: u8, acceptSessionJoiner: &IAllJoynAcceptSessionJoiner) -> Result<ComPtr<AllJoynAcceptSessionJoinerEventArgs>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, uniqueName.get(), sessionPort, trafficType, proximity, acceptSessionJoiner as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynSessionMemberAddedEventArgs, 1235384714, 3537, 18113, 156, 214, 39, 25, 14, 80, 58, 94);
RT_INTERFACE!{interface IAllJoynSessionMemberAddedEventArgs(IAllJoynSessionMemberAddedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynSessionMemberAddedEventArgs] {
    fn get_UniqueName(&self, out: *mut HSTRING) -> HRESULT
}}
impl IAllJoynSessionMemberAddedEventArgs {
    #[inline] pub unsafe fn get_unique_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_UniqueName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynSessionMemberAddedEventArgsFactory, 874373970, 7475, 16545, 161, 211, 229, 119, 112, 32, 225, 241);
RT_INTERFACE!{static interface IAllJoynSessionMemberAddedEventArgsFactory(IAllJoynSessionMemberAddedEventArgsFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynSessionMemberAddedEventArgsFactory] {
    fn Create(&self, uniqueName: HSTRING, out: *mut *mut AllJoynSessionMemberAddedEventArgs) -> HRESULT
}}
impl IAllJoynSessionMemberAddedEventArgsFactory {
    #[inline] pub unsafe fn create(&self, uniqueName: &HStringArg) -> Result<ComPtr<AllJoynSessionMemberAddedEventArgs>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, uniqueName.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynSessionMemberRemovedEventArgs, 1083842975, 43594, 18579, 180, 48, 186, 161, 182, 60, 98, 25);
RT_INTERFACE!{interface IAllJoynSessionMemberRemovedEventArgs(IAllJoynSessionMemberRemovedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynSessionMemberRemovedEventArgs] {
    fn get_UniqueName(&self, out: *mut HSTRING) -> HRESULT
}}
impl IAllJoynSessionMemberRemovedEventArgs {
    #[inline] pub unsafe fn get_unique_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_UniqueName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynSessionMemberRemovedEventArgsFactory, 3302184424, 17080, 19303, 183, 87, 208, 207, 202, 213, 146, 128);
RT_INTERFACE!{static interface IAllJoynSessionMemberRemovedEventArgsFactory(IAllJoynSessionMemberRemovedEventArgsFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynSessionMemberRemovedEventArgsFactory] {
    fn Create(&self, uniqueName: HSTRING, out: *mut *mut AllJoynSessionMemberRemovedEventArgs) -> HRESULT
}}
impl IAllJoynSessionMemberRemovedEventArgsFactory {
    #[inline] pub unsafe fn create(&self, uniqueName: &HStringArg) -> Result<ComPtr<AllJoynSessionMemberRemovedEventArgs>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, uniqueName.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_ENUM! { enum AllJoynSessionLostReason: i32 {
    None (AllJoynSessionLostReason_None) = 0, ProducerLeftSession (AllJoynSessionLostReason_ProducerLeftSession) = 1, ProducerClosedAbruptly (AllJoynSessionLostReason_ProducerClosedAbruptly) = 2, RemovedByProducer (AllJoynSessionLostReason_RemovedByProducer) = 3, LinkTimeout (AllJoynSessionLostReason_LinkTimeout) = 4, Other (AllJoynSessionLostReason_Other) = 5,
}}
DEFINE_IID!(IID_IAllJoynSessionJoinedEventArgs, 2661243856, 46551, 18373, 141, 171, 176, 64, 204, 25, 40, 113);
RT_INTERFACE!{interface IAllJoynSessionJoinedEventArgs(IAllJoynSessionJoinedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynSessionJoinedEventArgs] {
    fn get_Session(&self, out: *mut *mut AllJoynSession) -> HRESULT
}}
impl IAllJoynSessionJoinedEventArgs {
    #[inline] pub unsafe fn get_session(&self) -> Result<ComPtr<AllJoynSession>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Session)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynSessionJoinedEventArgsFactory, 1747244681, 54987, 19870, 160, 158, 53, 128, 104, 112, 177, 127);
RT_INTERFACE!{static interface IAllJoynSessionJoinedEventArgsFactory(IAllJoynSessionJoinedEventArgsFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynSessionJoinedEventArgsFactory] {
    fn Create(&self, session: *mut AllJoynSession, out: *mut *mut AllJoynSessionJoinedEventArgs) -> HRESULT
}}
impl IAllJoynSessionJoinedEventArgsFactory {
    #[inline] pub unsafe fn create(&self, session: &AllJoynSession) -> Result<ComPtr<AllJoynSessionJoinedEventArgs>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, session as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynSessionLostEventArgs, 3882263690, 35768, 18772, 174, 103, 210, 250, 67, 209, 249, 107);
RT_INTERFACE!{interface IAllJoynSessionLostEventArgs(IAllJoynSessionLostEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynSessionLostEventArgs] {
    fn get_Reason(&self, out: *mut AllJoynSessionLostReason) -> HRESULT
}}
impl IAllJoynSessionLostEventArgs {
    #[inline] pub unsafe fn get_reason(&self) -> Result<AllJoynSessionLostReason> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Reason)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynSessionLostEventArgsFactory, 331087154, 54004, 18889, 152, 14, 40, 5, 225, 53, 134, 177);
RT_INTERFACE!{static interface IAllJoynSessionLostEventArgsFactory(IAllJoynSessionLostEventArgsFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynSessionLostEventArgsFactory] {
    fn Create(&self, reason: AllJoynSessionLostReason, out: *mut *mut AllJoynSessionLostEventArgs) -> HRESULT
}}
impl IAllJoynSessionLostEventArgsFactory {
    #[inline] pub unsafe fn create(&self, reason: AllJoynSessionLostReason) -> Result<ComPtr<AllJoynSessionLostEventArgs>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, reason, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynProducerStoppedEventArgs, 1362138992, 18743, 18733, 128, 128, 35, 100, 57, 152, 124, 235);
RT_INTERFACE!{interface IAllJoynProducerStoppedEventArgs(IAllJoynProducerStoppedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynProducerStoppedEventArgs] {
    fn get_Status(&self, out: *mut i32) -> HRESULT
}}
impl IAllJoynProducerStoppedEventArgs {
    #[inline] pub unsafe fn get_status(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynProducerStoppedEventArgsFactory, 1448253793, 45593, 19822, 159, 120, 250, 63, 153, 250, 143, 229);
RT_INTERFACE!{static interface IAllJoynProducerStoppedEventArgsFactory(IAllJoynProducerStoppedEventArgsFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynProducerStoppedEventArgsFactory] {
    fn Create(&self, status: i32, out: *mut *mut AllJoynProducerStoppedEventArgs) -> HRESULT
}}
impl IAllJoynProducerStoppedEventArgsFactory {
    #[inline] pub unsafe fn create(&self, status: i32) -> Result<ComPtr<AllJoynProducerStoppedEventArgs>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, status, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class AllJoynProducerStoppedEventArgs: IAllJoynProducerStoppedEventArgs}
impl RtActivatable<IAllJoynProducerStoppedEventArgsFactory> for AllJoynProducerStoppedEventArgs {}
impl AllJoynProducerStoppedEventArgs {
    #[inline] pub fn create(status: i32) -> Result<ComPtr<AllJoynProducerStoppedEventArgs>> { unsafe {
        <Self as RtActivatable<IAllJoynProducerStoppedEventArgsFactory>>::get_activation_factory().create(status)
    }}
}
DEFINE_CLSID!(AllJoynProducerStoppedEventArgs(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,80,114,111,100,117,99,101,114,83,116,111,112,112,101,100,69,118,101,110,116,65,114,103,115,0]) [CLSID_AllJoynProducerStoppedEventArgs]);
DEFINE_IID!(IID_IAllJoynBusObjectStoppedEventArgs, 3725598997, 61326, 19778, 185, 59, 162, 174, 116, 81, 151, 102);
RT_INTERFACE!{interface IAllJoynBusObjectStoppedEventArgs(IAllJoynBusObjectStoppedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynBusObjectStoppedEventArgs] {
    fn get_Status(&self, out: *mut i32) -> HRESULT
}}
impl IAllJoynBusObjectStoppedEventArgs {
    #[inline] pub unsafe fn get_status(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynBusObjectStoppedEventArgsFactory, 1797455176, 53411, 16981, 149, 58, 71, 114, 180, 2, 128, 115);
RT_INTERFACE!{static interface IAllJoynBusObjectStoppedEventArgsFactory(IAllJoynBusObjectStoppedEventArgsFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynBusObjectStoppedEventArgsFactory] {
    fn Create(&self, status: i32, out: *mut *mut AllJoynBusObjectStoppedEventArgs) -> HRESULT
}}
impl IAllJoynBusObjectStoppedEventArgsFactory {
    #[inline] pub unsafe fn create(&self, status: i32) -> Result<ComPtr<AllJoynBusObjectStoppedEventArgs>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, status, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynWatcherStoppedEventArgs, 3388776507, 28701, 19112, 151, 221, 162, 187, 10, 143, 95, 163);
RT_INTERFACE!{interface IAllJoynWatcherStoppedEventArgs(IAllJoynWatcherStoppedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynWatcherStoppedEventArgs] {
    fn get_Status(&self, out: *mut i32) -> HRESULT
}}
impl IAllJoynWatcherStoppedEventArgs {
    #[inline] pub unsafe fn get_status(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynWatcherStoppedEventArgsFactory, 2274338216, 11600, 18401, 144, 74, 32, 191, 13, 72, 199, 130);
RT_INTERFACE!{static interface IAllJoynWatcherStoppedEventArgsFactory(IAllJoynWatcherStoppedEventArgsFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynWatcherStoppedEventArgsFactory] {
    fn Create(&self, status: i32, out: *mut *mut AllJoynWatcherStoppedEventArgs) -> HRESULT
}}
impl IAllJoynWatcherStoppedEventArgsFactory {
    #[inline] pub unsafe fn create(&self, status: i32) -> Result<ComPtr<AllJoynWatcherStoppedEventArgs>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, status, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class AllJoynWatcherStoppedEventArgs: IAllJoynWatcherStoppedEventArgs}
impl RtActivatable<IAllJoynWatcherStoppedEventArgsFactory> for AllJoynWatcherStoppedEventArgs {}
impl AllJoynWatcherStoppedEventArgs {
    #[inline] pub fn create(status: i32) -> Result<ComPtr<AllJoynWatcherStoppedEventArgs>> { unsafe {
        <Self as RtActivatable<IAllJoynWatcherStoppedEventArgsFactory>>::get_activation_factory().create(status)
    }}
}
DEFINE_CLSID!(AllJoynWatcherStoppedEventArgs(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,87,97,116,99,104,101,114,83,116,111,112,112,101,100,69,118,101,110,116,65,114,103,115,0]) [CLSID_AllJoynWatcherStoppedEventArgs]);
DEFINE_IID!(IID_IAllJoynServiceInfoRemovedEventArgs, 811051359, 7487, 16883, 137, 105, 227, 39, 146, 98, 115, 150);
RT_INTERFACE!{interface IAllJoynServiceInfoRemovedEventArgs(IAllJoynServiceInfoRemovedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynServiceInfoRemovedEventArgs] {
    fn get_UniqueName(&self, out: *mut HSTRING) -> HRESULT
}}
impl IAllJoynServiceInfoRemovedEventArgs {
    #[inline] pub unsafe fn get_unique_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_UniqueName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynServiceInfoRemovedEventArgsFactory, 230655527, 39679, 18773, 146, 39, 105, 83, 186, 244, 21, 105);
RT_INTERFACE!{static interface IAllJoynServiceInfoRemovedEventArgsFactory(IAllJoynServiceInfoRemovedEventArgsFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynServiceInfoRemovedEventArgsFactory] {
    fn Create(&self, uniqueName: HSTRING, out: *mut *mut AllJoynServiceInfoRemovedEventArgs) -> HRESULT
}}
impl IAllJoynServiceInfoRemovedEventArgsFactory {
    #[inline] pub unsafe fn create(&self, uniqueName: &HStringArg) -> Result<ComPtr<AllJoynServiceInfoRemovedEventArgs>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, uniqueName.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class AllJoynServiceInfoRemovedEventArgs: IAllJoynServiceInfoRemovedEventArgs}
impl RtActivatable<IAllJoynServiceInfoRemovedEventArgsFactory> for AllJoynServiceInfoRemovedEventArgs {}
impl AllJoynServiceInfoRemovedEventArgs {
    #[inline] pub fn create(uniqueName: &HStringArg) -> Result<ComPtr<AllJoynServiceInfoRemovedEventArgs>> { unsafe {
        <Self as RtActivatable<IAllJoynServiceInfoRemovedEventArgsFactory>>::get_activation_factory().create(uniqueName)
    }}
}
DEFINE_CLSID!(AllJoynServiceInfoRemovedEventArgs(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,83,101,114,118,105,99,101,73,110,102,111,82,101,109,111,118,101,100,69,118,101,110,116,65,114,103,115,0]) [CLSID_AllJoynServiceInfoRemovedEventArgs]);
DEFINE_IID!(IID_IAllJoynMessageInfo, 4281008423, 11282, 18521, 170, 58, 199, 68, 97, 238, 129, 76);
RT_INTERFACE!{interface IAllJoynMessageInfo(IAllJoynMessageInfoVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynMessageInfo] {
    fn get_SenderUniqueName(&self, out: *mut HSTRING) -> HRESULT
}}
impl IAllJoynMessageInfo {
    #[inline] pub unsafe fn get_sender_unique_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SenderUniqueName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAllJoynMessageInfoFactory, 879119402, 33417, 17364, 180, 168, 63, 77, 227, 89, 240, 67);
RT_INTERFACE!{static interface IAllJoynMessageInfoFactory(IAllJoynMessageInfoFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IAllJoynMessageInfoFactory] {
    fn Create(&self, senderUniqueName: HSTRING, out: *mut *mut AllJoynMessageInfo) -> HRESULT
}}
impl IAllJoynMessageInfoFactory {
    #[inline] pub unsafe fn create(&self, senderUniqueName: &HStringArg) -> Result<ComPtr<AllJoynMessageInfo>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, senderUniqueName.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class AllJoynMessageInfo: IAllJoynMessageInfo}
impl RtActivatable<IAllJoynMessageInfoFactory> for AllJoynMessageInfo {}
impl AllJoynMessageInfo {
    #[inline] pub fn create(senderUniqueName: &HStringArg) -> Result<ComPtr<AllJoynMessageInfo>> { unsafe {
        <Self as RtActivatable<IAllJoynMessageInfoFactory>>::get_activation_factory().create(senderUniqueName)
    }}
}
DEFINE_CLSID!(AllJoynMessageInfo(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,65,108,108,74,111,121,110,46,65,108,108,74,111,121,110,77,101,115,115,97,103,101,73,110,102,111,0]) [CLSID_AllJoynMessageInfo]);
} // Windows.Devices.AllJoyn
pub mod background { // Windows.Devices.Background
use ::prelude::*;
DEFINE_IID!(IID_IDeviceUseDetails, 2102808897, 21886, 16724, 185, 148, 228, 247, 161, 31, 179, 35);
RT_INTERFACE!{interface IDeviceUseDetails(IDeviceUseDetailsVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceUseDetails] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Arguments(&self, out: *mut HSTRING) -> HRESULT
}}
impl IDeviceUseDetails {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_arguments(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Arguments)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class DeviceUseDetails: IDeviceUseDetails}
DEFINE_IID!(IID_IDeviceServicingDetails, 1252781609, 9028, 19140, 133, 39, 74, 142, 246, 144, 86, 69);
RT_INTERFACE!{interface IDeviceServicingDetails(IDeviceServicingDetailsVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceServicingDetails] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Arguments(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ExpectedDuration(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT
}}
impl IDeviceServicingDetails {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_arguments(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Arguments)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_expected_duration(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ExpectedDuration)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class DeviceServicingDetails: IDeviceServicingDetails}
} // Windows.Devices.Background
pub mod bluetooth { // Windows.Devices.Bluetooth
use ::prelude::*;
RT_ENUM! { enum BluetoothCacheMode: i32 {
    Cached (BluetoothCacheMode_Cached) = 0, Uncached (BluetoothCacheMode_Uncached) = 1,
}}
RT_ENUM! { enum BluetoothMajorClass: i32 {
    Miscellaneous (BluetoothMajorClass_Miscellaneous) = 0, Computer (BluetoothMajorClass_Computer) = 1, Phone (BluetoothMajorClass_Phone) = 2, NetworkAccessPoint (BluetoothMajorClass_NetworkAccessPoint) = 3, AudioVideo (BluetoothMajorClass_AudioVideo) = 4, Peripheral (BluetoothMajorClass_Peripheral) = 5, Imaging (BluetoothMajorClass_Imaging) = 6, Wearable (BluetoothMajorClass_Wearable) = 7, Toy (BluetoothMajorClass_Toy) = 8, Health (BluetoothMajorClass_Health) = 9,
}}
RT_ENUM! { enum BluetoothMinorClass: i32 {
    Uncategorized (BluetoothMinorClass_Uncategorized) = 0, ComputerDesktop (BluetoothMinorClass_ComputerDesktop) = 1, ComputerServer (BluetoothMinorClass_ComputerServer) = 2, ComputerLaptop (BluetoothMinorClass_ComputerLaptop) = 3, ComputerHandheld (BluetoothMinorClass_ComputerHandheld) = 4, ComputerPalmSize (BluetoothMinorClass_ComputerPalmSize) = 5, ComputerWearable (BluetoothMinorClass_ComputerWearable) = 6, ComputerTablet (BluetoothMinorClass_ComputerTablet) = 7, PhoneCellular (BluetoothMinorClass_PhoneCellular) = 1, PhoneCordless (BluetoothMinorClass_PhoneCordless) = 2, PhoneSmartPhone (BluetoothMinorClass_PhoneSmartPhone) = 3, PhoneWired (BluetoothMinorClass_PhoneWired) = 4, PhoneIsdn (BluetoothMinorClass_PhoneIsdn) = 5, NetworkFullyAvailable (BluetoothMinorClass_NetworkFullyAvailable) = 0, NetworkUsed01To17Percent (BluetoothMinorClass_NetworkUsed01To17Percent) = 8, NetworkUsed17To33Percent (BluetoothMinorClass_NetworkUsed17To33Percent) = 16, NetworkUsed33To50Percent (BluetoothMinorClass_NetworkUsed33To50Percent) = 24, NetworkUsed50To67Percent (BluetoothMinorClass_NetworkUsed50To67Percent) = 32, NetworkUsed67To83Percent (BluetoothMinorClass_NetworkUsed67To83Percent) = 40, NetworkUsed83To99Percent (BluetoothMinorClass_NetworkUsed83To99Percent) = 48, NetworkNoServiceAvailable (BluetoothMinorClass_NetworkNoServiceAvailable) = 56, AudioVideoWearableHeadset (BluetoothMinorClass_AudioVideoWearableHeadset) = 1, AudioVideoHandsFree (BluetoothMinorClass_AudioVideoHandsFree) = 2, AudioVideoMicrophone (BluetoothMinorClass_AudioVideoMicrophone) = 4, AudioVideoLoudspeaker (BluetoothMinorClass_AudioVideoLoudspeaker) = 5, AudioVideoHeadphones (BluetoothMinorClass_AudioVideoHeadphones) = 6, AudioVideoPortableAudio (BluetoothMinorClass_AudioVideoPortableAudio) = 7, AudioVideoCarAudio (BluetoothMinorClass_AudioVideoCarAudio) = 8, AudioVideoSetTopBox (BluetoothMinorClass_AudioVideoSetTopBox) = 9, AudioVideoHifiAudioDevice (BluetoothMinorClass_AudioVideoHifiAudioDevice) = 10, AudioVideoVcr (BluetoothMinorClass_AudioVideoVcr) = 11, AudioVideoVideoCamera (BluetoothMinorClass_AudioVideoVideoCamera) = 12, AudioVideoCamcorder (BluetoothMinorClass_AudioVideoCamcorder) = 13, AudioVideoVideoMonitor (BluetoothMinorClass_AudioVideoVideoMonitor) = 14, AudioVideoVideoDisplayAndLoudspeaker (BluetoothMinorClass_AudioVideoVideoDisplayAndLoudspeaker) = 15, AudioVideoVideoConferencing (BluetoothMinorClass_AudioVideoVideoConferencing) = 16, AudioVideoGamingOrToy (BluetoothMinorClass_AudioVideoGamingOrToy) = 18, PeripheralJoystick (BluetoothMinorClass_PeripheralJoystick) = 1, PeripheralGamepad (BluetoothMinorClass_PeripheralGamepad) = 2, PeripheralRemoteControl (BluetoothMinorClass_PeripheralRemoteControl) = 3, PeripheralSensing (BluetoothMinorClass_PeripheralSensing) = 4, PeripheralDigitizerTablet (BluetoothMinorClass_PeripheralDigitizerTablet) = 5, PeripheralCardReader (BluetoothMinorClass_PeripheralCardReader) = 6, PeripheralDigitalPen (BluetoothMinorClass_PeripheralDigitalPen) = 7, PeripheralHandheldScanner (BluetoothMinorClass_PeripheralHandheldScanner) = 8, PeripheralHandheldGesture (BluetoothMinorClass_PeripheralHandheldGesture) = 9, WearableWristwatch (BluetoothMinorClass_WearableWristwatch) = 1, WearablePager (BluetoothMinorClass_WearablePager) = 2, WearableJacket (BluetoothMinorClass_WearableJacket) = 3, WearableHelmet (BluetoothMinorClass_WearableHelmet) = 4, WearableGlasses (BluetoothMinorClass_WearableGlasses) = 5, ToyRobot (BluetoothMinorClass_ToyRobot) = 1, ToyVehicle (BluetoothMinorClass_ToyVehicle) = 2, ToyDoll (BluetoothMinorClass_ToyDoll) = 3, ToyController (BluetoothMinorClass_ToyController) = 4, ToyGame (BluetoothMinorClass_ToyGame) = 5, HealthBloodPressureMonitor (BluetoothMinorClass_HealthBloodPressureMonitor) = 1, HealthThermometer (BluetoothMinorClass_HealthThermometer) = 2, HealthWeighingScale (BluetoothMinorClass_HealthWeighingScale) = 3, HealthGlucoseMeter (BluetoothMinorClass_HealthGlucoseMeter) = 4, HealthPulseOximeter (BluetoothMinorClass_HealthPulseOximeter) = 5, HealthHeartRateMonitor (BluetoothMinorClass_HealthHeartRateMonitor) = 6, HealthHealthDataDisplay (BluetoothMinorClass_HealthHealthDataDisplay) = 7, HealthStepCounter (BluetoothMinorClass_HealthStepCounter) = 8, HealthBodyCompositionAnalyzer (BluetoothMinorClass_HealthBodyCompositionAnalyzer) = 9, HealthPeakFlowMonitor (BluetoothMinorClass_HealthPeakFlowMonitor) = 10, HealthMedicationMonitor (BluetoothMinorClass_HealthMedicationMonitor) = 11, HealthKneeProsthesis (BluetoothMinorClass_HealthKneeProsthesis) = 12, HealthAnkleProsthesis (BluetoothMinorClass_HealthAnkleProsthesis) = 13, HealthGenericHealthManager (BluetoothMinorClass_HealthGenericHealthManager) = 14, HealthPersonalMobilityDevice (BluetoothMinorClass_HealthPersonalMobilityDevice) = 15,
}}
RT_ENUM! { enum BluetoothServiceCapabilities: u32 {
    None (BluetoothServiceCapabilities_None) = 0, LimitedDiscoverableMode (BluetoothServiceCapabilities_LimitedDiscoverableMode) = 1, PositioningService (BluetoothServiceCapabilities_PositioningService) = 8, NetworkingService (BluetoothServiceCapabilities_NetworkingService) = 16, RenderingService (BluetoothServiceCapabilities_RenderingService) = 32, CapturingService (BluetoothServiceCapabilities_CapturingService) = 64, ObjectTransferService (BluetoothServiceCapabilities_ObjectTransferService) = 128, AudioService (BluetoothServiceCapabilities_AudioService) = 256, TelephoneService (BluetoothServiceCapabilities_TelephoneService) = 512, InformationService (BluetoothServiceCapabilities_InformationService) = 1024,
}}
RT_ENUM! { enum BluetoothConnectionStatus: i32 {
    Disconnected (BluetoothConnectionStatus_Disconnected) = 0, Connected (BluetoothConnectionStatus_Connected) = 1,
}}
RT_ENUM! { enum BluetoothError: i32 {
    Success (BluetoothError_Success) = 0, RadioNotAvailable (BluetoothError_RadioNotAvailable) = 1, ResourceInUse (BluetoothError_ResourceInUse) = 2, DeviceNotConnected (BluetoothError_DeviceNotConnected) = 3, OtherError (BluetoothError_OtherError) = 4, DisabledByPolicy (BluetoothError_DisabledByPolicy) = 5, NotSupported (BluetoothError_NotSupported) = 6, DisabledByUser (BluetoothError_DisabledByUser) = 7, ConsentRequired (BluetoothError_ConsentRequired) = 8, TransportNotSupported (BluetoothError_TransportNotSupported) = 9,
}}
RT_ENUM! { enum BluetoothAddressType: i32 {
    Public (BluetoothAddressType_Public) = 0, Random (BluetoothAddressType_Random) = 1, Unspecified (BluetoothAddressType_Unspecified) = 2,
}}
DEFINE_IID!(IID_IBluetoothAdapterStatics, 2332228458, 44108, 18241, 134, 97, 142, 171, 125, 23, 234, 159);
RT_INTERFACE!{static interface IBluetoothAdapterStatics(IBluetoothAdapterStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothAdapterStatics] {
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<BluetoothAdapter>) -> HRESULT,
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<BluetoothAdapter>) -> HRESULT
}}
impl IBluetoothAdapterStatics {
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothAdapter>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothAdapter>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothAdapter: IBluetoothAdapter}
impl RtActivatable<IBluetoothAdapterStatics> for BluetoothAdapter {}
impl BluetoothAdapter {
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IBluetoothAdapterStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothAdapter>>> { unsafe {
        <Self as RtActivatable<IBluetoothAdapterStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothAdapter>>> { unsafe {
        <Self as RtActivatable<IBluetoothAdapterStatics>>::get_activation_factory().get_default_async()
    }}
}
DEFINE_CLSID!(BluetoothAdapter(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,66,108,117,101,116,111,111,116,104,65,100,97,112,116,101,114,0]) [CLSID_BluetoothAdapter]);
DEFINE_IID!(IID_IBluetoothAdapter, 2037706828, 24442, 18996, 146, 37, 168, 85, 248, 75, 26, 139);
RT_INTERFACE!{interface IBluetoothAdapter(IBluetoothAdapterVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothAdapter] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_BluetoothAddress(&self, out: *mut u64) -> HRESULT,
    fn get_IsClassicSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsLowEnergySupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsPeripheralRoleSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsCentralRoleSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsAdvertisementOffloadSupported(&self, out: *mut bool) -> HRESULT,
    fn GetRadioAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<super::radios::Radio>) -> HRESULT
}}
impl IBluetoothAdapter {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bluetooth_address(&self) -> Result<u64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BluetoothAddress)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_classic_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsClassicSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_low_energy_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsLowEnergySupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_peripheral_role_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsPeripheralRoleSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_central_role_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsCentralRoleSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_advertisement_offload_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsAdvertisementOffloadSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_radio_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::radios::Radio>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetRadioAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothDeviceId, 3245951407, 22465, 17986, 188, 206, 230, 192, 107, 32, 174, 118);
RT_INTERFACE!{interface IBluetoothDeviceId(IBluetoothDeviceIdVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothDeviceId] {
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn get_IsClassicDevice(&self, out: *mut bool) -> HRESULT,
    fn get_IsLowEnergyDevice(&self, out: *mut bool) -> HRESULT
}}
impl IBluetoothDeviceId {
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_classic_device(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsClassicDevice)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_low_energy_device(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsLowEnergyDevice)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothDeviceId: IBluetoothDeviceId}
DEFINE_IID!(IID_IBluetoothUuidHelperStatics, 400493784, 53108, 19233, 175, 230, 245, 122, 17, 188, 222, 160);
RT_INTERFACE!{static interface IBluetoothUuidHelperStatics(IBluetoothUuidHelperStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothUuidHelperStatics] {
    fn FromShortId(&self, shortId: u32, out: *mut Guid) -> HRESULT,
    fn TryGetShortId(&self, uuid: Guid, out: *mut *mut super::super::foundation::IReference<u32>) -> HRESULT
}}
impl IBluetoothUuidHelperStatics {
    #[inline] pub unsafe fn from_short_id(&self, shortId: u32) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).FromShortId)(self as *const _ as *mut _, shortId, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_get_short_id(&self, uuid: Guid) -> Result<ComPtr<super::super::foundation::IReference<u32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryGetShortId)(self as *const _ as *mut _, uuid, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{static class BluetoothUuidHelper}
impl RtActivatable<IBluetoothUuidHelperStatics> for BluetoothUuidHelper {}
impl BluetoothUuidHelper {
    #[inline] pub fn from_short_id(shortId: u32) -> Result<Guid> { unsafe {
        <Self as RtActivatable<IBluetoothUuidHelperStatics>>::get_activation_factory().from_short_id(shortId)
    }}
    #[inline] pub fn try_get_short_id(uuid: Guid) -> Result<ComPtr<super::super::foundation::IReference<u32>>> { unsafe {
        <Self as RtActivatable<IBluetoothUuidHelperStatics>>::get_activation_factory().try_get_short_id(uuid)
    }}
}
DEFINE_CLSID!(BluetoothUuidHelper(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,66,108,117,101,116,111,111,116,104,85,117,105,100,72,101,108,112,101,114,0]) [CLSID_BluetoothUuidHelper]);
DEFINE_IID!(IID_IBluetoothDeviceStatics, 160554833, 22491, 18213, 187, 215, 132, 246, 67, 39, 236, 44);
RT_INTERFACE!{static interface IBluetoothDeviceStatics(IBluetoothDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothDeviceStatics] {
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<BluetoothDevice>) -> HRESULT,
    #[cfg(not(feature="windows-networking"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-networking")] fn FromHostNameAsync(&self, hostName: *mut super::super::networking::HostName, out: *mut *mut super::super::foundation::IAsyncOperation<BluetoothDevice>) -> HRESULT,
    fn FromBluetoothAddressAsync(&self, address: u64, out: *mut *mut super::super::foundation::IAsyncOperation<BluetoothDevice>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT
}}
impl IBluetoothDeviceStatics {
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn from_host_name_async(&self, hostName: &super::super::networking::HostName) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromHostNameAsync)(self as *const _ as *mut _, hostName as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_bluetooth_address_async(&self, address: u64) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromBluetoothAddressAsync)(self as *const _ as *mut _, address, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothDevice: IBluetoothDevice}
impl RtActivatable<IBluetoothDeviceStatics2> for BluetoothDevice {}
impl RtActivatable<IBluetoothDeviceStatics> for BluetoothDevice {}
impl BluetoothDevice {
    #[inline] pub fn get_device_selector_from_pairing_state(pairingState: bool) -> Result<HString> { unsafe {
        <Self as RtActivatable<IBluetoothDeviceStatics2>>::get_activation_factory().get_device_selector_from_pairing_state(pairingState)
    }}
    #[inline] pub fn get_device_selector_from_connection_status(connectionStatus: BluetoothConnectionStatus) -> Result<HString> { unsafe {
        <Self as RtActivatable<IBluetoothDeviceStatics2>>::get_activation_factory().get_device_selector_from_connection_status(connectionStatus)
    }}
    #[inline] pub fn get_device_selector_from_device_name(deviceName: &HStringArg) -> Result<HString> { unsafe {
        <Self as RtActivatable<IBluetoothDeviceStatics2>>::get_activation_factory().get_device_selector_from_device_name(deviceName)
    }}
    #[inline] pub fn get_device_selector_from_bluetooth_address(bluetoothAddress: u64) -> Result<HString> { unsafe {
        <Self as RtActivatable<IBluetoothDeviceStatics2>>::get_activation_factory().get_device_selector_from_bluetooth_address(bluetoothAddress)
    }}
    #[inline] pub fn get_device_selector_from_class_of_device(classOfDevice: &BluetoothClassOfDevice) -> Result<HString> { unsafe {
        <Self as RtActivatable<IBluetoothDeviceStatics2>>::get_activation_factory().get_device_selector_from_class_of_device(classOfDevice)
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothDevice>>> { unsafe {
        <Self as RtActivatable<IBluetoothDeviceStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[cfg(feature="windows-networking")] #[inline] pub fn from_host_name_async(hostName: &super::super::networking::HostName) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothDevice>>> { unsafe {
        <Self as RtActivatable<IBluetoothDeviceStatics>>::get_activation_factory().from_host_name_async(hostName)
    }}
    #[inline] pub fn from_bluetooth_address_async(address: u64) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothDevice>>> { unsafe {
        <Self as RtActivatable<IBluetoothDeviceStatics>>::get_activation_factory().from_bluetooth_address_async(address)
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IBluetoothDeviceStatics>>::get_activation_factory().get_device_selector()
    }}
}
DEFINE_CLSID!(BluetoothDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,66,108,117,101,116,111,111,116,104,68,101,118,105,99,101,0]) [CLSID_BluetoothDevice]);
DEFINE_IID!(IID_IBluetoothDeviceStatics2, 3265170991, 19988, 17527, 170, 27, 184, 180, 126, 91, 126, 206);
RT_INTERFACE!{static interface IBluetoothDeviceStatics2(IBluetoothDeviceStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothDeviceStatics2] {
    fn GetDeviceSelectorFromPairingState(&self, pairingState: bool, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromConnectionStatus(&self, connectionStatus: BluetoothConnectionStatus, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromDeviceName(&self, deviceName: HSTRING, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromBluetoothAddress(&self, bluetoothAddress: u64, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromClassOfDevice(&self, classOfDevice: *mut BluetoothClassOfDevice, out: *mut HSTRING) -> HRESULT
}}
impl IBluetoothDeviceStatics2 {
    #[inline] pub unsafe fn get_device_selector_from_pairing_state(&self, pairingState: bool) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromPairingState)(self as *const _ as *mut _, pairingState, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_connection_status(&self, connectionStatus: BluetoothConnectionStatus) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromConnectionStatus)(self as *const _ as *mut _, connectionStatus, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_device_name(&self, deviceName: &HStringArg) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromDeviceName)(self as *const _ as *mut _, deviceName.get(), &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_bluetooth_address(&self, bluetoothAddress: u64) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromBluetoothAddress)(self as *const _ as *mut _, bluetoothAddress, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_class_of_device(&self, classOfDevice: &BluetoothClassOfDevice) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromClassOfDevice)(self as *const _ as *mut _, classOfDevice as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothClassOfDevice: IBluetoothClassOfDevice}
impl RtActivatable<IBluetoothClassOfDeviceStatics> for BluetoothClassOfDevice {}
impl BluetoothClassOfDevice {
    #[inline] pub fn from_raw_value(rawValue: u32) -> Result<ComPtr<BluetoothClassOfDevice>> { unsafe {
        <Self as RtActivatable<IBluetoothClassOfDeviceStatics>>::get_activation_factory().from_raw_value(rawValue)
    }}
    #[inline] pub fn from_parts(majorClass: BluetoothMajorClass, minorClass: BluetoothMinorClass, serviceCapabilities: BluetoothServiceCapabilities) -> Result<ComPtr<BluetoothClassOfDevice>> { unsafe {
        <Self as RtActivatable<IBluetoothClassOfDeviceStatics>>::get_activation_factory().from_parts(majorClass, minorClass, serviceCapabilities)
    }}
}
DEFINE_CLSID!(BluetoothClassOfDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,66,108,117,101,116,111,111,116,104,67,108,97,115,115,79,102,68,101,118,105,99,101,0]) [CLSID_BluetoothClassOfDevice]);
DEFINE_IID!(IID_IBluetoothDevice, 590721366, 37074, 18948, 174, 245, 14, 32, 185, 230, 183, 7);
RT_INTERFACE!{interface IBluetoothDevice(IBluetoothDeviceVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothDevice] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    #[cfg(not(feature="windows-networking"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-networking")] fn get_HostName(&self, out: *mut *mut super::super::networking::HostName) -> HRESULT,
    fn get_Name(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ClassOfDevice(&self, out: *mut *mut BluetoothClassOfDevice) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy4(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_SdpRecords(&self, out: *mut *mut super::super::foundation::collections::IVectorView<super::super::storage::streams::IBuffer>) -> HRESULT,
    fn get_RfcommServices(&self, out: *mut *mut super::super::foundation::collections::IVectorView<rfcomm::RfcommDeviceService>) -> HRESULT,
    fn get_ConnectionStatus(&self, out: *mut BluetoothConnectionStatus) -> HRESULT,
    fn get_BluetoothAddress(&self, out: *mut u64) -> HRESULT,
    fn add_NameChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<BluetoothDevice, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_NameChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_SdpRecordsChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<BluetoothDevice, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SdpRecordsChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_ConnectionStatusChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<BluetoothDevice, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ConnectionStatusChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IBluetoothDevice {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn get_host_name(&self) -> Result<ComPtr<super::super::networking::HostName>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_HostName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Name)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_class_of_device(&self) -> Result<ComPtr<BluetoothClassOfDevice>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ClassOfDevice)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_sdp_records(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<super::super::storage::streams::IBuffer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SdpRecords)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_rfcomm_services(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<rfcomm::RfcommDeviceService>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_RfcommServices)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_connection_status(&self) -> Result<BluetoothConnectionStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ConnectionStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bluetooth_address(&self) -> Result<u64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BluetoothAddress)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_name_changed(&self, handler: &super::super::foundation::TypedEventHandler<BluetoothDevice, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_NameChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_name_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_NameChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_sdp_records_changed(&self, handler: &super::super::foundation::TypedEventHandler<BluetoothDevice, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SdpRecordsChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_sdp_records_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SdpRecordsChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_connection_status_changed(&self, handler: &super::super::foundation::TypedEventHandler<BluetoothDevice, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ConnectionStatusChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_connection_status_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ConnectionStatusChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothDevice2, 20183380, 45398, 19920, 177, 245, 193, 27, 195, 26, 81, 99);
RT_INTERFACE!{interface IBluetoothDevice2(IBluetoothDevice2Vtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothDevice2] {
    fn get_DeviceInformation(&self, out: *mut *mut super::enumeration::DeviceInformation) -> HRESULT
}}
impl IBluetoothDevice2 {
    #[inline] pub unsafe fn get_device_information(&self) -> Result<ComPtr<super::enumeration::DeviceInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothDevice3, 1476392843, 25882, 17492, 185, 15, 235, 33, 239, 11, 13, 113);
RT_INTERFACE!{interface IBluetoothDevice3(IBluetoothDevice3Vtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothDevice3] {
    fn get_DeviceAccessInformation(&self, out: *mut *mut super::enumeration::DeviceAccessInformation) -> HRESULT,
    fn RequestAccessAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<super::enumeration::DeviceAccessStatus>) -> HRESULT,
    fn GetRfcommServicesAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<rfcomm::RfcommDeviceServicesResult>) -> HRESULT,
    fn GetRfcommServicesWithCacheModeAsync(&self, cacheMode: BluetoothCacheMode, out: *mut *mut super::super::foundation::IAsyncOperation<rfcomm::RfcommDeviceServicesResult>) -> HRESULT,
    fn GetRfcommServicesForIdAsync(&self, serviceId: *mut rfcomm::RfcommServiceId, out: *mut *mut super::super::foundation::IAsyncOperation<rfcomm::RfcommDeviceServicesResult>) -> HRESULT,
    fn GetRfcommServicesForIdWithCacheModeAsync(&self, serviceId: *mut rfcomm::RfcommServiceId, cacheMode: BluetoothCacheMode, out: *mut *mut super::super::foundation::IAsyncOperation<rfcomm::RfcommDeviceServicesResult>) -> HRESULT
}}
impl IBluetoothDevice3 {
    #[inline] pub unsafe fn get_device_access_information(&self) -> Result<ComPtr<super::enumeration::DeviceAccessInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceAccessInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn request_access_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::enumeration::DeviceAccessStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestAccessAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_rfcomm_services_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<rfcomm::RfcommDeviceServicesResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetRfcommServicesAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_rfcomm_services_with_cache_mode_async(&self, cacheMode: BluetoothCacheMode) -> Result<ComPtr<super::super::foundation::IAsyncOperation<rfcomm::RfcommDeviceServicesResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetRfcommServicesWithCacheModeAsync)(self as *const _ as *mut _, cacheMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_rfcomm_services_for_id_async(&self, serviceId: &rfcomm::RfcommServiceId) -> Result<ComPtr<super::super::foundation::IAsyncOperation<rfcomm::RfcommDeviceServicesResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetRfcommServicesForIdAsync)(self as *const _ as *mut _, serviceId as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_rfcomm_services_for_id_with_cache_mode_async(&self, serviceId: &rfcomm::RfcommServiceId, cacheMode: BluetoothCacheMode) -> Result<ComPtr<super::super::foundation::IAsyncOperation<rfcomm::RfcommDeviceServicesResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetRfcommServicesForIdWithCacheModeAsync)(self as *const _ as *mut _, serviceId as *const _ as *mut _, cacheMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothLEAppearanceCategoriesStatics, 1833784574, 1130, 16773, 170, 182, 130, 76, 240, 97, 8, 97);
RT_INTERFACE!{static interface IBluetoothLEAppearanceCategoriesStatics(IBluetoothLEAppearanceCategoriesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAppearanceCategoriesStatics] {
    fn get_Uncategorized(&self, out: *mut u16) -> HRESULT,
    fn get_Phone(&self, out: *mut u16) -> HRESULT,
    fn get_Computer(&self, out: *mut u16) -> HRESULT,
    fn get_Watch(&self, out: *mut u16) -> HRESULT,
    fn get_Clock(&self, out: *mut u16) -> HRESULT,
    fn get_Display(&self, out: *mut u16) -> HRESULT,
    fn get_RemoteControl(&self, out: *mut u16) -> HRESULT,
    fn get_EyeGlasses(&self, out: *mut u16) -> HRESULT,
    fn get_Tag(&self, out: *mut u16) -> HRESULT,
    fn get_Keyring(&self, out: *mut u16) -> HRESULT,
    fn get_MediaPlayer(&self, out: *mut u16) -> HRESULT,
    fn get_BarcodeScanner(&self, out: *mut u16) -> HRESULT,
    fn get_Thermometer(&self, out: *mut u16) -> HRESULT,
    fn get_HeartRate(&self, out: *mut u16) -> HRESULT,
    fn get_BloodPressure(&self, out: *mut u16) -> HRESULT,
    fn get_HumanInterfaceDevice(&self, out: *mut u16) -> HRESULT,
    fn get_GlucoseMeter(&self, out: *mut u16) -> HRESULT,
    fn get_RunningWalking(&self, out: *mut u16) -> HRESULT,
    fn get_Cycling(&self, out: *mut u16) -> HRESULT,
    fn get_PulseOximeter(&self, out: *mut u16) -> HRESULT,
    fn get_WeightScale(&self, out: *mut u16) -> HRESULT,
    fn get_OutdoorSportActivity(&self, out: *mut u16) -> HRESULT
}}
impl IBluetoothLEAppearanceCategoriesStatics {
    #[inline] pub unsafe fn get_uncategorized(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Uncategorized)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_phone(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Phone)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_computer(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Computer)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_watch(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Watch)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_clock(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Clock)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_display(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Display)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_remote_control(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RemoteControl)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_eye_glasses(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_EyeGlasses)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_tag(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Tag)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_keyring(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Keyring)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_media_player(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MediaPlayer)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_barcode_scanner(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BarcodeScanner)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_thermometer(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Thermometer)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_heart_rate(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HeartRate)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_blood_pressure(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BloodPressure)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_human_interface_device(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HumanInterfaceDevice)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_glucose_meter(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GlucoseMeter)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_running_walking(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RunningWalking)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cycling(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Cycling)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pulse_oximeter(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PulseOximeter)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_weight_scale(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_WeightScale)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_outdoor_sport_activity(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_OutdoorSportActivity)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{static class BluetoothLEAppearanceCategories}
impl RtActivatable<IBluetoothLEAppearanceCategoriesStatics> for BluetoothLEAppearanceCategories {}
impl BluetoothLEAppearanceCategories {
    #[inline] pub fn get_uncategorized() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_uncategorized()
    }}
    #[inline] pub fn get_phone() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_phone()
    }}
    #[inline] pub fn get_computer() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_computer()
    }}
    #[inline] pub fn get_watch() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_watch()
    }}
    #[inline] pub fn get_clock() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_clock()
    }}
    #[inline] pub fn get_display() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_display()
    }}
    #[inline] pub fn get_remote_control() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_remote_control()
    }}
    #[inline] pub fn get_eye_glasses() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_eye_glasses()
    }}
    #[inline] pub fn get_tag() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_tag()
    }}
    #[inline] pub fn get_keyring() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_keyring()
    }}
    #[inline] pub fn get_media_player() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_media_player()
    }}
    #[inline] pub fn get_barcode_scanner() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_barcode_scanner()
    }}
    #[inline] pub fn get_thermometer() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_thermometer()
    }}
    #[inline] pub fn get_heart_rate() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_heart_rate()
    }}
    #[inline] pub fn get_blood_pressure() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_blood_pressure()
    }}
    #[inline] pub fn get_human_interface_device() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_human_interface_device()
    }}
    #[inline] pub fn get_glucose_meter() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_glucose_meter()
    }}
    #[inline] pub fn get_running_walking() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_running_walking()
    }}
    #[inline] pub fn get_cycling() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_cycling()
    }}
    #[inline] pub fn get_pulse_oximeter() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_pulse_oximeter()
    }}
    #[inline] pub fn get_weight_scale() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_weight_scale()
    }}
    #[inline] pub fn get_outdoor_sport_activity() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceCategoriesStatics>>::get_activation_factory().get_outdoor_sport_activity()
    }}
}
DEFINE_CLSID!(BluetoothLEAppearanceCategories(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,66,108,117,101,116,111,111,116,104,76,69,65,112,112,101,97,114,97,110,99,101,67,97,116,101,103,111,114,105,101,115,0]) [CLSID_BluetoothLEAppearanceCategories]);
DEFINE_IID!(IID_IBluetoothLEAppearanceSubcategoriesStatics, 3850085894, 8516, 16730, 131, 18, 113, 204, 242, 145, 248, 209);
RT_INTERFACE!{static interface IBluetoothLEAppearanceSubcategoriesStatics(IBluetoothLEAppearanceSubcategoriesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAppearanceSubcategoriesStatics] {
    fn get_Generic(&self, out: *mut u16) -> HRESULT,
    fn get_SportsWatch(&self, out: *mut u16) -> HRESULT,
    fn get_ThermometerEar(&self, out: *mut u16) -> HRESULT,
    fn get_HeartRateBelt(&self, out: *mut u16) -> HRESULT,
    fn get_BloodPressureArm(&self, out: *mut u16) -> HRESULT,
    fn get_BloodPressureWrist(&self, out: *mut u16) -> HRESULT,
    fn get_Keyboard(&self, out: *mut u16) -> HRESULT,
    fn get_Mouse(&self, out: *mut u16) -> HRESULT,
    fn get_Joystick(&self, out: *mut u16) -> HRESULT,
    fn get_Gamepad(&self, out: *mut u16) -> HRESULT,
    fn get_DigitizerTablet(&self, out: *mut u16) -> HRESULT,
    fn get_CardReader(&self, out: *mut u16) -> HRESULT,
    fn get_DigitalPen(&self, out: *mut u16) -> HRESULT,
    fn get_BarcodeScanner(&self, out: *mut u16) -> HRESULT,
    fn get_RunningWalkingInShoe(&self, out: *mut u16) -> HRESULT,
    fn get_RunningWalkingOnShoe(&self, out: *mut u16) -> HRESULT,
    fn get_RunningWalkingOnHip(&self, out: *mut u16) -> HRESULT,
    fn get_CyclingComputer(&self, out: *mut u16) -> HRESULT,
    fn get_CyclingSpeedSensor(&self, out: *mut u16) -> HRESULT,
    fn get_CyclingCadenceSensor(&self, out: *mut u16) -> HRESULT,
    fn get_CyclingPowerSensor(&self, out: *mut u16) -> HRESULT,
    fn get_CyclingSpeedCadenceSensor(&self, out: *mut u16) -> HRESULT,
    fn get_OximeterFingertip(&self, out: *mut u16) -> HRESULT,
    fn get_OximeterWristWorn(&self, out: *mut u16) -> HRESULT,
    fn get_LocationDisplay(&self, out: *mut u16) -> HRESULT,
    fn get_LocationNavigationDisplay(&self, out: *mut u16) -> HRESULT,
    fn get_LocationPod(&self, out: *mut u16) -> HRESULT,
    fn get_LocationNavigationPod(&self, out: *mut u16) -> HRESULT
}}
impl IBluetoothLEAppearanceSubcategoriesStatics {
    #[inline] pub unsafe fn get_generic(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Generic)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sports_watch(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SportsWatch)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_thermometer_ear(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ThermometerEar)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_heart_rate_belt(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HeartRateBelt)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_blood_pressure_arm(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BloodPressureArm)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_blood_pressure_wrist(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BloodPressureWrist)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_keyboard(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Keyboard)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_mouse(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Mouse)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_joystick(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Joystick)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gamepad(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Gamepad)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_digitizer_tablet(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DigitizerTablet)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_card_reader(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CardReader)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_digital_pen(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DigitalPen)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_barcode_scanner(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BarcodeScanner)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_running_walking_in_shoe(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RunningWalkingInShoe)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_running_walking_on_shoe(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RunningWalkingOnShoe)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_running_walking_on_hip(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RunningWalkingOnHip)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cycling_computer(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CyclingComputer)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cycling_speed_sensor(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CyclingSpeedSensor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cycling_cadence_sensor(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CyclingCadenceSensor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cycling_power_sensor(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CyclingPowerSensor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cycling_speed_cadence_sensor(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CyclingSpeedCadenceSensor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_oximeter_fingertip(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_OximeterFingertip)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_oximeter_wrist_worn(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_OximeterWristWorn)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_location_display(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LocationDisplay)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_location_navigation_display(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LocationNavigationDisplay)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_location_pod(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LocationPod)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_location_navigation_pod(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LocationNavigationPod)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{static class BluetoothLEAppearanceSubcategories}
impl RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics> for BluetoothLEAppearanceSubcategories {}
impl BluetoothLEAppearanceSubcategories {
    #[inline] pub fn get_generic() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_generic()
    }}
    #[inline] pub fn get_sports_watch() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_sports_watch()
    }}
    #[inline] pub fn get_thermometer_ear() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_thermometer_ear()
    }}
    #[inline] pub fn get_heart_rate_belt() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_heart_rate_belt()
    }}
    #[inline] pub fn get_blood_pressure_arm() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_blood_pressure_arm()
    }}
    #[inline] pub fn get_blood_pressure_wrist() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_blood_pressure_wrist()
    }}
    #[inline] pub fn get_keyboard() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_keyboard()
    }}
    #[inline] pub fn get_mouse() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_mouse()
    }}
    #[inline] pub fn get_joystick() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_joystick()
    }}
    #[inline] pub fn get_gamepad() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_gamepad()
    }}
    #[inline] pub fn get_digitizer_tablet() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_digitizer_tablet()
    }}
    #[inline] pub fn get_card_reader() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_card_reader()
    }}
    #[inline] pub fn get_digital_pen() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_digital_pen()
    }}
    #[inline] pub fn get_barcode_scanner() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_barcode_scanner()
    }}
    #[inline] pub fn get_running_walking_in_shoe() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_running_walking_in_shoe()
    }}
    #[inline] pub fn get_running_walking_on_shoe() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_running_walking_on_shoe()
    }}
    #[inline] pub fn get_running_walking_on_hip() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_running_walking_on_hip()
    }}
    #[inline] pub fn get_cycling_computer() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_cycling_computer()
    }}
    #[inline] pub fn get_cycling_speed_sensor() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_cycling_speed_sensor()
    }}
    #[inline] pub fn get_cycling_cadence_sensor() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_cycling_cadence_sensor()
    }}
    #[inline] pub fn get_cycling_power_sensor() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_cycling_power_sensor()
    }}
    #[inline] pub fn get_cycling_speed_cadence_sensor() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_cycling_speed_cadence_sensor()
    }}
    #[inline] pub fn get_oximeter_fingertip() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_oximeter_fingertip()
    }}
    #[inline] pub fn get_oximeter_wrist_worn() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_oximeter_wrist_worn()
    }}
    #[inline] pub fn get_location_display() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_location_display()
    }}
    #[inline] pub fn get_location_navigation_display() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_location_navigation_display()
    }}
    #[inline] pub fn get_location_pod() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_location_pod()
    }}
    #[inline] pub fn get_location_navigation_pod() -> Result<u16> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceSubcategoriesStatics>>::get_activation_factory().get_location_navigation_pod()
    }}
}
DEFINE_CLSID!(BluetoothLEAppearanceSubcategories(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,66,108,117,101,116,111,111,116,104,76,69,65,112,112,101,97,114,97,110,99,101,83,117,98,99,97,116,101,103,111,114,105,101,115,0]) [CLSID_BluetoothLEAppearanceSubcategories]);
DEFINE_IID!(IID_IBluetoothLEAppearance, 1562409458, 26280, 16984, 152, 94, 2, 180, 217, 80, 159, 24);
RT_INTERFACE!{interface IBluetoothLEAppearance(IBluetoothLEAppearanceVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAppearance] {
    fn get_RawValue(&self, out: *mut u16) -> HRESULT,
    fn get_Category(&self, out: *mut u16) -> HRESULT,
    fn get_SubCategory(&self, out: *mut u16) -> HRESULT
}}
impl IBluetoothLEAppearance {
    #[inline] pub unsafe fn get_raw_value(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RawValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_category(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Category)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sub_category(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SubCategory)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothLEAppearanceStatics, 2710814919, 17668, 20298, 155, 165, 205, 16, 84, 229, 224, 101);
RT_INTERFACE!{static interface IBluetoothLEAppearanceStatics(IBluetoothLEAppearanceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAppearanceStatics] {
    fn FromRawValue(&self, rawValue: u16, out: *mut *mut BluetoothLEAppearance) -> HRESULT,
    fn FromParts(&self, appearanceCategory: u16, appearanceSubCategory: u16, out: *mut *mut BluetoothLEAppearance) -> HRESULT
}}
impl IBluetoothLEAppearanceStatics {
    #[inline] pub unsafe fn from_raw_value(&self, rawValue: u16) -> Result<ComPtr<BluetoothLEAppearance>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromRawValue)(self as *const _ as *mut _, rawValue, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_parts(&self, appearanceCategory: u16, appearanceSubCategory: u16) -> Result<ComPtr<BluetoothLEAppearance>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromParts)(self as *const _ as *mut _, appearanceCategory, appearanceSubCategory, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothLEAppearance: IBluetoothLEAppearance}
impl RtActivatable<IBluetoothLEAppearanceStatics> for BluetoothLEAppearance {}
impl BluetoothLEAppearance {
    #[inline] pub fn from_raw_value(rawValue: u16) -> Result<ComPtr<BluetoothLEAppearance>> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceStatics>>::get_activation_factory().from_raw_value(rawValue)
    }}
    #[inline] pub fn from_parts(appearanceCategory: u16, appearanceSubCategory: u16) -> Result<ComPtr<BluetoothLEAppearance>> { unsafe {
        <Self as RtActivatable<IBluetoothLEAppearanceStatics>>::get_activation_factory().from_parts(appearanceCategory, appearanceSubCategory)
    }}
}
DEFINE_CLSID!(BluetoothLEAppearance(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,66,108,117,101,116,111,111,116,104,76,69,65,112,112,101,97,114,97,110,99,101,0]) [CLSID_BluetoothLEAppearance]);
DEFINE_IID!(IID_IBluetoothLEDeviceStatics, 3369015833, 61622, 19440, 134, 137, 65, 48, 61, 226, 217, 244);
RT_INTERFACE!{static interface IBluetoothLEDeviceStatics(IBluetoothLEDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEDeviceStatics] {
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<BluetoothLEDevice>) -> HRESULT,
    fn FromBluetoothAddressAsync(&self, bluetoothAddress: u64, out: *mut *mut super::super::foundation::IAsyncOperation<BluetoothLEDevice>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT
}}
impl IBluetoothLEDeviceStatics {
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothLEDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_bluetooth_address_async(&self, bluetoothAddress: u64) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothLEDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromBluetoothAddressAsync)(self as *const _ as *mut _, bluetoothAddress, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothLEDevice: IBluetoothLEDevice}
impl RtActivatable<IBluetoothLEDeviceStatics2> for BluetoothLEDevice {}
impl RtActivatable<IBluetoothLEDeviceStatics> for BluetoothLEDevice {}
impl BluetoothLEDevice {
    #[inline] pub fn get_device_selector_from_pairing_state(pairingState: bool) -> Result<HString> { unsafe {
        <Self as RtActivatable<IBluetoothLEDeviceStatics2>>::get_activation_factory().get_device_selector_from_pairing_state(pairingState)
    }}
    #[inline] pub fn get_device_selector_from_connection_status(connectionStatus: BluetoothConnectionStatus) -> Result<HString> { unsafe {
        <Self as RtActivatable<IBluetoothLEDeviceStatics2>>::get_activation_factory().get_device_selector_from_connection_status(connectionStatus)
    }}
    #[inline] pub fn get_device_selector_from_device_name(deviceName: &HStringArg) -> Result<HString> { unsafe {
        <Self as RtActivatable<IBluetoothLEDeviceStatics2>>::get_activation_factory().get_device_selector_from_device_name(deviceName)
    }}
    #[inline] pub fn get_device_selector_from_bluetooth_address(bluetoothAddress: u64) -> Result<HString> { unsafe {
        <Self as RtActivatable<IBluetoothLEDeviceStatics2>>::get_activation_factory().get_device_selector_from_bluetooth_address(bluetoothAddress)
    }}
    #[inline] pub fn get_device_selector_from_bluetooth_address_with_bluetooth_address_type(bluetoothAddress: u64, bluetoothAddressType: BluetoothAddressType) -> Result<HString> { unsafe {
        <Self as RtActivatable<IBluetoothLEDeviceStatics2>>::get_activation_factory().get_device_selector_from_bluetooth_address_with_bluetooth_address_type(bluetoothAddress, bluetoothAddressType)
    }}
    #[inline] pub fn get_device_selector_from_appearance(appearance: &BluetoothLEAppearance) -> Result<HString> { unsafe {
        <Self as RtActivatable<IBluetoothLEDeviceStatics2>>::get_activation_factory().get_device_selector_from_appearance(appearance)
    }}
    #[inline] pub fn from_bluetooth_address_with_bluetooth_address_type_async(bluetoothAddress: u64, bluetoothAddressType: BluetoothAddressType) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothLEDevice>>> { unsafe {
        <Self as RtActivatable<IBluetoothLEDeviceStatics2>>::get_activation_factory().from_bluetooth_address_with_bluetooth_address_type_async(bluetoothAddress, bluetoothAddressType)
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothLEDevice>>> { unsafe {
        <Self as RtActivatable<IBluetoothLEDeviceStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn from_bluetooth_address_async(bluetoothAddress: u64) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothLEDevice>>> { unsafe {
        <Self as RtActivatable<IBluetoothLEDeviceStatics>>::get_activation_factory().from_bluetooth_address_async(bluetoothAddress)
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IBluetoothLEDeviceStatics>>::get_activation_factory().get_device_selector()
    }}
}
DEFINE_CLSID!(BluetoothLEDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,66,108,117,101,116,111,111,116,104,76,69,68,101,118,105,99,101,0]) [CLSID_BluetoothLEDevice]);
DEFINE_IID!(IID_IBluetoothLEDeviceStatics2, 1595064427, 15276, 17384, 173, 22, 86, 50, 113, 189, 65, 194);
RT_INTERFACE!{static interface IBluetoothLEDeviceStatics2(IBluetoothLEDeviceStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEDeviceStatics2] {
    fn GetDeviceSelectorFromPairingState(&self, pairingState: bool, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromConnectionStatus(&self, connectionStatus: BluetoothConnectionStatus, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromDeviceName(&self, deviceName: HSTRING, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromBluetoothAddress(&self, bluetoothAddress: u64, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromBluetoothAddressWithBluetoothAddressType(&self, bluetoothAddress: u64, bluetoothAddressType: BluetoothAddressType, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromAppearance(&self, appearance: *mut BluetoothLEAppearance, out: *mut HSTRING) -> HRESULT,
    fn FromBluetoothAddressWithBluetoothAddressTypeAsync(&self, bluetoothAddress: u64, bluetoothAddressType: BluetoothAddressType, out: *mut *mut super::super::foundation::IAsyncOperation<BluetoothLEDevice>) -> HRESULT
}}
impl IBluetoothLEDeviceStatics2 {
    #[inline] pub unsafe fn get_device_selector_from_pairing_state(&self, pairingState: bool) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromPairingState)(self as *const _ as *mut _, pairingState, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_connection_status(&self, connectionStatus: BluetoothConnectionStatus) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromConnectionStatus)(self as *const _ as *mut _, connectionStatus, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_device_name(&self, deviceName: &HStringArg) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromDeviceName)(self as *const _ as *mut _, deviceName.get(), &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_bluetooth_address(&self, bluetoothAddress: u64) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromBluetoothAddress)(self as *const _ as *mut _, bluetoothAddress, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_bluetooth_address_with_bluetooth_address_type(&self, bluetoothAddress: u64, bluetoothAddressType: BluetoothAddressType) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromBluetoothAddressWithBluetoothAddressType)(self as *const _ as *mut _, bluetoothAddress, bluetoothAddressType, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_appearance(&self, appearance: &BluetoothLEAppearance) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromAppearance)(self as *const _ as *mut _, appearance as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_bluetooth_address_with_bluetooth_address_type_async(&self, bluetoothAddress: u64, bluetoothAddressType: BluetoothAddressType) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BluetoothLEDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromBluetoothAddressWithBluetoothAddressTypeAsync)(self as *const _ as *mut _, bluetoothAddress, bluetoothAddressType, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothLEDevice, 3052285819, 19160, 17986, 172, 72, 128, 160, 181, 0, 232, 135);
RT_INTERFACE!{interface IBluetoothLEDevice(IBluetoothLEDeviceVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEDevice] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Name(&self, out: *mut HSTRING) -> HRESULT,
    fn get_GattServices(&self, out: *mut *mut super::super::foundation::collections::IVectorView<genericattributeprofile::GattDeviceService>) -> HRESULT,
    fn get_ConnectionStatus(&self, out: *mut BluetoothConnectionStatus) -> HRESULT,
    fn get_BluetoothAddress(&self, out: *mut u64) -> HRESULT,
    fn GetGattService(&self, serviceUuid: Guid, out: *mut *mut genericattributeprofile::GattDeviceService) -> HRESULT,
    fn add_NameChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<BluetoothLEDevice, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_NameChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_GattServicesChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<BluetoothLEDevice, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_GattServicesChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_ConnectionStatusChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<BluetoothLEDevice, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ConnectionStatusChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IBluetoothLEDevice {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Name)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gatt_services(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<genericattributeprofile::GattDeviceService>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_GattServices)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_connection_status(&self) -> Result<BluetoothConnectionStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ConnectionStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bluetooth_address(&self) -> Result<u64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BluetoothAddress)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gatt_service(&self, serviceUuid: Guid) -> Result<ComPtr<genericattributeprofile::GattDeviceService>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetGattService)(self as *const _ as *mut _, serviceUuid, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_name_changed(&self, handler: &super::super::foundation::TypedEventHandler<BluetoothLEDevice, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_NameChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_name_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_NameChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_gatt_services_changed(&self, handler: &super::super::foundation::TypedEventHandler<BluetoothLEDevice, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_GattServicesChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_gatt_services_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_GattServicesChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_connection_status_changed(&self, handler: &super::super::foundation::TypedEventHandler<BluetoothLEDevice, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ConnectionStatusChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_connection_status_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ConnectionStatusChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothLEDevice2, 653288115, 31470, 19761, 186, 186, 177, 185, 119, 95, 89, 22);
RT_INTERFACE!{interface IBluetoothLEDevice2(IBluetoothLEDevice2Vtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEDevice2] {
    fn get_DeviceInformation(&self, out: *mut *mut super::enumeration::DeviceInformation) -> HRESULT,
    fn get_Appearance(&self, out: *mut *mut BluetoothLEAppearance) -> HRESULT,
    fn get_BluetoothAddressType(&self, out: *mut BluetoothAddressType) -> HRESULT
}}
impl IBluetoothLEDevice2 {
    #[inline] pub unsafe fn get_device_information(&self) -> Result<ComPtr<super::enumeration::DeviceInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_appearance(&self) -> Result<ComPtr<BluetoothLEAppearance>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Appearance)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bluetooth_address_type(&self) -> Result<BluetoothAddressType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BluetoothAddressType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothLEDevice3, 2934563987, 17580, 16604, 175, 51, 178, 193, 60, 1, 202, 70);
RT_INTERFACE!{interface IBluetoothLEDevice3(IBluetoothLEDevice3Vtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEDevice3] {
    fn get_DeviceAccessInformation(&self, out: *mut *mut super::enumeration::DeviceAccessInformation) -> HRESULT,
    fn RequestAccessAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<super::enumeration::DeviceAccessStatus>) -> HRESULT,
    fn GetGattServicesAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<genericattributeprofile::GattDeviceServicesResult>) -> HRESULT,
    fn GetGattServicesWithCacheModeAsync(&self, cacheMode: BluetoothCacheMode, out: *mut *mut super::super::foundation::IAsyncOperation<genericattributeprofile::GattDeviceServicesResult>) -> HRESULT,
    fn GetGattServicesForUuidAsync(&self, serviceUuid: Guid, out: *mut *mut super::super::foundation::IAsyncOperation<genericattributeprofile::GattDeviceServicesResult>) -> HRESULT,
    fn GetGattServicesForUuidWithCacheModeAsync(&self, serviceUuid: Guid, cacheMode: BluetoothCacheMode, out: *mut *mut super::super::foundation::IAsyncOperation<genericattributeprofile::GattDeviceServicesResult>) -> HRESULT
}}
impl IBluetoothLEDevice3 {
    #[inline] pub unsafe fn get_device_access_information(&self) -> Result<ComPtr<super::enumeration::DeviceAccessInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceAccessInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn request_access_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::enumeration::DeviceAccessStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestAccessAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gatt_services_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<genericattributeprofile::GattDeviceServicesResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetGattServicesAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gatt_services_with_cache_mode_async(&self, cacheMode: BluetoothCacheMode) -> Result<ComPtr<super::super::foundation::IAsyncOperation<genericattributeprofile::GattDeviceServicesResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetGattServicesWithCacheModeAsync)(self as *const _ as *mut _, cacheMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gatt_services_for_uuid_async(&self, serviceUuid: Guid) -> Result<ComPtr<super::super::foundation::IAsyncOperation<genericattributeprofile::GattDeviceServicesResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetGattServicesForUuidAsync)(self as *const _ as *mut _, serviceUuid, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gatt_services_for_uuid_with_cache_mode_async(&self, serviceUuid: Guid, cacheMode: BluetoothCacheMode) -> Result<ComPtr<super::super::foundation::IAsyncOperation<genericattributeprofile::GattDeviceServicesResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetGattServicesForUuidWithCacheModeAsync)(self as *const _ as *mut _, serviceUuid, cacheMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothClassOfDevice, 3594527358, 55255, 18017, 148, 84, 101, 3, 156, 161, 122, 43);
RT_INTERFACE!{interface IBluetoothClassOfDevice(IBluetoothClassOfDeviceVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothClassOfDevice] {
    fn get_RawValue(&self, out: *mut u32) -> HRESULT,
    fn get_MajorClass(&self, out: *mut BluetoothMajorClass) -> HRESULT,
    fn get_MinorClass(&self, out: *mut BluetoothMinorClass) -> HRESULT,
    fn get_ServiceCapabilities(&self, out: *mut BluetoothServiceCapabilities) -> HRESULT
}}
impl IBluetoothClassOfDevice {
    #[inline] pub unsafe fn get_raw_value(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RawValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_major_class(&self) -> Result<BluetoothMajorClass> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MajorClass)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_minor_class(&self) -> Result<BluetoothMinorClass> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinorClass)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_capabilities(&self) -> Result<BluetoothServiceCapabilities> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ServiceCapabilities)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothClassOfDeviceStatics, 3831575997, 4002, 16748, 145, 180, 193, 228, 140, 160, 97, 193);
RT_INTERFACE!{static interface IBluetoothClassOfDeviceStatics(IBluetoothClassOfDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothClassOfDeviceStatics] {
    fn FromRawValue(&self, rawValue: u32, out: *mut *mut BluetoothClassOfDevice) -> HRESULT,
    fn FromParts(&self, majorClass: BluetoothMajorClass, minorClass: BluetoothMinorClass, serviceCapabilities: BluetoothServiceCapabilities, out: *mut *mut BluetoothClassOfDevice) -> HRESULT
}}
impl IBluetoothClassOfDeviceStatics {
    #[inline] pub unsafe fn from_raw_value(&self, rawValue: u32) -> Result<ComPtr<BluetoothClassOfDevice>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromRawValue)(self as *const _ as *mut _, rawValue, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_parts(&self, majorClass: BluetoothMajorClass, minorClass: BluetoothMinorClass, serviceCapabilities: BluetoothServiceCapabilities) -> Result<ComPtr<BluetoothClassOfDevice>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromParts)(self as *const _ as *mut _, majorClass, minorClass, serviceCapabilities, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothSignalStrengthFilter, 3749409681, 27573, 19710, 144, 177, 93, 115, 36, 237, 207, 127);
RT_INTERFACE!{interface IBluetoothSignalStrengthFilter(IBluetoothSignalStrengthFilterVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothSignalStrengthFilter] {
    fn get_InRangeThresholdInDBm(&self, out: *mut *mut super::super::foundation::IReference<i16>) -> HRESULT,
    fn put_InRangeThresholdInDBm(&self, value: *mut super::super::foundation::IReference<i16>) -> HRESULT,
    fn get_OutOfRangeThresholdInDBm(&self, out: *mut *mut super::super::foundation::IReference<i16>) -> HRESULT,
    fn put_OutOfRangeThresholdInDBm(&self, value: *mut super::super::foundation::IReference<i16>) -> HRESULT,
    fn get_OutOfRangeTimeout(&self, out: *mut *mut super::super::foundation::IReference<super::super::foundation::TimeSpan>) -> HRESULT,
    fn put_OutOfRangeTimeout(&self, value: *mut super::super::foundation::IReference<super::super::foundation::TimeSpan>) -> HRESULT,
    fn get_SamplingInterval(&self, out: *mut *mut super::super::foundation::IReference<super::super::foundation::TimeSpan>) -> HRESULT,
    fn put_SamplingInterval(&self, value: *mut super::super::foundation::IReference<super::super::foundation::TimeSpan>) -> HRESULT
}}
impl IBluetoothSignalStrengthFilter {
    #[inline] pub unsafe fn get_in_range_threshold_in_dbm(&self) -> Result<ComPtr<super::super::foundation::IReference<i16>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_InRangeThresholdInDBm)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_in_range_threshold_in_dbm(&self, value: &super::super::foundation::IReference<i16>) -> Result<()> {
        let hr = ((*self.lpVtbl).put_InRangeThresholdInDBm)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_out_of_range_threshold_in_dbm(&self) -> Result<ComPtr<super::super::foundation::IReference<i16>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_OutOfRangeThresholdInDBm)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_out_of_range_threshold_in_dbm(&self, value: &super::super::foundation::IReference<i16>) -> Result<()> {
        let hr = ((*self.lpVtbl).put_OutOfRangeThresholdInDBm)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_out_of_range_timeout(&self) -> Result<ComPtr<super::super::foundation::IReference<super::super::foundation::TimeSpan>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_OutOfRangeTimeout)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_out_of_range_timeout(&self, value: &super::super::foundation::IReference<super::super::foundation::TimeSpan>) -> Result<()> {
        let hr = ((*self.lpVtbl).put_OutOfRangeTimeout)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sampling_interval(&self) -> Result<ComPtr<super::super::foundation::IReference<super::super::foundation::TimeSpan>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SamplingInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_sampling_interval(&self, value: &super::super::foundation::IReference<super::super::foundation::TimeSpan>) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SamplingInterval)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothSignalStrengthFilter: IBluetoothSignalStrengthFilter}
impl RtActivatable<IActivationFactory> for BluetoothSignalStrengthFilter {}
DEFINE_CLSID!(BluetoothSignalStrengthFilter(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,66,108,117,101,116,111,111,116,104,83,105,103,110,97,108,83,116,114,101,110,103,116,104,70,105,108,116,101,114,0]) [CLSID_BluetoothSignalStrengthFilter]);
pub mod rfcomm { // Windows.Devices.Bluetooth.Rfcomm
use ::prelude::*;
RT_CLASS!{class RfcommDeviceService: IRfcommDeviceService}
impl RtActivatable<IRfcommDeviceServiceStatics2> for RfcommDeviceService {}
impl RtActivatable<IRfcommDeviceServiceStatics> for RfcommDeviceService {}
impl RfcommDeviceService {
    #[inline] pub fn get_device_selector_for_bluetooth_device(bluetoothDevice: &super::BluetoothDevice) -> Result<HString> { unsafe {
        <Self as RtActivatable<IRfcommDeviceServiceStatics2>>::get_activation_factory().get_device_selector_for_bluetooth_device(bluetoothDevice)
    }}
    #[inline] pub fn get_device_selector_for_bluetooth_device_with_cache_mode(bluetoothDevice: &super::BluetoothDevice, cacheMode: super::BluetoothCacheMode) -> Result<HString> { unsafe {
        <Self as RtActivatable<IRfcommDeviceServiceStatics2>>::get_activation_factory().get_device_selector_for_bluetooth_device_with_cache_mode(bluetoothDevice, cacheMode)
    }}
    #[inline] pub fn get_device_selector_for_bluetooth_device_and_service_id(bluetoothDevice: &super::BluetoothDevice, serviceId: &RfcommServiceId) -> Result<HString> { unsafe {
        <Self as RtActivatable<IRfcommDeviceServiceStatics2>>::get_activation_factory().get_device_selector_for_bluetooth_device_and_service_id(bluetoothDevice, serviceId)
    }}
    #[inline] pub fn get_device_selector_for_bluetooth_device_and_service_id_with_cache_mode(bluetoothDevice: &super::BluetoothDevice, serviceId: &RfcommServiceId, cacheMode: super::BluetoothCacheMode) -> Result<HString> { unsafe {
        <Self as RtActivatable<IRfcommDeviceServiceStatics2>>::get_activation_factory().get_device_selector_for_bluetooth_device_and_service_id_with_cache_mode(bluetoothDevice, serviceId, cacheMode)
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<RfcommDeviceService>>> { unsafe {
        <Self as RtActivatable<IRfcommDeviceServiceStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_device_selector(serviceId: &RfcommServiceId) -> Result<HString> { unsafe {
        <Self as RtActivatable<IRfcommDeviceServiceStatics>>::get_activation_factory().get_device_selector(serviceId)
    }}
}
DEFINE_CLSID!(RfcommDeviceService(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,82,102,99,111,109,109,46,82,102,99,111,109,109,68,101,118,105,99,101,83,101,114,118,105,99,101,0]) [CLSID_RfcommDeviceService]);
RT_CLASS!{class RfcommDeviceServicesResult: IRfcommDeviceServicesResult}
RT_CLASS!{class RfcommServiceId: IRfcommServiceId}
impl RtActivatable<IRfcommServiceIdStatics> for RfcommServiceId {}
impl RfcommServiceId {
    #[inline] pub fn from_uuid(uuid: Guid) -> Result<ComPtr<RfcommServiceId>> { unsafe {
        <Self as RtActivatable<IRfcommServiceIdStatics>>::get_activation_factory().from_uuid(uuid)
    }}
    #[inline] pub fn from_short_id(shortId: u32) -> Result<ComPtr<RfcommServiceId>> { unsafe {
        <Self as RtActivatable<IRfcommServiceIdStatics>>::get_activation_factory().from_short_id(shortId)
    }}
    #[inline] pub fn get_serial_port() -> Result<ComPtr<RfcommServiceId>> { unsafe {
        <Self as RtActivatable<IRfcommServiceIdStatics>>::get_activation_factory().get_serial_port()
    }}
    #[inline] pub fn get_obex_object_push() -> Result<ComPtr<RfcommServiceId>> { unsafe {
        <Self as RtActivatable<IRfcommServiceIdStatics>>::get_activation_factory().get_obex_object_push()
    }}
    #[inline] pub fn get_obex_file_transfer() -> Result<ComPtr<RfcommServiceId>> { unsafe {
        <Self as RtActivatable<IRfcommServiceIdStatics>>::get_activation_factory().get_obex_file_transfer()
    }}
    #[inline] pub fn get_phone_book_access_pce() -> Result<ComPtr<RfcommServiceId>> { unsafe {
        <Self as RtActivatable<IRfcommServiceIdStatics>>::get_activation_factory().get_phone_book_access_pce()
    }}
    #[inline] pub fn get_phone_book_access_pse() -> Result<ComPtr<RfcommServiceId>> { unsafe {
        <Self as RtActivatable<IRfcommServiceIdStatics>>::get_activation_factory().get_phone_book_access_pse()
    }}
    #[inline] pub fn get_generic_file_transfer() -> Result<ComPtr<RfcommServiceId>> { unsafe {
        <Self as RtActivatable<IRfcommServiceIdStatics>>::get_activation_factory().get_generic_file_transfer()
    }}
}
DEFINE_CLSID!(RfcommServiceId(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,82,102,99,111,109,109,46,82,102,99,111,109,109,83,101,114,118,105,99,101,73,100,0]) [CLSID_RfcommServiceId]);
DEFINE_IID!(IID_IRfcommServiceIdStatics, 706191034, 43381, 18147, 181, 107, 8, 255, 215, 131, 165, 254);
RT_INTERFACE!{static interface IRfcommServiceIdStatics(IRfcommServiceIdStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IRfcommServiceIdStatics] {
    fn FromUuid(&self, uuid: Guid, out: *mut *mut RfcommServiceId) -> HRESULT,
    fn FromShortId(&self, shortId: u32, out: *mut *mut RfcommServiceId) -> HRESULT,
    fn get_SerialPort(&self, out: *mut *mut RfcommServiceId) -> HRESULT,
    fn get_ObexObjectPush(&self, out: *mut *mut RfcommServiceId) -> HRESULT,
    fn get_ObexFileTransfer(&self, out: *mut *mut RfcommServiceId) -> HRESULT,
    fn get_PhoneBookAccessPce(&self, out: *mut *mut RfcommServiceId) -> HRESULT,
    fn get_PhoneBookAccessPse(&self, out: *mut *mut RfcommServiceId) -> HRESULT,
    fn get_GenericFileTransfer(&self, out: *mut *mut RfcommServiceId) -> HRESULT
}}
impl IRfcommServiceIdStatics {
    #[inline] pub unsafe fn from_uuid(&self, uuid: Guid) -> Result<ComPtr<RfcommServiceId>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromUuid)(self as *const _ as *mut _, uuid, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_short_id(&self, shortId: u32) -> Result<ComPtr<RfcommServiceId>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromShortId)(self as *const _ as *mut _, shortId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_serial_port(&self) -> Result<ComPtr<RfcommServiceId>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SerialPort)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_obex_object_push(&self) -> Result<ComPtr<RfcommServiceId>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ObexObjectPush)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_obex_file_transfer(&self) -> Result<ComPtr<RfcommServiceId>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ObexFileTransfer)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_phone_book_access_pce(&self) -> Result<ComPtr<RfcommServiceId>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PhoneBookAccessPce)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_phone_book_access_pse(&self) -> Result<ComPtr<RfcommServiceId>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PhoneBookAccessPse)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_generic_file_transfer(&self) -> Result<ComPtr<RfcommServiceId>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_GenericFileTransfer)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IRfcommServiceId, 576885252, 32258, 16407, 129, 54, 218, 27, 106, 27, 155, 191);
RT_INTERFACE!{interface IRfcommServiceId(IRfcommServiceIdVtbl): IInspectable(IInspectableVtbl) [IID_IRfcommServiceId] {
    fn get_Uuid(&self, out: *mut Guid) -> HRESULT,
    fn AsShortId(&self, out: *mut u32) -> HRESULT,
    fn AsString(&self, out: *mut HSTRING) -> HRESULT
}}
impl IRfcommServiceId {
    #[inline] pub unsafe fn get_uuid(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Uuid)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn as_short_id(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).AsShortId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn as_string(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).AsString)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IRfcommDeviceServicesResult, 994588812, 31951, 18574, 150, 37, 210, 89, 165, 115, 45, 85);
RT_INTERFACE!{interface IRfcommDeviceServicesResult(IRfcommDeviceServicesResultVtbl): IInspectable(IInspectableVtbl) [IID_IRfcommDeviceServicesResult] {
    fn get_Error(&self, out: *mut super::BluetoothError) -> HRESULT,
    fn get_Services(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<RfcommDeviceService>) -> HRESULT
}}
impl IRfcommDeviceServicesResult {
    #[inline] pub unsafe fn get_error(&self) -> Result<super::BluetoothError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Error)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_services(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<RfcommDeviceService>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Services)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IRfcommDeviceServiceStatics, 2762033647, 25197, 16812, 178, 83, 135, 172, 92, 39, 226, 138);
RT_INTERFACE!{static interface IRfcommDeviceServiceStatics(IRfcommDeviceServiceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IRfcommDeviceServiceStatics] {
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<RfcommDeviceService>) -> HRESULT,
    fn GetDeviceSelector(&self, serviceId: *mut RfcommServiceId, out: *mut HSTRING) -> HRESULT
}}
impl IRfcommDeviceServiceStatics {
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<RfcommDeviceService>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self, serviceId: &RfcommServiceId) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, serviceId as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IRfcommDeviceServiceStatics2, 2861347273, 59277, 19428, 128, 118, 10, 61, 135, 160, 160, 95);
RT_INTERFACE!{static interface IRfcommDeviceServiceStatics2(IRfcommDeviceServiceStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IRfcommDeviceServiceStatics2] {
    fn GetDeviceSelectorForBluetoothDevice(&self, bluetoothDevice: *mut super::BluetoothDevice, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorForBluetoothDeviceWithCacheMode(&self, bluetoothDevice: *mut super::BluetoothDevice, cacheMode: super::BluetoothCacheMode, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorForBluetoothDeviceAndServiceId(&self, bluetoothDevice: *mut super::BluetoothDevice, serviceId: *mut RfcommServiceId, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorForBluetoothDeviceAndServiceIdWithCacheMode(&self, bluetoothDevice: *mut super::BluetoothDevice, serviceId: *mut RfcommServiceId, cacheMode: super::BluetoothCacheMode, out: *mut HSTRING) -> HRESULT
}}
impl IRfcommDeviceServiceStatics2 {
    #[inline] pub unsafe fn get_device_selector_for_bluetooth_device(&self, bluetoothDevice: &super::BluetoothDevice) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorForBluetoothDevice)(self as *const _ as *mut _, bluetoothDevice as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_for_bluetooth_device_with_cache_mode(&self, bluetoothDevice: &super::BluetoothDevice, cacheMode: super::BluetoothCacheMode) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorForBluetoothDeviceWithCacheMode)(self as *const _ as *mut _, bluetoothDevice as *const _ as *mut _, cacheMode, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_for_bluetooth_device_and_service_id(&self, bluetoothDevice: &super::BluetoothDevice, serviceId: &RfcommServiceId) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorForBluetoothDeviceAndServiceId)(self as *const _ as *mut _, bluetoothDevice as *const _ as *mut _, serviceId as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_for_bluetooth_device_and_service_id_with_cache_mode(&self, bluetoothDevice: &super::BluetoothDevice, serviceId: &RfcommServiceId, cacheMode: super::BluetoothCacheMode) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorForBluetoothDeviceAndServiceIdWithCacheMode)(self as *const _ as *mut _, bluetoothDevice as *const _ as *mut _, serviceId as *const _ as *mut _, cacheMode, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IRfcommDeviceService, 2927755039, 50593, 19520, 140, 40, 243, 239, 214, 144, 98, 243);
RT_INTERFACE!{interface IRfcommDeviceService(IRfcommDeviceServiceVtbl): IInspectable(IInspectableVtbl) [IID_IRfcommDeviceService] {
    #[cfg(not(feature="windows-networking"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-networking")] fn get_ConnectionHostName(&self, out: *mut *mut ::rt::gen::windows::networking::HostName) -> HRESULT,
    fn get_ConnectionServiceName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ServiceId(&self, out: *mut *mut RfcommServiceId) -> HRESULT,
    #[cfg(not(feature="windows-networking"))] fn __Dummy3(&self) -> (),
    #[cfg(feature="windows-networking")] fn get_ProtectionLevel(&self, out: *mut ::rt::gen::windows::networking::sockets::SocketProtectionLevel) -> HRESULT,
    #[cfg(not(feature="windows-networking"))] fn __Dummy4(&self) -> (),
    #[cfg(feature="windows-networking")] fn get_MaxProtectionLevel(&self, out: *mut ::rt::gen::windows::networking::sockets::SocketProtectionLevel) -> HRESULT,
    #[cfg(feature="windows-storage")] fn GetSdpRawAttributesAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<::rt::gen::windows::foundation::collections::IMapView<u32, ::rt::gen::windows::storage::streams::IBuffer>>) -> HRESULT,
    #[cfg(feature="windows-storage")] fn GetSdpRawAttributesWithCacheModeAsync(&self, cacheMode: super::BluetoothCacheMode, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<::rt::gen::windows::foundation::collections::IMapView<u32, ::rt::gen::windows::storage::streams::IBuffer>>) -> HRESULT
}}
impl IRfcommDeviceService {
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn get_connection_host_name(&self) -> Result<ComPtr<::rt::gen::windows::networking::HostName>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ConnectionHostName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_connection_service_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ConnectionServiceName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_id(&self) -> Result<ComPtr<RfcommServiceId>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ServiceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn get_protection_level(&self) -> Result<::rt::gen::windows::networking::sockets::SocketProtectionLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ProtectionLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn get_max_protection_level(&self) -> Result<::rt::gen::windows::networking::sockets::SocketProtectionLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxProtectionLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_sdp_raw_attributes_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<::rt::gen::windows::foundation::collections::IMapView<u32, ::rt::gen::windows::storage::streams::IBuffer>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetSdpRawAttributesAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_sdp_raw_attributes_with_cache_mode_async(&self, cacheMode: super::BluetoothCacheMode) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<::rt::gen::windows::foundation::collections::IMapView<u32, ::rt::gen::windows::storage::streams::IBuffer>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetSdpRawAttributesWithCacheModeAsync)(self as *const _ as *mut _, cacheMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IRfcommDeviceService2, 1399647508, 60365, 18942, 191, 159, 64, 239, 198, 137, 178, 13);
RT_INTERFACE!{interface IRfcommDeviceService2(IRfcommDeviceService2Vtbl): IInspectable(IInspectableVtbl) [IID_IRfcommDeviceService2] {
    fn get_Device(&self, out: *mut *mut super::BluetoothDevice) -> HRESULT
}}
impl IRfcommDeviceService2 {
    #[inline] pub unsafe fn get_device(&self) -> Result<ComPtr<super::BluetoothDevice>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Device)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IRfcommDeviceService3, 472034534, 56644, 19747, 134, 109, 143, 52, 134, 238, 100, 144);
RT_INTERFACE!{interface IRfcommDeviceService3(IRfcommDeviceService3Vtbl): IInspectable(IInspectableVtbl) [IID_IRfcommDeviceService3] {
    fn get_DeviceAccessInformation(&self, out: *mut *mut super::super::enumeration::DeviceAccessInformation) -> HRESULT,
    fn RequestAccessAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<super::super::enumeration::DeviceAccessStatus>) -> HRESULT
}}
impl IRfcommDeviceService3 {
    #[inline] pub unsafe fn get_device_access_information(&self) -> Result<ComPtr<super::super::enumeration::DeviceAccessInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceAccessInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn request_access_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<super::super::enumeration::DeviceAccessStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestAccessAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IRfcommServiceProviderStatics, 2559083267, 27082, 16698, 132, 247, 67, 68, 199, 41, 41, 151);
RT_INTERFACE!{static interface IRfcommServiceProviderStatics(IRfcommServiceProviderStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IRfcommServiceProviderStatics] {
    fn CreateAsync(&self, serviceId: *mut RfcommServiceId, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<RfcommServiceProvider>) -> HRESULT
}}
impl IRfcommServiceProviderStatics {
    #[inline] pub unsafe fn create_async(&self, serviceId: &RfcommServiceId) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<RfcommServiceProvider>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateAsync)(self as *const _ as *mut _, serviceId as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class RfcommServiceProvider: IRfcommServiceProvider}
impl RtActivatable<IRfcommServiceProviderStatics> for RfcommServiceProvider {}
impl RfcommServiceProvider {
    #[inline] pub fn create_async(serviceId: &RfcommServiceId) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<RfcommServiceProvider>>> { unsafe {
        <Self as RtActivatable<IRfcommServiceProviderStatics>>::get_activation_factory().create_async(serviceId)
    }}
}
DEFINE_CLSID!(RfcommServiceProvider(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,82,102,99,111,109,109,46,82,102,99,111,109,109,83,101,114,118,105,99,101,80,114,111,118,105,100,101,114,0]) [CLSID_RfcommServiceProvider]);
DEFINE_IID!(IID_IRfcommServiceProvider, 3940285892, 45558, 17663, 159, 124, 231, 168, 42, 184, 104, 33);
RT_INTERFACE!{interface IRfcommServiceProvider(IRfcommServiceProviderVtbl): IInspectable(IInspectableVtbl) [IID_IRfcommServiceProvider] {
    fn get_ServiceId(&self, out: *mut *mut RfcommServiceId) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_SdpRawAttributes(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IMap<u32, ::rt::gen::windows::storage::streams::IBuffer>) -> HRESULT,
    #[cfg(not(feature="windows-networking"))] fn __Dummy2(&self) -> (),
    #[cfg(feature="windows-networking")] fn StartAdvertising(&self, listener: *mut ::rt::gen::windows::networking::sockets::StreamSocketListener) -> HRESULT,
    fn StopAdvertising(&self) -> HRESULT
}}
impl IRfcommServiceProvider {
    #[inline] pub unsafe fn get_service_id(&self) -> Result<ComPtr<RfcommServiceId>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ServiceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_sdp_raw_attributes(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IMap<u32, ::rt::gen::windows::storage::streams::IBuffer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SdpRawAttributes)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn start_advertising(&self, listener: &::rt::gen::windows::networking::sockets::StreamSocketListener) -> Result<()> {
        let hr = ((*self.lpVtbl).StartAdvertising)(self as *const _ as *mut _, listener as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop_advertising(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).StopAdvertising)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IRfcommServiceProvider2, 1936449478, 15489, 19742, 186, 242, 221, 187, 129, 40, 69, 18);
RT_INTERFACE!{interface IRfcommServiceProvider2(IRfcommServiceProvider2Vtbl): IInspectable(IInspectableVtbl) [IID_IRfcommServiceProvider2] {
    #[cfg(feature="windows-networking")] fn StartAdvertisingWithRadioDiscoverability(&self, listener: *mut ::rt::gen::windows::networking::sockets::StreamSocketListener, radioDiscoverable: bool) -> HRESULT
}}
impl IRfcommServiceProvider2 {
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn start_advertising_with_radio_discoverability(&self, listener: &::rt::gen::windows::networking::sockets::StreamSocketListener, radioDiscoverable: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).StartAdvertisingWithRadioDiscoverability)(self as *const _ as *mut _, listener as *const _ as *mut _, radioDiscoverable);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
} // Windows.Devices.Bluetooth.Rfcomm
pub mod genericattributeprofile { // Windows.Devices.Bluetooth.GenericAttributeProfile
use ::prelude::*;
RT_CLASS!{class GattDeviceService: IGattDeviceService}
impl RtActivatable<IGattDeviceServiceStatics> for GattDeviceService {}
impl RtActivatable<IGattDeviceServiceStatics2> for GattDeviceService {}
impl GattDeviceService {
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattDeviceService>>> { unsafe {
        <Self as RtActivatable<IGattDeviceServiceStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_device_selector_from_uuid(serviceUuid: Guid) -> Result<HString> { unsafe {
        <Self as RtActivatable<IGattDeviceServiceStatics>>::get_activation_factory().get_device_selector_from_uuid(serviceUuid)
    }}
    #[inline] pub fn get_device_selector_from_short_id(serviceShortId: u16) -> Result<HString> { unsafe {
        <Self as RtActivatable<IGattDeviceServiceStatics>>::get_activation_factory().get_device_selector_from_short_id(serviceShortId)
    }}
    #[inline] pub fn convert_short_id_to_uuid(shortId: u16) -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattDeviceServiceStatics>>::get_activation_factory().convert_short_id_to_uuid(shortId)
    }}
    #[inline] pub fn from_id_with_sharing_mode_async(deviceId: &HStringArg, sharingMode: GattSharingMode) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattDeviceService>>> { unsafe {
        <Self as RtActivatable<IGattDeviceServiceStatics2>>::get_activation_factory().from_id_with_sharing_mode_async(deviceId, sharingMode)
    }}
    #[inline] pub fn get_device_selector_for_bluetooth_device_id(bluetoothDeviceId: &super::BluetoothDeviceId) -> Result<HString> { unsafe {
        <Self as RtActivatable<IGattDeviceServiceStatics2>>::get_activation_factory().get_device_selector_for_bluetooth_device_id(bluetoothDeviceId)
    }}
    #[inline] pub fn get_device_selector_for_bluetooth_device_id_with_cache_mode(bluetoothDeviceId: &super::BluetoothDeviceId, cacheMode: super::BluetoothCacheMode) -> Result<HString> { unsafe {
        <Self as RtActivatable<IGattDeviceServiceStatics2>>::get_activation_factory().get_device_selector_for_bluetooth_device_id_with_cache_mode(bluetoothDeviceId, cacheMode)
    }}
    #[inline] pub fn get_device_selector_for_bluetooth_device_id_and_uuid(bluetoothDeviceId: &super::BluetoothDeviceId, serviceUuid: Guid) -> Result<HString> { unsafe {
        <Self as RtActivatable<IGattDeviceServiceStatics2>>::get_activation_factory().get_device_selector_for_bluetooth_device_id_and_uuid(bluetoothDeviceId, serviceUuid)
    }}
    #[inline] pub fn get_device_selector_for_bluetooth_device_id_and_uuid_with_cache_mode(bluetoothDeviceId: &super::BluetoothDeviceId, serviceUuid: Guid, cacheMode: super::BluetoothCacheMode) -> Result<HString> { unsafe {
        <Self as RtActivatable<IGattDeviceServiceStatics2>>::get_activation_factory().get_device_selector_for_bluetooth_device_id_and_uuid_with_cache_mode(bluetoothDeviceId, serviceUuid, cacheMode)
    }}
}
DEFINE_CLSID!(GattDeviceService(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,68,101,118,105,99,101,83,101,114,118,105,99,101,0]) [CLSID_GattDeviceService]);
RT_CLASS!{class GattDeviceServicesResult: IGattDeviceServicesResult}
RT_ENUM! { enum GattSessionStatus: i32 {
    Closed (GattSessionStatus_Closed) = 0, Active (GattSessionStatus_Active) = 1,
}}
RT_ENUM! { enum GattCharacteristicProperties: u32 {
    None (GattCharacteristicProperties_None) = 0, Broadcast (GattCharacteristicProperties_Broadcast) = 1, Read (GattCharacteristicProperties_Read) = 2, WriteWithoutResponse (GattCharacteristicProperties_WriteWithoutResponse) = 4, Write (GattCharacteristicProperties_Write) = 8, Notify (GattCharacteristicProperties_Notify) = 16, Indicate (GattCharacteristicProperties_Indicate) = 32, AuthenticatedSignedWrites (GattCharacteristicProperties_AuthenticatedSignedWrites) = 64, ExtendedProperties (GattCharacteristicProperties_ExtendedProperties) = 128, ReliableWrites (GattCharacteristicProperties_ReliableWrites) = 256, WritableAuxiliaries (GattCharacteristicProperties_WritableAuxiliaries) = 512,
}}
RT_ENUM! { enum GattClientCharacteristicConfigurationDescriptorValue: i32 {
    None (GattClientCharacteristicConfigurationDescriptorValue_None) = 0, Notify (GattClientCharacteristicConfigurationDescriptorValue_Notify) = 1, Indicate (GattClientCharacteristicConfigurationDescriptorValue_Indicate) = 2,
}}
RT_ENUM! { enum GattProtectionLevel: i32 {
    Plain (GattProtectionLevel_Plain) = 0, AuthenticationRequired (GattProtectionLevel_AuthenticationRequired) = 1, EncryptionRequired (GattProtectionLevel_EncryptionRequired) = 2, EncryptionAndAuthenticationRequired (GattProtectionLevel_EncryptionAndAuthenticationRequired) = 3,
}}
RT_ENUM! { enum GattWriteOption: i32 {
    WriteWithResponse (GattWriteOption_WriteWithResponse) = 0, WriteWithoutResponse (GattWriteOption_WriteWithoutResponse) = 1,
}}
RT_ENUM! { enum GattCommunicationStatus: i32 {
    Success (GattCommunicationStatus_Success) = 0, Unreachable (GattCommunicationStatus_Unreachable) = 1, ProtocolError (GattCommunicationStatus_ProtocolError) = 2, AccessDenied (GattCommunicationStatus_AccessDenied) = 3,
}}
RT_ENUM! { enum GattSharingMode: i32 {
    Unspecified (GattSharingMode_Unspecified) = 0, Exclusive (GattSharingMode_Exclusive) = 1, SharedReadOnly (GattSharingMode_SharedReadOnly) = 2, SharedReadAndWrite (GattSharingMode_SharedReadAndWrite) = 3,
}}
RT_ENUM! { enum GattOpenStatus: i32 {
    Unspecified (GattOpenStatus_Unspecified) = 0, Success (GattOpenStatus_Success) = 1, AlreadyOpened (GattOpenStatus_AlreadyOpened) = 2, NotFound (GattOpenStatus_NotFound) = 3, SharingViolation (GattOpenStatus_SharingViolation) = 4, AccessDenied (GattOpenStatus_AccessDenied) = 5,
}}
RT_ENUM! { enum GattRequestState: i32 {
    Pending (GattRequestState_Pending) = 0, Completed (GattRequestState_Completed) = 1, Canceled (GattRequestState_Canceled) = 2,
}}
RT_ENUM! { enum GattServiceProviderAdvertisementStatus: i32 {
    Created (GattServiceProviderAdvertisementStatus_Created) = 0, Stopped (GattServiceProviderAdvertisementStatus_Stopped) = 1, Started (GattServiceProviderAdvertisementStatus_Started) = 2, Aborted (GattServiceProviderAdvertisementStatus_Aborted) = 3,
}}
DEFINE_IID!(IID_IGattProtocolErrorStatics, 3393635781, 3788, 18441, 190, 163, 207, 121, 188, 153, 30, 55);
RT_INTERFACE!{static interface IGattProtocolErrorStatics(IGattProtocolErrorStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGattProtocolErrorStatics] {
    fn get_InvalidHandle(&self, out: *mut u8) -> HRESULT,
    fn get_ReadNotPermitted(&self, out: *mut u8) -> HRESULT,
    fn get_WriteNotPermitted(&self, out: *mut u8) -> HRESULT,
    fn get_InvalidPdu(&self, out: *mut u8) -> HRESULT,
    fn get_InsufficientAuthentication(&self, out: *mut u8) -> HRESULT,
    fn get_RequestNotSupported(&self, out: *mut u8) -> HRESULT,
    fn get_InvalidOffset(&self, out: *mut u8) -> HRESULT,
    fn get_InsufficientAuthorization(&self, out: *mut u8) -> HRESULT,
    fn get_PrepareQueueFull(&self, out: *mut u8) -> HRESULT,
    fn get_AttributeNotFound(&self, out: *mut u8) -> HRESULT,
    fn get_AttributeNotLong(&self, out: *mut u8) -> HRESULT,
    fn get_InsufficientEncryptionKeySize(&self, out: *mut u8) -> HRESULT,
    fn get_InvalidAttributeValueLength(&self, out: *mut u8) -> HRESULT,
    fn get_UnlikelyError(&self, out: *mut u8) -> HRESULT,
    fn get_InsufficientEncryption(&self, out: *mut u8) -> HRESULT,
    fn get_UnsupportedGroupType(&self, out: *mut u8) -> HRESULT,
    fn get_InsufficientResources(&self, out: *mut u8) -> HRESULT
}}
impl IGattProtocolErrorStatics {
    #[inline] pub unsafe fn get_invalid_handle(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InvalidHandle)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_read_not_permitted(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadNotPermitted)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_write_not_permitted(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_WriteNotPermitted)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_invalid_pdu(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InvalidPdu)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_insufficient_authentication(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InsufficientAuthentication)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_request_not_supported(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RequestNotSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_invalid_offset(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InvalidOffset)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_insufficient_authorization(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InsufficientAuthorization)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_prepare_queue_full(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PrepareQueueFull)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_attribute_not_found(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AttributeNotFound)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_attribute_not_long(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AttributeNotLong)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_insufficient_encryption_key_size(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InsufficientEncryptionKeySize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_invalid_attribute_value_length(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InvalidAttributeValueLength)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_unlikely_error(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UnlikelyError)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_insufficient_encryption(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InsufficientEncryption)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_unsupported_group_type(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UnsupportedGroupType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_insufficient_resources(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InsufficientResources)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{static class GattProtocolError}
impl RtActivatable<IGattProtocolErrorStatics> for GattProtocolError {}
impl GattProtocolError {
    #[inline] pub fn get_invalid_handle() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_invalid_handle()
    }}
    #[inline] pub fn get_read_not_permitted() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_read_not_permitted()
    }}
    #[inline] pub fn get_write_not_permitted() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_write_not_permitted()
    }}
    #[inline] pub fn get_invalid_pdu() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_invalid_pdu()
    }}
    #[inline] pub fn get_insufficient_authentication() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_insufficient_authentication()
    }}
    #[inline] pub fn get_request_not_supported() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_request_not_supported()
    }}
    #[inline] pub fn get_invalid_offset() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_invalid_offset()
    }}
    #[inline] pub fn get_insufficient_authorization() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_insufficient_authorization()
    }}
    #[inline] pub fn get_prepare_queue_full() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_prepare_queue_full()
    }}
    #[inline] pub fn get_attribute_not_found() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_attribute_not_found()
    }}
    #[inline] pub fn get_attribute_not_long() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_attribute_not_long()
    }}
    #[inline] pub fn get_insufficient_encryption_key_size() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_insufficient_encryption_key_size()
    }}
    #[inline] pub fn get_invalid_attribute_value_length() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_invalid_attribute_value_length()
    }}
    #[inline] pub fn get_unlikely_error() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_unlikely_error()
    }}
    #[inline] pub fn get_insufficient_encryption() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_insufficient_encryption()
    }}
    #[inline] pub fn get_unsupported_group_type() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_unsupported_group_type()
    }}
    #[inline] pub fn get_insufficient_resources() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattProtocolErrorStatics>>::get_activation_factory().get_insufficient_resources()
    }}
}
DEFINE_CLSID!(GattProtocolError(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,80,114,111,116,111,99,111,108,69,114,114,111,114,0]) [CLSID_GattProtocolError]);
DEFINE_IID!(IID_IGattSessionStatics, 778418524, 21407, 19895, 130, 168, 115, 189, 187, 247, 62, 191);
RT_INTERFACE!{static interface IGattSessionStatics(IGattSessionStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGattSessionStatics] {
    fn FromDeviceIdAsync(&self, deviceId: *mut super::BluetoothDeviceId, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattSession>) -> HRESULT
}}
impl IGattSessionStatics {
    #[inline] pub unsafe fn from_device_id_async(&self, deviceId: &super::BluetoothDeviceId) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattSession>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromDeviceIdAsync)(self as *const _ as *mut _, deviceId as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GattSession: IGattSession}
impl RtActivatable<IGattSessionStatics> for GattSession {}
impl GattSession {
    #[inline] pub fn from_device_id_async(deviceId: &super::BluetoothDeviceId) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattSession>>> { unsafe {
        <Self as RtActivatable<IGattSessionStatics>>::get_activation_factory().from_device_id_async(deviceId)
    }}
}
DEFINE_CLSID!(GattSession(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,83,101,115,115,105,111,110,0]) [CLSID_GattSession]);
DEFINE_IID!(IID_IGattSession, 3527102787, 57422, 19492, 153, 156, 156, 37, 111, 152, 86, 177);
RT_INTERFACE!{interface IGattSession(IGattSessionVtbl): IInspectable(IInspectableVtbl) [IID_IGattSession] {
    fn get_DeviceId(&self, out: *mut *mut super::BluetoothDeviceId) -> HRESULT,
    fn get_CanMaintainConnection(&self, out: *mut bool) -> HRESULT,
    fn put_MaintainConnection(&self, value: bool) -> HRESULT,
    fn get_MaintainConnection(&self, out: *mut bool) -> HRESULT,
    fn get_MaxPduSize(&self, out: *mut u16) -> HRESULT,
    fn get_SessionStatus(&self, out: *mut GattSessionStatus) -> HRESULT,
    fn add_MaxPduSizeChanged(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<GattSession, IInspectable>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_MaxPduSizeChanged(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn add_SessionStatusChanged(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<GattSession, GattSessionStatusChangedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SessionStatusChanged(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT
}}
impl IGattSession {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<ComPtr<super::BluetoothDeviceId>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_can_maintain_connection(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanMaintainConnection)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_maintain_connection(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_MaintainConnection)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_maintain_connection(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaintainConnection)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_pdu_size(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxPduSize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_session_status(&self) -> Result<GattSessionStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SessionStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_max_pdu_size_changed(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<GattSession, IInspectable>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_MaxPduSizeChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_max_pdu_size_changed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_MaxPduSizeChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_session_status_changed(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<GattSession, GattSessionStatusChangedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SessionStatusChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_session_status_changed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SessionStatusChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class GattSessionStatusChangedEventArgs: IGattSessionStatusChangedEventArgs}
DEFINE_IID!(IID_IGattSessionStatusChangedEventArgs, 1980086062, 33663, 16460, 171, 52, 49, 99, 243, 157, 223, 50);
RT_INTERFACE!{interface IGattSessionStatusChangedEventArgs(IGattSessionStatusChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IGattSessionStatusChangedEventArgs] {
    fn get_Error(&self, out: *mut super::BluetoothError) -> HRESULT,
    fn get_Status(&self, out: *mut GattSessionStatus) -> HRESULT
}}
impl IGattSessionStatusChangedEventArgs {
    #[inline] pub unsafe fn get_error(&self) -> Result<super::BluetoothError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Error)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<GattSessionStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattDeviceServiceStatics, 426573858, 64173, 17884, 174, 91, 42, 195, 24, 78, 132, 219);
RT_INTERFACE!{static interface IGattDeviceServiceStatics(IGattDeviceServiceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGattDeviceServiceStatics] {
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattDeviceService>) -> HRESULT,
    fn GetDeviceSelectorFromUuid(&self, serviceUuid: Guid, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromShortId(&self, serviceShortId: u16, out: *mut HSTRING) -> HRESULT,
    fn ConvertShortIdToUuid(&self, shortId: u16, out: *mut Guid) -> HRESULT
}}
impl IGattDeviceServiceStatics {
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattDeviceService>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_uuid(&self, serviceUuid: Guid) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromUuid)(self as *const _ as *mut _, serviceUuid, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_short_id(&self, serviceShortId: u16) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromShortId)(self as *const _ as *mut _, serviceShortId, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn convert_short_id_to_uuid(&self, shortId: u16) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).ConvertShortIdToUuid)(self as *const _ as *mut _, shortId, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattDeviceServiceStatics2, 100931694, 9382, 19213, 162, 242, 48, 204, 1, 84, 93, 37);
RT_INTERFACE!{static interface IGattDeviceServiceStatics2(IGattDeviceServiceStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IGattDeviceServiceStatics2] {
    fn FromIdWithSharingModeAsync(&self, deviceId: HSTRING, sharingMode: GattSharingMode, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattDeviceService>) -> HRESULT,
    fn GetDeviceSelectorForBluetoothDeviceId(&self, bluetoothDeviceId: *mut super::BluetoothDeviceId, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorForBluetoothDeviceIdWithCacheMode(&self, bluetoothDeviceId: *mut super::BluetoothDeviceId, cacheMode: super::BluetoothCacheMode, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorForBluetoothDeviceIdAndUuid(&self, bluetoothDeviceId: *mut super::BluetoothDeviceId, serviceUuid: Guid, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorForBluetoothDeviceIdAndUuidWithCacheMode(&self, bluetoothDeviceId: *mut super::BluetoothDeviceId, serviceUuid: Guid, cacheMode: super::BluetoothCacheMode, out: *mut HSTRING) -> HRESULT
}}
impl IGattDeviceServiceStatics2 {
    #[inline] pub unsafe fn from_id_with_sharing_mode_async(&self, deviceId: &HStringArg, sharingMode: GattSharingMode) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattDeviceService>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdWithSharingModeAsync)(self as *const _ as *mut _, deviceId.get(), sharingMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_for_bluetooth_device_id(&self, bluetoothDeviceId: &super::BluetoothDeviceId) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorForBluetoothDeviceId)(self as *const _ as *mut _, bluetoothDeviceId as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_for_bluetooth_device_id_with_cache_mode(&self, bluetoothDeviceId: &super::BluetoothDeviceId, cacheMode: super::BluetoothCacheMode) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorForBluetoothDeviceIdWithCacheMode)(self as *const _ as *mut _, bluetoothDeviceId as *const _ as *mut _, cacheMode, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_for_bluetooth_device_id_and_uuid(&self, bluetoothDeviceId: &super::BluetoothDeviceId, serviceUuid: Guid) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorForBluetoothDeviceIdAndUuid)(self as *const _ as *mut _, bluetoothDeviceId as *const _ as *mut _, serviceUuid, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_for_bluetooth_device_id_and_uuid_with_cache_mode(&self, bluetoothDeviceId: &super::BluetoothDeviceId, serviceUuid: Guid, cacheMode: super::BluetoothCacheMode) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorForBluetoothDeviceIdAndUuidWithCacheMode)(self as *const _ as *mut _, bluetoothDeviceId as *const _ as *mut _, serviceUuid, cacheMode, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattDeviceService, 2893773829, 45884, 18383, 153, 15, 107, 143, 85, 119, 223, 113);
RT_INTERFACE!{interface IGattDeviceService(IGattDeviceServiceVtbl): IInspectable(IInspectableVtbl) [IID_IGattDeviceService] {
    fn GetCharacteristics(&self, characteristicUuid: Guid, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattCharacteristic>) -> HRESULT,
    fn GetIncludedServices(&self, serviceUuid: Guid, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattDeviceService>) -> HRESULT,
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Uuid(&self, out: *mut Guid) -> HRESULT,
    fn get_AttributeHandle(&self, out: *mut u16) -> HRESULT
}}
impl IGattDeviceService {
    #[inline] pub unsafe fn get_characteristics(&self, characteristicUuid: Guid) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattCharacteristic>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCharacteristics)(self as *const _ as *mut _, characteristicUuid, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_included_services(&self, serviceUuid: Guid) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattDeviceService>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetIncludedServices)(self as *const _ as *mut _, serviceUuid, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_uuid(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Uuid)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_attribute_handle(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AttributeHandle)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class GattCharacteristic: IGattCharacteristic}
impl RtActivatable<IGattCharacteristicStatics> for GattCharacteristic {}
impl GattCharacteristic {
    #[inline] pub fn convert_short_id_to_uuid(shortId: u16) -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicStatics>>::get_activation_factory().convert_short_id_to_uuid(shortId)
    }}
}
DEFINE_CLSID!(GattCharacteristic(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,67,104,97,114,97,99,116,101,114,105,115,116,105,99,0]) [CLSID_GattCharacteristic]);
DEFINE_IID!(IID_IGattDeviceService2, 4233384459, 2829, 18184, 186, 224, 159, 253, 148, 137, 188, 89);
RT_INTERFACE!{interface IGattDeviceService2(IGattDeviceService2Vtbl): IInspectable(IInspectableVtbl) [IID_IGattDeviceService2] {
    fn get_Device(&self, out: *mut *mut super::BluetoothLEDevice) -> HRESULT,
    fn get_ParentServices(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattDeviceService>) -> HRESULT,
    fn GetAllCharacteristics(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattCharacteristic>) -> HRESULT,
    fn GetAllIncludedServices(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattDeviceService>) -> HRESULT
}}
impl IGattDeviceService2 {
    #[inline] pub unsafe fn get_device(&self) -> Result<ComPtr<super::BluetoothLEDevice>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Device)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_parent_services(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattDeviceService>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ParentServices)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_all_characteristics(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattCharacteristic>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetAllCharacteristics)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_all_included_services(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattDeviceService>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetAllIncludedServices)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattDeviceService3, 2996021584, 3155, 17276, 169, 179, 92, 50, 16, 198, 229, 105);
RT_INTERFACE!{interface IGattDeviceService3(IGattDeviceService3Vtbl): IInspectable(IInspectableVtbl) [IID_IGattDeviceService3] {
    fn get_DeviceAccessInformation(&self, out: *mut *mut super::super::enumeration::DeviceAccessInformation) -> HRESULT,
    fn get_Session(&self, out: *mut *mut GattSession) -> HRESULT,
    fn get_SharingMode(&self, out: *mut GattSharingMode) -> HRESULT,
    fn RequestAccessAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<super::super::enumeration::DeviceAccessStatus>) -> HRESULT,
    fn OpenAsync(&self, sharingMode: GattSharingMode, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattOpenStatus>) -> HRESULT,
    fn GetCharacteristicsAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattCharacteristicsResult>) -> HRESULT,
    fn GetCharacteristicsWithCacheModeAsync(&self, cacheMode: super::BluetoothCacheMode, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattCharacteristicsResult>) -> HRESULT,
    fn GetCharacteristicsForUuidAsync(&self, characteristicUuid: Guid, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattCharacteristicsResult>) -> HRESULT,
    fn GetCharacteristicsForUuidWithCacheModeAsync(&self, characteristicUuid: Guid, cacheMode: super::BluetoothCacheMode, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattCharacteristicsResult>) -> HRESULT,
    fn GetIncludedServicesAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattDeviceServicesResult>) -> HRESULT,
    fn GetIncludedServicesWithCacheModeAsync(&self, cacheMode: super::BluetoothCacheMode, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattDeviceServicesResult>) -> HRESULT,
    fn GetIncludedServicesForUuidAsync(&self, serviceUuid: Guid, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattDeviceServicesResult>) -> HRESULT,
    fn GetIncludedServicesForUuidWithCacheModeAsync(&self, serviceUuid: Guid, cacheMode: super::BluetoothCacheMode, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattDeviceServicesResult>) -> HRESULT
}}
impl IGattDeviceService3 {
    #[inline] pub unsafe fn get_device_access_information(&self) -> Result<ComPtr<super::super::enumeration::DeviceAccessInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceAccessInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_session(&self) -> Result<ComPtr<GattSession>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Session)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sharing_mode(&self) -> Result<GattSharingMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SharingMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn request_access_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<super::super::enumeration::DeviceAccessStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestAccessAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn open_async(&self, sharingMode: GattSharingMode) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattOpenStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).OpenAsync)(self as *const _ as *mut _, sharingMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_characteristics_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattCharacteristicsResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCharacteristicsAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_characteristics_with_cache_mode_async(&self, cacheMode: super::BluetoothCacheMode) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattCharacteristicsResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCharacteristicsWithCacheModeAsync)(self as *const _ as *mut _, cacheMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_characteristics_for_uuid_async(&self, characteristicUuid: Guid) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattCharacteristicsResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCharacteristicsForUuidAsync)(self as *const _ as *mut _, characteristicUuid, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_characteristics_for_uuid_with_cache_mode_async(&self, characteristicUuid: Guid, cacheMode: super::BluetoothCacheMode) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattCharacteristicsResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCharacteristicsForUuidWithCacheModeAsync)(self as *const _ as *mut _, characteristicUuid, cacheMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_included_services_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattDeviceServicesResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetIncludedServicesAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_included_services_with_cache_mode_async(&self, cacheMode: super::BluetoothCacheMode) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattDeviceServicesResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetIncludedServicesWithCacheModeAsync)(self as *const _ as *mut _, cacheMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_included_services_for_uuid_async(&self, serviceUuid: Guid) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattDeviceServicesResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetIncludedServicesForUuidAsync)(self as *const _ as *mut _, serviceUuid, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_included_services_for_uuid_with_cache_mode_async(&self, serviceUuid: Guid, cacheMode: super::BluetoothCacheMode) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattDeviceServicesResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetIncludedServicesForUuidWithCacheModeAsync)(self as *const _ as *mut _, serviceUuid, cacheMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GattCharacteristicsResult: IGattCharacteristicsResult}
DEFINE_IID!(IID_IGattDeviceServicesResult, 387830766, 365, 16797, 131, 138, 87, 108, 244, 117, 163, 216);
RT_INTERFACE!{interface IGattDeviceServicesResult(IGattDeviceServicesResultVtbl): IInspectable(IInspectableVtbl) [IID_IGattDeviceServicesResult] {
    fn get_Status(&self, out: *mut GattCommunicationStatus) -> HRESULT,
    fn get_ProtocolError(&self, out: *mut *mut ::rt::gen::windows::foundation::IReference<u8>) -> HRESULT,
    fn get_Services(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattDeviceService>) -> HRESULT
}}
impl IGattDeviceServicesResult {
    #[inline] pub unsafe fn get_status(&self) -> Result<GattCommunicationStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_protocol_error(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IReference<u8>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ProtocolError)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_services(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattDeviceService>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Services)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattCharacteristicStatics, 1506496707, 22836, 20328, 161, 152, 235, 134, 79, 164, 78, 107);
RT_INTERFACE!{static interface IGattCharacteristicStatics(IGattCharacteristicStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGattCharacteristicStatics] {
    fn ConvertShortIdToUuid(&self, shortId: u16, out: *mut Guid) -> HRESULT
}}
impl IGattCharacteristicStatics {
    #[inline] pub unsafe fn convert_short_id_to_uuid(&self, shortId: u16) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).ConvertShortIdToUuid)(self as *const _ as *mut _, shortId, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattCharacteristic, 1506496705, 22836, 20328, 161, 152, 235, 134, 79, 164, 78, 107);
RT_INTERFACE!{interface IGattCharacteristic(IGattCharacteristicVtbl): IInspectable(IInspectableVtbl) [IID_IGattCharacteristic] {
    fn GetDescriptors(&self, descriptorUuid: Guid, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattDescriptor>) -> HRESULT,
    fn get_CharacteristicProperties(&self, out: *mut GattCharacteristicProperties) -> HRESULT,
    fn get_ProtectionLevel(&self, out: *mut GattProtectionLevel) -> HRESULT,
    fn put_ProtectionLevel(&self, value: GattProtectionLevel) -> HRESULT,
    fn get_UserDescription(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Uuid(&self, out: *mut Guid) -> HRESULT,
    fn get_AttributeHandle(&self, out: *mut u16) -> HRESULT,
    fn get_PresentationFormats(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattPresentationFormat>) -> HRESULT,
    fn ReadValueAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattReadResult>) -> HRESULT,
    fn ReadValueWithCacheModeAsync(&self, cacheMode: super::BluetoothCacheMode, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattReadResult>) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy10(&self) -> (),
    #[cfg(feature="windows-storage")] fn WriteValueAsync(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattCommunicationStatus>) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy11(&self) -> (),
    #[cfg(feature="windows-storage")] fn WriteValueWithOptionAsync(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer, writeOption: GattWriteOption, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattCommunicationStatus>) -> HRESULT,
    fn ReadClientCharacteristicConfigurationDescriptorAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattReadClientCharacteristicConfigurationDescriptorResult>) -> HRESULT,
    fn WriteClientCharacteristicConfigurationDescriptorAsync(&self, clientCharacteristicConfigurationDescriptorValue: GattClientCharacteristicConfigurationDescriptorValue, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattCommunicationStatus>) -> HRESULT,
    fn add_ValueChanged(&self, valueChangedHandler: *mut ::rt::gen::windows::foundation::TypedEventHandler<GattCharacteristic, GattValueChangedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ValueChanged(&self, valueChangedEventCookie: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT
}}
impl IGattCharacteristic {
    #[inline] pub unsafe fn get_descriptors(&self, descriptorUuid: Guid) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattDescriptor>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDescriptors)(self as *const _ as *mut _, descriptorUuid, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_characteristic_properties(&self) -> Result<GattCharacteristicProperties> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CharacteristicProperties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_protection_level(&self) -> Result<GattProtectionLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ProtectionLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_protection_level(&self, value: GattProtectionLevel) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ProtectionLevel)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_user_description(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_UserDescription)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_uuid(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Uuid)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_attribute_handle(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AttributeHandle)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_presentation_formats(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattPresentationFormat>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PresentationFormats)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn read_value_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattReadResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ReadValueAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn read_value_with_cache_mode_async(&self, cacheMode: super::BluetoothCacheMode) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattReadResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ReadValueWithCacheModeAsync)(self as *const _ as *mut _, cacheMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn write_value_async(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattCommunicationStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).WriteValueAsync)(self as *const _ as *mut _, value as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn write_value_with_option_async(&self, value: &::rt::gen::windows::storage::streams::IBuffer, writeOption: GattWriteOption) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattCommunicationStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).WriteValueWithOptionAsync)(self as *const _ as *mut _, value as *const _ as *mut _, writeOption, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn read_client_characteristic_configuration_descriptor_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattReadClientCharacteristicConfigurationDescriptorResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ReadClientCharacteristicConfigurationDescriptorAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn write_client_characteristic_configuration_descriptor_async(&self, clientCharacteristicConfigurationDescriptorValue: GattClientCharacteristicConfigurationDescriptorValue) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattCommunicationStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).WriteClientCharacteristicConfigurationDescriptorAsync)(self as *const _ as *mut _, clientCharacteristicConfigurationDescriptorValue, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_value_changed(&self, valueChangedHandler: &::rt::gen::windows::foundation::TypedEventHandler<GattCharacteristic, GattValueChangedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ValueChanged)(self as *const _ as *mut _, valueChangedHandler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_value_changed(&self, valueChangedEventCookie: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ValueChanged)(self as *const _ as *mut _, valueChangedEventCookie);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class GattDescriptor: IGattDescriptor}
impl RtActivatable<IGattDescriptorStatics> for GattDescriptor {}
impl GattDescriptor {
    #[inline] pub fn convert_short_id_to_uuid(shortId: u16) -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattDescriptorStatics>>::get_activation_factory().convert_short_id_to_uuid(shortId)
    }}
}
DEFINE_CLSID!(GattDescriptor(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,68,101,115,99,114,105,112,116,111,114,0]) [CLSID_GattDescriptor]);
RT_CLASS!{class GattPresentationFormat: IGattPresentationFormat}
impl RtActivatable<IGattPresentationFormatStatics> for GattPresentationFormat {}
impl RtActivatable<IGattPresentationFormatStatics2> for GattPresentationFormat {}
impl GattPresentationFormat {
    #[inline] pub fn get_bluetooth_sig_assigned_numbers() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatStatics>>::get_activation_factory().get_bluetooth_sig_assigned_numbers()
    }}
    #[inline] pub fn from_parts(formatType: u8, exponent: i32, unit: u16, namespaceId: u8, description: u16) -> Result<ComPtr<GattPresentationFormat>> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatStatics2>>::get_activation_factory().from_parts(formatType, exponent, unit, namespaceId, description)
    }}
}
DEFINE_CLSID!(GattPresentationFormat(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,80,114,101,115,101,110,116,97,116,105,111,110,70,111,114,109,97,116,0]) [CLSID_GattPresentationFormat]);
RT_CLASS!{class GattReadResult: IGattReadResult}
RT_CLASS!{class GattReadClientCharacteristicConfigurationDescriptorResult: IGattReadClientCharacteristicConfigurationDescriptorResult}
RT_CLASS!{class GattValueChangedEventArgs: IGattValueChangedEventArgs}
DEFINE_IID!(IID_IGattCharacteristic2, 2920985976, 60422, 18276, 183, 128, 152, 53, 161, 211, 93, 110);
RT_INTERFACE!{interface IGattCharacteristic2(IGattCharacteristic2Vtbl): IInspectable(IInspectableVtbl) [IID_IGattCharacteristic2] {
    fn get_Service(&self, out: *mut *mut GattDeviceService) -> HRESULT,
    fn GetAllDescriptors(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattDescriptor>) -> HRESULT
}}
impl IGattCharacteristic2 {
    #[inline] pub unsafe fn get_service(&self) -> Result<ComPtr<GattDeviceService>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Service)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_all_descriptors(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattDescriptor>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetAllDescriptors)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattCharacteristic3, 1060922942, 37844, 16491, 184, 23, 219, 129, 248, 237, 83, 179);
RT_INTERFACE!{interface IGattCharacteristic3(IGattCharacteristic3Vtbl): IInspectable(IInspectableVtbl) [IID_IGattCharacteristic3] {
    fn GetDescriptorsAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattDescriptorsResult>) -> HRESULT,
    fn GetDescriptorsWithCacheModeAsync(&self, cacheMode: super::BluetoothCacheMode, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattDescriptorsResult>) -> HRESULT,
    fn GetDescriptorsForUuidAsync(&self, descriptorUuid: Guid, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattDescriptorsResult>) -> HRESULT,
    fn GetDescriptorsForUuidWithCacheModeAsync(&self, descriptorUuid: Guid, cacheMode: super::BluetoothCacheMode, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattDescriptorsResult>) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy4(&self) -> (),
    #[cfg(feature="windows-storage")] fn WriteValueWithResultAsync(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattWriteResult>) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy5(&self) -> (),
    #[cfg(feature="windows-storage")] fn WriteValueWithResultAndOptionAsync(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer, writeOption: GattWriteOption, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattWriteResult>) -> HRESULT,
    fn WriteClientCharacteristicConfigurationDescriptorWithResultAsync(&self, clientCharacteristicConfigurationDescriptorValue: GattClientCharacteristicConfigurationDescriptorValue, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattWriteResult>) -> HRESULT
}}
impl IGattCharacteristic3 {
    #[inline] pub unsafe fn get_descriptors_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattDescriptorsResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDescriptorsAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_descriptors_with_cache_mode_async(&self, cacheMode: super::BluetoothCacheMode) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattDescriptorsResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDescriptorsWithCacheModeAsync)(self as *const _ as *mut _, cacheMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_descriptors_for_uuid_async(&self, descriptorUuid: Guid) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattDescriptorsResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDescriptorsForUuidAsync)(self as *const _ as *mut _, descriptorUuid, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_descriptors_for_uuid_with_cache_mode_async(&self, descriptorUuid: Guid, cacheMode: super::BluetoothCacheMode) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattDescriptorsResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDescriptorsForUuidWithCacheModeAsync)(self as *const _ as *mut _, descriptorUuid, cacheMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn write_value_with_result_async(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattWriteResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).WriteValueWithResultAsync)(self as *const _ as *mut _, value as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn write_value_with_result_and_option_async(&self, value: &::rt::gen::windows::storage::streams::IBuffer, writeOption: GattWriteOption) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattWriteResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).WriteValueWithResultAndOptionAsync)(self as *const _ as *mut _, value as *const _ as *mut _, writeOption, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn write_client_characteristic_configuration_descriptor_with_result_async(&self, clientCharacteristicConfigurationDescriptorValue: GattClientCharacteristicConfigurationDescriptorValue) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattWriteResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).WriteClientCharacteristicConfigurationDescriptorWithResultAsync)(self as *const _ as *mut _, clientCharacteristicConfigurationDescriptorValue, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GattDescriptorsResult: IGattDescriptorsResult}
RT_CLASS!{class GattWriteResult: IGattWriteResult}
DEFINE_IID!(IID_IGattCharacteristicsResult, 294949980, 45655, 20286, 157, 183, 246, 139, 201, 169, 174, 242);
RT_INTERFACE!{interface IGattCharacteristicsResult(IGattCharacteristicsResultVtbl): IInspectable(IInspectableVtbl) [IID_IGattCharacteristicsResult] {
    fn get_Status(&self, out: *mut GattCommunicationStatus) -> HRESULT,
    fn get_ProtocolError(&self, out: *mut *mut ::rt::gen::windows::foundation::IReference<u8>) -> HRESULT,
    fn get_Characteristics(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattCharacteristic>) -> HRESULT
}}
impl IGattCharacteristicsResult {
    #[inline] pub unsafe fn get_status(&self) -> Result<GattCommunicationStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_protocol_error(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IReference<u8>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ProtocolError)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_characteristics(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattCharacteristic>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Characteristics)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattDescriptorStatics, 2449825581, 32900, 17220, 180, 194, 40, 77, 225, 154, 133, 6);
RT_INTERFACE!{static interface IGattDescriptorStatics(IGattDescriptorStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGattDescriptorStatics] {
    fn ConvertShortIdToUuid(&self, shortId: u16, out: *mut Guid) -> HRESULT
}}
impl IGattDescriptorStatics {
    #[inline] pub unsafe fn convert_short_id_to_uuid(&self, shortId: u16) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).ConvertShortIdToUuid)(self as *const _ as *mut _, shortId, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattDescriptor, 2449825579, 32900, 17220, 180, 194, 40, 77, 225, 154, 133, 6);
RT_INTERFACE!{interface IGattDescriptor(IGattDescriptorVtbl): IInspectable(IInspectableVtbl) [IID_IGattDescriptor] {
    fn get_ProtectionLevel(&self, out: *mut GattProtectionLevel) -> HRESULT,
    fn put_ProtectionLevel(&self, value: GattProtectionLevel) -> HRESULT,
    fn get_Uuid(&self, out: *mut Guid) -> HRESULT,
    fn get_AttributeHandle(&self, out: *mut u16) -> HRESULT,
    fn ReadValueAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattReadResult>) -> HRESULT,
    fn ReadValueWithCacheModeAsync(&self, cacheMode: super::BluetoothCacheMode, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattReadResult>) -> HRESULT,
    #[cfg(feature="windows-storage")] fn WriteValueAsync(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattCommunicationStatus>) -> HRESULT
}}
impl IGattDescriptor {
    #[inline] pub unsafe fn get_protection_level(&self) -> Result<GattProtectionLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ProtectionLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_protection_level(&self, value: GattProtectionLevel) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ProtectionLevel)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_uuid(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Uuid)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_attribute_handle(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AttributeHandle)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn read_value_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattReadResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ReadValueAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn read_value_with_cache_mode_async(&self, cacheMode: super::BluetoothCacheMode) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattReadResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ReadValueWithCacheModeAsync)(self as *const _ as *mut _, cacheMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn write_value_async(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattCommunicationStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).WriteValueAsync)(self as *const _ as *mut _, value as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattDescriptor2, 2404793657, 54832, 16492, 186, 17, 16, 205, 209, 107, 14, 94);
RT_INTERFACE!{interface IGattDescriptor2(IGattDescriptor2Vtbl): IInspectable(IInspectableVtbl) [IID_IGattDescriptor2] {
    #[cfg(feature="windows-storage")] fn WriteValueWithResultAsync(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattWriteResult>) -> HRESULT
}}
impl IGattDescriptor2 {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn write_value_with_result_async(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattWriteResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).WriteValueWithResultAsync)(self as *const _ as *mut _, value as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattDescriptorsResult, 2613088755, 38375, 17545, 141, 37, 255, 129, 149, 90, 87, 185);
RT_INTERFACE!{interface IGattDescriptorsResult(IGattDescriptorsResultVtbl): IInspectable(IInspectableVtbl) [IID_IGattDescriptorsResult] {
    fn get_Status(&self, out: *mut GattCommunicationStatus) -> HRESULT,
    fn get_ProtocolError(&self, out: *mut *mut ::rt::gen::windows::foundation::IReference<u8>) -> HRESULT,
    fn get_Descriptors(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattDescriptor>) -> HRESULT
}}
impl IGattDescriptorsResult {
    #[inline] pub unsafe fn get_status(&self) -> Result<GattCommunicationStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_protocol_error(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IReference<u8>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ProtocolError)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_descriptors(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattDescriptor>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Descriptors)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattPresentationFormatTypesStatics, 4210145802, 12474, 16540, 190, 247, 207, 251, 109, 3, 184, 251);
RT_INTERFACE!{static interface IGattPresentationFormatTypesStatics(IGattPresentationFormatTypesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGattPresentationFormatTypesStatics] {
    fn get_Boolean(&self, out: *mut u8) -> HRESULT,
    fn get_Bit2(&self, out: *mut u8) -> HRESULT,
    fn get_Nibble(&self, out: *mut u8) -> HRESULT,
    fn get_UInt8(&self, out: *mut u8) -> HRESULT,
    fn get_UInt12(&self, out: *mut u8) -> HRESULT,
    fn get_UInt16(&self, out: *mut u8) -> HRESULT,
    fn get_UInt24(&self, out: *mut u8) -> HRESULT,
    fn get_UInt32(&self, out: *mut u8) -> HRESULT,
    fn get_UInt48(&self, out: *mut u8) -> HRESULT,
    fn get_UInt64(&self, out: *mut u8) -> HRESULT,
    fn get_UInt128(&self, out: *mut u8) -> HRESULT,
    fn get_SInt8(&self, out: *mut u8) -> HRESULT,
    fn get_SInt12(&self, out: *mut u8) -> HRESULT,
    fn get_SInt16(&self, out: *mut u8) -> HRESULT,
    fn get_SInt24(&self, out: *mut u8) -> HRESULT,
    fn get_SInt32(&self, out: *mut u8) -> HRESULT,
    fn get_SInt48(&self, out: *mut u8) -> HRESULT,
    fn get_SInt64(&self, out: *mut u8) -> HRESULT,
    fn get_SInt128(&self, out: *mut u8) -> HRESULT,
    fn get_Float32(&self, out: *mut u8) -> HRESULT,
    fn get_Float64(&self, out: *mut u8) -> HRESULT,
    fn get_SFloat(&self, out: *mut u8) -> HRESULT,
    fn get_Float(&self, out: *mut u8) -> HRESULT,
    fn get_DUInt16(&self, out: *mut u8) -> HRESULT,
    fn get_Utf8(&self, out: *mut u8) -> HRESULT,
    fn get_Utf16(&self, out: *mut u8) -> HRESULT,
    fn get_Struct(&self, out: *mut u8) -> HRESULT
}}
impl IGattPresentationFormatTypesStatics {
    #[inline] pub unsafe fn get_boolean(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Boolean)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bit2(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Bit2)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_nibble(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Nibble)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_uint8(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UInt8)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_uint12(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UInt12)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_uint16(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UInt16)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_uint24(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UInt24)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_uint32(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UInt32)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_uint48(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UInt48)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_uint64(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UInt64)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_uint128(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UInt128)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sint8(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SInt8)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sint12(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SInt12)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sint16(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SInt16)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sint24(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SInt24)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sint32(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SInt32)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sint48(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SInt48)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sint64(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SInt64)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sint128(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SInt128)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_float32(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Float32)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_float64(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Float64)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sfloat(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SFloat)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_float(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Float)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_duint16(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DUInt16)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_utf8(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Utf8)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_utf16(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Utf16)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_struct(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Struct)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{static class GattPresentationFormatTypes}
impl RtActivatable<IGattPresentationFormatTypesStatics> for GattPresentationFormatTypes {}
impl GattPresentationFormatTypes {
    #[inline] pub fn get_boolean() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_boolean()
    }}
    #[inline] pub fn get_bit2() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_bit2()
    }}
    #[inline] pub fn get_nibble() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_nibble()
    }}
    #[inline] pub fn get_uint8() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_uint8()
    }}
    #[inline] pub fn get_uint12() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_uint12()
    }}
    #[inline] pub fn get_uint16() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_uint16()
    }}
    #[inline] pub fn get_uint24() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_uint24()
    }}
    #[inline] pub fn get_uint32() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_uint32()
    }}
    #[inline] pub fn get_uint48() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_uint48()
    }}
    #[inline] pub fn get_uint64() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_uint64()
    }}
    #[inline] pub fn get_uint128() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_uint128()
    }}
    #[inline] pub fn get_sint8() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_sint8()
    }}
    #[inline] pub fn get_sint12() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_sint12()
    }}
    #[inline] pub fn get_sint16() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_sint16()
    }}
    #[inline] pub fn get_sint24() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_sint24()
    }}
    #[inline] pub fn get_sint32() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_sint32()
    }}
    #[inline] pub fn get_sint48() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_sint48()
    }}
    #[inline] pub fn get_sint64() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_sint64()
    }}
    #[inline] pub fn get_sint128() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_sint128()
    }}
    #[inline] pub fn get_float32() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_float32()
    }}
    #[inline] pub fn get_float64() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_float64()
    }}
    #[inline] pub fn get_sfloat() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_sfloat()
    }}
    #[inline] pub fn get_float() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_float()
    }}
    #[inline] pub fn get_duint16() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_duint16()
    }}
    #[inline] pub fn get_utf8() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_utf8()
    }}
    #[inline] pub fn get_utf16() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_utf16()
    }}
    #[inline] pub fn get_struct() -> Result<u8> { unsafe {
        <Self as RtActivatable<IGattPresentationFormatTypesStatics>>::get_activation_factory().get_struct()
    }}
}
DEFINE_CLSID!(GattPresentationFormatTypes(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,80,114,101,115,101,110,116,97,116,105,111,110,70,111,114,109,97,116,84,121,112,101,115,0]) [CLSID_GattPresentationFormatTypes]);
DEFINE_IID!(IID_IGattPresentationFormatStatics, 426573856, 64173, 17884, 174, 91, 42, 195, 24, 78, 132, 219);
RT_INTERFACE!{static interface IGattPresentationFormatStatics(IGattPresentationFormatStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGattPresentationFormatStatics] {
    fn get_BluetoothSigAssignedNumbers(&self, out: *mut u8) -> HRESULT
}}
impl IGattPresentationFormatStatics {
    #[inline] pub unsafe fn get_bluetooth_sig_assigned_numbers(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BluetoothSigAssignedNumbers)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattPresentationFormatStatics2, 2848069395, 47151, 17246, 182, 52, 33, 253, 133, 164, 60, 7);
RT_INTERFACE!{static interface IGattPresentationFormatStatics2(IGattPresentationFormatStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IGattPresentationFormatStatics2] {
    fn FromParts(&self, formatType: u8, exponent: i32, unit: u16, namespaceId: u8, description: u16, out: *mut *mut GattPresentationFormat) -> HRESULT
}}
impl IGattPresentationFormatStatics2 {
    #[inline] pub unsafe fn from_parts(&self, formatType: u8, exponent: i32, unit: u16, namespaceId: u8, description: u16) -> Result<ComPtr<GattPresentationFormat>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromParts)(self as *const _ as *mut _, formatType, exponent, unit, namespaceId, description, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattPresentationFormat, 426573857, 64173, 17884, 174, 91, 42, 195, 24, 78, 132, 219);
RT_INTERFACE!{interface IGattPresentationFormat(IGattPresentationFormatVtbl): IInspectable(IInspectableVtbl) [IID_IGattPresentationFormat] {
    fn get_FormatType(&self, out: *mut u8) -> HRESULT,
    fn get_Exponent(&self, out: *mut i32) -> HRESULT,
    fn get_Unit(&self, out: *mut u16) -> HRESULT,
    fn get_Namespace(&self, out: *mut u8) -> HRESULT,
    fn get_Description(&self, out: *mut u16) -> HRESULT
}}
impl IGattPresentationFormat {
    #[inline] pub unsafe fn get_format_type(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_FormatType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_exponent(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Exponent)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_unit(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Unit)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_namespace(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Namespace)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_description(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Description)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattValueChangedEventArgs, 3525040980, 1763, 20184, 162, 99, 172, 250, 200, 186, 115, 19);
RT_INTERFACE!{interface IGattValueChangedEventArgs(IGattValueChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IGattValueChangedEventArgs] {
    #[cfg(not(feature="windows-storage"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_CharacteristicValue(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    fn get_Timestamp(&self, out: *mut ::rt::gen::windows::foundation::DateTime) -> HRESULT
}}
impl IGattValueChangedEventArgs {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_characteristic_value(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_CharacteristicValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<::rt::gen::windows::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattServiceUuidsStatics, 1841655896, 39610, 17431, 184, 242, 220, 224, 22, 211, 78, 226);
RT_INTERFACE!{static interface IGattServiceUuidsStatics(IGattServiceUuidsStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGattServiceUuidsStatics] {
    fn get_Battery(&self, out: *mut Guid) -> HRESULT,
    fn get_BloodPressure(&self, out: *mut Guid) -> HRESULT,
    fn get_CyclingSpeedAndCadence(&self, out: *mut Guid) -> HRESULT,
    fn get_GenericAccess(&self, out: *mut Guid) -> HRESULT,
    fn get_GenericAttribute(&self, out: *mut Guid) -> HRESULT,
    fn get_Glucose(&self, out: *mut Guid) -> HRESULT,
    fn get_HealthThermometer(&self, out: *mut Guid) -> HRESULT,
    fn get_HeartRate(&self, out: *mut Guid) -> HRESULT,
    fn get_RunningSpeedAndCadence(&self, out: *mut Guid) -> HRESULT
}}
impl IGattServiceUuidsStatics {
    #[inline] pub unsafe fn get_battery(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Battery)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_blood_pressure(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BloodPressure)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cycling_speed_and_cadence(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CyclingSpeedAndCadence)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_generic_access(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GenericAccess)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_generic_attribute(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GenericAttribute)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_glucose(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Glucose)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_health_thermometer(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HealthThermometer)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_heart_rate(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HeartRate)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_running_speed_and_cadence(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RunningSpeedAndCadence)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattServiceUuidsStatics2, 3534656757, 15637, 20345, 156, 12, 234, 175, 166, 117, 21, 92);
RT_INTERFACE!{static interface IGattServiceUuidsStatics2(IGattServiceUuidsStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IGattServiceUuidsStatics2] {
    fn get_AlertNotification(&self, out: *mut Guid) -> HRESULT,
    fn get_CurrentTime(&self, out: *mut Guid) -> HRESULT,
    fn get_CyclingPower(&self, out: *mut Guid) -> HRESULT,
    fn get_DeviceInformation(&self, out: *mut Guid) -> HRESULT,
    fn get_HumanInterfaceDevice(&self, out: *mut Guid) -> HRESULT,
    fn get_ImmediateAlert(&self, out: *mut Guid) -> HRESULT,
    fn get_LinkLoss(&self, out: *mut Guid) -> HRESULT,
    fn get_LocationAndNavigation(&self, out: *mut Guid) -> HRESULT,
    fn get_NextDstChange(&self, out: *mut Guid) -> HRESULT,
    fn get_PhoneAlertStatus(&self, out: *mut Guid) -> HRESULT,
    fn get_ReferenceTimeUpdate(&self, out: *mut Guid) -> HRESULT,
    fn get_ScanParameters(&self, out: *mut Guid) -> HRESULT,
    fn get_TxPower(&self, out: *mut Guid) -> HRESULT
}}
impl IGattServiceUuidsStatics2 {
    #[inline] pub unsafe fn get_alert_notification(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AlertNotification)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_current_time(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CurrentTime)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cycling_power(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CyclingPower)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_information(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DeviceInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_human_interface_device(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HumanInterfaceDevice)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_immediate_alert(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ImmediateAlert)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_link_loss(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LinkLoss)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_location_and_navigation(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LocationAndNavigation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_next_dst_change(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_NextDstChange)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_phone_alert_status(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PhoneAlertStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_reference_time_update(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReferenceTimeUpdate)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_scan_parameters(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ScanParameters)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_tx_power(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TxPower)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{static class GattServiceUuids}
impl RtActivatable<IGattServiceUuidsStatics2> for GattServiceUuids {}
impl RtActivatable<IGattServiceUuidsStatics> for GattServiceUuids {}
impl GattServiceUuids {
    #[inline] pub fn get_alert_notification() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics2>>::get_activation_factory().get_alert_notification()
    }}
    #[inline] pub fn get_current_time() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics2>>::get_activation_factory().get_current_time()
    }}
    #[inline] pub fn get_cycling_power() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics2>>::get_activation_factory().get_cycling_power()
    }}
    #[inline] pub fn get_device_information() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics2>>::get_activation_factory().get_device_information()
    }}
    #[inline] pub fn get_human_interface_device() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics2>>::get_activation_factory().get_human_interface_device()
    }}
    #[inline] pub fn get_immediate_alert() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics2>>::get_activation_factory().get_immediate_alert()
    }}
    #[inline] pub fn get_link_loss() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics2>>::get_activation_factory().get_link_loss()
    }}
    #[inline] pub fn get_location_and_navigation() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics2>>::get_activation_factory().get_location_and_navigation()
    }}
    #[inline] pub fn get_next_dst_change() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics2>>::get_activation_factory().get_next_dst_change()
    }}
    #[inline] pub fn get_phone_alert_status() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics2>>::get_activation_factory().get_phone_alert_status()
    }}
    #[inline] pub fn get_reference_time_update() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics2>>::get_activation_factory().get_reference_time_update()
    }}
    #[inline] pub fn get_scan_parameters() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics2>>::get_activation_factory().get_scan_parameters()
    }}
    #[inline] pub fn get_tx_power() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics2>>::get_activation_factory().get_tx_power()
    }}
    #[inline] pub fn get_battery() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics>>::get_activation_factory().get_battery()
    }}
    #[inline] pub fn get_blood_pressure() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics>>::get_activation_factory().get_blood_pressure()
    }}
    #[inline] pub fn get_cycling_speed_and_cadence() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics>>::get_activation_factory().get_cycling_speed_and_cadence()
    }}
    #[inline] pub fn get_generic_access() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics>>::get_activation_factory().get_generic_access()
    }}
    #[inline] pub fn get_generic_attribute() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics>>::get_activation_factory().get_generic_attribute()
    }}
    #[inline] pub fn get_glucose() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics>>::get_activation_factory().get_glucose()
    }}
    #[inline] pub fn get_health_thermometer() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics>>::get_activation_factory().get_health_thermometer()
    }}
    #[inline] pub fn get_heart_rate() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics>>::get_activation_factory().get_heart_rate()
    }}
    #[inline] pub fn get_running_speed_and_cadence() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattServiceUuidsStatics>>::get_activation_factory().get_running_speed_and_cadence()
    }}
}
DEFINE_CLSID!(GattServiceUuids(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,83,101,114,118,105,99,101,85,117,105,100,115,0]) [CLSID_GattServiceUuids]);
DEFINE_IID!(IID_IGattCharacteristicUuidsStatics, 1492796806, 45534, 18188, 183, 222, 13, 17, 255, 68, 244, 183);
RT_INTERFACE!{static interface IGattCharacteristicUuidsStatics(IGattCharacteristicUuidsStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGattCharacteristicUuidsStatics] {
    fn get_BatteryLevel(&self, out: *mut Guid) -> HRESULT,
    fn get_BloodPressureFeature(&self, out: *mut Guid) -> HRESULT,
    fn get_BloodPressureMeasurement(&self, out: *mut Guid) -> HRESULT,
    fn get_BodySensorLocation(&self, out: *mut Guid) -> HRESULT,
    fn get_CscFeature(&self, out: *mut Guid) -> HRESULT,
    fn get_CscMeasurement(&self, out: *mut Guid) -> HRESULT,
    fn get_GlucoseFeature(&self, out: *mut Guid) -> HRESULT,
    fn get_GlucoseMeasurement(&self, out: *mut Guid) -> HRESULT,
    fn get_GlucoseMeasurementContext(&self, out: *mut Guid) -> HRESULT,
    fn get_HeartRateControlPoint(&self, out: *mut Guid) -> HRESULT,
    fn get_HeartRateMeasurement(&self, out: *mut Guid) -> HRESULT,
    fn get_IntermediateCuffPressure(&self, out: *mut Guid) -> HRESULT,
    fn get_IntermediateTemperature(&self, out: *mut Guid) -> HRESULT,
    fn get_MeasurementInterval(&self, out: *mut Guid) -> HRESULT,
    fn get_RecordAccessControlPoint(&self, out: *mut Guid) -> HRESULT,
    fn get_RscFeature(&self, out: *mut Guid) -> HRESULT,
    fn get_RscMeasurement(&self, out: *mut Guid) -> HRESULT,
    fn get_SCControlPoint(&self, out: *mut Guid) -> HRESULT,
    fn get_SensorLocation(&self, out: *mut Guid) -> HRESULT,
    fn get_TemperatureMeasurement(&self, out: *mut Guid) -> HRESULT,
    fn get_TemperatureType(&self, out: *mut Guid) -> HRESULT
}}
impl IGattCharacteristicUuidsStatics {
    #[inline] pub unsafe fn get_battery_level(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BatteryLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_blood_pressure_feature(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BloodPressureFeature)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_blood_pressure_measurement(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BloodPressureMeasurement)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_body_sensor_location(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BodySensorLocation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_csc_feature(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CscFeature)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_csc_measurement(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CscMeasurement)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_glucose_feature(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GlucoseFeature)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_glucose_measurement(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GlucoseMeasurement)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_glucose_measurement_context(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GlucoseMeasurementContext)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_heart_rate_control_point(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HeartRateControlPoint)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_heart_rate_measurement(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HeartRateMeasurement)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_intermediate_cuff_pressure(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IntermediateCuffPressure)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_intermediate_temperature(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IntermediateTemperature)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_measurement_interval(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MeasurementInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_record_access_control_point(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RecordAccessControlPoint)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_rsc_feature(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RscFeature)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_rsc_measurement(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RscMeasurement)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sccontrol_point(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SCControlPoint)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sensor_location(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SensorLocation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_temperature_measurement(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TemperatureMeasurement)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_temperature_type(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TemperatureType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattCharacteristicUuidsStatics2, 408269861, 54382, 18988, 156, 63, 237, 109, 234, 41, 231, 190);
RT_INTERFACE!{static interface IGattCharacteristicUuidsStatics2(IGattCharacteristicUuidsStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IGattCharacteristicUuidsStatics2] {
    fn get_AlertCategoryId(&self, out: *mut Guid) -> HRESULT,
    fn get_AlertCategoryIdBitMask(&self, out: *mut Guid) -> HRESULT,
    fn get_AlertLevel(&self, out: *mut Guid) -> HRESULT,
    fn get_AlertNotificationControlPoint(&self, out: *mut Guid) -> HRESULT,
    fn get_AlertStatus(&self, out: *mut Guid) -> HRESULT,
    fn get_GapAppearance(&self, out: *mut Guid) -> HRESULT,
    fn get_BootKeyboardInputReport(&self, out: *mut Guid) -> HRESULT,
    fn get_BootKeyboardOutputReport(&self, out: *mut Guid) -> HRESULT,
    fn get_BootMouseInputReport(&self, out: *mut Guid) -> HRESULT,
    fn get_CurrentTime(&self, out: *mut Guid) -> HRESULT,
    fn get_CyclingPowerControlPoint(&self, out: *mut Guid) -> HRESULT,
    fn get_CyclingPowerFeature(&self, out: *mut Guid) -> HRESULT,
    fn get_CyclingPowerMeasurement(&self, out: *mut Guid) -> HRESULT,
    fn get_CyclingPowerVector(&self, out: *mut Guid) -> HRESULT,
    fn get_DateTime(&self, out: *mut Guid) -> HRESULT,
    fn get_DayDateTime(&self, out: *mut Guid) -> HRESULT,
    fn get_DayOfWeek(&self, out: *mut Guid) -> HRESULT,
    fn get_GapDeviceName(&self, out: *mut Guid) -> HRESULT,
    fn get_DstOffset(&self, out: *mut Guid) -> HRESULT,
    fn get_ExactTime256(&self, out: *mut Guid) -> HRESULT,
    fn get_FirmwareRevisionString(&self, out: *mut Guid) -> HRESULT,
    fn get_HardwareRevisionString(&self, out: *mut Guid) -> HRESULT,
    fn get_HidControlPoint(&self, out: *mut Guid) -> HRESULT,
    fn get_HidInformation(&self, out: *mut Guid) -> HRESULT,
    fn get_Ieee1107320601RegulatoryCertificationDataList(&self, out: *mut Guid) -> HRESULT,
    fn get_LnControlPoint(&self, out: *mut Guid) -> HRESULT,
    fn get_LnFeature(&self, out: *mut Guid) -> HRESULT,
    fn get_LocalTimeInformation(&self, out: *mut Guid) -> HRESULT,
    fn get_LocationAndSpeed(&self, out: *mut Guid) -> HRESULT,
    fn get_ManufacturerNameString(&self, out: *mut Guid) -> HRESULT,
    fn get_ModelNumberString(&self, out: *mut Guid) -> HRESULT,
    fn get_Navigation(&self, out: *mut Guid) -> HRESULT,
    fn get_NewAlert(&self, out: *mut Guid) -> HRESULT,
    fn get_GapPeripheralPreferredConnectionParameters(&self, out: *mut Guid) -> HRESULT,
    fn get_GapPeripheralPrivacyFlag(&self, out: *mut Guid) -> HRESULT,
    fn get_PnpId(&self, out: *mut Guid) -> HRESULT,
    fn get_PositionQuality(&self, out: *mut Guid) -> HRESULT,
    fn get_ProtocolMode(&self, out: *mut Guid) -> HRESULT,
    fn get_GapReconnectionAddress(&self, out: *mut Guid) -> HRESULT,
    fn get_ReferenceTimeInformation(&self, out: *mut Guid) -> HRESULT,
    fn get_Report(&self, out: *mut Guid) -> HRESULT,
    fn get_ReportMap(&self, out: *mut Guid) -> HRESULT,
    fn get_RingerControlPoint(&self, out: *mut Guid) -> HRESULT,
    fn get_RingerSetting(&self, out: *mut Guid) -> HRESULT,
    fn get_ScanIntervalWindow(&self, out: *mut Guid) -> HRESULT,
    fn get_ScanRefresh(&self, out: *mut Guid) -> HRESULT,
    fn get_SerialNumberString(&self, out: *mut Guid) -> HRESULT,
    fn get_GattServiceChanged(&self, out: *mut Guid) -> HRESULT,
    fn get_SoftwareRevisionString(&self, out: *mut Guid) -> HRESULT,
    fn get_SupportedNewAlertCategory(&self, out: *mut Guid) -> HRESULT,
    fn get_SupportUnreadAlertCategory(&self, out: *mut Guid) -> HRESULT,
    fn get_SystemId(&self, out: *mut Guid) -> HRESULT,
    fn get_TimeAccuracy(&self, out: *mut Guid) -> HRESULT,
    fn get_TimeSource(&self, out: *mut Guid) -> HRESULT,
    fn get_TimeUpdateControlPoint(&self, out: *mut Guid) -> HRESULT,
    fn get_TimeUpdateState(&self, out: *mut Guid) -> HRESULT,
    fn get_TimeWithDst(&self, out: *mut Guid) -> HRESULT,
    fn get_TimeZone(&self, out: *mut Guid) -> HRESULT,
    fn get_TxPowerLevel(&self, out: *mut Guid) -> HRESULT,
    fn get_UnreadAlertStatus(&self, out: *mut Guid) -> HRESULT
}}
impl IGattCharacteristicUuidsStatics2 {
    #[inline] pub unsafe fn get_alert_category_id(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AlertCategoryId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_alert_category_id_bit_mask(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AlertCategoryIdBitMask)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_alert_level(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AlertLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_alert_notification_control_point(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AlertNotificationControlPoint)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_alert_status(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AlertStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gap_appearance(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GapAppearance)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_boot_keyboard_input_report(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BootKeyboardInputReport)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_boot_keyboard_output_report(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BootKeyboardOutputReport)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_boot_mouse_input_report(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BootMouseInputReport)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_current_time(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CurrentTime)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cycling_power_control_point(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CyclingPowerControlPoint)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cycling_power_feature(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CyclingPowerFeature)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cycling_power_measurement(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CyclingPowerMeasurement)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cycling_power_vector(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CyclingPowerVector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_date_time(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DateTime)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_day_date_time(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DayDateTime)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_day_of_week(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DayOfWeek)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gap_device_name(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GapDeviceName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_dst_offset(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DstOffset)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_exact_time256(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ExactTime256)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_firmware_revision_string(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_FirmwareRevisionString)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_hardware_revision_string(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HardwareRevisionString)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_hid_control_point(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HidControlPoint)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_hid_information(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HidInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ieee1107320601_regulatory_certification_data_list(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ieee1107320601RegulatoryCertificationDataList)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ln_control_point(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LnControlPoint)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ln_feature(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LnFeature)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_local_time_information(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LocalTimeInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_location_and_speed(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LocationAndSpeed)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_manufacturer_name_string(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ManufacturerNameString)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_model_number_string(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ModelNumberString)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_navigation(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Navigation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_new_alert(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_NewAlert)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gap_peripheral_preferred_connection_parameters(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GapPeripheralPreferredConnectionParameters)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gap_peripheral_privacy_flag(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GapPeripheralPrivacyFlag)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pnp_id(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PnpId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_position_quality(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PositionQuality)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_protocol_mode(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ProtocolMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gap_reconnection_address(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GapReconnectionAddress)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_reference_time_information(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReferenceTimeInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Report)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_map(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportMap)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ringer_control_point(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RingerControlPoint)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ringer_setting(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RingerSetting)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_scan_interval_window(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ScanIntervalWindow)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_scan_refresh(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ScanRefresh)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_serial_number_string(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SerialNumberString)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gatt_service_changed(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GattServiceChanged)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_software_revision_string(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SoftwareRevisionString)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_new_alert_category(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SupportedNewAlertCategory)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_support_unread_alert_category(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SupportUnreadAlertCategory)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_system_id(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SystemId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_time_accuracy(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TimeAccuracy)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_time_source(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TimeSource)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_time_update_control_point(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TimeUpdateControlPoint)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_time_update_state(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TimeUpdateState)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_time_with_dst(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TimeWithDst)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_time_zone(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TimeZone)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_tx_power_level(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TxPowerLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_unread_alert_status(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UnreadAlertStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{static class GattCharacteristicUuids}
impl RtActivatable<IGattCharacteristicUuidsStatics2> for GattCharacteristicUuids {}
impl RtActivatable<IGattCharacteristicUuidsStatics> for GattCharacteristicUuids {}
impl GattCharacteristicUuids {
    #[inline] pub fn get_alert_category_id() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_alert_category_id()
    }}
    #[inline] pub fn get_alert_category_id_bit_mask() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_alert_category_id_bit_mask()
    }}
    #[inline] pub fn get_alert_level() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_alert_level()
    }}
    #[inline] pub fn get_alert_notification_control_point() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_alert_notification_control_point()
    }}
    #[inline] pub fn get_alert_status() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_alert_status()
    }}
    #[inline] pub fn get_gap_appearance() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_gap_appearance()
    }}
    #[inline] pub fn get_boot_keyboard_input_report() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_boot_keyboard_input_report()
    }}
    #[inline] pub fn get_boot_keyboard_output_report() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_boot_keyboard_output_report()
    }}
    #[inline] pub fn get_boot_mouse_input_report() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_boot_mouse_input_report()
    }}
    #[inline] pub fn get_current_time() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_current_time()
    }}
    #[inline] pub fn get_cycling_power_control_point() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_cycling_power_control_point()
    }}
    #[inline] pub fn get_cycling_power_feature() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_cycling_power_feature()
    }}
    #[inline] pub fn get_cycling_power_measurement() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_cycling_power_measurement()
    }}
    #[inline] pub fn get_cycling_power_vector() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_cycling_power_vector()
    }}
    #[inline] pub fn get_date_time() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_date_time()
    }}
    #[inline] pub fn get_day_date_time() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_day_date_time()
    }}
    #[inline] pub fn get_day_of_week() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_day_of_week()
    }}
    #[inline] pub fn get_gap_device_name() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_gap_device_name()
    }}
    #[inline] pub fn get_dst_offset() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_dst_offset()
    }}
    #[inline] pub fn get_exact_time256() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_exact_time256()
    }}
    #[inline] pub fn get_firmware_revision_string() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_firmware_revision_string()
    }}
    #[inline] pub fn get_hardware_revision_string() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_hardware_revision_string()
    }}
    #[inline] pub fn get_hid_control_point() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_hid_control_point()
    }}
    #[inline] pub fn get_hid_information() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_hid_information()
    }}
    #[inline] pub fn get_ieee1107320601_regulatory_certification_data_list() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_ieee1107320601_regulatory_certification_data_list()
    }}
    #[inline] pub fn get_ln_control_point() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_ln_control_point()
    }}
    #[inline] pub fn get_ln_feature() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_ln_feature()
    }}
    #[inline] pub fn get_local_time_information() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_local_time_information()
    }}
    #[inline] pub fn get_location_and_speed() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_location_and_speed()
    }}
    #[inline] pub fn get_manufacturer_name_string() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_manufacturer_name_string()
    }}
    #[inline] pub fn get_model_number_string() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_model_number_string()
    }}
    #[inline] pub fn get_navigation() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_navigation()
    }}
    #[inline] pub fn get_new_alert() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_new_alert()
    }}
    #[inline] pub fn get_gap_peripheral_preferred_connection_parameters() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_gap_peripheral_preferred_connection_parameters()
    }}
    #[inline] pub fn get_gap_peripheral_privacy_flag() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_gap_peripheral_privacy_flag()
    }}
    #[inline] pub fn get_pnp_id() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_pnp_id()
    }}
    #[inline] pub fn get_position_quality() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_position_quality()
    }}
    #[inline] pub fn get_protocol_mode() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_protocol_mode()
    }}
    #[inline] pub fn get_gap_reconnection_address() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_gap_reconnection_address()
    }}
    #[inline] pub fn get_reference_time_information() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_reference_time_information()
    }}
    #[inline] pub fn get_report() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_report()
    }}
    #[inline] pub fn get_report_map() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_report_map()
    }}
    #[inline] pub fn get_ringer_control_point() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_ringer_control_point()
    }}
    #[inline] pub fn get_ringer_setting() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_ringer_setting()
    }}
    #[inline] pub fn get_scan_interval_window() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_scan_interval_window()
    }}
    #[inline] pub fn get_scan_refresh() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_scan_refresh()
    }}
    #[inline] pub fn get_serial_number_string() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_serial_number_string()
    }}
    #[inline] pub fn get_gatt_service_changed() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_gatt_service_changed()
    }}
    #[inline] pub fn get_software_revision_string() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_software_revision_string()
    }}
    #[inline] pub fn get_supported_new_alert_category() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_supported_new_alert_category()
    }}
    #[inline] pub fn get_support_unread_alert_category() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_support_unread_alert_category()
    }}
    #[inline] pub fn get_system_id() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_system_id()
    }}
    #[inline] pub fn get_time_accuracy() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_time_accuracy()
    }}
    #[inline] pub fn get_time_source() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_time_source()
    }}
    #[inline] pub fn get_time_update_control_point() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_time_update_control_point()
    }}
    #[inline] pub fn get_time_update_state() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_time_update_state()
    }}
    #[inline] pub fn get_time_with_dst() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_time_with_dst()
    }}
    #[inline] pub fn get_time_zone() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_time_zone()
    }}
    #[inline] pub fn get_tx_power_level() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_tx_power_level()
    }}
    #[inline] pub fn get_unread_alert_status() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics2>>::get_activation_factory().get_unread_alert_status()
    }}
    #[inline] pub fn get_battery_level() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_battery_level()
    }}
    #[inline] pub fn get_blood_pressure_feature() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_blood_pressure_feature()
    }}
    #[inline] pub fn get_blood_pressure_measurement() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_blood_pressure_measurement()
    }}
    #[inline] pub fn get_body_sensor_location() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_body_sensor_location()
    }}
    #[inline] pub fn get_csc_feature() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_csc_feature()
    }}
    #[inline] pub fn get_csc_measurement() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_csc_measurement()
    }}
    #[inline] pub fn get_glucose_feature() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_glucose_feature()
    }}
    #[inline] pub fn get_glucose_measurement() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_glucose_measurement()
    }}
    #[inline] pub fn get_glucose_measurement_context() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_glucose_measurement_context()
    }}
    #[inline] pub fn get_heart_rate_control_point() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_heart_rate_control_point()
    }}
    #[inline] pub fn get_heart_rate_measurement() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_heart_rate_measurement()
    }}
    #[inline] pub fn get_intermediate_cuff_pressure() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_intermediate_cuff_pressure()
    }}
    #[inline] pub fn get_intermediate_temperature() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_intermediate_temperature()
    }}
    #[inline] pub fn get_measurement_interval() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_measurement_interval()
    }}
    #[inline] pub fn get_record_access_control_point() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_record_access_control_point()
    }}
    #[inline] pub fn get_rsc_feature() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_rsc_feature()
    }}
    #[inline] pub fn get_rsc_measurement() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_rsc_measurement()
    }}
    #[inline] pub fn get_sccontrol_point() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_sccontrol_point()
    }}
    #[inline] pub fn get_sensor_location() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_sensor_location()
    }}
    #[inline] pub fn get_temperature_measurement() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_temperature_measurement()
    }}
    #[inline] pub fn get_temperature_type() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattCharacteristicUuidsStatics>>::get_activation_factory().get_temperature_type()
    }}
}
DEFINE_CLSID!(GattCharacteristicUuids(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,67,104,97,114,97,99,116,101,114,105,115,116,105,99,85,117,105,100,115,0]) [CLSID_GattCharacteristicUuids]);
DEFINE_IID!(IID_IGattDescriptorUuidsStatics, 2801296078, 40188, 17137, 145, 133, 255, 55, 183, 81, 129, 211);
RT_INTERFACE!{static interface IGattDescriptorUuidsStatics(IGattDescriptorUuidsStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGattDescriptorUuidsStatics] {
    fn get_CharacteristicAggregateFormat(&self, out: *mut Guid) -> HRESULT,
    fn get_CharacteristicExtendedProperties(&self, out: *mut Guid) -> HRESULT,
    fn get_CharacteristicPresentationFormat(&self, out: *mut Guid) -> HRESULT,
    fn get_CharacteristicUserDescription(&self, out: *mut Guid) -> HRESULT,
    fn get_ClientCharacteristicConfiguration(&self, out: *mut Guid) -> HRESULT,
    fn get_ServerCharacteristicConfiguration(&self, out: *mut Guid) -> HRESULT
}}
impl IGattDescriptorUuidsStatics {
    #[inline] pub unsafe fn get_characteristic_aggregate_format(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CharacteristicAggregateFormat)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_characteristic_extended_properties(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CharacteristicExtendedProperties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_characteristic_presentation_format(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CharacteristicPresentationFormat)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_characteristic_user_description(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CharacteristicUserDescription)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_client_characteristic_configuration(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ClientCharacteristicConfiguration)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_server_characteristic_configuration(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ServerCharacteristicConfiguration)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{static class GattDescriptorUuids}
impl RtActivatable<IGattDescriptorUuidsStatics> for GattDescriptorUuids {}
impl GattDescriptorUuids {
    #[inline] pub fn get_characteristic_aggregate_format() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattDescriptorUuidsStatics>>::get_activation_factory().get_characteristic_aggregate_format()
    }}
    #[inline] pub fn get_characteristic_extended_properties() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattDescriptorUuidsStatics>>::get_activation_factory().get_characteristic_extended_properties()
    }}
    #[inline] pub fn get_characteristic_presentation_format() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattDescriptorUuidsStatics>>::get_activation_factory().get_characteristic_presentation_format()
    }}
    #[inline] pub fn get_characteristic_user_description() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattDescriptorUuidsStatics>>::get_activation_factory().get_characteristic_user_description()
    }}
    #[inline] pub fn get_client_characteristic_configuration() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattDescriptorUuidsStatics>>::get_activation_factory().get_client_characteristic_configuration()
    }}
    #[inline] pub fn get_server_characteristic_configuration() -> Result<Guid> { unsafe {
        <Self as RtActivatable<IGattDescriptorUuidsStatics>>::get_activation_factory().get_server_characteristic_configuration()
    }}
}
DEFINE_CLSID!(GattDescriptorUuids(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,68,101,115,99,114,105,112,116,111,114,85,117,105,100,115,0]) [CLSID_GattDescriptorUuids]);
DEFINE_IID!(IID_IGattReliableWriteTransaction, 1671851783, 6890, 19532, 165, 15, 151, 186, 228, 116, 179, 72);
RT_INTERFACE!{interface IGattReliableWriteTransaction(IGattReliableWriteTransactionVtbl): IInspectable(IInspectableVtbl) [IID_IGattReliableWriteTransaction] {
    #[cfg(not(feature="windows-storage"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-storage")] fn WriteValue(&self, characteristic: *mut GattCharacteristic, value: *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    fn CommitAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattCommunicationStatus>) -> HRESULT
}}
impl IGattReliableWriteTransaction {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn write_value(&self, characteristic: &GattCharacteristic, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).WriteValue)(self as *const _ as *mut _, characteristic as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn commit_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattCommunicationStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CommitAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattReliableWriteTransaction2, 1360083335, 61202, 17967, 159, 178, 161, 164, 58, 103, 148, 22);
RT_INTERFACE!{interface IGattReliableWriteTransaction2(IGattReliableWriteTransaction2Vtbl): IInspectable(IInspectableVtbl) [IID_IGattReliableWriteTransaction2] {
    fn CommitWithResultAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattWriteResult>) -> HRESULT
}}
impl IGattReliableWriteTransaction2 {
    #[inline] pub unsafe fn commit_with_result_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattWriteResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CommitWithResultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GattReliableWriteTransaction: IGattReliableWriteTransaction}
impl RtActivatable<IActivationFactory> for GattReliableWriteTransaction {}
DEFINE_CLSID!(GattReliableWriteTransaction(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,82,101,108,105,97,98,108,101,87,114,105,116,101,84,114,97,110,115,97,99,116,105,111,110,0]) [CLSID_GattReliableWriteTransaction]);
DEFINE_IID!(IID_IGattReadResult, 1671851784, 6890, 19532, 165, 15, 151, 186, 228, 116, 179, 72);
RT_INTERFACE!{interface IGattReadResult(IGattReadResultVtbl): IInspectable(IInspectableVtbl) [IID_IGattReadResult] {
    fn get_Status(&self, out: *mut GattCommunicationStatus) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_Value(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT
}}
impl IGattReadResult {
    #[inline] pub unsafe fn get_status(&self) -> Result<GattCommunicationStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_value(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Value)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattReadResult2, 2702135456, 64323, 18607, 186, 170, 99, 138, 92, 99, 41, 254);
RT_INTERFACE!{interface IGattReadResult2(IGattReadResult2Vtbl): IInspectable(IInspectableVtbl) [IID_IGattReadResult2] {
    fn get_ProtocolError(&self, out: *mut *mut ::rt::gen::windows::foundation::IReference<u8>) -> HRESULT
}}
impl IGattReadResult2 {
    #[inline] pub unsafe fn get_protocol_error(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IReference<u8>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ProtocolError)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattWriteResult, 1234296241, 52011, 17655, 153, 252, 210, 154, 40, 113, 220, 155);
RT_INTERFACE!{interface IGattWriteResult(IGattWriteResultVtbl): IInspectable(IInspectableVtbl) [IID_IGattWriteResult] {
    fn get_Status(&self, out: *mut GattCommunicationStatus) -> HRESULT,
    fn get_ProtocolError(&self, out: *mut *mut ::rt::gen::windows::foundation::IReference<u8>) -> HRESULT
}}
impl IGattWriteResult {
    #[inline] pub unsafe fn get_status(&self) -> Result<GattCommunicationStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_protocol_error(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IReference<u8>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ProtocolError)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattReadClientCharacteristicConfigurationDescriptorResult, 1671851785, 6890, 19532, 165, 15, 151, 186, 228, 116, 179, 72);
RT_INTERFACE!{interface IGattReadClientCharacteristicConfigurationDescriptorResult(IGattReadClientCharacteristicConfigurationDescriptorResultVtbl): IInspectable(IInspectableVtbl) [IID_IGattReadClientCharacteristicConfigurationDescriptorResult] {
    fn get_Status(&self, out: *mut GattCommunicationStatus) -> HRESULT,
    fn get_ClientCharacteristicConfigurationDescriptor(&self, out: *mut GattClientCharacteristicConfigurationDescriptorValue) -> HRESULT
}}
impl IGattReadClientCharacteristicConfigurationDescriptorResult {
    #[inline] pub unsafe fn get_status(&self) -> Result<GattCommunicationStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_client_characteristic_configuration_descriptor(&self) -> Result<GattClientCharacteristicConfigurationDescriptorValue> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ClientCharacteristicConfigurationDescriptor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattReadClientCharacteristicConfigurationDescriptorResult2, 468821405, 47693, 17954, 134, 81, 244, 238, 21, 13, 10, 93);
RT_INTERFACE!{interface IGattReadClientCharacteristicConfigurationDescriptorResult2(IGattReadClientCharacteristicConfigurationDescriptorResult2Vtbl): IInspectable(IInspectableVtbl) [IID_IGattReadClientCharacteristicConfigurationDescriptorResult2] {
    fn get_ProtocolError(&self, out: *mut *mut ::rt::gen::windows::foundation::IReference<u8>) -> HRESULT
}}
impl IGattReadClientCharacteristicConfigurationDescriptorResult2 {
    #[inline] pub unsafe fn get_protocol_error(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IReference<u8>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ProtocolError)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattServiceProviderAdvertisingParameters, 3805163947, 25365, 19490, 155, 215, 120, 29, 188, 61, 141, 130);
RT_INTERFACE!{interface IGattServiceProviderAdvertisingParameters(IGattServiceProviderAdvertisingParametersVtbl): IInspectable(IInspectableVtbl) [IID_IGattServiceProviderAdvertisingParameters] {
    fn put_IsConnectable(&self, value: bool) -> HRESULT,
    fn get_IsConnectable(&self, out: *mut bool) -> HRESULT,
    fn put_IsDiscoverable(&self, value: bool) -> HRESULT,
    fn get_IsDiscoverable(&self, out: *mut bool) -> HRESULT
}}
impl IGattServiceProviderAdvertisingParameters {
    #[inline] pub unsafe fn set_is_connectable(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsConnectable)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_connectable(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsConnectable)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_discoverable(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsDiscoverable)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_discoverable(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDiscoverable)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class GattServiceProviderAdvertisingParameters: IGattServiceProviderAdvertisingParameters}
impl RtActivatable<IActivationFactory> for GattServiceProviderAdvertisingParameters {}
DEFINE_CLSID!(GattServiceProviderAdvertisingParameters(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,83,101,114,118,105,99,101,80,114,111,118,105,100,101,114,65,100,118,101,114,116,105,115,105,110,103,80,97,114,97,109,101,116,101,114,115,0]) [CLSID_GattServiceProviderAdvertisingParameters]);
DEFINE_IID!(IID_IGattLocalCharacteristicParameters, 4210507188, 19711, 17607, 132, 69, 4, 14, 110, 173, 0, 99);
RT_INTERFACE!{interface IGattLocalCharacteristicParameters(IGattLocalCharacteristicParametersVtbl): IInspectable(IInspectableVtbl) [IID_IGattLocalCharacteristicParameters] {
    #[cfg(not(feature="windows-storage"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-storage")] fn put_StaticValue(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_StaticValue(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    fn put_CharacteristicProperties(&self, value: GattCharacteristicProperties) -> HRESULT,
    fn get_CharacteristicProperties(&self, out: *mut GattCharacteristicProperties) -> HRESULT,
    fn put_ReadProtectionLevel(&self, value: GattProtectionLevel) -> HRESULT,
    fn get_ReadProtectionLevel(&self, out: *mut GattProtectionLevel) -> HRESULT,
    fn put_WriteProtectionLevel(&self, value: GattProtectionLevel) -> HRESULT,
    fn get_WriteProtectionLevel(&self, out: *mut GattProtectionLevel) -> HRESULT,
    fn put_UserDescription(&self, value: HSTRING) -> HRESULT,
    fn get_UserDescription(&self, out: *mut HSTRING) -> HRESULT,
    fn get_PresentationFormats(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVector<GattPresentationFormat>) -> HRESULT
}}
impl IGattLocalCharacteristicParameters {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_static_value(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).put_StaticValue)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_static_value(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_StaticValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_characteristic_properties(&self, value: GattCharacteristicProperties) -> Result<()> {
        let hr = ((*self.lpVtbl).put_CharacteristicProperties)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_characteristic_properties(&self) -> Result<GattCharacteristicProperties> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CharacteristicProperties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_read_protection_level(&self, value: GattProtectionLevel) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReadProtectionLevel)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_read_protection_level(&self) -> Result<GattProtectionLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadProtectionLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_write_protection_level(&self, value: GattProtectionLevel) -> Result<()> {
        let hr = ((*self.lpVtbl).put_WriteProtectionLevel)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_write_protection_level(&self) -> Result<GattProtectionLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_WriteProtectionLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_user_description(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_UserDescription)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_user_description(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_UserDescription)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_presentation_formats(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVector<GattPresentationFormat>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PresentationFormats)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GattLocalCharacteristicParameters: IGattLocalCharacteristicParameters}
impl RtActivatable<IActivationFactory> for GattLocalCharacteristicParameters {}
DEFINE_CLSID!(GattLocalCharacteristicParameters(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,76,111,99,97,108,67,104,97,114,97,99,116,101,114,105,115,116,105,99,80,97,114,97,109,101,116,101,114,115,0]) [CLSID_GattLocalCharacteristicParameters]);
DEFINE_IID!(IID_IGattLocalDescriptorParameters, 1608441450, 62401, 19302, 140, 75, 227, 210, 41, 59, 64, 233);
RT_INTERFACE!{interface IGattLocalDescriptorParameters(IGattLocalDescriptorParametersVtbl): IInspectable(IInspectableVtbl) [IID_IGattLocalDescriptorParameters] {
    #[cfg(not(feature="windows-storage"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-storage")] fn put_StaticValue(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_StaticValue(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    fn put_ReadProtectionLevel(&self, value: GattProtectionLevel) -> HRESULT,
    fn get_ReadProtectionLevel(&self, out: *mut GattProtectionLevel) -> HRESULT,
    fn put_WriteProtectionLevel(&self, value: GattProtectionLevel) -> HRESULT,
    fn get_WriteProtectionLevel(&self, out: *mut GattProtectionLevel) -> HRESULT
}}
impl IGattLocalDescriptorParameters {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_static_value(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).put_StaticValue)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_static_value(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_StaticValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_read_protection_level(&self, value: GattProtectionLevel) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReadProtectionLevel)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_read_protection_level(&self) -> Result<GattProtectionLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadProtectionLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_write_protection_level(&self, value: GattProtectionLevel) -> Result<()> {
        let hr = ((*self.lpVtbl).put_WriteProtectionLevel)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_write_protection_level(&self) -> Result<GattProtectionLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_WriteProtectionLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class GattLocalDescriptorParameters: IGattLocalDescriptorParameters}
impl RtActivatable<IActivationFactory> for GattLocalDescriptorParameters {}
DEFINE_CLSID!(GattLocalDescriptorParameters(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,76,111,99,97,108,68,101,115,99,114,105,112,116,111,114,80,97,114,97,109,101,116,101,114,115,0]) [CLSID_GattLocalDescriptorParameters]);
DEFINE_IID!(IID_IGattServiceProviderStatics, 830029923, 21078, 16468, 164, 244, 123, 190, 119, 85, 165, 126);
RT_INTERFACE!{static interface IGattServiceProviderStatics(IGattServiceProviderStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGattServiceProviderStatics] {
    fn CreateAsync(&self, serviceUuid: Guid, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattServiceProviderResult>) -> HRESULT
}}
impl IGattServiceProviderStatics {
    #[inline] pub unsafe fn create_async(&self, serviceUuid: Guid) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattServiceProviderResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateAsync)(self as *const _ as *mut _, serviceUuid, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GattServiceProviderResult: IGattServiceProviderResult}
DEFINE_IID!(IID_IGattServiceProvider, 2015540173, 10377, 20358, 160, 81, 63, 10, 237, 28, 39, 96);
RT_INTERFACE!{interface IGattServiceProvider(IGattServiceProviderVtbl): IInspectable(IInspectableVtbl) [IID_IGattServiceProvider] {
    fn get_Service(&self, out: *mut *mut GattLocalService) -> HRESULT,
    fn get_AdvertisementStatus(&self, out: *mut GattServiceProviderAdvertisementStatus) -> HRESULT,
    fn add_AdvertisementStatusChanged(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<GattServiceProvider, GattServiceProviderAdvertisementStatusChangedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_AdvertisementStatusChanged(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn StartAdvertising(&self) -> HRESULT,
    fn StartAdvertisingWithParameters(&self, parameters: *mut GattServiceProviderAdvertisingParameters) -> HRESULT,
    fn StopAdvertising(&self) -> HRESULT
}}
impl IGattServiceProvider {
    #[inline] pub unsafe fn get_service(&self) -> Result<ComPtr<GattLocalService>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Service)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_advertisement_status(&self) -> Result<GattServiceProviderAdvertisementStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AdvertisementStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_advertisement_status_changed(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<GattServiceProvider, GattServiceProviderAdvertisementStatusChangedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_AdvertisementStatusChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_advertisement_status_changed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_AdvertisementStatusChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn start_advertising(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).StartAdvertising)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn start_advertising_with_parameters(&self, parameters: &GattServiceProviderAdvertisingParameters) -> Result<()> {
        let hr = ((*self.lpVtbl).StartAdvertisingWithParameters)(self as *const _ as *mut _, parameters as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop_advertising(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).StopAdvertising)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class GattLocalService: IGattLocalService}
RT_CLASS!{class GattServiceProvider: IGattServiceProvider}
impl RtActivatable<IGattServiceProviderStatics> for GattServiceProvider {}
impl GattServiceProvider {
    #[inline] pub fn create_async(serviceUuid: Guid) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattServiceProviderResult>>> { unsafe {
        <Self as RtActivatable<IGattServiceProviderStatics>>::get_activation_factory().create_async(serviceUuid)
    }}
}
DEFINE_CLSID!(GattServiceProvider(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,71,101,110,101,114,105,99,65,116,116,114,105,98,117,116,101,80,114,111,102,105,108,101,46,71,97,116,116,83,101,114,118,105,99,101,80,114,111,118,105,100,101,114,0]) [CLSID_GattServiceProvider]);
RT_CLASS!{class GattServiceProviderAdvertisementStatusChangedEventArgs: IGattServiceProviderAdvertisementStatusChangedEventArgs}
DEFINE_IID!(IID_IGattServiceProviderAdvertisementStatusChangedEventArgs, 1504029285, 64033, 20476, 177, 85, 4, 217, 40, 1, 38, 134);
RT_INTERFACE!{interface IGattServiceProviderAdvertisementStatusChangedEventArgs(IGattServiceProviderAdvertisementStatusChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IGattServiceProviderAdvertisementStatusChangedEventArgs] {
    fn get_Error(&self, out: *mut super::BluetoothError) -> HRESULT,
    fn get_Status(&self, out: *mut GattServiceProviderAdvertisementStatus) -> HRESULT
}}
impl IGattServiceProviderAdvertisementStatusChangedEventArgs {
    #[inline] pub unsafe fn get_error(&self) -> Result<super::BluetoothError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Error)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<GattServiceProviderAdvertisementStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattServiceProviderResult, 1984337624, 50494, 17036, 138, 72, 103, 175, 224, 44, 58, 230);
RT_INTERFACE!{interface IGattServiceProviderResult(IGattServiceProviderResultVtbl): IInspectable(IInspectableVtbl) [IID_IGattServiceProviderResult] {
    fn get_Error(&self, out: *mut super::BluetoothError) -> HRESULT,
    fn get_ServiceProvider(&self, out: *mut *mut GattServiceProvider) -> HRESULT
}}
impl IGattServiceProviderResult {
    #[inline] pub unsafe fn get_error(&self) -> Result<super::BluetoothError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Error)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_provider(&self) -> Result<ComPtr<GattServiceProvider>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ServiceProvider)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattLocalService, 4111721048, 63479, 18690, 184, 3, 87, 252, 199, 214, 254, 131);
RT_INTERFACE!{interface IGattLocalService(IGattLocalServiceVtbl): IInspectable(IInspectableVtbl) [IID_IGattLocalService] {
    fn get_Uuid(&self, out: *mut Guid) -> HRESULT,
    fn CreateCharacteristicAsync(&self, characteristicUuid: Guid, parameters: *mut GattLocalCharacteristicParameters, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattLocalCharacteristicResult>) -> HRESULT,
    fn get_Characteristics(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattLocalCharacteristic>) -> HRESULT
}}
impl IGattLocalService {
    #[inline] pub unsafe fn get_uuid(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Uuid)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_characteristic_async(&self, characteristicUuid: Guid, parameters: &GattLocalCharacteristicParameters) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattLocalCharacteristicResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateCharacteristicAsync)(self as *const _ as *mut _, characteristicUuid, parameters as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_characteristics(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattLocalCharacteristic>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Characteristics)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GattLocalCharacteristicResult: IGattLocalCharacteristicResult}
RT_CLASS!{class GattLocalCharacteristic: IGattLocalCharacteristic}
DEFINE_IID!(IID_IGattLocalCharacteristic, 2933798765, 21522, 19828, 146, 168, 141, 235, 133, 38, 130, 156);
RT_INTERFACE!{interface IGattLocalCharacteristic(IGattLocalCharacteristicVtbl): IInspectable(IInspectableVtbl) [IID_IGattLocalCharacteristic] {
    fn get_Uuid(&self, out: *mut Guid) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_StaticValue(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    fn get_CharacteristicProperties(&self, out: *mut GattCharacteristicProperties) -> HRESULT,
    fn get_ReadProtectionLevel(&self, out: *mut GattProtectionLevel) -> HRESULT,
    fn get_WriteProtectionLevel(&self, out: *mut GattProtectionLevel) -> HRESULT,
    fn CreateDescriptorAsync(&self, descriptorUuid: Guid, parameters: *mut GattLocalDescriptorParameters, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattLocalDescriptorResult>) -> HRESULT,
    fn get_Descriptors(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattLocalDescriptor>) -> HRESULT,
    fn get_UserDescription(&self, out: *mut HSTRING) -> HRESULT,
    fn get_PresentationFormats(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattPresentationFormat>) -> HRESULT,
    fn get_SubscribedClients(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GattSubscribedClient>) -> HRESULT,
    fn add_SubscribedClientsChanged(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<GattLocalCharacteristic, IInspectable>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SubscribedClientsChanged(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn add_ReadRequested(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<GattLocalCharacteristic, GattReadRequestedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadRequested(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn add_WriteRequested(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<GattLocalCharacteristic, GattWriteRequestedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_WriteRequested(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    #[cfg(feature="windows-storage")] fn NotifyValueAsync(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<::rt::gen::windows::foundation::collections::IVectorView<GattClientNotificationResult>>) -> HRESULT,
    #[cfg(feature="windows-storage")] fn NotifyValueForSubscribedClientAsync(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer, subscribedClient: *mut GattSubscribedClient, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattClientNotificationResult>) -> HRESULT
}}
impl IGattLocalCharacteristic {
    #[inline] pub unsafe fn get_uuid(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Uuid)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_static_value(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_StaticValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_characteristic_properties(&self) -> Result<GattCharacteristicProperties> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CharacteristicProperties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_read_protection_level(&self) -> Result<GattProtectionLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadProtectionLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_write_protection_level(&self) -> Result<GattProtectionLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_WriteProtectionLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_descriptor_async(&self, descriptorUuid: Guid, parameters: &GattLocalDescriptorParameters) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattLocalDescriptorResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateDescriptorAsync)(self as *const _ as *mut _, descriptorUuid, parameters as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_descriptors(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattLocalDescriptor>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Descriptors)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_user_description(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_UserDescription)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_presentation_formats(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattPresentationFormat>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PresentationFormats)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_subscribed_clients(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GattSubscribedClient>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SubscribedClients)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_subscribed_clients_changed(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<GattLocalCharacteristic, IInspectable>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SubscribedClientsChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_subscribed_clients_changed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SubscribedClientsChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_read_requested(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<GattLocalCharacteristic, GattReadRequestedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_read_requested(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_write_requested(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<GattLocalCharacteristic, GattWriteRequestedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_WriteRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_write_requested(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_WriteRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn notify_value_async(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<::rt::gen::windows::foundation::collections::IVectorView<GattClientNotificationResult>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).NotifyValueAsync)(self as *const _ as *mut _, value as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn notify_value_for_subscribed_client_async(&self, value: &::rt::gen::windows::storage::streams::IBuffer, subscribedClient: &GattSubscribedClient) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattClientNotificationResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).NotifyValueForSubscribedClientAsync)(self as *const _ as *mut _, value as *const _ as *mut _, subscribedClient as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GattLocalDescriptorResult: IGattLocalDescriptorResult}
RT_CLASS!{class GattLocalDescriptor: IGattLocalDescriptor}
RT_CLASS!{class GattSubscribedClient: IGattSubscribedClient}
RT_CLASS!{class GattReadRequestedEventArgs: IGattReadRequestedEventArgs}
RT_CLASS!{class GattWriteRequestedEventArgs: IGattWriteRequestedEventArgs}
RT_CLASS!{class GattClientNotificationResult: IGattClientNotificationResult}
DEFINE_IID!(IID_IGattLocalCharacteristicResult, 2037767835, 368, 17303, 150, 102, 146, 248, 99, 241, 46, 230);
RT_INTERFACE!{interface IGattLocalCharacteristicResult(IGattLocalCharacteristicResultVtbl): IInspectable(IInspectableVtbl) [IID_IGattLocalCharacteristicResult] {
    fn get_Characteristic(&self, out: *mut *mut GattLocalCharacteristic) -> HRESULT,
    fn get_Error(&self, out: *mut super::BluetoothError) -> HRESULT
}}
impl IGattLocalCharacteristicResult {
    #[inline] pub unsafe fn get_characteristic(&self) -> Result<ComPtr<GattLocalCharacteristic>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Characteristic)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_error(&self) -> Result<super::BluetoothError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Error)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattSubscribedClient, 1936625665, 5540, 20162, 146, 72, 227, 242, 13, 70, 59, 233);
RT_INTERFACE!{interface IGattSubscribedClient(IGattSubscribedClientVtbl): IInspectable(IInspectableVtbl) [IID_IGattSubscribedClient] {
    fn get_Session(&self, out: *mut *mut GattSession) -> HRESULT,
    fn get_MaxNotificationSize(&self, out: *mut u16) -> HRESULT,
    fn add_MaxNotificationSizeChanged(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<GattSubscribedClient, IInspectable>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_MaxNotificationSizeChanged(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT
}}
impl IGattSubscribedClient {
    #[inline] pub unsafe fn get_session(&self) -> Result<ComPtr<GattSession>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Session)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_notification_size(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxNotificationSize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_max_notification_size_changed(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<GattSubscribedClient, IInspectable>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_MaxNotificationSizeChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_max_notification_size_changed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_MaxNotificationSizeChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattClientNotificationResult, 1349342617, 274, 16794, 142, 59, 174, 33, 175, 171, 210, 194);
RT_INTERFACE!{interface IGattClientNotificationResult(IGattClientNotificationResultVtbl): IInspectable(IInspectableVtbl) [IID_IGattClientNotificationResult] {
    fn get_SubscribedClient(&self, out: *mut *mut GattSubscribedClient) -> HRESULT,
    fn get_Status(&self, out: *mut GattCommunicationStatus) -> HRESULT,
    fn get_ProtocolError(&self, out: *mut *mut ::rt::gen::windows::foundation::IReference<u8>) -> HRESULT
}}
impl IGattClientNotificationResult {
    #[inline] pub unsafe fn get_subscribed_client(&self) -> Result<ComPtr<GattSubscribedClient>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SubscribedClient)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<GattCommunicationStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_protocol_error(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IReference<u8>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ProtocolError)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattLocalDescriptor, 4102995462, 30877, 19019, 134, 82, 189, 1, 123, 93, 47, 198);
RT_INTERFACE!{interface IGattLocalDescriptor(IGattLocalDescriptorVtbl): IInspectable(IInspectableVtbl) [IID_IGattLocalDescriptor] {
    fn get_Uuid(&self, out: *mut Guid) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_StaticValue(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    fn get_ReadProtectionLevel(&self, out: *mut GattProtectionLevel) -> HRESULT,
    fn get_WriteProtectionLevel(&self, out: *mut GattProtectionLevel) -> HRESULT,
    fn add_ReadRequested(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<GattLocalDescriptor, GattReadRequestedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadRequested(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn add_WriteRequested(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<GattLocalDescriptor, GattWriteRequestedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_WriteRequested(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT
}}
impl IGattLocalDescriptor {
    #[inline] pub unsafe fn get_uuid(&self) -> Result<Guid> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Uuid)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_static_value(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_StaticValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_read_protection_level(&self) -> Result<GattProtectionLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadProtectionLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_write_protection_level(&self) -> Result<GattProtectionLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_WriteProtectionLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_read_requested(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<GattLocalDescriptor, GattReadRequestedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_read_requested(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_write_requested(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<GattLocalDescriptor, GattWriteRequestedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_WriteRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_write_requested(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_WriteRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattLocalDescriptorResult, 928485822, 12831, 17254, 191, 193, 59, 198, 184, 44, 121, 248);
RT_INTERFACE!{interface IGattLocalDescriptorResult(IGattLocalDescriptorResultVtbl): IInspectable(IInspectableVtbl) [IID_IGattLocalDescriptorResult] {
    fn get_Descriptor(&self, out: *mut *mut GattLocalDescriptor) -> HRESULT,
    fn get_Error(&self, out: *mut super::BluetoothError) -> HRESULT
}}
impl IGattLocalDescriptorResult {
    #[inline] pub unsafe fn get_descriptor(&self) -> Result<ComPtr<GattLocalDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Descriptor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_error(&self) -> Result<super::BluetoothError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Error)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattReadRequest, 4057818421, 27341, 17062, 164, 187, 215, 137, 218, 224, 4, 62);
RT_INTERFACE!{interface IGattReadRequest(IGattReadRequestVtbl): IInspectable(IInspectableVtbl) [IID_IGattReadRequest] {
    fn get_Offset(&self, out: *mut u32) -> HRESULT,
    fn get_Length(&self, out: *mut u32) -> HRESULT,
    fn get_State(&self, out: *mut GattRequestState) -> HRESULT,
    fn add_StateChanged(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<GattReadRequest, GattRequestStateChangedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_StateChanged(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy5(&self) -> (),
    #[cfg(feature="windows-storage")] fn RespondWithValue(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    fn RespondWithProtocolError(&self, protocolError: u8) -> HRESULT
}}
impl IGattReadRequest {
    #[inline] pub unsafe fn get_offset(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Offset)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_length(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Length)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_state(&self) -> Result<GattRequestState> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_State)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_state_changed(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<GattReadRequest, GattRequestStateChangedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_StateChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_state_changed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_StateChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn respond_with_value(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).RespondWithValue)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn respond_with_protocol_error(&self, protocolError: u8) -> Result<()> {
        let hr = ((*self.lpVtbl).RespondWithProtocolError)(self as *const _ as *mut _, protocolError);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class GattReadRequest: IGattReadRequest}
RT_CLASS!{class GattRequestStateChangedEventArgs: IGattRequestStateChangedEventArgs}
DEFINE_IID!(IID_IGattWriteRequest, 2931206637, 56879, 20418, 169, 168, 148, 234, 120, 68, 241, 61);
RT_INTERFACE!{interface IGattWriteRequest(IGattWriteRequestVtbl): IInspectable(IInspectableVtbl) [IID_IGattWriteRequest] {
    #[cfg(not(feature="windows-storage"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_Value(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    fn get_Offset(&self, out: *mut u32) -> HRESULT,
    fn get_Option(&self, out: *mut GattWriteOption) -> HRESULT,
    fn get_State(&self, out: *mut GattRequestState) -> HRESULT,
    fn add_StateChanged(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<GattWriteRequest, GattRequestStateChangedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_StateChanged(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn Respond(&self) -> HRESULT,
    fn RespondWithProtocolError(&self, protocolError: u8) -> HRESULT
}}
impl IGattWriteRequest {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_value(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Value)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_offset(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Offset)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_option(&self) -> Result<GattWriteOption> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Option)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_state(&self) -> Result<GattRequestState> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_State)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_state_changed(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<GattWriteRequest, GattRequestStateChangedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_StateChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_state_changed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_StateChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn respond(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Respond)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn respond_with_protocol_error(&self, protocolError: u8) -> Result<()> {
        let hr = ((*self.lpVtbl).RespondWithProtocolError)(self as *const _ as *mut _, protocolError);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class GattWriteRequest: IGattWriteRequest}
DEFINE_IID!(IID_IGattReadRequestedEventArgs, 2471064131, 62364, 18507, 138, 182, 153, 107, 164, 134, 207, 163);
RT_INTERFACE!{interface IGattReadRequestedEventArgs(IGattReadRequestedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IGattReadRequestedEventArgs] {
    fn get_Session(&self, out: *mut *mut GattSession) -> HRESULT,
    fn GetDeferral(&self, out: *mut *mut ::rt::gen::windows::foundation::Deferral) -> HRESULT,
    fn GetRequestAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattReadRequest>) -> HRESULT
}}
impl IGattReadRequestedEventArgs {
    #[inline] pub unsafe fn get_session(&self) -> Result<ComPtr<GattSession>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Session)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_deferral(&self) -> Result<ComPtr<::rt::gen::windows::foundation::Deferral>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeferral)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_request_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattReadRequest>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetRequestAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattWriteRequestedEventArgs, 770476990, 42810, 18202, 148, 213, 3, 125, 234, 221, 8, 6);
RT_INTERFACE!{interface IGattWriteRequestedEventArgs(IGattWriteRequestedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IGattWriteRequestedEventArgs] {
    fn get_Session(&self, out: *mut *mut GattSession) -> HRESULT,
    fn GetDeferral(&self, out: *mut *mut ::rt::gen::windows::foundation::Deferral) -> HRESULT,
    fn GetRequestAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<GattWriteRequest>) -> HRESULT
}}
impl IGattWriteRequestedEventArgs {
    #[inline] pub unsafe fn get_session(&self) -> Result<ComPtr<GattSession>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Session)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_deferral(&self) -> Result<ComPtr<::rt::gen::windows::foundation::Deferral>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeferral)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_request_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<GattWriteRequest>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetRequestAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattRequestStateChangedEventArgs, 3895777580, 10174, 17587, 157, 13, 79, 198, 232, 8, 221, 63);
RT_INTERFACE!{interface IGattRequestStateChangedEventArgs(IGattRequestStateChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IGattRequestStateChangedEventArgs] {
    fn get_State(&self, out: *mut GattRequestState) -> HRESULT,
    fn get_Error(&self, out: *mut super::BluetoothError) -> HRESULT
}}
impl IGattRequestStateChangedEventArgs {
    #[inline] pub unsafe fn get_state(&self) -> Result<GattRequestState> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_State)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_error(&self) -> Result<super::BluetoothError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Error)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
} // Windows.Devices.Bluetooth.GenericAttributeProfile
pub mod advertisement { // Windows.Devices.Bluetooth.Advertisement
use ::prelude::*;
RT_ENUM! { enum BluetoothLEScanningMode: i32 {
    Passive (BluetoothLEScanningMode_Passive) = 0, Active (BluetoothLEScanningMode_Active) = 1,
}}
RT_ENUM! { enum BluetoothLEAdvertisementFlags: u32 {
    None (BluetoothLEAdvertisementFlags_None) = 0, LimitedDiscoverableMode (BluetoothLEAdvertisementFlags_LimitedDiscoverableMode) = 1, GeneralDiscoverableMode (BluetoothLEAdvertisementFlags_GeneralDiscoverableMode) = 2, ClassicNotSupported (BluetoothLEAdvertisementFlags_ClassicNotSupported) = 4, DualModeControllerCapable (BluetoothLEAdvertisementFlags_DualModeControllerCapable) = 8, DualModeHostCapable (BluetoothLEAdvertisementFlags_DualModeHostCapable) = 16,
}}
RT_ENUM! { enum BluetoothLEAdvertisementType: i32 {
    ConnectableUndirected (BluetoothLEAdvertisementType_ConnectableUndirected) = 0, ConnectableDirected (BluetoothLEAdvertisementType_ConnectableDirected) = 1, ScannableUndirected (BluetoothLEAdvertisementType_ScannableUndirected) = 2, NonConnectableUndirected (BluetoothLEAdvertisementType_NonConnectableUndirected) = 3, ScanResponse (BluetoothLEAdvertisementType_ScanResponse) = 4,
}}
RT_ENUM! { enum BluetoothLEAdvertisementWatcherStatus: i32 {
    Created (BluetoothLEAdvertisementWatcherStatus_Created) = 0, Started (BluetoothLEAdvertisementWatcherStatus_Started) = 1, Stopping (BluetoothLEAdvertisementWatcherStatus_Stopping) = 2, Stopped (BluetoothLEAdvertisementWatcherStatus_Stopped) = 3, Aborted (BluetoothLEAdvertisementWatcherStatus_Aborted) = 4,
}}
DEFINE_IID!(IID_IBluetoothLEAdvertisement, 107983543, 13265, 20093, 131, 103, 207, 129, 208, 247, 150, 83);
RT_INTERFACE!{interface IBluetoothLEAdvertisement(IBluetoothLEAdvertisementVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisement] {
    fn get_Flags(&self, out: *mut *mut ::rt::gen::windows::foundation::IReference<BluetoothLEAdvertisementFlags>) -> HRESULT,
    fn put_Flags(&self, value: *mut ::rt::gen::windows::foundation::IReference<BluetoothLEAdvertisementFlags>) -> HRESULT,
    fn get_LocalName(&self, out: *mut HSTRING) -> HRESULT,
    fn put_LocalName(&self, value: HSTRING) -> HRESULT,
    fn get_ServiceUuids(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVector<Guid>) -> HRESULT,
    fn get_ManufacturerData(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVector<BluetoothLEManufacturerData>) -> HRESULT,
    fn get_DataSections(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVector<BluetoothLEAdvertisementDataSection>) -> HRESULT,
    fn GetManufacturerDataByCompanyId(&self, companyId: u16, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<BluetoothLEManufacturerData>) -> HRESULT,
    fn GetSectionsByType(&self, type_: u8, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<BluetoothLEAdvertisementDataSection>) -> HRESULT
}}
impl IBluetoothLEAdvertisement {
    #[inline] pub unsafe fn get_flags(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IReference<BluetoothLEAdvertisementFlags>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Flags)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_flags(&self, value: &::rt::gen::windows::foundation::IReference<BluetoothLEAdvertisementFlags>) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Flags)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_local_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_LocalName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_local_name(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_LocalName)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_uuids(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVector<Guid>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ServiceUuids)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_manufacturer_data(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVector<BluetoothLEManufacturerData>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ManufacturerData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_data_sections(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVector<BluetoothLEAdvertisementDataSection>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DataSections)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_manufacturer_data_by_company_id(&self, companyId: u16) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<BluetoothLEManufacturerData>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetManufacturerDataByCompanyId)(self as *const _ as *mut _, companyId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sections_by_type(&self, type_: u8) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<BluetoothLEAdvertisementDataSection>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetSectionsByType)(self as *const _ as *mut _, type_, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothLEManufacturerData: IBluetoothLEManufacturerData}
impl RtActivatable<IBluetoothLEManufacturerDataFactory> for BluetoothLEManufacturerData {}
impl RtActivatable<IActivationFactory> for BluetoothLEManufacturerData {}
impl BluetoothLEManufacturerData {
    #[cfg(feature="windows-storage")] #[inline] pub fn create(companyId: u16, data: &::rt::gen::windows::storage::streams::IBuffer) -> Result<ComPtr<BluetoothLEManufacturerData>> { unsafe {
        <Self as RtActivatable<IBluetoothLEManufacturerDataFactory>>::get_activation_factory().create(companyId, data)
    }}
}
DEFINE_CLSID!(BluetoothLEManufacturerData(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,65,100,118,101,114,116,105,115,101,109,101,110,116,46,66,108,117,101,116,111,111,116,104,76,69,77,97,110,117,102,97,99,116,117,114,101,114,68,97,116,97,0]) [CLSID_BluetoothLEManufacturerData]);
RT_CLASS!{class BluetoothLEAdvertisementDataSection: IBluetoothLEAdvertisementDataSection}
impl RtActivatable<IBluetoothLEAdvertisementDataSectionFactory> for BluetoothLEAdvertisementDataSection {}
impl RtActivatable<IActivationFactory> for BluetoothLEAdvertisementDataSection {}
impl BluetoothLEAdvertisementDataSection {
    #[cfg(feature="windows-storage")] #[inline] pub fn create(dataType: u8, data: &::rt::gen::windows::storage::streams::IBuffer) -> Result<ComPtr<BluetoothLEAdvertisementDataSection>> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataSectionFactory>>::get_activation_factory().create(dataType, data)
    }}
}
DEFINE_CLSID!(BluetoothLEAdvertisementDataSection(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,65,100,118,101,114,116,105,115,101,109,101,110,116,46,66,108,117,101,116,111,111,116,104,76,69,65,100,118,101,114,116,105,115,101,109,101,110,116,68,97,116,97,83,101,99,116,105,111,110,0]) [CLSID_BluetoothLEAdvertisementDataSection]);
RT_CLASS!{class BluetoothLEAdvertisement: IBluetoothLEAdvertisement}
impl RtActivatable<IActivationFactory> for BluetoothLEAdvertisement {}
DEFINE_CLSID!(BluetoothLEAdvertisement(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,65,100,118,101,114,116,105,115,101,109,101,110,116,46,66,108,117,101,116,111,111,116,104,76,69,65,100,118,101,114,116,105,115,101,109,101,110,116,0]) [CLSID_BluetoothLEAdvertisement]);
DEFINE_IID!(IID_IBluetoothLEAdvertisementFilter, 320778451, 53326, 18353, 131, 126, 73, 64, 91, 246, 248, 15);
RT_INTERFACE!{interface IBluetoothLEAdvertisementFilter(IBluetoothLEAdvertisementFilterVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementFilter] {
    fn get_Advertisement(&self, out: *mut *mut BluetoothLEAdvertisement) -> HRESULT,
    fn put_Advertisement(&self, value: *mut BluetoothLEAdvertisement) -> HRESULT,
    fn get_BytePatterns(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVector<BluetoothLEAdvertisementBytePattern>) -> HRESULT
}}
impl IBluetoothLEAdvertisementFilter {
    #[inline] pub unsafe fn get_advertisement(&self) -> Result<ComPtr<BluetoothLEAdvertisement>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Advertisement)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_advertisement(&self, value: &BluetoothLEAdvertisement) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Advertisement)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_byte_patterns(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVector<BluetoothLEAdvertisementBytePattern>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BytePatterns)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothLEAdvertisementBytePattern: IBluetoothLEAdvertisementBytePattern}
impl RtActivatable<IBluetoothLEAdvertisementBytePatternFactory> for BluetoothLEAdvertisementBytePattern {}
impl RtActivatable<IActivationFactory> for BluetoothLEAdvertisementBytePattern {}
impl BluetoothLEAdvertisementBytePattern {
    #[cfg(feature="windows-storage")] #[inline] pub fn create(dataType: u8, offset: i16, data: &::rt::gen::windows::storage::streams::IBuffer) -> Result<ComPtr<BluetoothLEAdvertisementBytePattern>> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementBytePatternFactory>>::get_activation_factory().create(dataType, offset, data)
    }}
}
DEFINE_CLSID!(BluetoothLEAdvertisementBytePattern(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,65,100,118,101,114,116,105,115,101,109,101,110,116,46,66,108,117,101,116,111,111,116,104,76,69,65,100,118,101,114,116,105,115,101,109,101,110,116,66,121,116,101,80,97,116,116,101,114,110,0]) [CLSID_BluetoothLEAdvertisementBytePattern]);
RT_CLASS!{class BluetoothLEAdvertisementFilter: IBluetoothLEAdvertisementFilter}
impl RtActivatable<IActivationFactory> for BluetoothLEAdvertisementFilter {}
DEFINE_CLSID!(BluetoothLEAdvertisementFilter(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,65,100,118,101,114,116,105,115,101,109,101,110,116,46,66,108,117,101,116,111,111,116,104,76,69,65,100,118,101,114,116,105,115,101,109,101,110,116,70,105,108,116,101,114,0]) [CLSID_BluetoothLEAdvertisementFilter]);
DEFINE_IID!(IID_IBluetoothLEAdvertisementWatcherStoppedEventArgs, 3712022605, 59321, 17379, 156, 4, 6, 133, 208, 133, 253, 140);
RT_INTERFACE!{interface IBluetoothLEAdvertisementWatcherStoppedEventArgs(IBluetoothLEAdvertisementWatcherStoppedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementWatcherStoppedEventArgs] {
    fn get_Error(&self, out: *mut super::BluetoothError) -> HRESULT
}}
impl IBluetoothLEAdvertisementWatcherStoppedEventArgs {
    #[inline] pub unsafe fn get_error(&self) -> Result<super::BluetoothError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Error)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothLEAdvertisementWatcherStoppedEventArgs: IBluetoothLEAdvertisementWatcherStoppedEventArgs}
DEFINE_IID!(IID_IBluetoothLEAdvertisementWatcherFactory, 2595171670, 14764, 17726, 179, 42, 133, 198, 87, 224, 23, 241);
RT_INTERFACE!{static interface IBluetoothLEAdvertisementWatcherFactory(IBluetoothLEAdvertisementWatcherFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementWatcherFactory] {
    fn Create(&self, advertisementFilter: *mut BluetoothLEAdvertisementFilter, out: *mut *mut BluetoothLEAdvertisementWatcher) -> HRESULT
}}
impl IBluetoothLEAdvertisementWatcherFactory {
    #[inline] pub unsafe fn create(&self, advertisementFilter: &BluetoothLEAdvertisementFilter) -> Result<ComPtr<BluetoothLEAdvertisementWatcher>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, advertisementFilter as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothLEAdvertisementWatcher: IBluetoothLEAdvertisementWatcher}
impl RtActivatable<IBluetoothLEAdvertisementWatcherFactory> for BluetoothLEAdvertisementWatcher {}
impl RtActivatable<IActivationFactory> for BluetoothLEAdvertisementWatcher {}
impl BluetoothLEAdvertisementWatcher {
    #[inline] pub fn create(advertisementFilter: &BluetoothLEAdvertisementFilter) -> Result<ComPtr<BluetoothLEAdvertisementWatcher>> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementWatcherFactory>>::get_activation_factory().create(advertisementFilter)
    }}
}
DEFINE_CLSID!(BluetoothLEAdvertisementWatcher(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,65,100,118,101,114,116,105,115,101,109,101,110,116,46,66,108,117,101,116,111,111,116,104,76,69,65,100,118,101,114,116,105,115,101,109,101,110,116,87,97,116,99,104,101,114,0]) [CLSID_BluetoothLEAdvertisementWatcher]);
DEFINE_IID!(IID_IBluetoothLEAdvertisementWatcher, 2796303215, 62419, 17047, 141, 108, 200, 30, 166, 98, 63, 64);
RT_INTERFACE!{interface IBluetoothLEAdvertisementWatcher(IBluetoothLEAdvertisementWatcherVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementWatcher] {
    fn get_MinSamplingInterval(&self, out: *mut ::rt::gen::windows::foundation::TimeSpan) -> HRESULT,
    fn get_MaxSamplingInterval(&self, out: *mut ::rt::gen::windows::foundation::TimeSpan) -> HRESULT,
    fn get_MinOutOfRangeTimeout(&self, out: *mut ::rt::gen::windows::foundation::TimeSpan) -> HRESULT,
    fn get_MaxOutOfRangeTimeout(&self, out: *mut ::rt::gen::windows::foundation::TimeSpan) -> HRESULT,
    fn get_Status(&self, out: *mut BluetoothLEAdvertisementWatcherStatus) -> HRESULT,
    fn get_ScanningMode(&self, out: *mut BluetoothLEScanningMode) -> HRESULT,
    fn put_ScanningMode(&self, value: BluetoothLEScanningMode) -> HRESULT,
    fn get_SignalStrengthFilter(&self, out: *mut *mut super::BluetoothSignalStrengthFilter) -> HRESULT,
    fn put_SignalStrengthFilter(&self, value: *mut super::BluetoothSignalStrengthFilter) -> HRESULT,
    fn get_AdvertisementFilter(&self, out: *mut *mut BluetoothLEAdvertisementFilter) -> HRESULT,
    fn put_AdvertisementFilter(&self, value: *mut BluetoothLEAdvertisementFilter) -> HRESULT,
    fn Start(&self) -> HRESULT,
    fn Stop(&self) -> HRESULT,
    fn add_Received(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<BluetoothLEAdvertisementWatcher, BluetoothLEAdvertisementReceivedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Received(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn add_Stopped(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<BluetoothLEAdvertisementWatcher, BluetoothLEAdvertisementWatcherStoppedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Stopped(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT
}}
impl IBluetoothLEAdvertisementWatcher {
    #[inline] pub unsafe fn get_min_sampling_interval(&self) -> Result<::rt::gen::windows::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinSamplingInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_sampling_interval(&self) -> Result<::rt::gen::windows::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxSamplingInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_min_out_of_range_timeout(&self) -> Result<::rt::gen::windows::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinOutOfRangeTimeout)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_out_of_range_timeout(&self) -> Result<::rt::gen::windows::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxOutOfRangeTimeout)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<BluetoothLEAdvertisementWatcherStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_scanning_mode(&self) -> Result<BluetoothLEScanningMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ScanningMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_scanning_mode(&self, value: BluetoothLEScanningMode) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ScanningMode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_signal_strength_filter(&self) -> Result<ComPtr<super::BluetoothSignalStrengthFilter>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SignalStrengthFilter)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_signal_strength_filter(&self, value: &super::BluetoothSignalStrengthFilter) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SignalStrengthFilter)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_advertisement_filter(&self) -> Result<ComPtr<BluetoothLEAdvertisementFilter>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AdvertisementFilter)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_advertisement_filter(&self, value: &BluetoothLEAdvertisementFilter) -> Result<()> {
        let hr = ((*self.lpVtbl).put_AdvertisementFilter)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Stop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_received(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<BluetoothLEAdvertisementWatcher, BluetoothLEAdvertisementReceivedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Received)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_received(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Received)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_stopped(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<BluetoothLEAdvertisementWatcher, BluetoothLEAdvertisementWatcherStoppedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Stopped)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_stopped(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Stopped)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothLEAdvertisementReceivedEventArgs: IBluetoothLEAdvertisementReceivedEventArgs}
DEFINE_IID!(IID_IBluetoothLEAdvertisementReceivedEventArgs, 664305119, 58774, 16830, 141, 67, 158, 103, 49, 212, 169, 19);
RT_INTERFACE!{interface IBluetoothLEAdvertisementReceivedEventArgs(IBluetoothLEAdvertisementReceivedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementReceivedEventArgs] {
    fn get_RawSignalStrengthInDBm(&self, out: *mut i16) -> HRESULT,
    fn get_BluetoothAddress(&self, out: *mut u64) -> HRESULT,
    fn get_AdvertisementType(&self, out: *mut BluetoothLEAdvertisementType) -> HRESULT,
    fn get_Timestamp(&self, out: *mut ::rt::gen::windows::foundation::DateTime) -> HRESULT,
    fn get_Advertisement(&self, out: *mut *mut BluetoothLEAdvertisement) -> HRESULT
}}
impl IBluetoothLEAdvertisementReceivedEventArgs {
    #[inline] pub unsafe fn get_raw_signal_strength_in_dbm(&self) -> Result<i16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RawSignalStrengthInDBm)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bluetooth_address(&self) -> Result<u64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BluetoothAddress)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_advertisement_type(&self) -> Result<BluetoothLEAdvertisementType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AdvertisementType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<::rt::gen::windows::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_advertisement(&self) -> Result<ComPtr<BluetoothLEAdvertisement>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Advertisement)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothLEAdvertisementDataSectionFactory, 3886287170, 43077, 16453, 191, 126, 62, 153, 113, 219, 138, 107);
RT_INTERFACE!{static interface IBluetoothLEAdvertisementDataSectionFactory(IBluetoothLEAdvertisementDataSectionFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementDataSectionFactory] {
    #[cfg(feature="windows-storage")] fn Create(&self, dataType: u8, data: *mut ::rt::gen::windows::storage::streams::IBuffer, out: *mut *mut BluetoothLEAdvertisementDataSection) -> HRESULT
}}
impl IBluetoothLEAdvertisementDataSectionFactory {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn create(&self, dataType: u8, data: &::rt::gen::windows::storage::streams::IBuffer) -> Result<ComPtr<BluetoothLEAdvertisementDataSection>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, dataType, data as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothLEAdvertisementDataSection, 3609277204, 14915, 16633, 182, 240, 146, 191, 239, 195, 74, 227);
RT_INTERFACE!{interface IBluetoothLEAdvertisementDataSection(IBluetoothLEAdvertisementDataSectionVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementDataSection] {
    fn get_DataType(&self, out: *mut u8) -> HRESULT,
    fn put_DataType(&self, value: u8) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_Data(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    #[cfg(feature="windows-storage")] fn put_Data(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT
}}
impl IBluetoothLEAdvertisementDataSection {
    #[inline] pub unsafe fn get_data_type(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DataType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_data_type(&self, value: u8) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DataType)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_data(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Data)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_data(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Data)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothLEManufacturerDataFactory, 3231398392, 12698, 17438, 141, 229, 102, 168, 30, 135, 122, 108);
RT_INTERFACE!{static interface IBluetoothLEManufacturerDataFactory(IBluetoothLEManufacturerDataFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEManufacturerDataFactory] {
    #[cfg(feature="windows-storage")] fn Create(&self, companyId: u16, data: *mut ::rt::gen::windows::storage::streams::IBuffer, out: *mut *mut BluetoothLEManufacturerData) -> HRESULT
}}
impl IBluetoothLEManufacturerDataFactory {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn create(&self, companyId: u16, data: &::rt::gen::windows::storage::streams::IBuffer) -> Result<ComPtr<BluetoothLEManufacturerData>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, companyId, data as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothLEManufacturerData, 2435693080, 26979, 17715, 176, 97, 70, 148, 218, 251, 52, 229);
RT_INTERFACE!{interface IBluetoothLEManufacturerData(IBluetoothLEManufacturerDataVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEManufacturerData] {
    fn get_CompanyId(&self, out: *mut u16) -> HRESULT,
    fn put_CompanyId(&self, value: u16) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_Data(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    #[cfg(feature="windows-storage")] fn put_Data(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT
}}
impl IBluetoothLEManufacturerData {
    #[inline] pub unsafe fn get_company_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CompanyId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_company_id(&self, value: u16) -> Result<()> {
        let hr = ((*self.lpVtbl).put_CompanyId)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_data(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Data)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_data(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Data)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothLEAdvertisementBytePatternFactory, 3269610867, 64860, 20163, 190, 42, 156, 166, 250, 17, 183, 189);
RT_INTERFACE!{static interface IBluetoothLEAdvertisementBytePatternFactory(IBluetoothLEAdvertisementBytePatternFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementBytePatternFactory] {
    #[cfg(feature="windows-storage")] fn Create(&self, dataType: u8, offset: i16, data: *mut ::rt::gen::windows::storage::streams::IBuffer, out: *mut *mut BluetoothLEAdvertisementBytePattern) -> HRESULT
}}
impl IBluetoothLEAdvertisementBytePatternFactory {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn create(&self, dataType: u8, offset: i16, data: &::rt::gen::windows::storage::streams::IBuffer) -> Result<ComPtr<BluetoothLEAdvertisementBytePattern>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, dataType, offset, data as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothLEAdvertisementBytePattern, 4227520498, 47557, 18952, 188, 81, 80, 47, 142, 246, 138, 121);
RT_INTERFACE!{interface IBluetoothLEAdvertisementBytePattern(IBluetoothLEAdvertisementBytePatternVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementBytePattern] {
    fn get_DataType(&self, out: *mut u8) -> HRESULT,
    fn put_DataType(&self, value: u8) -> HRESULT,
    fn get_Offset(&self, out: *mut i16) -> HRESULT,
    fn put_Offset(&self, value: i16) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_Data(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    #[cfg(feature="windows-storage")] fn put_Data(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT
}}
impl IBluetoothLEAdvertisementBytePattern {
    #[inline] pub unsafe fn get_data_type(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DataType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_data_type(&self, value: u8) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DataType)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_offset(&self) -> Result<i16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Offset)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_offset(&self, value: i16) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Offset)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_data(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Data)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_data(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Data)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBluetoothLEAdvertisementDataTypesStatics, 1001801519, 1542, 17227, 167, 110, 116, 21, 159, 6, 132, 211);
RT_INTERFACE!{static interface IBluetoothLEAdvertisementDataTypesStatics(IBluetoothLEAdvertisementDataTypesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementDataTypesStatics] {
    fn get_Flags(&self, out: *mut u8) -> HRESULT,
    fn get_IncompleteService16BitUuids(&self, out: *mut u8) -> HRESULT,
    fn get_CompleteService16BitUuids(&self, out: *mut u8) -> HRESULT,
    fn get_IncompleteService32BitUuids(&self, out: *mut u8) -> HRESULT,
    fn get_CompleteService32BitUuids(&self, out: *mut u8) -> HRESULT,
    fn get_IncompleteService128BitUuids(&self, out: *mut u8) -> HRESULT,
    fn get_CompleteService128BitUuids(&self, out: *mut u8) -> HRESULT,
    fn get_ShortenedLocalName(&self, out: *mut u8) -> HRESULT,
    fn get_CompleteLocalName(&self, out: *mut u8) -> HRESULT,
    fn get_TxPowerLevel(&self, out: *mut u8) -> HRESULT,
    fn get_SlaveConnectionIntervalRange(&self, out: *mut u8) -> HRESULT,
    fn get_ServiceSolicitation16BitUuids(&self, out: *mut u8) -> HRESULT,
    fn get_ServiceSolicitation32BitUuids(&self, out: *mut u8) -> HRESULT,
    fn get_ServiceSolicitation128BitUuids(&self, out: *mut u8) -> HRESULT,
    fn get_ServiceData16BitUuids(&self, out: *mut u8) -> HRESULT,
    fn get_ServiceData32BitUuids(&self, out: *mut u8) -> HRESULT,
    fn get_ServiceData128BitUuids(&self, out: *mut u8) -> HRESULT,
    fn get_PublicTargetAddress(&self, out: *mut u8) -> HRESULT,
    fn get_RandomTargetAddress(&self, out: *mut u8) -> HRESULT,
    fn get_Appearance(&self, out: *mut u8) -> HRESULT,
    fn get_AdvertisingInterval(&self, out: *mut u8) -> HRESULT,
    fn get_ManufacturerSpecificData(&self, out: *mut u8) -> HRESULT
}}
impl IBluetoothLEAdvertisementDataTypesStatics {
    #[inline] pub unsafe fn get_flags(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Flags)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_incomplete_service16_bit_uuids(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IncompleteService16BitUuids)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_complete_service16_bit_uuids(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CompleteService16BitUuids)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_incomplete_service32_bit_uuids(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IncompleteService32BitUuids)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_complete_service32_bit_uuids(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CompleteService32BitUuids)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_incomplete_service128_bit_uuids(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IncompleteService128BitUuids)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_complete_service128_bit_uuids(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CompleteService128BitUuids)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_shortened_local_name(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ShortenedLocalName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_complete_local_name(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CompleteLocalName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_tx_power_level(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TxPowerLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_slave_connection_interval_range(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SlaveConnectionIntervalRange)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_solicitation16_bit_uuids(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ServiceSolicitation16BitUuids)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_solicitation32_bit_uuids(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ServiceSolicitation32BitUuids)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_solicitation128_bit_uuids(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ServiceSolicitation128BitUuids)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_data16_bit_uuids(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ServiceData16BitUuids)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_data32_bit_uuids(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ServiceData32BitUuids)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_data128_bit_uuids(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ServiceData128BitUuids)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_public_target_address(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PublicTargetAddress)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_random_target_address(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RandomTargetAddress)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_appearance(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Appearance)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_advertising_interval(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AdvertisingInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_manufacturer_specific_data(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ManufacturerSpecificData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{static class BluetoothLEAdvertisementDataTypes}
impl RtActivatable<IBluetoothLEAdvertisementDataTypesStatics> for BluetoothLEAdvertisementDataTypes {}
impl BluetoothLEAdvertisementDataTypes {
    #[inline] pub fn get_flags() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_flags()
    }}
    #[inline] pub fn get_incomplete_service16_bit_uuids() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_incomplete_service16_bit_uuids()
    }}
    #[inline] pub fn get_complete_service16_bit_uuids() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_complete_service16_bit_uuids()
    }}
    #[inline] pub fn get_incomplete_service32_bit_uuids() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_incomplete_service32_bit_uuids()
    }}
    #[inline] pub fn get_complete_service32_bit_uuids() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_complete_service32_bit_uuids()
    }}
    #[inline] pub fn get_incomplete_service128_bit_uuids() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_incomplete_service128_bit_uuids()
    }}
    #[inline] pub fn get_complete_service128_bit_uuids() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_complete_service128_bit_uuids()
    }}
    #[inline] pub fn get_shortened_local_name() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_shortened_local_name()
    }}
    #[inline] pub fn get_complete_local_name() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_complete_local_name()
    }}
    #[inline] pub fn get_tx_power_level() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_tx_power_level()
    }}
    #[inline] pub fn get_slave_connection_interval_range() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_slave_connection_interval_range()
    }}
    #[inline] pub fn get_service_solicitation16_bit_uuids() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_service_solicitation16_bit_uuids()
    }}
    #[inline] pub fn get_service_solicitation32_bit_uuids() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_service_solicitation32_bit_uuids()
    }}
    #[inline] pub fn get_service_solicitation128_bit_uuids() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_service_solicitation128_bit_uuids()
    }}
    #[inline] pub fn get_service_data16_bit_uuids() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_service_data16_bit_uuids()
    }}
    #[inline] pub fn get_service_data32_bit_uuids() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_service_data32_bit_uuids()
    }}
    #[inline] pub fn get_service_data128_bit_uuids() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_service_data128_bit_uuids()
    }}
    #[inline] pub fn get_public_target_address() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_public_target_address()
    }}
    #[inline] pub fn get_random_target_address() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_random_target_address()
    }}
    #[inline] pub fn get_appearance() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_appearance()
    }}
    #[inline] pub fn get_advertising_interval() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_advertising_interval()
    }}
    #[inline] pub fn get_manufacturer_specific_data() -> Result<u8> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementDataTypesStatics>>::get_activation_factory().get_manufacturer_specific_data()
    }}
}
DEFINE_CLSID!(BluetoothLEAdvertisementDataTypes(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,65,100,118,101,114,116,105,115,101,109,101,110,116,46,66,108,117,101,116,111,111,116,104,76,69,65,100,118,101,114,116,105,115,101,109,101,110,116,68,97,116,97,84,121,112,101,115,0]) [CLSID_BluetoothLEAdvertisementDataTypes]);
RT_ENUM! { enum BluetoothLEAdvertisementPublisherStatus: i32 {
    Created (BluetoothLEAdvertisementPublisherStatus_Created) = 0, Waiting (BluetoothLEAdvertisementPublisherStatus_Waiting) = 1, Started (BluetoothLEAdvertisementPublisherStatus_Started) = 2, Stopping (BluetoothLEAdvertisementPublisherStatus_Stopping) = 3, Stopped (BluetoothLEAdvertisementPublisherStatus_Stopped) = 4, Aborted (BluetoothLEAdvertisementPublisherStatus_Aborted) = 5,
}}
DEFINE_IID!(IID_IBluetoothLEAdvertisementPublisherStatusChangedEventArgs, 163757471, 11775, 19235, 134, 238, 13, 20, 251, 148, 174, 174);
RT_INTERFACE!{interface IBluetoothLEAdvertisementPublisherStatusChangedEventArgs(IBluetoothLEAdvertisementPublisherStatusChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementPublisherStatusChangedEventArgs] {
    fn get_Status(&self, out: *mut BluetoothLEAdvertisementPublisherStatus) -> HRESULT,
    fn get_Error(&self, out: *mut super::BluetoothError) -> HRESULT
}}
impl IBluetoothLEAdvertisementPublisherStatusChangedEventArgs {
    #[inline] pub unsafe fn get_status(&self) -> Result<BluetoothLEAdvertisementPublisherStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_error(&self) -> Result<super::BluetoothError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Error)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothLEAdvertisementPublisherStatusChangedEventArgs: IBluetoothLEAdvertisementPublisherStatusChangedEventArgs}
DEFINE_IID!(IID_IBluetoothLEAdvertisementPublisherFactory, 1549731422, 47203, 18817, 161, 175, 28, 84, 77, 139, 12, 13);
RT_INTERFACE!{static interface IBluetoothLEAdvertisementPublisherFactory(IBluetoothLEAdvertisementPublisherFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementPublisherFactory] {
    fn Create(&self, advertisement: *mut BluetoothLEAdvertisement, out: *mut *mut BluetoothLEAdvertisementPublisher) -> HRESULT
}}
impl IBluetoothLEAdvertisementPublisherFactory {
    #[inline] pub unsafe fn create(&self, advertisement: &BluetoothLEAdvertisement) -> Result<ComPtr<BluetoothLEAdvertisementPublisher>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, advertisement as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothLEAdvertisementPublisher: IBluetoothLEAdvertisementPublisher}
impl RtActivatable<IBluetoothLEAdvertisementPublisherFactory> for BluetoothLEAdvertisementPublisher {}
impl RtActivatable<IActivationFactory> for BluetoothLEAdvertisementPublisher {}
impl BluetoothLEAdvertisementPublisher {
    #[inline] pub fn create(advertisement: &BluetoothLEAdvertisement) -> Result<ComPtr<BluetoothLEAdvertisementPublisher>> { unsafe {
        <Self as RtActivatable<IBluetoothLEAdvertisementPublisherFactory>>::get_activation_factory().create(advertisement)
    }}
}
DEFINE_CLSID!(BluetoothLEAdvertisementPublisher(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,65,100,118,101,114,116,105,115,101,109,101,110,116,46,66,108,117,101,116,111,111,116,104,76,69,65,100,118,101,114,116,105,115,101,109,101,110,116,80,117,98,108,105,115,104,101,114,0]) [CLSID_BluetoothLEAdvertisementPublisher]);
DEFINE_IID!(IID_IBluetoothLEAdvertisementPublisher, 3454542073, 55802, 17366, 162, 100, 221, 216, 183, 218, 139, 120);
RT_INTERFACE!{interface IBluetoothLEAdvertisementPublisher(IBluetoothLEAdvertisementPublisherVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementPublisher] {
    fn get_Status(&self, out: *mut BluetoothLEAdvertisementPublisherStatus) -> HRESULT,
    fn get_Advertisement(&self, out: *mut *mut BluetoothLEAdvertisement) -> HRESULT,
    fn Start(&self) -> HRESULT,
    fn Stop(&self) -> HRESULT,
    fn add_StatusChanged(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<BluetoothLEAdvertisementPublisher, BluetoothLEAdvertisementPublisherStatusChangedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_StatusChanged(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT
}}
impl IBluetoothLEAdvertisementPublisher {
    #[inline] pub unsafe fn get_status(&self) -> Result<BluetoothLEAdvertisementPublisherStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_advertisement(&self) -> Result<ComPtr<BluetoothLEAdvertisement>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Advertisement)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Stop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_status_changed(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<BluetoothLEAdvertisementPublisher, BluetoothLEAdvertisementPublisherStatusChangedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_StatusChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_status_changed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_StatusChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
} // Windows.Devices.Bluetooth.Advertisement
pub mod background { // Windows.Devices.Bluetooth.Background
use ::prelude::*;
RT_ENUM! { enum BluetoothEventTriggeringMode: i32 {
    Serial (BluetoothEventTriggeringMode_Serial) = 0, Batch (BluetoothEventTriggeringMode_Batch) = 1, KeepLatest (BluetoothEventTriggeringMode_KeepLatest) = 2,
}}
DEFINE_IID!(IID_IRfcommInboundConnectionInformation, 1832809896, 21545, 16473, 146, 227, 30, 139, 101, 82, 135, 7);
RT_INTERFACE!{interface IRfcommInboundConnectionInformation(IRfcommInboundConnectionInformationVtbl): IInspectable(IInspectableVtbl) [IID_IRfcommInboundConnectionInformation] {
    #[cfg(not(feature="windows-storage"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_SdpRecord(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-storage")] fn put_SdpRecord(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    fn get_LocalServiceId(&self, out: *mut *mut super::rfcomm::RfcommServiceId) -> HRESULT,
    fn put_LocalServiceId(&self, value: *mut super::rfcomm::RfcommServiceId) -> HRESULT,
    fn get_ServiceCapabilities(&self, out: *mut super::BluetoothServiceCapabilities) -> HRESULT,
    fn put_ServiceCapabilities(&self, value: super::BluetoothServiceCapabilities) -> HRESULT
}}
impl IRfcommInboundConnectionInformation {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_sdp_record(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SdpRecord)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_sdp_record(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SdpRecord)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_local_service_id(&self) -> Result<ComPtr<super::rfcomm::RfcommServiceId>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_LocalServiceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_local_service_id(&self, value: &super::rfcomm::RfcommServiceId) -> Result<()> {
        let hr = ((*self.lpVtbl).put_LocalServiceId)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_capabilities(&self) -> Result<super::BluetoothServiceCapabilities> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ServiceCapabilities)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_service_capabilities(&self, value: super::BluetoothServiceCapabilities) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ServiceCapabilities)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class RfcommInboundConnectionInformation: IRfcommInboundConnectionInformation}
DEFINE_IID!(IID_IRfcommOutboundConnectionInformation, 2962301563, 62516, 19632, 153, 177, 74, 184, 206, 218, 237, 215);
RT_INTERFACE!{interface IRfcommOutboundConnectionInformation(IRfcommOutboundConnectionInformationVtbl): IInspectable(IInspectableVtbl) [IID_IRfcommOutboundConnectionInformation] {
    fn get_RemoteServiceId(&self, out: *mut *mut super::rfcomm::RfcommServiceId) -> HRESULT,
    fn put_RemoteServiceId(&self, value: *mut super::rfcomm::RfcommServiceId) -> HRESULT
}}
impl IRfcommOutboundConnectionInformation {
    #[inline] pub unsafe fn get_remote_service_id(&self) -> Result<ComPtr<super::rfcomm::RfcommServiceId>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_RemoteServiceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_remote_service_id(&self, value: &super::rfcomm::RfcommServiceId) -> Result<()> {
        let hr = ((*self.lpVtbl).put_RemoteServiceId)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class RfcommOutboundConnectionInformation: IRfcommOutboundConnectionInformation}
DEFINE_IID!(IID_IRfcommConnectionTriggerDetails, 4179784525, 11836, 20220, 171, 89, 252, 92, 249, 111, 151, 227);
RT_INTERFACE!{interface IRfcommConnectionTriggerDetails(IRfcommConnectionTriggerDetailsVtbl): IInspectable(IInspectableVtbl) [IID_IRfcommConnectionTriggerDetails] {
    #[cfg(not(feature="windows-networking"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-networking")] fn get_Socket(&self, out: *mut *mut ::rt::gen::windows::networking::sockets::StreamSocket) -> HRESULT,
    fn get_Incoming(&self, out: *mut bool) -> HRESULT,
    fn get_RemoteDevice(&self, out: *mut *mut super::BluetoothDevice) -> HRESULT
}}
impl IRfcommConnectionTriggerDetails {
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn get_socket(&self) -> Result<ComPtr<::rt::gen::windows::networking::sockets::StreamSocket>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Socket)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_incoming(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Incoming)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_remote_device(&self) -> Result<ComPtr<super::BluetoothDevice>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_RemoteDevice)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class RfcommConnectionTriggerDetails: IRfcommConnectionTriggerDetails}
DEFINE_IID!(IID_IGattCharacteristicNotificationTriggerDetails, 2610969368, 4076, 17258, 147, 177, 244, 108, 105, 117, 50, 162);
RT_INTERFACE!{interface IGattCharacteristicNotificationTriggerDetails(IGattCharacteristicNotificationTriggerDetailsVtbl): IInspectable(IInspectableVtbl) [IID_IGattCharacteristicNotificationTriggerDetails] {
    fn get_Characteristic(&self, out: *mut *mut super::genericattributeprofile::GattCharacteristic) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_Value(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT
}}
impl IGattCharacteristicNotificationTriggerDetails {
    #[inline] pub unsafe fn get_characteristic(&self) -> Result<ComPtr<super::genericattributeprofile::GattCharacteristic>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Characteristic)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_value(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Value)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattCharacteristicNotificationTriggerDetails2, 1920618716, 38045, 17738, 177, 146, 152, 52, 103, 227, 213, 15);
RT_INTERFACE!{interface IGattCharacteristicNotificationTriggerDetails2(IGattCharacteristicNotificationTriggerDetails2Vtbl): IInspectable(IInspectableVtbl) [IID_IGattCharacteristicNotificationTriggerDetails2] {
    fn get_Error(&self, out: *mut super::BluetoothError) -> HRESULT,
    fn get_EventTriggeringMode(&self, out: *mut BluetoothEventTriggeringMode) -> HRESULT,
    fn get_ValueChangedEvents(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<super::genericattributeprofile::GattValueChangedEventArgs>) -> HRESULT
}}
impl IGattCharacteristicNotificationTriggerDetails2 {
    #[inline] pub unsafe fn get_error(&self) -> Result<super::BluetoothError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Error)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_event_triggering_mode(&self) -> Result<BluetoothEventTriggeringMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_EventTriggeringMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_value_changed_events(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<super::genericattributeprofile::GattValueChangedEventArgs>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ValueChangedEvents)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GattCharacteristicNotificationTriggerDetails: IGattCharacteristicNotificationTriggerDetails}
DEFINE_IID!(IID_IGattServiceProviderConnectionStatics, 1028693835, 2830, 17510, 184, 205, 110, 189, 218, 31, 161, 125);
RT_INTERFACE!{static interface IGattServiceProviderConnectionStatics(IGattServiceProviderConnectionStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGattServiceProviderConnectionStatics] {
    fn get_AllServices(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IMapView<HString, GattServiceProviderConnection>) -> HRESULT
}}
impl IGattServiceProviderConnectionStatics {
    #[inline] pub unsafe fn get_all_services(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IMapView<HString, GattServiceProviderConnection>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AllServices)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GattServiceProviderConnection: IGattServiceProviderConnection}
impl RtActivatable<IGattServiceProviderConnectionStatics> for GattServiceProviderConnection {}
impl GattServiceProviderConnection {
    #[inline] pub fn get_all_services() -> Result<ComPtr<::rt::gen::windows::foundation::collections::IMapView<HString, GattServiceProviderConnection>>> { unsafe {
        <Self as RtActivatable<IGattServiceProviderConnectionStatics>>::get_activation_factory().get_all_services()
    }}
}
DEFINE_CLSID!(GattServiceProviderConnection(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,66,108,117,101,116,111,111,116,104,46,66,97,99,107,103,114,111,117,110,100,46,71,97,116,116,83,101,114,118,105,99,101,80,114,111,118,105,100,101,114,67,111,110,110,101,99,116,105,111,110,0]) [CLSID_GattServiceProviderConnection]);
DEFINE_IID!(IID_IGattServiceProviderConnection, 2141305273, 12051, 16565, 149, 130, 142, 183, 142, 152, 239, 19);
RT_INTERFACE!{interface IGattServiceProviderConnection(IGattServiceProviderConnectionVtbl): IInspectable(IInspectableVtbl) [IID_IGattServiceProviderConnection] {
    fn get_TriggerId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Service(&self, out: *mut *mut super::genericattributeprofile::GattLocalService) -> HRESULT,
    fn Start(&self) -> HRESULT
}}
impl IGattServiceProviderConnection {
    #[inline] pub unsafe fn get_trigger_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_TriggerId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service(&self) -> Result<ComPtr<super::genericattributeprofile::GattLocalService>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Service)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGattServiceProviderTriggerDetails, 2928412197, 1535, 19195, 177, 106, 222, 149, 243, 207, 1, 88);
RT_INTERFACE!{interface IGattServiceProviderTriggerDetails(IGattServiceProviderTriggerDetailsVtbl): IInspectable(IInspectableVtbl) [IID_IGattServiceProviderTriggerDetails] {
    fn get_Connection(&self, out: *mut *mut GattServiceProviderConnection) -> HRESULT
}}
impl IGattServiceProviderTriggerDetails {
    #[inline] pub unsafe fn get_connection(&self) -> Result<ComPtr<GattServiceProviderConnection>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Connection)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GattServiceProviderTriggerDetails: IGattServiceProviderTriggerDetails}
DEFINE_IID!(IID_IBluetoothLEAdvertisementWatcherTriggerDetails, 2816170711, 8791, 20073, 151, 132, 254, 230, 69, 193, 220, 224);
RT_INTERFACE!{interface IBluetoothLEAdvertisementWatcherTriggerDetails(IBluetoothLEAdvertisementWatcherTriggerDetailsVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementWatcherTriggerDetails] {
    fn get_Error(&self, out: *mut super::BluetoothError) -> HRESULT,
    fn get_Advertisements(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<super::advertisement::BluetoothLEAdvertisementReceivedEventArgs>) -> HRESULT,
    fn get_SignalStrengthFilter(&self, out: *mut *mut super::BluetoothSignalStrengthFilter) -> HRESULT
}}
impl IBluetoothLEAdvertisementWatcherTriggerDetails {
    #[inline] pub unsafe fn get_error(&self) -> Result<super::BluetoothError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Error)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_advertisements(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<super::advertisement::BluetoothLEAdvertisementReceivedEventArgs>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Advertisements)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_signal_strength_filter(&self) -> Result<ComPtr<super::BluetoothSignalStrengthFilter>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SignalStrengthFilter)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothLEAdvertisementWatcherTriggerDetails: IBluetoothLEAdvertisementWatcherTriggerDetails}
DEFINE_IID!(IID_IBluetoothLEAdvertisementPublisherTriggerDetails, 1628359302, 13440, 16841, 169, 24, 125, 218, 223, 32, 126, 0);
RT_INTERFACE!{interface IBluetoothLEAdvertisementPublisherTriggerDetails(IBluetoothLEAdvertisementPublisherTriggerDetailsVtbl): IInspectable(IInspectableVtbl) [IID_IBluetoothLEAdvertisementPublisherTriggerDetails] {
    fn get_Status(&self, out: *mut super::advertisement::BluetoothLEAdvertisementPublisherStatus) -> HRESULT,
    fn get_Error(&self, out: *mut super::BluetoothError) -> HRESULT
}}
impl IBluetoothLEAdvertisementPublisherTriggerDetails {
    #[inline] pub unsafe fn get_status(&self) -> Result<super::advertisement::BluetoothLEAdvertisementPublisherStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_error(&self) -> Result<super::BluetoothError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Error)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class BluetoothLEAdvertisementPublisherTriggerDetails: IBluetoothLEAdvertisementPublisherTriggerDetails}
} // Windows.Devices.Bluetooth.Background
} // Windows.Devices.Bluetooth
pub mod enumeration { // Windows.Devices.Enumeration
use ::prelude::*;
DEFINE_IID!(IID_IDeviceConnectionChangeTriggerDetails, 3092745228, 48065, 18507, 191, 250, 123, 49, 220, 194, 0, 178);
RT_INTERFACE!{interface IDeviceConnectionChangeTriggerDetails(IDeviceConnectionChangeTriggerDetailsVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceConnectionChangeTriggerDetails] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl IDeviceConnectionChangeTriggerDetails {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class DeviceConnectionChangeTriggerDetails: IDeviceConnectionChangeTriggerDetails}
RT_ENUM! { enum DevicePickerDisplayStatusOptions: u32 {
    None (DevicePickerDisplayStatusOptions_None) = 0, ShowProgress (DevicePickerDisplayStatusOptions_ShowProgress) = 1, ShowDisconnectButton (DevicePickerDisplayStatusOptions_ShowDisconnectButton) = 2, ShowRetryButton (DevicePickerDisplayStatusOptions_ShowRetryButton) = 4,
}}
DEFINE_IID!(IID_IDevicePickerAppearance, 3868857030, 58919, 20184, 155, 108, 70, 10, 244, 69, 229, 109);
RT_INTERFACE!{interface IDevicePickerAppearance(IDevicePickerAppearanceVtbl): IInspectable(IInspectableVtbl) [IID_IDevicePickerAppearance] {
    fn get_Title(&self, out: *mut HSTRING) -> HRESULT,
    fn put_Title(&self, value: HSTRING) -> HRESULT,
    #[cfg(feature="windows-ui")] fn get_ForegroundColor(&self, out: *mut super::super::ui::Color) -> HRESULT,
    #[cfg(feature="windows-ui")] fn put_ForegroundColor(&self, value: super::super::ui::Color) -> HRESULT,
    #[cfg(feature="windows-ui")] fn get_BackgroundColor(&self, out: *mut super::super::ui::Color) -> HRESULT,
    #[cfg(feature="windows-ui")] fn put_BackgroundColor(&self, value: super::super::ui::Color) -> HRESULT,
    #[cfg(feature="windows-ui")] fn get_AccentColor(&self, out: *mut super::super::ui::Color) -> HRESULT,
    #[cfg(feature="windows-ui")] fn put_AccentColor(&self, value: super::super::ui::Color) -> HRESULT,
    #[cfg(feature="windows-ui")] fn get_SelectedForegroundColor(&self, out: *mut super::super::ui::Color) -> HRESULT,
    #[cfg(feature="windows-ui")] fn put_SelectedForegroundColor(&self, value: super::super::ui::Color) -> HRESULT,
    #[cfg(feature="windows-ui")] fn get_SelectedBackgroundColor(&self, out: *mut super::super::ui::Color) -> HRESULT,
    #[cfg(feature="windows-ui")] fn put_SelectedBackgroundColor(&self, value: super::super::ui::Color) -> HRESULT,
    #[cfg(feature="windows-ui")] fn get_SelectedAccentColor(&self, out: *mut super::super::ui::Color) -> HRESULT,
    #[cfg(feature="windows-ui")] fn put_SelectedAccentColor(&self, value: super::super::ui::Color) -> HRESULT
}}
impl IDevicePickerAppearance {
    #[inline] pub unsafe fn get_title(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Title)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_title(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Title)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn get_foreground_color(&self) -> Result<super::super::ui::Color> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ForegroundColor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn set_foreground_color(&self, value: super::super::ui::Color) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ForegroundColor)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn get_background_color(&self) -> Result<super::super::ui::Color> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BackgroundColor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn set_background_color(&self, value: super::super::ui::Color) -> Result<()> {
        let hr = ((*self.lpVtbl).put_BackgroundColor)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn get_accent_color(&self) -> Result<super::super::ui::Color> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AccentColor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn set_accent_color(&self, value: super::super::ui::Color) -> Result<()> {
        let hr = ((*self.lpVtbl).put_AccentColor)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn get_selected_foreground_color(&self) -> Result<super::super::ui::Color> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SelectedForegroundColor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn set_selected_foreground_color(&self, value: super::super::ui::Color) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SelectedForegroundColor)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn get_selected_background_color(&self) -> Result<super::super::ui::Color> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SelectedBackgroundColor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn set_selected_background_color(&self, value: super::super::ui::Color) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SelectedBackgroundColor)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn get_selected_accent_color(&self) -> Result<super::super::ui::Color> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SelectedAccentColor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn set_selected_accent_color(&self, value: super::super::ui::Color) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SelectedAccentColor)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class DevicePickerAppearance: IDevicePickerAppearance}
DEFINE_IID!(IID_IDeviceSelectedEventArgs, 647944926, 7471, 18752, 132, 2, 65, 86, 184, 29, 60, 119);
RT_INTERFACE!{interface IDeviceSelectedEventArgs(IDeviceSelectedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceSelectedEventArgs] {
    fn get_SelectedDevice(&self, out: *mut *mut DeviceInformation) -> HRESULT
}}
impl IDeviceSelectedEventArgs {
    #[inline] pub unsafe fn get_selected_device(&self) -> Result<ComPtr<DeviceInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SelectedDevice)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class DeviceSelectedEventArgs: IDeviceSelectedEventArgs}
DEFINE_IID!(IID_IDeviceDisconnectButtonClickedEventArgs, 2386867565, 63746, 18944, 181, 54, 243, 121, 146, 230, 162, 167);
RT_INTERFACE!{interface IDeviceDisconnectButtonClickedEventArgs(IDeviceDisconnectButtonClickedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceDisconnectButtonClickedEventArgs] {
    fn get_Device(&self, out: *mut *mut DeviceInformation) -> HRESULT
}}
impl IDeviceDisconnectButtonClickedEventArgs {
    #[inline] pub unsafe fn get_device(&self) -> Result<ComPtr<DeviceInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Device)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class DeviceDisconnectButtonClickedEventArgs: IDeviceDisconnectButtonClickedEventArgs}
DEFINE_IID!(IID_IDevicePickerFilter, 2447086242, 22475, 18673, 155, 89, 165, 155, 122, 31, 2, 162);
RT_INTERFACE!{interface IDevicePickerFilter(IDevicePickerFilterVtbl): IInspectable(IInspectableVtbl) [IID_IDevicePickerFilter] {
    fn get_SupportedDeviceClasses(&self, out: *mut *mut super::super::foundation::collections::IVector<DeviceClass>) -> HRESULT,
    fn get_SupportedDeviceSelectors(&self, out: *mut *mut super::super::foundation::collections::IVector<HString>) -> HRESULT
}}
impl IDevicePickerFilter {
    #[inline] pub unsafe fn get_supported_device_classes(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<DeviceClass>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedDeviceClasses)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_device_selectors(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedDeviceSelectors)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class DevicePickerFilter: IDevicePickerFilter}
DEFINE_IID!(IID_IDevicePicker, 2224650914, 842, 17472, 136, 19, 125, 11, 212, 121, 191, 90);
RT_INTERFACE!{interface IDevicePicker(IDevicePickerVtbl): IInspectable(IInspectableVtbl) [IID_IDevicePicker] {
    fn get_Filter(&self, out: *mut *mut DevicePickerFilter) -> HRESULT,
    fn get_Appearance(&self, out: *mut *mut DevicePickerAppearance) -> HRESULT,
    fn get_RequestedProperties(&self, out: *mut *mut super::super::foundation::collections::IVector<HString>) -> HRESULT,
    fn add_DeviceSelected(&self, handler: *mut super::super::foundation::TypedEventHandler<DevicePicker, DeviceSelectedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_DeviceSelected(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_DisconnectButtonClicked(&self, handler: *mut super::super::foundation::TypedEventHandler<DevicePicker, DeviceDisconnectButtonClickedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_DisconnectButtonClicked(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_DevicePickerDismissed(&self, handler: *mut super::super::foundation::TypedEventHandler<DevicePicker, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_DevicePickerDismissed(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn Show(&self, selection: super::super::foundation::Rect) -> HRESULT,
    #[cfg(not(feature="windows-ui"))] fn __Dummy10(&self) -> (),
    #[cfg(feature="windows-ui")] fn ShowWithPlacement(&self, selection: super::super::foundation::Rect, placement: super::super::ui::popups::Placement) -> HRESULT,
    fn PickSingleDeviceAsync(&self, selection: super::super::foundation::Rect, out: *mut *mut super::super::foundation::IAsyncOperation<DeviceInformation>) -> HRESULT,
    #[cfg(not(feature="windows-ui"))] fn __Dummy12(&self) -> (),
    #[cfg(feature="windows-ui")] fn PickSingleDeviceAsyncWithPlacement(&self, selection: super::super::foundation::Rect, placement: super::super::ui::popups::Placement, out: *mut *mut super::super::foundation::IAsyncOperation<DeviceInformation>) -> HRESULT,
    fn Hide(&self) -> HRESULT,
    fn SetDisplayStatus(&self, device: *mut DeviceInformation, status: HSTRING, options: DevicePickerDisplayStatusOptions) -> HRESULT
}}
impl IDevicePicker {
    #[inline] pub unsafe fn get_filter(&self) -> Result<ComPtr<DevicePickerFilter>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Filter)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_appearance(&self) -> Result<ComPtr<DevicePickerAppearance>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Appearance)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_requested_properties(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_RequestedProperties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_device_selected(&self, handler: &super::super::foundation::TypedEventHandler<DevicePicker, DeviceSelectedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_DeviceSelected)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_device_selected(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_DeviceSelected)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_disconnect_button_clicked(&self, handler: &super::super::foundation::TypedEventHandler<DevicePicker, DeviceDisconnectButtonClickedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_DisconnectButtonClicked)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_disconnect_button_clicked(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_DisconnectButtonClicked)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_device_picker_dismissed(&self, handler: &super::super::foundation::TypedEventHandler<DevicePicker, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_DevicePickerDismissed)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_device_picker_dismissed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_DevicePickerDismissed)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn show(&self, selection: super::super::foundation::Rect) -> Result<()> {
        let hr = ((*self.lpVtbl).Show)(self as *const _ as *mut _, selection);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn show_with_placement(&self, selection: super::super::foundation::Rect, placement: super::super::ui::popups::Placement) -> Result<()> {
        let hr = ((*self.lpVtbl).ShowWithPlacement)(self as *const _ as *mut _, selection, placement);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn pick_single_device_async(&self, selection: super::super::foundation::Rect) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformation>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).PickSingleDeviceAsync)(self as *const _ as *mut _, selection, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn pick_single_device_async_with_placement(&self, selection: super::super::foundation::Rect, placement: super::super::ui::popups::Placement) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformation>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).PickSingleDeviceAsyncWithPlacement)(self as *const _ as *mut _, selection, placement, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn hide(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Hide)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_display_status(&self, device: &DeviceInformation, status: &HStringArg, options: DevicePickerDisplayStatusOptions) -> Result<()> {
        let hr = ((*self.lpVtbl).SetDisplayStatus)(self as *const _ as *mut _, device as *const _ as *mut _, status.get(), options);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class DevicePicker: IDevicePicker}
impl RtActivatable<IActivationFactory> for DevicePicker {}
DEFINE_CLSID!(DevicePicker(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,69,110,117,109,101,114,97,116,105,111,110,46,68,101,118,105,99,101,80,105,99,107,101,114,0]) [CLSID_DevicePicker]);
RT_ENUM! { enum DeviceClass: i32 {
    All (DeviceClass_All) = 0, AudioCapture (DeviceClass_AudioCapture) = 1, AudioRender (DeviceClass_AudioRender) = 2, PortableStorageDevice (DeviceClass_PortableStorageDevice) = 3, VideoCapture (DeviceClass_VideoCapture) = 4, ImageScanner (DeviceClass_ImageScanner) = 5, Location (DeviceClass_Location) = 6,
}}
RT_ENUM! { enum DeviceWatcherStatus: i32 {
    Created (DeviceWatcherStatus_Created) = 0, Started (DeviceWatcherStatus_Started) = 1, EnumerationCompleted (DeviceWatcherStatus_EnumerationCompleted) = 2, Stopping (DeviceWatcherStatus_Stopping) = 3, Stopped (DeviceWatcherStatus_Stopped) = 4, Aborted (DeviceWatcherStatus_Aborted) = 5,
}}
#[cfg(feature="windows-storage")] RT_CLASS!{class DeviceThumbnail: super::super::storage::streams::IRandomAccessStreamWithContentType}
#[cfg(not(feature="windows-storage"))] RT_CLASS!{class DeviceThumbnail: IInspectable}
RT_ENUM! { enum Panel: i32 {
    Unknown (Panel_Unknown) = 0, Front (Panel_Front) = 1, Back (Panel_Back) = 2, Top (Panel_Top) = 3, Bottom (Panel_Bottom) = 4, Left (Panel_Left) = 5, Right (Panel_Right) = 6,
}}
DEFINE_IID!(IID_IEnclosureLocation, 1110706727, 22544, 17820, 170, 187, 198, 94, 31, 129, 62, 207);
RT_INTERFACE!{interface IEnclosureLocation(IEnclosureLocationVtbl): IInspectable(IInspectableVtbl) [IID_IEnclosureLocation] {
    fn get_InDock(&self, out: *mut bool) -> HRESULT,
    fn get_InLid(&self, out: *mut bool) -> HRESULT,
    fn get_Panel(&self, out: *mut Panel) -> HRESULT
}}
impl IEnclosureLocation {
    #[inline] pub unsafe fn get_in_dock(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InDock)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_in_lid(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InLid)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_panel(&self) -> Result<Panel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Panel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IEnclosureLocation2, 679844187, 57469, 18525, 138, 158, 189, 242, 154, 239, 79, 102);
RT_INTERFACE!{interface IEnclosureLocation2(IEnclosureLocation2Vtbl): IInspectable(IInspectableVtbl) [IID_IEnclosureLocation2] {
    fn get_RotationAngleInDegreesClockwise(&self, out: *mut u32) -> HRESULT
}}
impl IEnclosureLocation2 {
    #[inline] pub unsafe fn get_rotation_angle_in_degrees_clockwise(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RotationAngleInDegreesClockwise)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class EnclosureLocation: IEnclosureLocation}
RT_ENUM! { enum DeviceInformationKind: i32 {
    Unknown (DeviceInformationKind_Unknown) = 0, DeviceInterface (DeviceInformationKind_DeviceInterface) = 1, DeviceContainer (DeviceInformationKind_DeviceContainer) = 2, Device (DeviceInformationKind_Device) = 3, DeviceInterfaceClass (DeviceInformationKind_DeviceInterfaceClass) = 4, AssociationEndpoint (DeviceInformationKind_AssociationEndpoint) = 5, AssociationEndpointContainer (DeviceInformationKind_AssociationEndpointContainer) = 6, AssociationEndpointService (DeviceInformationKind_AssociationEndpointService) = 7,
}}
DEFINE_IID!(IID_IDeviceInformationUpdate, 2402374405, 55666, 17591, 163, 126, 158, 130, 44, 120, 33, 59);
RT_INTERFACE!{interface IDeviceInformationUpdate(IDeviceInformationUpdateVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceInformationUpdate] {
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Properties(&self, out: *mut *mut super::super::foundation::collections::IMapView<HString, IInspectable>) -> HRESULT
}}
impl IDeviceInformationUpdate {
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_properties(&self) -> Result<ComPtr<super::super::foundation::collections::IMapView<HString, IInspectable>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Properties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IDeviceInformationUpdate2, 1570575500, 43123, 18526, 186, 166, 170, 98, 7, 136, 227, 204);
RT_INTERFACE!{interface IDeviceInformationUpdate2(IDeviceInformationUpdate2Vtbl): IInspectable(IInspectableVtbl) [IID_IDeviceInformationUpdate2] {
    fn get_Kind(&self, out: *mut DeviceInformationKind) -> HRESULT
}}
impl IDeviceInformationUpdate2 {
    #[inline] pub unsafe fn get_kind(&self) -> Result<DeviceInformationKind> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Kind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class DeviceInformationUpdate: IDeviceInformationUpdate}
RT_CLASS!{class DeviceInformationCollection: super::super::foundation::collections::IVectorView<DeviceInformation>}
DEFINE_IID!(IID_IDeviceWatcher, 3387603325, 36715, 20374, 169, 244, 171, 200, 20, 226, 34, 113);
RT_INTERFACE!{interface IDeviceWatcher(IDeviceWatcherVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceWatcher] {
    fn add_Added(&self, handler: *mut super::super::foundation::TypedEventHandler<DeviceWatcher, DeviceInformation>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Added(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_Updated(&self, handler: *mut super::super::foundation::TypedEventHandler<DeviceWatcher, DeviceInformationUpdate>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Updated(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_Removed(&self, handler: *mut super::super::foundation::TypedEventHandler<DeviceWatcher, DeviceInformationUpdate>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Removed(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_EnumerationCompleted(&self, handler: *mut super::super::foundation::TypedEventHandler<DeviceWatcher, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_EnumerationCompleted(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_Stopped(&self, handler: *mut super::super::foundation::TypedEventHandler<DeviceWatcher, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Stopped(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_Status(&self, out: *mut DeviceWatcherStatus) -> HRESULT,
    fn Start(&self) -> HRESULT,
    fn Stop(&self) -> HRESULT
}}
impl IDeviceWatcher {
    #[inline] pub unsafe fn add_added(&self, handler: &super::super::foundation::TypedEventHandler<DeviceWatcher, DeviceInformation>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Added)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_added(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Added)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_updated(&self, handler: &super::super::foundation::TypedEventHandler<DeviceWatcher, DeviceInformationUpdate>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Updated)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_updated(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Updated)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_removed(&self, handler: &super::super::foundation::TypedEventHandler<DeviceWatcher, DeviceInformationUpdate>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Removed)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_removed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Removed)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_enumeration_completed(&self, handler: &super::super::foundation::TypedEventHandler<DeviceWatcher, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_EnumerationCompleted)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_enumeration_completed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_EnumerationCompleted)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_stopped(&self, handler: &super::super::foundation::TypedEventHandler<DeviceWatcher, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Stopped)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_stopped(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Stopped)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<DeviceWatcherStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Stop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class DeviceWatcher: IDeviceWatcher}
RT_CLASS!{class DeviceInformation: IDeviceInformation}
impl RtActivatable<IDeviceInformationStatics2> for DeviceInformation {}
impl RtActivatable<IDeviceInformationStatics> for DeviceInformation {}
impl DeviceInformation {
    #[inline] pub fn get_aqs_filter_from_device_class(deviceClass: DeviceClass) -> Result<HString> { unsafe {
        <Self as RtActivatable<IDeviceInformationStatics2>>::get_activation_factory().get_aqs_filter_from_device_class(deviceClass)
    }}
    #[inline] pub fn create_from_id_async_with_kind_and_additional_properties(deviceId: &HStringArg, additionalProperties: &super::super::foundation::collections::IIterable<HString>, kind: DeviceInformationKind) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformation>>> { unsafe {
        <Self as RtActivatable<IDeviceInformationStatics2>>::get_activation_factory().create_from_id_async_with_kind_and_additional_properties(deviceId, additionalProperties, kind)
    }}
    #[inline] pub fn find_all_async_with_kind_aqs_filter_and_additional_properties(aqsFilter: &HStringArg, additionalProperties: &super::super::foundation::collections::IIterable<HString>, kind: DeviceInformationKind) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformationCollection>>> { unsafe {
        <Self as RtActivatable<IDeviceInformationStatics2>>::get_activation_factory().find_all_async_with_kind_aqs_filter_and_additional_properties(aqsFilter, additionalProperties, kind)
    }}
    #[inline] pub fn create_watcher_with_kind_aqs_filter_and_additional_properties(aqsFilter: &HStringArg, additionalProperties: &super::super::foundation::collections::IIterable<HString>, kind: DeviceInformationKind) -> Result<ComPtr<DeviceWatcher>> { unsafe {
        <Self as RtActivatable<IDeviceInformationStatics2>>::get_activation_factory().create_watcher_with_kind_aqs_filter_and_additional_properties(aqsFilter, additionalProperties, kind)
    }}
    #[inline] pub fn create_from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformation>>> { unsafe {
        <Self as RtActivatable<IDeviceInformationStatics>>::get_activation_factory().create_from_id_async(deviceId)
    }}
    #[inline] pub fn create_from_id_async_additional_properties(deviceId: &HStringArg, additionalProperties: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformation>>> { unsafe {
        <Self as RtActivatable<IDeviceInformationStatics>>::get_activation_factory().create_from_id_async_additional_properties(deviceId, additionalProperties)
    }}
    #[inline] pub fn find_all_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformationCollection>>> { unsafe {
        <Self as RtActivatable<IDeviceInformationStatics>>::get_activation_factory().find_all_async()
    }}
    #[inline] pub fn find_all_async_device_class(deviceClass: DeviceClass) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformationCollection>>> { unsafe {
        <Self as RtActivatable<IDeviceInformationStatics>>::get_activation_factory().find_all_async_device_class(deviceClass)
    }}
    #[inline] pub fn find_all_async_aqs_filter(aqsFilter: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformationCollection>>> { unsafe {
        <Self as RtActivatable<IDeviceInformationStatics>>::get_activation_factory().find_all_async_aqs_filter(aqsFilter)
    }}
    #[inline] pub fn find_all_async_aqs_filter_and_additional_properties(aqsFilter: &HStringArg, additionalProperties: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformationCollection>>> { unsafe {
        <Self as RtActivatable<IDeviceInformationStatics>>::get_activation_factory().find_all_async_aqs_filter_and_additional_properties(aqsFilter, additionalProperties)
    }}
    #[inline] pub fn create_watcher() -> Result<ComPtr<DeviceWatcher>> { unsafe {
        <Self as RtActivatable<IDeviceInformationStatics>>::get_activation_factory().create_watcher()
    }}
    #[inline] pub fn create_watcher_device_class(deviceClass: DeviceClass) -> Result<ComPtr<DeviceWatcher>> { unsafe {
        <Self as RtActivatable<IDeviceInformationStatics>>::get_activation_factory().create_watcher_device_class(deviceClass)
    }}
    #[inline] pub fn create_watcher_aqs_filter(aqsFilter: &HStringArg) -> Result<ComPtr<DeviceWatcher>> { unsafe {
        <Self as RtActivatable<IDeviceInformationStatics>>::get_activation_factory().create_watcher_aqs_filter(aqsFilter)
    }}
    #[inline] pub fn create_watcher_aqs_filter_and_additional_properties(aqsFilter: &HStringArg, additionalProperties: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<DeviceWatcher>> { unsafe {
        <Self as RtActivatable<IDeviceInformationStatics>>::get_activation_factory().create_watcher_aqs_filter_and_additional_properties(aqsFilter, additionalProperties)
    }}
}
DEFINE_CLSID!(DeviceInformation(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,69,110,117,109,101,114,97,116,105,111,110,46,68,101,118,105,99,101,73,110,102,111,114,109,97,116,105,111,110,0]) [CLSID_DeviceInformation]);
RT_ENUM! { enum DeviceWatcherEventKind: i32 {
    Add (DeviceWatcherEventKind_Add) = 0, Update (DeviceWatcherEventKind_Update) = 1, Remove (DeviceWatcherEventKind_Remove) = 2,
}}
DEFINE_IID!(IID_IDeviceWatcher2, 4278732142, 60692, 18921, 154, 105, 129, 23, 197, 74, 233, 113);
RT_INTERFACE!{interface IDeviceWatcher2(IDeviceWatcher2Vtbl): IInspectable(IInspectableVtbl) [IID_IDeviceWatcher2] {
    #[cfg(feature="windows-applicationmodel")] fn GetBackgroundTrigger(&self, requestedEventKinds: *mut super::super::foundation::collections::IIterable<DeviceWatcherEventKind>, out: *mut *mut super::super::applicationmodel::background::DeviceWatcherTrigger) -> HRESULT
}}
impl IDeviceWatcher2 {
    #[cfg(feature="windows-applicationmodel")] #[inline] pub unsafe fn get_background_trigger(&self, requestedEventKinds: &super::super::foundation::collections::IIterable<DeviceWatcherEventKind>) -> Result<ComPtr<super::super::applicationmodel::background::DeviceWatcherTrigger>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetBackgroundTrigger)(self as *const _ as *mut _, requestedEventKinds as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IDeviceInformationStatics, 3246329870, 14918, 19064, 128, 19, 118, 157, 201, 185, 115, 144);
RT_INTERFACE!{static interface IDeviceInformationStatics(IDeviceInformationStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceInformationStatics] {
    fn CreateFromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<DeviceInformation>) -> HRESULT,
    fn CreateFromIdAsyncAdditionalProperties(&self, deviceId: HSTRING, additionalProperties: *mut super::super::foundation::collections::IIterable<HString>, out: *mut *mut super::super::foundation::IAsyncOperation<DeviceInformation>) -> HRESULT,
    fn FindAllAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<DeviceInformationCollection>) -> HRESULT,
    fn FindAllAsyncDeviceClass(&self, deviceClass: DeviceClass, out: *mut *mut super::super::foundation::IAsyncOperation<DeviceInformationCollection>) -> HRESULT,
    fn FindAllAsyncAqsFilter(&self, aqsFilter: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<DeviceInformationCollection>) -> HRESULT,
    fn FindAllAsyncAqsFilterAndAdditionalProperties(&self, aqsFilter: HSTRING, additionalProperties: *mut super::super::foundation::collections::IIterable<HString>, out: *mut *mut super::super::foundation::IAsyncOperation<DeviceInformationCollection>) -> HRESULT,
    fn CreateWatcher(&self, out: *mut *mut DeviceWatcher) -> HRESULT,
    fn CreateWatcherDeviceClass(&self, deviceClass: DeviceClass, out: *mut *mut DeviceWatcher) -> HRESULT,
    fn CreateWatcherAqsFilter(&self, aqsFilter: HSTRING, out: *mut *mut DeviceWatcher) -> HRESULT,
    fn CreateWatcherAqsFilterAndAdditionalProperties(&self, aqsFilter: HSTRING, additionalProperties: *mut super::super::foundation::collections::IIterable<HString>, out: *mut *mut DeviceWatcher) -> HRESULT
}}
impl IDeviceInformationStatics {
    #[inline] pub unsafe fn create_from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformation>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateFromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_from_id_async_additional_properties(&self, deviceId: &HStringArg, additionalProperties: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformation>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateFromIdAsyncAdditionalProperties)(self as *const _ as *mut _, deviceId.get(), additionalProperties as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn find_all_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformationCollection>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FindAllAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn find_all_async_device_class(&self, deviceClass: DeviceClass) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformationCollection>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FindAllAsyncDeviceClass)(self as *const _ as *mut _, deviceClass, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn find_all_async_aqs_filter(&self, aqsFilter: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformationCollection>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FindAllAsyncAqsFilter)(self as *const _ as *mut _, aqsFilter.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn find_all_async_aqs_filter_and_additional_properties(&self, aqsFilter: &HStringArg, additionalProperties: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformationCollection>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FindAllAsyncAqsFilterAndAdditionalProperties)(self as *const _ as *mut _, aqsFilter.get(), additionalProperties as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_watcher(&self) -> Result<ComPtr<DeviceWatcher>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWatcher)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_watcher_device_class(&self, deviceClass: DeviceClass) -> Result<ComPtr<DeviceWatcher>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWatcherDeviceClass)(self as *const _ as *mut _, deviceClass, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_watcher_aqs_filter(&self, aqsFilter: &HStringArg) -> Result<ComPtr<DeviceWatcher>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWatcherAqsFilter)(self as *const _ as *mut _, aqsFilter.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_watcher_aqs_filter_and_additional_properties(&self, aqsFilter: &HStringArg, additionalProperties: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<DeviceWatcher>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWatcherAqsFilterAndAdditionalProperties)(self as *const _ as *mut _, aqsFilter.get(), additionalProperties as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IDeviceInformationStatics2, 1228623668, 43087, 17917, 145, 103, 21, 209, 203, 27, 209, 249);
RT_INTERFACE!{static interface IDeviceInformationStatics2(IDeviceInformationStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IDeviceInformationStatics2] {
    fn GetAqsFilterFromDeviceClass(&self, deviceClass: DeviceClass, out: *mut HSTRING) -> HRESULT,
    fn CreateFromIdAsyncWithKindAndAdditionalProperties(&self, deviceId: HSTRING, additionalProperties: *mut super::super::foundation::collections::IIterable<HString>, kind: DeviceInformationKind, out: *mut *mut super::super::foundation::IAsyncOperation<DeviceInformation>) -> HRESULT,
    fn FindAllAsyncWithKindAqsFilterAndAdditionalProperties(&self, aqsFilter: HSTRING, additionalProperties: *mut super::super::foundation::collections::IIterable<HString>, kind: DeviceInformationKind, out: *mut *mut super::super::foundation::IAsyncOperation<DeviceInformationCollection>) -> HRESULT,
    fn CreateWatcherWithKindAqsFilterAndAdditionalProperties(&self, aqsFilter: HSTRING, additionalProperties: *mut super::super::foundation::collections::IIterable<HString>, kind: DeviceInformationKind, out: *mut *mut DeviceWatcher) -> HRESULT
}}
impl IDeviceInformationStatics2 {
    #[inline] pub unsafe fn get_aqs_filter_from_device_class(&self, deviceClass: DeviceClass) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetAqsFilterFromDeviceClass)(self as *const _ as *mut _, deviceClass, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_from_id_async_with_kind_and_additional_properties(&self, deviceId: &HStringArg, additionalProperties: &super::super::foundation::collections::IIterable<HString>, kind: DeviceInformationKind) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformation>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateFromIdAsyncWithKindAndAdditionalProperties)(self as *const _ as *mut _, deviceId.get(), additionalProperties as *const _ as *mut _, kind, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn find_all_async_with_kind_aqs_filter_and_additional_properties(&self, aqsFilter: &HStringArg, additionalProperties: &super::super::foundation::collections::IIterable<HString>, kind: DeviceInformationKind) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceInformationCollection>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FindAllAsyncWithKindAqsFilterAndAdditionalProperties)(self as *const _ as *mut _, aqsFilter.get(), additionalProperties as *const _ as *mut _, kind, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_watcher_with_kind_aqs_filter_and_additional_properties(&self, aqsFilter: &HStringArg, additionalProperties: &super::super::foundation::collections::IIterable<HString>, kind: DeviceInformationKind) -> Result<ComPtr<DeviceWatcher>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWatcherWithKindAqsFilterAndAdditionalProperties)(self as *const _ as *mut _, aqsFilter.get(), additionalProperties as *const _ as *mut _, kind, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IDeviceInformation, 2879454101, 17304, 18589, 142, 68, 230, 19, 9, 39, 1, 31);
RT_INTERFACE!{interface IDeviceInformation(IDeviceInformationVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceInformation] {
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Name(&self, out: *mut HSTRING) -> HRESULT,
    fn get_IsEnabled(&self, out: *mut bool) -> HRESULT,
    fn get_IsDefault(&self, out: *mut bool) -> HRESULT,
    fn get_EnclosureLocation(&self, out: *mut *mut EnclosureLocation) -> HRESULT,
    fn get_Properties(&self, out: *mut *mut super::super::foundation::collections::IMapView<HString, IInspectable>) -> HRESULT,
    fn Update(&self, updateInfo: *mut DeviceInformationUpdate) -> HRESULT,
    fn GetThumbnailAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<DeviceThumbnail>) -> HRESULT,
    fn GetGlyphThumbnailAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<DeviceThumbnail>) -> HRESULT
}}
impl IDeviceInformation {
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Name)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_default(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDefault)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_enclosure_location(&self) -> Result<ComPtr<EnclosureLocation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_EnclosureLocation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_properties(&self) -> Result<ComPtr<super::super::foundation::collections::IMapView<HString, IInspectable>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Properties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn update(&self, updateInfo: &DeviceInformationUpdate) -> Result<()> {
        let hr = ((*self.lpVtbl).Update)(self as *const _ as *mut _, updateInfo as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_thumbnail_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceThumbnail>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetThumbnailAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_glyph_thumbnail_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceThumbnail>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetGlyphThumbnailAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_ENUM! { enum DevicePairingKinds: u32 {
    None (DevicePairingKinds_None) = 0, ConfirmOnly (DevicePairingKinds_ConfirmOnly) = 1, DisplayPin (DevicePairingKinds_DisplayPin) = 2, ProvidePin (DevicePairingKinds_ProvidePin) = 4, ConfirmPinMatch (DevicePairingKinds_ConfirmPinMatch) = 8,
}}
RT_ENUM! { enum DevicePairingResultStatus: i32 {
    Paired (DevicePairingResultStatus_Paired) = 0, NotReadyToPair (DevicePairingResultStatus_NotReadyToPair) = 1, NotPaired (DevicePairingResultStatus_NotPaired) = 2, AlreadyPaired (DevicePairingResultStatus_AlreadyPaired) = 3, ConnectionRejected (DevicePairingResultStatus_ConnectionRejected) = 4, TooManyConnections (DevicePairingResultStatus_TooManyConnections) = 5, HardwareFailure (DevicePairingResultStatus_HardwareFailure) = 6, AuthenticationTimeout (DevicePairingResultStatus_AuthenticationTimeout) = 7, AuthenticationNotAllowed (DevicePairingResultStatus_AuthenticationNotAllowed) = 8, AuthenticationFailure (DevicePairingResultStatus_AuthenticationFailure) = 9, NoSupportedProfiles (DevicePairingResultStatus_NoSupportedProfiles) = 10, ProtectionLevelCouldNotBeMet (DevicePairingResultStatus_ProtectionLevelCouldNotBeMet) = 11, AccessDenied (DevicePairingResultStatus_AccessDenied) = 12, InvalidCeremonyData (DevicePairingResultStatus_InvalidCeremonyData) = 13, PairingCanceled (DevicePairingResultStatus_PairingCanceled) = 14, OperationAlreadyInProgress (DevicePairingResultStatus_OperationAlreadyInProgress) = 15, RequiredHandlerNotRegistered (DevicePairingResultStatus_RequiredHandlerNotRegistered) = 16, RejectedByHandler (DevicePairingResultStatus_RejectedByHandler) = 17, RemoteDeviceHasAssociation (DevicePairingResultStatus_RemoteDeviceHasAssociation) = 18, Failed (DevicePairingResultStatus_Failed) = 19,
}}
RT_ENUM! { enum DeviceUnpairingResultStatus: i32 {
    Unpaired (DeviceUnpairingResultStatus_Unpaired) = 0, AlreadyUnpaired (DeviceUnpairingResultStatus_AlreadyUnpaired) = 1, OperationAlreadyInProgress (DeviceUnpairingResultStatus_OperationAlreadyInProgress) = 2, AccessDenied (DeviceUnpairingResultStatus_AccessDenied) = 3, Failed (DeviceUnpairingResultStatus_Failed) = 4,
}}
RT_ENUM! { enum DevicePairingProtectionLevel: i32 {
    Default (DevicePairingProtectionLevel_Default) = 0, None (DevicePairingProtectionLevel_None) = 1, Encryption (DevicePairingProtectionLevel_Encryption) = 2, EncryptionAndAuthentication (DevicePairingProtectionLevel_EncryptionAndAuthentication) = 3,
}}
DEFINE_IID!(IID_IDevicePairingResult, 120259263, 56725, 16421, 155, 55, 222, 81, 173, 186, 55, 183);
RT_INTERFACE!{interface IDevicePairingResult(IDevicePairingResultVtbl): IInspectable(IInspectableVtbl) [IID_IDevicePairingResult] {
    fn get_Status(&self, out: *mut DevicePairingResultStatus) -> HRESULT,
    fn get_ProtectionLevelUsed(&self, out: *mut DevicePairingProtectionLevel) -> HRESULT
}}
impl IDevicePairingResult {
    #[inline] pub unsafe fn get_status(&self) -> Result<DevicePairingResultStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_protection_level_used(&self) -> Result<DevicePairingProtectionLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ProtectionLevelUsed)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class DevicePairingResult: IDevicePairingResult}
DEFINE_IID!(IID_IDeviceUnpairingResult, 1727285971, 31193, 17483, 146, 207, 169, 46, 247, 37, 113, 199);
RT_INTERFACE!{interface IDeviceUnpairingResult(IDeviceUnpairingResultVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceUnpairingResult] {
    fn get_Status(&self, out: *mut DeviceUnpairingResultStatus) -> HRESULT
}}
impl IDeviceUnpairingResult {
    #[inline] pub unsafe fn get_status(&self) -> Result<DeviceUnpairingResultStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class DeviceUnpairingResult: IDeviceUnpairingResult}
DEFINE_IID!(IID_IDevicePairingSettings, 1210888828, 33723, 16910, 190, 81, 102, 2, 178, 34, 222, 84);
RT_INTERFACE!{interface IDevicePairingSettings(IDevicePairingSettingsVtbl): IInspectable(IInspectableVtbl) [IID_IDevicePairingSettings] {
    
}}
DEFINE_IID!(IID_IDevicePairingRequestedEventArgs, 4145544278, 56939, 18559, 131, 118, 1, 128, 172, 166, 153, 99);
RT_INTERFACE!{interface IDevicePairingRequestedEventArgs(IDevicePairingRequestedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IDevicePairingRequestedEventArgs] {
    fn get_DeviceInformation(&self, out: *mut *mut DeviceInformation) -> HRESULT,
    fn get_PairingKind(&self, out: *mut DevicePairingKinds) -> HRESULT,
    fn get_Pin(&self, out: *mut HSTRING) -> HRESULT,
    fn Accept(&self) -> HRESULT,
    fn AcceptWithPin(&self, pin: HSTRING) -> HRESULT,
    fn GetDeferral(&self, out: *mut *mut super::super::foundation::Deferral) -> HRESULT
}}
impl IDevicePairingRequestedEventArgs {
    #[inline] pub unsafe fn get_device_information(&self) -> Result<ComPtr<DeviceInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pairing_kind(&self) -> Result<DevicePairingKinds> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PairingKind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pin(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Pin)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn accept(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Accept)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn accept_with_pin(&self, pin: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).AcceptWithPin)(self as *const _ as *mut _, pin.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_deferral(&self) -> Result<ComPtr<super::super::foundation::Deferral>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeferral)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class DevicePairingRequestedEventArgs: IDevicePairingRequestedEventArgs}
DEFINE_IID!(IID_IDeviceInformationCustomPairing, 2232650754, 20198, 18708, 131, 112, 16, 122, 57, 20, 76, 14);
RT_INTERFACE!{interface IDeviceInformationCustomPairing(IDeviceInformationCustomPairingVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceInformationCustomPairing] {
    fn PairAsync(&self, pairingKindsSupported: DevicePairingKinds, out: *mut *mut super::super::foundation::IAsyncOperation<DevicePairingResult>) -> HRESULT,
    fn PairWithProtectionLevelAsync(&self, pairingKindsSupported: DevicePairingKinds, minProtectionLevel: DevicePairingProtectionLevel, out: *mut *mut super::super::foundation::IAsyncOperation<DevicePairingResult>) -> HRESULT,
    fn PairWithProtectionLevelAndSettingsAsync(&self, pairingKindsSupported: DevicePairingKinds, minProtectionLevel: DevicePairingProtectionLevel, devicePairingSettings: *mut IDevicePairingSettings, out: *mut *mut super::super::foundation::IAsyncOperation<DevicePairingResult>) -> HRESULT,
    fn add_PairingRequested(&self, handler: *mut super::super::foundation::TypedEventHandler<DeviceInformationCustomPairing, DevicePairingRequestedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_PairingRequested(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IDeviceInformationCustomPairing {
    #[inline] pub unsafe fn pair_async(&self, pairingKindsSupported: DevicePairingKinds) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DevicePairingResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).PairAsync)(self as *const _ as *mut _, pairingKindsSupported, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn pair_with_protection_level_async(&self, pairingKindsSupported: DevicePairingKinds, minProtectionLevel: DevicePairingProtectionLevel) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DevicePairingResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).PairWithProtectionLevelAsync)(self as *const _ as *mut _, pairingKindsSupported, minProtectionLevel, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn pair_with_protection_level_and_settings_async(&self, pairingKindsSupported: DevicePairingKinds, minProtectionLevel: DevicePairingProtectionLevel, devicePairingSettings: &IDevicePairingSettings) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DevicePairingResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).PairWithProtectionLevelAndSettingsAsync)(self as *const _ as *mut _, pairingKindsSupported, minProtectionLevel, devicePairingSettings as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_pairing_requested(&self, handler: &super::super::foundation::TypedEventHandler<DeviceInformationCustomPairing, DevicePairingRequestedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_PairingRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_pairing_requested(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_PairingRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class DeviceInformationCustomPairing: IDeviceInformationCustomPairing}
DEFINE_IID!(IID_IDeviceInformationPairing, 742877685, 63108, 16597, 132, 105, 232, 219, 170, 183, 4, 133);
RT_INTERFACE!{interface IDeviceInformationPairing(IDeviceInformationPairingVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceInformationPairing] {
    fn get_IsPaired(&self, out: *mut bool) -> HRESULT,
    fn get_CanPair(&self, out: *mut bool) -> HRESULT,
    fn PairAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<DevicePairingResult>) -> HRESULT,
    fn PairWithProtectionLevelAsync(&self, minProtectionLevel: DevicePairingProtectionLevel, out: *mut *mut super::super::foundation::IAsyncOperation<DevicePairingResult>) -> HRESULT
}}
impl IDeviceInformationPairing {
    #[inline] pub unsafe fn get_is_paired(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsPaired)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_can_pair(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanPair)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn pair_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DevicePairingResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).PairAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn pair_with_protection_level_async(&self, minProtectionLevel: DevicePairingProtectionLevel) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DevicePairingResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).PairWithProtectionLevelAsync)(self as *const _ as *mut _, minProtectionLevel, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IDeviceInformationPairing2, 4135981821, 2798, 17192, 133, 204, 28, 116, 43, 177, 121, 13);
RT_INTERFACE!{interface IDeviceInformationPairing2(IDeviceInformationPairing2Vtbl): IInspectable(IInspectableVtbl) [IID_IDeviceInformationPairing2] {
    fn get_ProtectionLevel(&self, out: *mut DevicePairingProtectionLevel) -> HRESULT,
    fn get_Custom(&self, out: *mut *mut DeviceInformationCustomPairing) -> HRESULT,
    fn PairWithProtectionLevelAndSettingsAsync(&self, minProtectionLevel: DevicePairingProtectionLevel, devicePairingSettings: *mut IDevicePairingSettings, out: *mut *mut super::super::foundation::IAsyncOperation<DevicePairingResult>) -> HRESULT,
    fn UnpairAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<DeviceUnpairingResult>) -> HRESULT
}}
impl IDeviceInformationPairing2 {
    #[inline] pub unsafe fn get_protection_level(&self) -> Result<DevicePairingProtectionLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ProtectionLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_custom(&self) -> Result<ComPtr<DeviceInformationCustomPairing>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Custom)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn pair_with_protection_level_and_settings_async(&self, minProtectionLevel: DevicePairingProtectionLevel, devicePairingSettings: &IDevicePairingSettings) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DevicePairingResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).PairWithProtectionLevelAndSettingsAsync)(self as *const _ as *mut _, minProtectionLevel, devicePairingSettings as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn unpair_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<DeviceUnpairingResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).UnpairAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IDeviceInformationPairingStatics, 3910517768, 14036, 18849, 191, 19, 81, 65, 115, 121, 155, 107);
RT_INTERFACE!{static interface IDeviceInformationPairingStatics(IDeviceInformationPairingStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceInformationPairingStatics] {
    fn TryRegisterForAllInboundPairingRequests(&self, pairingKindsSupported: DevicePairingKinds, out: *mut bool) -> HRESULT
}}
impl IDeviceInformationPairingStatics {
    #[inline] pub unsafe fn try_register_for_all_inbound_pairing_requests(&self, pairingKindsSupported: DevicePairingKinds) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).TryRegisterForAllInboundPairingRequests)(self as *const _ as *mut _, pairingKindsSupported, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class DeviceInformationPairing: IDeviceInformationPairing}
impl RtActivatable<IDeviceInformationPairingStatics> for DeviceInformationPairing {}
impl DeviceInformationPairing {
    #[inline] pub fn try_register_for_all_inbound_pairing_requests(pairingKindsSupported: DevicePairingKinds) -> Result<bool> { unsafe {
        <Self as RtActivatable<IDeviceInformationPairingStatics>>::get_activation_factory().try_register_for_all_inbound_pairing_requests(pairingKindsSupported)
    }}
}
DEFINE_CLSID!(DeviceInformationPairing(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,69,110,117,109,101,114,97,116,105,111,110,46,68,101,118,105,99,101,73,110,102,111,114,109,97,116,105,111,110,80,97,105,114,105,110,103,0]) [CLSID_DeviceInformationPairing]);
DEFINE_IID!(IID_IDeviceInformation2, 4048987704, 31127, 18649, 161, 12, 38, 157, 70, 83, 63, 72);
RT_INTERFACE!{interface IDeviceInformation2(IDeviceInformation2Vtbl): IInspectable(IInspectableVtbl) [IID_IDeviceInformation2] {
    fn get_Kind(&self, out: *mut DeviceInformationKind) -> HRESULT,
    fn get_Pairing(&self, out: *mut *mut DeviceInformationPairing) -> HRESULT
}}
impl IDeviceInformation2 {
    #[inline] pub unsafe fn get_kind(&self) -> Result<DeviceInformationKind> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Kind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pairing(&self) -> Result<ComPtr<DeviceInformationPairing>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Pairing)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_ENUM! { enum DeviceAccessStatus: i32 {
    Unspecified (DeviceAccessStatus_Unspecified) = 0, Allowed (DeviceAccessStatus_Allowed) = 1, DeniedByUser (DeviceAccessStatus_DeniedByUser) = 2, DeniedBySystem (DeviceAccessStatus_DeniedBySystem) = 3,
}}
DEFINE_IID!(IID_IDeviceAccessChangedEventArgs, 3738831820, 20381, 20312, 157, 186, 169, 188, 128, 4, 8, 213);
RT_INTERFACE!{interface IDeviceAccessChangedEventArgs(IDeviceAccessChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceAccessChangedEventArgs] {
    fn get_Status(&self, out: *mut DeviceAccessStatus) -> HRESULT
}}
impl IDeviceAccessChangedEventArgs {
    #[inline] pub unsafe fn get_status(&self) -> Result<DeviceAccessStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IDeviceAccessChangedEventArgs2, 2186424930, 37707, 19248, 161, 120, 173, 195, 159, 47, 43, 227);
RT_INTERFACE!{interface IDeviceAccessChangedEventArgs2(IDeviceAccessChangedEventArgs2Vtbl): IInspectable(IInspectableVtbl) [IID_IDeviceAccessChangedEventArgs2] {
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT
}}
impl IDeviceAccessChangedEventArgs2 {
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class DeviceAccessChangedEventArgs: IDeviceAccessChangedEventArgs}
DEFINE_IID!(IID_IDeviceAccessInformation, 195730035, 28133, 18709, 141, 221, 154, 5, 84, 166, 245, 69);
RT_INTERFACE!{interface IDeviceAccessInformation(IDeviceAccessInformationVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceAccessInformation] {
    fn add_AccessChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<DeviceAccessInformation, DeviceAccessChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_AccessChanged(&self, cookie: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_CurrentStatus(&self, out: *mut DeviceAccessStatus) -> HRESULT
}}
impl IDeviceAccessInformation {
    #[inline] pub unsafe fn add_access_changed(&self, handler: &super::super::foundation::TypedEventHandler<DeviceAccessInformation, DeviceAccessChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_AccessChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_access_changed(&self, cookie: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_AccessChanged)(self as *const _ as *mut _, cookie);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_current_status(&self) -> Result<DeviceAccessStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CurrentStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class DeviceAccessInformation: IDeviceAccessInformation}
impl RtActivatable<IDeviceAccessInformationStatics> for DeviceAccessInformation {}
impl DeviceAccessInformation {
    #[inline] pub fn create_from_id(deviceId: &HStringArg) -> Result<ComPtr<DeviceAccessInformation>> { unsafe {
        <Self as RtActivatable<IDeviceAccessInformationStatics>>::get_activation_factory().create_from_id(deviceId)
    }}
    #[inline] pub fn create_from_device_class_id(deviceClassId: Guid) -> Result<ComPtr<DeviceAccessInformation>> { unsafe {
        <Self as RtActivatable<IDeviceAccessInformationStatics>>::get_activation_factory().create_from_device_class_id(deviceClassId)
    }}
    #[inline] pub fn create_from_device_class(deviceClass: DeviceClass) -> Result<ComPtr<DeviceAccessInformation>> { unsafe {
        <Self as RtActivatable<IDeviceAccessInformationStatics>>::get_activation_factory().create_from_device_class(deviceClass)
    }}
}
DEFINE_CLSID!(DeviceAccessInformation(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,69,110,117,109,101,114,97,116,105,111,110,46,68,101,118,105,99,101,65,99,99,101,115,115,73,110,102,111,114,109,97,116,105,111,110,0]) [CLSID_DeviceAccessInformation]);
DEFINE_IID!(IID_IDeviceAccessInformationStatics, 1464587219, 24368, 17869, 138, 148, 114, 79, 229, 151, 48, 132);
RT_INTERFACE!{static interface IDeviceAccessInformationStatics(IDeviceAccessInformationStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceAccessInformationStatics] {
    fn CreateFromId(&self, deviceId: HSTRING, out: *mut *mut DeviceAccessInformation) -> HRESULT,
    fn CreateFromDeviceClassId(&self, deviceClassId: Guid, out: *mut *mut DeviceAccessInformation) -> HRESULT,
    fn CreateFromDeviceClass(&self, deviceClass: DeviceClass, out: *mut *mut DeviceAccessInformation) -> HRESULT
}}
impl IDeviceAccessInformationStatics {
    #[inline] pub unsafe fn create_from_id(&self, deviceId: &HStringArg) -> Result<ComPtr<DeviceAccessInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateFromId)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_from_device_class_id(&self, deviceClassId: Guid) -> Result<ComPtr<DeviceAccessInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateFromDeviceClassId)(self as *const _ as *mut _, deviceClassId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_from_device_class(&self, deviceClass: DeviceClass) -> Result<ComPtr<DeviceAccessInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateFromDeviceClass)(self as *const _ as *mut _, deviceClass, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IDeviceWatcherEvent, 1957338123, 7613, 18429, 182, 53, 60, 197, 86, 208, 255, 139);
RT_INTERFACE!{interface IDeviceWatcherEvent(IDeviceWatcherEventVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceWatcherEvent] {
    fn get_Kind(&self, out: *mut DeviceWatcherEventKind) -> HRESULT,
    fn get_DeviceInformation(&self, out: *mut *mut DeviceInformation) -> HRESULT,
    fn get_DeviceInformationUpdate(&self, out: *mut *mut DeviceInformationUpdate) -> HRESULT
}}
impl IDeviceWatcherEvent {
    #[inline] pub unsafe fn get_kind(&self) -> Result<DeviceWatcherEventKind> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Kind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_information(&self) -> Result<ComPtr<DeviceInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_information_update(&self) -> Result<ComPtr<DeviceInformationUpdate>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceInformationUpdate)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class DeviceWatcherEvent: IDeviceWatcherEvent}
DEFINE_IID!(IID_IDeviceWatcherTriggerDetails, 947945753, 19639, 20055, 165, 109, 119, 109, 7, 203, 254, 249);
RT_INTERFACE!{interface IDeviceWatcherTriggerDetails(IDeviceWatcherTriggerDetailsVtbl): IInspectable(IInspectableVtbl) [IID_IDeviceWatcherTriggerDetails] {
    fn get_DeviceWatcherEvents(&self, out: *mut *mut super::super::foundation::collections::IVectorView<DeviceWatcherEvent>) -> HRESULT
}}
impl IDeviceWatcherTriggerDetails {
    #[inline] pub unsafe fn get_device_watcher_events(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<DeviceWatcherEvent>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceWatcherEvents)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class DeviceWatcherTriggerDetails: IDeviceWatcherTriggerDetails}
pub mod pnp { // Windows.Devices.Enumeration.Pnp
use ::prelude::*;
RT_ENUM! { enum PnpObjectType: i32 {
    Unknown (PnpObjectType_Unknown) = 0, DeviceInterface (PnpObjectType_DeviceInterface) = 1, DeviceContainer (PnpObjectType_DeviceContainer) = 2, Device (PnpObjectType_Device) = 3, DeviceInterfaceClass (PnpObjectType_DeviceInterfaceClass) = 4, AssociationEndpoint (PnpObjectType_AssociationEndpoint) = 5, AssociationEndpointContainer (PnpObjectType_AssociationEndpointContainer) = 6, AssociationEndpointService (PnpObjectType_AssociationEndpointService) = 7,
}}
DEFINE_IID!(IID_IPnpObjectUpdate, 1868163090, 30, 18500, 188, 198, 67, 40, 134, 133, 106, 23);
RT_INTERFACE!{interface IPnpObjectUpdate(IPnpObjectUpdateVtbl): IInspectable(IInspectableVtbl) [IID_IPnpObjectUpdate] {
    fn get_Type(&self, out: *mut PnpObjectType) -> HRESULT,
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Properties(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IMapView<HString, IInspectable>) -> HRESULT
}}
impl IPnpObjectUpdate {
    #[inline] pub unsafe fn get_type(&self) -> Result<PnpObjectType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Type)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_properties(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IMapView<HString, IInspectable>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Properties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PnpObjectUpdate: IPnpObjectUpdate}
RT_CLASS!{class PnpObjectCollection: ::rt::gen::windows::foundation::collections::IVectorView<PnpObject>}
DEFINE_IID!(IID_IPnpObjectWatcher, 2211011752, 18290, 19066, 172, 168, 228, 140, 66, 168, 156, 68);
RT_INTERFACE!{interface IPnpObjectWatcher(IPnpObjectWatcherVtbl): IInspectable(IInspectableVtbl) [IID_IPnpObjectWatcher] {
    fn add_Added(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<PnpObjectWatcher, PnpObject>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Added(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn add_Updated(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<PnpObjectWatcher, PnpObjectUpdate>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Updated(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn add_Removed(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<PnpObjectWatcher, PnpObjectUpdate>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Removed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn add_EnumerationCompleted(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<PnpObjectWatcher, IInspectable>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_EnumerationCompleted(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn add_Stopped(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<PnpObjectWatcher, IInspectable>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Stopped(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn get_Status(&self, out: *mut super::DeviceWatcherStatus) -> HRESULT,
    fn Start(&self) -> HRESULT,
    fn Stop(&self) -> HRESULT
}}
impl IPnpObjectWatcher {
    #[inline] pub unsafe fn add_added(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<PnpObjectWatcher, PnpObject>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Added)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_added(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Added)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_updated(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<PnpObjectWatcher, PnpObjectUpdate>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Updated)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_updated(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Updated)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_removed(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<PnpObjectWatcher, PnpObjectUpdate>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Removed)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_removed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Removed)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_enumeration_completed(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<PnpObjectWatcher, IInspectable>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_EnumerationCompleted)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_enumeration_completed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_EnumerationCompleted)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_stopped(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<PnpObjectWatcher, IInspectable>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Stopped)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_stopped(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Stopped)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<super::DeviceWatcherStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Stop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class PnpObjectWatcher: IPnpObjectWatcher}
RT_CLASS!{class PnpObject: IPnpObject}
impl RtActivatable<IPnpObjectStatics> for PnpObject {}
impl PnpObject {
    #[inline] pub fn create_from_id_async(type_: PnpObjectType, id: &HStringArg, requestedProperties: &::rt::gen::windows::foundation::collections::IIterable<HString>) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<PnpObject>>> { unsafe {
        <Self as RtActivatable<IPnpObjectStatics>>::get_activation_factory().create_from_id_async(type_, id, requestedProperties)
    }}
    #[inline] pub fn find_all_async(type_: PnpObjectType, requestedProperties: &::rt::gen::windows::foundation::collections::IIterable<HString>) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<PnpObjectCollection>>> { unsafe {
        <Self as RtActivatable<IPnpObjectStatics>>::get_activation_factory().find_all_async(type_, requestedProperties)
    }}
    #[inline] pub fn find_all_async_aqs_filter(type_: PnpObjectType, requestedProperties: &::rt::gen::windows::foundation::collections::IIterable<HString>, aqsFilter: &HStringArg) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<PnpObjectCollection>>> { unsafe {
        <Self as RtActivatable<IPnpObjectStatics>>::get_activation_factory().find_all_async_aqs_filter(type_, requestedProperties, aqsFilter)
    }}
    #[inline] pub fn create_watcher(type_: PnpObjectType, requestedProperties: &::rt::gen::windows::foundation::collections::IIterable<HString>) -> Result<ComPtr<PnpObjectWatcher>> { unsafe {
        <Self as RtActivatable<IPnpObjectStatics>>::get_activation_factory().create_watcher(type_, requestedProperties)
    }}
    #[inline] pub fn create_watcher_aqs_filter(type_: PnpObjectType, requestedProperties: &::rt::gen::windows::foundation::collections::IIterable<HString>, aqsFilter: &HStringArg) -> Result<ComPtr<PnpObjectWatcher>> { unsafe {
        <Self as RtActivatable<IPnpObjectStatics>>::get_activation_factory().create_watcher_aqs_filter(type_, requestedProperties, aqsFilter)
    }}
}
DEFINE_CLSID!(PnpObject(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,69,110,117,109,101,114,97,116,105,111,110,46,80,110,112,46,80,110,112,79,98,106,101,99,116,0]) [CLSID_PnpObject]);
DEFINE_IID!(IID_IPnpObjectStatics, 3015911997, 53608, 18016, 187, 243, 167, 51, 177, 75, 110, 1);
RT_INTERFACE!{static interface IPnpObjectStatics(IPnpObjectStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IPnpObjectStatics] {
    fn CreateFromIdAsync(&self, type_: PnpObjectType, id: HSTRING, requestedProperties: *mut ::rt::gen::windows::foundation::collections::IIterable<HString>, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<PnpObject>) -> HRESULT,
    fn FindAllAsync(&self, type_: PnpObjectType, requestedProperties: *mut ::rt::gen::windows::foundation::collections::IIterable<HString>, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<PnpObjectCollection>) -> HRESULT,
    fn FindAllAsyncAqsFilter(&self, type_: PnpObjectType, requestedProperties: *mut ::rt::gen::windows::foundation::collections::IIterable<HString>, aqsFilter: HSTRING, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<PnpObjectCollection>) -> HRESULT,
    fn CreateWatcher(&self, type_: PnpObjectType, requestedProperties: *mut ::rt::gen::windows::foundation::collections::IIterable<HString>, out: *mut *mut PnpObjectWatcher) -> HRESULT,
    fn CreateWatcherAqsFilter(&self, type_: PnpObjectType, requestedProperties: *mut ::rt::gen::windows::foundation::collections::IIterable<HString>, aqsFilter: HSTRING, out: *mut *mut PnpObjectWatcher) -> HRESULT
}}
impl IPnpObjectStatics {
    #[inline] pub unsafe fn create_from_id_async(&self, type_: PnpObjectType, id: &HStringArg, requestedProperties: &::rt::gen::windows::foundation::collections::IIterable<HString>) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<PnpObject>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateFromIdAsync)(self as *const _ as *mut _, type_, id.get(), requestedProperties as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn find_all_async(&self, type_: PnpObjectType, requestedProperties: &::rt::gen::windows::foundation::collections::IIterable<HString>) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<PnpObjectCollection>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FindAllAsync)(self as *const _ as *mut _, type_, requestedProperties as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn find_all_async_aqs_filter(&self, type_: PnpObjectType, requestedProperties: &::rt::gen::windows::foundation::collections::IIterable<HString>, aqsFilter: &HStringArg) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<PnpObjectCollection>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FindAllAsyncAqsFilter)(self as *const _ as *mut _, type_, requestedProperties as *const _ as *mut _, aqsFilter.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_watcher(&self, type_: PnpObjectType, requestedProperties: &::rt::gen::windows::foundation::collections::IIterable<HString>) -> Result<ComPtr<PnpObjectWatcher>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWatcher)(self as *const _ as *mut _, type_, requestedProperties as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_watcher_aqs_filter(&self, type_: PnpObjectType, requestedProperties: &::rt::gen::windows::foundation::collections::IIterable<HString>, aqsFilter: &HStringArg) -> Result<ComPtr<PnpObjectWatcher>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWatcherAqsFilter)(self as *const _ as *mut _, type_, requestedProperties as *const _ as *mut _, aqsFilter.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPnpObject, 2512806488, 29499, 19087, 147, 163, 219, 7, 138, 200, 112, 193);
RT_INTERFACE!{interface IPnpObject(IPnpObjectVtbl): IInspectable(IInspectableVtbl) [IID_IPnpObject] {
    fn get_Type(&self, out: *mut PnpObjectType) -> HRESULT,
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Properties(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IMapView<HString, IInspectable>) -> HRESULT,
    fn Update(&self, updateInfo: *mut PnpObjectUpdate) -> HRESULT
}}
impl IPnpObject {
    #[inline] pub unsafe fn get_type(&self) -> Result<PnpObjectType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Type)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_properties(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IMapView<HString, IInspectable>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Properties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn update(&self, updateInfo: &PnpObjectUpdate) -> Result<()> {
        let hr = ((*self.lpVtbl).Update)(self as *const _ as *mut _, updateInfo as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
} // Windows.Devices.Enumeration.Pnp
} // Windows.Devices.Enumeration
pub mod geolocation { // Windows.Devices.Geolocation
use ::prelude::*;
RT_ENUM! { enum PositionAccuracy: i32 {
    Default (PositionAccuracy_Default) = 0, High (PositionAccuracy_High) = 1,
}}
RT_ENUM! { enum PositionStatus: i32 {
    Ready (PositionStatus_Ready) = 0, Initializing (PositionStatus_Initializing) = 1, NoData (PositionStatus_NoData) = 2, Disabled (PositionStatus_Disabled) = 3, NotInitialized (PositionStatus_NotInitialized) = 4, NotAvailable (PositionStatus_NotAvailable) = 5,
}}
RT_ENUM! { enum PositionSource: i32 {
    Cellular (PositionSource_Cellular) = 0, Satellite (PositionSource_Satellite) = 1, WiFi (PositionSource_WiFi) = 2, IPAddress (PositionSource_IPAddress) = 3, Unknown (PositionSource_Unknown) = 4, Default (PositionSource_Default) = 5, Obfuscated (PositionSource_Obfuscated) = 6,
}}
RT_ENUM! { enum GeoshapeType: i32 {
    Geopoint (GeoshapeType_Geopoint) = 0, Geocircle (GeoshapeType_Geocircle) = 1, Geopath (GeoshapeType_Geopath) = 2, GeoboundingBox (GeoshapeType_GeoboundingBox) = 3,
}}
RT_ENUM! { enum AltitudeReferenceSystem: i32 {
    Unspecified (AltitudeReferenceSystem_Unspecified) = 0, Terrain (AltitudeReferenceSystem_Terrain) = 1, Ellipsoid (AltitudeReferenceSystem_Ellipsoid) = 2, Geoid (AltitudeReferenceSystem_Geoid) = 3, Surface (AltitudeReferenceSystem_Surface) = 4,
}}
RT_STRUCT! { struct BasicGeoposition {
    Latitude: f64, Longitude: f64, Altitude: f64,
}}
RT_ENUM! { enum GeolocationAccessStatus: i32 {
    Unspecified (GeolocationAccessStatus_Unspecified) = 0, Allowed (GeolocationAccessStatus_Allowed) = 1, Denied (GeolocationAccessStatus_Denied) = 2,
}}
DEFINE_IID!(IID_IGeoshape, 3382485679, 50985, 17345, 143, 171, 214, 222, 201, 20, 223, 126);
RT_INTERFACE!{interface IGeoshape(IGeoshapeVtbl): IInspectable(IInspectableVtbl) [IID_IGeoshape] {
    fn get_GeoshapeType(&self, out: *mut GeoshapeType) -> HRESULT,
    fn get_SpatialReferenceId(&self, out: *mut u32) -> HRESULT,
    fn get_AltitudeReferenceSystem(&self, out: *mut AltitudeReferenceSystem) -> HRESULT
}}
impl IGeoshape {
    #[inline] pub unsafe fn get_geoshape_type(&self) -> Result<GeoshapeType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GeoshapeType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_spatial_reference_id(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SpatialReferenceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_altitude_reference_system(&self) -> Result<AltitudeReferenceSystem> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AltitudeReferenceSystem)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeopoint, 1811546347, 58734, 18875, 156, 175, 203, 170, 120, 168, 188, 239);
RT_INTERFACE!{interface IGeopoint(IGeopointVtbl): IInspectable(IInspectableVtbl) [IID_IGeopoint] {
    fn get_Position(&self, out: *mut BasicGeoposition) -> HRESULT
}}
impl IGeopoint {
    #[inline] pub unsafe fn get_position(&self) -> Result<BasicGeoposition> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Position)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeopointFactory, 3681258803, 30397, 20016, 138, 247, 168, 68, 220, 55, 183, 160);
RT_INTERFACE!{static interface IGeopointFactory(IGeopointFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IGeopointFactory] {
    fn Create(&self, position: BasicGeoposition, out: *mut *mut Geopoint) -> HRESULT,
    fn CreateWithAltitudeReferenceSystem(&self, position: BasicGeoposition, altitudeReferenceSystem: AltitudeReferenceSystem, out: *mut *mut Geopoint) -> HRESULT,
    fn CreateWithAltitudeReferenceSystemAndSpatialReferenceId(&self, position: BasicGeoposition, altitudeReferenceSystem: AltitudeReferenceSystem, spatialReferenceId: u32, out: *mut *mut Geopoint) -> HRESULT
}}
impl IGeopointFactory {
    #[inline] pub unsafe fn create(&self, position: BasicGeoposition) -> Result<ComPtr<Geopoint>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, position, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_with_altitude_reference_system(&self, position: BasicGeoposition, altitudeReferenceSystem: AltitudeReferenceSystem) -> Result<ComPtr<Geopoint>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWithAltitudeReferenceSystem)(self as *const _ as *mut _, position, altitudeReferenceSystem, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_with_altitude_reference_system_and_spatial_reference_id(&self, position: BasicGeoposition, altitudeReferenceSystem: AltitudeReferenceSystem, spatialReferenceId: u32) -> Result<ComPtr<Geopoint>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWithAltitudeReferenceSystemAndSpatialReferenceId)(self as *const _ as *mut _, position, altitudeReferenceSystem, spatialReferenceId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Geopoint: IGeopoint}
impl RtActivatable<IGeopointFactory> for Geopoint {}
impl Geopoint {
    #[inline] pub fn create(position: BasicGeoposition) -> Result<ComPtr<Geopoint>> { unsafe {
        <Self as RtActivatable<IGeopointFactory>>::get_activation_factory().create(position)
    }}
    #[inline] pub fn create_with_altitude_reference_system(position: BasicGeoposition, altitudeReferenceSystem: AltitudeReferenceSystem) -> Result<ComPtr<Geopoint>> { unsafe {
        <Self as RtActivatable<IGeopointFactory>>::get_activation_factory().create_with_altitude_reference_system(position, altitudeReferenceSystem)
    }}
    #[inline] pub fn create_with_altitude_reference_system_and_spatial_reference_id(position: BasicGeoposition, altitudeReferenceSystem: AltitudeReferenceSystem, spatialReferenceId: u32) -> Result<ComPtr<Geopoint>> { unsafe {
        <Self as RtActivatable<IGeopointFactory>>::get_activation_factory().create_with_altitude_reference_system_and_spatial_reference_id(position, altitudeReferenceSystem, spatialReferenceId)
    }}
}
DEFINE_CLSID!(Geopoint(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,71,101,111,108,111,99,97,116,105,111,110,46,71,101,111,112,111,105,110,116,0]) [CLSID_Geopoint]);
DEFINE_IID!(IID_IGeopath, 3846166457, 11684, 18196, 166, 82, 222, 133, 147, 40, 152, 152);
RT_INTERFACE!{interface IGeopath(IGeopathVtbl): IInspectable(IInspectableVtbl) [IID_IGeopath] {
    fn get_Positions(&self, out: *mut *mut super::super::foundation::collections::IVectorView<BasicGeoposition>) -> HRESULT
}}
impl IGeopath {
    #[inline] pub unsafe fn get_positions(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<BasicGeoposition>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Positions)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeopathFactory, 666806728, 51175, 17241, 155, 155, 252, 163, 224, 94, 245, 147);
RT_INTERFACE!{static interface IGeopathFactory(IGeopathFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IGeopathFactory] {
    fn Create(&self, positions: *mut super::super::foundation::collections::IIterable<BasicGeoposition>, out: *mut *mut Geopath) -> HRESULT,
    fn CreateWithAltitudeReference(&self, positions: *mut super::super::foundation::collections::IIterable<BasicGeoposition>, altitudeReferenceSystem: AltitudeReferenceSystem, out: *mut *mut Geopath) -> HRESULT,
    fn CreateWithAltitudeReferenceAndSpatialReference(&self, positions: *mut super::super::foundation::collections::IIterable<BasicGeoposition>, altitudeReferenceSystem: AltitudeReferenceSystem, spatialReferenceId: u32, out: *mut *mut Geopath) -> HRESULT
}}
impl IGeopathFactory {
    #[inline] pub unsafe fn create(&self, positions: &super::super::foundation::collections::IIterable<BasicGeoposition>) -> Result<ComPtr<Geopath>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, positions as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_with_altitude_reference(&self, positions: &super::super::foundation::collections::IIterable<BasicGeoposition>, altitudeReferenceSystem: AltitudeReferenceSystem) -> Result<ComPtr<Geopath>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWithAltitudeReference)(self as *const _ as *mut _, positions as *const _ as *mut _, altitudeReferenceSystem, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_with_altitude_reference_and_spatial_reference(&self, positions: &super::super::foundation::collections::IIterable<BasicGeoposition>, altitudeReferenceSystem: AltitudeReferenceSystem, spatialReferenceId: u32) -> Result<ComPtr<Geopath>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWithAltitudeReferenceAndSpatialReference)(self as *const _ as *mut _, positions as *const _ as *mut _, altitudeReferenceSystem, spatialReferenceId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Geopath: IGeopath}
impl RtActivatable<IGeopathFactory> for Geopath {}
impl Geopath {
    #[inline] pub fn create(positions: &super::super::foundation::collections::IIterable<BasicGeoposition>) -> Result<ComPtr<Geopath>> { unsafe {
        <Self as RtActivatable<IGeopathFactory>>::get_activation_factory().create(positions)
    }}
    #[inline] pub fn create_with_altitude_reference(positions: &super::super::foundation::collections::IIterable<BasicGeoposition>, altitudeReferenceSystem: AltitudeReferenceSystem) -> Result<ComPtr<Geopath>> { unsafe {
        <Self as RtActivatable<IGeopathFactory>>::get_activation_factory().create_with_altitude_reference(positions, altitudeReferenceSystem)
    }}
    #[inline] pub fn create_with_altitude_reference_and_spatial_reference(positions: &super::super::foundation::collections::IIterable<BasicGeoposition>, altitudeReferenceSystem: AltitudeReferenceSystem, spatialReferenceId: u32) -> Result<ComPtr<Geopath>> { unsafe {
        <Self as RtActivatable<IGeopathFactory>>::get_activation_factory().create_with_altitude_reference_and_spatial_reference(positions, altitudeReferenceSystem, spatialReferenceId)
    }}
}
DEFINE_CLSID!(Geopath(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,71,101,111,108,111,99,97,116,105,111,110,46,71,101,111,112,97,116,104,0]) [CLSID_Geopath]);
DEFINE_IID!(IID_IGeoboundingBox, 144099339, 10063, 17370, 154, 6, 203, 252, 218, 235, 78, 194);
RT_INTERFACE!{interface IGeoboundingBox(IGeoboundingBoxVtbl): IInspectable(IInspectableVtbl) [IID_IGeoboundingBox] {
    fn get_NorthwestCorner(&self, out: *mut BasicGeoposition) -> HRESULT,
    fn get_SoutheastCorner(&self, out: *mut BasicGeoposition) -> HRESULT,
    fn get_Center(&self, out: *mut BasicGeoposition) -> HRESULT,
    fn get_MinAltitude(&self, out: *mut f64) -> HRESULT,
    fn get_MaxAltitude(&self, out: *mut f64) -> HRESULT
}}
impl IGeoboundingBox {
    #[inline] pub unsafe fn get_northwest_corner(&self) -> Result<BasicGeoposition> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_NorthwestCorner)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_southeast_corner(&self) -> Result<BasicGeoposition> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SoutheastCorner)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_center(&self) -> Result<BasicGeoposition> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Center)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_min_altitude(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinAltitude)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_altitude(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxAltitude)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeoboundingBoxFactory, 1308337545, 1041, 19132, 179, 181, 91, 188, 203, 87, 217, 140);
RT_INTERFACE!{static interface IGeoboundingBoxFactory(IGeoboundingBoxFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IGeoboundingBoxFactory] {
    fn Create(&self, northwestCorner: BasicGeoposition, southeastCorner: BasicGeoposition, out: *mut *mut GeoboundingBox) -> HRESULT,
    fn CreateWithAltitudeReference(&self, northwestCorner: BasicGeoposition, southeastCorner: BasicGeoposition, altitudeReferenceSystem: AltitudeReferenceSystem, out: *mut *mut GeoboundingBox) -> HRESULT,
    fn CreateWithAltitudeReferenceAndSpatialReference(&self, northwestCorner: BasicGeoposition, southeastCorner: BasicGeoposition, altitudeReferenceSystem: AltitudeReferenceSystem, spatialReferenceId: u32, out: *mut *mut GeoboundingBox) -> HRESULT
}}
impl IGeoboundingBoxFactory {
    #[inline] pub unsafe fn create(&self, northwestCorner: BasicGeoposition, southeastCorner: BasicGeoposition) -> Result<ComPtr<GeoboundingBox>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, northwestCorner, southeastCorner, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_with_altitude_reference(&self, northwestCorner: BasicGeoposition, southeastCorner: BasicGeoposition, altitudeReferenceSystem: AltitudeReferenceSystem) -> Result<ComPtr<GeoboundingBox>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWithAltitudeReference)(self as *const _ as *mut _, northwestCorner, southeastCorner, altitudeReferenceSystem, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_with_altitude_reference_and_spatial_reference(&self, northwestCorner: BasicGeoposition, southeastCorner: BasicGeoposition, altitudeReferenceSystem: AltitudeReferenceSystem, spatialReferenceId: u32) -> Result<ComPtr<GeoboundingBox>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWithAltitudeReferenceAndSpatialReference)(self as *const _ as *mut _, northwestCorner, southeastCorner, altitudeReferenceSystem, spatialReferenceId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GeoboundingBox: IGeoboundingBox}
impl RtActivatable<IGeoboundingBoxFactory> for GeoboundingBox {}
impl RtActivatable<IGeoboundingBoxStatics> for GeoboundingBox {}
impl GeoboundingBox {
    #[inline] pub fn create(northwestCorner: BasicGeoposition, southeastCorner: BasicGeoposition) -> Result<ComPtr<GeoboundingBox>> { unsafe {
        <Self as RtActivatable<IGeoboundingBoxFactory>>::get_activation_factory().create(northwestCorner, southeastCorner)
    }}
    #[inline] pub fn create_with_altitude_reference(northwestCorner: BasicGeoposition, southeastCorner: BasicGeoposition, altitudeReferenceSystem: AltitudeReferenceSystem) -> Result<ComPtr<GeoboundingBox>> { unsafe {
        <Self as RtActivatable<IGeoboundingBoxFactory>>::get_activation_factory().create_with_altitude_reference(northwestCorner, southeastCorner, altitudeReferenceSystem)
    }}
    #[inline] pub fn create_with_altitude_reference_and_spatial_reference(northwestCorner: BasicGeoposition, southeastCorner: BasicGeoposition, altitudeReferenceSystem: AltitudeReferenceSystem, spatialReferenceId: u32) -> Result<ComPtr<GeoboundingBox>> { unsafe {
        <Self as RtActivatable<IGeoboundingBoxFactory>>::get_activation_factory().create_with_altitude_reference_and_spatial_reference(northwestCorner, southeastCorner, altitudeReferenceSystem, spatialReferenceId)
    }}
    #[inline] pub fn try_compute(positions: &super::super::foundation::collections::IIterable<BasicGeoposition>) -> Result<ComPtr<GeoboundingBox>> { unsafe {
        <Self as RtActivatable<IGeoboundingBoxStatics>>::get_activation_factory().try_compute(positions)
    }}
    #[inline] pub fn try_compute_with_altitude_reference(positions: &super::super::foundation::collections::IIterable<BasicGeoposition>, altitudeRefSystem: AltitudeReferenceSystem) -> Result<ComPtr<GeoboundingBox>> { unsafe {
        <Self as RtActivatable<IGeoboundingBoxStatics>>::get_activation_factory().try_compute_with_altitude_reference(positions, altitudeRefSystem)
    }}
    #[inline] pub fn try_compute_with_altitude_reference_and_spatial_reference(positions: &super::super::foundation::collections::IIterable<BasicGeoposition>, altitudeRefSystem: AltitudeReferenceSystem, spatialReferenceId: u32) -> Result<ComPtr<GeoboundingBox>> { unsafe {
        <Self as RtActivatable<IGeoboundingBoxStatics>>::get_activation_factory().try_compute_with_altitude_reference_and_spatial_reference(positions, altitudeRefSystem, spatialReferenceId)
    }}
}
DEFINE_CLSID!(GeoboundingBox(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,71,101,111,108,111,99,97,116,105,111,110,46,71,101,111,98,111,117,110,100,105,110,103,66,111,120,0]) [CLSID_GeoboundingBox]);
DEFINE_IID!(IID_IGeoboundingBoxStatics, 1740113672, 58906, 19664, 132, 27, 147, 35, 55, 146, 181, 202);
RT_INTERFACE!{static interface IGeoboundingBoxStatics(IGeoboundingBoxStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGeoboundingBoxStatics] {
    fn TryCompute(&self, positions: *mut super::super::foundation::collections::IIterable<BasicGeoposition>, out: *mut *mut GeoboundingBox) -> HRESULT,
    fn TryComputeWithAltitudeReference(&self, positions: *mut super::super::foundation::collections::IIterable<BasicGeoposition>, altitudeRefSystem: AltitudeReferenceSystem, out: *mut *mut GeoboundingBox) -> HRESULT,
    fn TryComputeWithAltitudeReferenceAndSpatialReference(&self, positions: *mut super::super::foundation::collections::IIterable<BasicGeoposition>, altitudeRefSystem: AltitudeReferenceSystem, spatialReferenceId: u32, out: *mut *mut GeoboundingBox) -> HRESULT
}}
impl IGeoboundingBoxStatics {
    #[inline] pub unsafe fn try_compute(&self, positions: &super::super::foundation::collections::IIterable<BasicGeoposition>) -> Result<ComPtr<GeoboundingBox>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryCompute)(self as *const _ as *mut _, positions as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_compute_with_altitude_reference(&self, positions: &super::super::foundation::collections::IIterable<BasicGeoposition>, altitudeRefSystem: AltitudeReferenceSystem) -> Result<ComPtr<GeoboundingBox>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryComputeWithAltitudeReference)(self as *const _ as *mut _, positions as *const _ as *mut _, altitudeRefSystem, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_compute_with_altitude_reference_and_spatial_reference(&self, positions: &super::super::foundation::collections::IIterable<BasicGeoposition>, altitudeRefSystem: AltitudeReferenceSystem, spatialReferenceId: u32) -> Result<ComPtr<GeoboundingBox>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryComputeWithAltitudeReferenceAndSpatialReference)(self as *const _ as *mut _, positions as *const _ as *mut _, altitudeRefSystem, spatialReferenceId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeocoordinateSatelliteData, 3274339545, 9736, 18252, 145, 44, 6, 221, 73, 15, 74, 247);
RT_INTERFACE!{interface IGeocoordinateSatelliteData(IGeocoordinateSatelliteDataVtbl): IInspectable(IInspectableVtbl) [IID_IGeocoordinateSatelliteData] {
    fn get_PositionDilutionOfPrecision(&self, out: *mut *mut super::super::foundation::IReference<f64>) -> HRESULT,
    fn get_HorizontalDilutionOfPrecision(&self, out: *mut *mut super::super::foundation::IReference<f64>) -> HRESULT,
    fn get_VerticalDilutionOfPrecision(&self, out: *mut *mut super::super::foundation::IReference<f64>) -> HRESULT
}}
impl IGeocoordinateSatelliteData {
    #[inline] pub unsafe fn get_position_dilution_of_precision(&self) -> Result<ComPtr<super::super::foundation::IReference<f64>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PositionDilutionOfPrecision)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_horizontal_dilution_of_precision(&self) -> Result<ComPtr<super::super::foundation::IReference<f64>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_HorizontalDilutionOfPrecision)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_vertical_dilution_of_precision(&self) -> Result<ComPtr<super::super::foundation::IReference<f64>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_VerticalDilutionOfPrecision)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GeocoordinateSatelliteData: IGeocoordinateSatelliteData}
DEFINE_IID!(IID_IVenueData, 1727238535, 24803, 19247, 181, 39, 79, 83, 241, 195, 198, 119);
RT_INTERFACE!{interface IVenueData(IVenueDataVtbl): IInspectable(IInspectableVtbl) [IID_IVenueData] {
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Level(&self, out: *mut HSTRING) -> HRESULT
}}
impl IVenueData {
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_level(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Level)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class VenueData: IVenueData}
DEFINE_IID!(IID_IGeocoordinate, 3995181994, 38762, 19568, 128, 61, 8, 62, 165, 91, 203, 196);
RT_INTERFACE!{interface IGeocoordinate(IGeocoordinateVtbl): IInspectable(IInspectableVtbl) [IID_IGeocoordinate] {
    fn get_Latitude(&self, out: *mut f64) -> HRESULT,
    fn get_Longitude(&self, out: *mut f64) -> HRESULT,
    fn get_Altitude(&self, out: *mut *mut super::super::foundation::IReference<f64>) -> HRESULT,
    fn get_Accuracy(&self, out: *mut f64) -> HRESULT,
    fn get_AltitudeAccuracy(&self, out: *mut *mut super::super::foundation::IReference<f64>) -> HRESULT,
    fn get_Heading(&self, out: *mut *mut super::super::foundation::IReference<f64>) -> HRESULT,
    fn get_Speed(&self, out: *mut *mut super::super::foundation::IReference<f64>) -> HRESULT,
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT
}}
impl IGeocoordinate {
    #[inline] pub unsafe fn get_latitude(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Latitude)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_longitude(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Longitude)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_altitude(&self) -> Result<ComPtr<super::super::foundation::IReference<f64>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Altitude)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_accuracy(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Accuracy)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_altitude_accuracy(&self) -> Result<ComPtr<super::super::foundation::IReference<f64>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AltitudeAccuracy)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_heading(&self) -> Result<ComPtr<super::super::foundation::IReference<f64>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Heading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_speed(&self) -> Result<ComPtr<super::super::foundation::IReference<f64>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Speed)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeocoordinateWithPositionData, 2514891966, 56278, 16556, 184, 242, 166, 92, 3, 64, 217, 166);
RT_INTERFACE!{interface IGeocoordinateWithPositionData(IGeocoordinateWithPositionDataVtbl): IInspectable(IInspectableVtbl) [IID_IGeocoordinateWithPositionData] {
    fn get_PositionSource(&self, out: *mut PositionSource) -> HRESULT,
    fn get_SatelliteData(&self, out: *mut *mut GeocoordinateSatelliteData) -> HRESULT
}}
impl IGeocoordinateWithPositionData {
    #[inline] pub unsafe fn get_position_source(&self) -> Result<PositionSource> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PositionSource)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_satellite_data(&self) -> Result<ComPtr<GeocoordinateSatelliteData>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SatelliteData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeocoordinateWithPoint, 4276749605, 53804, 19782, 181, 39, 11, 150, 6, 111, 199, 219);
RT_INTERFACE!{interface IGeocoordinateWithPoint(IGeocoordinateWithPointVtbl): IInspectable(IInspectableVtbl) [IID_IGeocoordinateWithPoint] {
    fn get_Point(&self, out: *mut *mut Geopoint) -> HRESULT
}}
impl IGeocoordinateWithPoint {
    #[inline] pub unsafe fn get_point(&self) -> Result<ComPtr<Geopoint>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Point)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeocoordinateWithPositionSourceTimestamp, 2235825154, 51697, 17936, 175, 224, 139, 195, 166, 168, 112, 54);
RT_INTERFACE!{interface IGeocoordinateWithPositionSourceTimestamp(IGeocoordinateWithPositionSourceTimestampVtbl): IInspectable(IInspectableVtbl) [IID_IGeocoordinateWithPositionSourceTimestamp] {
    fn get_PositionSourceTimestamp(&self, out: *mut *mut super::super::foundation::IReference<super::super::foundation::DateTime>) -> HRESULT
}}
impl IGeocoordinateWithPositionSourceTimestamp {
    #[inline] pub unsafe fn get_position_source_timestamp(&self) -> Result<ComPtr<super::super::foundation::IReference<super::super::foundation::DateTime>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PositionSourceTimestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeoposition, 3247244372, 32065, 20471, 169, 87, 157, 255, 180, 239, 127, 91);
RT_INTERFACE!{interface IGeoposition(IGeopositionVtbl): IInspectable(IInspectableVtbl) [IID_IGeoposition] {
    fn get_Coordinate(&self, out: *mut *mut Geocoordinate) -> HRESULT,
    fn get_CivicAddress(&self, out: *mut *mut CivicAddress) -> HRESULT
}}
impl IGeoposition {
    #[inline] pub unsafe fn get_coordinate(&self) -> Result<ComPtr<Geocoordinate>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Coordinate)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_civic_address(&self) -> Result<ComPtr<CivicAddress>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_CivicAddress)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeoposition2, 2137192087, 34417, 19213, 134, 248, 71, 74, 132, 150, 24, 124);
RT_INTERFACE!{interface IGeoposition2(IGeoposition2Vtbl): IInspectable(IInspectableVtbl) [IID_IGeoposition2] {
    fn get_VenueData(&self, out: *mut *mut VenueData) -> HRESULT
}}
impl IGeoposition2 {
    #[inline] pub unsafe fn get_venue_data(&self) -> Result<ComPtr<VenueData>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_VenueData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Geocoordinate: IGeocoordinate}
RT_CLASS!{class CivicAddress: ICivicAddress}
DEFINE_IID!(IID_ICivicAddress, 2824239642, 25844, 19784, 188, 234, 246, 176, 8, 236, 163, 76);
RT_INTERFACE!{interface ICivicAddress(ICivicAddressVtbl): IInspectable(IInspectableVtbl) [IID_ICivicAddress] {
    fn get_Country(&self, out: *mut HSTRING) -> HRESULT,
    fn get_State(&self, out: *mut HSTRING) -> HRESULT,
    fn get_City(&self, out: *mut HSTRING) -> HRESULT,
    fn get_PostalCode(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT
}}
impl ICivicAddress {
    #[inline] pub unsafe fn get_country(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Country)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_state(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_State)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_city(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_City)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_postal_code(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PostalCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class Geoposition: IGeoposition}
DEFINE_IID!(IID_IPositionChangedEventArgs, 931503333, 40222, 18117, 191, 59, 106, 216, 202, 193, 160, 147);
RT_INTERFACE!{interface IPositionChangedEventArgs(IPositionChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPositionChangedEventArgs] {
    fn get_Position(&self, out: *mut *mut Geoposition) -> HRESULT
}}
impl IPositionChangedEventArgs {
    #[inline] pub unsafe fn get_position(&self) -> Result<ComPtr<Geoposition>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Position)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PositionChangedEventArgs: IPositionChangedEventArgs}
DEFINE_IID!(IID_IStatusChangedEventArgs, 877908698, 35987, 16657, 162, 5, 154, 236, 252, 155, 229, 192);
RT_INTERFACE!{interface IStatusChangedEventArgs(IStatusChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IStatusChangedEventArgs] {
    fn get_Status(&self, out: *mut PositionStatus) -> HRESULT
}}
impl IStatusChangedEventArgs {
    #[inline] pub unsafe fn get_status(&self) -> Result<PositionStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class StatusChangedEventArgs: IStatusChangedEventArgs}
DEFINE_IID!(IID_IGeolocator, 2848178018, 17700, 18825, 138, 169, 222, 1, 157, 46, 85, 31);
RT_INTERFACE!{interface IGeolocator(IGeolocatorVtbl): IInspectable(IInspectableVtbl) [IID_IGeolocator] {
    fn get_DesiredAccuracy(&self, out: *mut PositionAccuracy) -> HRESULT,
    fn put_DesiredAccuracy(&self, value: PositionAccuracy) -> HRESULT,
    fn get_MovementThreshold(&self, out: *mut f64) -> HRESULT,
    fn put_MovementThreshold(&self, value: f64) -> HRESULT,
    fn get_ReportInterval(&self, out: *mut u32) -> HRESULT,
    fn put_ReportInterval(&self, value: u32) -> HRESULT,
    fn get_LocationStatus(&self, out: *mut PositionStatus) -> HRESULT,
    fn GetGeopositionAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<Geoposition>) -> HRESULT,
    fn GetGeopositionAsyncWithAgeAndTimeout(&self, maximumAge: super::super::foundation::TimeSpan, timeout: super::super::foundation::TimeSpan, out: *mut *mut super::super::foundation::IAsyncOperation<Geoposition>) -> HRESULT,
    fn add_PositionChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<Geolocator, PositionChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_PositionChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_StatusChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<Geolocator, StatusChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_StatusChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IGeolocator {
    #[inline] pub unsafe fn get_desired_accuracy(&self) -> Result<PositionAccuracy> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DesiredAccuracy)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_desired_accuracy(&self, value: PositionAccuracy) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DesiredAccuracy)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_movement_threshold(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MovementThreshold)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_movement_threshold(&self, value: f64) -> Result<()> {
        let hr = ((*self.lpVtbl).put_MovementThreshold)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_report_interval(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReportInterval)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_location_status(&self) -> Result<PositionStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LocationStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_geoposition_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Geoposition>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetGeopositionAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_geoposition_async_with_age_and_timeout(&self, maximumAge: super::super::foundation::TimeSpan, timeout: super::super::foundation::TimeSpan) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Geoposition>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetGeopositionAsyncWithAgeAndTimeout)(self as *const _ as *mut _, maximumAge, timeout, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_position_changed(&self, handler: &super::super::foundation::TypedEventHandler<Geolocator, PositionChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_PositionChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_position_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_PositionChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_status_changed(&self, handler: &super::super::foundation::TypedEventHandler<Geolocator, StatusChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_StatusChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_status_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_StatusChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class Geolocator: IGeolocator}
impl RtActivatable<IGeolocatorStatics2> for Geolocator {}
impl RtActivatable<IGeolocatorStatics> for Geolocator {}
impl RtActivatable<IActivationFactory> for Geolocator {}
impl Geolocator {
    #[inline] pub fn get_is_default_geoposition_recommended() -> Result<bool> { unsafe {
        <Self as RtActivatable<IGeolocatorStatics2>>::get_activation_factory().get_is_default_geoposition_recommended()
    }}
    #[inline] pub fn set_default_geoposition(value: &super::super::foundation::IReference<BasicGeoposition>) -> Result<()> { unsafe {
        <Self as RtActivatable<IGeolocatorStatics2>>::get_activation_factory().set_default_geoposition(value)
    }}
    #[inline] pub fn get_default_geoposition() -> Result<ComPtr<super::super::foundation::IReference<BasicGeoposition>>> { unsafe {
        <Self as RtActivatable<IGeolocatorStatics2>>::get_activation_factory().get_default_geoposition()
    }}
    #[inline] pub fn request_access_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<GeolocationAccessStatus>>> { unsafe {
        <Self as RtActivatable<IGeolocatorStatics>>::get_activation_factory().request_access_async()
    }}
    #[inline] pub fn get_geoposition_history_async(startTime: super::super::foundation::DateTime) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<Geoposition>>>> { unsafe {
        <Self as RtActivatable<IGeolocatorStatics>>::get_activation_factory().get_geoposition_history_async(startTime)
    }}
    #[inline] pub fn get_geoposition_history_with_duration_async(startTime: super::super::foundation::DateTime, duration: super::super::foundation::TimeSpan) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<Geoposition>>>> { unsafe {
        <Self as RtActivatable<IGeolocatorStatics>>::get_activation_factory().get_geoposition_history_with_duration_async(startTime, duration)
    }}
}
DEFINE_CLSID!(Geolocator(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,71,101,111,108,111,99,97,116,105,111,110,46,71,101,111,108,111,99,97,116,111,114,0]) [CLSID_Geolocator]);
DEFINE_IID!(IID_IGeolocatorWithScalarAccuracy, 2532692929, 47119, 17930, 153, 77, 169, 108, 71, 165, 26, 164);
RT_INTERFACE!{interface IGeolocatorWithScalarAccuracy(IGeolocatorWithScalarAccuracyVtbl): IInspectable(IInspectableVtbl) [IID_IGeolocatorWithScalarAccuracy] {
    fn get_DesiredAccuracyInMeters(&self, out: *mut *mut super::super::foundation::IReference<u32>) -> HRESULT,
    fn put_DesiredAccuracyInMeters(&self, value: *mut super::super::foundation::IReference<u32>) -> HRESULT
}}
impl IGeolocatorWithScalarAccuracy {
    #[inline] pub unsafe fn get_desired_accuracy_in_meters(&self) -> Result<ComPtr<super::super::foundation::IReference<u32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DesiredAccuracyInMeters)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_desired_accuracy_in_meters(&self, value: &super::super::foundation::IReference<u32>) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DesiredAccuracyInMeters)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeolocator2, 3518246509, 34961, 17332, 173, 54, 39, 198, 254, 154, 151, 177);
RT_INTERFACE!{interface IGeolocator2(IGeolocator2Vtbl): IInspectable(IInspectableVtbl) [IID_IGeolocator2] {
    fn AllowFallbackToConsentlessPositions(&self) -> HRESULT
}}
impl IGeolocator2 {
    #[inline] pub unsafe fn allow_fallback_to_consentless_positions(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).AllowFallbackToConsentlessPositions)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeolocatorStatics, 2593027441, 11765, 17809, 159, 135, 235, 95, 216, 148, 233, 183);
RT_INTERFACE!{static interface IGeolocatorStatics(IGeolocatorStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGeolocatorStatics] {
    fn RequestAccessAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<GeolocationAccessStatus>) -> HRESULT,
    fn GetGeopositionHistoryAsync(&self, startTime: super::super::foundation::DateTime, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<Geoposition>>) -> HRESULT,
    fn GetGeopositionHistoryWithDurationAsync(&self, startTime: super::super::foundation::DateTime, duration: super::super::foundation::TimeSpan, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<Geoposition>>) -> HRESULT
}}
impl IGeolocatorStatics {
    #[inline] pub unsafe fn request_access_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<GeolocationAccessStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestAccessAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_geoposition_history_async(&self, startTime: super::super::foundation::DateTime) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<Geoposition>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetGeopositionHistoryAsync)(self as *const _ as *mut _, startTime, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_geoposition_history_with_duration_async(&self, startTime: super::super::foundation::DateTime, duration: super::super::foundation::TimeSpan) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<Geoposition>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetGeopositionHistoryWithDurationAsync)(self as *const _ as *mut _, startTime, duration, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeolocatorStatics2, 2570064290, 64028, 17969, 167, 29, 13, 190, 177, 37, 13, 156);
RT_INTERFACE!{static interface IGeolocatorStatics2(IGeolocatorStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IGeolocatorStatics2] {
    fn get_IsDefaultGeopositionRecommended(&self, out: *mut bool) -> HRESULT,
    fn put_DefaultGeoposition(&self, value: *mut super::super::foundation::IReference<BasicGeoposition>) -> HRESULT,
    fn get_DefaultGeoposition(&self, out: *mut *mut super::super::foundation::IReference<BasicGeoposition>) -> HRESULT
}}
impl IGeolocatorStatics2 {
    #[inline] pub unsafe fn get_is_default_geoposition_recommended(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDefaultGeopositionRecommended)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_default_geoposition(&self, value: &super::super::foundation::IReference<BasicGeoposition>) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DefaultGeoposition)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_geoposition(&self) -> Result<ComPtr<super::super::foundation::IReference<BasicGeoposition>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DefaultGeoposition)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeocircle, 971266115, 43001, 20067, 146, 167, 186, 12, 40, 209, 36, 177);
RT_INTERFACE!{interface IGeocircle(IGeocircleVtbl): IInspectable(IInspectableVtbl) [IID_IGeocircle] {
    fn get_Center(&self, out: *mut BasicGeoposition) -> HRESULT,
    fn get_Radius(&self, out: *mut f64) -> HRESULT
}}
impl IGeocircle {
    #[inline] pub unsafe fn get_center(&self) -> Result<BasicGeoposition> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Center)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_radius(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Radius)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeocircleFactory, 2950058783, 29361, 20349, 135, 204, 78, 212, 201, 132, 156, 5);
RT_INTERFACE!{static interface IGeocircleFactory(IGeocircleFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IGeocircleFactory] {
    fn Create(&self, position: BasicGeoposition, radius: f64, out: *mut *mut Geocircle) -> HRESULT,
    fn CreateWithAltitudeReferenceSystem(&self, position: BasicGeoposition, radius: f64, altitudeReferenceSystem: AltitudeReferenceSystem, out: *mut *mut Geocircle) -> HRESULT,
    fn CreateWithAltitudeReferenceSystemAndSpatialReferenceId(&self, position: BasicGeoposition, radius: f64, altitudeReferenceSystem: AltitudeReferenceSystem, spatialReferenceId: u32, out: *mut *mut Geocircle) -> HRESULT
}}
impl IGeocircleFactory {
    #[inline] pub unsafe fn create(&self, position: BasicGeoposition, radius: f64) -> Result<ComPtr<Geocircle>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, position, radius, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_with_altitude_reference_system(&self, position: BasicGeoposition, radius: f64, altitudeReferenceSystem: AltitudeReferenceSystem) -> Result<ComPtr<Geocircle>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWithAltitudeReferenceSystem)(self as *const _ as *mut _, position, radius, altitudeReferenceSystem, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_with_altitude_reference_system_and_spatial_reference_id(&self, position: BasicGeoposition, radius: f64, altitudeReferenceSystem: AltitudeReferenceSystem, spatialReferenceId: u32) -> Result<ComPtr<Geocircle>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWithAltitudeReferenceSystemAndSpatialReferenceId)(self as *const _ as *mut _, position, radius, altitudeReferenceSystem, spatialReferenceId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Geocircle: IGeocircle}
impl RtActivatable<IGeocircleFactory> for Geocircle {}
impl Geocircle {
    #[inline] pub fn create(position: BasicGeoposition, radius: f64) -> Result<ComPtr<Geocircle>> { unsafe {
        <Self as RtActivatable<IGeocircleFactory>>::get_activation_factory().create(position, radius)
    }}
    #[inline] pub fn create_with_altitude_reference_system(position: BasicGeoposition, radius: f64, altitudeReferenceSystem: AltitudeReferenceSystem) -> Result<ComPtr<Geocircle>> { unsafe {
        <Self as RtActivatable<IGeocircleFactory>>::get_activation_factory().create_with_altitude_reference_system(position, radius, altitudeReferenceSystem)
    }}
    #[inline] pub fn create_with_altitude_reference_system_and_spatial_reference_id(position: BasicGeoposition, radius: f64, altitudeReferenceSystem: AltitudeReferenceSystem, spatialReferenceId: u32) -> Result<ComPtr<Geocircle>> { unsafe {
        <Self as RtActivatable<IGeocircleFactory>>::get_activation_factory().create_with_altitude_reference_system_and_spatial_reference_id(position, radius, altitudeReferenceSystem, spatialReferenceId)
    }}
}
DEFINE_CLSID!(Geocircle(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,71,101,111,108,111,99,97,116,105,111,110,46,71,101,111,99,105,114,99,108,101,0]) [CLSID_Geocircle]);
pub mod geofencing { // Windows.Devices.Geolocation.Geofencing
use ::prelude::*;
RT_ENUM! { enum MonitoredGeofenceStates: u32 {
    None (MonitoredGeofenceStates_None) = 0, Entered (MonitoredGeofenceStates_Entered) = 1, Exited (MonitoredGeofenceStates_Exited) = 2, Removed (MonitoredGeofenceStates_Removed) = 4,
}}
RT_ENUM! { enum GeofenceState: u32 {
    None (GeofenceState_None) = 0, Entered (GeofenceState_Entered) = 1, Exited (GeofenceState_Exited) = 2, Removed (GeofenceState_Removed) = 4,
}}
RT_ENUM! { enum GeofenceMonitorStatus: i32 {
    Ready (GeofenceMonitorStatus_Ready) = 0, Initializing (GeofenceMonitorStatus_Initializing) = 1, NoData (GeofenceMonitorStatus_NoData) = 2, Disabled (GeofenceMonitorStatus_Disabled) = 3, NotInitialized (GeofenceMonitorStatus_NotInitialized) = 4, NotAvailable (GeofenceMonitorStatus_NotAvailable) = 5,
}}
RT_ENUM! { enum GeofenceRemovalReason: i32 {
    Used (GeofenceRemovalReason_Used) = 0, Expired (GeofenceRemovalReason_Expired) = 1,
}}
DEFINE_IID!(IID_IGeofenceFactory, 2216649291, 12895, 19344, 188, 167, 43, 128, 34, 169, 55, 150);
RT_INTERFACE!{static interface IGeofenceFactory(IGeofenceFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IGeofenceFactory] {
    fn Create(&self, id: HSTRING, geoshape: *mut super::IGeoshape, out: *mut *mut Geofence) -> HRESULT,
    fn CreateWithMonitorStates(&self, id: HSTRING, geoshape: *mut super::IGeoshape, monitoredStates: MonitoredGeofenceStates, singleUse: bool, out: *mut *mut Geofence) -> HRESULT,
    fn CreateWithMonitorStatesAndDwellTime(&self, id: HSTRING, geoshape: *mut super::IGeoshape, monitoredStates: MonitoredGeofenceStates, singleUse: bool, dwellTime: ::rt::gen::windows::foundation::TimeSpan, out: *mut *mut Geofence) -> HRESULT,
    fn CreateWithMonitorStatesDwellTimeStartTimeAndDuration(&self, id: HSTRING, geoshape: *mut super::IGeoshape, monitoredStates: MonitoredGeofenceStates, singleUse: bool, dwellTime: ::rt::gen::windows::foundation::TimeSpan, startTime: ::rt::gen::windows::foundation::DateTime, duration: ::rt::gen::windows::foundation::TimeSpan, out: *mut *mut Geofence) -> HRESULT
}}
impl IGeofenceFactory {
    #[inline] pub unsafe fn create(&self, id: &HStringArg, geoshape: &super::IGeoshape) -> Result<ComPtr<Geofence>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, id.get(), geoshape as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_with_monitor_states(&self, id: &HStringArg, geoshape: &super::IGeoshape, monitoredStates: MonitoredGeofenceStates, singleUse: bool) -> Result<ComPtr<Geofence>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWithMonitorStates)(self as *const _ as *mut _, id.get(), geoshape as *const _ as *mut _, monitoredStates, singleUse, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_with_monitor_states_and_dwell_time(&self, id: &HStringArg, geoshape: &super::IGeoshape, monitoredStates: MonitoredGeofenceStates, singleUse: bool, dwellTime: ::rt::gen::windows::foundation::TimeSpan) -> Result<ComPtr<Geofence>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWithMonitorStatesAndDwellTime)(self as *const _ as *mut _, id.get(), geoshape as *const _ as *mut _, monitoredStates, singleUse, dwellTime, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_with_monitor_states_dwell_time_start_time_and_duration(&self, id: &HStringArg, geoshape: &super::IGeoshape, monitoredStates: MonitoredGeofenceStates, singleUse: bool, dwellTime: ::rt::gen::windows::foundation::TimeSpan, startTime: ::rt::gen::windows::foundation::DateTime, duration: ::rt::gen::windows::foundation::TimeSpan) -> Result<ComPtr<Geofence>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWithMonitorStatesDwellTimeStartTimeAndDuration)(self as *const _ as *mut _, id.get(), geoshape as *const _ as *mut _, monitoredStates, singleUse, dwellTime, startTime, duration, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Geofence: IGeofence}
impl RtActivatable<IGeofenceFactory> for Geofence {}
impl Geofence {
    #[inline] pub fn create(id: &HStringArg, geoshape: &super::IGeoshape) -> Result<ComPtr<Geofence>> { unsafe {
        <Self as RtActivatable<IGeofenceFactory>>::get_activation_factory().create(id, geoshape)
    }}
    #[inline] pub fn create_with_monitor_states(id: &HStringArg, geoshape: &super::IGeoshape, monitoredStates: MonitoredGeofenceStates, singleUse: bool) -> Result<ComPtr<Geofence>> { unsafe {
        <Self as RtActivatable<IGeofenceFactory>>::get_activation_factory().create_with_monitor_states(id, geoshape, monitoredStates, singleUse)
    }}
    #[inline] pub fn create_with_monitor_states_and_dwell_time(id: &HStringArg, geoshape: &super::IGeoshape, monitoredStates: MonitoredGeofenceStates, singleUse: bool, dwellTime: ::rt::gen::windows::foundation::TimeSpan) -> Result<ComPtr<Geofence>> { unsafe {
        <Self as RtActivatable<IGeofenceFactory>>::get_activation_factory().create_with_monitor_states_and_dwell_time(id, geoshape, monitoredStates, singleUse, dwellTime)
    }}
    #[inline] pub fn create_with_monitor_states_dwell_time_start_time_and_duration(id: &HStringArg, geoshape: &super::IGeoshape, monitoredStates: MonitoredGeofenceStates, singleUse: bool, dwellTime: ::rt::gen::windows::foundation::TimeSpan, startTime: ::rt::gen::windows::foundation::DateTime, duration: ::rt::gen::windows::foundation::TimeSpan) -> Result<ComPtr<Geofence>> { unsafe {
        <Self as RtActivatable<IGeofenceFactory>>::get_activation_factory().create_with_monitor_states_dwell_time_start_time_and_duration(id, geoshape, monitoredStates, singleUse, dwellTime, startTime, duration)
    }}
}
DEFINE_CLSID!(Geofence(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,71,101,111,108,111,99,97,116,105,111,110,46,71,101,111,102,101,110,99,105,110,103,46,71,101,111,102,101,110,99,101,0]) [CLSID_Geofence]);
DEFINE_IID!(IID_IGeofence, 2617837603, 60856, 18400, 130, 69, 91, 246, 29, 50, 31, 45);
RT_INTERFACE!{interface IGeofence(IGeofenceVtbl): IInspectable(IInspectableVtbl) [IID_IGeofence] {
    fn get_StartTime(&self, out: *mut ::rt::gen::windows::foundation::DateTime) -> HRESULT,
    fn get_Duration(&self, out: *mut ::rt::gen::windows::foundation::TimeSpan) -> HRESULT,
    fn get_DwellTime(&self, out: *mut ::rt::gen::windows::foundation::TimeSpan) -> HRESULT,
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn get_MonitoredStates(&self, out: *mut MonitoredGeofenceStates) -> HRESULT,
    fn get_Geoshape(&self, out: *mut *mut super::IGeoshape) -> HRESULT,
    fn get_SingleUse(&self, out: *mut bool) -> HRESULT
}}
impl IGeofence {
    #[inline] pub unsafe fn get_start_time(&self) -> Result<::rt::gen::windows::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_StartTime)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_duration(&self) -> Result<::rt::gen::windows::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Duration)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_dwell_time(&self) -> Result<::rt::gen::windows::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DwellTime)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_monitored_states(&self) -> Result<MonitoredGeofenceStates> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MonitoredStates)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_geoshape(&self) -> Result<ComPtr<super::IGeoshape>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Geoshape)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_single_use(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SingleUse)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeofenceStateChangeReport, 2586065944, 9316, 19593, 190, 5, 179, 255, 255, 91, 171, 197);
RT_INTERFACE!{interface IGeofenceStateChangeReport(IGeofenceStateChangeReportVtbl): IInspectable(IInspectableVtbl) [IID_IGeofenceStateChangeReport] {
    fn get_NewState(&self, out: *mut GeofenceState) -> HRESULT,
    fn get_Geofence(&self, out: *mut *mut Geofence) -> HRESULT,
    fn get_Geoposition(&self, out: *mut *mut super::Geoposition) -> HRESULT,
    fn get_RemovalReason(&self, out: *mut GeofenceRemovalReason) -> HRESULT
}}
impl IGeofenceStateChangeReport {
    #[inline] pub unsafe fn get_new_state(&self) -> Result<GeofenceState> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_NewState)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_geofence(&self) -> Result<ComPtr<Geofence>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Geofence)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_geoposition(&self) -> Result<ComPtr<super::Geoposition>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Geoposition)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_removal_reason(&self) -> Result<GeofenceRemovalReason> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RemovalReason)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGeofenceMonitorStatics, 768815055, 32373, 18585, 172, 227, 43, 208, 166, 92, 206, 6);
RT_INTERFACE!{static interface IGeofenceMonitorStatics(IGeofenceMonitorStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGeofenceMonitorStatics] {
    fn get_Current(&self, out: *mut *mut GeofenceMonitor) -> HRESULT
}}
impl IGeofenceMonitorStatics {
    #[inline] pub unsafe fn get_current(&self) -> Result<ComPtr<GeofenceMonitor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Current)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class GeofenceMonitor: IGeofenceMonitor}
impl RtActivatable<IGeofenceMonitorStatics> for GeofenceMonitor {}
impl GeofenceMonitor {
    #[inline] pub fn get_current() -> Result<ComPtr<GeofenceMonitor>> { unsafe {
        <Self as RtActivatable<IGeofenceMonitorStatics>>::get_activation_factory().get_current()
    }}
}
DEFINE_CLSID!(GeofenceMonitor(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,71,101,111,108,111,99,97,116,105,111,110,46,71,101,111,102,101,110,99,105,110,103,46,71,101,111,102,101,110,99,101,77,111,110,105,116,111,114,0]) [CLSID_GeofenceMonitor]);
DEFINE_IID!(IID_IGeofenceMonitor, 1276075896, 7199, 17953, 187, 189, 131, 59, 146, 36, 114, 38);
RT_INTERFACE!{interface IGeofenceMonitor(IGeofenceMonitorVtbl): IInspectable(IInspectableVtbl) [IID_IGeofenceMonitor] {
    fn get_Status(&self, out: *mut GeofenceMonitorStatus) -> HRESULT,
    fn get_Geofences(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVector<Geofence>) -> HRESULT,
    fn get_LastKnownGeoposition(&self, out: *mut *mut super::Geoposition) -> HRESULT,
    fn add_GeofenceStateChanged(&self, eventHandler: *mut ::rt::gen::windows::foundation::TypedEventHandler<GeofenceMonitor, IInspectable>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_GeofenceStateChanged(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn ReadReports(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<GeofenceStateChangeReport>) -> HRESULT,
    fn add_StatusChanged(&self, eventHandler: *mut ::rt::gen::windows::foundation::TypedEventHandler<GeofenceMonitor, IInspectable>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_StatusChanged(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT
}}
impl IGeofenceMonitor {
    #[inline] pub unsafe fn get_status(&self) -> Result<GeofenceMonitorStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_geofences(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVector<Geofence>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Geofences)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_last_known_geoposition(&self) -> Result<ComPtr<super::Geoposition>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_LastKnownGeoposition)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_geofence_state_changed(&self, eventHandler: &::rt::gen::windows::foundation::TypedEventHandler<GeofenceMonitor, IInspectable>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_GeofenceStateChanged)(self as *const _ as *mut _, eventHandler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_geofence_state_changed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_GeofenceStateChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn read_reports(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<GeofenceStateChangeReport>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ReadReports)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_status_changed(&self, eventHandler: &::rt::gen::windows::foundation::TypedEventHandler<GeofenceMonitor, IInspectable>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_StatusChanged)(self as *const _ as *mut _, eventHandler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_status_changed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_StatusChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class GeofenceStateChangeReport: IGeofenceStateChangeReport}
} // Windows.Devices.Geolocation.Geofencing
} // Windows.Devices.Geolocation
pub mod haptics { // Windows.Devices.Haptics
use ::prelude::*;
DEFINE_IID!(IID_IKnownSimpleHapticsControllerWaveformsStatics, 1029144311, 19694, 4582, 181, 53, 0, 27, 220, 6, 171, 59);
RT_INTERFACE!{static interface IKnownSimpleHapticsControllerWaveformsStatics(IKnownSimpleHapticsControllerWaveformsStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IKnownSimpleHapticsControllerWaveformsStatics] {
    fn get_Click(&self, out: *mut u16) -> HRESULT,
    fn get_BuzzContinuous(&self, out: *mut u16) -> HRESULT,
    fn get_RumbleContinuous(&self, out: *mut u16) -> HRESULT,
    fn get_Press(&self, out: *mut u16) -> HRESULT,
    fn get_Release(&self, out: *mut u16) -> HRESULT
}}
impl IKnownSimpleHapticsControllerWaveformsStatics {
    #[inline] pub unsafe fn get_click(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Click)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_buzz_continuous(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BuzzContinuous)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_rumble_continuous(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RumbleContinuous)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_press(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Press)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_release(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Release)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISimpleHapticsControllerFeedback, 1029144312, 19694, 4582, 181, 53, 0, 27, 220, 6, 171, 59);
RT_INTERFACE!{interface ISimpleHapticsControllerFeedback(ISimpleHapticsControllerFeedbackVtbl): IInspectable(IInspectableVtbl) [IID_ISimpleHapticsControllerFeedback] {
    fn get_Waveform(&self, out: *mut u16) -> HRESULT,
    fn get_Duration(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT
}}
impl ISimpleHapticsControllerFeedback {
    #[inline] pub unsafe fn get_waveform(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Waveform)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_duration(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Duration)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISimpleHapticsController, 1029144313, 19694, 4582, 181, 53, 0, 27, 220, 6, 171, 59);
RT_INTERFACE!{interface ISimpleHapticsController(ISimpleHapticsControllerVtbl): IInspectable(IInspectableVtbl) [IID_ISimpleHapticsController] {
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn get_SupportedFeedback(&self, out: *mut *mut super::super::foundation::collections::IVectorView<SimpleHapticsControllerFeedback>) -> HRESULT,
    fn get_IsIntensitySupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsPlayCountSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsPlayDurationSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsReplayPauseIntervalSupported(&self, out: *mut bool) -> HRESULT,
    fn StopFeedback(&self) -> HRESULT,
    fn SendHapticFeedback(&self, feedback: *mut SimpleHapticsControllerFeedback) -> HRESULT,
    fn SendHapticFeedbackWithIntensity(&self, feedback: *mut SimpleHapticsControllerFeedback, intensity: f64) -> HRESULT,
    fn SendHapticFeedbackForDuration(&self, feedback: *mut SimpleHapticsControllerFeedback, intensity: f64, playDuration: super::super::foundation::TimeSpan) -> HRESULT,
    fn SendHapticFeedbackForPlayCount(&self, feedback: *mut SimpleHapticsControllerFeedback, intensity: f64, playCount: i32, replayPauseInterval: super::super::foundation::TimeSpan) -> HRESULT
}}
impl ISimpleHapticsController {
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_feedback(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<SimpleHapticsControllerFeedback>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedFeedback)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_intensity_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsIntensitySupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_play_count_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsPlayCountSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_play_duration_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsPlayDurationSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_replay_pause_interval_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsReplayPauseIntervalSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop_feedback(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).StopFeedback)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn send_haptic_feedback(&self, feedback: &SimpleHapticsControllerFeedback) -> Result<()> {
        let hr = ((*self.lpVtbl).SendHapticFeedback)(self as *const _ as *mut _, feedback as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn send_haptic_feedback_with_intensity(&self, feedback: &SimpleHapticsControllerFeedback, intensity: f64) -> Result<()> {
        let hr = ((*self.lpVtbl).SendHapticFeedbackWithIntensity)(self as *const _ as *mut _, feedback as *const _ as *mut _, intensity);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn send_haptic_feedback_for_duration(&self, feedback: &SimpleHapticsControllerFeedback, intensity: f64, playDuration: super::super::foundation::TimeSpan) -> Result<()> {
        let hr = ((*self.lpVtbl).SendHapticFeedbackForDuration)(self as *const _ as *mut _, feedback as *const _ as *mut _, intensity, playDuration);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn send_haptic_feedback_for_play_count(&self, feedback: &SimpleHapticsControllerFeedback, intensity: f64, playCount: i32, replayPauseInterval: super::super::foundation::TimeSpan) -> Result<()> {
        let hr = ((*self.lpVtbl).SendHapticFeedbackForPlayCount)(self as *const _ as *mut _, feedback as *const _ as *mut _, intensity, playCount, replayPauseInterval);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class SimpleHapticsControllerFeedback: ISimpleHapticsControllerFeedback}
RT_CLASS!{class SimpleHapticsController: ISimpleHapticsController}
RT_CLASS!{static class KnownSimpleHapticsControllerWaveforms}
impl RtActivatable<IKnownSimpleHapticsControllerWaveformsStatics> for KnownSimpleHapticsControllerWaveforms {}
impl KnownSimpleHapticsControllerWaveforms {
    #[inline] pub fn get_click() -> Result<u16> { unsafe {
        <Self as RtActivatable<IKnownSimpleHapticsControllerWaveformsStatics>>::get_activation_factory().get_click()
    }}
    #[inline] pub fn get_buzz_continuous() -> Result<u16> { unsafe {
        <Self as RtActivatable<IKnownSimpleHapticsControllerWaveformsStatics>>::get_activation_factory().get_buzz_continuous()
    }}
    #[inline] pub fn get_rumble_continuous() -> Result<u16> { unsafe {
        <Self as RtActivatable<IKnownSimpleHapticsControllerWaveformsStatics>>::get_activation_factory().get_rumble_continuous()
    }}
    #[inline] pub fn get_press() -> Result<u16> { unsafe {
        <Self as RtActivatable<IKnownSimpleHapticsControllerWaveformsStatics>>::get_activation_factory().get_press()
    }}
    #[inline] pub fn get_release() -> Result<u16> { unsafe {
        <Self as RtActivatable<IKnownSimpleHapticsControllerWaveformsStatics>>::get_activation_factory().get_release()
    }}
}
DEFINE_CLSID!(KnownSimpleHapticsControllerWaveforms(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,72,97,112,116,105,99,115,46,75,110,111,119,110,83,105,109,112,108,101,72,97,112,116,105,99,115,67,111,110,116,114,111,108,108,101,114,87,97,118,101,102,111,114,109,115,0]) [CLSID_KnownSimpleHapticsControllerWaveforms]);
RT_ENUM! { enum VibrationAccessStatus: i32 {
    Allowed (VibrationAccessStatus_Allowed) = 0, DeniedByUser (VibrationAccessStatus_DeniedByUser) = 1, DeniedBySystem (VibrationAccessStatus_DeniedBySystem) = 2, DeniedByEnergySaver (VibrationAccessStatus_DeniedByEnergySaver) = 3,
}}
DEFINE_IID!(IID_IVibrationDeviceStatics, 1407380973, 8848, 19145, 142, 179, 26, 132, 18, 46, 183, 28);
RT_INTERFACE!{static interface IVibrationDeviceStatics(IVibrationDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IVibrationDeviceStatics] {
    fn RequestAccessAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<VibrationAccessStatus>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<VibrationDevice>) -> HRESULT,
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<VibrationDevice>) -> HRESULT,
    fn FindAllAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<VibrationDevice>>) -> HRESULT
}}
impl IVibrationDeviceStatics {
    #[inline] pub unsafe fn request_access_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<VibrationAccessStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestAccessAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<VibrationDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<VibrationDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn find_all_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<VibrationDevice>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FindAllAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class VibrationDevice: IVibrationDevice}
impl RtActivatable<IVibrationDeviceStatics> for VibrationDevice {}
impl VibrationDevice {
    #[inline] pub fn request_access_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<VibrationAccessStatus>>> { unsafe {
        <Self as RtActivatable<IVibrationDeviceStatics>>::get_activation_factory().request_access_async()
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IVibrationDeviceStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<VibrationDevice>>> { unsafe {
        <Self as RtActivatable<IVibrationDeviceStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<VibrationDevice>>> { unsafe {
        <Self as RtActivatable<IVibrationDeviceStatics>>::get_activation_factory().get_default_async()
    }}
    #[inline] pub fn find_all_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<VibrationDevice>>>> { unsafe {
        <Self as RtActivatable<IVibrationDeviceStatics>>::get_activation_factory().find_all_async()
    }}
}
DEFINE_CLSID!(VibrationDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,72,97,112,116,105,99,115,46,86,105,98,114,97,116,105,111,110,68,101,118,105,99,101,0]) [CLSID_VibrationDevice]);
DEFINE_IID!(IID_IVibrationDevice, 1089608254, 34884, 18431, 179, 18, 6, 24, 90, 56, 68, 218);
RT_INTERFACE!{interface IVibrationDevice(IVibrationDeviceVtbl): IInspectable(IInspectableVtbl) [IID_IVibrationDevice] {
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn get_SimpleHapticsController(&self, out: *mut *mut SimpleHapticsController) -> HRESULT
}}
impl IVibrationDevice {
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_simple_haptics_controller(&self) -> Result<ComPtr<SimpleHapticsController>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SimpleHapticsController)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
} // Windows.Devices.Haptics
pub mod humaninterfacedevice { // Windows.Devices.HumanInterfaceDevice
use ::prelude::*;
RT_ENUM! { enum HidReportType: i32 {
    Input (HidReportType_Input) = 0, Output (HidReportType_Output) = 1, Feature (HidReportType_Feature) = 2,
}}
RT_ENUM! { enum HidCollectionType: i32 {
    Physical (HidCollectionType_Physical) = 0, Application (HidCollectionType_Application) = 1, Logical (HidCollectionType_Logical) = 2, Report (HidCollectionType_Report) = 3, NamedArray (HidCollectionType_NamedArray) = 4, UsageSwitch (HidCollectionType_UsageSwitch) = 5, UsageModifier (HidCollectionType_UsageModifier) = 6, Other (HidCollectionType_Other) = 7,
}}
DEFINE_IID!(IID_IHidDeviceStatics, 2656666084, 38998, 16780, 159, 115, 119, 222, 12, 216, 87, 84);
RT_INTERFACE!{static interface IHidDeviceStatics(IHidDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IHidDeviceStatics] {
    fn GetDeviceSelector(&self, usagePage: u16, usageId: u16, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorVidPid(&self, usagePage: u16, usageId: u16, vendorId: u16, productId: u16, out: *mut HSTRING) -> HRESULT,
    #[cfg(feature="windows-storage")] fn FromIdAsync(&self, deviceId: HSTRING, accessMode: super::super::storage::FileAccessMode, out: *mut *mut super::super::foundation::IAsyncOperation<HidDevice>) -> HRESULT
}}
impl IHidDeviceStatics {
    #[inline] pub unsafe fn get_device_selector(&self, usagePage: u16, usageId: u16) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, usagePage, usageId, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_vid_pid(&self, usagePage: u16, usageId: u16, vendorId: u16, productId: u16) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorVidPid)(self as *const _ as *mut _, usagePage, usageId, vendorId, productId, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg, accessMode: super::super::storage::FileAccessMode) -> Result<ComPtr<super::super::foundation::IAsyncOperation<HidDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), accessMode, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class HidDevice: IHidDevice}
impl RtActivatable<IHidDeviceStatics> for HidDevice {}
impl HidDevice {
    #[inline] pub fn get_device_selector(usagePage: u16, usageId: u16) -> Result<HString> { unsafe {
        <Self as RtActivatable<IHidDeviceStatics>>::get_activation_factory().get_device_selector(usagePage, usageId)
    }}
    #[inline] pub fn get_device_selector_vid_pid(usagePage: u16, usageId: u16, vendorId: u16, productId: u16) -> Result<HString> { unsafe {
        <Self as RtActivatable<IHidDeviceStatics>>::get_activation_factory().get_device_selector_vid_pid(usagePage, usageId, vendorId, productId)
    }}
    #[cfg(feature="windows-storage")] #[inline] pub fn from_id_async(deviceId: &HStringArg, accessMode: super::super::storage::FileAccessMode) -> Result<ComPtr<super::super::foundation::IAsyncOperation<HidDevice>>> { unsafe {
        <Self as RtActivatable<IHidDeviceStatics>>::get_activation_factory().from_id_async(deviceId, accessMode)
    }}
}
DEFINE_CLSID!(HidDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,72,117,109,97,110,73,110,116,101,114,102,97,99,101,68,101,118,105,99,101,46,72,105,100,68,101,118,105,99,101,0]) [CLSID_HidDevice]);
DEFINE_IID!(IID_IHidDevice, 1602884839, 8704, 17198, 149, 218, 208, 155, 135, 213, 116, 168);
RT_INTERFACE!{interface IHidDevice(IHidDeviceVtbl): IInspectable(IInspectableVtbl) [IID_IHidDevice] {
    fn get_VendorId(&self, out: *mut u16) -> HRESULT,
    fn get_ProductId(&self, out: *mut u16) -> HRESULT,
    fn get_Version(&self, out: *mut u16) -> HRESULT,
    fn get_UsagePage(&self, out: *mut u16) -> HRESULT,
    fn get_UsageId(&self, out: *mut u16) -> HRESULT,
    fn GetInputReportAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<HidInputReport>) -> HRESULT,
    fn GetInputReportByIdAsync(&self, reportId: u16, out: *mut *mut super::super::foundation::IAsyncOperation<HidInputReport>) -> HRESULT,
    fn GetFeatureReportAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<HidFeatureReport>) -> HRESULT,
    fn GetFeatureReportByIdAsync(&self, reportId: u16, out: *mut *mut super::super::foundation::IAsyncOperation<HidFeatureReport>) -> HRESULT,
    fn CreateOutputReport(&self, out: *mut *mut HidOutputReport) -> HRESULT,
    fn CreateOutputReportById(&self, reportId: u16, out: *mut *mut HidOutputReport) -> HRESULT,
    fn CreateFeatureReport(&self, out: *mut *mut HidFeatureReport) -> HRESULT,
    fn CreateFeatureReportById(&self, reportId: u16, out: *mut *mut HidFeatureReport) -> HRESULT,
    fn SendOutputReportAsync(&self, outputReport: *mut HidOutputReport, out: *mut *mut super::super::foundation::IAsyncOperation<u32>) -> HRESULT,
    fn SendFeatureReportAsync(&self, featureReport: *mut HidFeatureReport, out: *mut *mut super::super::foundation::IAsyncOperation<u32>) -> HRESULT,
    fn GetBooleanControlDescriptions(&self, reportType: HidReportType, usagePage: u16, usageId: u16, out: *mut *mut super::super::foundation::collections::IVectorView<HidBooleanControlDescription>) -> HRESULT,
    fn GetNumericControlDescriptions(&self, reportType: HidReportType, usagePage: u16, usageId: u16, out: *mut *mut super::super::foundation::collections::IVectorView<HidNumericControlDescription>) -> HRESULT,
    fn add_InputReportReceived(&self, reportHandler: *mut super::super::foundation::TypedEventHandler<HidDevice, HidInputReportReceivedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_InputReportReceived(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IHidDevice {
    #[inline] pub unsafe fn get_vendor_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_VendorId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_product_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ProductId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_version(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Version)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_usage_page(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsagePage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_usage_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsageId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_input_report_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<HidInputReport>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetInputReportAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_input_report_by_id_async(&self, reportId: u16) -> Result<ComPtr<super::super::foundation::IAsyncOperation<HidInputReport>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetInputReportByIdAsync)(self as *const _ as *mut _, reportId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_feature_report_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<HidFeatureReport>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetFeatureReportAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_feature_report_by_id_async(&self, reportId: u16) -> Result<ComPtr<super::super::foundation::IAsyncOperation<HidFeatureReport>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetFeatureReportByIdAsync)(self as *const _ as *mut _, reportId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_output_report(&self) -> Result<ComPtr<HidOutputReport>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateOutputReport)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_output_report_by_id(&self, reportId: u16) -> Result<ComPtr<HidOutputReport>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateOutputReportById)(self as *const _ as *mut _, reportId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_feature_report(&self) -> Result<ComPtr<HidFeatureReport>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateFeatureReport)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_feature_report_by_id(&self, reportId: u16) -> Result<ComPtr<HidFeatureReport>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateFeatureReportById)(self as *const _ as *mut _, reportId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn send_output_report_async(&self, outputReport: &HidOutputReport) -> Result<ComPtr<super::super::foundation::IAsyncOperation<u32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).SendOutputReportAsync)(self as *const _ as *mut _, outputReport as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn send_feature_report_async(&self, featureReport: &HidFeatureReport) -> Result<ComPtr<super::super::foundation::IAsyncOperation<u32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).SendFeatureReportAsync)(self as *const _ as *mut _, featureReport as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_boolean_control_descriptions(&self, reportType: HidReportType, usagePage: u16, usageId: u16) -> Result<ComPtr<super::super::foundation::collections::IVectorView<HidBooleanControlDescription>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetBooleanControlDescriptions)(self as *const _ as *mut _, reportType, usagePage, usageId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_numeric_control_descriptions(&self, reportType: HidReportType, usagePage: u16, usageId: u16) -> Result<ComPtr<super::super::foundation::collections::IVectorView<HidNumericControlDescription>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetNumericControlDescriptions)(self as *const _ as *mut _, reportType, usagePage, usageId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_input_report_received(&self, reportHandler: &super::super::foundation::TypedEventHandler<HidDevice, HidInputReportReceivedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_InputReportReceived)(self as *const _ as *mut _, reportHandler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_input_report_received(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_InputReportReceived)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class HidInputReport: IHidInputReport}
RT_CLASS!{class HidFeatureReport: IHidFeatureReport}
RT_CLASS!{class HidOutputReport: IHidOutputReport}
RT_CLASS!{class HidBooleanControlDescription: IHidBooleanControlDescription}
RT_CLASS!{class HidNumericControlDescription: IHidNumericControlDescription}
RT_CLASS!{class HidInputReportReceivedEventArgs: IHidInputReportReceivedEventArgs}
DEFINE_IID!(IID_IHidBooleanControlDescription, 1637279043, 10712, 18986, 134, 131, 132, 158, 32, 123, 190, 49);
RT_INTERFACE!{interface IHidBooleanControlDescription(IHidBooleanControlDescriptionVtbl): IInspectable(IInspectableVtbl) [IID_IHidBooleanControlDescription] {
    fn get_Id(&self, out: *mut u32) -> HRESULT,
    fn get_ReportId(&self, out: *mut u16) -> HRESULT,
    fn get_ReportType(&self, out: *mut HidReportType) -> HRESULT,
    fn get_UsagePage(&self, out: *mut u16) -> HRESULT,
    fn get_UsageId(&self, out: *mut u16) -> HRESULT,
    fn get_ParentCollections(&self, out: *mut *mut super::super::foundation::collections::IVectorView<HidCollection>) -> HRESULT
}}
impl IHidBooleanControlDescription {
    #[inline] pub unsafe fn get_id(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_type(&self) -> Result<HidReportType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_usage_page(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsagePage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_usage_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsageId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_parent_collections(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<HidCollection>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ParentCollections)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class HidCollection: IHidCollection}
DEFINE_IID!(IID_IHidBooleanControlDescription2, 3371094762, 35447, 19510, 170, 0, 95, 240, 68, 157, 62, 115);
RT_INTERFACE!{interface IHidBooleanControlDescription2(IHidBooleanControlDescription2Vtbl): IInspectable(IInspectableVtbl) [IID_IHidBooleanControlDescription2] {
    fn get_IsAbsolute(&self, out: *mut bool) -> HRESULT
}}
impl IHidBooleanControlDescription2 {
    #[inline] pub unsafe fn get_is_absolute(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsAbsolute)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IHidNumericControlDescription, 1670209158, 7575, 19573, 146, 127, 95, 245, 139, 160, 94, 50);
RT_INTERFACE!{interface IHidNumericControlDescription(IHidNumericControlDescriptionVtbl): IInspectable(IInspectableVtbl) [IID_IHidNumericControlDescription] {
    fn get_Id(&self, out: *mut u32) -> HRESULT,
    fn get_ReportId(&self, out: *mut u16) -> HRESULT,
    fn get_ReportType(&self, out: *mut HidReportType) -> HRESULT,
    fn get_ReportSize(&self, out: *mut u32) -> HRESULT,
    fn get_ReportCount(&self, out: *mut u32) -> HRESULT,
    fn get_UsagePage(&self, out: *mut u16) -> HRESULT,
    fn get_UsageId(&self, out: *mut u16) -> HRESULT,
    fn get_LogicalMinimum(&self, out: *mut i32) -> HRESULT,
    fn get_LogicalMaximum(&self, out: *mut i32) -> HRESULT,
    fn get_PhysicalMinimum(&self, out: *mut i32) -> HRESULT,
    fn get_PhysicalMaximum(&self, out: *mut i32) -> HRESULT,
    fn get_UnitExponent(&self, out: *mut u32) -> HRESULT,
    fn get_Unit(&self, out: *mut u32) -> HRESULT,
    fn get_IsAbsolute(&self, out: *mut bool) -> HRESULT,
    fn get_HasNull(&self, out: *mut bool) -> HRESULT,
    fn get_ParentCollections(&self, out: *mut *mut super::super::foundation::collections::IVectorView<HidCollection>) -> HRESULT
}}
impl IHidNumericControlDescription {
    #[inline] pub unsafe fn get_id(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_type(&self) -> Result<HidReportType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_size(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportSize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_count(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportCount)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_usage_page(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsagePage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_usage_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsageId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_logical_minimum(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LogicalMinimum)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_logical_maximum(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LogicalMaximum)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_physical_minimum(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PhysicalMinimum)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_physical_maximum(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PhysicalMaximum)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_unit_exponent(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UnitExponent)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_unit(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Unit)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_absolute(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsAbsolute)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_has_null(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HasNull)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_parent_collections(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<HidCollection>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ParentCollections)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IHidCollection, 1904866723, 13041, 18147, 190, 253, 68, 210, 102, 59, 126, 106);
RT_INTERFACE!{interface IHidCollection(IHidCollectionVtbl): IInspectable(IInspectableVtbl) [IID_IHidCollection] {
    fn get_Id(&self, out: *mut u32) -> HRESULT,
    fn get_Type(&self, out: *mut HidCollectionType) -> HRESULT,
    fn get_UsagePage(&self, out: *mut u32) -> HRESULT,
    fn get_UsageId(&self, out: *mut u32) -> HRESULT
}}
impl IHidCollection {
    #[inline] pub unsafe fn get_id(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_type(&self) -> Result<HidCollectionType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Type)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_usage_page(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsagePage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_usage_id(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsageId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IHidInputReport, 3277655632, 63463, 20109, 178, 62, 202, 187, 229, 107, 144, 233);
RT_INTERFACE!{interface IHidInputReport(IHidInputReportVtbl): IInspectable(IInspectableVtbl) [IID_IHidInputReport] {
    fn get_Id(&self, out: *mut u16) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_Data(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT,
    fn get_ActivatedBooleanControls(&self, out: *mut *mut super::super::foundation::collections::IVectorView<HidBooleanControl>) -> HRESULT,
    fn get_TransitionedBooleanControls(&self, out: *mut *mut super::super::foundation::collections::IVectorView<HidBooleanControl>) -> HRESULT,
    fn GetBooleanControl(&self, usagePage: u16, usageId: u16, out: *mut *mut HidBooleanControl) -> HRESULT,
    fn GetBooleanControlByDescription(&self, controlDescription: *mut HidBooleanControlDescription, out: *mut *mut HidBooleanControl) -> HRESULT,
    fn GetNumericControl(&self, usagePage: u16, usageId: u16, out: *mut *mut HidNumericControl) -> HRESULT,
    fn GetNumericControlByDescription(&self, controlDescription: *mut HidNumericControlDescription, out: *mut *mut HidNumericControl) -> HRESULT
}}
impl IHidInputReport {
    #[inline] pub unsafe fn get_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_data(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Data)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_activated_boolean_controls(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<HidBooleanControl>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ActivatedBooleanControls)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_transitioned_boolean_controls(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<HidBooleanControl>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_TransitionedBooleanControls)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_boolean_control(&self, usagePage: u16, usageId: u16) -> Result<ComPtr<HidBooleanControl>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetBooleanControl)(self as *const _ as *mut _, usagePage, usageId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_boolean_control_by_description(&self, controlDescription: &HidBooleanControlDescription) -> Result<ComPtr<HidBooleanControl>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetBooleanControlByDescription)(self as *const _ as *mut _, controlDescription as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_numeric_control(&self, usagePage: u16, usageId: u16) -> Result<ComPtr<HidNumericControl>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetNumericControl)(self as *const _ as *mut _, usagePage, usageId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_numeric_control_by_description(&self, controlDescription: &HidNumericControlDescription) -> Result<ComPtr<HidNumericControl>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetNumericControlByDescription)(self as *const _ as *mut _, controlDescription as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class HidBooleanControl: IHidBooleanControl}
RT_CLASS!{class HidNumericControl: IHidNumericControl}
DEFINE_IID!(IID_IHidOutputReport, 1657480516, 51350, 17507, 147, 193, 223, 157, 176, 83, 196, 80);
RT_INTERFACE!{interface IHidOutputReport(IHidOutputReportVtbl): IInspectable(IInspectableVtbl) [IID_IHidOutputReport] {
    fn get_Id(&self, out: *mut u16) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_Data(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy2(&self) -> (),
    #[cfg(feature="windows-storage")] fn put_Data(&self, value: *mut super::super::storage::streams::IBuffer) -> HRESULT,
    fn GetBooleanControl(&self, usagePage: u16, usageId: u16, out: *mut *mut HidBooleanControl) -> HRESULT,
    fn GetBooleanControlByDescription(&self, controlDescription: *mut HidBooleanControlDescription, out: *mut *mut HidBooleanControl) -> HRESULT,
    fn GetNumericControl(&self, usagePage: u16, usageId: u16, out: *mut *mut HidNumericControl) -> HRESULT,
    fn GetNumericControlByDescription(&self, controlDescription: *mut HidNumericControlDescription, out: *mut *mut HidNumericControl) -> HRESULT
}}
impl IHidOutputReport {
    #[inline] pub unsafe fn get_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_data(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Data)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_data(&self, value: &super::super::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Data)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_boolean_control(&self, usagePage: u16, usageId: u16) -> Result<ComPtr<HidBooleanControl>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetBooleanControl)(self as *const _ as *mut _, usagePage, usageId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_boolean_control_by_description(&self, controlDescription: &HidBooleanControlDescription) -> Result<ComPtr<HidBooleanControl>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetBooleanControlByDescription)(self as *const _ as *mut _, controlDescription as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_numeric_control(&self, usagePage: u16, usageId: u16) -> Result<ComPtr<HidNumericControl>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetNumericControl)(self as *const _ as *mut _, usagePage, usageId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_numeric_control_by_description(&self, controlDescription: &HidNumericControlDescription) -> Result<ComPtr<HidNumericControl>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetNumericControlByDescription)(self as *const _ as *mut _, controlDescription as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IHidFeatureReport, 2216532857, 23269, 18147, 130, 239, 31, 236, 92, 137, 66, 244);
RT_INTERFACE!{interface IHidFeatureReport(IHidFeatureReportVtbl): IInspectable(IInspectableVtbl) [IID_IHidFeatureReport] {
    fn get_Id(&self, out: *mut u16) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_Data(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy2(&self) -> (),
    #[cfg(feature="windows-storage")] fn put_Data(&self, value: *mut super::super::storage::streams::IBuffer) -> HRESULT,
    fn GetBooleanControl(&self, usagePage: u16, usageId: u16, out: *mut *mut HidBooleanControl) -> HRESULT,
    fn GetBooleanControlByDescription(&self, controlDescription: *mut HidBooleanControlDescription, out: *mut *mut HidBooleanControl) -> HRESULT,
    fn GetNumericControl(&self, usagePage: u16, usageId: u16, out: *mut *mut HidNumericControl) -> HRESULT,
    fn GetNumericControlByDescription(&self, controlDescription: *mut HidNumericControlDescription, out: *mut *mut HidNumericControl) -> HRESULT
}}
impl IHidFeatureReport {
    #[inline] pub unsafe fn get_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_data(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Data)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_data(&self, value: &super::super::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Data)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_boolean_control(&self, usagePage: u16, usageId: u16) -> Result<ComPtr<HidBooleanControl>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetBooleanControl)(self as *const _ as *mut _, usagePage, usageId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_boolean_control_by_description(&self, controlDescription: &HidBooleanControlDescription) -> Result<ComPtr<HidBooleanControl>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetBooleanControlByDescription)(self as *const _ as *mut _, controlDescription as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_numeric_control(&self, usagePage: u16, usageId: u16) -> Result<ComPtr<HidNumericControl>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetNumericControl)(self as *const _ as *mut _, usagePage, usageId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_numeric_control_by_description(&self, controlDescription: &HidNumericControlDescription) -> Result<ComPtr<HidNumericControl>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetNumericControlByDescription)(self as *const _ as *mut _, controlDescription as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IHidInputReportReceivedEventArgs, 1884931531, 22962, 19906, 152, 92, 10, 220, 97, 54, 250, 45);
RT_INTERFACE!{interface IHidInputReportReceivedEventArgs(IHidInputReportReceivedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IHidInputReportReceivedEventArgs] {
    fn get_Report(&self, out: *mut *mut HidInputReport) -> HRESULT
}}
impl IHidInputReportReceivedEventArgs {
    #[inline] pub unsafe fn get_report(&self) -> Result<ComPtr<HidInputReport>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Report)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IHidBooleanControl, 1380840586, 13973, 16524, 187, 162, 226, 235, 90, 191, 188, 32);
RT_INTERFACE!{interface IHidBooleanControl(IHidBooleanControlVtbl): IInspectable(IInspectableVtbl) [IID_IHidBooleanControl] {
    fn get_Id(&self, out: *mut u32) -> HRESULT,
    fn get_UsagePage(&self, out: *mut u16) -> HRESULT,
    fn get_UsageId(&self, out: *mut u16) -> HRESULT,
    fn get_IsActive(&self, out: *mut bool) -> HRESULT,
    fn put_IsActive(&self, value: bool) -> HRESULT,
    fn get_ControlDescription(&self, out: *mut *mut HidBooleanControlDescription) -> HRESULT
}}
impl IHidBooleanControl {
    #[inline] pub unsafe fn get_id(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_usage_page(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsagePage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_usage_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsageId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_active(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsActive)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_active(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsActive)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_control_description(&self) -> Result<ComPtr<HidBooleanControlDescription>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ControlDescription)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IHidNumericControl, 3817476773, 13735, 19317, 137, 200, 251, 31, 40, 177, 8, 35);
RT_INTERFACE!{interface IHidNumericControl(IHidNumericControlVtbl): IInspectable(IInspectableVtbl) [IID_IHidNumericControl] {
    fn get_Id(&self, out: *mut u32) -> HRESULT,
    fn get_IsGrouped(&self, out: *mut bool) -> HRESULT,
    fn get_UsagePage(&self, out: *mut u16) -> HRESULT,
    fn get_UsageId(&self, out: *mut u16) -> HRESULT,
    fn get_Value(&self, out: *mut i64) -> HRESULT,
    fn put_Value(&self, value: i64) -> HRESULT,
    fn get_ScaledValue(&self, out: *mut i64) -> HRESULT,
    fn put_ScaledValue(&self, value: i64) -> HRESULT,
    fn get_ControlDescription(&self, out: *mut *mut HidNumericControlDescription) -> HRESULT
}}
impl IHidNumericControl {
    #[inline] pub unsafe fn get_id(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_grouped(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsGrouped)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_usage_page(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsagePage)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_usage_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsageId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_value(&self) -> Result<i64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Value)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_value(&self, value: i64) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Value)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_scaled_value(&self) -> Result<i64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ScaledValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_scaled_value(&self, value: i64) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ScaledValue)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_control_description(&self) -> Result<ComPtr<HidNumericControlDescription>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ControlDescription)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
} // Windows.Devices.HumanInterfaceDevice
pub mod input { // Windows.Devices.Input
use ::prelude::*;
RT_ENUM! { enum PointerDeviceType: i32 {
    Touch (PointerDeviceType_Touch) = 0, Pen (PointerDeviceType_Pen) = 1, Mouse (PointerDeviceType_Mouse) = 2,
}}
RT_STRUCT! { struct PointerDeviceUsage {
    UsagePage: u32, Usage: u32, MinLogical: i32, MaxLogical: i32, MinPhysical: i32, MaxPhysical: i32, Unit: u32, PhysicalMultiplier: f32,
}}
RT_STRUCT! { struct MouseDelta {
    X: i32, Y: i32,
}}
DEFINE_IID!(IID_IMouseCapabilities, 3164987427, 32217, 19307, 154, 146, 85, 212, 60, 179, 143, 115);
RT_INTERFACE!{interface IMouseCapabilities(IMouseCapabilitiesVtbl): IInspectable(IInspectableVtbl) [IID_IMouseCapabilities] {
    fn get_MousePresent(&self, out: *mut i32) -> HRESULT,
    fn get_VerticalWheelPresent(&self, out: *mut i32) -> HRESULT,
    fn get_HorizontalWheelPresent(&self, out: *mut i32) -> HRESULT,
    fn get_SwapButtons(&self, out: *mut i32) -> HRESULT,
    fn get_NumberOfButtons(&self, out: *mut u32) -> HRESULT
}}
impl IMouseCapabilities {
    #[inline] pub unsafe fn get_mouse_present(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MousePresent)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_vertical_wheel_present(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_VerticalWheelPresent)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_horizontal_wheel_present(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HorizontalWheelPresent)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_swap_buttons(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SwapButtons)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_number_of_buttons(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_NumberOfButtons)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IKeyboardCapabilities, 977247062, 26520, 19388, 131, 62, 15, 52, 177, 124, 101, 255);
RT_INTERFACE!{interface IKeyboardCapabilities(IKeyboardCapabilitiesVtbl): IInspectable(IInspectableVtbl) [IID_IKeyboardCapabilities] {
    fn get_KeyboardPresent(&self, out: *mut i32) -> HRESULT
}}
impl IKeyboardCapabilities {
    #[inline] pub unsafe fn get_keyboard_present(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_KeyboardPresent)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ITouchCapabilities, 551376377, 5105, 18120, 146, 133, 44, 5, 250, 62, 218, 111);
RT_INTERFACE!{interface ITouchCapabilities(ITouchCapabilitiesVtbl): IInspectable(IInspectableVtbl) [IID_ITouchCapabilities] {
    fn get_TouchPresent(&self, out: *mut i32) -> HRESULT,
    fn get_Contacts(&self, out: *mut u32) -> HRESULT
}}
impl ITouchCapabilities {
    #[inline] pub unsafe fn get_touch_present(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TouchPresent)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_contacts(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Contacts)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPointerDeviceStatics, 3635976865, 53702, 16750, 189, 141, 87, 144, 145, 77, 197, 99);
RT_INTERFACE!{static interface IPointerDeviceStatics(IPointerDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IPointerDeviceStatics] {
    fn GetPointerDevice(&self, pointerId: u32, out: *mut *mut PointerDevice) -> HRESULT,
    fn GetPointerDevices(&self, out: *mut *mut super::super::foundation::collections::IVectorView<PointerDevice>) -> HRESULT
}}
impl IPointerDeviceStatics {
    #[inline] pub unsafe fn get_pointer_device(&self, pointerId: u32) -> Result<ComPtr<PointerDevice>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetPointerDevice)(self as *const _ as *mut _, pointerId, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pointer_devices(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<PointerDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetPointerDevices)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PointerDevice: IPointerDevice}
impl RtActivatable<IPointerDeviceStatics> for PointerDevice {}
impl PointerDevice {
    #[inline] pub fn get_pointer_device(pointerId: u32) -> Result<ComPtr<PointerDevice>> { unsafe {
        <Self as RtActivatable<IPointerDeviceStatics>>::get_activation_factory().get_pointer_device(pointerId)
    }}
    #[inline] pub fn get_pointer_devices() -> Result<ComPtr<super::super::foundation::collections::IVectorView<PointerDevice>>> { unsafe {
        <Self as RtActivatable<IPointerDeviceStatics>>::get_activation_factory().get_pointer_devices()
    }}
}
DEFINE_CLSID!(PointerDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,73,110,112,117,116,46,80,111,105,110,116,101,114,68,101,118,105,99,101,0]) [CLSID_PointerDevice]);
DEFINE_IID!(IID_IPointerDevice, 2479471356, 60363, 18046, 130, 198, 39, 111, 234, 227, 107, 90);
RT_INTERFACE!{interface IPointerDevice(IPointerDeviceVtbl): IInspectable(IInspectableVtbl) [IID_IPointerDevice] {
    fn get_PointerDeviceType(&self, out: *mut PointerDeviceType) -> HRESULT,
    fn get_IsIntegrated(&self, out: *mut bool) -> HRESULT,
    fn get_MaxContacts(&self, out: *mut u32) -> HRESULT,
    fn get_PhysicalDeviceRect(&self, out: *mut super::super::foundation::Rect) -> HRESULT,
    fn get_ScreenRect(&self, out: *mut super::super::foundation::Rect) -> HRESULT,
    fn get_SupportedUsages(&self, out: *mut *mut super::super::foundation::collections::IVectorView<PointerDeviceUsage>) -> HRESULT
}}
impl IPointerDevice {
    #[inline] pub unsafe fn get_pointer_device_type(&self) -> Result<PointerDeviceType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PointerDeviceType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_integrated(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsIntegrated)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_contacts(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxContacts)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_physical_device_rect(&self) -> Result<super::super::foundation::Rect> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PhysicalDeviceRect)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_screen_rect(&self) -> Result<super::super::foundation::Rect> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ScreenRect)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_usages(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<PointerDeviceUsage>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedUsages)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPointerDevice2, 4171682464, 50308, 18591, 174, 62, 48, 210, 238, 31, 253, 62);
RT_INTERFACE!{interface IPointerDevice2(IPointerDevice2Vtbl): IInspectable(IInspectableVtbl) [IID_IPointerDevice2] {
    fn get_MaxPointersWithZDistance(&self, out: *mut u32) -> HRESULT
}}
impl IPointerDevice2 {
    #[inline] pub unsafe fn get_max_pointers_with_zdistance(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxPointersWithZDistance)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMouseEventArgs, 4129663581, 9044, 19655, 146, 48, 150, 148, 28, 150, 159, 222);
RT_INTERFACE!{interface IMouseEventArgs(IMouseEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IMouseEventArgs] {
    fn get_MouseDelta(&self, out: *mut MouseDelta) -> HRESULT
}}
impl IMouseEventArgs {
    #[inline] pub unsafe fn get_mouse_delta(&self) -> Result<MouseDelta> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MouseDelta)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMouseDevice, 2297295960, 62152, 18932, 190, 31, 194, 86, 179, 136, 188, 17);
RT_INTERFACE!{interface IMouseDevice(IMouseDeviceVtbl): IInspectable(IInspectableVtbl) [IID_IMouseDevice] {
    fn add_MouseMoved(&self, handler: *mut super::super::foundation::TypedEventHandler<MouseDevice, MouseEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_MouseMoved(&self, cookie: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IMouseDevice {
    #[inline] pub unsafe fn add_mouse_moved(&self, handler: &super::super::foundation::TypedEventHandler<MouseDevice, MouseEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_MouseMoved)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_mouse_moved(&self, cookie: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_MouseMoved)(self as *const _ as *mut _, cookie);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class MouseDevice: IMouseDevice}
impl RtActivatable<IMouseDeviceStatics> for MouseDevice {}
impl MouseDevice {
    #[inline] pub fn get_for_current_view() -> Result<ComPtr<MouseDevice>> { unsafe {
        <Self as RtActivatable<IMouseDeviceStatics>>::get_activation_factory().get_for_current_view()
    }}
}
DEFINE_CLSID!(MouseDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,73,110,112,117,116,46,77,111,117,115,101,68,101,118,105,99,101,0]) [CLSID_MouseDevice]);
RT_CLASS!{class MouseEventArgs: IMouseEventArgs}
DEFINE_IID!(IID_IMouseDeviceStatics, 1212846149, 28016, 18907, 142, 104, 70, 255, 189, 23, 211, 141);
RT_INTERFACE!{static interface IMouseDeviceStatics(IMouseDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IMouseDeviceStatics] {
    fn GetForCurrentView(&self, out: *mut *mut MouseDevice) -> HRESULT
}}
impl IMouseDeviceStatics {
    #[inline] pub unsafe fn get_for_current_view(&self) -> Result<ComPtr<MouseDevice>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetForCurrentView)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MouseCapabilities: IMouseCapabilities}
impl RtActivatable<IActivationFactory> for MouseCapabilities {}
DEFINE_CLSID!(MouseCapabilities(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,73,110,112,117,116,46,77,111,117,115,101,67,97,112,97,98,105,108,105,116,105,101,115,0]) [CLSID_MouseCapabilities]);
RT_CLASS!{class KeyboardCapabilities: IKeyboardCapabilities}
impl RtActivatable<IActivationFactory> for KeyboardCapabilities {}
DEFINE_CLSID!(KeyboardCapabilities(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,73,110,112,117,116,46,75,101,121,98,111,97,114,100,67,97,112,97,98,105,108,105,116,105,101,115,0]) [CLSID_KeyboardCapabilities]);
RT_CLASS!{class TouchCapabilities: ITouchCapabilities}
impl RtActivatable<IActivationFactory> for TouchCapabilities {}
DEFINE_CLSID!(TouchCapabilities(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,73,110,112,117,116,46,84,111,117,99,104,67,97,112,97,98,105,108,105,116,105,101,115,0]) [CLSID_TouchCapabilities]);
} // Windows.Devices.Input
pub mod lights { // Windows.Devices.Lights
use ::prelude::*;
DEFINE_IID!(IID_ILampStatics, 2820817260, 34949, 16414, 184, 33, 142, 139, 56, 168, 232, 236);
RT_INTERFACE!{static interface ILampStatics(ILampStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ILampStatics] {
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<Lamp>) -> HRESULT,
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<Lamp>) -> HRESULT
}}
impl ILampStatics {
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Lamp>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Lamp>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Lamp: ILamp}
impl RtActivatable<ILampStatics> for Lamp {}
impl Lamp {
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<ILampStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Lamp>>> { unsafe {
        <Self as RtActivatable<ILampStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<Lamp>>> { unsafe {
        <Self as RtActivatable<ILampStatics>>::get_activation_factory().get_default_async()
    }}
}
DEFINE_CLSID!(Lamp(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,76,105,103,104,116,115,46,76,97,109,112,0]) [CLSID_Lamp]);
DEFINE_IID!(IID_ILamp, 75324314, 59973, 19243, 177, 162, 20, 223, 240, 11, 222, 123);
RT_INTERFACE!{interface ILamp(ILampVtbl): IInspectable(IInspectableVtbl) [IID_ILamp] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_IsEnabled(&self, out: *mut bool) -> HRESULT,
    fn put_IsEnabled(&self, value: bool) -> HRESULT,
    fn get_BrightnessLevel(&self, out: *mut f32) -> HRESULT,
    fn put_BrightnessLevel(&self, value: f32) -> HRESULT,
    fn get_IsColorSettable(&self, out: *mut bool) -> HRESULT,
    #[cfg(not(feature="windows-ui"))] fn __Dummy6(&self) -> (),
    #[cfg(feature="windows-ui")] fn get_Color(&self, out: *mut super::super::ui::Color) -> HRESULT,
    #[cfg(not(feature="windows-ui"))] fn __Dummy7(&self) -> (),
    #[cfg(feature="windows-ui")] fn put_Color(&self, value: super::super::ui::Color) -> HRESULT,
    fn add_AvailabilityChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<Lamp, LampAvailabilityChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_AvailabilityChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl ILamp {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_enabled(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsEnabled)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_brightness_level(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BrightnessLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_brightness_level(&self, value: f32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_BrightnessLevel)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_color_settable(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsColorSettable)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn get_color(&self) -> Result<super::super::ui::Color> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Color)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-ui")] #[inline] pub unsafe fn set_color(&self, value: super::super::ui::Color) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Color)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_availability_changed(&self, handler: &super::super::foundation::TypedEventHandler<Lamp, LampAvailabilityChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_AvailabilityChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_availability_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_AvailabilityChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class LampAvailabilityChangedEventArgs: ILampAvailabilityChangedEventArgs}
DEFINE_IID!(IID_ILampAvailabilityChangedEventArgs, 1332624877, 1954, 18845, 146, 96, 103, 227, 4, 83, 43, 164);
RT_INTERFACE!{interface ILampAvailabilityChangedEventArgs(ILampAvailabilityChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_ILampAvailabilityChangedEventArgs] {
    fn get_IsAvailable(&self, out: *mut bool) -> HRESULT
}}
impl ILampAvailabilityChangedEventArgs {
    #[inline] pub unsafe fn get_is_available(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsAvailable)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
} // Windows.Devices.Lights
pub mod midi { // Windows.Devices.Midi
use ::prelude::*;
RT_ENUM! { enum MidiMessageType: i32 {
    None (MidiMessageType_None) = 0, NoteOff (MidiMessageType_NoteOff) = 128, NoteOn (MidiMessageType_NoteOn) = 144, PolyphonicKeyPressure (MidiMessageType_PolyphonicKeyPressure) = 160, ControlChange (MidiMessageType_ControlChange) = 176, ProgramChange (MidiMessageType_ProgramChange) = 192, ChannelPressure (MidiMessageType_ChannelPressure) = 208, PitchBendChange (MidiMessageType_PitchBendChange) = 224, SystemExclusive (MidiMessageType_SystemExclusive) = 240, MidiTimeCode (MidiMessageType_MidiTimeCode) = 241, SongPositionPointer (MidiMessageType_SongPositionPointer) = 242, SongSelect (MidiMessageType_SongSelect) = 243, TuneRequest (MidiMessageType_TuneRequest) = 246, EndSystemExclusive (MidiMessageType_EndSystemExclusive) = 247, TimingClock (MidiMessageType_TimingClock) = 248, Start (MidiMessageType_Start) = 250, Continue (MidiMessageType_Continue) = 251, Stop (MidiMessageType_Stop) = 252, ActiveSensing (MidiMessageType_ActiveSensing) = 254, SystemReset (MidiMessageType_SystemReset) = 255,
}}
DEFINE_IID!(IID_IMidiMessage, 2037807429, 4244, 17027, 155, 224, 40, 159, 192, 238, 131, 52);
RT_INTERFACE!{interface IMidiMessage(IMidiMessageVtbl): IInspectable(IInspectableVtbl) [IID_IMidiMessage] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_RawData(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT,
    fn get_Type(&self, out: *mut MidiMessageType) -> HRESULT
}}
impl IMidiMessage {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_raw_data(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_RawData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_type(&self) -> Result<MidiMessageType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Type)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMidiNoteOffMessage, 385714932, 6542, 19855, 166, 84, 211, 5, 162, 147, 84, 143);
RT_INTERFACE!{interface IMidiNoteOffMessage(IMidiNoteOffMessageVtbl): IInspectable(IInspectableVtbl) [IID_IMidiNoteOffMessage] {
    fn get_Channel(&self, out: *mut u8) -> HRESULT,
    fn get_Note(&self, out: *mut u8) -> HRESULT,
    fn get_Velocity(&self, out: *mut u8) -> HRESULT
}}
impl IMidiNoteOffMessage {
    #[inline] pub unsafe fn get_channel(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Channel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_note(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Note)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_velocity(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Velocity)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMidiNoteOnMessage, 3760343797, 24961, 18141, 175, 162, 65, 0, 4, 192, 87, 170);
RT_INTERFACE!{interface IMidiNoteOnMessage(IMidiNoteOnMessageVtbl): IInspectable(IInspectableVtbl) [IID_IMidiNoteOnMessage] {
    fn get_Channel(&self, out: *mut u8) -> HRESULT,
    fn get_Note(&self, out: *mut u8) -> HRESULT,
    fn get_Velocity(&self, out: *mut u8) -> HRESULT
}}
impl IMidiNoteOnMessage {
    #[inline] pub unsafe fn get_channel(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Channel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_note(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Note)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_velocity(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Velocity)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMidiPolyphonicKeyPressureMessage, 527644670, 44264, 18592, 134, 142, 124, 219, 242, 15, 4, 214);
RT_INTERFACE!{interface IMidiPolyphonicKeyPressureMessage(IMidiPolyphonicKeyPressureMessageVtbl): IInspectable(IInspectableVtbl) [IID_IMidiPolyphonicKeyPressureMessage] {
    fn get_Channel(&self, out: *mut u8) -> HRESULT,
    fn get_Note(&self, out: *mut u8) -> HRESULT,
    fn get_Pressure(&self, out: *mut u8) -> HRESULT
}}
impl IMidiPolyphonicKeyPressureMessage {
    #[inline] pub unsafe fn get_channel(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Channel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_note(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Note)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pressure(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Pressure)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMidiControlChangeMessage, 3085000579, 30733, 16479, 183, 129, 62, 21, 152, 201, 127, 64);
RT_INTERFACE!{interface IMidiControlChangeMessage(IMidiControlChangeMessageVtbl): IInspectable(IInspectableVtbl) [IID_IMidiControlChangeMessage] {
    fn get_Channel(&self, out: *mut u8) -> HRESULT,
    fn get_Controller(&self, out: *mut u8) -> HRESULT,
    fn get_ControlValue(&self, out: *mut u8) -> HRESULT
}}
impl IMidiControlChangeMessage {
    #[inline] pub unsafe fn get_channel(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Channel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_controller(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Controller)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_control_value(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ControlValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMidiProgramChangeMessage, 2629516408, 31294, 17191, 170, 152, 32, 184, 228, 72, 90, 248);
RT_INTERFACE!{interface IMidiProgramChangeMessage(IMidiProgramChangeMessageVtbl): IInspectable(IInspectableVtbl) [IID_IMidiProgramChangeMessage] {
    fn get_Channel(&self, out: *mut u8) -> HRESULT,
    fn get_Program(&self, out: *mut u8) -> HRESULT
}}
impl IMidiProgramChangeMessage {
    #[inline] pub unsafe fn get_channel(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Channel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_program(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Program)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMidiChannelPressureMessage, 3189745760, 25268, 19794, 163, 126, 146, 229, 77, 53, 185, 9);
RT_INTERFACE!{interface IMidiChannelPressureMessage(IMidiChannelPressureMessageVtbl): IInspectable(IInspectableVtbl) [IID_IMidiChannelPressureMessage] {
    fn get_Channel(&self, out: *mut u8) -> HRESULT,
    fn get_Pressure(&self, out: *mut u8) -> HRESULT
}}
impl IMidiChannelPressureMessage {
    #[inline] pub unsafe fn get_channel(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Channel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pressure(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Pressure)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMidiPitchBendChangeMessage, 702500017, 11935, 20399, 140, 43, 156, 184, 42, 144, 121, 202);
RT_INTERFACE!{interface IMidiPitchBendChangeMessage(IMidiPitchBendChangeMessageVtbl): IInspectable(IInspectableVtbl) [IID_IMidiPitchBendChangeMessage] {
    fn get_Channel(&self, out: *mut u8) -> HRESULT,
    fn get_Bend(&self, out: *mut u16) -> HRESULT
}}
impl IMidiPitchBendChangeMessage {
    #[inline] pub unsafe fn get_channel(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Channel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bend(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Bend)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMidiTimeCodeMessage, 200738941, 64099, 18972, 141, 235, 192, 232, 119, 150, 166, 215);
RT_INTERFACE!{interface IMidiTimeCodeMessage(IMidiTimeCodeMessageVtbl): IInspectable(IInspectableVtbl) [IID_IMidiTimeCodeMessage] {
    fn get_FrameType(&self, out: *mut u8) -> HRESULT,
    fn get_Values(&self, out: *mut u8) -> HRESULT
}}
impl IMidiTimeCodeMessage {
    #[inline] pub unsafe fn get_frame_type(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_FrameType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_values(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Values)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMidiSongPositionPointerMessage, 1285885014, 60510, 19172, 161, 21, 136, 220, 87, 204, 43, 121);
RT_INTERFACE!{interface IMidiSongPositionPointerMessage(IMidiSongPositionPointerMessageVtbl): IInspectable(IInspectableVtbl) [IID_IMidiSongPositionPointerMessage] {
    fn get_Beats(&self, out: *mut u16) -> HRESULT
}}
impl IMidiSongPositionPointerMessage {
    #[inline] pub unsafe fn get_beats(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Beats)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMidiSongSelectMessage, 1240527487, 28035, 18241, 165, 191, 70, 41, 246, 190, 151, 79);
RT_INTERFACE!{interface IMidiSongSelectMessage(IMidiSongSelectMessageVtbl): IInspectable(IInspectableVtbl) [IID_IMidiSongSelectMessage] {
    fn get_Song(&self, out: *mut u8) -> HRESULT
}}
impl IMidiSongSelectMessage {
    #[inline] pub unsafe fn get_song(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Song)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMidiNoteOffMessageFactory, 2796699872, 42825, 16991, 138, 244, 164, 217, 121, 204, 21, 181);
RT_INTERFACE!{static interface IMidiNoteOffMessageFactory(IMidiNoteOffMessageFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IMidiNoteOffMessageFactory] {
    fn CreateMidiNoteOffMessage(&self, channel: u8, note: u8, velocity: u8, out: *mut *mut MidiNoteOffMessage) -> HRESULT
}}
impl IMidiNoteOffMessageFactory {
    #[inline] pub unsafe fn create_midi_note_off_message(&self, channel: u8, note: u8, velocity: u8) -> Result<ComPtr<MidiNoteOffMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateMidiNoteOffMessage)(self as *const _ as *mut _, channel, note, velocity, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MidiNoteOffMessage: IMidiNoteOffMessage}
impl RtActivatable<IMidiNoteOffMessageFactory> for MidiNoteOffMessage {}
impl MidiNoteOffMessage {
    #[inline] pub fn create_midi_note_off_message(channel: u8, note: u8, velocity: u8) -> Result<ComPtr<MidiNoteOffMessage>> { unsafe {
        <Self as RtActivatable<IMidiNoteOffMessageFactory>>::get_activation_factory().create_midi_note_off_message(channel, note, velocity)
    }}
}
DEFINE_CLSID!(MidiNoteOffMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,78,111,116,101,79,102,102,77,101,115,115,97,103,101,0]) [CLSID_MidiNoteOffMessage]);
DEFINE_IID!(IID_IMidiNoteOnMessageFactory, 2604826784, 22977, 16910, 181, 23, 21, 161, 10, 169, 96, 107);
RT_INTERFACE!{static interface IMidiNoteOnMessageFactory(IMidiNoteOnMessageFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IMidiNoteOnMessageFactory] {
    fn CreateMidiNoteOnMessage(&self, channel: u8, note: u8, velocity: u8, out: *mut *mut MidiNoteOnMessage) -> HRESULT
}}
impl IMidiNoteOnMessageFactory {
    #[inline] pub unsafe fn create_midi_note_on_message(&self, channel: u8, note: u8, velocity: u8) -> Result<ComPtr<MidiNoteOnMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateMidiNoteOnMessage)(self as *const _ as *mut _, channel, note, velocity, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MidiNoteOnMessage: IMidiNoteOnMessage}
impl RtActivatable<IMidiNoteOnMessageFactory> for MidiNoteOnMessage {}
impl MidiNoteOnMessage {
    #[inline] pub fn create_midi_note_on_message(channel: u8, note: u8, velocity: u8) -> Result<ComPtr<MidiNoteOnMessage>> { unsafe {
        <Self as RtActivatable<IMidiNoteOnMessageFactory>>::get_activation_factory().create_midi_note_on_message(channel, note, velocity)
    }}
}
DEFINE_CLSID!(MidiNoteOnMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,78,111,116,101,79,110,77,101,115,115,97,103,101,0]) [CLSID_MidiNoteOnMessage]);
DEFINE_IID!(IID_IMidiPolyphonicKeyPressureMessageFactory, 3918481470, 50355, 19922, 145, 124, 227, 73, 129, 90, 27, 59);
RT_INTERFACE!{static interface IMidiPolyphonicKeyPressureMessageFactory(IMidiPolyphonicKeyPressureMessageFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IMidiPolyphonicKeyPressureMessageFactory] {
    fn CreateMidiPolyphonicKeyPressureMessage(&self, channel: u8, note: u8, pressure: u8, out: *mut *mut MidiPolyphonicKeyPressureMessage) -> HRESULT
}}
impl IMidiPolyphonicKeyPressureMessageFactory {
    #[inline] pub unsafe fn create_midi_polyphonic_key_pressure_message(&self, channel: u8, note: u8, pressure: u8) -> Result<ComPtr<MidiPolyphonicKeyPressureMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateMidiPolyphonicKeyPressureMessage)(self as *const _ as *mut _, channel, note, pressure, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MidiPolyphonicKeyPressureMessage: IMidiPolyphonicKeyPressureMessage}
impl RtActivatable<IMidiPolyphonicKeyPressureMessageFactory> for MidiPolyphonicKeyPressureMessage {}
impl MidiPolyphonicKeyPressureMessage {
    #[inline] pub fn create_midi_polyphonic_key_pressure_message(channel: u8, note: u8, pressure: u8) -> Result<ComPtr<MidiPolyphonicKeyPressureMessage>> { unsafe {
        <Self as RtActivatable<IMidiPolyphonicKeyPressureMessageFactory>>::get_activation_factory().create_midi_polyphonic_key_pressure_message(channel, note, pressure)
    }}
}
DEFINE_CLSID!(MidiPolyphonicKeyPressureMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,80,111,108,121,112,104,111,110,105,99,75,101,121,80,114,101,115,115,117,114,101,77,101,115,115,97,103,101,0]) [CLSID_MidiPolyphonicKeyPressureMessage]);
DEFINE_IID!(IID_IMidiControlChangeMessageFactory, 716260129, 38252, 18093, 151, 82, 248, 127, 85, 5, 47, 227);
RT_INTERFACE!{static interface IMidiControlChangeMessageFactory(IMidiControlChangeMessageFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IMidiControlChangeMessageFactory] {
    fn CreateMidiControlChangeMessage(&self, channel: u8, controller: u8, controlValue: u8, out: *mut *mut MidiControlChangeMessage) -> HRESULT
}}
impl IMidiControlChangeMessageFactory {
    #[inline] pub unsafe fn create_midi_control_change_message(&self, channel: u8, controller: u8, controlValue: u8) -> Result<ComPtr<MidiControlChangeMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateMidiControlChangeMessage)(self as *const _ as *mut _, channel, controller, controlValue, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MidiControlChangeMessage: IMidiControlChangeMessage}
impl RtActivatable<IMidiControlChangeMessageFactory> for MidiControlChangeMessage {}
impl MidiControlChangeMessage {
    #[inline] pub fn create_midi_control_change_message(channel: u8, controller: u8, controlValue: u8) -> Result<ComPtr<MidiControlChangeMessage>> { unsafe {
        <Self as RtActivatable<IMidiControlChangeMessageFactory>>::get_activation_factory().create_midi_control_change_message(channel, controller, controlValue)
    }}
}
DEFINE_CLSID!(MidiControlChangeMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,67,111,110,116,114,111,108,67,104,97,110,103,101,77,101,115,115,97,103,101,0]) [CLSID_MidiControlChangeMessage]);
DEFINE_IID!(IID_IMidiProgramChangeMessageFactory, 3601875847, 21067, 16644, 156, 153, 101, 114, 191, 210, 226, 97);
RT_INTERFACE!{static interface IMidiProgramChangeMessageFactory(IMidiProgramChangeMessageFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IMidiProgramChangeMessageFactory] {
    fn CreateMidiProgramChangeMessage(&self, channel: u8, program: u8, out: *mut *mut MidiProgramChangeMessage) -> HRESULT
}}
impl IMidiProgramChangeMessageFactory {
    #[inline] pub unsafe fn create_midi_program_change_message(&self, channel: u8, program: u8) -> Result<ComPtr<MidiProgramChangeMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateMidiProgramChangeMessage)(self as *const _ as *mut _, channel, program, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MidiProgramChangeMessage: IMidiProgramChangeMessage}
impl RtActivatable<IMidiProgramChangeMessageFactory> for MidiProgramChangeMessage {}
impl MidiProgramChangeMessage {
    #[inline] pub fn create_midi_program_change_message(channel: u8, program: u8) -> Result<ComPtr<MidiProgramChangeMessage>> { unsafe {
        <Self as RtActivatable<IMidiProgramChangeMessageFactory>>::get_activation_factory().create_midi_program_change_message(channel, program)
    }}
}
DEFINE_CLSID!(MidiProgramChangeMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,80,114,111,103,114,97,109,67,104,97,110,103,101,77,101,115,115,97,103,101,0]) [CLSID_MidiProgramChangeMessage]);
DEFINE_IID!(IID_IMidiChannelPressureMessageFactory, 1645800751, 8836, 16682, 148, 207, 16, 251, 4, 132, 44, 108);
RT_INTERFACE!{static interface IMidiChannelPressureMessageFactory(IMidiChannelPressureMessageFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IMidiChannelPressureMessageFactory] {
    fn CreateMidiChannelPressureMessage(&self, channel: u8, pressure: u8, out: *mut *mut MidiChannelPressureMessage) -> HRESULT
}}
impl IMidiChannelPressureMessageFactory {
    #[inline] pub unsafe fn create_midi_channel_pressure_message(&self, channel: u8, pressure: u8) -> Result<ComPtr<MidiChannelPressureMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateMidiChannelPressureMessage)(self as *const _ as *mut _, channel, pressure, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MidiChannelPressureMessage: IMidiChannelPressureMessage}
impl RtActivatable<IMidiChannelPressureMessageFactory> for MidiChannelPressureMessage {}
impl MidiChannelPressureMessage {
    #[inline] pub fn create_midi_channel_pressure_message(channel: u8, pressure: u8) -> Result<ComPtr<MidiChannelPressureMessage>> { unsafe {
        <Self as RtActivatable<IMidiChannelPressureMessageFactory>>::get_activation_factory().create_midi_channel_pressure_message(channel, pressure)
    }}
}
DEFINE_CLSID!(MidiChannelPressureMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,67,104,97,110,110,101,108,80,114,101,115,115,117,114,101,77,101,115,115,97,103,101,0]) [CLSID_MidiChannelPressureMessage]);
DEFINE_IID!(IID_IMidiPitchBendChangeMessageFactory, 4126072661, 53192, 18726, 179, 14, 163, 98, 35, 147, 48, 108);
RT_INTERFACE!{static interface IMidiPitchBendChangeMessageFactory(IMidiPitchBendChangeMessageFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IMidiPitchBendChangeMessageFactory] {
    fn CreateMidiPitchBendChangeMessage(&self, channel: u8, bend: u16, out: *mut *mut MidiPitchBendChangeMessage) -> HRESULT
}}
impl IMidiPitchBendChangeMessageFactory {
    #[inline] pub unsafe fn create_midi_pitch_bend_change_message(&self, channel: u8, bend: u16) -> Result<ComPtr<MidiPitchBendChangeMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateMidiPitchBendChangeMessage)(self as *const _ as *mut _, channel, bend, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MidiPitchBendChangeMessage: IMidiPitchBendChangeMessage}
impl RtActivatable<IMidiPitchBendChangeMessageFactory> for MidiPitchBendChangeMessage {}
impl MidiPitchBendChangeMessage {
    #[inline] pub fn create_midi_pitch_bend_change_message(channel: u8, bend: u16) -> Result<ComPtr<MidiPitchBendChangeMessage>> { unsafe {
        <Self as RtActivatable<IMidiPitchBendChangeMessageFactory>>::get_activation_factory().create_midi_pitch_bend_change_message(channel, bend)
    }}
}
DEFINE_CLSID!(MidiPitchBendChangeMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,80,105,116,99,104,66,101,110,100,67,104,97,110,103,101,77,101,115,115,97,103,101,0]) [CLSID_MidiPitchBendChangeMessage]);
DEFINE_IID!(IID_IMidiSystemExclusiveMessageFactory, 138273314, 15220, 17184, 155, 66, 12, 168, 84, 95, 138, 36);
RT_INTERFACE!{static interface IMidiSystemExclusiveMessageFactory(IMidiSystemExclusiveMessageFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IMidiSystemExclusiveMessageFactory] {
    #[cfg(feature="windows-storage")] fn CreateMidiSystemExclusiveMessage(&self, rawData: *mut super::super::storage::streams::IBuffer, out: *mut *mut MidiSystemExclusiveMessage) -> HRESULT
}}
impl IMidiSystemExclusiveMessageFactory {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn create_midi_system_exclusive_message(&self, rawData: &super::super::storage::streams::IBuffer) -> Result<ComPtr<MidiSystemExclusiveMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateMidiSystemExclusiveMessage)(self as *const _ as *mut _, rawData as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MidiSystemExclusiveMessage: IMidiMessage}
impl RtActivatable<IMidiSystemExclusiveMessageFactory> for MidiSystemExclusiveMessage {}
impl MidiSystemExclusiveMessage {
    #[cfg(feature="windows-storage")] #[inline] pub fn create_midi_system_exclusive_message(rawData: &super::super::storage::streams::IBuffer) -> Result<ComPtr<MidiSystemExclusiveMessage>> { unsafe {
        <Self as RtActivatable<IMidiSystemExclusiveMessageFactory>>::get_activation_factory().create_midi_system_exclusive_message(rawData)
    }}
}
DEFINE_CLSID!(MidiSystemExclusiveMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,83,121,115,116,101,109,69,120,99,108,117,115,105,118,101,77,101,115,115,97,103,101,0]) [CLSID_MidiSystemExclusiveMessage]);
DEFINE_IID!(IID_IMidiTimeCodeMessageFactory, 3945830853, 30492, 16606, 185, 97, 23, 90, 116, 137, 168, 94);
RT_INTERFACE!{static interface IMidiTimeCodeMessageFactory(IMidiTimeCodeMessageFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IMidiTimeCodeMessageFactory] {
    fn CreateMidiTimeCodeMessage(&self, frameType: u8, values: u8, out: *mut *mut MidiTimeCodeMessage) -> HRESULT
}}
impl IMidiTimeCodeMessageFactory {
    #[inline] pub unsafe fn create_midi_time_code_message(&self, frameType: u8, values: u8) -> Result<ComPtr<MidiTimeCodeMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateMidiTimeCodeMessage)(self as *const _ as *mut _, frameType, values, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MidiTimeCodeMessage: IMidiTimeCodeMessage}
impl RtActivatable<IMidiTimeCodeMessageFactory> for MidiTimeCodeMessage {}
impl MidiTimeCodeMessage {
    #[inline] pub fn create_midi_time_code_message(frameType: u8, values: u8) -> Result<ComPtr<MidiTimeCodeMessage>> { unsafe {
        <Self as RtActivatable<IMidiTimeCodeMessageFactory>>::get_activation_factory().create_midi_time_code_message(frameType, values)
    }}
}
DEFINE_CLSID!(MidiTimeCodeMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,84,105,109,101,67,111,100,101,77,101,115,115,97,103,101,0]) [CLSID_MidiTimeCodeMessage]);
DEFINE_IID!(IID_IMidiSongPositionPointerMessageFactory, 2617305494, 61707, 20458, 179, 149, 245, 214, 207, 128, 246, 78);
RT_INTERFACE!{static interface IMidiSongPositionPointerMessageFactory(IMidiSongPositionPointerMessageFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IMidiSongPositionPointerMessageFactory] {
    fn CreateMidiSongPositionPointerMessage(&self, beats: u16, out: *mut *mut MidiSongPositionPointerMessage) -> HRESULT
}}
impl IMidiSongPositionPointerMessageFactory {
    #[inline] pub unsafe fn create_midi_song_position_pointer_message(&self, beats: u16) -> Result<ComPtr<MidiSongPositionPointerMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateMidiSongPositionPointerMessage)(self as *const _ as *mut _, beats, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MidiSongPositionPointerMessage: IMidiSongPositionPointerMessage}
impl RtActivatable<IMidiSongPositionPointerMessageFactory> for MidiSongPositionPointerMessage {}
impl MidiSongPositionPointerMessage {
    #[inline] pub fn create_midi_song_position_pointer_message(beats: u16) -> Result<ComPtr<MidiSongPositionPointerMessage>> { unsafe {
        <Self as RtActivatable<IMidiSongPositionPointerMessageFactory>>::get_activation_factory().create_midi_song_position_pointer_message(beats)
    }}
}
DEFINE_CLSID!(MidiSongPositionPointerMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,83,111,110,103,80,111,115,105,116,105,111,110,80,111,105,110,116,101,114,77,101,115,115,97,103,101,0]) [CLSID_MidiSongPositionPointerMessage]);
DEFINE_IID!(IID_IMidiSongSelectMessageFactory, 2223536356, 34632, 16681, 166, 108, 160, 84, 147, 247, 93, 170);
RT_INTERFACE!{static interface IMidiSongSelectMessageFactory(IMidiSongSelectMessageFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IMidiSongSelectMessageFactory] {
    fn CreateMidiSongSelectMessage(&self, song: u8, out: *mut *mut MidiSongSelectMessage) -> HRESULT
}}
impl IMidiSongSelectMessageFactory {
    #[inline] pub unsafe fn create_midi_song_select_message(&self, song: u8) -> Result<ComPtr<MidiSongSelectMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateMidiSongSelectMessage)(self as *const _ as *mut _, song, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MidiSongSelectMessage: IMidiSongSelectMessage}
impl RtActivatable<IMidiSongSelectMessageFactory> for MidiSongSelectMessage {}
impl MidiSongSelectMessage {
    #[inline] pub fn create_midi_song_select_message(song: u8) -> Result<ComPtr<MidiSongSelectMessage>> { unsafe {
        <Self as RtActivatable<IMidiSongSelectMessageFactory>>::get_activation_factory().create_midi_song_select_message(song)
    }}
}
DEFINE_CLSID!(MidiSongSelectMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,83,111,110,103,83,101,108,101,99,116,77,101,115,115,97,103,101,0]) [CLSID_MidiSongSelectMessage]);
RT_CLASS!{class MidiTuneRequestMessage: IMidiMessage}
impl RtActivatable<IActivationFactory> for MidiTuneRequestMessage {}
DEFINE_CLSID!(MidiTuneRequestMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,84,117,110,101,82,101,113,117,101,115,116,77,101,115,115,97,103,101,0]) [CLSID_MidiTuneRequestMessage]);
RT_CLASS!{class MidiTimingClockMessage: IMidiMessage}
impl RtActivatable<IActivationFactory> for MidiTimingClockMessage {}
DEFINE_CLSID!(MidiTimingClockMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,84,105,109,105,110,103,67,108,111,99,107,77,101,115,115,97,103,101,0]) [CLSID_MidiTimingClockMessage]);
RT_CLASS!{class MidiStartMessage: IMidiMessage}
impl RtActivatable<IActivationFactory> for MidiStartMessage {}
DEFINE_CLSID!(MidiStartMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,83,116,97,114,116,77,101,115,115,97,103,101,0]) [CLSID_MidiStartMessage]);
RT_CLASS!{class MidiContinueMessage: IMidiMessage}
impl RtActivatable<IActivationFactory> for MidiContinueMessage {}
DEFINE_CLSID!(MidiContinueMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,67,111,110,116,105,110,117,101,77,101,115,115,97,103,101,0]) [CLSID_MidiContinueMessage]);
RT_CLASS!{class MidiStopMessage: IMidiMessage}
impl RtActivatable<IActivationFactory> for MidiStopMessage {}
DEFINE_CLSID!(MidiStopMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,83,116,111,112,77,101,115,115,97,103,101,0]) [CLSID_MidiStopMessage]);
RT_CLASS!{class MidiActiveSensingMessage: IMidiMessage}
impl RtActivatable<IActivationFactory> for MidiActiveSensingMessage {}
DEFINE_CLSID!(MidiActiveSensingMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,65,99,116,105,118,101,83,101,110,115,105,110,103,77,101,115,115,97,103,101,0]) [CLSID_MidiActiveSensingMessage]);
RT_CLASS!{class MidiSystemResetMessage: IMidiMessage}
impl RtActivatable<IActivationFactory> for MidiSystemResetMessage {}
DEFINE_CLSID!(MidiSystemResetMessage(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,83,121,115,116,101,109,82,101,115,101,116,77,101,115,115,97,103,101,0]) [CLSID_MidiSystemResetMessage]);
DEFINE_IID!(IID_IMidiMessageReceivedEventArgs, 1985375830, 62248, 19281, 144, 125, 179, 168, 206, 150, 191, 128);
RT_INTERFACE!{interface IMidiMessageReceivedEventArgs(IMidiMessageReceivedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IMidiMessageReceivedEventArgs] {
    fn get_Message(&self, out: *mut *mut IMidiMessage) -> HRESULT
}}
impl IMidiMessageReceivedEventArgs {
    #[inline] pub unsafe fn get_message(&self) -> Result<ComPtr<IMidiMessage>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Message)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MidiMessageReceivedEventArgs: IMidiMessageReceivedEventArgs}
DEFINE_IID!(IID_IMidiInPortStatics, 1153710556, 26623, 19054, 139, 172, 253, 182, 97, 12, 242, 150);
RT_INTERFACE!{static interface IMidiInPortStatics(IMidiInPortStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IMidiInPortStatics] {
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<MidiInPort>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT
}}
impl IMidiInPortStatics {
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<MidiInPort>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MidiInPort: IMidiInPort}
impl RtActivatable<IMidiInPortStatics> for MidiInPort {}
impl MidiInPort {
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<MidiInPort>>> { unsafe {
        <Self as RtActivatable<IMidiInPortStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IMidiInPortStatics>>::get_activation_factory().get_device_selector()
    }}
}
DEFINE_CLSID!(MidiInPort(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,73,110,80,111,114,116,0]) [CLSID_MidiInPort]);
DEFINE_IID!(IID_IMidiOutPortStatics, 106742761, 3976, 17547, 155, 100, 169, 88, 38, 198, 91, 143);
RT_INTERFACE!{static interface IMidiOutPortStatics(IMidiOutPortStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IMidiOutPortStatics] {
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<IMidiOutPort>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT
}}
impl IMidiOutPortStatics {
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<IMidiOutPort>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMidiOutPort, 2468179359, 22434, 19002, 173, 184, 70, 64, 136, 111, 102, 147);
RT_INTERFACE!{interface IMidiOutPort(IMidiOutPortVtbl): IInspectable(IInspectableVtbl) [IID_IMidiOutPort] {
    fn SendMessage(&self, midiMessage: *mut IMidiMessage) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-storage")] fn SendBuffer(&self, midiData: *mut super::super::storage::streams::IBuffer) -> HRESULT,
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl IMidiOutPort {
    #[inline] pub unsafe fn send_message(&self, midiMessage: &IMidiMessage) -> Result<()> {
        let hr = ((*self.lpVtbl).SendMessage)(self as *const _ as *mut _, midiMessage as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn send_buffer(&self, midiData: &super::super::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).SendBuffer)(self as *const _ as *mut _, midiData as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMidiInPort, 3586251227, 38682, 20143, 162, 61, 234, 25, 254, 96, 127, 249);
RT_INTERFACE!{interface IMidiInPort(IMidiInPortVtbl): IInspectable(IInspectableVtbl) [IID_IMidiInPort] {
    fn add_MessageReceived(&self, handler: *mut super::super::foundation::TypedEventHandler<MidiInPort, MidiMessageReceivedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_MessageReceived(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl IMidiInPort {
    #[inline] pub unsafe fn add_message_received(&self, handler: &super::super::foundation::TypedEventHandler<MidiInPort, MidiMessageReceivedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_MessageReceived)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_message_received(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_MessageReceived)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MidiOutPort: IMidiOutPort}
impl RtActivatable<IMidiOutPortStatics> for MidiOutPort {}
impl MidiOutPort {
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<IMidiOutPort>>> { unsafe {
        <Self as RtActivatable<IMidiOutPortStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IMidiOutPortStatics>>::get_activation_factory().get_device_selector()
    }}
}
DEFINE_CLSID!(MidiOutPort(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,79,117,116,80,111,114,116,0]) [CLSID_MidiOutPort]);
DEFINE_IID!(IID_IMidiSynthesizerStatics, 1109715624, 26153, 19819, 170, 143, 212, 82, 26, 90, 49, 206);
RT_INTERFACE!{static interface IMidiSynthesizerStatics(IMidiSynthesizerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IMidiSynthesizerStatics] {
    fn CreateAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<MidiSynthesizer>) -> HRESULT,
    fn CreateFromAudioDeviceAsync(&self, audioDevice: *mut super::enumeration::DeviceInformation, out: *mut *mut super::super::foundation::IAsyncOperation<MidiSynthesizer>) -> HRESULT,
    fn IsSynthesizer(&self, midiDevice: *mut super::enumeration::DeviceInformation, out: *mut bool) -> HRESULT
}}
impl IMidiSynthesizerStatics {
    #[inline] pub unsafe fn create_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<MidiSynthesizer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_from_audio_device_async(&self, audioDevice: &super::enumeration::DeviceInformation) -> Result<ComPtr<super::super::foundation::IAsyncOperation<MidiSynthesizer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateFromAudioDeviceAsync)(self as *const _ as *mut _, audioDevice as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_synthesizer(&self, midiDevice: &super::enumeration::DeviceInformation) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsSynthesizer)(self as *const _ as *mut _, midiDevice as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class MidiSynthesizer: IMidiSynthesizer}
impl RtActivatable<IMidiSynthesizerStatics> for MidiSynthesizer {}
impl MidiSynthesizer {
    #[inline] pub fn create_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<MidiSynthesizer>>> { unsafe {
        <Self as RtActivatable<IMidiSynthesizerStatics>>::get_activation_factory().create_async()
    }}
    #[inline] pub fn create_from_audio_device_async(audioDevice: &super::enumeration::DeviceInformation) -> Result<ComPtr<super::super::foundation::IAsyncOperation<MidiSynthesizer>>> { unsafe {
        <Self as RtActivatable<IMidiSynthesizerStatics>>::get_activation_factory().create_from_audio_device_async(audioDevice)
    }}
    #[inline] pub fn is_synthesizer(midiDevice: &super::enumeration::DeviceInformation) -> Result<bool> { unsafe {
        <Self as RtActivatable<IMidiSynthesizerStatics>>::get_activation_factory().is_synthesizer(midiDevice)
    }}
}
DEFINE_CLSID!(MidiSynthesizer(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,77,105,100,105,46,77,105,100,105,83,121,110,116,104,101,115,105,122,101,114,0]) [CLSID_MidiSynthesizer]);
DEFINE_IID!(IID_IMidiSynthesizer, 4040824158, 56208, 16479, 184, 174, 33, 210, 225, 127, 46, 69);
RT_INTERFACE!{interface IMidiSynthesizer(IMidiSynthesizerVtbl): IInspectable(IInspectableVtbl) [IID_IMidiSynthesizer] {
    fn get_AudioDevice(&self, out: *mut *mut super::enumeration::DeviceInformation) -> HRESULT,
    fn get_Volume(&self, out: *mut f64) -> HRESULT,
    fn put_Volume(&self, value: f64) -> HRESULT
}}
impl IMidiSynthesizer {
    #[inline] pub unsafe fn get_audio_device(&self) -> Result<ComPtr<super::enumeration::DeviceInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AudioDevice)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_volume(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Volume)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_volume(&self, value: f64) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Volume)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
} // Windows.Devices.Midi
pub mod perception { // Windows.Devices.Perception
use ::prelude::*;
RT_ENUM! { enum PerceptionFrameSourceAccessStatus: i32 {
    Unspecified (PerceptionFrameSourceAccessStatus_Unspecified) = 0, Allowed (PerceptionFrameSourceAccessStatus_Allowed) = 1, DeniedByUser (PerceptionFrameSourceAccessStatus_DeniedByUser) = 2, DeniedBySystem (PerceptionFrameSourceAccessStatus_DeniedBySystem) = 3,
}}
RT_ENUM! { enum PerceptionFrameSourcePropertyChangeStatus: i32 {
    Unknown (PerceptionFrameSourcePropertyChangeStatus_Unknown) = 0, Accepted (PerceptionFrameSourcePropertyChangeStatus_Accepted) = 1, LostControl (PerceptionFrameSourcePropertyChangeStatus_LostControl) = 2, PropertyNotSupported (PerceptionFrameSourcePropertyChangeStatus_PropertyNotSupported) = 3, PropertyReadOnly (PerceptionFrameSourcePropertyChangeStatus_PropertyReadOnly) = 4, ValueOutOfRange (PerceptionFrameSourcePropertyChangeStatus_ValueOutOfRange) = 5,
}}
DEFINE_IID!(IID_IPerceptionColorFrameSourceWatcher, 2528973714, 58983, 16580, 137, 249, 20, 98, 222, 166, 169, 204);
RT_INTERFACE!{interface IPerceptionColorFrameSourceWatcher(IPerceptionColorFrameSourceWatcherVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionColorFrameSourceWatcher] {
    fn add_SourceAdded(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionColorFrameSourceWatcher, PerceptionColorFrameSourceAddedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SourceAdded(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_SourceRemoved(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionColorFrameSourceWatcher, PerceptionColorFrameSourceRemovedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SourceRemoved(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_Stopped(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionColorFrameSourceWatcher, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Stopped(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_EnumerationCompleted(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionColorFrameSourceWatcher, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_EnumerationCompleted(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_Status(&self, out: *mut super::enumeration::DeviceWatcherStatus) -> HRESULT,
    fn Start(&self) -> HRESULT,
    fn Stop(&self) -> HRESULT
}}
impl IPerceptionColorFrameSourceWatcher {
    #[inline] pub unsafe fn add_source_added(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionColorFrameSourceWatcher, PerceptionColorFrameSourceAddedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SourceAdded)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_source_added(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SourceAdded)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_source_removed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionColorFrameSourceWatcher, PerceptionColorFrameSourceRemovedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SourceRemoved)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_source_removed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SourceRemoved)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_stopped(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionColorFrameSourceWatcher, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Stopped)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_stopped(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Stopped)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_enumeration_completed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionColorFrameSourceWatcher, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_EnumerationCompleted)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_enumeration_completed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_EnumerationCompleted)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<super::enumeration::DeviceWatcherStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Stop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionColorFrameSourceWatcher: IPerceptionColorFrameSourceWatcher}
RT_CLASS!{class PerceptionColorFrameSourceAddedEventArgs: IPerceptionColorFrameSourceAddedEventArgs}
RT_CLASS!{class PerceptionColorFrameSourceRemovedEventArgs: IPerceptionColorFrameSourceRemovedEventArgs}
DEFINE_IID!(IID_IPerceptionDepthFrameSourceWatcher, 2014222033, 36098, 19755, 173, 164, 91, 166, 36, 160, 235, 16);
RT_INTERFACE!{interface IPerceptionDepthFrameSourceWatcher(IPerceptionDepthFrameSourceWatcherVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionDepthFrameSourceWatcher] {
    fn add_SourceAdded(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionDepthFrameSourceWatcher, PerceptionDepthFrameSourceAddedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SourceAdded(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_SourceRemoved(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionDepthFrameSourceWatcher, PerceptionDepthFrameSourceRemovedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SourceRemoved(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_Stopped(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionDepthFrameSourceWatcher, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Stopped(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_EnumerationCompleted(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionDepthFrameSourceWatcher, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_EnumerationCompleted(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_Status(&self, out: *mut super::enumeration::DeviceWatcherStatus) -> HRESULT,
    fn Start(&self) -> HRESULT,
    fn Stop(&self) -> HRESULT
}}
impl IPerceptionDepthFrameSourceWatcher {
    #[inline] pub unsafe fn add_source_added(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionDepthFrameSourceWatcher, PerceptionDepthFrameSourceAddedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SourceAdded)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_source_added(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SourceAdded)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_source_removed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionDepthFrameSourceWatcher, PerceptionDepthFrameSourceRemovedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SourceRemoved)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_source_removed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SourceRemoved)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_stopped(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionDepthFrameSourceWatcher, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Stopped)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_stopped(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Stopped)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_enumeration_completed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionDepthFrameSourceWatcher, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_EnumerationCompleted)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_enumeration_completed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_EnumerationCompleted)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<super::enumeration::DeviceWatcherStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Stop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionDepthFrameSourceWatcher: IPerceptionDepthFrameSourceWatcher}
RT_CLASS!{class PerceptionDepthFrameSourceAddedEventArgs: IPerceptionDepthFrameSourceAddedEventArgs}
RT_CLASS!{class PerceptionDepthFrameSourceRemovedEventArgs: IPerceptionDepthFrameSourceRemovedEventArgs}
DEFINE_IID!(IID_IPerceptionInfraredFrameSourceWatcher, 943521689, 55052, 17485, 168, 176, 114, 12, 46, 102, 254, 59);
RT_INTERFACE!{interface IPerceptionInfraredFrameSourceWatcher(IPerceptionInfraredFrameSourceWatcherVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionInfraredFrameSourceWatcher] {
    fn add_SourceAdded(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSourceWatcher, PerceptionInfraredFrameSourceAddedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SourceAdded(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_SourceRemoved(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSourceWatcher, PerceptionInfraredFrameSourceRemovedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SourceRemoved(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_Stopped(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSourceWatcher, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Stopped(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_EnumerationCompleted(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSourceWatcher, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_EnumerationCompleted(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_Status(&self, out: *mut super::enumeration::DeviceWatcherStatus) -> HRESULT,
    fn Start(&self) -> HRESULT,
    fn Stop(&self) -> HRESULT
}}
impl IPerceptionInfraredFrameSourceWatcher {
    #[inline] pub unsafe fn add_source_added(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSourceWatcher, PerceptionInfraredFrameSourceAddedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SourceAdded)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_source_added(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SourceAdded)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_source_removed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSourceWatcher, PerceptionInfraredFrameSourceRemovedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SourceRemoved)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_source_removed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SourceRemoved)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_stopped(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSourceWatcher, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Stopped)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_stopped(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Stopped)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_enumeration_completed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSourceWatcher, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_EnumerationCompleted)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_enumeration_completed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_EnumerationCompleted)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<super::enumeration::DeviceWatcherStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Stop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionInfraredFrameSourceWatcher: IPerceptionInfraredFrameSourceWatcher}
RT_CLASS!{class PerceptionInfraredFrameSourceAddedEventArgs: IPerceptionInfraredFrameSourceAddedEventArgs}
RT_CLASS!{class PerceptionInfraredFrameSourceRemovedEventArgs: IPerceptionInfraredFrameSourceRemovedEventArgs}
DEFINE_IID!(IID_IPerceptionColorFrameSourceAddedEventArgs, 3513513190, 55844, 17452, 187, 213, 85, 84, 155, 91, 148, 243);
RT_INTERFACE!{interface IPerceptionColorFrameSourceAddedEventArgs(IPerceptionColorFrameSourceAddedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionColorFrameSourceAddedEventArgs] {
    fn get_FrameSource(&self, out: *mut *mut PerceptionColorFrameSource) -> HRESULT
}}
impl IPerceptionColorFrameSourceAddedEventArgs {
    #[inline] pub unsafe fn get_frame_source(&self) -> Result<ComPtr<PerceptionColorFrameSource>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FrameSource)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionColorFrameSource: IPerceptionColorFrameSource}
impl RtActivatable<IPerceptionColorFrameSourceStatics> for PerceptionColorFrameSource {}
impl PerceptionColorFrameSource {
    #[inline] pub fn create_watcher() -> Result<ComPtr<PerceptionColorFrameSourceWatcher>> { unsafe {
        <Self as RtActivatable<IPerceptionColorFrameSourceStatics>>::get_activation_factory().create_watcher()
    }}
    #[inline] pub fn find_all_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PerceptionColorFrameSource>>>> { unsafe {
        <Self as RtActivatable<IPerceptionColorFrameSourceStatics>>::get_activation_factory().find_all_async()
    }}
    #[inline] pub fn from_id_async(id: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionColorFrameSource>>> { unsafe {
        <Self as RtActivatable<IPerceptionColorFrameSourceStatics>>::get_activation_factory().from_id_async(id)
    }}
    #[inline] pub fn request_access_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionFrameSourceAccessStatus>>> { unsafe {
        <Self as RtActivatable<IPerceptionColorFrameSourceStatics>>::get_activation_factory().request_access_async()
    }}
}
DEFINE_CLSID!(PerceptionColorFrameSource(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,80,101,114,99,101,112,116,105,111,110,67,111,108,111,114,70,114,97,109,101,83,111,117,114,99,101,0]) [CLSID_PerceptionColorFrameSource]);
DEFINE_IID!(IID_IPerceptionColorFrameSourceRemovedEventArgs, 3531078249, 60236, 17135, 186, 79, 40, 143, 97, 92, 147, 193);
RT_INTERFACE!{interface IPerceptionColorFrameSourceRemovedEventArgs(IPerceptionColorFrameSourceRemovedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionColorFrameSourceRemovedEventArgs] {
    fn get_FrameSource(&self, out: *mut *mut PerceptionColorFrameSource) -> HRESULT
}}
impl IPerceptionColorFrameSourceRemovedEventArgs {
    #[inline] pub unsafe fn get_frame_source(&self) -> Result<ComPtr<PerceptionColorFrameSource>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FrameSource)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionDepthFrameSourceAddedEventArgs, 2477031784, 35832, 17874, 162, 248, 74, 192, 147, 28, 199, 166);
RT_INTERFACE!{interface IPerceptionDepthFrameSourceAddedEventArgs(IPerceptionDepthFrameSourceAddedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionDepthFrameSourceAddedEventArgs] {
    fn get_FrameSource(&self, out: *mut *mut PerceptionDepthFrameSource) -> HRESULT
}}
impl IPerceptionDepthFrameSourceAddedEventArgs {
    #[inline] pub unsafe fn get_frame_source(&self) -> Result<ComPtr<PerceptionDepthFrameSource>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FrameSource)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionDepthFrameSource: IPerceptionDepthFrameSource}
impl RtActivatable<IPerceptionDepthFrameSourceStatics> for PerceptionDepthFrameSource {}
impl PerceptionDepthFrameSource {
    #[inline] pub fn create_watcher() -> Result<ComPtr<PerceptionDepthFrameSourceWatcher>> { unsafe {
        <Self as RtActivatable<IPerceptionDepthFrameSourceStatics>>::get_activation_factory().create_watcher()
    }}
    #[inline] pub fn find_all_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PerceptionDepthFrameSource>>>> { unsafe {
        <Self as RtActivatable<IPerceptionDepthFrameSourceStatics>>::get_activation_factory().find_all_async()
    }}
    #[inline] pub fn from_id_async(id: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionDepthFrameSource>>> { unsafe {
        <Self as RtActivatable<IPerceptionDepthFrameSourceStatics>>::get_activation_factory().from_id_async(id)
    }}
    #[inline] pub fn request_access_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionFrameSourceAccessStatus>>> { unsafe {
        <Self as RtActivatable<IPerceptionDepthFrameSourceStatics>>::get_activation_factory().request_access_async()
    }}
}
DEFINE_CLSID!(PerceptionDepthFrameSource(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,80,101,114,99,101,112,116,105,111,110,68,101,112,116,104,70,114,97,109,101,83,111,117,114,99,101,0]) [CLSID_PerceptionDepthFrameSource]);
DEFINE_IID!(IID_IPerceptionDepthFrameSourceRemovedEventArgs, 2696989773, 59756, 19841, 134, 221, 56, 185, 94, 73, 198, 223);
RT_INTERFACE!{interface IPerceptionDepthFrameSourceRemovedEventArgs(IPerceptionDepthFrameSourceRemovedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionDepthFrameSourceRemovedEventArgs] {
    fn get_FrameSource(&self, out: *mut *mut PerceptionDepthFrameSource) -> HRESULT
}}
impl IPerceptionDepthFrameSourceRemovedEventArgs {
    #[inline] pub unsafe fn get_frame_source(&self) -> Result<ComPtr<PerceptionDepthFrameSource>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FrameSource)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionInfraredFrameSourceAddedEventArgs, 1832075552, 38350, 18016, 144, 122, 217, 128, 53, 170, 43, 124);
RT_INTERFACE!{interface IPerceptionInfraredFrameSourceAddedEventArgs(IPerceptionInfraredFrameSourceAddedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionInfraredFrameSourceAddedEventArgs] {
    fn get_FrameSource(&self, out: *mut *mut PerceptionInfraredFrameSource) -> HRESULT
}}
impl IPerceptionInfraredFrameSourceAddedEventArgs {
    #[inline] pub unsafe fn get_frame_source(&self) -> Result<ComPtr<PerceptionInfraredFrameSource>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FrameSource)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionInfraredFrameSource: IPerceptionInfraredFrameSource}
impl RtActivatable<IPerceptionInfraredFrameSourceStatics> for PerceptionInfraredFrameSource {}
impl PerceptionInfraredFrameSource {
    #[inline] pub fn create_watcher() -> Result<ComPtr<PerceptionInfraredFrameSourceWatcher>> { unsafe {
        <Self as RtActivatable<IPerceptionInfraredFrameSourceStatics>>::get_activation_factory().create_watcher()
    }}
    #[inline] pub fn find_all_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PerceptionInfraredFrameSource>>>> { unsafe {
        <Self as RtActivatable<IPerceptionInfraredFrameSourceStatics>>::get_activation_factory().find_all_async()
    }}
    #[inline] pub fn from_id_async(id: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionInfraredFrameSource>>> { unsafe {
        <Self as RtActivatable<IPerceptionInfraredFrameSourceStatics>>::get_activation_factory().from_id_async(id)
    }}
    #[inline] pub fn request_access_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionFrameSourceAccessStatus>>> { unsafe {
        <Self as RtActivatable<IPerceptionInfraredFrameSourceStatics>>::get_activation_factory().request_access_async()
    }}
}
DEFINE_CLSID!(PerceptionInfraredFrameSource(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,80,101,114,99,101,112,116,105,111,110,73,110,102,114,97,114,101,100,70,114,97,109,101,83,111,117,114,99,101,0]) [CLSID_PerceptionInfraredFrameSource]);
DEFINE_IID!(IID_IPerceptionInfraredFrameSourceRemovedEventArgs, 3927605361, 31344, 19041, 175, 148, 7, 48, 56, 83, 246, 149);
RT_INTERFACE!{interface IPerceptionInfraredFrameSourceRemovedEventArgs(IPerceptionInfraredFrameSourceRemovedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionInfraredFrameSourceRemovedEventArgs] {
    fn get_FrameSource(&self, out: *mut *mut PerceptionInfraredFrameSource) -> HRESULT
}}
impl IPerceptionInfraredFrameSourceRemovedEventArgs {
    #[inline] pub unsafe fn get_frame_source(&self) -> Result<ComPtr<PerceptionInfraredFrameSource>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FrameSource)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IKnownPerceptionFrameSourcePropertiesStatics, 1576127650, 504, 19079, 184, 89, 213, 229, 183, 225, 222, 71);
RT_INTERFACE!{static interface IKnownPerceptionFrameSourcePropertiesStatics(IKnownPerceptionFrameSourcePropertiesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IKnownPerceptionFrameSourcePropertiesStatics] {
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn get_PhysicalDeviceIds(&self, out: *mut HSTRING) -> HRESULT,
    fn get_FrameKind(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DeviceModelVersion(&self, out: *mut HSTRING) -> HRESULT,
    fn get_EnclosureLocation(&self, out: *mut HSTRING) -> HRESULT
}}
impl IKnownPerceptionFrameSourcePropertiesStatics {
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_physical_device_ids(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PhysicalDeviceIds)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_frame_kind(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FrameKind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_model_version(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceModelVersion)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_enclosure_location(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_EnclosureLocation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IKnownPerceptionFrameSourcePropertiesStatics2, 2848483441, 1500, 19021, 138, 92, 164, 236, 242, 107, 188, 70);
RT_INTERFACE!{static interface IKnownPerceptionFrameSourcePropertiesStatics2(IKnownPerceptionFrameSourcePropertiesStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IKnownPerceptionFrameSourcePropertiesStatics2] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl IKnownPerceptionFrameSourcePropertiesStatics2 {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IKnownPerceptionVideoFrameSourcePropertiesStatics, 1576127650, 504, 19079, 184, 89, 213, 229, 183, 225, 222, 72);
RT_INTERFACE!{static interface IKnownPerceptionVideoFrameSourcePropertiesStatics(IKnownPerceptionVideoFrameSourcePropertiesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IKnownPerceptionVideoFrameSourcePropertiesStatics] {
    fn get_VideoProfile(&self, out: *mut HSTRING) -> HRESULT,
    fn get_SupportedVideoProfiles(&self, out: *mut HSTRING) -> HRESULT,
    fn get_AvailableVideoProfiles(&self, out: *mut HSTRING) -> HRESULT,
    fn get_IsMirrored(&self, out: *mut HSTRING) -> HRESULT,
    fn get_CameraIntrinsics(&self, out: *mut HSTRING) -> HRESULT
}}
impl IKnownPerceptionVideoFrameSourcePropertiesStatics {
    #[inline] pub unsafe fn get_video_profile(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_VideoProfile)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_video_profiles(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedVideoProfiles)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_available_video_profiles(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AvailableVideoProfiles)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_mirrored(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_IsMirrored)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_camera_intrinsics(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_CameraIntrinsics)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IKnownPerceptionInfraredFrameSourcePropertiesStatics, 1576127650, 504, 19079, 184, 89, 213, 229, 183, 225, 222, 73);
RT_INTERFACE!{static interface IKnownPerceptionInfraredFrameSourcePropertiesStatics(IKnownPerceptionInfraredFrameSourcePropertiesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IKnownPerceptionInfraredFrameSourcePropertiesStatics] {
    fn get_Exposure(&self, out: *mut HSTRING) -> HRESULT,
    fn get_AutoExposureEnabled(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ExposureCompensation(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ActiveIlluminationEnabled(&self, out: *mut HSTRING) -> HRESULT,
    fn get_AmbientSubtractionEnabled(&self, out: *mut HSTRING) -> HRESULT,
    fn get_StructureLightPatternEnabled(&self, out: *mut HSTRING) -> HRESULT,
    fn get_InterleavedIlluminationEnabled(&self, out: *mut HSTRING) -> HRESULT
}}
impl IKnownPerceptionInfraredFrameSourcePropertiesStatics {
    #[inline] pub unsafe fn get_exposure(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Exposure)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_auto_exposure_enabled(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AutoExposureEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_exposure_compensation(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ExposureCompensation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_active_illumination_enabled(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ActiveIlluminationEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ambient_subtraction_enabled(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AmbientSubtractionEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_structure_light_pattern_enabled(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_StructureLightPatternEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_interleaved_illumination_enabled(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_InterleavedIlluminationEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IKnownPerceptionDepthFrameSourcePropertiesStatics, 1576127650, 504, 19079, 184, 89, 213, 229, 183, 225, 222, 74);
RT_INTERFACE!{static interface IKnownPerceptionDepthFrameSourcePropertiesStatics(IKnownPerceptionDepthFrameSourcePropertiesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IKnownPerceptionDepthFrameSourcePropertiesStatics] {
    fn get_MinDepth(&self, out: *mut HSTRING) -> HRESULT,
    fn get_MaxDepth(&self, out: *mut HSTRING) -> HRESULT
}}
impl IKnownPerceptionDepthFrameSourcePropertiesStatics {
    #[inline] pub unsafe fn get_min_depth(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_MinDepth)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_depth(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_MaxDepth)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IKnownPerceptionColorFrameSourcePropertiesStatics, 1576127650, 504, 19079, 184, 89, 213, 229, 183, 225, 222, 75);
RT_INTERFACE!{static interface IKnownPerceptionColorFrameSourcePropertiesStatics(IKnownPerceptionColorFrameSourcePropertiesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IKnownPerceptionColorFrameSourcePropertiesStatics] {
    fn get_Exposure(&self, out: *mut HSTRING) -> HRESULT,
    fn get_AutoExposureEnabled(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ExposureCompensation(&self, out: *mut HSTRING) -> HRESULT
}}
impl IKnownPerceptionColorFrameSourcePropertiesStatics {
    #[inline] pub unsafe fn get_exposure(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Exposure)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_auto_exposure_enabled(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AutoExposureEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_exposure_compensation(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ExposureCompensation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IKnownPerceptionVideoProfilePropertiesStatics, 2399724263, 23158, 17379, 161, 58, 218, 61, 145, 169, 239, 152);
RT_INTERFACE!{static interface IKnownPerceptionVideoProfilePropertiesStatics(IKnownPerceptionVideoProfilePropertiesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IKnownPerceptionVideoProfilePropertiesStatics] {
    fn get_BitmapPixelFormat(&self, out: *mut HSTRING) -> HRESULT,
    fn get_BitmapAlphaMode(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Width(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Height(&self, out: *mut HSTRING) -> HRESULT,
    fn get_FrameDuration(&self, out: *mut HSTRING) -> HRESULT
}}
impl IKnownPerceptionVideoProfilePropertiesStatics {
    #[inline] pub unsafe fn get_bitmap_pixel_format(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BitmapPixelFormat)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bitmap_alpha_mode(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BitmapAlphaMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_width(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Width)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_height(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Height)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_frame_duration(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FrameDuration)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IKnownCameraIntrinsicsPropertiesStatics, 146815352, 17274, 19863, 166, 99, 253, 49, 149, 96, 2, 73);
RT_INTERFACE!{static interface IKnownCameraIntrinsicsPropertiesStatics(IKnownCameraIntrinsicsPropertiesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IKnownCameraIntrinsicsPropertiesStatics] {
    fn get_FocalLength(&self, out: *mut HSTRING) -> HRESULT,
    fn get_PrincipalPoint(&self, out: *mut HSTRING) -> HRESULT,
    fn get_RadialDistortion(&self, out: *mut HSTRING) -> HRESULT,
    fn get_TangentialDistortion(&self, out: *mut HSTRING) -> HRESULT
}}
impl IKnownCameraIntrinsicsPropertiesStatics {
    #[inline] pub unsafe fn get_focal_length(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FocalLength)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_principal_point(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PrincipalPoint)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_radial_distortion(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_RadialDistortion)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_tangential_distortion(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_TangentialDistortion)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionFrameSourcePropertyChangeResult, 506673418, 15504, 19746, 184, 152, 244, 43, 186, 100, 24, 255);
RT_INTERFACE!{interface IPerceptionFrameSourcePropertyChangeResult(IPerceptionFrameSourcePropertyChangeResultVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionFrameSourcePropertyChangeResult] {
    fn get_Status(&self, out: *mut PerceptionFrameSourcePropertyChangeStatus) -> HRESULT,
    fn get_NewValue(&self, out: *mut *mut IInspectable) -> HRESULT
}}
impl IPerceptionFrameSourcePropertyChangeResult {
    #[inline] pub unsafe fn get_status(&self) -> Result<PerceptionFrameSourcePropertyChangeStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_new_value(&self) -> Result<ComPtr<IInspectable>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_NewValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionControlSession, 2576975443, 23101, 16767, 146, 57, 241, 136, 158, 84, 139, 72);
RT_INTERFACE!{interface IPerceptionControlSession(IPerceptionControlSessionVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionControlSession] {
    fn add_ControlLost(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionControlSession, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ControlLost(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn TrySetPropertyAsync(&self, name: HSTRING, value: *mut IInspectable, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionFrameSourcePropertyChangeResult>) -> HRESULT
}}
impl IPerceptionControlSession {
    #[inline] pub unsafe fn add_control_lost(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionControlSession, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ControlLost)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_control_lost(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ControlLost)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_set_property_async(&self, name: &HStringArg, value: &IInspectable) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionFrameSourcePropertyChangeResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TrySetPropertyAsync)(self as *const _ as *mut _, name.get(), value as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionControlSession: IPerceptionControlSession}
RT_CLASS!{class PerceptionFrameSourcePropertyChangeResult: IPerceptionFrameSourcePropertyChangeResult}
DEFINE_IID!(IID_IPerceptionFrameSourcePropertiesChangedEventArgs, 1818812520, 48369, 20172, 184, 145, 118, 37, 209, 36, 75, 107);
RT_INTERFACE!{interface IPerceptionFrameSourcePropertiesChangedEventArgs(IPerceptionFrameSourcePropertiesChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionFrameSourcePropertiesChangedEventArgs] {
    fn get_CollectionChange(&self, out: *mut super::super::foundation::collections::CollectionChange) -> HRESULT,
    fn get_Key(&self, out: *mut HSTRING) -> HRESULT
}}
impl IPerceptionFrameSourcePropertiesChangedEventArgs {
    #[inline] pub unsafe fn get_collection_change(&self) -> Result<super::super::foundation::collections::CollectionChange> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CollectionChange)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_key(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Key)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionInfraredFrameSourceStatics, 1576258722, 504, 19079, 184, 89, 213, 229, 183, 225, 222, 71);
RT_INTERFACE!{static interface IPerceptionInfraredFrameSourceStatics(IPerceptionInfraredFrameSourceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionInfraredFrameSourceStatics] {
    fn CreateWatcher(&self, out: *mut *mut PerceptionInfraredFrameSourceWatcher) -> HRESULT,
    fn FindAllAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PerceptionInfraredFrameSource>>) -> HRESULT,
    fn FromIdAsync(&self, id: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionInfraredFrameSource>) -> HRESULT,
    fn RequestAccessAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionFrameSourceAccessStatus>) -> HRESULT
}}
impl IPerceptionInfraredFrameSourceStatics {
    #[inline] pub unsafe fn create_watcher(&self) -> Result<ComPtr<PerceptionInfraredFrameSourceWatcher>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWatcher)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn find_all_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PerceptionInfraredFrameSource>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FindAllAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, id: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionInfraredFrameSource>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, id.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn request_access_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionFrameSourceAccessStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestAccessAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionDepthFrameSourceStatics, 1576258722, 504, 19079, 184, 89, 213, 229, 183, 225, 222, 72);
RT_INTERFACE!{static interface IPerceptionDepthFrameSourceStatics(IPerceptionDepthFrameSourceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionDepthFrameSourceStatics] {
    fn CreateWatcher(&self, out: *mut *mut PerceptionDepthFrameSourceWatcher) -> HRESULT,
    fn FindAllAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PerceptionDepthFrameSource>>) -> HRESULT,
    fn FromIdAsync(&self, id: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionDepthFrameSource>) -> HRESULT,
    fn RequestAccessAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionFrameSourceAccessStatus>) -> HRESULT
}}
impl IPerceptionDepthFrameSourceStatics {
    #[inline] pub unsafe fn create_watcher(&self) -> Result<ComPtr<PerceptionDepthFrameSourceWatcher>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWatcher)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn find_all_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PerceptionDepthFrameSource>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FindAllAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, id: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionDepthFrameSource>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, id.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn request_access_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionFrameSourceAccessStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestAccessAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionColorFrameSourceStatics, 1576258722, 504, 19079, 184, 89, 213, 229, 183, 225, 222, 73);
RT_INTERFACE!{static interface IPerceptionColorFrameSourceStatics(IPerceptionColorFrameSourceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionColorFrameSourceStatics] {
    fn CreateWatcher(&self, out: *mut *mut PerceptionColorFrameSourceWatcher) -> HRESULT,
    fn FindAllAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PerceptionColorFrameSource>>) -> HRESULT,
    fn FromIdAsync(&self, id: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionColorFrameSource>) -> HRESULT,
    fn RequestAccessAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionFrameSourceAccessStatus>) -> HRESULT
}}
impl IPerceptionColorFrameSourceStatics {
    #[inline] pub unsafe fn create_watcher(&self) -> Result<ComPtr<PerceptionColorFrameSourceWatcher>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWatcher)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn find_all_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PerceptionColorFrameSource>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FindAllAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, id: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionColorFrameSource>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, id.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn request_access_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionFrameSourceAccessStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestAccessAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionColorFrameSource, 3698178684, 2904, 18061, 156, 161, 109, 176, 76, 192, 71, 124);
RT_INTERFACE!{interface IPerceptionColorFrameSource(IPerceptionColorFrameSourceVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionColorFrameSource] {
    fn add_AvailableChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionColorFrameSource, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_AvailableChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_ActiveChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionColorFrameSource, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ActiveChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_PropertiesChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionColorFrameSource, PerceptionFrameSourcePropertiesChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_PropertiesChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_VideoProfileChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionColorFrameSource, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_VideoProfileChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_CameraIntrinsicsChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionColorFrameSource, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_CameraIntrinsicsChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DisplayName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DeviceKind(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Available(&self, out: *mut bool) -> HRESULT,
    fn get_Active(&self, out: *mut bool) -> HRESULT,
    fn get_IsControlled(&self, out: *mut bool) -> HRESULT,
    fn get_Properties(&self, out: *mut *mut super::super::foundation::collections::IMapView<HString, IInspectable>) -> HRESULT,
    fn get_SupportedVideoProfiles(&self, out: *mut *mut super::super::foundation::collections::IVectorView<PerceptionVideoProfile>) -> HRESULT,
    fn get_AvailableVideoProfiles(&self, out: *mut *mut super::super::foundation::collections::IVectorView<PerceptionVideoProfile>) -> HRESULT,
    fn get_VideoProfile(&self, out: *mut *mut PerceptionVideoProfile) -> HRESULT,
    #[cfg(not(feature="windows-media"))] fn __Dummy20(&self) -> (),
    #[cfg(feature="windows-media")] fn get_CameraIntrinsics(&self, out: *mut *mut super::super::media::devices::core::CameraIntrinsics) -> HRESULT,
    fn AcquireControlSession(&self, out: *mut *mut PerceptionControlSession) -> HRESULT,
    fn CanControlIndependentlyFrom(&self, targetId: HSTRING, out: *mut bool) -> HRESULT,
    fn IsCorrelatedWith(&self, targetId: HSTRING, out: *mut bool) -> HRESULT,
    fn TryGetTransformTo(&self, targetId: HSTRING, result: *mut super::super::foundation::numerics::Matrix4x4, out: *mut bool) -> HRESULT,
    fn TryGetDepthCorrelatedCameraIntrinsicsAsync(&self, correlatedDepthFrameSource: *mut PerceptionDepthFrameSource, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionDepthCorrelatedCameraIntrinsics>) -> HRESULT,
    fn TryGetDepthCorrelatedCoordinateMapperAsync(&self, targetSourceId: HSTRING, correlatedDepthFrameSource: *mut PerceptionDepthFrameSource, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionDepthCorrelatedCoordinateMapper>) -> HRESULT,
    fn TrySetVideoProfileAsync(&self, controlSession: *mut PerceptionControlSession, profile: *mut PerceptionVideoProfile, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionFrameSourcePropertyChangeResult>) -> HRESULT,
    fn OpenReader(&self, out: *mut *mut PerceptionColorFrameReader) -> HRESULT
}}
impl IPerceptionColorFrameSource {
    #[inline] pub unsafe fn add_available_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionColorFrameSource, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_AvailableChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_available_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_AvailableChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_active_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionColorFrameSource, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ActiveChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_active_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ActiveChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_properties_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionColorFrameSource, PerceptionFrameSourcePropertiesChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_PropertiesChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_properties_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_PropertiesChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_video_profile_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionColorFrameSource, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_VideoProfileChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_video_profile_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_VideoProfileChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_camera_intrinsics_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionColorFrameSource, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_CameraIntrinsicsChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_camera_intrinsics_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_CameraIntrinsicsChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_display_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DisplayName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_kind(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceKind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_available(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Available)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_active(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Active)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_controlled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsControlled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_properties(&self) -> Result<ComPtr<super::super::foundation::collections::IMapView<HString, IInspectable>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Properties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_video_profiles(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<PerceptionVideoProfile>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedVideoProfiles)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_available_video_profiles(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<PerceptionVideoProfile>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AvailableVideoProfiles)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_video_profile(&self) -> Result<ComPtr<PerceptionVideoProfile>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_VideoProfile)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-media")] #[inline] pub unsafe fn get_camera_intrinsics(&self) -> Result<ComPtr<super::super::media::devices::core::CameraIntrinsics>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_CameraIntrinsics)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn acquire_control_session(&self) -> Result<ComPtr<PerceptionControlSession>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).AcquireControlSession)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn can_control_independently_from(&self, targetId: &HStringArg) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).CanControlIndependentlyFrom)(self as *const _ as *mut _, targetId.get(), &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_correlated_with(&self, targetId: &HStringArg) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsCorrelatedWith)(self as *const _ as *mut _, targetId.get(), &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_get_transform_to(&self, targetId: &HStringArg) -> Result<(super::super::foundation::numerics::Matrix4x4, bool)> {
        let mut result = zeroed(); let mut out = zeroed();
        let hr = ((*self.lpVtbl).TryGetTransformTo)(self as *const _ as *mut _, targetId.get(), &mut result, &mut out);
        if hr == S_OK { Ok((result, out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_get_depth_correlated_camera_intrinsics_async(&self, correlatedDepthFrameSource: &PerceptionDepthFrameSource) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionDepthCorrelatedCameraIntrinsics>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryGetDepthCorrelatedCameraIntrinsicsAsync)(self as *const _ as *mut _, correlatedDepthFrameSource as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_get_depth_correlated_coordinate_mapper_async(&self, targetSourceId: &HStringArg, correlatedDepthFrameSource: &PerceptionDepthFrameSource) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionDepthCorrelatedCoordinateMapper>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryGetDepthCorrelatedCoordinateMapperAsync)(self as *const _ as *mut _, targetSourceId.get(), correlatedDepthFrameSource as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_set_video_profile_async(&self, controlSession: &PerceptionControlSession, profile: &PerceptionVideoProfile) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionFrameSourcePropertyChangeResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TrySetVideoProfileAsync)(self as *const _ as *mut _, controlSession as *const _ as *mut _, profile as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn open_reader(&self) -> Result<ComPtr<PerceptionColorFrameReader>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).OpenReader)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionFrameSourcePropertiesChangedEventArgs: IPerceptionFrameSourcePropertiesChangedEventArgs}
RT_CLASS!{class PerceptionVideoProfile: IPerceptionVideoProfile}
RT_CLASS!{class PerceptionDepthCorrelatedCameraIntrinsics: IPerceptionDepthCorrelatedCameraIntrinsics}
RT_CLASS!{class PerceptionDepthCorrelatedCoordinateMapper: IPerceptionDepthCorrelatedCoordinateMapper}
RT_CLASS!{class PerceptionColorFrameReader: IPerceptionColorFrameReader}
DEFINE_IID!(IID_IPerceptionColorFrameSource2, 4169140453, 22065, 17901, 173, 152, 140, 106, 160, 76, 251, 145);
RT_INTERFACE!{interface IPerceptionColorFrameSource2(IPerceptionColorFrameSource2Vtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionColorFrameSource2] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl IPerceptionColorFrameSource2 {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionDepthFrameSource, 2043950038, 18427, 19953, 191, 201, 240, 29, 64, 189, 153, 66);
RT_INTERFACE!{interface IPerceptionDepthFrameSource(IPerceptionDepthFrameSourceVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionDepthFrameSource] {
    fn add_AvailableChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionDepthFrameSource, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_AvailableChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_ActiveChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionDepthFrameSource, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ActiveChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_PropertiesChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionDepthFrameSource, PerceptionFrameSourcePropertiesChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_PropertiesChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_VideoProfileChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionDepthFrameSource, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_VideoProfileChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_CameraIntrinsicsChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionDepthFrameSource, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_CameraIntrinsicsChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DisplayName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DeviceKind(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Available(&self, out: *mut bool) -> HRESULT,
    fn get_Active(&self, out: *mut bool) -> HRESULT,
    fn get_IsControlled(&self, out: *mut bool) -> HRESULT,
    fn get_Properties(&self, out: *mut *mut super::super::foundation::collections::IMapView<HString, IInspectable>) -> HRESULT,
    fn get_SupportedVideoProfiles(&self, out: *mut *mut super::super::foundation::collections::IVectorView<PerceptionVideoProfile>) -> HRESULT,
    fn get_AvailableVideoProfiles(&self, out: *mut *mut super::super::foundation::collections::IVectorView<PerceptionVideoProfile>) -> HRESULT,
    fn get_VideoProfile(&self, out: *mut *mut PerceptionVideoProfile) -> HRESULT,
    #[cfg(not(feature="windows-media"))] fn __Dummy20(&self) -> (),
    #[cfg(feature="windows-media")] fn get_CameraIntrinsics(&self, out: *mut *mut super::super::media::devices::core::CameraIntrinsics) -> HRESULT,
    fn AcquireControlSession(&self, out: *mut *mut PerceptionControlSession) -> HRESULT,
    fn CanControlIndependentlyFrom(&self, targetId: HSTRING, out: *mut bool) -> HRESULT,
    fn IsCorrelatedWith(&self, targetId: HSTRING, out: *mut bool) -> HRESULT,
    fn TryGetTransformTo(&self, targetId: HSTRING, result: *mut super::super::foundation::numerics::Matrix4x4, out: *mut bool) -> HRESULT,
    fn TryGetDepthCorrelatedCameraIntrinsicsAsync(&self, target: *mut PerceptionDepthFrameSource, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionDepthCorrelatedCameraIntrinsics>) -> HRESULT,
    fn TryGetDepthCorrelatedCoordinateMapperAsync(&self, targetId: HSTRING, depthFrameSourceToMapWith: *mut PerceptionDepthFrameSource, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionDepthCorrelatedCoordinateMapper>) -> HRESULT,
    fn TrySetVideoProfileAsync(&self, controlSession: *mut PerceptionControlSession, profile: *mut PerceptionVideoProfile, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionFrameSourcePropertyChangeResult>) -> HRESULT,
    fn OpenReader(&self, out: *mut *mut PerceptionDepthFrameReader) -> HRESULT
}}
impl IPerceptionDepthFrameSource {
    #[inline] pub unsafe fn add_available_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionDepthFrameSource, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_AvailableChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_available_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_AvailableChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_active_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionDepthFrameSource, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ActiveChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_active_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ActiveChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_properties_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionDepthFrameSource, PerceptionFrameSourcePropertiesChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_PropertiesChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_properties_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_PropertiesChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_video_profile_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionDepthFrameSource, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_VideoProfileChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_video_profile_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_VideoProfileChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_camera_intrinsics_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionDepthFrameSource, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_CameraIntrinsicsChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_camera_intrinsics_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_CameraIntrinsicsChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_display_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DisplayName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_kind(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceKind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_available(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Available)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_active(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Active)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_controlled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsControlled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_properties(&self) -> Result<ComPtr<super::super::foundation::collections::IMapView<HString, IInspectable>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Properties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_video_profiles(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<PerceptionVideoProfile>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedVideoProfiles)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_available_video_profiles(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<PerceptionVideoProfile>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AvailableVideoProfiles)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_video_profile(&self) -> Result<ComPtr<PerceptionVideoProfile>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_VideoProfile)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-media")] #[inline] pub unsafe fn get_camera_intrinsics(&self) -> Result<ComPtr<super::super::media::devices::core::CameraIntrinsics>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_CameraIntrinsics)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn acquire_control_session(&self) -> Result<ComPtr<PerceptionControlSession>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).AcquireControlSession)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn can_control_independently_from(&self, targetId: &HStringArg) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).CanControlIndependentlyFrom)(self as *const _ as *mut _, targetId.get(), &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_correlated_with(&self, targetId: &HStringArg) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsCorrelatedWith)(self as *const _ as *mut _, targetId.get(), &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_get_transform_to(&self, targetId: &HStringArg) -> Result<(super::super::foundation::numerics::Matrix4x4, bool)> {
        let mut result = zeroed(); let mut out = zeroed();
        let hr = ((*self.lpVtbl).TryGetTransformTo)(self as *const _ as *mut _, targetId.get(), &mut result, &mut out);
        if hr == S_OK { Ok((result, out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_get_depth_correlated_camera_intrinsics_async(&self, target: &PerceptionDepthFrameSource) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionDepthCorrelatedCameraIntrinsics>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryGetDepthCorrelatedCameraIntrinsicsAsync)(self as *const _ as *mut _, target as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_get_depth_correlated_coordinate_mapper_async(&self, targetId: &HStringArg, depthFrameSourceToMapWith: &PerceptionDepthFrameSource) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionDepthCorrelatedCoordinateMapper>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryGetDepthCorrelatedCoordinateMapperAsync)(self as *const _ as *mut _, targetId.get(), depthFrameSourceToMapWith as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_set_video_profile_async(&self, controlSession: &PerceptionControlSession, profile: &PerceptionVideoProfile) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionFrameSourcePropertyChangeResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TrySetVideoProfileAsync)(self as *const _ as *mut _, controlSession as *const _ as *mut _, profile as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn open_reader(&self) -> Result<ComPtr<PerceptionDepthFrameReader>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).OpenReader)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionDepthFrameReader: IPerceptionDepthFrameReader}
DEFINE_IID!(IID_IPerceptionDepthFrameSource2, 3822206254, 28204, 20077, 145, 217, 112, 76, 216, 223, 247, 157);
RT_INTERFACE!{interface IPerceptionDepthFrameSource2(IPerceptionDepthFrameSource2Vtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionDepthFrameSource2] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl IPerceptionDepthFrameSource2 {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionInfraredFrameSource, 1437632322, 6152, 18766, 158, 48, 157, 42, 123, 232, 247, 0);
RT_INTERFACE!{interface IPerceptionInfraredFrameSource(IPerceptionInfraredFrameSourceVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionInfraredFrameSource] {
    fn add_AvailableChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSource, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_AvailableChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_ActiveChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSource, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ActiveChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_PropertiesChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSource, PerceptionFrameSourcePropertiesChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_PropertiesChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_VideoProfileChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSource, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_VideoProfileChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_CameraIntrinsicsChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSource, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_CameraIntrinsicsChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DisplayName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DeviceKind(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Available(&self, out: *mut bool) -> HRESULT,
    fn get_Active(&self, out: *mut bool) -> HRESULT,
    fn get_IsControlled(&self, out: *mut bool) -> HRESULT,
    fn get_Properties(&self, out: *mut *mut super::super::foundation::collections::IMapView<HString, IInspectable>) -> HRESULT,
    fn get_SupportedVideoProfiles(&self, out: *mut *mut super::super::foundation::collections::IVectorView<PerceptionVideoProfile>) -> HRESULT,
    fn get_AvailableVideoProfiles(&self, out: *mut *mut super::super::foundation::collections::IVectorView<PerceptionVideoProfile>) -> HRESULT,
    fn get_VideoProfile(&self, out: *mut *mut PerceptionVideoProfile) -> HRESULT,
    #[cfg(not(feature="windows-media"))] fn __Dummy20(&self) -> (),
    #[cfg(feature="windows-media")] fn get_CameraIntrinsics(&self, out: *mut *mut super::super::media::devices::core::CameraIntrinsics) -> HRESULT,
    fn AcquireControlSession(&self, out: *mut *mut PerceptionControlSession) -> HRESULT,
    fn CanControlIndependentlyFrom(&self, targetId: HSTRING, out: *mut bool) -> HRESULT,
    fn IsCorrelatedWith(&self, targetId: HSTRING, out: *mut bool) -> HRESULT,
    fn TryGetTransformTo(&self, targetId: HSTRING, result: *mut super::super::foundation::numerics::Matrix4x4, out: *mut bool) -> HRESULT,
    fn TryGetDepthCorrelatedCameraIntrinsicsAsync(&self, target: *mut PerceptionDepthFrameSource, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionDepthCorrelatedCameraIntrinsics>) -> HRESULT,
    fn TryGetDepthCorrelatedCoordinateMapperAsync(&self, targetId: HSTRING, depthFrameSourceToMapWith: *mut PerceptionDepthFrameSource, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionDepthCorrelatedCoordinateMapper>) -> HRESULT,
    fn TrySetVideoProfileAsync(&self, controlSession: *mut PerceptionControlSession, profile: *mut PerceptionVideoProfile, out: *mut *mut super::super::foundation::IAsyncOperation<PerceptionFrameSourcePropertyChangeResult>) -> HRESULT,
    fn OpenReader(&self, out: *mut *mut PerceptionInfraredFrameReader) -> HRESULT
}}
impl IPerceptionInfraredFrameSource {
    #[inline] pub unsafe fn add_available_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSource, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_AvailableChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_available_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_AvailableChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_active_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSource, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ActiveChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_active_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ActiveChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_properties_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSource, PerceptionFrameSourcePropertiesChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_PropertiesChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_properties_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_PropertiesChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_video_profile_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSource, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_VideoProfileChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_video_profile_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_VideoProfileChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_camera_intrinsics_changed(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionInfraredFrameSource, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_CameraIntrinsicsChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_camera_intrinsics_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_CameraIntrinsicsChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_display_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DisplayName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_kind(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceKind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_available(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Available)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_active(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Active)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_controlled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsControlled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_properties(&self) -> Result<ComPtr<super::super::foundation::collections::IMapView<HString, IInspectable>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Properties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_video_profiles(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<PerceptionVideoProfile>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedVideoProfiles)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_available_video_profiles(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<PerceptionVideoProfile>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AvailableVideoProfiles)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_video_profile(&self) -> Result<ComPtr<PerceptionVideoProfile>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_VideoProfile)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-media")] #[inline] pub unsafe fn get_camera_intrinsics(&self) -> Result<ComPtr<super::super::media::devices::core::CameraIntrinsics>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_CameraIntrinsics)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn acquire_control_session(&self) -> Result<ComPtr<PerceptionControlSession>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).AcquireControlSession)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn can_control_independently_from(&self, targetId: &HStringArg) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).CanControlIndependentlyFrom)(self as *const _ as *mut _, targetId.get(), &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_correlated_with(&self, targetId: &HStringArg) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsCorrelatedWith)(self as *const _ as *mut _, targetId.get(), &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_get_transform_to(&self, targetId: &HStringArg) -> Result<(super::super::foundation::numerics::Matrix4x4, bool)> {
        let mut result = zeroed(); let mut out = zeroed();
        let hr = ((*self.lpVtbl).TryGetTransformTo)(self as *const _ as *mut _, targetId.get(), &mut result, &mut out);
        if hr == S_OK { Ok((result, out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_get_depth_correlated_camera_intrinsics_async(&self, target: &PerceptionDepthFrameSource) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionDepthCorrelatedCameraIntrinsics>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryGetDepthCorrelatedCameraIntrinsicsAsync)(self as *const _ as *mut _, target as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_get_depth_correlated_coordinate_mapper_async(&self, targetId: &HStringArg, depthFrameSourceToMapWith: &PerceptionDepthFrameSource) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionDepthCorrelatedCoordinateMapper>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryGetDepthCorrelatedCoordinateMapperAsync)(self as *const _ as *mut _, targetId.get(), depthFrameSourceToMapWith as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_set_video_profile_async(&self, controlSession: &PerceptionControlSession, profile: &PerceptionVideoProfile) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PerceptionFrameSourcePropertyChangeResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TrySetVideoProfileAsync)(self as *const _ as *mut _, controlSession as *const _ as *mut _, profile as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn open_reader(&self) -> Result<ComPtr<PerceptionInfraredFrameReader>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).OpenReader)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionInfraredFrameReader: IPerceptionInfraredFrameReader}
DEFINE_IID!(IID_IPerceptionInfraredFrameSource2, 3704936344, 19211, 17152, 141, 133, 65, 8, 23, 250, 160, 50);
RT_INTERFACE!{interface IPerceptionInfraredFrameSource2(IPerceptionInfraredFrameSource2Vtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionInfraredFrameSource2] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl IPerceptionInfraredFrameSource2 {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionVideoProfile, 1970683555, 282, 18190, 130, 37, 111, 5, 173, 226, 86, 72);
RT_INTERFACE!{interface IPerceptionVideoProfile(IPerceptionVideoProfileVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionVideoProfile] {
    #[cfg(not(feature="windows-graphics"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-graphics")] fn get_BitmapPixelFormat(&self, out: *mut super::super::graphics::imaging::BitmapPixelFormat) -> HRESULT,
    #[cfg(not(feature="windows-graphics"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-graphics")] fn get_BitmapAlphaMode(&self, out: *mut super::super::graphics::imaging::BitmapAlphaMode) -> HRESULT,
    fn get_Width(&self, out: *mut i32) -> HRESULT,
    fn get_Height(&self, out: *mut i32) -> HRESULT,
    fn get_FrameDuration(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn IsEqual(&self, other: *mut PerceptionVideoProfile, out: *mut bool) -> HRESULT
}}
impl IPerceptionVideoProfile {
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn get_bitmap_pixel_format(&self) -> Result<super::super::graphics::imaging::BitmapPixelFormat> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BitmapPixelFormat)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn get_bitmap_alpha_mode(&self) -> Result<super::super::graphics::imaging::BitmapAlphaMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BitmapAlphaMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_width(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Width)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_height(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Height)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_frame_duration(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_FrameDuration)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_equal(&self, other: &PerceptionVideoProfile) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsEqual)(self as *const _ as *mut _, other as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionColorFrameReader, 1985017198, 47605, 17947, 131, 173, 242, 34, 175, 42, 170, 220);
RT_INTERFACE!{interface IPerceptionColorFrameReader(IPerceptionColorFrameReaderVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionColorFrameReader] {
    fn add_FrameArrived(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionColorFrameReader, PerceptionColorFrameArrivedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_FrameArrived(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_Source(&self, out: *mut *mut PerceptionColorFrameSource) -> HRESULT,
    fn get_IsPaused(&self, out: *mut bool) -> HRESULT,
    fn put_IsPaused(&self, value: bool) -> HRESULT,
    fn TryReadLatestFrame(&self, out: *mut *mut PerceptionColorFrame) -> HRESULT
}}
impl IPerceptionColorFrameReader {
    #[inline] pub unsafe fn add_frame_arrived(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionColorFrameReader, PerceptionColorFrameArrivedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_FrameArrived)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_frame_arrived(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_FrameArrived)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_source(&self) -> Result<ComPtr<PerceptionColorFrameSource>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Source)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_paused(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsPaused)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_paused(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsPaused)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_read_latest_frame(&self) -> Result<ComPtr<PerceptionColorFrame>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryReadLatestFrame)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionColorFrameArrivedEventArgs: IPerceptionColorFrameArrivedEventArgs}
RT_CLASS!{class PerceptionColorFrame: IPerceptionColorFrame}
DEFINE_IID!(IID_IPerceptionDepthFrameReader, 2980298911, 10651, 17938, 164, 247, 39, 15, 37, 160, 150, 236);
RT_INTERFACE!{interface IPerceptionDepthFrameReader(IPerceptionDepthFrameReaderVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionDepthFrameReader] {
    fn add_FrameArrived(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionDepthFrameReader, PerceptionDepthFrameArrivedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_FrameArrived(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_Source(&self, out: *mut *mut PerceptionDepthFrameSource) -> HRESULT,
    fn get_IsPaused(&self, out: *mut bool) -> HRESULT,
    fn put_IsPaused(&self, value: bool) -> HRESULT,
    fn TryReadLatestFrame(&self, out: *mut *mut PerceptionDepthFrame) -> HRESULT
}}
impl IPerceptionDepthFrameReader {
    #[inline] pub unsafe fn add_frame_arrived(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionDepthFrameReader, PerceptionDepthFrameArrivedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_FrameArrived)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_frame_arrived(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_FrameArrived)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_source(&self) -> Result<ComPtr<PerceptionDepthFrameSource>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Source)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_paused(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsPaused)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_paused(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsPaused)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_read_latest_frame(&self) -> Result<ComPtr<PerceptionDepthFrame>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryReadLatestFrame)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionDepthFrameArrivedEventArgs: IPerceptionDepthFrameArrivedEventArgs}
RT_CLASS!{class PerceptionDepthFrame: IPerceptionDepthFrame}
DEFINE_IID!(IID_IPerceptionInfraredFrameReader, 2036387352, 54171, 20424, 160, 74, 146, 151, 52, 198, 117, 108);
RT_INTERFACE!{interface IPerceptionInfraredFrameReader(IPerceptionInfraredFrameReaderVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionInfraredFrameReader] {
    fn add_FrameArrived(&self, handler: *mut super::super::foundation::TypedEventHandler<PerceptionInfraredFrameReader, PerceptionInfraredFrameArrivedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_FrameArrived(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_Source(&self, out: *mut *mut PerceptionInfraredFrameSource) -> HRESULT,
    fn get_IsPaused(&self, out: *mut bool) -> HRESULT,
    fn put_IsPaused(&self, value: bool) -> HRESULT,
    fn TryReadLatestFrame(&self, out: *mut *mut PerceptionInfraredFrame) -> HRESULT
}}
impl IPerceptionInfraredFrameReader {
    #[inline] pub unsafe fn add_frame_arrived(&self, handler: &super::super::foundation::TypedEventHandler<PerceptionInfraredFrameReader, PerceptionInfraredFrameArrivedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_FrameArrived)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_frame_arrived(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_FrameArrived)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_source(&self) -> Result<ComPtr<PerceptionInfraredFrameSource>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Source)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_paused(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsPaused)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_paused(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsPaused)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_read_latest_frame(&self) -> Result<ComPtr<PerceptionInfraredFrame>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryReadLatestFrame)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionInfraredFrameArrivedEventArgs: IPerceptionInfraredFrameArrivedEventArgs}
RT_CLASS!{class PerceptionInfraredFrame: IPerceptionInfraredFrame}
DEFINE_IID!(IID_IPerceptionColorFrame, 4267840841, 11455, 20372, 152, 97, 248, 23, 234, 49, 119, 71);
RT_INTERFACE!{interface IPerceptionColorFrame(IPerceptionColorFrameVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionColorFrame] {
    #[cfg(feature="windows-media")] fn get_VideoFrame(&self, out: *mut *mut super::super::media::VideoFrame) -> HRESULT
}}
impl IPerceptionColorFrame {
    #[cfg(feature="windows-media")] #[inline] pub unsafe fn get_video_frame(&self) -> Result<ComPtr<super::super::media::VideoFrame>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_VideoFrame)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionDepthFrame, 2742780412, 39174, 20477, 145, 97, 0, 36, 179, 96, 182, 87);
RT_INTERFACE!{interface IPerceptionDepthFrame(IPerceptionDepthFrameVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionDepthFrame] {
    #[cfg(feature="windows-media")] fn get_VideoFrame(&self, out: *mut *mut super::super::media::VideoFrame) -> HRESULT
}}
impl IPerceptionDepthFrame {
    #[cfg(feature="windows-media")] #[inline] pub unsafe fn get_video_frame(&self) -> Result<ComPtr<super::super::media::VideoFrame>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_VideoFrame)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionInfraredFrame, 2961728118, 33950, 19578, 138, 230, 181, 96, 100, 83, 33, 83);
RT_INTERFACE!{interface IPerceptionInfraredFrame(IPerceptionInfraredFrameVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionInfraredFrame] {
    #[cfg(feature="windows-media")] fn get_VideoFrame(&self, out: *mut *mut super::super::media::VideoFrame) -> HRESULT
}}
impl IPerceptionInfraredFrame {
    #[cfg(feature="windows-media")] #[inline] pub unsafe fn get_video_frame(&self) -> Result<ComPtr<super::super::media::VideoFrame>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_VideoFrame)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionColorFrameArrivedEventArgs, 2410480341, 34551, 19853, 185, 102, 90, 55, 97, 186, 159, 89);
RT_INTERFACE!{interface IPerceptionColorFrameArrivedEventArgs(IPerceptionColorFrameArrivedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionColorFrameArrivedEventArgs] {
    fn get_RelativeTime(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn TryOpenFrame(&self, out: *mut *mut PerceptionColorFrame) -> HRESULT
}}
impl IPerceptionColorFrameArrivedEventArgs {
    #[inline] pub unsafe fn get_relative_time(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RelativeTime)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_open_frame(&self) -> Result<ComPtr<PerceptionColorFrame>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryOpenFrame)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionDepthFrameArrivedEventArgs, 1144858034, 45698, 17975, 145, 115, 172, 151, 132, 53, 201, 133);
RT_INTERFACE!{interface IPerceptionDepthFrameArrivedEventArgs(IPerceptionDepthFrameArrivedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionDepthFrameArrivedEventArgs] {
    fn get_RelativeTime(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn TryOpenFrame(&self, out: *mut *mut PerceptionDepthFrame) -> HRESULT
}}
impl IPerceptionDepthFrameArrivedEventArgs {
    #[inline] pub unsafe fn get_relative_time(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RelativeTime)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_open_frame(&self) -> Result<ComPtr<PerceptionDepthFrame>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryOpenFrame)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionInfraredFrameArrivedEventArgs, 2675440327, 46269, 18519, 157, 80, 190, 142, 240, 117, 218, 239);
RT_INTERFACE!{interface IPerceptionInfraredFrameArrivedEventArgs(IPerceptionInfraredFrameArrivedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionInfraredFrameArrivedEventArgs] {
    fn get_RelativeTime(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn TryOpenFrame(&self, out: *mut *mut PerceptionInfraredFrame) -> HRESULT
}}
impl IPerceptionInfraredFrameArrivedEventArgs {
    #[inline] pub unsafe fn get_relative_time(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RelativeTime)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_open_frame(&self) -> Result<ComPtr<PerceptionInfraredFrame>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryOpenFrame)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionDepthCorrelatedCameraIntrinsics, 1699269121, 34526, 23521, 101, 130, 128, 127, 207, 76, 149, 207);
RT_INTERFACE!{interface IPerceptionDepthCorrelatedCameraIntrinsics(IPerceptionDepthCorrelatedCameraIntrinsicsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionDepthCorrelatedCameraIntrinsics] {
    fn UnprojectPixelAtCorrelatedDepth(&self, pixelCoordinate: super::super::foundation::Point, depthFrame: *mut PerceptionDepthFrame, out: *mut super::super::foundation::numerics::Vector3) -> HRESULT,
    fn UnprojectPixelsAtCorrelatedDepth(&self, sourceCoordinatesSize: u32, sourceCoordinates: *mut super::super::foundation::Point, depthFrame: *mut PerceptionDepthFrame, resultsSize: u32, results: *mut super::super::foundation::numerics::Vector3) -> HRESULT,
    fn UnprojectRegionPixelsAtCorrelatedDepthAsync(&self, region: super::super::foundation::Rect, depthFrame: *mut PerceptionDepthFrame, resultsSize: u32, results: *mut super::super::foundation::numerics::Vector3, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn UnprojectAllPixelsAtCorrelatedDepthAsync(&self, depthFrame: *mut PerceptionDepthFrame, resultsSize: u32, results: *mut super::super::foundation::numerics::Vector3, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT
}}
impl IPerceptionDepthCorrelatedCameraIntrinsics {
    #[inline] pub unsafe fn unproject_pixel_at_correlated_depth(&self, pixelCoordinate: super::super::foundation::Point, depthFrame: &PerceptionDepthFrame) -> Result<super::super::foundation::numerics::Vector3> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).UnprojectPixelAtCorrelatedDepth)(self as *const _ as *mut _, pixelCoordinate, depthFrame as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn unproject_pixels_at_correlated_depth(&self, sourceCoordinates: &[super::super::foundation::Point], depthFrame: &PerceptionDepthFrame, resultsSize: u32, results: *mut super::super::foundation::numerics::Vector3) -> Result<()> {
        let hr = ((*self.lpVtbl).UnprojectPixelsAtCorrelatedDepth)(self as *const _ as *mut _, sourceCoordinates.len() as u32, sourceCoordinates.as_ptr() as *mut _, depthFrame as *const _ as *mut _, resultsSize, results);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn unproject_region_pixels_at_correlated_depth_async(&self, region: super::super::foundation::Rect, depthFrame: &PerceptionDepthFrame, resultsSize: u32, results: *mut super::super::foundation::numerics::Vector3) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).UnprojectRegionPixelsAtCorrelatedDepthAsync)(self as *const _ as *mut _, region, depthFrame as *const _ as *mut _, resultsSize, results, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn unproject_all_pixels_at_correlated_depth_async(&self, depthFrame: &PerceptionDepthFrame, resultsSize: u32, results: *mut super::super::foundation::numerics::Vector3) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).UnprojectAllPixelsAtCorrelatedDepthAsync)(self as *const _ as *mut _, depthFrame as *const _ as *mut _, resultsSize, results, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionDepthCorrelatedCoordinateMapper, 1531813149, 46582, 18076, 184, 194, 185, 122, 69, 230, 134, 59);
RT_INTERFACE!{interface IPerceptionDepthCorrelatedCoordinateMapper(IPerceptionDepthCorrelatedCoordinateMapperVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionDepthCorrelatedCoordinateMapper] {
    fn MapPixelToTarget(&self, sourcePixelCoordinate: super::super::foundation::Point, depthFrame: *mut PerceptionDepthFrame, out: *mut super::super::foundation::Point) -> HRESULT,
    fn MapPixelsToTarget(&self, sourceCoordinatesSize: u32, sourceCoordinates: *mut super::super::foundation::Point, depthFrame: *mut PerceptionDepthFrame, resultsSize: u32, results: *mut super::super::foundation::Point) -> HRESULT,
    fn MapRegionOfPixelsToTargetAsync(&self, region: super::super::foundation::Rect, depthFrame: *mut PerceptionDepthFrame, targetCoordinatesSize: u32, targetCoordinates: *mut super::super::foundation::Point, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn MapAllPixelsToTargetAsync(&self, depthFrame: *mut PerceptionDepthFrame, targetCoordinatesSize: u32, targetCoordinates: *mut super::super::foundation::Point, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT
}}
impl IPerceptionDepthCorrelatedCoordinateMapper {
    #[inline] pub unsafe fn map_pixel_to_target(&self, sourcePixelCoordinate: super::super::foundation::Point, depthFrame: &PerceptionDepthFrame) -> Result<super::super::foundation::Point> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).MapPixelToTarget)(self as *const _ as *mut _, sourcePixelCoordinate, depthFrame as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn map_pixels_to_target(&self, sourceCoordinates: &[super::super::foundation::Point], depthFrame: &PerceptionDepthFrame, resultsSize: u32, results: *mut super::super::foundation::Point) -> Result<()> {
        let hr = ((*self.lpVtbl).MapPixelsToTarget)(self as *const _ as *mut _, sourceCoordinates.len() as u32, sourceCoordinates.as_ptr() as *mut _, depthFrame as *const _ as *mut _, resultsSize, results);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn map_region_of_pixels_to_target_async(&self, region: super::super::foundation::Rect, depthFrame: &PerceptionDepthFrame, targetCoordinatesSize: u32, targetCoordinates: *mut super::super::foundation::Point) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).MapRegionOfPixelsToTargetAsync)(self as *const _ as *mut _, region, depthFrame as *const _ as *mut _, targetCoordinatesSize, targetCoordinates, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn map_all_pixels_to_target_async(&self, depthFrame: &PerceptionDepthFrame, targetCoordinatesSize: u32, targetCoordinates: *mut super::super::foundation::Point) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).MapAllPixelsToTargetAsync)(self as *const _ as *mut _, depthFrame as *const _ as *mut _, targetCoordinatesSize, targetCoordinates, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{static class KnownPerceptionFrameSourceProperties}
impl RtActivatable<IKnownPerceptionFrameSourcePropertiesStatics> for KnownPerceptionFrameSourceProperties {}
impl RtActivatable<IKnownPerceptionFrameSourcePropertiesStatics2> for KnownPerceptionFrameSourceProperties {}
impl KnownPerceptionFrameSourceProperties {
    #[inline] pub fn get_id() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionFrameSourcePropertiesStatics>>::get_activation_factory().get_id()
    }}
    #[inline] pub fn get_physical_device_ids() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionFrameSourcePropertiesStatics>>::get_activation_factory().get_physical_device_ids()
    }}
    #[inline] pub fn get_frame_kind() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionFrameSourcePropertiesStatics>>::get_activation_factory().get_frame_kind()
    }}
    #[inline] pub fn get_device_model_version() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionFrameSourcePropertiesStatics>>::get_activation_factory().get_device_model_version()
    }}
    #[inline] pub fn get_enclosure_location() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionFrameSourcePropertiesStatics>>::get_activation_factory().get_enclosure_location()
    }}
    #[inline] pub fn get_device_id() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionFrameSourcePropertiesStatics2>>::get_activation_factory().get_device_id()
    }}
}
DEFINE_CLSID!(KnownPerceptionFrameSourceProperties(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,75,110,111,119,110,80,101,114,99,101,112,116,105,111,110,70,114,97,109,101,83,111,117,114,99,101,80,114,111,112,101,114,116,105,101,115,0]) [CLSID_KnownPerceptionFrameSourceProperties]);
RT_CLASS!{static class KnownPerceptionVideoFrameSourceProperties}
impl RtActivatable<IKnownPerceptionVideoFrameSourcePropertiesStatics> for KnownPerceptionVideoFrameSourceProperties {}
impl KnownPerceptionVideoFrameSourceProperties {
    #[inline] pub fn get_video_profile() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionVideoFrameSourcePropertiesStatics>>::get_activation_factory().get_video_profile()
    }}
    #[inline] pub fn get_supported_video_profiles() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionVideoFrameSourcePropertiesStatics>>::get_activation_factory().get_supported_video_profiles()
    }}
    #[inline] pub fn get_available_video_profiles() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionVideoFrameSourcePropertiesStatics>>::get_activation_factory().get_available_video_profiles()
    }}
    #[inline] pub fn get_is_mirrored() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionVideoFrameSourcePropertiesStatics>>::get_activation_factory().get_is_mirrored()
    }}
    #[inline] pub fn get_camera_intrinsics() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionVideoFrameSourcePropertiesStatics>>::get_activation_factory().get_camera_intrinsics()
    }}
}
DEFINE_CLSID!(KnownPerceptionVideoFrameSourceProperties(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,75,110,111,119,110,80,101,114,99,101,112,116,105,111,110,86,105,100,101,111,70,114,97,109,101,83,111,117,114,99,101,80,114,111,112,101,114,116,105,101,115,0]) [CLSID_KnownPerceptionVideoFrameSourceProperties]);
RT_CLASS!{static class KnownPerceptionInfraredFrameSourceProperties}
impl RtActivatable<IKnownPerceptionInfraredFrameSourcePropertiesStatics> for KnownPerceptionInfraredFrameSourceProperties {}
impl KnownPerceptionInfraredFrameSourceProperties {
    #[inline] pub fn get_exposure() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionInfraredFrameSourcePropertiesStatics>>::get_activation_factory().get_exposure()
    }}
    #[inline] pub fn get_auto_exposure_enabled() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionInfraredFrameSourcePropertiesStatics>>::get_activation_factory().get_auto_exposure_enabled()
    }}
    #[inline] pub fn get_exposure_compensation() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionInfraredFrameSourcePropertiesStatics>>::get_activation_factory().get_exposure_compensation()
    }}
    #[inline] pub fn get_active_illumination_enabled() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionInfraredFrameSourcePropertiesStatics>>::get_activation_factory().get_active_illumination_enabled()
    }}
    #[inline] pub fn get_ambient_subtraction_enabled() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionInfraredFrameSourcePropertiesStatics>>::get_activation_factory().get_ambient_subtraction_enabled()
    }}
    #[inline] pub fn get_structure_light_pattern_enabled() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionInfraredFrameSourcePropertiesStatics>>::get_activation_factory().get_structure_light_pattern_enabled()
    }}
    #[inline] pub fn get_interleaved_illumination_enabled() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionInfraredFrameSourcePropertiesStatics>>::get_activation_factory().get_interleaved_illumination_enabled()
    }}
}
DEFINE_CLSID!(KnownPerceptionInfraredFrameSourceProperties(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,75,110,111,119,110,80,101,114,99,101,112,116,105,111,110,73,110,102,114,97,114,101,100,70,114,97,109,101,83,111,117,114,99,101,80,114,111,112,101,114,116,105,101,115,0]) [CLSID_KnownPerceptionInfraredFrameSourceProperties]);
RT_CLASS!{static class KnownPerceptionDepthFrameSourceProperties}
impl RtActivatable<IKnownPerceptionDepthFrameSourcePropertiesStatics> for KnownPerceptionDepthFrameSourceProperties {}
impl KnownPerceptionDepthFrameSourceProperties {
    #[inline] pub fn get_min_depth() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionDepthFrameSourcePropertiesStatics>>::get_activation_factory().get_min_depth()
    }}
    #[inline] pub fn get_max_depth() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionDepthFrameSourcePropertiesStatics>>::get_activation_factory().get_max_depth()
    }}
}
DEFINE_CLSID!(KnownPerceptionDepthFrameSourceProperties(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,75,110,111,119,110,80,101,114,99,101,112,116,105,111,110,68,101,112,116,104,70,114,97,109,101,83,111,117,114,99,101,80,114,111,112,101,114,116,105,101,115,0]) [CLSID_KnownPerceptionDepthFrameSourceProperties]);
RT_CLASS!{static class KnownPerceptionColorFrameSourceProperties}
impl RtActivatable<IKnownPerceptionColorFrameSourcePropertiesStatics> for KnownPerceptionColorFrameSourceProperties {}
impl KnownPerceptionColorFrameSourceProperties {
    #[inline] pub fn get_exposure() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionColorFrameSourcePropertiesStatics>>::get_activation_factory().get_exposure()
    }}
    #[inline] pub fn get_auto_exposure_enabled() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionColorFrameSourcePropertiesStatics>>::get_activation_factory().get_auto_exposure_enabled()
    }}
    #[inline] pub fn get_exposure_compensation() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionColorFrameSourcePropertiesStatics>>::get_activation_factory().get_exposure_compensation()
    }}
}
DEFINE_CLSID!(KnownPerceptionColorFrameSourceProperties(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,75,110,111,119,110,80,101,114,99,101,112,116,105,111,110,67,111,108,111,114,70,114,97,109,101,83,111,117,114,99,101,80,114,111,112,101,114,116,105,101,115,0]) [CLSID_KnownPerceptionColorFrameSourceProperties]);
RT_CLASS!{static class KnownPerceptionVideoProfileProperties}
impl RtActivatable<IKnownPerceptionVideoProfilePropertiesStatics> for KnownPerceptionVideoProfileProperties {}
impl KnownPerceptionVideoProfileProperties {
    #[inline] pub fn get_bitmap_pixel_format() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionVideoProfilePropertiesStatics>>::get_activation_factory().get_bitmap_pixel_format()
    }}
    #[inline] pub fn get_bitmap_alpha_mode() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionVideoProfilePropertiesStatics>>::get_activation_factory().get_bitmap_alpha_mode()
    }}
    #[inline] pub fn get_width() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionVideoProfilePropertiesStatics>>::get_activation_factory().get_width()
    }}
    #[inline] pub fn get_height() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionVideoProfilePropertiesStatics>>::get_activation_factory().get_height()
    }}
    #[inline] pub fn get_frame_duration() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionVideoProfilePropertiesStatics>>::get_activation_factory().get_frame_duration()
    }}
}
DEFINE_CLSID!(KnownPerceptionVideoProfileProperties(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,75,110,111,119,110,80,101,114,99,101,112,116,105,111,110,86,105,100,101,111,80,114,111,102,105,108,101,80,114,111,112,101,114,116,105,101,115,0]) [CLSID_KnownPerceptionVideoProfileProperties]);
RT_CLASS!{static class KnownCameraIntrinsicsProperties}
impl RtActivatable<IKnownCameraIntrinsicsPropertiesStatics> for KnownCameraIntrinsicsProperties {}
impl KnownCameraIntrinsicsProperties {
    #[inline] pub fn get_focal_length() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownCameraIntrinsicsPropertiesStatics>>::get_activation_factory().get_focal_length()
    }}
    #[inline] pub fn get_principal_point() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownCameraIntrinsicsPropertiesStatics>>::get_activation_factory().get_principal_point()
    }}
    #[inline] pub fn get_radial_distortion() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownCameraIntrinsicsPropertiesStatics>>::get_activation_factory().get_radial_distortion()
    }}
    #[inline] pub fn get_tangential_distortion() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownCameraIntrinsicsPropertiesStatics>>::get_activation_factory().get_tangential_distortion()
    }}
}
DEFINE_CLSID!(KnownCameraIntrinsicsProperties(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,75,110,111,119,110,67,97,109,101,114,97,73,110,116,114,105,110,115,105,99,115,80,114,111,112,101,114,116,105,101,115,0]) [CLSID_KnownCameraIntrinsicsProperties]);
pub mod provider { // Windows.Devices.Perception.Provider
use ::prelude::*;
DEFINE_IID!(IID_IKnownPerceptionFrameKindStatics, 988172758, 38505, 16646, 159, 174, 72, 53, 193, 185, 97, 4);
RT_INTERFACE!{static interface IKnownPerceptionFrameKindStatics(IKnownPerceptionFrameKindStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IKnownPerceptionFrameKindStatics] {
    fn get_Color(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Depth(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Infrared(&self, out: *mut HSTRING) -> HRESULT
}}
impl IKnownPerceptionFrameKindStatics {
    #[inline] pub unsafe fn get_color(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Color)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_depth(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Depth)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_infrared(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Infrared)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionFrameProviderManagerServiceStatics, 2927855334, 51929, 17241, 143, 150, 142, 174, 81, 129, 5, 38);
RT_INTERFACE!{static interface IPerceptionFrameProviderManagerServiceStatics(IPerceptionFrameProviderManagerServiceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionFrameProviderManagerServiceStatics] {
    fn RegisterFrameProviderInfo(&self, manager: *mut IPerceptionFrameProviderManager, frameProviderInfo: *mut PerceptionFrameProviderInfo) -> HRESULT,
    fn UnregisterFrameProviderInfo(&self, manager: *mut IPerceptionFrameProviderManager, frameProviderInfo: *mut PerceptionFrameProviderInfo) -> HRESULT,
    fn RegisterFaceAuthenticationGroup(&self, manager: *mut IPerceptionFrameProviderManager, faceAuthenticationGroup: *mut PerceptionFaceAuthenticationGroup) -> HRESULT,
    fn UnregisterFaceAuthenticationGroup(&self, manager: *mut IPerceptionFrameProviderManager, faceAuthenticationGroup: *mut PerceptionFaceAuthenticationGroup) -> HRESULT,
    fn RegisterControlGroup(&self, manager: *mut IPerceptionFrameProviderManager, controlGroup: *mut PerceptionControlGroup) -> HRESULT,
    fn UnregisterControlGroup(&self, manager: *mut IPerceptionFrameProviderManager, controlGroup: *mut PerceptionControlGroup) -> HRESULT,
    fn RegisterCorrelationGroup(&self, manager: *mut IPerceptionFrameProviderManager, correlationGroup: *mut PerceptionCorrelationGroup) -> HRESULT,
    fn UnregisterCorrelationGroup(&self, manager: *mut IPerceptionFrameProviderManager, correlationGroup: *mut PerceptionCorrelationGroup) -> HRESULT,
    fn UpdateAvailabilityForProvider(&self, provider: *mut IPerceptionFrameProvider, available: bool) -> HRESULT,
    fn PublishFrameForProvider(&self, provider: *mut IPerceptionFrameProvider, frame: *mut PerceptionFrame) -> HRESULT
}}
impl IPerceptionFrameProviderManagerServiceStatics {
    #[inline] pub unsafe fn register_frame_provider_info(&self, manager: &IPerceptionFrameProviderManager, frameProviderInfo: &PerceptionFrameProviderInfo) -> Result<()> {
        let hr = ((*self.lpVtbl).RegisterFrameProviderInfo)(self as *const _ as *mut _, manager as *const _ as *mut _, frameProviderInfo as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn unregister_frame_provider_info(&self, manager: &IPerceptionFrameProviderManager, frameProviderInfo: &PerceptionFrameProviderInfo) -> Result<()> {
        let hr = ((*self.lpVtbl).UnregisterFrameProviderInfo)(self as *const _ as *mut _, manager as *const _ as *mut _, frameProviderInfo as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn register_face_authentication_group(&self, manager: &IPerceptionFrameProviderManager, faceAuthenticationGroup: &PerceptionFaceAuthenticationGroup) -> Result<()> {
        let hr = ((*self.lpVtbl).RegisterFaceAuthenticationGroup)(self as *const _ as *mut _, manager as *const _ as *mut _, faceAuthenticationGroup as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn unregister_face_authentication_group(&self, manager: &IPerceptionFrameProviderManager, faceAuthenticationGroup: &PerceptionFaceAuthenticationGroup) -> Result<()> {
        let hr = ((*self.lpVtbl).UnregisterFaceAuthenticationGroup)(self as *const _ as *mut _, manager as *const _ as *mut _, faceAuthenticationGroup as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn register_control_group(&self, manager: &IPerceptionFrameProviderManager, controlGroup: &PerceptionControlGroup) -> Result<()> {
        let hr = ((*self.lpVtbl).RegisterControlGroup)(self as *const _ as *mut _, manager as *const _ as *mut _, controlGroup as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn unregister_control_group(&self, manager: &IPerceptionFrameProviderManager, controlGroup: &PerceptionControlGroup) -> Result<()> {
        let hr = ((*self.lpVtbl).UnregisterControlGroup)(self as *const _ as *mut _, manager as *const _ as *mut _, controlGroup as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn register_correlation_group(&self, manager: &IPerceptionFrameProviderManager, correlationGroup: &PerceptionCorrelationGroup) -> Result<()> {
        let hr = ((*self.lpVtbl).RegisterCorrelationGroup)(self as *const _ as *mut _, manager as *const _ as *mut _, correlationGroup as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn unregister_correlation_group(&self, manager: &IPerceptionFrameProviderManager, correlationGroup: &PerceptionCorrelationGroup) -> Result<()> {
        let hr = ((*self.lpVtbl).UnregisterCorrelationGroup)(self as *const _ as *mut _, manager as *const _ as *mut _, correlationGroup as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn update_availability_for_provider(&self, provider: &IPerceptionFrameProvider, available: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).UpdateAvailabilityForProvider)(self as *const _ as *mut _, provider as *const _ as *mut _, available);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn publish_frame_for_provider(&self, provider: &IPerceptionFrameProvider, frame: &PerceptionFrame) -> Result<()> {
        let hr = ((*self.lpVtbl).PublishFrameForProvider)(self as *const _ as *mut _, provider as *const _ as *mut _, frame as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionFrameProviderManager, 2841234951, 60115, 13279, 142, 193, 185, 36, 171, 224, 25, 196);
RT_INTERFACE!{interface IPerceptionFrameProviderManager(IPerceptionFrameProviderManagerVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionFrameProviderManager] {
    fn GetFrameProvider(&self, frameProviderInfo: *mut PerceptionFrameProviderInfo, out: *mut *mut IPerceptionFrameProvider) -> HRESULT
}}
impl IPerceptionFrameProviderManager {
    #[inline] pub unsafe fn get_frame_provider(&self, frameProviderInfo: &PerceptionFrameProviderInfo) -> Result<ComPtr<IPerceptionFrameProvider>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetFrameProvider)(self as *const _ as *mut _, frameProviderInfo as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionFrameProviderInfo: IPerceptionFrameProviderInfo}
impl RtActivatable<IActivationFactory> for PerceptionFrameProviderInfo {}
DEFINE_CLSID!(PerceptionFrameProviderInfo(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,80,114,111,118,105,100,101,114,46,80,101,114,99,101,112,116,105,111,110,70,114,97,109,101,80,114,111,118,105,100,101,114,73,110,102,111,0]) [CLSID_PerceptionFrameProviderInfo]);
DEFINE_IID!(IID_IPerceptionFrameProvider, 2035251897, 45949, 15155, 161, 13, 48, 98, 100, 25, 206, 101);
RT_INTERFACE!{interface IPerceptionFrameProvider(IPerceptionFrameProviderVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionFrameProvider] {
    fn get_FrameProviderInfo(&self, out: *mut *mut PerceptionFrameProviderInfo) -> HRESULT,
    fn get_Available(&self, out: *mut bool) -> HRESULT,
    fn get_Properties(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IPropertySet) -> HRESULT,
    fn Start(&self) -> HRESULT,
    fn Stop(&self) -> HRESULT,
    fn SetProperty(&self, value: *mut PerceptionPropertyChangeRequest) -> HRESULT
}}
impl IPerceptionFrameProvider {
    #[inline] pub unsafe fn get_frame_provider_info(&self) -> Result<ComPtr<PerceptionFrameProviderInfo>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FrameProviderInfo)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_available(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Available)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_properties(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IPropertySet>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Properties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Stop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_property(&self, value: &PerceptionPropertyChangeRequest) -> Result<()> {
        let hr = ((*self.lpVtbl).SetProperty)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionPropertyChangeRequest: IPerceptionPropertyChangeRequest}
RT_CLASS!{class PerceptionFaceAuthenticationGroup: IPerceptionFaceAuthenticationGroup}
impl RtActivatable<IPerceptionFaceAuthenticationGroupFactory> for PerceptionFaceAuthenticationGroup {}
impl PerceptionFaceAuthenticationGroup {
    #[inline] pub fn create(ids: &::rt::gen::windows::foundation::collections::IIterable<HString>, startHandler: &PerceptionStartFaceAuthenticationHandler, stopHandler: &PerceptionStopFaceAuthenticationHandler) -> Result<ComPtr<PerceptionFaceAuthenticationGroup>> { unsafe {
        <Self as RtActivatable<IPerceptionFaceAuthenticationGroupFactory>>::get_activation_factory().create(ids, startHandler, stopHandler)
    }}
}
DEFINE_CLSID!(PerceptionFaceAuthenticationGroup(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,80,114,111,118,105,100,101,114,46,80,101,114,99,101,112,116,105,111,110,70,97,99,101,65,117,116,104,101,110,116,105,99,97,116,105,111,110,71,114,111,117,112,0]) [CLSID_PerceptionFaceAuthenticationGroup]);
RT_CLASS!{class PerceptionControlGroup: IPerceptionControlGroup}
impl RtActivatable<IPerceptionControlGroupFactory> for PerceptionControlGroup {}
impl PerceptionControlGroup {
    #[inline] pub fn create(ids: &::rt::gen::windows::foundation::collections::IIterable<HString>) -> Result<ComPtr<PerceptionControlGroup>> { unsafe {
        <Self as RtActivatable<IPerceptionControlGroupFactory>>::get_activation_factory().create(ids)
    }}
}
DEFINE_CLSID!(PerceptionControlGroup(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,80,114,111,118,105,100,101,114,46,80,101,114,99,101,112,116,105,111,110,67,111,110,116,114,111,108,71,114,111,117,112,0]) [CLSID_PerceptionControlGroup]);
RT_CLASS!{class PerceptionCorrelationGroup: IPerceptionCorrelationGroup}
impl RtActivatable<IPerceptionCorrelationGroupFactory> for PerceptionCorrelationGroup {}
impl PerceptionCorrelationGroup {
    #[inline] pub fn create(relativeLocations: &::rt::gen::windows::foundation::collections::IIterable<PerceptionCorrelation>) -> Result<ComPtr<PerceptionCorrelationGroup>> { unsafe {
        <Self as RtActivatable<IPerceptionCorrelationGroupFactory>>::get_activation_factory().create(relativeLocations)
    }}
}
DEFINE_CLSID!(PerceptionCorrelationGroup(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,80,114,111,118,105,100,101,114,46,80,101,114,99,101,112,116,105,111,110,67,111,114,114,101,108,97,116,105,111,110,71,114,111,117,112,0]) [CLSID_PerceptionCorrelationGroup]);
RT_CLASS!{class PerceptionFrame: IPerceptionFrame}
DEFINE_IID!(IID_IPerceptionFrameProviderInfo, 3433650664, 31102, 20099, 155, 135, 3, 106, 116, 20, 47, 196);
RT_INTERFACE!{interface IPerceptionFrameProviderInfo(IPerceptionFrameProviderInfoVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionFrameProviderInfo] {
    fn get_Id(&self, out: *mut HSTRING) -> HRESULT,
    fn put_Id(&self, value: HSTRING) -> HRESULT,
    fn get_DisplayName(&self, out: *mut HSTRING) -> HRESULT,
    fn put_DisplayName(&self, value: HSTRING) -> HRESULT,
    fn get_DeviceKind(&self, out: *mut HSTRING) -> HRESULT,
    fn put_DeviceKind(&self, value: HSTRING) -> HRESULT,
    fn get_FrameKind(&self, out: *mut HSTRING) -> HRESULT,
    fn put_FrameKind(&self, value: HSTRING) -> HRESULT,
    fn get_Hidden(&self, out: *mut bool) -> HRESULT,
    fn put_Hidden(&self, value: bool) -> HRESULT
}}
impl IPerceptionFrameProviderInfo {
    #[inline] pub unsafe fn get_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Id)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_id(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Id)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_display_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DisplayName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_display_name(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DisplayName)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_kind(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceKind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_device_kind(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DeviceKind)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_frame_kind(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FrameKind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_frame_kind(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_FrameKind)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_hidden(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Hidden)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_hidden(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Hidden)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionControlGroupFactory, 790295264, 47857, 17723, 190, 212, 205, 157, 70, 25, 21, 76);
RT_INTERFACE!{static interface IPerceptionControlGroupFactory(IPerceptionControlGroupFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionControlGroupFactory] {
    fn Create(&self, ids: *mut ::rt::gen::windows::foundation::collections::IIterable<HString>, out: *mut *mut PerceptionControlGroup) -> HRESULT
}}
impl IPerceptionControlGroupFactory {
    #[inline] pub unsafe fn create(&self, ids: &::rt::gen::windows::foundation::collections::IIterable<HString>) -> Result<ComPtr<PerceptionControlGroup>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, ids as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionControlGroup, 388778114, 12249, 19534, 186, 52, 253, 242, 10, 115, 221, 229);
RT_INTERFACE!{interface IPerceptionControlGroup(IPerceptionControlGroupVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionControlGroup] {
    fn get_FrameProviderIds(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<HString>) -> HRESULT
}}
impl IPerceptionControlGroup {
    #[inline] pub unsafe fn get_frame_provider_ids(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FrameProviderIds)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_PerceptionStartFaceAuthenticationHandler, 1954639146, 8336, 18032, 140, 72, 239, 57, 231, 255, 124, 38);
RT_DELEGATE!{delegate PerceptionStartFaceAuthenticationHandler(PerceptionStartFaceAuthenticationHandlerVtbl, PerceptionStartFaceAuthenticationHandlerImpl) [IID_PerceptionStartFaceAuthenticationHandler] {
    fn Invoke(&self, sender: *mut PerceptionFaceAuthenticationGroup, out: *mut bool) -> HRESULT
}}
impl PerceptionStartFaceAuthenticationHandler {
    #[inline] pub unsafe fn invoke(&self, sender: &PerceptionFaceAuthenticationGroup) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).Invoke)(self as *const _ as *mut _, sender as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_PerceptionStopFaceAuthenticationHandler, 947840682, 35277, 18462, 170, 222, 221, 146, 247, 11, 42, 215);
RT_DELEGATE!{delegate PerceptionStopFaceAuthenticationHandler(PerceptionStopFaceAuthenticationHandlerVtbl, PerceptionStopFaceAuthenticationHandlerImpl) [IID_PerceptionStopFaceAuthenticationHandler] {
    fn Invoke(&self, sender: *mut PerceptionFaceAuthenticationGroup) -> HRESULT
}}
impl PerceptionStopFaceAuthenticationHandler {
    #[inline] pub unsafe fn invoke(&self, sender: &PerceptionFaceAuthenticationGroup) -> Result<()> {
        let hr = ((*self.lpVtbl).Invoke)(self as *const _ as *mut _, sender as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionFaceAuthenticationGroupFactory, 3867805140, 46604, 16628, 188, 185, 242, 77, 70, 70, 115, 32);
RT_INTERFACE!{static interface IPerceptionFaceAuthenticationGroupFactory(IPerceptionFaceAuthenticationGroupFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionFaceAuthenticationGroupFactory] {
    fn Create(&self, ids: *mut ::rt::gen::windows::foundation::collections::IIterable<HString>, startHandler: *mut PerceptionStartFaceAuthenticationHandler, stopHandler: *mut PerceptionStopFaceAuthenticationHandler, out: *mut *mut PerceptionFaceAuthenticationGroup) -> HRESULT
}}
impl IPerceptionFaceAuthenticationGroupFactory {
    #[inline] pub unsafe fn create(&self, ids: &::rt::gen::windows::foundation::collections::IIterable<HString>, startHandler: &PerceptionStartFaceAuthenticationHandler, stopHandler: &PerceptionStopFaceAuthenticationHandler) -> Result<ComPtr<PerceptionFaceAuthenticationGroup>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, ids as *const _ as *mut _, startHandler as *const _ as *mut _, stopHandler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionFaceAuthenticationGroup, 3892418580, 19089, 16816, 131, 166, 136, 26, 23, 117, 53, 62);
RT_INTERFACE!{interface IPerceptionFaceAuthenticationGroup(IPerceptionFaceAuthenticationGroupVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionFaceAuthenticationGroup] {
    fn get_FrameProviderIds(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<HString>) -> HRESULT
}}
impl IPerceptionFaceAuthenticationGroup {
    #[inline] pub unsafe fn get_frame_provider_ids(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FrameProviderIds)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionCorrelationFactory, 3567698981, 10372, 19087, 129, 52, 40, 53, 215, 40, 108, 191);
RT_INTERFACE!{static interface IPerceptionCorrelationFactory(IPerceptionCorrelationFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionCorrelationFactory] {
    fn Create(&self, targetId: HSTRING, position: ::rt::gen::windows::foundation::numerics::Vector3, orientation: ::rt::gen::windows::foundation::numerics::Quaternion, out: *mut *mut PerceptionCorrelation) -> HRESULT
}}
impl IPerceptionCorrelationFactory {
    #[inline] pub unsafe fn create(&self, targetId: &HStringArg, position: ::rt::gen::windows::foundation::numerics::Vector3, orientation: ::rt::gen::windows::foundation::numerics::Quaternion) -> Result<ComPtr<PerceptionCorrelation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, targetId.get(), position, orientation, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionCorrelation: IPerceptionCorrelation}
impl RtActivatable<IPerceptionCorrelationFactory> for PerceptionCorrelation {}
impl PerceptionCorrelation {
    #[inline] pub fn create(targetId: &HStringArg, position: ::rt::gen::windows::foundation::numerics::Vector3, orientation: ::rt::gen::windows::foundation::numerics::Quaternion) -> Result<ComPtr<PerceptionCorrelation>> { unsafe {
        <Self as RtActivatable<IPerceptionCorrelationFactory>>::get_activation_factory().create(targetId, position, orientation)
    }}
}
DEFINE_CLSID!(PerceptionCorrelation(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,80,114,111,118,105,100,101,114,46,80,101,114,99,101,112,116,105,111,110,67,111,114,114,101,108,97,116,105,111,110,0]) [CLSID_PerceptionCorrelation]);
DEFINE_IID!(IID_IPerceptionCorrelation, 3021150850, 57333, 16455, 138, 25, 59, 77, 128, 95, 113, 118);
RT_INTERFACE!{interface IPerceptionCorrelation(IPerceptionCorrelationVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionCorrelation] {
    fn get_TargetId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Position(&self, out: *mut ::rt::gen::windows::foundation::numerics::Vector3) -> HRESULT,
    fn get_Orientation(&self, out: *mut ::rt::gen::windows::foundation::numerics::Quaternion) -> HRESULT
}}
impl IPerceptionCorrelation {
    #[inline] pub unsafe fn get_target_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_TargetId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_position(&self) -> Result<::rt::gen::windows::foundation::numerics::Vector3> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Position)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_orientation(&self) -> Result<::rt::gen::windows::foundation::numerics::Quaternion> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Orientation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionCorrelationGroupFactory, 2113806472, 25567, 18669, 131, 177, 74, 184, 41, 19, 41, 149);
RT_INTERFACE!{static interface IPerceptionCorrelationGroupFactory(IPerceptionCorrelationGroupFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionCorrelationGroupFactory] {
    fn Create(&self, relativeLocations: *mut ::rt::gen::windows::foundation::collections::IIterable<PerceptionCorrelation>, out: *mut *mut PerceptionCorrelationGroup) -> HRESULT
}}
impl IPerceptionCorrelationGroupFactory {
    #[inline] pub unsafe fn create(&self, relativeLocations: &::rt::gen::windows::foundation::collections::IIterable<PerceptionCorrelation>) -> Result<ComPtr<PerceptionCorrelationGroup>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, relativeLocations as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionCorrelationGroup, 1965689094, 13991, 18363, 155, 121, 86, 204, 107, 116, 103, 112);
RT_INTERFACE!{interface IPerceptionCorrelationGroup(IPerceptionCorrelationGroupVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionCorrelationGroup] {
    fn get_RelativeLocations(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<PerceptionCorrelation>) -> HRESULT
}}
impl IPerceptionCorrelationGroup {
    #[inline] pub unsafe fn get_relative_locations(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<PerceptionCorrelation>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_RelativeLocations)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionFrame, 2097051685, 21691, 19869, 190, 197, 142, 246, 97, 81, 210, 172);
RT_INTERFACE!{interface IPerceptionFrame(IPerceptionFrameVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionFrame] {
    fn get_RelativeTime(&self, out: *mut ::rt::gen::windows::foundation::TimeSpan) -> HRESULT,
    fn put_RelativeTime(&self, value: ::rt::gen::windows::foundation::TimeSpan) -> HRESULT,
    fn get_Properties(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::ValueSet) -> HRESULT,
    fn get_FrameData(&self, out: *mut *mut ::rt::gen::windows::foundation::IMemoryBuffer) -> HRESULT
}}
impl IPerceptionFrame {
    #[inline] pub unsafe fn get_relative_time(&self) -> Result<::rt::gen::windows::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RelativeTime)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_relative_time(&self, value: ::rt::gen::windows::foundation::TimeSpan) -> Result<()> {
        let hr = ((*self.lpVtbl).put_RelativeTime)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_properties(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::ValueSet>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Properties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_frame_data(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IMemoryBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FrameData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionVideoFrameAllocatorFactory, 442020065, 59674, 18462, 184, 118, 168, 158, 43, 188, 107, 51);
RT_INTERFACE!{static interface IPerceptionVideoFrameAllocatorFactory(IPerceptionVideoFrameAllocatorFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionVideoFrameAllocatorFactory] {
    #[cfg(feature="windows-graphics")] fn Create(&self, maxOutstandingFrameCountForWrite: u32, format: ::rt::gen::windows::graphics::imaging::BitmapPixelFormat, resolution: ::rt::gen::windows::foundation::Size, alpha: ::rt::gen::windows::graphics::imaging::BitmapAlphaMode, out: *mut *mut PerceptionVideoFrameAllocator) -> HRESULT
}}
impl IPerceptionVideoFrameAllocatorFactory {
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn create(&self, maxOutstandingFrameCountForWrite: u32, format: ::rt::gen::windows::graphics::imaging::BitmapPixelFormat, resolution: ::rt::gen::windows::foundation::Size, alpha: ::rt::gen::windows::graphics::imaging::BitmapAlphaMode) -> Result<ComPtr<PerceptionVideoFrameAllocator>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, maxOutstandingFrameCountForWrite, format, resolution, alpha, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PerceptionVideoFrameAllocator: IPerceptionVideoFrameAllocator}
impl RtActivatable<IPerceptionVideoFrameAllocatorFactory> for PerceptionVideoFrameAllocator {}
impl PerceptionVideoFrameAllocator {
    #[cfg(feature="windows-graphics")] #[inline] pub fn create(maxOutstandingFrameCountForWrite: u32, format: ::rt::gen::windows::graphics::imaging::BitmapPixelFormat, resolution: ::rt::gen::windows::foundation::Size, alpha: ::rt::gen::windows::graphics::imaging::BitmapAlphaMode) -> Result<ComPtr<PerceptionVideoFrameAllocator>> { unsafe {
        <Self as RtActivatable<IPerceptionVideoFrameAllocatorFactory>>::get_activation_factory().create(maxOutstandingFrameCountForWrite, format, resolution, alpha)
    }}
}
DEFINE_CLSID!(PerceptionVideoFrameAllocator(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,80,114,111,118,105,100,101,114,46,80,101,114,99,101,112,116,105,111,110,86,105,100,101,111,70,114,97,109,101,65,108,108,111,99,97,116,111,114,0]) [CLSID_PerceptionVideoFrameAllocator]);
DEFINE_IID!(IID_IPerceptionVideoFrameAllocator, 1278781402, 64984, 20180, 160, 57, 42, 111, 155, 35, 80, 56);
RT_INTERFACE!{interface IPerceptionVideoFrameAllocator(IPerceptionVideoFrameAllocatorVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionVideoFrameAllocator] {
    fn AllocateFrame(&self, out: *mut *mut PerceptionFrame) -> HRESULT,
    #[cfg(feature="windows-media")] fn CopyFromVideoFrame(&self, frame: *mut ::rt::gen::windows::media::VideoFrame, out: *mut *mut PerceptionFrame) -> HRESULT
}}
impl IPerceptionVideoFrameAllocator {
    #[inline] pub unsafe fn allocate_frame(&self) -> Result<ComPtr<PerceptionFrame>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).AllocateFrame)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-media")] #[inline] pub unsafe fn copy_from_video_frame(&self, frame: &::rt::gen::windows::media::VideoFrame) -> Result<ComPtr<PerceptionFrame>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CopyFromVideoFrame)(self as *const _ as *mut _, frame as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPerceptionPropertyChangeRequest, 1012591441, 13579, 19960, 148, 20, 89, 224, 152, 21, 81, 11);
RT_INTERFACE!{interface IPerceptionPropertyChangeRequest(IPerceptionPropertyChangeRequestVtbl): IInspectable(IInspectableVtbl) [IID_IPerceptionPropertyChangeRequest] {
    fn get_Name(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Value(&self, out: *mut *mut IInspectable) -> HRESULT,
    fn get_Status(&self, out: *mut super::PerceptionFrameSourcePropertyChangeStatus) -> HRESULT,
    fn put_Status(&self, value: super::PerceptionFrameSourcePropertyChangeStatus) -> HRESULT,
    fn GetDeferral(&self, out: *mut *mut ::rt::gen::windows::foundation::Deferral) -> HRESULT
}}
impl IPerceptionPropertyChangeRequest {
    #[inline] pub unsafe fn get_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Name)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_value(&self) -> Result<ComPtr<IInspectable>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Value)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<super::PerceptionFrameSourcePropertyChangeStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_status(&self, value: super::PerceptionFrameSourcePropertyChangeStatus) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Status)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_deferral(&self) -> Result<ComPtr<::rt::gen::windows::foundation::Deferral>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeferral)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{static class PerceptionFrameProviderManagerService}
impl RtActivatable<IPerceptionFrameProviderManagerServiceStatics> for PerceptionFrameProviderManagerService {}
impl PerceptionFrameProviderManagerService {
    #[inline] pub fn register_frame_provider_info(manager: &IPerceptionFrameProviderManager, frameProviderInfo: &PerceptionFrameProviderInfo) -> Result<()> { unsafe {
        <Self as RtActivatable<IPerceptionFrameProviderManagerServiceStatics>>::get_activation_factory().register_frame_provider_info(manager, frameProviderInfo)
    }}
    #[inline] pub fn unregister_frame_provider_info(manager: &IPerceptionFrameProviderManager, frameProviderInfo: &PerceptionFrameProviderInfo) -> Result<()> { unsafe {
        <Self as RtActivatable<IPerceptionFrameProviderManagerServiceStatics>>::get_activation_factory().unregister_frame_provider_info(manager, frameProviderInfo)
    }}
    #[inline] pub fn register_face_authentication_group(manager: &IPerceptionFrameProviderManager, faceAuthenticationGroup: &PerceptionFaceAuthenticationGroup) -> Result<()> { unsafe {
        <Self as RtActivatable<IPerceptionFrameProviderManagerServiceStatics>>::get_activation_factory().register_face_authentication_group(manager, faceAuthenticationGroup)
    }}
    #[inline] pub fn unregister_face_authentication_group(manager: &IPerceptionFrameProviderManager, faceAuthenticationGroup: &PerceptionFaceAuthenticationGroup) -> Result<()> { unsafe {
        <Self as RtActivatable<IPerceptionFrameProviderManagerServiceStatics>>::get_activation_factory().unregister_face_authentication_group(manager, faceAuthenticationGroup)
    }}
    #[inline] pub fn register_control_group(manager: &IPerceptionFrameProviderManager, controlGroup: &PerceptionControlGroup) -> Result<()> { unsafe {
        <Self as RtActivatable<IPerceptionFrameProviderManagerServiceStatics>>::get_activation_factory().register_control_group(manager, controlGroup)
    }}
    #[inline] pub fn unregister_control_group(manager: &IPerceptionFrameProviderManager, controlGroup: &PerceptionControlGroup) -> Result<()> { unsafe {
        <Self as RtActivatable<IPerceptionFrameProviderManagerServiceStatics>>::get_activation_factory().unregister_control_group(manager, controlGroup)
    }}
    #[inline] pub fn register_correlation_group(manager: &IPerceptionFrameProviderManager, correlationGroup: &PerceptionCorrelationGroup) -> Result<()> { unsafe {
        <Self as RtActivatable<IPerceptionFrameProviderManagerServiceStatics>>::get_activation_factory().register_correlation_group(manager, correlationGroup)
    }}
    #[inline] pub fn unregister_correlation_group(manager: &IPerceptionFrameProviderManager, correlationGroup: &PerceptionCorrelationGroup) -> Result<()> { unsafe {
        <Self as RtActivatable<IPerceptionFrameProviderManagerServiceStatics>>::get_activation_factory().unregister_correlation_group(manager, correlationGroup)
    }}
    #[inline] pub fn update_availability_for_provider(provider: &IPerceptionFrameProvider, available: bool) -> Result<()> { unsafe {
        <Self as RtActivatable<IPerceptionFrameProviderManagerServiceStatics>>::get_activation_factory().update_availability_for_provider(provider, available)
    }}
    #[inline] pub fn publish_frame_for_provider(provider: &IPerceptionFrameProvider, frame: &PerceptionFrame) -> Result<()> { unsafe {
        <Self as RtActivatable<IPerceptionFrameProviderManagerServiceStatics>>::get_activation_factory().publish_frame_for_provider(provider, frame)
    }}
}
DEFINE_CLSID!(PerceptionFrameProviderManagerService(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,80,114,111,118,105,100,101,114,46,80,101,114,99,101,112,116,105,111,110,70,114,97,109,101,80,114,111,118,105,100,101,114,77,97,110,97,103,101,114,83,101,114,118,105,99,101,0]) [CLSID_PerceptionFrameProviderManagerService]);
RT_CLASS!{static class KnownPerceptionFrameKind}
impl RtActivatable<IKnownPerceptionFrameKindStatics> for KnownPerceptionFrameKind {}
impl KnownPerceptionFrameKind {
    #[inline] pub fn get_color() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionFrameKindStatics>>::get_activation_factory().get_color()
    }}
    #[inline] pub fn get_depth() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionFrameKindStatics>>::get_activation_factory().get_depth()
    }}
    #[inline] pub fn get_infrared() -> Result<HString> { unsafe {
        <Self as RtActivatable<IKnownPerceptionFrameKindStatics>>::get_activation_factory().get_infrared()
    }}
}
DEFINE_CLSID!(KnownPerceptionFrameKind(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,101,114,99,101,112,116,105,111,110,46,80,114,111,118,105,100,101,114,46,75,110,111,119,110,80,101,114,99,101,112,116,105,111,110,70,114,97,109,101,75,105,110,100,0]) [CLSID_KnownPerceptionFrameKind]);
} // Windows.Devices.Perception.Provider
} // Windows.Devices.Perception
pub mod pointofservice { // Windows.Devices.PointOfService
use ::prelude::*;
RT_ENUM! { enum UnifiedPosErrorSeverity: i32 {
    UnknownErrorSeverity (UnifiedPosErrorSeverity_UnknownErrorSeverity) = 0, Warning (UnifiedPosErrorSeverity_Warning) = 1, Recoverable (UnifiedPosErrorSeverity_Recoverable) = 2, Unrecoverable (UnifiedPosErrorSeverity_Unrecoverable) = 3, AssistanceRequired (UnifiedPosErrorSeverity_AssistanceRequired) = 4, Fatal (UnifiedPosErrorSeverity_Fatal) = 5,
}}
RT_ENUM! { enum UnifiedPosPowerReportingType: i32 {
    UnknownPowerReportingType (UnifiedPosPowerReportingType_UnknownPowerReportingType) = 0, Standard (UnifiedPosPowerReportingType_Standard) = 1, Advanced (UnifiedPosPowerReportingType_Advanced) = 2,
}}
RT_ENUM! { enum UnifiedPosHealthCheckLevel: i32 {
    UnknownHealthCheckLevel (UnifiedPosHealthCheckLevel_UnknownHealthCheckLevel) = 0, POSInternal (UnifiedPosHealthCheckLevel_POSInternal) = 1, External (UnifiedPosHealthCheckLevel_External) = 2, Interactive (UnifiedPosHealthCheckLevel_Interactive) = 3,
}}
RT_ENUM! { enum UnifiedPosErrorReason: i32 {
    UnknownErrorReason (UnifiedPosErrorReason_UnknownErrorReason) = 0, NoService (UnifiedPosErrorReason_NoService) = 1, Disabled (UnifiedPosErrorReason_Disabled) = 2, Illegal (UnifiedPosErrorReason_Illegal) = 3, NoHardware (UnifiedPosErrorReason_NoHardware) = 4, Closed (UnifiedPosErrorReason_Closed) = 5, Offline (UnifiedPosErrorReason_Offline) = 6, Failure (UnifiedPosErrorReason_Failure) = 7, Timeout (UnifiedPosErrorReason_Timeout) = 8, Busy (UnifiedPosErrorReason_Busy) = 9, Extended (UnifiedPosErrorReason_Extended) = 10,
}}
RT_ENUM! { enum MagneticStripeReaderAuthenticationLevel: i32 {
    NotSupported (MagneticStripeReaderAuthenticationLevel_NotSupported) = 0, Optional (MagneticStripeReaderAuthenticationLevel_Optional) = 1, Required (MagneticStripeReaderAuthenticationLevel_Required) = 2,
}}
RT_ENUM! { enum PosPrinterMapMode: i32 {
    Dots (PosPrinterMapMode_Dots) = 0, Twips (PosPrinterMapMode_Twips) = 1, English (PosPrinterMapMode_English) = 2, Metric (PosPrinterMapMode_Metric) = 3,
}}
RT_ENUM! { enum PosPrinterCartridgeSensors: u32 {
    None (PosPrinterCartridgeSensors_None) = 0, Removed (PosPrinterCartridgeSensors_Removed) = 1, Empty (PosPrinterCartridgeSensors_Empty) = 2, HeadCleaning (PosPrinterCartridgeSensors_HeadCleaning) = 4, NearEnd (PosPrinterCartridgeSensors_NearEnd) = 8,
}}
RT_ENUM! { enum PosPrinterColorCapabilities: u32 {
    None (PosPrinterColorCapabilities_None) = 0, Primary (PosPrinterColorCapabilities_Primary) = 1, Custom1 (PosPrinterColorCapabilities_Custom1) = 2, Custom2 (PosPrinterColorCapabilities_Custom2) = 4, Custom3 (PosPrinterColorCapabilities_Custom3) = 8, Custom4 (PosPrinterColorCapabilities_Custom4) = 16, Custom5 (PosPrinterColorCapabilities_Custom5) = 32, Custom6 (PosPrinterColorCapabilities_Custom6) = 64, Cyan (PosPrinterColorCapabilities_Cyan) = 128, Magenta (PosPrinterColorCapabilities_Magenta) = 256, Yellow (PosPrinterColorCapabilities_Yellow) = 512, Full (PosPrinterColorCapabilities_Full) = 1024,
}}
RT_ENUM! { enum PosPrinterColorCartridge: i32 {
    Unknown (PosPrinterColorCartridge_Unknown) = 0, Primary (PosPrinterColorCartridge_Primary) = 1, Custom1 (PosPrinterColorCartridge_Custom1) = 2, Custom2 (PosPrinterColorCartridge_Custom2) = 3, Custom3 (PosPrinterColorCartridge_Custom3) = 4, Custom4 (PosPrinterColorCartridge_Custom4) = 5, Custom5 (PosPrinterColorCartridge_Custom5) = 6, Custom6 (PosPrinterColorCartridge_Custom6) = 7, Cyan (PosPrinterColorCartridge_Cyan) = 8, Magenta (PosPrinterColorCartridge_Magenta) = 9, Yellow (PosPrinterColorCartridge_Yellow) = 10,
}}
RT_ENUM! { enum PosPrinterMarkFeedCapabilities: u32 {
    None (PosPrinterMarkFeedCapabilities_None) = 0, ToTakeUp (PosPrinterMarkFeedCapabilities_ToTakeUp) = 1, ToCutter (PosPrinterMarkFeedCapabilities_ToCutter) = 2, ToCurrentTopOfForm (PosPrinterMarkFeedCapabilities_ToCurrentTopOfForm) = 4, ToNextTopOfForm (PosPrinterMarkFeedCapabilities_ToNextTopOfForm) = 8,
}}
RT_ENUM! { enum PosPrinterRuledLineCapabilities: u32 {
    None (PosPrinterRuledLineCapabilities_None) = 0, Horizontal (PosPrinterRuledLineCapabilities_Horizontal) = 1, Vertical (PosPrinterRuledLineCapabilities_Vertical) = 2,
}}
RT_ENUM! { enum PosPrinterPrintSide: i32 {
    Unknown (PosPrinterPrintSide_Unknown) = 0, Side1 (PosPrinterPrintSide_Side1) = 1, Side2 (PosPrinterPrintSide_Side2) = 2,
}}
RT_ENUM! { enum PosPrinterLineDirection: i32 {
    Horizontal (PosPrinterLineDirection_Horizontal) = 0, Vertical (PosPrinterLineDirection_Vertical) = 1,
}}
RT_ENUM! { enum PosPrinterLineStyle: i32 {
    SingleSolid (PosPrinterLineStyle_SingleSolid) = 0, DoubleSolid (PosPrinterLineStyle_DoubleSolid) = 1, Broken (PosPrinterLineStyle_Broken) = 2, Chain (PosPrinterLineStyle_Chain) = 3,
}}
RT_ENUM! { enum PosPrinterMarkFeedKind: i32 {
    ToTakeUp (PosPrinterMarkFeedKind_ToTakeUp) = 0, ToCutter (PosPrinterMarkFeedKind_ToCutter) = 1, ToCurrentTopOfForm (PosPrinterMarkFeedKind_ToCurrentTopOfForm) = 2, ToNextTopOfForm (PosPrinterMarkFeedKind_ToNextTopOfForm) = 3,
}}
RT_ENUM! { enum PosPrinterAlignment: i32 {
    Left (PosPrinterAlignment_Left) = 0, Center (PosPrinterAlignment_Center) = 1, Right (PosPrinterAlignment_Right) = 2,
}}
RT_ENUM! { enum PosPrinterBarcodeTextPosition: i32 {
    None (PosPrinterBarcodeTextPosition_None) = 0, Above (PosPrinterBarcodeTextPosition_Above) = 1, Below (PosPrinterBarcodeTextPosition_Below) = 2,
}}
RT_ENUM! { enum PosPrinterRotation: i32 {
    Normal (PosPrinterRotation_Normal) = 0, Right90 (PosPrinterRotation_Right90) = 1, Left90 (PosPrinterRotation_Left90) = 2, Rotate180 (PosPrinterRotation_Rotate180) = 3,
}}
RT_ENUM! { enum PosPrinterStatusKind: i32 {
    Online (PosPrinterStatusKind_Online) = 0, Off (PosPrinterStatusKind_Off) = 1, Offline (PosPrinterStatusKind_Offline) = 2, OffOrOffline (PosPrinterStatusKind_OffOrOffline) = 3, Extended (PosPrinterStatusKind_Extended) = 4,
}}
RT_ENUM! { enum CashDrawerStatusKind: i32 {
    Online (CashDrawerStatusKind_Online) = 0, Off (CashDrawerStatusKind_Off) = 1, Offline (CashDrawerStatusKind_Offline) = 2, OffOrOffline (CashDrawerStatusKind_OffOrOffline) = 3, Extended (CashDrawerStatusKind_Extended) = 4,
}}
RT_ENUM! { enum BarcodeScannerStatus: i32 {
    Online (BarcodeScannerStatus_Online) = 0, Off (BarcodeScannerStatus_Off) = 1, Offline (BarcodeScannerStatus_Offline) = 2, OffOrOffline (BarcodeScannerStatus_OffOrOffline) = 3, Extended (BarcodeScannerStatus_Extended) = 4,
}}
RT_ENUM! { enum LineDisplayScrollDirection: i32 {
    Up (LineDisplayScrollDirection_Up) = 0, Down (LineDisplayScrollDirection_Down) = 1, Left (LineDisplayScrollDirection_Left) = 2, Right (LineDisplayScrollDirection_Right) = 3,
}}
RT_ENUM! { enum LineDisplayTextAttribute: i32 {
    Normal (LineDisplayTextAttribute_Normal) = 0, Blink (LineDisplayTextAttribute_Blink) = 1, Reverse (LineDisplayTextAttribute_Reverse) = 2, ReverseBlink (LineDisplayTextAttribute_ReverseBlink) = 3,
}}
RT_ENUM! { enum LineDisplayTextAttributeGranularity: i32 {
    NotSupported (LineDisplayTextAttributeGranularity_NotSupported) = 0, EntireDisplay (LineDisplayTextAttributeGranularity_EntireDisplay) = 1, PerCharacter (LineDisplayTextAttributeGranularity_PerCharacter) = 2,
}}
RT_ENUM! { enum PosConnectionTypes: u32 {
    Local (PosConnectionTypes_Local) = 1, IP (PosConnectionTypes_IP) = 2, Bluetooth (PosConnectionTypes_Bluetooth) = 4, All (PosConnectionTypes_All) = 4294967295,
}}
DEFINE_IID!(IID_IUnifiedPosErrorData, 731483194, 21852, 18569, 142, 216, 197, 153, 187, 58, 113, 42);
RT_INTERFACE!{interface IUnifiedPosErrorData(IUnifiedPosErrorDataVtbl): IInspectable(IInspectableVtbl) [IID_IUnifiedPosErrorData] {
    fn get_Message(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Severity(&self, out: *mut UnifiedPosErrorSeverity) -> HRESULT,
    fn get_Reason(&self, out: *mut UnifiedPosErrorReason) -> HRESULT,
    fn get_ExtendedReason(&self, out: *mut u32) -> HRESULT
}}
impl IUnifiedPosErrorData {
    #[inline] pub unsafe fn get_message(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Message)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_severity(&self) -> Result<UnifiedPosErrorSeverity> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Severity)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_reason(&self) -> Result<UnifiedPosErrorReason> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Reason)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_extended_reason(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ExtendedReason)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class UnifiedPosErrorData: IUnifiedPosErrorData}
DEFINE_IID!(IID_IBarcodeScannerStatusUpdatedEventArgs, 895321478, 40003, 17963, 169, 26, 129, 109, 201, 127, 69, 44);
RT_INTERFACE!{interface IBarcodeScannerStatusUpdatedEventArgs(IBarcodeScannerStatusUpdatedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IBarcodeScannerStatusUpdatedEventArgs] {
    fn get_Status(&self, out: *mut BarcodeScannerStatus) -> HRESULT,
    fn get_ExtendedStatus(&self, out: *mut u32) -> HRESULT
}}
impl IBarcodeScannerStatusUpdatedEventArgs {
    #[inline] pub unsafe fn get_status(&self) -> Result<BarcodeScannerStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_extended_status(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ExtendedStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class BarcodeScannerStatusUpdatedEventArgs: IBarcodeScannerStatusUpdatedEventArgs}
DEFINE_IID!(IID_IBarcodeSymbologiesStatics, 3397732795, 1746, 17396, 164, 75, 198, 32, 103, 159, 216, 208);
RT_INTERFACE!{static interface IBarcodeSymbologiesStatics(IBarcodeSymbologiesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IBarcodeSymbologiesStatics] {
    fn get_Unknown(&self, out: *mut u32) -> HRESULT,
    fn get_Ean8(&self, out: *mut u32) -> HRESULT,
    fn get_Ean8Add2(&self, out: *mut u32) -> HRESULT,
    fn get_Ean8Add5(&self, out: *mut u32) -> HRESULT,
    fn get_Eanv(&self, out: *mut u32) -> HRESULT,
    fn get_EanvAdd2(&self, out: *mut u32) -> HRESULT,
    fn get_EanvAdd5(&self, out: *mut u32) -> HRESULT,
    fn get_Ean13(&self, out: *mut u32) -> HRESULT,
    fn get_Ean13Add2(&self, out: *mut u32) -> HRESULT,
    fn get_Ean13Add5(&self, out: *mut u32) -> HRESULT,
    fn get_Isbn(&self, out: *mut u32) -> HRESULT,
    fn get_IsbnAdd5(&self, out: *mut u32) -> HRESULT,
    fn get_Ismn(&self, out: *mut u32) -> HRESULT,
    fn get_IsmnAdd2(&self, out: *mut u32) -> HRESULT,
    fn get_IsmnAdd5(&self, out: *mut u32) -> HRESULT,
    fn get_Issn(&self, out: *mut u32) -> HRESULT,
    fn get_IssnAdd2(&self, out: *mut u32) -> HRESULT,
    fn get_IssnAdd5(&self, out: *mut u32) -> HRESULT,
    fn get_Ean99(&self, out: *mut u32) -> HRESULT,
    fn get_Ean99Add2(&self, out: *mut u32) -> HRESULT,
    fn get_Ean99Add5(&self, out: *mut u32) -> HRESULT,
    fn get_Upca(&self, out: *mut u32) -> HRESULT,
    fn get_UpcaAdd2(&self, out: *mut u32) -> HRESULT,
    fn get_UpcaAdd5(&self, out: *mut u32) -> HRESULT,
    fn get_Upce(&self, out: *mut u32) -> HRESULT,
    fn get_UpceAdd2(&self, out: *mut u32) -> HRESULT,
    fn get_UpceAdd5(&self, out: *mut u32) -> HRESULT,
    fn get_UpcCoupon(&self, out: *mut u32) -> HRESULT,
    fn get_TfStd(&self, out: *mut u32) -> HRESULT,
    fn get_TfDis(&self, out: *mut u32) -> HRESULT,
    fn get_TfInt(&self, out: *mut u32) -> HRESULT,
    fn get_TfInd(&self, out: *mut u32) -> HRESULT,
    fn get_TfMat(&self, out: *mut u32) -> HRESULT,
    fn get_TfIata(&self, out: *mut u32) -> HRESULT,
    fn get_Gs1DatabarType1(&self, out: *mut u32) -> HRESULT,
    fn get_Gs1DatabarType2(&self, out: *mut u32) -> HRESULT,
    fn get_Gs1DatabarType3(&self, out: *mut u32) -> HRESULT,
    fn get_Code39(&self, out: *mut u32) -> HRESULT,
    fn get_Code39Ex(&self, out: *mut u32) -> HRESULT,
    fn get_Trioptic39(&self, out: *mut u32) -> HRESULT,
    fn get_Code32(&self, out: *mut u32) -> HRESULT,
    fn get_Pzn(&self, out: *mut u32) -> HRESULT,
    fn get_Code93(&self, out: *mut u32) -> HRESULT,
    fn get_Code93Ex(&self, out: *mut u32) -> HRESULT,
    fn get_Code128(&self, out: *mut u32) -> HRESULT,
    fn get_Gs1128(&self, out: *mut u32) -> HRESULT,
    fn get_Gs1128Coupon(&self, out: *mut u32) -> HRESULT,
    fn get_UccEan128(&self, out: *mut u32) -> HRESULT,
    fn get_Sisac(&self, out: *mut u32) -> HRESULT,
    fn get_Isbt(&self, out: *mut u32) -> HRESULT,
    fn get_Codabar(&self, out: *mut u32) -> HRESULT,
    fn get_Code11(&self, out: *mut u32) -> HRESULT,
    fn get_Msi(&self, out: *mut u32) -> HRESULT,
    fn get_Plessey(&self, out: *mut u32) -> HRESULT,
    fn get_Telepen(&self, out: *mut u32) -> HRESULT,
    fn get_Code16k(&self, out: *mut u32) -> HRESULT,
    fn get_CodablockA(&self, out: *mut u32) -> HRESULT,
    fn get_CodablockF(&self, out: *mut u32) -> HRESULT,
    fn get_Codablock128(&self, out: *mut u32) -> HRESULT,
    fn get_Code49(&self, out: *mut u32) -> HRESULT,
    fn get_Aztec(&self, out: *mut u32) -> HRESULT,
    fn get_DataCode(&self, out: *mut u32) -> HRESULT,
    fn get_DataMatrix(&self, out: *mut u32) -> HRESULT,
    fn get_HanXin(&self, out: *mut u32) -> HRESULT,
    fn get_Maxicode(&self, out: *mut u32) -> HRESULT,
    fn get_MicroPdf417(&self, out: *mut u32) -> HRESULT,
    fn get_MicroQr(&self, out: *mut u32) -> HRESULT,
    fn get_Pdf417(&self, out: *mut u32) -> HRESULT,
    fn get_Qr(&self, out: *mut u32) -> HRESULT,
    fn get_MsTag(&self, out: *mut u32) -> HRESULT,
    fn get_Ccab(&self, out: *mut u32) -> HRESULT,
    fn get_Ccc(&self, out: *mut u32) -> HRESULT,
    fn get_Tlc39(&self, out: *mut u32) -> HRESULT,
    fn get_AusPost(&self, out: *mut u32) -> HRESULT,
    fn get_CanPost(&self, out: *mut u32) -> HRESULT,
    fn get_ChinaPost(&self, out: *mut u32) -> HRESULT,
    fn get_DutchKix(&self, out: *mut u32) -> HRESULT,
    fn get_InfoMail(&self, out: *mut u32) -> HRESULT,
    fn get_ItalianPost25(&self, out: *mut u32) -> HRESULT,
    fn get_ItalianPost39(&self, out: *mut u32) -> HRESULT,
    fn get_JapanPost(&self, out: *mut u32) -> HRESULT,
    fn get_KoreanPost(&self, out: *mut u32) -> HRESULT,
    fn get_SwedenPost(&self, out: *mut u32) -> HRESULT,
    fn get_UkPost(&self, out: *mut u32) -> HRESULT,
    fn get_UsIntelligent(&self, out: *mut u32) -> HRESULT,
    fn get_UsIntelligentPkg(&self, out: *mut u32) -> HRESULT,
    fn get_UsPlanet(&self, out: *mut u32) -> HRESULT,
    fn get_UsPostNet(&self, out: *mut u32) -> HRESULT,
    fn get_Us4StateFics(&self, out: *mut u32) -> HRESULT,
    fn get_OcrA(&self, out: *mut u32) -> HRESULT,
    fn get_OcrB(&self, out: *mut u32) -> HRESULT,
    fn get_Micr(&self, out: *mut u32) -> HRESULT,
    fn get_ExtendedBase(&self, out: *mut u32) -> HRESULT,
    fn GetName(&self, scanDataType: u32, out: *mut HSTRING) -> HRESULT
}}
impl IBarcodeSymbologiesStatics {
    #[inline] pub unsafe fn get_unknown(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Unknown)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ean8(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ean8)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ean8_add2(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ean8Add2)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ean8_add5(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ean8Add5)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_eanv(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Eanv)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_eanv_add2(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_EanvAdd2)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_eanv_add5(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_EanvAdd5)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ean13(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ean13)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ean13_add2(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ean13Add2)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ean13_add5(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ean13Add5)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_isbn(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Isbn)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_isbn_add5(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsbnAdd5)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ismn(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ismn)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ismn_add2(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsmnAdd2)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ismn_add5(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsmnAdd5)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_issn(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Issn)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_issn_add2(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IssnAdd2)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_issn_add5(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IssnAdd5)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ean99(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ean99)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ean99_add2(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ean99Add2)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ean99_add5(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ean99Add5)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_upca(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Upca)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_upca_add2(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UpcaAdd2)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_upca_add5(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UpcaAdd5)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_upce(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Upce)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_upce_add2(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UpceAdd2)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_upce_add5(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UpceAdd5)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_upc_coupon(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UpcCoupon)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_tf_std(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TfStd)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_tf_dis(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TfDis)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_tf_int(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TfInt)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_tf_ind(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TfInd)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_tf_mat(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TfMat)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_tf_iata(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TfIata)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gs1_databar_type1(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Gs1DatabarType1)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gs1_databar_type2(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Gs1DatabarType2)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gs1_databar_type3(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Gs1DatabarType3)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_code39(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Code39)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_code39_ex(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Code39Ex)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_trioptic39(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Trioptic39)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_code32(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Code32)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pzn(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Pzn)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_code93(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Code93)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_code93_ex(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Code93Ex)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_code128(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Code128)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gs1128(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Gs1128)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gs1128_coupon(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Gs1128Coupon)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ucc_ean128(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UccEan128)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sisac(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Sisac)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_isbt(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Isbt)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_codabar(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Codabar)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_code11(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Code11)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_msi(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Msi)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_plessey(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Plessey)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_telepen(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Telepen)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_code16k(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Code16k)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_codablock_a(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CodablockA)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_codablock_f(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CodablockF)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_codablock128(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Codablock128)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_code49(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Code49)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_aztec(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Aztec)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_data_code(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DataCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_data_matrix(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DataMatrix)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_han_xin(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HanXin)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_maxicode(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Maxicode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_micro_pdf417(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MicroPdf417)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_micro_qr(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MicroQr)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pdf417(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Pdf417)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_qr(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Qr)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ms_tag(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MsTag)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ccab(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ccab)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ccc(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ccc)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_tlc39(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Tlc39)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_aus_post(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AusPost)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_can_post(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanPost)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_china_post(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ChinaPost)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_dutch_kix(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DutchKix)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_info_mail(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InfoMail)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_italian_post25(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ItalianPost25)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_italian_post39(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ItalianPost39)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_japan_post(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_JapanPost)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_korean_post(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_KoreanPost)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sweden_post(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SwedenPost)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_uk_post(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UkPost)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_us_intelligent(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsIntelligent)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_us_intelligent_pkg(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsIntelligentPkg)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_us_planet(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsPlanet)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_us_post_net(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsPostNet)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_us4_state_fics(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Us4StateFics)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ocr_a(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_OcrA)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ocr_b(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_OcrB)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_micr(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Micr)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_extended_base(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ExtendedBase)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_name(&self, scanDataType: u32) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetName)(self as *const _ as *mut _, scanDataType, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBarcodeSymbologiesStatics2, 2339707124, 39376, 16575, 148, 36, 185, 29, 109, 212, 198, 224);
RT_INTERFACE!{static interface IBarcodeSymbologiesStatics2(IBarcodeSymbologiesStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IBarcodeSymbologiesStatics2] {
    fn get_Gs1DWCode(&self, out: *mut u32) -> HRESULT
}}
impl IBarcodeSymbologiesStatics2 {
    #[inline] pub unsafe fn get_gs1_dwcode(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Gs1DWCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{static class BarcodeSymbologies}
impl RtActivatable<IBarcodeSymbologiesStatics> for BarcodeSymbologies {}
impl RtActivatable<IBarcodeSymbologiesStatics2> for BarcodeSymbologies {}
impl BarcodeSymbologies {
    #[inline] pub fn get_unknown() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_unknown()
    }}
    #[inline] pub fn get_ean8() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ean8()
    }}
    #[inline] pub fn get_ean8_add2() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ean8_add2()
    }}
    #[inline] pub fn get_ean8_add5() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ean8_add5()
    }}
    #[inline] pub fn get_eanv() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_eanv()
    }}
    #[inline] pub fn get_eanv_add2() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_eanv_add2()
    }}
    #[inline] pub fn get_eanv_add5() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_eanv_add5()
    }}
    #[inline] pub fn get_ean13() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ean13()
    }}
    #[inline] pub fn get_ean13_add2() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ean13_add2()
    }}
    #[inline] pub fn get_ean13_add5() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ean13_add5()
    }}
    #[inline] pub fn get_isbn() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_isbn()
    }}
    #[inline] pub fn get_isbn_add5() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_isbn_add5()
    }}
    #[inline] pub fn get_ismn() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ismn()
    }}
    #[inline] pub fn get_ismn_add2() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ismn_add2()
    }}
    #[inline] pub fn get_ismn_add5() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ismn_add5()
    }}
    #[inline] pub fn get_issn() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_issn()
    }}
    #[inline] pub fn get_issn_add2() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_issn_add2()
    }}
    #[inline] pub fn get_issn_add5() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_issn_add5()
    }}
    #[inline] pub fn get_ean99() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ean99()
    }}
    #[inline] pub fn get_ean99_add2() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ean99_add2()
    }}
    #[inline] pub fn get_ean99_add5() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ean99_add5()
    }}
    #[inline] pub fn get_upca() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_upca()
    }}
    #[inline] pub fn get_upca_add2() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_upca_add2()
    }}
    #[inline] pub fn get_upca_add5() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_upca_add5()
    }}
    #[inline] pub fn get_upce() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_upce()
    }}
    #[inline] pub fn get_upce_add2() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_upce_add2()
    }}
    #[inline] pub fn get_upce_add5() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_upce_add5()
    }}
    #[inline] pub fn get_upc_coupon() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_upc_coupon()
    }}
    #[inline] pub fn get_tf_std() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_tf_std()
    }}
    #[inline] pub fn get_tf_dis() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_tf_dis()
    }}
    #[inline] pub fn get_tf_int() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_tf_int()
    }}
    #[inline] pub fn get_tf_ind() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_tf_ind()
    }}
    #[inline] pub fn get_tf_mat() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_tf_mat()
    }}
    #[inline] pub fn get_tf_iata() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_tf_iata()
    }}
    #[inline] pub fn get_gs1_databar_type1() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_gs1_databar_type1()
    }}
    #[inline] pub fn get_gs1_databar_type2() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_gs1_databar_type2()
    }}
    #[inline] pub fn get_gs1_databar_type3() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_gs1_databar_type3()
    }}
    #[inline] pub fn get_code39() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_code39()
    }}
    #[inline] pub fn get_code39_ex() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_code39_ex()
    }}
    #[inline] pub fn get_trioptic39() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_trioptic39()
    }}
    #[inline] pub fn get_code32() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_code32()
    }}
    #[inline] pub fn get_pzn() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_pzn()
    }}
    #[inline] pub fn get_code93() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_code93()
    }}
    #[inline] pub fn get_code93_ex() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_code93_ex()
    }}
    #[inline] pub fn get_code128() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_code128()
    }}
    #[inline] pub fn get_gs1128() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_gs1128()
    }}
    #[inline] pub fn get_gs1128_coupon() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_gs1128_coupon()
    }}
    #[inline] pub fn get_ucc_ean128() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ucc_ean128()
    }}
    #[inline] pub fn get_sisac() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_sisac()
    }}
    #[inline] pub fn get_isbt() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_isbt()
    }}
    #[inline] pub fn get_codabar() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_codabar()
    }}
    #[inline] pub fn get_code11() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_code11()
    }}
    #[inline] pub fn get_msi() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_msi()
    }}
    #[inline] pub fn get_plessey() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_plessey()
    }}
    #[inline] pub fn get_telepen() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_telepen()
    }}
    #[inline] pub fn get_code16k() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_code16k()
    }}
    #[inline] pub fn get_codablock_a() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_codablock_a()
    }}
    #[inline] pub fn get_codablock_f() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_codablock_f()
    }}
    #[inline] pub fn get_codablock128() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_codablock128()
    }}
    #[inline] pub fn get_code49() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_code49()
    }}
    #[inline] pub fn get_aztec() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_aztec()
    }}
    #[inline] pub fn get_data_code() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_data_code()
    }}
    #[inline] pub fn get_data_matrix() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_data_matrix()
    }}
    #[inline] pub fn get_han_xin() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_han_xin()
    }}
    #[inline] pub fn get_maxicode() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_maxicode()
    }}
    #[inline] pub fn get_micro_pdf417() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_micro_pdf417()
    }}
    #[inline] pub fn get_micro_qr() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_micro_qr()
    }}
    #[inline] pub fn get_pdf417() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_pdf417()
    }}
    #[inline] pub fn get_qr() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_qr()
    }}
    #[inline] pub fn get_ms_tag() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ms_tag()
    }}
    #[inline] pub fn get_ccab() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ccab()
    }}
    #[inline] pub fn get_ccc() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ccc()
    }}
    #[inline] pub fn get_tlc39() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_tlc39()
    }}
    #[inline] pub fn get_aus_post() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_aus_post()
    }}
    #[inline] pub fn get_can_post() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_can_post()
    }}
    #[inline] pub fn get_china_post() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_china_post()
    }}
    #[inline] pub fn get_dutch_kix() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_dutch_kix()
    }}
    #[inline] pub fn get_info_mail() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_info_mail()
    }}
    #[inline] pub fn get_italian_post25() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_italian_post25()
    }}
    #[inline] pub fn get_italian_post39() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_italian_post39()
    }}
    #[inline] pub fn get_japan_post() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_japan_post()
    }}
    #[inline] pub fn get_korean_post() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_korean_post()
    }}
    #[inline] pub fn get_sweden_post() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_sweden_post()
    }}
    #[inline] pub fn get_uk_post() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_uk_post()
    }}
    #[inline] pub fn get_us_intelligent() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_us_intelligent()
    }}
    #[inline] pub fn get_us_intelligent_pkg() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_us_intelligent_pkg()
    }}
    #[inline] pub fn get_us_planet() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_us_planet()
    }}
    #[inline] pub fn get_us_post_net() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_us_post_net()
    }}
    #[inline] pub fn get_us4_state_fics() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_us4_state_fics()
    }}
    #[inline] pub fn get_ocr_a() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ocr_a()
    }}
    #[inline] pub fn get_ocr_b() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_ocr_b()
    }}
    #[inline] pub fn get_micr() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_micr()
    }}
    #[inline] pub fn get_extended_base() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_extended_base()
    }}
    #[inline] pub fn get_name(scanDataType: u32) -> Result<HString> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics>>::get_activation_factory().get_name(scanDataType)
    }}
    #[inline] pub fn get_gs1_dwcode() -> Result<u32> { unsafe {
        <Self as RtActivatable<IBarcodeSymbologiesStatics2>>::get_activation_factory().get_gs1_dwcode()
    }}
}
DEFINE_CLSID!(BarcodeSymbologies(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,111,105,110,116,79,102,83,101,114,118,105,99,101,46,66,97,114,99,111,100,101,83,121,109,98,111,108,111,103,105,101,115,0]) [CLSID_BarcodeSymbologies]);
RT_ENUM! { enum BarcodeSymbologyDecodeLengthKind: i32 {
    AnyLength (BarcodeSymbologyDecodeLengthKind_AnyLength) = 0, Discrete (BarcodeSymbologyDecodeLengthKind_Discrete) = 1, Range (BarcodeSymbologyDecodeLengthKind_Range) = 2,
}}
DEFINE_IID!(IID_IBarcodeSymbologyAttributes, 1715550840, 43898, 19162, 142, 206, 147, 96, 20, 178, 234, 215);
RT_INTERFACE!{interface IBarcodeSymbologyAttributes(IBarcodeSymbologyAttributesVtbl): IInspectable(IInspectableVtbl) [IID_IBarcodeSymbologyAttributes] {
    fn get_IsCheckDigitValidationEnabled(&self, out: *mut bool) -> HRESULT,
    fn put_IsCheckDigitValidationEnabled(&self, value: bool) -> HRESULT,
    fn get_IsCheckDigitValidationSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsCheckDigitTransmissionEnabled(&self, out: *mut bool) -> HRESULT,
    fn put_IsCheckDigitTransmissionEnabled(&self, value: bool) -> HRESULT,
    fn get_IsCheckDigitTransmissionSupported(&self, out: *mut bool) -> HRESULT,
    fn get_DecodeLength1(&self, out: *mut u32) -> HRESULT,
    fn put_DecodeLength1(&self, value: u32) -> HRESULT,
    fn get_DecodeLength2(&self, out: *mut u32) -> HRESULT,
    fn put_DecodeLength2(&self, value: u32) -> HRESULT,
    fn get_DecodeLengthKind(&self, out: *mut BarcodeSymbologyDecodeLengthKind) -> HRESULT,
    fn put_DecodeLengthKind(&self, value: BarcodeSymbologyDecodeLengthKind) -> HRESULT,
    fn get_IsDecodeLengthSupported(&self, out: *mut bool) -> HRESULT
}}
impl IBarcodeSymbologyAttributes {
    #[inline] pub unsafe fn get_is_check_digit_validation_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsCheckDigitValidationEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_check_digit_validation_enabled(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsCheckDigitValidationEnabled)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_check_digit_validation_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsCheckDigitValidationSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_check_digit_transmission_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsCheckDigitTransmissionEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_check_digit_transmission_enabled(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsCheckDigitTransmissionEnabled)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_check_digit_transmission_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsCheckDigitTransmissionSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_decode_length1(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DecodeLength1)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_decode_length1(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DecodeLength1)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_decode_length2(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DecodeLength2)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_decode_length2(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DecodeLength2)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_decode_length_kind(&self) -> Result<BarcodeSymbologyDecodeLengthKind> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DecodeLengthKind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_decode_length_kind(&self, value: BarcodeSymbologyDecodeLengthKind) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DecodeLengthKind)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_decode_length_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDecodeLengthSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class BarcodeSymbologyAttributes: IBarcodeSymbologyAttributes}
DEFINE_IID!(IID_IBarcodeScannerDataReceivedEventArgs, 1110747106, 60823, 18045, 173, 43, 1, 228, 67, 19, 169, 41);
RT_INTERFACE!{interface IBarcodeScannerDataReceivedEventArgs(IBarcodeScannerDataReceivedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IBarcodeScannerDataReceivedEventArgs] {
    fn get_Report(&self, out: *mut *mut BarcodeScannerReport) -> HRESULT
}}
impl IBarcodeScannerDataReceivedEventArgs {
    #[inline] pub unsafe fn get_report(&self) -> Result<ComPtr<BarcodeScannerReport>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Report)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class BarcodeScannerReport: IBarcodeScannerReport}
RT_CLASS!{class BarcodeScannerDataReceivedEventArgs: IBarcodeScannerDataReceivedEventArgs}
DEFINE_IID!(IID_IBarcodeScannerReport, 1558501552, 42121, 19350, 134, 196, 240, 191, 138, 55, 117, 61);
RT_INTERFACE!{interface IBarcodeScannerReport(IBarcodeScannerReportVtbl): IInspectable(IInspectableVtbl) [IID_IBarcodeScannerReport] {
    fn get_ScanDataType(&self, out: *mut u32) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_ScanData(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_ScanDataLabel(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT
}}
impl IBarcodeScannerReport {
    #[inline] pub unsafe fn get_scan_data_type(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ScanDataType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_scan_data(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ScanData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_scan_data_label(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ScanDataLabel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBarcodeScannerErrorOccurredEventArgs, 751984687, 53050, 16386, 167, 90, 197, 236, 70, 143, 10, 32);
RT_INTERFACE!{interface IBarcodeScannerErrorOccurredEventArgs(IBarcodeScannerErrorOccurredEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IBarcodeScannerErrorOccurredEventArgs] {
    fn get_PartialInputData(&self, out: *mut *mut BarcodeScannerReport) -> HRESULT,
    fn get_IsRetriable(&self, out: *mut bool) -> HRESULT,
    fn get_ErrorData(&self, out: *mut *mut UnifiedPosErrorData) -> HRESULT
}}
impl IBarcodeScannerErrorOccurredEventArgs {
    #[inline] pub unsafe fn get_partial_input_data(&self) -> Result<ComPtr<BarcodeScannerReport>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PartialInputData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_retriable(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsRetriable)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_error_data(&self) -> Result<ComPtr<UnifiedPosErrorData>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ErrorData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class BarcodeScannerErrorOccurredEventArgs: IBarcodeScannerErrorOccurredEventArgs}
DEFINE_IID!(IID_IBarcodeScannerImagePreviewReceivedEventArgs, 4088913541, 28299, 17230, 159, 88, 6, 239, 38, 188, 75, 175);
RT_INTERFACE!{interface IBarcodeScannerImagePreviewReceivedEventArgs(IBarcodeScannerImagePreviewReceivedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IBarcodeScannerImagePreviewReceivedEventArgs] {
    #[cfg(feature="windows-storage")] fn get_Preview(&self, out: *mut *mut super::super::storage::streams::IRandomAccessStreamWithContentType) -> HRESULT
}}
impl IBarcodeScannerImagePreviewReceivedEventArgs {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_preview(&self) -> Result<ComPtr<super::super::storage::streams::IRandomAccessStreamWithContentType>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Preview)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class BarcodeScannerImagePreviewReceivedEventArgs: IBarcodeScannerImagePreviewReceivedEventArgs}
DEFINE_IID!(IID_IBarcodeScannerCapabilities, 3322319332, 62152, 17440, 163, 7, 177, 46, 246, 98, 40, 87);
RT_INTERFACE!{interface IBarcodeScannerCapabilities(IBarcodeScannerCapabilitiesVtbl): IInspectable(IInspectableVtbl) [IID_IBarcodeScannerCapabilities] {
    fn get_PowerReportingType(&self, out: *mut UnifiedPosPowerReportingType) -> HRESULT,
    fn get_IsStatisticsReportingSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsStatisticsUpdatingSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsImagePreviewSupported(&self, out: *mut bool) -> HRESULT
}}
impl IBarcodeScannerCapabilities {
    #[inline] pub unsafe fn get_power_reporting_type(&self) -> Result<UnifiedPosPowerReportingType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PowerReportingType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_statistics_reporting_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStatisticsReportingSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_statistics_updating_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStatisticsUpdatingSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_image_preview_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsImagePreviewSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBarcodeScannerCapabilities1, 2388308969, 3628, 18223, 161, 204, 238, 128, 84, 182, 166, 132);
RT_INTERFACE!{interface IBarcodeScannerCapabilities1(IBarcodeScannerCapabilities1Vtbl): IInspectable(IInspectableVtbl) [IID_IBarcodeScannerCapabilities1] {
    fn get_IsSoftwareTriggerSupported(&self, out: *mut bool) -> HRESULT
}}
impl IBarcodeScannerCapabilities1 {
    #[inline] pub unsafe fn get_is_software_trigger_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsSoftwareTriggerSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class BarcodeScannerCapabilities: IBarcodeScannerCapabilities}
DEFINE_IID!(IID_IBarcodeScannerStatics, 1561419631, 55881, 16872, 140, 140, 240, 203, 98, 169, 196, 252);
RT_INTERFACE!{static interface IBarcodeScannerStatics(IBarcodeScannerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IBarcodeScannerStatics] {
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<BarcodeScanner>) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<BarcodeScanner>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT
}}
impl IBarcodeScannerStatics {
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BarcodeScanner>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BarcodeScanner>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class BarcodeScanner: IBarcodeScanner}
impl RtActivatable<IBarcodeScannerStatics2> for BarcodeScanner {}
impl RtActivatable<IBarcodeScannerStatics> for BarcodeScanner {}
impl BarcodeScanner {
    #[inline] pub fn get_device_selector_with_connection_types(connectionTypes: PosConnectionTypes) -> Result<HString> { unsafe {
        <Self as RtActivatable<IBarcodeScannerStatics2>>::get_activation_factory().get_device_selector_with_connection_types(connectionTypes)
    }}
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<BarcodeScanner>>> { unsafe {
        <Self as RtActivatable<IBarcodeScannerStatics>>::get_activation_factory().get_default_async()
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BarcodeScanner>>> { unsafe {
        <Self as RtActivatable<IBarcodeScannerStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IBarcodeScannerStatics>>::get_activation_factory().get_device_selector()
    }}
}
DEFINE_CLSID!(BarcodeScanner(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,111,105,110,116,79,102,83,101,114,118,105,99,101,46,66,97,114,99,111,100,101,83,99,97,110,110,101,114,0]) [CLSID_BarcodeScanner]);
DEFINE_IID!(IID_IBarcodeScannerStatics2, 3093636211, 41839, 16391, 177, 208, 39, 158, 190, 146, 166, 86);
RT_INTERFACE!{static interface IBarcodeScannerStatics2(IBarcodeScannerStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IBarcodeScannerStatics2] {
    fn GetDeviceSelectorWithConnectionTypes(&self, connectionTypes: PosConnectionTypes, out: *mut HSTRING) -> HRESULT
}}
impl IBarcodeScannerStatics2 {
    #[inline] pub unsafe fn get_device_selector_with_connection_types(&self, connectionTypes: PosConnectionTypes) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorWithConnectionTypes)(self as *const _ as *mut _, connectionTypes, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBarcodeScanner, 3198369286, 45668, 20227, 169, 193, 69, 178, 15, 1, 19, 79);
RT_INTERFACE!{interface IBarcodeScanner(IBarcodeScannerVtbl): IInspectable(IInspectableVtbl) [IID_IBarcodeScanner] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Capabilities(&self, out: *mut *mut BarcodeScannerCapabilities) -> HRESULT,
    fn ClaimScannerAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<ClaimedBarcodeScanner>) -> HRESULT,
    fn CheckHealthAsync(&self, level: UnifiedPosHealthCheckLevel, out: *mut *mut super::super::foundation::IAsyncOperation<HString>) -> HRESULT,
    fn GetSupportedSymbologiesAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<u32>>) -> HRESULT,
    fn IsSymbologySupportedAsync(&self, barcodeSymbology: u32, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy6(&self) -> (),
    #[cfg(feature="windows-storage")] fn RetrieveStatisticsAsync(&self, statisticsCategories: *mut super::super::foundation::collections::IIterable<HString>, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::storage::streams::IBuffer>) -> HRESULT,
    fn GetSupportedProfiles(&self, out: *mut *mut super::super::foundation::collections::IVectorView<HString>) -> HRESULT,
    fn IsProfileSupported(&self, profile: HSTRING, out: *mut bool) -> HRESULT,
    fn add_StatusUpdated(&self, handler: *mut super::super::foundation::TypedEventHandler<BarcodeScanner, BarcodeScannerStatusUpdatedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_StatusUpdated(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IBarcodeScanner {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_capabilities(&self) -> Result<ComPtr<BarcodeScannerCapabilities>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Capabilities)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn claim_scanner_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ClaimedBarcodeScanner>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ClaimScannerAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn check_health_async(&self, level: UnifiedPosHealthCheckLevel) -> Result<ComPtr<super::super::foundation::IAsyncOperation<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CheckHealthAsync)(self as *const _ as *mut _, level, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_symbologies_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<u32>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetSupportedSymbologiesAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_symbology_supported_async(&self, barcodeSymbology: u32) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).IsSymbologySupportedAsync)(self as *const _ as *mut _, barcodeSymbology, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn retrieve_statistics_async(&self, statisticsCategories: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::storage::streams::IBuffer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RetrieveStatisticsAsync)(self as *const _ as *mut _, statisticsCategories as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_profiles(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetSupportedProfiles)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_profile_supported(&self, profile: &HStringArg) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsProfileSupported)(self as *const _ as *mut _, profile.get(), &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_status_updated(&self, handler: &super::super::foundation::TypedEventHandler<BarcodeScanner, BarcodeScannerStatusUpdatedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_StatusUpdated)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_status_updated(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_StatusUpdated)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class ClaimedBarcodeScanner: IClaimedBarcodeScanner}
DEFINE_IID!(IID_IBarcodeScanner2, 2300662119, 36078, 17261, 137, 171, 141, 251, 67, 187, 66, 134);
RT_INTERFACE!{interface IBarcodeScanner2(IBarcodeScanner2Vtbl): IInspectable(IInspectableVtbl) [IID_IBarcodeScanner2] {
    fn get_VideoDeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl IBarcodeScanner2 {
    #[inline] pub unsafe fn get_video_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_VideoDeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IClaimedBarcodeScanner, 1248048284, 36772, 17202, 187, 38, 148, 93, 17, 216, 30, 15);
RT_INTERFACE!{interface IClaimedBarcodeScanner(IClaimedBarcodeScannerVtbl): IInspectable(IInspectableVtbl) [IID_IClaimedBarcodeScanner] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_IsEnabled(&self, out: *mut bool) -> HRESULT,
    fn put_IsDisabledOnDataReceived(&self, value: bool) -> HRESULT,
    fn get_IsDisabledOnDataReceived(&self, out: *mut bool) -> HRESULT,
    fn put_IsDecodeDataEnabled(&self, value: bool) -> HRESULT,
    fn get_IsDecodeDataEnabled(&self, out: *mut bool) -> HRESULT,
    fn EnableAsync(&self, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn DisableAsync(&self, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn RetainDevice(&self) -> HRESULT,
    fn SetActiveSymbologiesAsync(&self, symbologies: *mut super::super::foundation::collections::IIterable<u32>, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn ResetStatisticsAsync(&self, statisticsCategories: *mut super::super::foundation::collections::IIterable<HString>, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn UpdateStatisticsAsync(&self, statistics: *mut super::super::foundation::collections::IIterable<super::super::foundation::collections::IKeyValuePair<HString, HString>>, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn SetActiveProfileAsync(&self, profile: HSTRING, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn add_DataReceived(&self, handler: *mut super::super::foundation::TypedEventHandler<ClaimedBarcodeScanner, BarcodeScannerDataReceivedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_DataReceived(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_TriggerPressed(&self, handler: *mut super::super::foundation::EventHandler<ClaimedBarcodeScanner>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_TriggerPressed(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_TriggerReleased(&self, handler: *mut super::super::foundation::EventHandler<ClaimedBarcodeScanner>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_TriggerReleased(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_ReleaseDeviceRequested(&self, handler: *mut super::super::foundation::EventHandler<ClaimedBarcodeScanner>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReleaseDeviceRequested(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_ImagePreviewReceived(&self, handler: *mut super::super::foundation::TypedEventHandler<ClaimedBarcodeScanner, BarcodeScannerImagePreviewReceivedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ImagePreviewReceived(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_ErrorOccurred(&self, handler: *mut super::super::foundation::TypedEventHandler<ClaimedBarcodeScanner, BarcodeScannerErrorOccurredEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ErrorOccurred(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IClaimedBarcodeScanner {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_disabled_on_data_received(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsDisabledOnDataReceived)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_disabled_on_data_received(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDisabledOnDataReceived)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_decode_data_enabled(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsDecodeDataEnabled)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_decode_data_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDecodeDataEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn enable_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).EnableAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn disable_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).DisableAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn retain_device(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).RetainDevice)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_active_symbologies_async(&self, symbologies: &super::super::foundation::collections::IIterable<u32>) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).SetActiveSymbologiesAsync)(self as *const _ as *mut _, symbologies as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn reset_statistics_async(&self, statisticsCategories: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ResetStatisticsAsync)(self as *const _ as *mut _, statisticsCategories as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn update_statistics_async(&self, statistics: &super::super::foundation::collections::IIterable<super::super::foundation::collections::IKeyValuePair<HString, HString>>) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).UpdateStatisticsAsync)(self as *const _ as *mut _, statistics as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_active_profile_async(&self, profile: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).SetActiveProfileAsync)(self as *const _ as *mut _, profile.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_data_received(&self, handler: &super::super::foundation::TypedEventHandler<ClaimedBarcodeScanner, BarcodeScannerDataReceivedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_DataReceived)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_data_received(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_DataReceived)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_trigger_pressed(&self, handler: &super::super::foundation::EventHandler<ClaimedBarcodeScanner>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_TriggerPressed)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_trigger_pressed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_TriggerPressed)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_trigger_released(&self, handler: &super::super::foundation::EventHandler<ClaimedBarcodeScanner>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_TriggerReleased)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_trigger_released(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_TriggerReleased)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_release_device_requested(&self, handler: &super::super::foundation::EventHandler<ClaimedBarcodeScanner>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReleaseDeviceRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_release_device_requested(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReleaseDeviceRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_image_preview_received(&self, handler: &super::super::foundation::TypedEventHandler<ClaimedBarcodeScanner, BarcodeScannerImagePreviewReceivedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ImagePreviewReceived)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_image_preview_received(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ImagePreviewReceived)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_error_occurred(&self, handler: &super::super::foundation::TypedEventHandler<ClaimedBarcodeScanner, BarcodeScannerErrorOccurredEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ErrorOccurred)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_error_occurred(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ErrorOccurred)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IClaimedBarcodeScanner1, 4128943372, 34129, 17076, 153, 140, 151, 12, 32, 33, 10, 34);
RT_INTERFACE!{interface IClaimedBarcodeScanner1(IClaimedBarcodeScanner1Vtbl): IInspectable(IInspectableVtbl) [IID_IClaimedBarcodeScanner1] {
    fn StartSoftwareTriggerAsync(&self, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn StopSoftwareTriggerAsync(&self, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT
}}
impl IClaimedBarcodeScanner1 {
    #[inline] pub unsafe fn start_software_trigger_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).StartSoftwareTriggerAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop_software_trigger_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).StopSoftwareTriggerAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IClaimedBarcodeScanner2, 3820330636, 11659, 20336, 138, 243, 52, 72, 190, 221, 95, 226);
RT_INTERFACE!{interface IClaimedBarcodeScanner2(IClaimedBarcodeScanner2Vtbl): IInspectable(IInspectableVtbl) [IID_IClaimedBarcodeScanner2] {
    fn GetSymbologyAttributesAsync(&self, barcodeSymbology: u32, out: *mut *mut super::super::foundation::IAsyncOperation<BarcodeSymbologyAttributes>) -> HRESULT,
    fn SetSymbologyAttributesAsync(&self, barcodeSymbology: u32, attributes: *mut BarcodeSymbologyAttributes, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT
}}
impl IClaimedBarcodeScanner2 {
    #[inline] pub unsafe fn get_symbology_attributes_async(&self, barcodeSymbology: u32) -> Result<ComPtr<super::super::foundation::IAsyncOperation<BarcodeSymbologyAttributes>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetSymbologyAttributesAsync)(self as *const _ as *mut _, barcodeSymbology, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_symbology_attributes_async(&self, barcodeSymbology: u32, attributes: &BarcodeSymbologyAttributes) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).SetSymbologyAttributesAsync)(self as *const _ as *mut _, barcodeSymbology, attributes as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_ENUM! { enum MagneticStripeReaderStatus: i32 {
    Unauthenticated (MagneticStripeReaderStatus_Unauthenticated) = 0, Authenticated (MagneticStripeReaderStatus_Authenticated) = 1, Extended (MagneticStripeReaderStatus_Extended) = 2,
}}
RT_ENUM! { enum MagneticStripeReaderAuthenticationProtocol: i32 {
    None (MagneticStripeReaderAuthenticationProtocol_None) = 0, ChallengeResponse (MagneticStripeReaderAuthenticationProtocol_ChallengeResponse) = 1,
}}
RT_ENUM! { enum MagneticStripeReaderTrackIds: i32 {
    None (MagneticStripeReaderTrackIds_None) = 0, Track1 (MagneticStripeReaderTrackIds_Track1) = 1, Track2 (MagneticStripeReaderTrackIds_Track2) = 2, Track3 (MagneticStripeReaderTrackIds_Track3) = 4, Track4 (MagneticStripeReaderTrackIds_Track4) = 8,
}}
RT_ENUM! { enum MagneticStripeReaderErrorReportingType: i32 {
    CardLevel (MagneticStripeReaderErrorReportingType_CardLevel) = 0, TrackLevel (MagneticStripeReaderErrorReportingType_TrackLevel) = 1,
}}
RT_ENUM! { enum MagneticStripeReaderTrackErrorType: i32 {
    None (MagneticStripeReaderTrackErrorType_None) = 0, StartSentinelError (MagneticStripeReaderTrackErrorType_StartSentinelError) = 1, EndSentinelError (MagneticStripeReaderTrackErrorType_EndSentinelError) = 2, ParityError (MagneticStripeReaderTrackErrorType_ParityError) = 3, LrcError (MagneticStripeReaderTrackErrorType_LrcError) = 4, Unknown (MagneticStripeReaderTrackErrorType_Unknown) = -1,
}}
DEFINE_IID!(IID_IMagneticStripeReaderEncryptionAlgorithmsStatics, 1404400464, 50139, 18260, 156, 0, 65, 57, 35, 116, 161, 9);
RT_INTERFACE!{static interface IMagneticStripeReaderEncryptionAlgorithmsStatics(IMagneticStripeReaderEncryptionAlgorithmsStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IMagneticStripeReaderEncryptionAlgorithmsStatics] {
    fn get_None(&self, out: *mut u32) -> HRESULT,
    fn get_TripleDesDukpt(&self, out: *mut u32) -> HRESULT,
    fn get_ExtendedBase(&self, out: *mut u32) -> HRESULT
}}
impl IMagneticStripeReaderEncryptionAlgorithmsStatics {
    #[inline] pub unsafe fn get_none(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_None)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_triple_des_dukpt(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TripleDesDukpt)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_extended_base(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ExtendedBase)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{static class MagneticStripeReaderEncryptionAlgorithms}
impl RtActivatable<IMagneticStripeReaderEncryptionAlgorithmsStatics> for MagneticStripeReaderEncryptionAlgorithms {}
impl MagneticStripeReaderEncryptionAlgorithms {
    #[inline] pub fn get_none() -> Result<u32> { unsafe {
        <Self as RtActivatable<IMagneticStripeReaderEncryptionAlgorithmsStatics>>::get_activation_factory().get_none()
    }}
    #[inline] pub fn get_triple_des_dukpt() -> Result<u32> { unsafe {
        <Self as RtActivatable<IMagneticStripeReaderEncryptionAlgorithmsStatics>>::get_activation_factory().get_triple_des_dukpt()
    }}
    #[inline] pub fn get_extended_base() -> Result<u32> { unsafe {
        <Self as RtActivatable<IMagneticStripeReaderEncryptionAlgorithmsStatics>>::get_activation_factory().get_extended_base()
    }}
}
DEFINE_CLSID!(MagneticStripeReaderEncryptionAlgorithms(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,111,105,110,116,79,102,83,101,114,118,105,99,101,46,77,97,103,110,101,116,105,99,83,116,114,105,112,101,82,101,97,100,101,114,69,110,99,114,121,112,116,105,111,110,65,108,103,111,114,105,116,104,109,115,0]) [CLSID_MagneticStripeReaderEncryptionAlgorithms]);
DEFINE_IID!(IID_IMagneticStripeReaderCardTypesStatics, 1385114717, 10630, 18255, 132, 84, 124, 205, 5, 146, 141, 95);
RT_INTERFACE!{static interface IMagneticStripeReaderCardTypesStatics(IMagneticStripeReaderCardTypesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IMagneticStripeReaderCardTypesStatics] {
    fn get_Unknown(&self, out: *mut u32) -> HRESULT,
    fn get_Bank(&self, out: *mut u32) -> HRESULT,
    fn get_Aamva(&self, out: *mut u32) -> HRESULT,
    fn get_ExtendedBase(&self, out: *mut u32) -> HRESULT
}}
impl IMagneticStripeReaderCardTypesStatics {
    #[inline] pub unsafe fn get_unknown(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Unknown)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bank(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Bank)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_aamva(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Aamva)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_extended_base(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ExtendedBase)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{static class MagneticStripeReaderCardTypes}
impl RtActivatable<IMagneticStripeReaderCardTypesStatics> for MagneticStripeReaderCardTypes {}
impl MagneticStripeReaderCardTypes {
    #[inline] pub fn get_unknown() -> Result<u32> { unsafe {
        <Self as RtActivatable<IMagneticStripeReaderCardTypesStatics>>::get_activation_factory().get_unknown()
    }}
    #[inline] pub fn get_bank() -> Result<u32> { unsafe {
        <Self as RtActivatable<IMagneticStripeReaderCardTypesStatics>>::get_activation_factory().get_bank()
    }}
    #[inline] pub fn get_aamva() -> Result<u32> { unsafe {
        <Self as RtActivatable<IMagneticStripeReaderCardTypesStatics>>::get_activation_factory().get_aamva()
    }}
    #[inline] pub fn get_extended_base() -> Result<u32> { unsafe {
        <Self as RtActivatable<IMagneticStripeReaderCardTypesStatics>>::get_activation_factory().get_extended_base()
    }}
}
DEFINE_CLSID!(MagneticStripeReaderCardTypes(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,111,105,110,116,79,102,83,101,114,118,105,99,101,46,77,97,103,110,101,116,105,99,83,116,114,105,112,101,82,101,97,100,101,114,67,97,114,100,84,121,112,101,115,0]) [CLSID_MagneticStripeReaderCardTypes]);
DEFINE_IID!(IID_IMagneticStripeReaderTrackData, 273479281, 19101, 17518, 171, 197, 32, 64, 35, 7, 186, 54);
RT_INTERFACE!{interface IMagneticStripeReaderTrackData(IMagneticStripeReaderTrackDataVtbl): IInspectable(IInspectableVtbl) [IID_IMagneticStripeReaderTrackData] {
    #[cfg(feature="windows-storage")] fn get_Data(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_DiscretionaryData(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_EncryptedData(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT
}}
impl IMagneticStripeReaderTrackData {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_data(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Data)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_discretionary_data(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DiscretionaryData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_encrypted_data(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_EncryptedData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMagneticStripeReaderReport, 1784373319, 39344, 16776, 190, 241, 237, 223, 121, 247, 143, 230);
RT_INTERFACE!{interface IMagneticStripeReaderReport(IMagneticStripeReaderReportVtbl): IInspectable(IInspectableVtbl) [IID_IMagneticStripeReaderReport] {
    fn get_CardType(&self, out: *mut u32) -> HRESULT,
    fn get_Track1(&self, out: *mut *mut MagneticStripeReaderTrackData) -> HRESULT,
    fn get_Track2(&self, out: *mut *mut MagneticStripeReaderTrackData) -> HRESULT,
    fn get_Track3(&self, out: *mut *mut MagneticStripeReaderTrackData) -> HRESULT,
    fn get_Track4(&self, out: *mut *mut MagneticStripeReaderTrackData) -> HRESULT,
    fn get_Properties(&self, out: *mut *mut super::super::foundation::collections::IMapView<HString, HString>) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_CardAuthenticationData(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT,
    fn get_CardAuthenticationDataLength(&self, out: *mut u32) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_AdditionalSecurityInformation(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT
}}
impl IMagneticStripeReaderReport {
    #[inline] pub unsafe fn get_card_type(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CardType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_track1(&self) -> Result<ComPtr<MagneticStripeReaderTrackData>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Track1)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_track2(&self) -> Result<ComPtr<MagneticStripeReaderTrackData>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Track2)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_track3(&self) -> Result<ComPtr<MagneticStripeReaderTrackData>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Track3)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_track4(&self) -> Result<ComPtr<MagneticStripeReaderTrackData>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Track4)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_properties(&self) -> Result<ComPtr<super::super::foundation::collections::IMapView<HString, HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Properties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_card_authentication_data(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_CardAuthenticationData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_card_authentication_data_length(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CardAuthenticationDataLength)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_additional_security_information(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AdditionalSecurityInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MagneticStripeReaderTrackData: IMagneticStripeReaderTrackData}
DEFINE_IID!(IID_IMagneticStripeReaderBankCardDataReceivedEventArgs, 781551651, 41754, 18275, 136, 44, 35, 114, 94, 57, 176, 142);
RT_INTERFACE!{interface IMagneticStripeReaderBankCardDataReceivedEventArgs(IMagneticStripeReaderBankCardDataReceivedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IMagneticStripeReaderBankCardDataReceivedEventArgs] {
    fn get_Report(&self, out: *mut *mut MagneticStripeReaderReport) -> HRESULT,
    fn get_AccountNumber(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ExpirationDate(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ServiceCode(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Title(&self, out: *mut HSTRING) -> HRESULT,
    fn get_FirstName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_MiddleInitial(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Surname(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Suffix(&self, out: *mut HSTRING) -> HRESULT
}}
impl IMagneticStripeReaderBankCardDataReceivedEventArgs {
    #[inline] pub unsafe fn get_report(&self) -> Result<ComPtr<MagneticStripeReaderReport>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Report)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_account_number(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AccountNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_expiration_date(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ExpirationDate)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_code(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ServiceCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_title(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Title)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_first_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FirstName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_middle_initial(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_MiddleInitial)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_surname(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Surname)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_suffix(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Suffix)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MagneticStripeReaderReport: IMagneticStripeReaderReport}
DEFINE_IID!(IID_IMagneticStripeReaderAamvaCardDataReceivedEventArgs, 172735825, 49942, 18704, 135, 243, 122, 98, 186, 134, 45, 49);
RT_INTERFACE!{interface IMagneticStripeReaderAamvaCardDataReceivedEventArgs(IMagneticStripeReaderAamvaCardDataReceivedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IMagneticStripeReaderAamvaCardDataReceivedEventArgs] {
    fn get_Report(&self, out: *mut *mut MagneticStripeReaderReport) -> HRESULT,
    fn get_LicenseNumber(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ExpirationDate(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Restrictions(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Class(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Endorsements(&self, out: *mut HSTRING) -> HRESULT,
    fn get_BirthDate(&self, out: *mut HSTRING) -> HRESULT,
    fn get_FirstName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Surname(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Suffix(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Gender(&self, out: *mut HSTRING) -> HRESULT,
    fn get_HairColor(&self, out: *mut HSTRING) -> HRESULT,
    fn get_EyeColor(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Height(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Weight(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Address(&self, out: *mut HSTRING) -> HRESULT,
    fn get_City(&self, out: *mut HSTRING) -> HRESULT,
    fn get_State(&self, out: *mut HSTRING) -> HRESULT,
    fn get_PostalCode(&self, out: *mut HSTRING) -> HRESULT
}}
impl IMagneticStripeReaderAamvaCardDataReceivedEventArgs {
    #[inline] pub unsafe fn get_report(&self) -> Result<ComPtr<MagneticStripeReaderReport>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Report)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_license_number(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_LicenseNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_expiration_date(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ExpirationDate)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_restrictions(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Restrictions)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_class(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Class)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_endorsements(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Endorsements)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_birth_date(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BirthDate)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_first_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FirstName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_surname(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Surname)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_suffix(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Suffix)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_gender(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Gender)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_hair_color(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_HairColor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_eye_color(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_EyeColor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_height(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Height)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_weight(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Weight)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_address(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Address)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_city(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_City)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_state(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_State)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_postal_code(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PostalCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMagneticStripeReaderVendorSpecificCardDataReceivedEventArgs, 2936689940, 22988, 19040, 153, 232, 153, 165, 61, 172, 229, 170);
RT_INTERFACE!{interface IMagneticStripeReaderVendorSpecificCardDataReceivedEventArgs(IMagneticStripeReaderVendorSpecificCardDataReceivedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IMagneticStripeReaderVendorSpecificCardDataReceivedEventArgs] {
    fn get_Report(&self, out: *mut *mut MagneticStripeReaderReport) -> HRESULT
}}
impl IMagneticStripeReaderVendorSpecificCardDataReceivedEventArgs {
    #[inline] pub unsafe fn get_report(&self) -> Result<ComPtr<MagneticStripeReaderReport>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Report)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMagneticStripeReaderErrorOccurredEventArgs, 535689565, 11396, 16813, 183, 120, 242, 53, 106, 120, 154, 177);
RT_INTERFACE!{interface IMagneticStripeReaderErrorOccurredEventArgs(IMagneticStripeReaderErrorOccurredEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IMagneticStripeReaderErrorOccurredEventArgs] {
    fn get_Track1Status(&self, out: *mut MagneticStripeReaderTrackErrorType) -> HRESULT,
    fn get_Track2Status(&self, out: *mut MagneticStripeReaderTrackErrorType) -> HRESULT,
    fn get_Track3Status(&self, out: *mut MagneticStripeReaderTrackErrorType) -> HRESULT,
    fn get_Track4Status(&self, out: *mut MagneticStripeReaderTrackErrorType) -> HRESULT,
    fn get_ErrorData(&self, out: *mut *mut UnifiedPosErrorData) -> HRESULT,
    fn get_PartialInputData(&self, out: *mut *mut MagneticStripeReaderReport) -> HRESULT
}}
impl IMagneticStripeReaderErrorOccurredEventArgs {
    #[inline] pub unsafe fn get_track1_status(&self) -> Result<MagneticStripeReaderTrackErrorType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Track1Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_track2_status(&self) -> Result<MagneticStripeReaderTrackErrorType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Track2Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_track3_status(&self) -> Result<MagneticStripeReaderTrackErrorType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Track3Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_track4_status(&self) -> Result<MagneticStripeReaderTrackErrorType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Track4Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_error_data(&self) -> Result<ComPtr<UnifiedPosErrorData>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ErrorData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_partial_input_data(&self) -> Result<ComPtr<MagneticStripeReaderReport>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PartialInputData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMagneticStripeReaderStatusUpdatedEventArgs, 164391856, 12898, 16413, 158, 138, 232, 13, 99, 88, 144, 107);
RT_INTERFACE!{interface IMagneticStripeReaderStatusUpdatedEventArgs(IMagneticStripeReaderStatusUpdatedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IMagneticStripeReaderStatusUpdatedEventArgs] {
    fn get_Status(&self, out: *mut MagneticStripeReaderStatus) -> HRESULT,
    fn get_ExtendedStatus(&self, out: *mut u32) -> HRESULT
}}
impl IMagneticStripeReaderStatusUpdatedEventArgs {
    #[inline] pub unsafe fn get_status(&self) -> Result<MagneticStripeReaderStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_extended_status(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ExtendedStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class MagneticStripeReaderBankCardDataReceivedEventArgs: IMagneticStripeReaderBankCardDataReceivedEventArgs}
RT_CLASS!{class MagneticStripeReaderAamvaCardDataReceivedEventArgs: IMagneticStripeReaderAamvaCardDataReceivedEventArgs}
RT_CLASS!{class MagneticStripeReaderVendorSpecificCardDataReceivedEventArgs: IMagneticStripeReaderVendorSpecificCardDataReceivedEventArgs}
RT_CLASS!{class MagneticStripeReaderErrorOccurredEventArgs: IMagneticStripeReaderErrorOccurredEventArgs}
RT_CLASS!{class MagneticStripeReaderStatusUpdatedEventArgs: IMagneticStripeReaderStatusUpdatedEventArgs}
DEFINE_IID!(IID_IMagneticStripeReaderCapabilities, 1898479772, 50240, 17570, 164, 103, 70, 145, 117, 208, 40, 150);
RT_INTERFACE!{interface IMagneticStripeReaderCapabilities(IMagneticStripeReaderCapabilitiesVtbl): IInspectable(IInspectableVtbl) [IID_IMagneticStripeReaderCapabilities] {
    fn get_CardAuthentication(&self, out: *mut HSTRING) -> HRESULT,
    fn get_SupportedEncryptionAlgorithms(&self, out: *mut u32) -> HRESULT,
    fn get_AuthenticationLevel(&self, out: *mut MagneticStripeReaderAuthenticationLevel) -> HRESULT,
    fn get_IsIsoSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsJisOneSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsJisTwoSupported(&self, out: *mut bool) -> HRESULT,
    fn get_PowerReportingType(&self, out: *mut UnifiedPosPowerReportingType) -> HRESULT,
    fn get_IsStatisticsReportingSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsStatisticsUpdatingSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsTrackDataMaskingSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsTransmitSentinelsSupported(&self, out: *mut bool) -> HRESULT
}}
impl IMagneticStripeReaderCapabilities {
    #[inline] pub unsafe fn get_card_authentication(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_CardAuthentication)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_encryption_algorithms(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SupportedEncryptionAlgorithms)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_authentication_level(&self) -> Result<MagneticStripeReaderAuthenticationLevel> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AuthenticationLevel)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_iso_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsIsoSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_jis_one_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsJisOneSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_jis_two_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsJisTwoSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_power_reporting_type(&self) -> Result<UnifiedPosPowerReportingType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PowerReportingType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_statistics_reporting_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStatisticsReportingSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_statistics_updating_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStatisticsUpdatingSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_track_data_masking_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsTrackDataMaskingSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_transmit_sentinels_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsTransmitSentinelsSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class MagneticStripeReaderCapabilities: IMagneticStripeReaderCapabilities}
DEFINE_IID!(IID_IClaimedMagneticStripeReader, 1197254899, 37911, 18620, 185, 215, 65, 99, 167, 132, 76, 2);
RT_INTERFACE!{interface IClaimedMagneticStripeReader(IClaimedMagneticStripeReaderVtbl): IInspectable(IInspectableVtbl) [IID_IClaimedMagneticStripeReader] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_IsEnabled(&self, out: *mut bool) -> HRESULT,
    fn put_IsDisabledOnDataReceived(&self, value: bool) -> HRESULT,
    fn get_IsDisabledOnDataReceived(&self, out: *mut bool) -> HRESULT,
    fn put_IsDecodeDataEnabled(&self, value: bool) -> HRESULT,
    fn get_IsDecodeDataEnabled(&self, out: *mut bool) -> HRESULT,
    fn get_IsDeviceAuthenticated(&self, out: *mut bool) -> HRESULT,
    fn put_DataEncryptionAlgorithm(&self, value: u32) -> HRESULT,
    fn get_DataEncryptionAlgorithm(&self, out: *mut u32) -> HRESULT,
    fn put_TracksToRead(&self, value: MagneticStripeReaderTrackIds) -> HRESULT,
    fn get_TracksToRead(&self, out: *mut MagneticStripeReaderTrackIds) -> HRESULT,
    fn put_IsTransmitSentinelsEnabled(&self, value: bool) -> HRESULT,
    fn get_IsTransmitSentinelsEnabled(&self, out: *mut bool) -> HRESULT,
    fn EnableAsync(&self, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn DisableAsync(&self, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn RetainDevice(&self) -> HRESULT,
    fn SetErrorReportingType(&self, value: MagneticStripeReaderErrorReportingType) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy17(&self) -> (),
    #[cfg(feature="windows-storage")] fn RetrieveDeviceAuthenticationDataAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::storage::streams::IBuffer>) -> HRESULT,
    fn AuthenticateDeviceAsync(&self, responseTokenSize: u32, responseToken: *mut u8, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn DeAuthenticateDeviceAsync(&self, responseTokenSize: u32, responseToken: *mut u8, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn UpdateKeyAsync(&self, key: HSTRING, keyName: HSTRING, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn ResetStatisticsAsync(&self, statisticsCategories: *mut super::super::foundation::collections::IIterable<HString>, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn UpdateStatisticsAsync(&self, statistics: *mut super::super::foundation::collections::IIterable<super::super::foundation::collections::IKeyValuePair<HString, HString>>, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn add_BankCardDataReceived(&self, handler: *mut super::super::foundation::TypedEventHandler<ClaimedMagneticStripeReader, MagneticStripeReaderBankCardDataReceivedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_BankCardDataReceived(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_AamvaCardDataReceived(&self, handler: *mut super::super::foundation::TypedEventHandler<ClaimedMagneticStripeReader, MagneticStripeReaderAamvaCardDataReceivedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_AamvaCardDataReceived(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_VendorSpecificDataReceived(&self, handler: *mut super::super::foundation::TypedEventHandler<ClaimedMagneticStripeReader, MagneticStripeReaderVendorSpecificCardDataReceivedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_VendorSpecificDataReceived(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_ReleaseDeviceRequested(&self, handler: *mut super::super::foundation::EventHandler<ClaimedMagneticStripeReader>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReleaseDeviceRequested(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_ErrorOccurred(&self, handler: *mut super::super::foundation::TypedEventHandler<ClaimedMagneticStripeReader, MagneticStripeReaderErrorOccurredEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ErrorOccurred(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IClaimedMagneticStripeReader {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_disabled_on_data_received(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsDisabledOnDataReceived)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_disabled_on_data_received(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDisabledOnDataReceived)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_decode_data_enabled(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsDecodeDataEnabled)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_decode_data_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDecodeDataEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_device_authenticated(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDeviceAuthenticated)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_data_encryption_algorithm(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DataEncryptionAlgorithm)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_data_encryption_algorithm(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DataEncryptionAlgorithm)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_tracks_to_read(&self, value: MagneticStripeReaderTrackIds) -> Result<()> {
        let hr = ((*self.lpVtbl).put_TracksToRead)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_tracks_to_read(&self) -> Result<MagneticStripeReaderTrackIds> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_TracksToRead)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_transmit_sentinels_enabled(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsTransmitSentinelsEnabled)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_transmit_sentinels_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsTransmitSentinelsEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn enable_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).EnableAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn disable_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).DisableAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn retain_device(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).RetainDevice)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_error_reporting_type(&self, value: MagneticStripeReaderErrorReportingType) -> Result<()> {
        let hr = ((*self.lpVtbl).SetErrorReportingType)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn retrieve_device_authentication_data_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::storage::streams::IBuffer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RetrieveDeviceAuthenticationDataAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn authenticate_device_async(&self, responseToken: &[u8]) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).AuthenticateDeviceAsync)(self as *const _ as *mut _, responseToken.len() as u32, responseToken.as_ptr() as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn de_authenticate_device_async(&self, responseToken: &[u8]) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).DeAuthenticateDeviceAsync)(self as *const _ as *mut _, responseToken.len() as u32, responseToken.as_ptr() as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn update_key_async(&self, key: &HStringArg, keyName: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).UpdateKeyAsync)(self as *const _ as *mut _, key.get(), keyName.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn reset_statistics_async(&self, statisticsCategories: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ResetStatisticsAsync)(self as *const _ as *mut _, statisticsCategories as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn update_statistics_async(&self, statistics: &super::super::foundation::collections::IIterable<super::super::foundation::collections::IKeyValuePair<HString, HString>>) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).UpdateStatisticsAsync)(self as *const _ as *mut _, statistics as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_bank_card_data_received(&self, handler: &super::super::foundation::TypedEventHandler<ClaimedMagneticStripeReader, MagneticStripeReaderBankCardDataReceivedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_BankCardDataReceived)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_bank_card_data_received(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_BankCardDataReceived)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_aamva_card_data_received(&self, handler: &super::super::foundation::TypedEventHandler<ClaimedMagneticStripeReader, MagneticStripeReaderAamvaCardDataReceivedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_AamvaCardDataReceived)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_aamva_card_data_received(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_AamvaCardDataReceived)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_vendor_specific_data_received(&self, handler: &super::super::foundation::TypedEventHandler<ClaimedMagneticStripeReader, MagneticStripeReaderVendorSpecificCardDataReceivedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_VendorSpecificDataReceived)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_vendor_specific_data_received(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_VendorSpecificDataReceived)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_release_device_requested(&self, handler: &super::super::foundation::EventHandler<ClaimedMagneticStripeReader>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReleaseDeviceRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_release_device_requested(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReleaseDeviceRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_error_occurred(&self, handler: &super::super::foundation::TypedEventHandler<ClaimedMagneticStripeReader, MagneticStripeReaderErrorOccurredEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ErrorOccurred)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_error_occurred(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ErrorOccurred)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class ClaimedMagneticStripeReader: IClaimedMagneticStripeReader}
DEFINE_IID!(IID_IMagneticStripeReaderStatics, 3294604106, 61399, 18272, 165, 206, 21, 176, 228, 126, 148, 235);
RT_INTERFACE!{static interface IMagneticStripeReaderStatics(IMagneticStripeReaderStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IMagneticStripeReaderStatics] {
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<MagneticStripeReader>) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<MagneticStripeReader>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT
}}
impl IMagneticStripeReaderStatics {
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<MagneticStripeReader>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<MagneticStripeReader>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class MagneticStripeReader: IMagneticStripeReader}
impl RtActivatable<IMagneticStripeReaderStatics2> for MagneticStripeReader {}
impl RtActivatable<IMagneticStripeReaderStatics> for MagneticStripeReader {}
impl MagneticStripeReader {
    #[inline] pub fn get_device_selector_with_connection_types(connectionTypes: PosConnectionTypes) -> Result<HString> { unsafe {
        <Self as RtActivatable<IMagneticStripeReaderStatics2>>::get_activation_factory().get_device_selector_with_connection_types(connectionTypes)
    }}
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<MagneticStripeReader>>> { unsafe {
        <Self as RtActivatable<IMagneticStripeReaderStatics>>::get_activation_factory().get_default_async()
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<MagneticStripeReader>>> { unsafe {
        <Self as RtActivatable<IMagneticStripeReaderStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IMagneticStripeReaderStatics>>::get_activation_factory().get_device_selector()
    }}
}
DEFINE_CLSID!(MagneticStripeReader(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,111,105,110,116,79,102,83,101,114,118,105,99,101,46,77,97,103,110,101,116,105,99,83,116,114,105,112,101,82,101,97,100,101,114,0]) [CLSID_MagneticStripeReader]);
DEFINE_IID!(IID_IMagneticStripeReaderStatics2, 2360197986, 54887, 18682, 134, 188, 245, 174, 17, 137, 38, 43);
RT_INTERFACE!{static interface IMagneticStripeReaderStatics2(IMagneticStripeReaderStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IMagneticStripeReaderStatics2] {
    fn GetDeviceSelectorWithConnectionTypes(&self, connectionTypes: PosConnectionTypes, out: *mut HSTRING) -> HRESULT
}}
impl IMagneticStripeReaderStatics2 {
    #[inline] pub unsafe fn get_device_selector_with_connection_types(&self, connectionTypes: PosConnectionTypes) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorWithConnectionTypes)(self as *const _ as *mut _, connectionTypes, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMagneticStripeReader, 445820949, 18371, 18058, 147, 51, 12, 101, 23, 87, 72, 131);
RT_INTERFACE!{interface IMagneticStripeReader(IMagneticStripeReaderVtbl): IInspectable(IInspectableVtbl) [IID_IMagneticStripeReader] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Capabilities(&self, out: *mut *mut MagneticStripeReaderCapabilities) -> HRESULT,
    fn get_SupportedCardTypes(&self, outSize: *mut u32, out: *mut *mut u32) -> HRESULT,
    fn get_DeviceAuthenticationProtocol(&self, out: *mut MagneticStripeReaderAuthenticationProtocol) -> HRESULT,
    fn CheckHealthAsync(&self, level: UnifiedPosHealthCheckLevel, out: *mut *mut super::super::foundation::IAsyncOperation<HString>) -> HRESULT,
    fn ClaimReaderAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<ClaimedMagneticStripeReader>) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy6(&self) -> (),
    #[cfg(feature="windows-storage")] fn RetrieveStatisticsAsync(&self, statisticsCategories: *mut super::super::foundation::collections::IIterable<HString>, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::storage::streams::IBuffer>) -> HRESULT,
    fn GetErrorReportingType(&self, out: *mut MagneticStripeReaderErrorReportingType) -> HRESULT,
    fn add_StatusUpdated(&self, handler: *mut super::super::foundation::TypedEventHandler<MagneticStripeReader, MagneticStripeReaderStatusUpdatedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_StatusUpdated(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IMagneticStripeReader {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_capabilities(&self) -> Result<ComPtr<MagneticStripeReaderCapabilities>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Capabilities)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_card_types(&self) -> Result<ComArray<u32>> {
        let mut outSize = 0; let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedCardTypes)(self as *const _ as *mut _, &mut outSize, &mut out);
        if hr == S_OK { Ok(ComArray::from_raw(outSize, out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_authentication_protocol(&self) -> Result<MagneticStripeReaderAuthenticationProtocol> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DeviceAuthenticationProtocol)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn check_health_async(&self, level: UnifiedPosHealthCheckLevel) -> Result<ComPtr<super::super::foundation::IAsyncOperation<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CheckHealthAsync)(self as *const _ as *mut _, level, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn claim_reader_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ClaimedMagneticStripeReader>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ClaimReaderAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn retrieve_statistics_async(&self, statisticsCategories: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::storage::streams::IBuffer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RetrieveStatisticsAsync)(self as *const _ as *mut _, statisticsCategories as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_error_reporting_type(&self) -> Result<MagneticStripeReaderErrorReportingType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).GetErrorReportingType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_status_updated(&self, handler: &super::super::foundation::TypedEventHandler<MagneticStripeReader, MagneticStripeReaderStatusUpdatedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_StatusUpdated)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_status_updated(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_StatusUpdated)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPosPrinterCharacterSetIdsStatics, 1550884607, 28826, 20455, 178, 21, 6, 167, 72, 163, 139, 57);
RT_INTERFACE!{static interface IPosPrinterCharacterSetIdsStatics(IPosPrinterCharacterSetIdsStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IPosPrinterCharacterSetIdsStatics] {
    fn get_Utf16LE(&self, out: *mut u32) -> HRESULT,
    fn get_Ascii(&self, out: *mut u32) -> HRESULT,
    fn get_Ansi(&self, out: *mut u32) -> HRESULT
}}
impl IPosPrinterCharacterSetIdsStatics {
    #[inline] pub unsafe fn get_utf16_le(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Utf16LE)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ascii(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ascii)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ansi(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Ansi)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{static class PosPrinterCharacterSetIds}
impl RtActivatable<IPosPrinterCharacterSetIdsStatics> for PosPrinterCharacterSetIds {}
impl PosPrinterCharacterSetIds {
    #[inline] pub fn get_utf16_le() -> Result<u32> { unsafe {
        <Self as RtActivatable<IPosPrinterCharacterSetIdsStatics>>::get_activation_factory().get_utf16_le()
    }}
    #[inline] pub fn get_ascii() -> Result<u32> { unsafe {
        <Self as RtActivatable<IPosPrinterCharacterSetIdsStatics>>::get_activation_factory().get_ascii()
    }}
    #[inline] pub fn get_ansi() -> Result<u32> { unsafe {
        <Self as RtActivatable<IPosPrinterCharacterSetIdsStatics>>::get_activation_factory().get_ansi()
    }}
}
DEFINE_CLSID!(PosPrinterCharacterSetIds(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,111,105,110,116,79,102,83,101,114,118,105,99,101,46,80,111,115,80,114,105,110,116,101,114,67,104,97,114,97,99,116,101,114,83,101,116,73,100,115,0]) [CLSID_PosPrinterCharacterSetIds]);
DEFINE_IID!(IID_ICommonPosPrintStationCapabilities, 3730526922, 57390, 16617, 158, 94, 27, 72, 142, 106, 172, 252);
RT_INTERFACE!{interface ICommonPosPrintStationCapabilities(ICommonPosPrintStationCapabilitiesVtbl): IInspectable(IInspectableVtbl) [IID_ICommonPosPrintStationCapabilities] {
    fn get_IsPrinterPresent(&self, out: *mut bool) -> HRESULT,
    fn get_IsDualColorSupported(&self, out: *mut bool) -> HRESULT,
    fn get_ColorCartridgeCapabilities(&self, out: *mut PosPrinterColorCapabilities) -> HRESULT,
    fn get_CartridgeSensors(&self, out: *mut PosPrinterCartridgeSensors) -> HRESULT,
    fn get_IsBoldSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsItalicSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsUnderlineSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsDoubleHighPrintSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsDoubleWidePrintSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsDoubleHighDoubleWidePrintSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsPaperEmptySensorSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsPaperNearEndSensorSupported(&self, out: *mut bool) -> HRESULT,
    fn get_SupportedCharactersPerLine(&self, out: *mut *mut super::super::foundation::collections::IVectorView<u32>) -> HRESULT
}}
impl ICommonPosPrintStationCapabilities {
    #[inline] pub unsafe fn get_is_printer_present(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsPrinterPresent)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_dual_color_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDualColorSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_color_cartridge_capabilities(&self) -> Result<PosPrinterColorCapabilities> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ColorCartridgeCapabilities)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cartridge_sensors(&self) -> Result<PosPrinterCartridgeSensors> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CartridgeSensors)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_bold_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsBoldSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_italic_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsItalicSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_underline_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsUnderlineSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_double_high_print_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDoubleHighPrintSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_double_wide_print_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDoubleWidePrintSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_double_high_double_wide_print_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDoubleHighDoubleWidePrintSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_paper_empty_sensor_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsPaperEmptySensorSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_paper_near_end_sensor_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsPaperNearEndSensorSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_characters_per_line(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<u32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedCharactersPerLine)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ICommonReceiptSlipCapabilities, 153643915, 39027, 19717, 191, 190, 71, 39, 166, 3, 143, 105);
RT_INTERFACE!{interface ICommonReceiptSlipCapabilities(ICommonReceiptSlipCapabilitiesVtbl): IInspectable(IInspectableVtbl) [IID_ICommonReceiptSlipCapabilities] {
    fn get_IsBarcodeSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsBitmapSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsLeft90RotationSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsRight90RotationSupported(&self, out: *mut bool) -> HRESULT,
    fn get_Is180RotationSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsPrintAreaSupported(&self, out: *mut bool) -> HRESULT,
    fn get_RuledLineCapabilities(&self, out: *mut PosPrinterRuledLineCapabilities) -> HRESULT,
    fn get_SupportedBarcodeRotations(&self, out: *mut *mut super::super::foundation::collections::IVectorView<PosPrinterRotation>) -> HRESULT,
    fn get_SupportedBitmapRotations(&self, out: *mut *mut super::super::foundation::collections::IVectorView<PosPrinterRotation>) -> HRESULT
}}
impl ICommonReceiptSlipCapabilities {
    #[inline] pub unsafe fn get_is_barcode_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsBarcodeSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_bitmap_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsBitmapSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_left90_rotation_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsLeft90RotationSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_right90_rotation_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsRight90RotationSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is180_rotation_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Is180RotationSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_print_area_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsPrintAreaSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ruled_line_capabilities(&self) -> Result<PosPrinterRuledLineCapabilities> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RuledLineCapabilities)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_barcode_rotations(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<PosPrinterRotation>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedBarcodeRotations)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_bitmap_rotations(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<PosPrinterRotation>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedBitmapRotations)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IReceiptPrinterCapabilities, 3102782863, 20904, 17404, 155, 213, 141, 226, 114, 166, 65, 91);
RT_INTERFACE!{interface IReceiptPrinterCapabilities(IReceiptPrinterCapabilitiesVtbl): IInspectable(IInspectableVtbl) [IID_IReceiptPrinterCapabilities] {
    fn get_CanCutPaper(&self, out: *mut bool) -> HRESULT,
    fn get_IsStampSupported(&self, out: *mut bool) -> HRESULT,
    fn get_MarkFeedCapabilities(&self, out: *mut PosPrinterMarkFeedCapabilities) -> HRESULT
}}
impl IReceiptPrinterCapabilities {
    #[inline] pub unsafe fn get_can_cut_paper(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanCutPaper)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_stamp_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStampSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_mark_feed_capabilities(&self) -> Result<PosPrinterMarkFeedCapabilities> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MarkFeedCapabilities)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class ReceiptPrinterCapabilities: IReceiptPrinterCapabilities}
DEFINE_IID!(IID_ISlipPrinterCapabilities, 2578539417, 18572, 16727, 138, 194, 159, 87, 247, 8, 211, 219);
RT_INTERFACE!{interface ISlipPrinterCapabilities(ISlipPrinterCapabilitiesVtbl): IInspectable(IInspectableVtbl) [IID_ISlipPrinterCapabilities] {
    fn get_IsFullLengthSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsBothSidesPrintingSupported(&self, out: *mut bool) -> HRESULT
}}
impl ISlipPrinterCapabilities {
    #[inline] pub unsafe fn get_is_full_length_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsFullLengthSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_both_sides_printing_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsBothSidesPrintingSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class SlipPrinterCapabilities: ISlipPrinterCapabilities}
DEFINE_IID!(IID_IJournalPrinterCapabilities, 995937347, 57415, 17507, 187, 88, 23, 181, 186, 29, 128, 86);
RT_INTERFACE!{interface IJournalPrinterCapabilities(IJournalPrinterCapabilitiesVtbl): IInspectable(IInspectableVtbl) [IID_IJournalPrinterCapabilities] {
    
}}
RT_CLASS!{class JournalPrinterCapabilities: IJournalPrinterCapabilities}
DEFINE_IID!(IID_IPosPrinterCapabilities, 3454621473, 17280, 18821, 173, 197, 57, 219, 48, 205, 147, 188);
RT_INTERFACE!{interface IPosPrinterCapabilities(IPosPrinterCapabilitiesVtbl): IInspectable(IInspectableVtbl) [IID_IPosPrinterCapabilities] {
    fn get_PowerReportingType(&self, out: *mut UnifiedPosPowerReportingType) -> HRESULT,
    fn get_IsStatisticsReportingSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsStatisticsUpdatingSupported(&self, out: *mut bool) -> HRESULT,
    fn get_DefaultCharacterSet(&self, out: *mut u32) -> HRESULT,
    fn get_HasCoverSensor(&self, out: *mut bool) -> HRESULT,
    fn get_CanMapCharacterSet(&self, out: *mut bool) -> HRESULT,
    fn get_IsTransactionSupported(&self, out: *mut bool) -> HRESULT,
    fn get_Receipt(&self, out: *mut *mut ReceiptPrinterCapabilities) -> HRESULT,
    fn get_Slip(&self, out: *mut *mut SlipPrinterCapabilities) -> HRESULT,
    fn get_Journal(&self, out: *mut *mut JournalPrinterCapabilities) -> HRESULT
}}
impl IPosPrinterCapabilities {
    #[inline] pub unsafe fn get_power_reporting_type(&self) -> Result<UnifiedPosPowerReportingType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PowerReportingType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_statistics_reporting_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStatisticsReportingSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_statistics_updating_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStatisticsUpdatingSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_character_set(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DefaultCharacterSet)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_has_cover_sensor(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HasCoverSensor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_can_map_character_set(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanMapCharacterSet)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_transaction_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsTransactionSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_receipt(&self) -> Result<ComPtr<ReceiptPrinterCapabilities>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Receipt)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_slip(&self) -> Result<ComPtr<SlipPrinterCapabilities>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Slip)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_journal(&self) -> Result<ComPtr<JournalPrinterCapabilities>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Journal)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PosPrinterCapabilities: IPosPrinterCapabilities}
DEFINE_IID!(IID_IPosPrinterStatus, 3522217776, 55872, 17192, 191, 118, 81, 86, 250, 51, 183, 71);
RT_INTERFACE!{interface IPosPrinterStatus(IPosPrinterStatusVtbl): IInspectable(IInspectableVtbl) [IID_IPosPrinterStatus] {
    fn get_StatusKind(&self, out: *mut PosPrinterStatusKind) -> HRESULT,
    fn get_ExtendedStatus(&self, out: *mut u32) -> HRESULT
}}
impl IPosPrinterStatus {
    #[inline] pub unsafe fn get_status_kind(&self) -> Result<PosPrinterStatusKind> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_StatusKind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_extended_status(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ExtendedStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class PosPrinterStatus: IPosPrinterStatus}
DEFINE_IID!(IID_IPosPrinterStatusUpdatedEventArgs, 786139103, 5030, 17037, 186, 129, 176, 231, 195, 229, 163, 205);
RT_INTERFACE!{interface IPosPrinterStatusUpdatedEventArgs(IPosPrinterStatusUpdatedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPosPrinterStatusUpdatedEventArgs] {
    fn get_Status(&self, out: *mut *mut PosPrinterStatus) -> HRESULT
}}
impl IPosPrinterStatusUpdatedEventArgs {
    #[inline] pub unsafe fn get_status(&self) -> Result<ComPtr<PosPrinterStatus>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PosPrinterStatusUpdatedEventArgs: IPosPrinterStatusUpdatedEventArgs}
DEFINE_IID!(IID_IPosPrinterReleaseDeviceRequestedEventArgs, 734765913, 7407, 16562, 158, 203, 249, 39, 248, 86, 174, 60);
RT_INTERFACE!{interface IPosPrinterReleaseDeviceRequestedEventArgs(IPosPrinterReleaseDeviceRequestedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPosPrinterReleaseDeviceRequestedEventArgs] {
    
}}
RT_CLASS!{class PosPrinterReleaseDeviceRequestedEventArgs: IPosPrinterReleaseDeviceRequestedEventArgs}
DEFINE_IID!(IID_IPosPrinterStatics, 2363544810, 4911, 19679, 166, 74, 45, 13, 124, 150, 168, 91);
RT_INTERFACE!{static interface IPosPrinterStatics(IPosPrinterStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IPosPrinterStatics] {
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<PosPrinter>) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<PosPrinter>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT
}}
impl IPosPrinterStatics {
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PosPrinter>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PosPrinter>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PosPrinter: IPosPrinter}
impl RtActivatable<IPosPrinterStatics2> for PosPrinter {}
impl RtActivatable<IPosPrinterStatics> for PosPrinter {}
impl PosPrinter {
    #[inline] pub fn get_device_selector_with_connection_types(connectionTypes: PosConnectionTypes) -> Result<HString> { unsafe {
        <Self as RtActivatable<IPosPrinterStatics2>>::get_activation_factory().get_device_selector_with_connection_types(connectionTypes)
    }}
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<PosPrinter>>> { unsafe {
        <Self as RtActivatable<IPosPrinterStatics>>::get_activation_factory().get_default_async()
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<PosPrinter>>> { unsafe {
        <Self as RtActivatable<IPosPrinterStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IPosPrinterStatics>>::get_activation_factory().get_device_selector()
    }}
}
DEFINE_CLSID!(PosPrinter(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,111,105,110,116,79,102,83,101,114,118,105,99,101,46,80,111,115,80,114,105,110,116,101,114,0]) [CLSID_PosPrinter]);
DEFINE_IID!(IID_IPosPrinterStatics2, 4006423580, 45264, 17127, 177, 55, 184, 155, 22, 36, 77, 65);
RT_INTERFACE!{static interface IPosPrinterStatics2(IPosPrinterStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IPosPrinterStatics2] {
    fn GetDeviceSelectorWithConnectionTypes(&self, connectionTypes: PosConnectionTypes, out: *mut HSTRING) -> HRESULT
}}
impl IPosPrinterStatics2 {
    #[inline] pub unsafe fn get_device_selector_with_connection_types(&self, connectionTypes: PosConnectionTypes) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorWithConnectionTypes)(self as *const _ as *mut _, connectionTypes, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPosPrinter, 704889102, 39449, 18945, 153, 79, 18, 223, 173, 106, 220, 191);
RT_INTERFACE!{interface IPosPrinter(IPosPrinterVtbl): IInspectable(IInspectableVtbl) [IID_IPosPrinter] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Capabilities(&self, out: *mut *mut PosPrinterCapabilities) -> HRESULT,
    fn get_SupportedCharacterSets(&self, out: *mut *mut super::super::foundation::collections::IVectorView<u32>) -> HRESULT,
    fn get_SupportedTypeFaces(&self, out: *mut *mut super::super::foundation::collections::IVectorView<HString>) -> HRESULT,
    fn get_Status(&self, out: *mut *mut PosPrinterStatus) -> HRESULT,
    fn ClaimPrinterAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<ClaimedPosPrinter>) -> HRESULT,
    fn CheckHealthAsync(&self, level: UnifiedPosHealthCheckLevel, out: *mut *mut super::super::foundation::IAsyncOperation<HString>) -> HRESULT,
    fn GetStatisticsAsync(&self, statisticsCategories: *mut super::super::foundation::collections::IIterable<HString>, out: *mut *mut super::super::foundation::IAsyncOperation<HString>) -> HRESULT,
    fn add_StatusUpdated(&self, handler: *mut super::super::foundation::TypedEventHandler<PosPrinter, PosPrinterStatusUpdatedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_StatusUpdated(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IPosPrinter {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_capabilities(&self) -> Result<ComPtr<PosPrinterCapabilities>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Capabilities)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_character_sets(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<u32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedCharacterSets)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_type_faces(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedTypeFaces)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<ComPtr<PosPrinterStatus>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn claim_printer_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ClaimedPosPrinter>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ClaimPrinterAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn check_health_async(&self, level: UnifiedPosHealthCheckLevel) -> Result<ComPtr<super::super::foundation::IAsyncOperation<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CheckHealthAsync)(self as *const _ as *mut _, level, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_statistics_async(&self, statisticsCategories: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<super::super::foundation::IAsyncOperation<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetStatisticsAsync)(self as *const _ as *mut _, statisticsCategories as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_status_updated(&self, handler: &super::super::foundation::TypedEventHandler<PosPrinter, PosPrinterStatusUpdatedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_StatusUpdated)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_status_updated(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_StatusUpdated)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class ClaimedPosPrinter: IClaimedPosPrinter}
DEFINE_IID!(IID_IPosPrinterJob, 2593390684, 1557, 17809, 165, 143, 48, 248, 126, 223, 226, 228);
RT_INTERFACE!{interface IPosPrinterJob(IPosPrinterJobVtbl): IInspectable(IInspectableVtbl) [IID_IPosPrinterJob] {
    fn Print(&self, data: HSTRING) -> HRESULT,
    fn PrintLine(&self, data: HSTRING) -> HRESULT,
    fn PrintNewline(&self) -> HRESULT,
    fn ExecuteAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT
}}
impl IPosPrinterJob {
    #[inline] pub unsafe fn print(&self, data: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).Print)(self as *const _ as *mut _, data.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn print_line(&self, data: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).PrintLine)(self as *const _ as *mut _, data.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn print_newline(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).PrintNewline)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn execute_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ExecuteAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IReceiptOrSlipJob, 1394710974, 51395, 19906, 137, 233, 92, 74, 55, 179, 77, 220);
RT_INTERFACE!{interface IReceiptOrSlipJob(IReceiptOrSlipJobVtbl): IInspectable(IInspectableVtbl) [IID_IReceiptOrSlipJob] {
    fn SetBarcodeRotation(&self, value: PosPrinterRotation) -> HRESULT,
    fn SetPrintRotation(&self, value: PosPrinterRotation, includeBitmaps: bool) -> HRESULT,
    fn SetPrintArea(&self, value: super::super::foundation::Rect) -> HRESULT,
    #[cfg(feature="windows-graphics")] fn SetBitmap(&self, bitmapNumber: u32, bitmap: *mut super::super::graphics::imaging::BitmapFrame, alignment: PosPrinterAlignment) -> HRESULT,
    #[cfg(feature="windows-graphics")] fn SetBitmapCustomWidthStandardAlign(&self, bitmapNumber: u32, bitmap: *mut super::super::graphics::imaging::BitmapFrame, alignment: PosPrinterAlignment, width: u32) -> HRESULT,
    #[cfg(feature="windows-graphics")] fn SetCustomAlignedBitmap(&self, bitmapNumber: u32, bitmap: *mut super::super::graphics::imaging::BitmapFrame, alignmentDistance: u32) -> HRESULT,
    #[cfg(feature="windows-graphics")] fn SetBitmapCustomWidthCustomAlign(&self, bitmapNumber: u32, bitmap: *mut super::super::graphics::imaging::BitmapFrame, alignmentDistance: u32, width: u32) -> HRESULT,
    fn PrintSavedBitmap(&self, bitmapNumber: u32) -> HRESULT,
    fn DrawRuledLine(&self, positionList: HSTRING, lineDirection: PosPrinterLineDirection, lineWidth: u32, lineStyle: PosPrinterLineStyle, lineColor: u32) -> HRESULT,
    fn PrintBarcode(&self, data: HSTRING, symbology: u32, height: u32, width: u32, textPosition: PosPrinterBarcodeTextPosition, alignment: PosPrinterAlignment) -> HRESULT,
    fn PrintBarcodeCustomAlign(&self, data: HSTRING, symbology: u32, height: u32, width: u32, textPosition: PosPrinterBarcodeTextPosition, alignmentDistance: u32) -> HRESULT,
    #[cfg(feature="windows-graphics")] fn PrintBitmap(&self, bitmap: *mut super::super::graphics::imaging::BitmapFrame, alignment: PosPrinterAlignment) -> HRESULT,
    #[cfg(feature="windows-graphics")] fn PrintBitmapCustomWidthStandardAlign(&self, bitmap: *mut super::super::graphics::imaging::BitmapFrame, alignment: PosPrinterAlignment, width: u32) -> HRESULT,
    #[cfg(feature="windows-graphics")] fn PrintCustomAlignedBitmap(&self, bitmap: *mut super::super::graphics::imaging::BitmapFrame, alignmentDistance: u32) -> HRESULT,
    #[cfg(feature="windows-graphics")] fn PrintBitmapCustomWidthCustomAlign(&self, bitmap: *mut super::super::graphics::imaging::BitmapFrame, alignmentDistance: u32, width: u32) -> HRESULT
}}
impl IReceiptOrSlipJob {
    #[inline] pub unsafe fn set_barcode_rotation(&self, value: PosPrinterRotation) -> Result<()> {
        let hr = ((*self.lpVtbl).SetBarcodeRotation)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_print_rotation(&self, value: PosPrinterRotation, includeBitmaps: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).SetPrintRotation)(self as *const _ as *mut _, value, includeBitmaps);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_print_area(&self, value: super::super::foundation::Rect) -> Result<()> {
        let hr = ((*self.lpVtbl).SetPrintArea)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn set_bitmap(&self, bitmapNumber: u32, bitmap: &super::super::graphics::imaging::BitmapFrame, alignment: PosPrinterAlignment) -> Result<()> {
        let hr = ((*self.lpVtbl).SetBitmap)(self as *const _ as *mut _, bitmapNumber, bitmap as *const _ as *mut _, alignment);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn set_bitmap_custom_width_standard_align(&self, bitmapNumber: u32, bitmap: &super::super::graphics::imaging::BitmapFrame, alignment: PosPrinterAlignment, width: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).SetBitmapCustomWidthStandardAlign)(self as *const _ as *mut _, bitmapNumber, bitmap as *const _ as *mut _, alignment, width);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn set_custom_aligned_bitmap(&self, bitmapNumber: u32, bitmap: &super::super::graphics::imaging::BitmapFrame, alignmentDistance: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).SetCustomAlignedBitmap)(self as *const _ as *mut _, bitmapNumber, bitmap as *const _ as *mut _, alignmentDistance);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn set_bitmap_custom_width_custom_align(&self, bitmapNumber: u32, bitmap: &super::super::graphics::imaging::BitmapFrame, alignmentDistance: u32, width: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).SetBitmapCustomWidthCustomAlign)(self as *const _ as *mut _, bitmapNumber, bitmap as *const _ as *mut _, alignmentDistance, width);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn print_saved_bitmap(&self, bitmapNumber: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).PrintSavedBitmap)(self as *const _ as *mut _, bitmapNumber);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn draw_ruled_line(&self, positionList: &HStringArg, lineDirection: PosPrinterLineDirection, lineWidth: u32, lineStyle: PosPrinterLineStyle, lineColor: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).DrawRuledLine)(self as *const _ as *mut _, positionList.get(), lineDirection, lineWidth, lineStyle, lineColor);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn print_barcode(&self, data: &HStringArg, symbology: u32, height: u32, width: u32, textPosition: PosPrinterBarcodeTextPosition, alignment: PosPrinterAlignment) -> Result<()> {
        let hr = ((*self.lpVtbl).PrintBarcode)(self as *const _ as *mut _, data.get(), symbology, height, width, textPosition, alignment);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn print_barcode_custom_align(&self, data: &HStringArg, symbology: u32, height: u32, width: u32, textPosition: PosPrinterBarcodeTextPosition, alignmentDistance: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).PrintBarcodeCustomAlign)(self as *const _ as *mut _, data.get(), symbology, height, width, textPosition, alignmentDistance);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn print_bitmap(&self, bitmap: &super::super::graphics::imaging::BitmapFrame, alignment: PosPrinterAlignment) -> Result<()> {
        let hr = ((*self.lpVtbl).PrintBitmap)(self as *const _ as *mut _, bitmap as *const _ as *mut _, alignment);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn print_bitmap_custom_width_standard_align(&self, bitmap: &super::super::graphics::imaging::BitmapFrame, alignment: PosPrinterAlignment, width: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).PrintBitmapCustomWidthStandardAlign)(self as *const _ as *mut _, bitmap as *const _ as *mut _, alignment, width);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn print_custom_aligned_bitmap(&self, bitmap: &super::super::graphics::imaging::BitmapFrame, alignmentDistance: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).PrintCustomAlignedBitmap)(self as *const _ as *mut _, bitmap as *const _ as *mut _, alignmentDistance);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn print_bitmap_custom_width_custom_align(&self, bitmap: &super::super::graphics::imaging::BitmapFrame, alignmentDistance: u32, width: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).PrintBitmapCustomWidthCustomAlign)(self as *const _ as *mut _, bitmap as *const _ as *mut _, alignmentDistance, width);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IReceiptPrintJob, 2861958766, 44205, 19321, 157, 15, 192, 207, 192, 141, 199, 123);
RT_INTERFACE!{interface IReceiptPrintJob(IReceiptPrintJobVtbl): IInspectable(IInspectableVtbl) [IID_IReceiptPrintJob] {
    fn MarkFeed(&self, kind: PosPrinterMarkFeedKind) -> HRESULT,
    fn CutPaper(&self, percentage: f64) -> HRESULT,
    fn CutPaperDefault(&self) -> HRESULT
}}
impl IReceiptPrintJob {
    #[inline] pub unsafe fn mark_feed(&self, kind: PosPrinterMarkFeedKind) -> Result<()> {
        let hr = ((*self.lpVtbl).MarkFeed)(self as *const _ as *mut _, kind);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn cut_paper(&self, percentage: f64) -> Result<()> {
        let hr = ((*self.lpVtbl).CutPaper)(self as *const _ as *mut _, percentage);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn cut_paper_default(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).CutPaperDefault)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class ReceiptPrintJob: IReceiptPrintJob}
RT_CLASS!{class SlipPrintJob: IReceiptOrSlipJob}
RT_CLASS!{class JournalPrintJob: IPosPrinterJob}
DEFINE_IID!(IID_ICommonClaimedPosPrinterStation, 3085657768, 65162, 19707, 139, 66, 227, 91, 40, 12, 178, 124);
RT_INTERFACE!{interface ICommonClaimedPosPrinterStation(ICommonClaimedPosPrinterStationVtbl): IInspectable(IInspectableVtbl) [IID_ICommonClaimedPosPrinterStation] {
    fn put_CharactersPerLine(&self, value: u32) -> HRESULT,
    fn get_CharactersPerLine(&self, out: *mut u32) -> HRESULT,
    fn put_LineHeight(&self, value: u32) -> HRESULT,
    fn get_LineHeight(&self, out: *mut u32) -> HRESULT,
    fn put_LineSpacing(&self, value: u32) -> HRESULT,
    fn get_LineSpacing(&self, out: *mut u32) -> HRESULT,
    fn get_LineWidth(&self, out: *mut u32) -> HRESULT,
    fn put_IsLetterQuality(&self, value: bool) -> HRESULT,
    fn get_IsLetterQuality(&self, out: *mut bool) -> HRESULT,
    fn get_IsPaperNearEnd(&self, out: *mut bool) -> HRESULT,
    fn put_ColorCartridge(&self, value: PosPrinterColorCartridge) -> HRESULT,
    fn get_ColorCartridge(&self, out: *mut PosPrinterColorCartridge) -> HRESULT,
    fn get_IsCoverOpen(&self, out: *mut bool) -> HRESULT,
    fn get_IsCartridgeRemoved(&self, out: *mut bool) -> HRESULT,
    fn get_IsCartridgeEmpty(&self, out: *mut bool) -> HRESULT,
    fn get_IsHeadCleaning(&self, out: *mut bool) -> HRESULT,
    fn get_IsPaperEmpty(&self, out: *mut bool) -> HRESULT,
    fn get_IsReadyToPrint(&self, out: *mut bool) -> HRESULT,
    fn ValidateData(&self, data: HSTRING, out: *mut bool) -> HRESULT
}}
impl ICommonClaimedPosPrinterStation {
    #[inline] pub unsafe fn set_characters_per_line(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_CharactersPerLine)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_characters_per_line(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CharactersPerLine)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_line_height(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_LineHeight)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_line_height(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LineHeight)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_line_spacing(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_LineSpacing)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_line_spacing(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LineSpacing)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_line_width(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LineWidth)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_letter_quality(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsLetterQuality)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_letter_quality(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsLetterQuality)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_paper_near_end(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsPaperNearEnd)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_color_cartridge(&self, value: PosPrinterColorCartridge) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ColorCartridge)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_color_cartridge(&self) -> Result<PosPrinterColorCartridge> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ColorCartridge)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_cover_open(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsCoverOpen)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_cartridge_removed(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsCartridgeRemoved)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_cartridge_empty(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsCartridgeEmpty)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_head_cleaning(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsHeadCleaning)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_paper_empty(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsPaperEmpty)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_ready_to_print(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsReadyToPrint)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn validate_data(&self, data: &HStringArg) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).ValidateData)(self as *const _ as *mut _, data.get(), &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IClaimedReceiptPrinter, 2597485172, 56673, 20194, 152, 55, 91, 93, 114, 213, 56, 185);
RT_INTERFACE!{interface IClaimedReceiptPrinter(IClaimedReceiptPrinterVtbl): IInspectable(IInspectableVtbl) [IID_IClaimedReceiptPrinter] {
    fn get_SidewaysMaxLines(&self, out: *mut u32) -> HRESULT,
    fn get_SidewaysMaxChars(&self, out: *mut u32) -> HRESULT,
    fn get_LinesToPaperCut(&self, out: *mut u32) -> HRESULT,
    fn get_PageSize(&self, out: *mut super::super::foundation::Size) -> HRESULT,
    fn get_PrintArea(&self, out: *mut super::super::foundation::Rect) -> HRESULT,
    fn CreateJob(&self, out: *mut *mut ReceiptPrintJob) -> HRESULT
}}
impl IClaimedReceiptPrinter {
    #[inline] pub unsafe fn get_sideways_max_lines(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SidewaysMaxLines)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sideways_max_chars(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SidewaysMaxChars)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_lines_to_paper_cut(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LinesToPaperCut)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_page_size(&self) -> Result<super::super::foundation::Size> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PageSize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_print_area(&self) -> Result<super::super::foundation::Rect> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PrintArea)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_job(&self) -> Result<ComPtr<ReceiptPrintJob>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateJob)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class ClaimedReceiptPrinter: IClaimedReceiptPrinter}
DEFINE_IID!(IID_IClaimedSlipPrinter, 3177050098, 44944, 20106, 183, 123, 227, 174, 156, 166, 58, 127);
RT_INTERFACE!{interface IClaimedSlipPrinter(IClaimedSlipPrinterVtbl): IInspectable(IInspectableVtbl) [IID_IClaimedSlipPrinter] {
    fn get_SidewaysMaxLines(&self, out: *mut u32) -> HRESULT,
    fn get_SidewaysMaxChars(&self, out: *mut u32) -> HRESULT,
    fn get_MaxLines(&self, out: *mut u32) -> HRESULT,
    fn get_LinesNearEndToEnd(&self, out: *mut u32) -> HRESULT,
    fn get_PrintSide(&self, out: *mut PosPrinterPrintSide) -> HRESULT,
    fn get_PageSize(&self, out: *mut super::super::foundation::Size) -> HRESULT,
    fn get_PrintArea(&self, out: *mut super::super::foundation::Rect) -> HRESULT,
    fn OpenJaws(&self) -> HRESULT,
    fn CloseJaws(&self) -> HRESULT,
    fn InsertSlipAsync(&self, timeout: super::super::foundation::TimeSpan, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn RemoveSlipAsync(&self, timeout: super::super::foundation::TimeSpan, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn ChangePrintSide(&self, printSide: PosPrinterPrintSide) -> HRESULT,
    fn CreateJob(&self, out: *mut *mut SlipPrintJob) -> HRESULT
}}
impl IClaimedSlipPrinter {
    #[inline] pub unsafe fn get_sideways_max_lines(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SidewaysMaxLines)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sideways_max_chars(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SidewaysMaxChars)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_lines(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxLines)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_lines_near_end_to_end(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_LinesNearEndToEnd)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_print_side(&self) -> Result<PosPrinterPrintSide> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PrintSide)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_page_size(&self) -> Result<super::super::foundation::Size> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PageSize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_print_area(&self) -> Result<super::super::foundation::Rect> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PrintArea)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn open_jaws(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).OpenJaws)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn close_jaws(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).CloseJaws)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn insert_slip_async(&self, timeout: super::super::foundation::TimeSpan) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).InsertSlipAsync)(self as *const _ as *mut _, timeout, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_slip_async(&self, timeout: super::super::foundation::TimeSpan) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RemoveSlipAsync)(self as *const _ as *mut _, timeout, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn change_print_side(&self, printSide: PosPrinterPrintSide) -> Result<()> {
        let hr = ((*self.lpVtbl).ChangePrintSide)(self as *const _ as *mut _, printSide);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_job(&self) -> Result<ComPtr<SlipPrintJob>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateJob)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class ClaimedSlipPrinter: IClaimedSlipPrinter}
DEFINE_IID!(IID_IClaimedJournalPrinter, 1743390256, 20861, 18559, 159, 223, 210, 224, 160, 162, 100, 165);
RT_INTERFACE!{interface IClaimedJournalPrinter(IClaimedJournalPrinterVtbl): IInspectable(IInspectableVtbl) [IID_IClaimedJournalPrinter] {
    fn CreateJob(&self, out: *mut *mut JournalPrintJob) -> HRESULT
}}
impl IClaimedJournalPrinter {
    #[inline] pub unsafe fn create_job(&self) -> Result<ComPtr<JournalPrintJob>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateJob)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class ClaimedJournalPrinter: IClaimedJournalPrinter}
DEFINE_IID!(IID_IClaimedPosPrinter, 1835322892, 57406, 19220, 163, 142, 194, 140, 52, 184, 99, 83);
RT_INTERFACE!{interface IClaimedPosPrinter(IClaimedPosPrinterVtbl): IInspectable(IInspectableVtbl) [IID_IClaimedPosPrinter] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_IsEnabled(&self, out: *mut bool) -> HRESULT,
    fn put_CharacterSet(&self, value: u32) -> HRESULT,
    fn get_CharacterSet(&self, out: *mut u32) -> HRESULT,
    fn get_IsCoverOpen(&self, out: *mut bool) -> HRESULT,
    fn put_IsCharacterSetMappingEnabled(&self, value: bool) -> HRESULT,
    fn get_IsCharacterSetMappingEnabled(&self, out: *mut bool) -> HRESULT,
    fn put_MapMode(&self, value: PosPrinterMapMode) -> HRESULT,
    fn get_MapMode(&self, out: *mut PosPrinterMapMode) -> HRESULT,
    fn get_Receipt(&self, out: *mut *mut ClaimedReceiptPrinter) -> HRESULT,
    fn get_Slip(&self, out: *mut *mut ClaimedSlipPrinter) -> HRESULT,
    fn get_Journal(&self, out: *mut *mut ClaimedJournalPrinter) -> HRESULT,
    fn EnableAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn DisableAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn RetainDeviceAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn ResetStatisticsAsync(&self, statisticsCategories: *mut super::super::foundation::collections::IIterable<HString>, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn UpdateStatisticsAsync(&self, statistics: *mut super::super::foundation::collections::IIterable<super::super::foundation::collections::IKeyValuePair<HString, HString>>, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn add_ReleaseDeviceRequested(&self, handler: *mut super::super::foundation::TypedEventHandler<ClaimedPosPrinter, PosPrinterReleaseDeviceRequestedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReleaseDeviceRequested(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IClaimedPosPrinter {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_character_set(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_CharacterSet)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_character_set(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CharacterSet)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_cover_open(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsCoverOpen)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_character_set_mapping_enabled(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsCharacterSetMappingEnabled)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_character_set_mapping_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsCharacterSetMappingEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_map_mode(&self, value: PosPrinterMapMode) -> Result<()> {
        let hr = ((*self.lpVtbl).put_MapMode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_map_mode(&self) -> Result<PosPrinterMapMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MapMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_receipt(&self) -> Result<ComPtr<ClaimedReceiptPrinter>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Receipt)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_slip(&self) -> Result<ComPtr<ClaimedSlipPrinter>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Slip)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_journal(&self) -> Result<ComPtr<ClaimedJournalPrinter>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Journal)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn enable_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).EnableAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn disable_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).DisableAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn retain_device_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RetainDeviceAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn reset_statistics_async(&self, statisticsCategories: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ResetStatisticsAsync)(self as *const _ as *mut _, statisticsCategories as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn update_statistics_async(&self, statistics: &super::super::foundation::collections::IIterable<super::super::foundation::collections::IKeyValuePair<HString, HString>>) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).UpdateStatisticsAsync)(self as *const _ as *mut _, statistics as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_release_device_requested(&self, handler: &super::super::foundation::TypedEventHandler<ClaimedPosPrinter, PosPrinterReleaseDeviceRequestedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReleaseDeviceRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_release_device_requested(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReleaseDeviceRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ICashDrawerStatusUpdatedEventArgs, 816507274, 3440, 17820, 149, 83, 135, 225, 36, 197, 36, 136);
RT_INTERFACE!{interface ICashDrawerStatusUpdatedEventArgs(ICashDrawerStatusUpdatedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_ICashDrawerStatusUpdatedEventArgs] {
    fn get_Status(&self, out: *mut *mut CashDrawerStatus) -> HRESULT
}}
impl ICashDrawerStatusUpdatedEventArgs {
    #[inline] pub unsafe fn get_status(&self) -> Result<ComPtr<CashDrawerStatus>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class CashDrawerStatus: ICashDrawerStatus}
RT_CLASS!{class CashDrawerStatusUpdatedEventArgs: ICashDrawerStatusUpdatedEventArgs}
DEFINE_IID!(IID_ICashDrawerStatus, 1807579327, 56481, 19974, 153, 235, 90, 246, 165, 174, 193, 8);
RT_INTERFACE!{interface ICashDrawerStatus(ICashDrawerStatusVtbl): IInspectable(IInspectableVtbl) [IID_ICashDrawerStatus] {
    fn get_StatusKind(&self, out: *mut CashDrawerStatusKind) -> HRESULT,
    fn get_ExtendedStatus(&self, out: *mut u32) -> HRESULT
}}
impl ICashDrawerStatus {
    #[inline] pub unsafe fn get_status_kind(&self) -> Result<CashDrawerStatusKind> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_StatusKind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_extended_status(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ExtendedStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ICashDrawerCapabilities, 197582347, 59623, 19231, 177, 209, 62, 80, 26, 208, 130, 71);
RT_INTERFACE!{interface ICashDrawerCapabilities(ICashDrawerCapabilitiesVtbl): IInspectable(IInspectableVtbl) [IID_ICashDrawerCapabilities] {
    fn get_PowerReportingType(&self, out: *mut UnifiedPosPowerReportingType) -> HRESULT,
    fn get_IsStatisticsReportingSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsStatisticsUpdatingSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsStatusReportingSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsStatusMultiDrawerDetectSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsDrawerOpenSensorAvailable(&self, out: *mut bool) -> HRESULT
}}
impl ICashDrawerCapabilities {
    #[inline] pub unsafe fn get_power_reporting_type(&self) -> Result<UnifiedPosPowerReportingType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PowerReportingType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_statistics_reporting_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStatisticsReportingSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_statistics_updating_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStatisticsUpdatingSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_status_reporting_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStatusReportingSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_status_multi_drawer_detect_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStatusMultiDrawerDetectSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_drawer_open_sensor_available(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDrawerOpenSensorAvailable)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class CashDrawerCapabilities: ICashDrawerCapabilities}
DEFINE_IID!(IID_ICashDrawerEventSourceEventArgs, 1774926785, 5247, 16924, 156, 35, 9, 1, 35, 187, 120, 108);
RT_INTERFACE!{interface ICashDrawerEventSourceEventArgs(ICashDrawerEventSourceEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_ICashDrawerEventSourceEventArgs] {
    fn get_CashDrawer(&self, out: *mut *mut CashDrawer) -> HRESULT
}}
impl ICashDrawerEventSourceEventArgs {
    #[inline] pub unsafe fn get_cash_drawer(&self) -> Result<ComPtr<CashDrawer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_CashDrawer)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class CashDrawer: ICashDrawer}
impl RtActivatable<ICashDrawerStatics2> for CashDrawer {}
impl RtActivatable<ICashDrawerStatics> for CashDrawer {}
impl CashDrawer {
    #[inline] pub fn get_device_selector_with_connection_types(connectionTypes: PosConnectionTypes) -> Result<HString> { unsafe {
        <Self as RtActivatable<ICashDrawerStatics2>>::get_activation_factory().get_device_selector_with_connection_types(connectionTypes)
    }}
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<CashDrawer>>> { unsafe {
        <Self as RtActivatable<ICashDrawerStatics>>::get_activation_factory().get_default_async()
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<CashDrawer>>> { unsafe {
        <Self as RtActivatable<ICashDrawerStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<ICashDrawerStatics>>::get_activation_factory().get_device_selector()
    }}
}
DEFINE_CLSID!(CashDrawer(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,111,105,110,116,79,102,83,101,114,118,105,99,101,46,67,97,115,104,68,114,97,119,101,114,0]) [CLSID_CashDrawer]);
RT_CLASS!{class CashDrawerClosedEventArgs: ICashDrawerEventSourceEventArgs}
RT_CLASS!{class CashDrawerOpenedEventArgs: ICashDrawerEventSourceEventArgs}
DEFINE_IID!(IID_ICashDrawerEventSource, 3758548076, 62201, 17455, 141, 214, 6, 193, 10, 66, 39, 186);
RT_INTERFACE!{interface ICashDrawerEventSource(ICashDrawerEventSourceVtbl): IInspectable(IInspectableVtbl) [IID_ICashDrawerEventSource] {
    fn add_DrawerClosed(&self, handler: *mut super::super::foundation::TypedEventHandler<CashDrawerEventSource, CashDrawerClosedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_DrawerClosed(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_DrawerOpened(&self, handler: *mut super::super::foundation::TypedEventHandler<CashDrawerEventSource, CashDrawerOpenedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_DrawerOpened(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl ICashDrawerEventSource {
    #[inline] pub unsafe fn add_drawer_closed(&self, handler: &super::super::foundation::TypedEventHandler<CashDrawerEventSource, CashDrawerClosedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_DrawerClosed)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_drawer_closed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_DrawerClosed)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_drawer_opened(&self, handler: &super::super::foundation::TypedEventHandler<CashDrawerEventSource, CashDrawerOpenedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_DrawerOpened)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_drawer_opened(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_DrawerOpened)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class CashDrawerEventSource: ICashDrawerEventSource}
DEFINE_IID!(IID_ICashDrawerStatics, 3751843162, 54327, 20479, 181, 71, 221, 169, 105, 164, 248, 131);
RT_INTERFACE!{static interface ICashDrawerStatics(ICashDrawerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ICashDrawerStatics] {
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<CashDrawer>) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<CashDrawer>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT
}}
impl ICashDrawerStatics {
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<CashDrawer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<CashDrawer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ICashDrawerStatics2, 1048674593, 35906, 16616, 156, 14, 64, 41, 112, 72, 16, 76);
RT_INTERFACE!{static interface ICashDrawerStatics2(ICashDrawerStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_ICashDrawerStatics2] {
    fn GetDeviceSelectorWithConnectionTypes(&self, connectionTypes: PosConnectionTypes, out: *mut HSTRING) -> HRESULT
}}
impl ICashDrawerStatics2 {
    #[inline] pub unsafe fn get_device_selector_with_connection_types(&self, connectionTypes: PosConnectionTypes) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorWithConnectionTypes)(self as *const _ as *mut _, connectionTypes, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ICashDrawer, 2676553160, 56916, 19182, 168, 144, 146, 11, 203, 254, 48, 252);
RT_INTERFACE!{interface ICashDrawer(ICashDrawerVtbl): IInspectable(IInspectableVtbl) [IID_ICashDrawer] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Capabilities(&self, out: *mut *mut CashDrawerCapabilities) -> HRESULT,
    fn get_Status(&self, out: *mut *mut CashDrawerStatus) -> HRESULT,
    fn get_IsDrawerOpen(&self, out: *mut bool) -> HRESULT,
    fn get_DrawerEventSource(&self, out: *mut *mut CashDrawerEventSource) -> HRESULT,
    fn ClaimDrawerAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<ClaimedCashDrawer>) -> HRESULT,
    fn CheckHealthAsync(&self, level: UnifiedPosHealthCheckLevel, out: *mut *mut super::super::foundation::IAsyncOperation<HString>) -> HRESULT,
    fn GetStatisticsAsync(&self, statisticsCategories: *mut super::super::foundation::collections::IIterable<HString>, out: *mut *mut super::super::foundation::IAsyncOperation<HString>) -> HRESULT,
    fn add_StatusUpdated(&self, handler: *mut super::super::foundation::TypedEventHandler<CashDrawer, CashDrawerStatusUpdatedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_StatusUpdated(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl ICashDrawer {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_capabilities(&self) -> Result<ComPtr<CashDrawerCapabilities>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Capabilities)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<ComPtr<CashDrawerStatus>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_drawer_open(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDrawerOpen)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_drawer_event_source(&self) -> Result<ComPtr<CashDrawerEventSource>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DrawerEventSource)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn claim_drawer_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ClaimedCashDrawer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ClaimDrawerAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn check_health_async(&self, level: UnifiedPosHealthCheckLevel) -> Result<ComPtr<super::super::foundation::IAsyncOperation<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CheckHealthAsync)(self as *const _ as *mut _, level, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_statistics_async(&self, statisticsCategories: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<super::super::foundation::IAsyncOperation<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetStatisticsAsync)(self as *const _ as *mut _, statisticsCategories as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_status_updated(&self, handler: &super::super::foundation::TypedEventHandler<CashDrawer, CashDrawerStatusUpdatedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_StatusUpdated)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_status_updated(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_StatusUpdated)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class ClaimedCashDrawer: IClaimedCashDrawer}
DEFINE_IID!(IID_ICashDrawerCloseAlarm, 1811451079, 28515, 17166, 171, 59, 149, 215, 95, 251, 232, 127);
RT_INTERFACE!{interface ICashDrawerCloseAlarm(ICashDrawerCloseAlarmVtbl): IInspectable(IInspectableVtbl) [IID_ICashDrawerCloseAlarm] {
    fn put_AlarmTimeout(&self, value: super::super::foundation::TimeSpan) -> HRESULT,
    fn get_AlarmTimeout(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn put_BeepFrequency(&self, value: u32) -> HRESULT,
    fn get_BeepFrequency(&self, out: *mut u32) -> HRESULT,
    fn put_BeepDuration(&self, value: super::super::foundation::TimeSpan) -> HRESULT,
    fn get_BeepDuration(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn put_BeepDelay(&self, value: super::super::foundation::TimeSpan) -> HRESULT,
    fn get_BeepDelay(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn add_AlarmTimeoutExpired(&self, handler: *mut super::super::foundation::TypedEventHandler<CashDrawerCloseAlarm, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_AlarmTimeoutExpired(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn StartAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT
}}
impl ICashDrawerCloseAlarm {
    #[inline] pub unsafe fn set_alarm_timeout(&self, value: super::super::foundation::TimeSpan) -> Result<()> {
        let hr = ((*self.lpVtbl).put_AlarmTimeout)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_alarm_timeout(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AlarmTimeout)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_beep_frequency(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_BeepFrequency)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_beep_frequency(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BeepFrequency)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_beep_duration(&self, value: super::super::foundation::TimeSpan) -> Result<()> {
        let hr = ((*self.lpVtbl).put_BeepDuration)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_beep_duration(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BeepDuration)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_beep_delay(&self, value: super::super::foundation::TimeSpan) -> Result<()> {
        let hr = ((*self.lpVtbl).put_BeepDelay)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_beep_delay(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BeepDelay)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_alarm_timeout_expired(&self, handler: &super::super::foundation::TypedEventHandler<CashDrawerCloseAlarm, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_AlarmTimeoutExpired)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_alarm_timeout_expired(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_AlarmTimeoutExpired)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn start_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).StartAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class CashDrawerCloseAlarm: ICashDrawerCloseAlarm}
DEFINE_IID!(IID_IClaimedCashDrawer, 3393165743, 43960, 17089, 138, 132, 92, 102, 81, 47, 90, 117);
RT_INTERFACE!{interface IClaimedCashDrawer(IClaimedCashDrawerVtbl): IInspectable(IInspectableVtbl) [IID_IClaimedCashDrawer] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_IsEnabled(&self, out: *mut bool) -> HRESULT,
    fn get_IsDrawerOpen(&self, out: *mut bool) -> HRESULT,
    fn get_CloseAlarm(&self, out: *mut *mut CashDrawerCloseAlarm) -> HRESULT,
    fn OpenDrawerAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn EnableAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn DisableAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn RetainDeviceAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn ResetStatisticsAsync(&self, statisticsCategories: *mut super::super::foundation::collections::IIterable<HString>, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn UpdateStatisticsAsync(&self, statistics: *mut super::super::foundation::collections::IIterable<super::super::foundation::collections::IKeyValuePair<HString, HString>>, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn add_ReleaseDeviceRequested(&self, handler: *mut super::super::foundation::TypedEventHandler<ClaimedCashDrawer, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReleaseDeviceRequested(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IClaimedCashDrawer {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_drawer_open(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDrawerOpen)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_close_alarm(&self) -> Result<ComPtr<CashDrawerCloseAlarm>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_CloseAlarm)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn open_drawer_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).OpenDrawerAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn enable_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).EnableAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn disable_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).DisableAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn retain_device_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RetainDeviceAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn reset_statistics_async(&self, statisticsCategories: &super::super::foundation::collections::IIterable<HString>) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ResetStatisticsAsync)(self as *const _ as *mut _, statisticsCategories as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn update_statistics_async(&self, statistics: &super::super::foundation::collections::IIterable<super::super::foundation::collections::IKeyValuePair<HString, HString>>) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).UpdateStatisticsAsync)(self as *const _ as *mut _, statistics as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_release_device_requested(&self, handler: &super::super::foundation::TypedEventHandler<ClaimedCashDrawer, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReleaseDeviceRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_release_device_requested(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReleaseDeviceRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ILineDisplayStatics, 36552886, 4528, 18064, 149, 71, 11, 57, 197, 175, 33, 20);
RT_INTERFACE!{static interface ILineDisplayStatics(ILineDisplayStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ILineDisplayStatics] {
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<LineDisplay>) -> HRESULT,
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<LineDisplay>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorWithConnectionTypes(&self, connectionTypes: PosConnectionTypes, out: *mut HSTRING) -> HRESULT
}}
impl ILineDisplayStatics {
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<LineDisplay>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<LineDisplay>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_with_connection_types(&self, connectionTypes: PosConnectionTypes) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorWithConnectionTypes)(self as *const _ as *mut _, connectionTypes, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class LineDisplay: ILineDisplay}
impl RtActivatable<ILineDisplayStatics> for LineDisplay {}
impl LineDisplay {
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<LineDisplay>>> { unsafe {
        <Self as RtActivatable<ILineDisplayStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<LineDisplay>>> { unsafe {
        <Self as RtActivatable<ILineDisplayStatics>>::get_activation_factory().get_default_async()
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<ILineDisplayStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn get_device_selector_with_connection_types(connectionTypes: PosConnectionTypes) -> Result<HString> { unsafe {
        <Self as RtActivatable<ILineDisplayStatics>>::get_activation_factory().get_device_selector_with_connection_types(connectionTypes)
    }}
}
DEFINE_CLSID!(LineDisplay(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,111,105,110,116,79,102,83,101,114,118,105,99,101,46,76,105,110,101,68,105,115,112,108,97,121,0]) [CLSID_LineDisplay]);
DEFINE_IID!(IID_IClaimedLineDisplayStatics, 2026543355, 35691, 18803, 134, 240, 62, 87, 12, 53, 24, 37);
RT_INTERFACE!{static interface IClaimedLineDisplayStatics(IClaimedLineDisplayStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IClaimedLineDisplayStatics] {
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<ClaimedLineDisplay>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorWithConnectionTypes(&self, connectionTypes: PosConnectionTypes, out: *mut HSTRING) -> HRESULT
}}
impl IClaimedLineDisplayStatics {
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ClaimedLineDisplay>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_with_connection_types(&self, connectionTypes: PosConnectionTypes) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorWithConnectionTypes)(self as *const _ as *mut _, connectionTypes, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class ClaimedLineDisplay: IClaimedLineDisplay}
impl RtActivatable<IClaimedLineDisplayStatics> for ClaimedLineDisplay {}
impl ClaimedLineDisplay {
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ClaimedLineDisplay>>> { unsafe {
        <Self as RtActivatable<IClaimedLineDisplayStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IClaimedLineDisplayStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn get_device_selector_with_connection_types(connectionTypes: PosConnectionTypes) -> Result<HString> { unsafe {
        <Self as RtActivatable<IClaimedLineDisplayStatics>>::get_activation_factory().get_device_selector_with_connection_types(connectionTypes)
    }}
}
DEFINE_CLSID!(ClaimedLineDisplay(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,111,105,110,116,79,102,83,101,114,118,105,99,101,46,67,108,97,105,109,101,100,76,105,110,101,68,105,115,112,108,97,121,0]) [CLSID_ClaimedLineDisplay]);
DEFINE_IID!(IID_ILineDisplayWindow, 3525308148, 9060, 19429, 190, 225, 133, 22, 128, 175, 73, 100);
RT_INTERFACE!{interface ILineDisplayWindow(ILineDisplayWindowVtbl): IInspectable(IInspectableVtbl) [IID_ILineDisplayWindow] {
    fn get_SizeInCharacters(&self, out: *mut super::super::foundation::Size) -> HRESULT,
    fn get_InterCharacterWaitInterval(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn put_InterCharacterWaitInterval(&self, value: super::super::foundation::TimeSpan) -> HRESULT,
    fn TryRefreshAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn TryDisplayTextAsync(&self, text: HSTRING, displayAttribute: LineDisplayTextAttribute, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn TryDisplayTextAtPositionAsync(&self, text: HSTRING, displayAttribute: LineDisplayTextAttribute, startPosition: super::super::foundation::Point, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn TryDisplayTextNormalAsync(&self, text: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn TryScrollTextAsync(&self, direction: LineDisplayScrollDirection, numberOfColumnsOrRows: u32, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT,
    fn TryClearTextAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<bool>) -> HRESULT
}}
impl ILineDisplayWindow {
    #[inline] pub unsafe fn get_size_in_characters(&self) -> Result<super::super::foundation::Size> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SizeInCharacters)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_inter_character_wait_interval(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InterCharacterWaitInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_inter_character_wait_interval(&self, value: super::super::foundation::TimeSpan) -> Result<()> {
        let hr = ((*self.lpVtbl).put_InterCharacterWaitInterval)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_refresh_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryRefreshAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_display_text_async(&self, text: &HStringArg, displayAttribute: LineDisplayTextAttribute) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryDisplayTextAsync)(self as *const _ as *mut _, text.get(), displayAttribute, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_display_text_at_position_async(&self, text: &HStringArg, displayAttribute: LineDisplayTextAttribute, startPosition: super::super::foundation::Point) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryDisplayTextAtPositionAsync)(self as *const _ as *mut _, text.get(), displayAttribute, startPosition, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_display_text_normal_async(&self, text: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryDisplayTextNormalAsync)(self as *const _ as *mut _, text.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_scroll_text_async(&self, direction: LineDisplayScrollDirection, numberOfColumnsOrRows: u32) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryScrollTextAsync)(self as *const _ as *mut _, direction, numberOfColumnsOrRows, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn try_clear_text_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<bool>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).TryClearTextAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class LineDisplayWindow: ILineDisplayWindow}
DEFINE_IID!(IID_ILineDisplayCapabilities, 1511372241, 36293, 19356, 145, 114, 48, 62, 71, 183, 12, 85);
RT_INTERFACE!{interface ILineDisplayCapabilities(ILineDisplayCapabilitiesVtbl): IInspectable(IInspectableVtbl) [IID_ILineDisplayCapabilities] {
    fn get_IsStatisticsReportingSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsStatisticsUpdatingSupported(&self, out: *mut bool) -> HRESULT,
    fn get_PowerReportingType(&self, out: *mut UnifiedPosPowerReportingType) -> HRESULT,
    fn get_CanChangeScreenSize(&self, out: *mut bool) -> HRESULT,
    fn get_CanDisplayBitmaps(&self, out: *mut bool) -> HRESULT,
    fn get_CanReadCharacterAtCursor(&self, out: *mut bool) -> HRESULT,
    fn get_CanMapCharacterSets(&self, out: *mut bool) -> HRESULT,
    fn get_CanDisplayCustomGlyphs(&self, out: *mut bool) -> HRESULT,
    fn get_CanReverse(&self, out: *mut LineDisplayTextAttributeGranularity) -> HRESULT,
    fn get_CanBlink(&self, out: *mut LineDisplayTextAttributeGranularity) -> HRESULT,
    fn get_CanChangeBlinkRate(&self, out: *mut bool) -> HRESULT,
    fn get_IsBrightnessSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsCursorSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsHorizontalMarqueeSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsVerticalMarqueeSupported(&self, out: *mut bool) -> HRESULT,
    fn get_IsInterCharacterWaitSupported(&self, out: *mut bool) -> HRESULT,
    fn get_SupportedDescriptors(&self, out: *mut u32) -> HRESULT,
    fn get_SupportedWindows(&self, out: *mut u32) -> HRESULT
}}
impl ILineDisplayCapabilities {
    #[inline] pub unsafe fn get_is_statistics_reporting_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStatisticsReportingSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_statistics_updating_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsStatisticsUpdatingSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_power_reporting_type(&self) -> Result<UnifiedPosPowerReportingType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PowerReportingType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_can_change_screen_size(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanChangeScreenSize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_can_display_bitmaps(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanDisplayBitmaps)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_can_read_character_at_cursor(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanReadCharacterAtCursor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_can_map_character_sets(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanMapCharacterSets)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_can_display_custom_glyphs(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanDisplayCustomGlyphs)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_can_reverse(&self) -> Result<LineDisplayTextAttributeGranularity> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanReverse)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_can_blink(&self) -> Result<LineDisplayTextAttributeGranularity> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanBlink)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_can_change_blink_rate(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanChangeBlinkRate)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_brightness_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsBrightnessSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_cursor_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsCursorSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_horizontal_marquee_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsHorizontalMarqueeSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_vertical_marquee_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsVerticalMarqueeSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_inter_character_wait_supported(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsInterCharacterWaitSupported)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_descriptors(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SupportedDescriptors)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_windows(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SupportedWindows)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class LineDisplayCapabilities: ILineDisplayCapabilities}
DEFINE_IID!(IID_ILineDisplay, 620093262, 15513, 17634, 183, 63, 229, 27, 227, 99, 122, 140);
RT_INTERFACE!{interface ILineDisplay(ILineDisplayVtbl): IInspectable(IInspectableVtbl) [IID_ILineDisplay] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Capabilities(&self, out: *mut *mut LineDisplayCapabilities) -> HRESULT,
    fn get_PhysicalDeviceName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_PhysicalDeviceDescription(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DeviceControlDescription(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DeviceControlVersion(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DeviceServiceVersion(&self, out: *mut HSTRING) -> HRESULT,
    fn ClaimAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<ClaimedLineDisplay>) -> HRESULT
}}
impl ILineDisplay {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_capabilities(&self) -> Result<ComPtr<LineDisplayCapabilities>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Capabilities)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_physical_device_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PhysicalDeviceName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_physical_device_description(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PhysicalDeviceDescription)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_control_description(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceControlDescription)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_control_version(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceControlVersion)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_service_version(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceServiceVersion)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn claim_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ClaimedLineDisplay>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ClaimAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IClaimedLineDisplay, 302696816, 39541, 19151, 170, 231, 9, 151, 43, 207, 135, 148);
RT_INTERFACE!{interface IClaimedLineDisplay(IClaimedLineDisplayVtbl): IInspectable(IInspectableVtbl) [IID_IClaimedLineDisplay] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Capabilities(&self, out: *mut *mut LineDisplayCapabilities) -> HRESULT,
    fn get_PhysicalDeviceName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_PhysicalDeviceDescription(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DeviceControlDescription(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DeviceControlVersion(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DeviceServiceVersion(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DefaultWindow(&self, out: *mut *mut LineDisplayWindow) -> HRESULT,
    fn RetainDevice(&self) -> HRESULT,
    fn add_ReleaseDeviceRequested(&self, handler: *mut super::super::foundation::TypedEventHandler<ClaimedLineDisplay, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReleaseDeviceRequested(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IClaimedLineDisplay {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_capabilities(&self) -> Result<ComPtr<LineDisplayCapabilities>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Capabilities)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_physical_device_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PhysicalDeviceName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_physical_device_description(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PhysicalDeviceDescription)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_control_description(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceControlDescription)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_control_version(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceControlVersion)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_service_version(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceServiceVersion)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_window(&self) -> Result<ComPtr<LineDisplayWindow>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DefaultWindow)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn retain_device(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).RetainDevice)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_release_device_requested(&self, handler: &super::super::foundation::TypedEventHandler<ClaimedLineDisplay, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReleaseDeviceRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_release_device_requested(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReleaseDeviceRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
} // Windows.Devices.PointOfService
pub mod radios { // Windows.Devices.Radios
use ::prelude::*;
RT_ENUM! { enum RadioState: i32 {
    Unknown (RadioState_Unknown) = 0, On (RadioState_On) = 1, Off (RadioState_Off) = 2, Disabled (RadioState_Disabled) = 3,
}}
RT_ENUM! { enum RadioKind: i32 {
    Other (RadioKind_Other) = 0, WiFi (RadioKind_WiFi) = 1, MobileBroadband (RadioKind_MobileBroadband) = 2, Bluetooth (RadioKind_Bluetooth) = 3, FM (RadioKind_FM) = 4,
}}
RT_ENUM! { enum RadioAccessStatus: i32 {
    Unspecified (RadioAccessStatus_Unspecified) = 0, Allowed (RadioAccessStatus_Allowed) = 1, DeniedByUser (RadioAccessStatus_DeniedByUser) = 2, DeniedBySystem (RadioAccessStatus_DeniedBySystem) = 3,
}}
DEFINE_IID!(IID_IRadioStatics, 1605804334, 26571, 18094, 170, 233, 101, 145, 159, 134, 239, 244);
RT_INTERFACE!{static interface IRadioStatics(IRadioStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IRadioStatics] {
    fn GetRadiosAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<Radio>>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<Radio>) -> HRESULT,
    fn RequestAccessAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<RadioAccessStatus>) -> HRESULT
}}
impl IRadioStatics {
    #[inline] pub unsafe fn get_radios_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<Radio>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetRadiosAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Radio>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn request_access_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<RadioAccessStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestAccessAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Radio: IRadio}
impl RtActivatable<IRadioStatics> for Radio {}
impl Radio {
    #[inline] pub fn get_radios_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<Radio>>>> { unsafe {
        <Self as RtActivatable<IRadioStatics>>::get_activation_factory().get_radios_async()
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IRadioStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Radio>>> { unsafe {
        <Self as RtActivatable<IRadioStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn request_access_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<RadioAccessStatus>>> { unsafe {
        <Self as RtActivatable<IRadioStatics>>::get_activation_factory().request_access_async()
    }}
}
DEFINE_CLSID!(Radio(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,82,97,100,105,111,115,46,82,97,100,105,111,0]) [CLSID_Radio]);
DEFINE_IID!(IID_IRadio, 622926047, 45886, 16746, 135, 95, 28, 243, 138, 226, 216, 62);
RT_INTERFACE!{interface IRadio(IRadioVtbl): IInspectable(IInspectableVtbl) [IID_IRadio] {
    fn SetStateAsync(&self, value: RadioState, out: *mut *mut super::super::foundation::IAsyncOperation<RadioAccessStatus>) -> HRESULT,
    fn add_StateChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<Radio, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_StateChanged(&self, eventCookie: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn get_State(&self, out: *mut RadioState) -> HRESULT,
    fn get_Name(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Kind(&self, out: *mut RadioKind) -> HRESULT
}}
impl IRadio {
    #[inline] pub unsafe fn set_state_async(&self, value: RadioState) -> Result<ComPtr<super::super::foundation::IAsyncOperation<RadioAccessStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).SetStateAsync)(self as *const _ as *mut _, value, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_state_changed(&self, handler: &super::super::foundation::TypedEventHandler<Radio, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_StateChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_state_changed(&self, eventCookie: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_StateChanged)(self as *const _ as *mut _, eventCookie);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_state(&self) -> Result<RadioState> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_State)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Name)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_kind(&self) -> Result<RadioKind> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Kind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
} // Windows.Devices.Radios
pub mod sensors { // Windows.Devices.Sensors
use ::prelude::*;
RT_ENUM! { enum MagnetometerAccuracy: i32 {
    Unknown (MagnetometerAccuracy_Unknown) = 0, Unreliable (MagnetometerAccuracy_Unreliable) = 1, Approximate (MagnetometerAccuracy_Approximate) = 2, High (MagnetometerAccuracy_High) = 3,
}}
RT_ENUM! { enum ActivityType: i32 {
    Unknown (ActivityType_Unknown) = 0, Idle (ActivityType_Idle) = 1, Stationary (ActivityType_Stationary) = 2, Fidgeting (ActivityType_Fidgeting) = 3, Walking (ActivityType_Walking) = 4, Running (ActivityType_Running) = 5, InVehicle (ActivityType_InVehicle) = 6, Biking (ActivityType_Biking) = 7,
}}
RT_ENUM! { enum ActivitySensorReadingConfidence: i32 {
    High (ActivitySensorReadingConfidence_High) = 0, Low (ActivitySensorReadingConfidence_Low) = 1,
}}
RT_ENUM! { enum SensorReadingType: i32 {
    Absolute (SensorReadingType_Absolute) = 0, Relative (SensorReadingType_Relative) = 1,
}}
RT_ENUM! { enum AccelerometerReadingType: i32 {
    Standard (AccelerometerReadingType_Standard) = 0, Linear (AccelerometerReadingType_Linear) = 1, Gravity (AccelerometerReadingType_Gravity) = 2,
}}
RT_ENUM! { enum SensorOptimizationGoal: i32 {
    Precision (SensorOptimizationGoal_Precision) = 0, PowerEfficiency (SensorOptimizationGoal_PowerEfficiency) = 1,
}}
RT_ENUM! { enum SensorType: i32 {
    Accelerometer (SensorType_Accelerometer) = 0, ActivitySensor (SensorType_ActivitySensor) = 1, Barometer (SensorType_Barometer) = 2, Compass (SensorType_Compass) = 3, CustomSensor (SensorType_CustomSensor) = 4, Gyroscope (SensorType_Gyroscope) = 5, ProximitySensor (SensorType_ProximitySensor) = 6, Inclinometer (SensorType_Inclinometer) = 7, LightSensor (SensorType_LightSensor) = 8, OrientationSensor (SensorType_OrientationSensor) = 9, Pedometer (SensorType_Pedometer) = 10, RelativeInclinometer (SensorType_RelativeInclinometer) = 11, RelativeOrientationSensor (SensorType_RelativeOrientationSensor) = 12, SimpleOrientationSensor (SensorType_SimpleOrientationSensor) = 13,
}}
DEFINE_IID!(IID_ISensorDataThreshold, 1423633505, 65099, 19975, 178, 96, 58, 76, 223, 190, 57, 110);
RT_INTERFACE!{interface ISensorDataThreshold(ISensorDataThresholdVtbl): IInspectable(IInspectableVtbl) [IID_ISensorDataThreshold] {
    
}}
DEFINE_IID!(IID_ISensorDataThresholdTriggerDetails, 2433151415, 59533, 18609, 188, 144, 97, 156, 123, 52, 147, 145);
RT_INTERFACE!{interface ISensorDataThresholdTriggerDetails(ISensorDataThresholdTriggerDetailsVtbl): IInspectable(IInspectableVtbl) [IID_ISensorDataThresholdTriggerDetails] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_SensorType(&self, out: *mut SensorType) -> HRESULT
}}
impl ISensorDataThresholdTriggerDetails {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_sensor_type(&self) -> Result<SensorType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SensorType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class SensorDataThresholdTriggerDetails: ISensorDataThresholdTriggerDetails}
DEFINE_IID!(IID_IAccelerometerDeviceId, 2125227177, 38869, 17517, 171, 90, 145, 125, 249, 185, 106, 44);
RT_INTERFACE!{interface IAccelerometerDeviceId(IAccelerometerDeviceIdVtbl): IInspectable(IInspectableVtbl) [IID_IAccelerometerDeviceId] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl IAccelerometerDeviceId {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAccelerometerStatics, 2783087476, 23175, 18989, 190, 204, 15, 144, 110, 160, 97, 221);
RT_INTERFACE!{static interface IAccelerometerStatics(IAccelerometerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IAccelerometerStatics] {
    fn GetDefault(&self, out: *mut *mut Accelerometer) -> HRESULT
}}
impl IAccelerometerStatics {
    #[inline] pub unsafe fn get_default(&self) -> Result<ComPtr<Accelerometer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefault)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Accelerometer: IAccelerometer}
impl RtActivatable<IAccelerometerStatics2> for Accelerometer {}
impl RtActivatable<IAccelerometerStatics> for Accelerometer {}
impl Accelerometer {
    #[inline] pub fn get_default_with_accelerometer_reading_type(readingType: AccelerometerReadingType) -> Result<ComPtr<Accelerometer>> { unsafe {
        <Self as RtActivatable<IAccelerometerStatics2>>::get_activation_factory().get_default_with_accelerometer_reading_type(readingType)
    }}
    #[inline] pub fn get_default() -> Result<ComPtr<Accelerometer>> { unsafe {
        <Self as RtActivatable<IAccelerometerStatics>>::get_activation_factory().get_default()
    }}
}
DEFINE_CLSID!(Accelerometer(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,65,99,99,101,108,101,114,111,109,101,116,101,114,0]) [CLSID_Accelerometer]);
DEFINE_IID!(IID_IAccelerometerStatics2, 3301213231, 55403, 18053, 178, 215, 51, 150, 247, 152, 213, 123);
RT_INTERFACE!{static interface IAccelerometerStatics2(IAccelerometerStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IAccelerometerStatics2] {
    fn GetDefaultWithAccelerometerReadingType(&self, readingType: AccelerometerReadingType, out: *mut *mut Accelerometer) -> HRESULT
}}
impl IAccelerometerStatics2 {
    #[inline] pub unsafe fn get_default_with_accelerometer_reading_type(&self, readingType: AccelerometerReadingType) -> Result<ComPtr<Accelerometer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultWithAccelerometerReadingType)(self as *const _ as *mut _, readingType, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAccelerometer, 3742909768, 10001, 19879, 128, 152, 75, 130, 32, 93, 60, 125);
RT_INTERFACE!{interface IAccelerometer(IAccelerometerVtbl): IInspectable(IInspectableVtbl) [IID_IAccelerometer] {
    fn GetCurrentReading(&self, out: *mut *mut AccelerometerReading) -> HRESULT,
    fn get_MinimumReportInterval(&self, out: *mut u32) -> HRESULT,
    fn put_ReportInterval(&self, value: u32) -> HRESULT,
    fn get_ReportInterval(&self, out: *mut u32) -> HRESULT,
    fn add_ReadingChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<Accelerometer, AccelerometerReadingChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadingChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_Shaken(&self, handler: *mut super::super::foundation::TypedEventHandler<Accelerometer, AccelerometerShakenEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_Shaken(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IAccelerometer {
    #[inline] pub unsafe fn get_current_reading(&self) -> Result<ComPtr<AccelerometerReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCurrentReading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_minimum_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinimumReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_report_interval(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReportInterval)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_reading_changed(&self, handler: &super::super::foundation::TypedEventHandler<Accelerometer, AccelerometerReadingChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadingChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_reading_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadingChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_shaken(&self, handler: &super::super::foundation::TypedEventHandler<Accelerometer, AccelerometerShakenEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_Shaken)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_shaken(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_Shaken)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class AccelerometerReading: IAccelerometerReading}
RT_CLASS!{class AccelerometerReadingChangedEventArgs: IAccelerometerReadingChangedEventArgs}
RT_CLASS!{class AccelerometerShakenEventArgs: IAccelerometerShakenEventArgs}
DEFINE_IID!(IID_IAccelerometer2, 3908080366, 18788, 16410, 182, 2, 34, 13, 113, 83, 198, 10);
RT_INTERFACE!{interface IAccelerometer2(IAccelerometer2Vtbl): IInspectable(IInspectableVtbl) [IID_IAccelerometer2] {
    #[cfg(feature="windows-graphics")] fn put_ReadingTransform(&self, value: super::super::graphics::display::DisplayOrientations) -> HRESULT,
    #[cfg(feature="windows-graphics")] fn get_ReadingTransform(&self, out: *mut super::super::graphics::display::DisplayOrientations) -> HRESULT
}}
impl IAccelerometer2 {
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn set_reading_transform(&self, value: super::super::graphics::display::DisplayOrientations) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReadingTransform)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn get_reading_transform(&self) -> Result<super::super::graphics::display::DisplayOrientations> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadingTransform)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAccelerometer3, 2279604778, 60800, 18923, 191, 138, 164, 234, 49, 229, 205, 132);
RT_INTERFACE!{interface IAccelerometer3(IAccelerometer3Vtbl): IInspectable(IInspectableVtbl) [IID_IAccelerometer3] {
    fn put_ReportLatency(&self, value: u32) -> HRESULT,
    fn get_ReportLatency(&self, out: *mut u32) -> HRESULT,
    fn get_MaxBatchSize(&self, out: *mut u32) -> HRESULT
}}
impl IAccelerometer3 {
    #[inline] pub unsafe fn set_report_latency(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReportLatency)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_latency(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportLatency)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_batch_size(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxBatchSize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAccelerometer4, 490159183, 17107, 17842, 129, 68, 171, 127, 182, 101, 235, 89);
RT_INTERFACE!{interface IAccelerometer4(IAccelerometer4Vtbl): IInspectable(IInspectableVtbl) [IID_IAccelerometer4] {
    fn get_ReadingType(&self, out: *mut AccelerometerReadingType) -> HRESULT
}}
impl IAccelerometer4 {
    #[inline] pub unsafe fn get_reading_type(&self) -> Result<AccelerometerReadingType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadingType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAccelerometerReading, 3120462539, 54097, 16559, 139, 182, 122, 169, 174, 100, 31, 183);
RT_INTERFACE!{interface IAccelerometerReading(IAccelerometerReadingVtbl): IInspectable(IInspectableVtbl) [IID_IAccelerometerReading] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_AccelerationX(&self, out: *mut f64) -> HRESULT,
    fn get_AccelerationY(&self, out: *mut f64) -> HRESULT,
    fn get_AccelerationZ(&self, out: *mut f64) -> HRESULT
}}
impl IAccelerometerReading {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_acceleration_x(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AccelerationX)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_acceleration_y(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AccelerationY)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_acceleration_z(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AccelerationZ)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAccelerometerReadingChangedEventArgs, 9815643, 46764, 18266, 159, 68, 139, 50, 211, 90, 63, 37);
RT_INTERFACE!{interface IAccelerometerReadingChangedEventArgs(IAccelerometerReadingChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAccelerometerReadingChangedEventArgs] {
    fn get_Reading(&self, out: *mut *mut AccelerometerReading) -> HRESULT
}}
impl IAccelerometerReadingChangedEventArgs {
    #[inline] pub unsafe fn get_reading(&self) -> Result<ComPtr<AccelerometerReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAccelerometerShakenEventArgs, 2516517329, 18984, 20277, 152, 232, 129, 120, 170, 228, 8, 74);
RT_INTERFACE!{interface IAccelerometerShakenEventArgs(IAccelerometerShakenEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAccelerometerShakenEventArgs] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT
}}
impl IAccelerometerShakenEventArgs {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IInclinometerDeviceId, 32053634, 16895, 17414, 174, 131, 98, 33, 15, 241, 111, 227);
RT_INTERFACE!{interface IInclinometerDeviceId(IInclinometerDeviceIdVtbl): IInspectable(IInspectableVtbl) [IID_IInclinometerDeviceId] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl IInclinometerDeviceId {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IInclinometerStatics, 4063151441, 39984, 17722, 139, 73, 60, 62, 235, 51, 203, 97);
RT_INTERFACE!{static interface IInclinometerStatics(IInclinometerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IInclinometerStatics] {
    fn GetDefault(&self, out: *mut *mut Inclinometer) -> HRESULT
}}
impl IInclinometerStatics {
    #[inline] pub unsafe fn get_default(&self) -> Result<ComPtr<Inclinometer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefault)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Inclinometer: IInclinometer}
impl RtActivatable<IInclinometerStatics> for Inclinometer {}
impl RtActivatable<IInclinometerStatics3> for Inclinometer {}
impl RtActivatable<IInclinometerStatics2> for Inclinometer {}
impl Inclinometer {
    #[inline] pub fn get_default() -> Result<ComPtr<Inclinometer>> { unsafe {
        <Self as RtActivatable<IInclinometerStatics>>::get_activation_factory().get_default()
    }}
    #[inline] pub fn get_default_with_sensor_reading_type(sensorReadingtype: SensorReadingType) -> Result<ComPtr<Inclinometer>> { unsafe {
        <Self as RtActivatable<IInclinometerStatics3>>::get_activation_factory().get_default_with_sensor_reading_type(sensorReadingtype)
    }}
    #[inline] pub fn get_default_for_relative_readings() -> Result<ComPtr<Inclinometer>> { unsafe {
        <Self as RtActivatable<IInclinometerStatics2>>::get_activation_factory().get_default_for_relative_readings()
    }}
}
DEFINE_CLSID!(Inclinometer(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,73,110,99,108,105,110,111,109,101,116,101,114,0]) [CLSID_Inclinometer]);
DEFINE_IID!(IID_IInclinometerStatics2, 71276405, 27166, 18844, 134, 224, 99, 140, 26, 134, 75, 0);
RT_INTERFACE!{static interface IInclinometerStatics2(IInclinometerStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IInclinometerStatics2] {
    fn GetDefaultForRelativeReadings(&self, out: *mut *mut Inclinometer) -> HRESULT
}}
impl IInclinometerStatics2 {
    #[inline] pub unsafe fn get_default_for_relative_readings(&self) -> Result<ComPtr<Inclinometer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultForRelativeReadings)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IInclinometerStatics3, 3181003392, 47386, 18473, 147, 146, 171, 192, 182, 189, 242, 180);
RT_INTERFACE!{static interface IInclinometerStatics3(IInclinometerStatics3Vtbl): IInspectable(IInspectableVtbl) [IID_IInclinometerStatics3] {
    fn GetDefaultWithSensorReadingType(&self, sensorReadingtype: SensorReadingType, out: *mut *mut Inclinometer) -> HRESULT
}}
impl IInclinometerStatics3 {
    #[inline] pub unsafe fn get_default_with_sensor_reading_type(&self, sensorReadingtype: SensorReadingType) -> Result<ComPtr<Inclinometer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultWithSensorReadingType)(self as *const _ as *mut _, sensorReadingtype, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IInclinometer, 642304623, 8838, 16495, 145, 97, 240, 196, 189, 128, 110, 191);
RT_INTERFACE!{interface IInclinometer(IInclinometerVtbl): IInspectable(IInspectableVtbl) [IID_IInclinometer] {
    fn GetCurrentReading(&self, out: *mut *mut InclinometerReading) -> HRESULT,
    fn get_MinimumReportInterval(&self, out: *mut u32) -> HRESULT,
    fn put_ReportInterval(&self, value: u32) -> HRESULT,
    fn get_ReportInterval(&self, out: *mut u32) -> HRESULT,
    fn add_ReadingChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<Inclinometer, InclinometerReadingChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadingChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IInclinometer {
    #[inline] pub unsafe fn get_current_reading(&self) -> Result<ComPtr<InclinometerReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCurrentReading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_minimum_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinimumReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_report_interval(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReportInterval)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_reading_changed(&self, handler: &super::super::foundation::TypedEventHandler<Inclinometer, InclinometerReadingChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadingChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_reading_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadingChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class InclinometerReading: IInclinometerReading}
RT_CLASS!{class InclinometerReadingChangedEventArgs: IInclinometerReadingChangedEventArgs}
DEFINE_IID!(IID_IInclinometer2, 43987859, 10418, 17912, 187, 22, 97, 232, 106, 127, 174, 110);
RT_INTERFACE!{interface IInclinometer2(IInclinometer2Vtbl): IInspectable(IInspectableVtbl) [IID_IInclinometer2] {
    #[cfg(not(feature="windows-graphics"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-graphics")] fn put_ReadingTransform(&self, value: super::super::graphics::display::DisplayOrientations) -> HRESULT,
    #[cfg(not(feature="windows-graphics"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-graphics")] fn get_ReadingTransform(&self, out: *mut super::super::graphics::display::DisplayOrientations) -> HRESULT,
    fn get_ReadingType(&self, out: *mut SensorReadingType) -> HRESULT
}}
impl IInclinometer2 {
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn set_reading_transform(&self, value: super::super::graphics::display::DisplayOrientations) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReadingTransform)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn get_reading_transform(&self) -> Result<super::super::graphics::display::DisplayOrientations> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadingTransform)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_reading_type(&self) -> Result<SensorReadingType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadingType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IInclinometerReading, 2672095317, 46838, 18815, 177, 39, 26, 119, 94, 80, 20, 88);
RT_INTERFACE!{interface IInclinometerReading(IInclinometerReadingVtbl): IInspectable(IInspectableVtbl) [IID_IInclinometerReading] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_PitchDegrees(&self, out: *mut f32) -> HRESULT,
    fn get_RollDegrees(&self, out: *mut f32) -> HRESULT,
    fn get_YawDegrees(&self, out: *mut f32) -> HRESULT
}}
impl IInclinometerReading {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pitch_degrees(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PitchDegrees)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_roll_degrees(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RollDegrees)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_yaw_degrees(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_YawDegrees)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IInclinometerReadingYawAccuracy, 3025397888, 8163, 18822, 162, 87, 230, 236, 226, 114, 57, 73);
RT_INTERFACE!{interface IInclinometerReadingYawAccuracy(IInclinometerReadingYawAccuracyVtbl): IInspectable(IInspectableVtbl) [IID_IInclinometerReadingYawAccuracy] {
    fn get_YawAccuracy(&self, out: *mut MagnetometerAccuracy) -> HRESULT
}}
impl IInclinometerReadingYawAccuracy {
    #[inline] pub unsafe fn get_yaw_accuracy(&self) -> Result<MagnetometerAccuracy> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_YawAccuracy)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IInclinometerReadingChangedEventArgs, 1256791489, 59371, 18744, 133, 17, 174, 13, 107, 68, 4, 56);
RT_INTERFACE!{interface IInclinometerReadingChangedEventArgs(IInclinometerReadingChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IInclinometerReadingChangedEventArgs] {
    fn get_Reading(&self, out: *mut *mut InclinometerReading) -> HRESULT
}}
impl IInclinometerReadingChangedEventArgs {
    #[inline] pub unsafe fn get_reading(&self) -> Result<ComPtr<InclinometerReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGyrometerDeviceId, 518383992, 35234, 17013, 158, 149, 113, 38, 244, 112, 135, 96);
RT_INTERFACE!{interface IGyrometerDeviceId(IGyrometerDeviceIdVtbl): IInspectable(IInspectableVtbl) [IID_IGyrometerDeviceId] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl IGyrometerDeviceId {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGyrometerStatics, 2209802185, 58525, 19257, 134, 230, 205, 85, 75, 228, 197, 193);
RT_INTERFACE!{static interface IGyrometerStatics(IGyrometerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IGyrometerStatics] {
    fn GetDefault(&self, out: *mut *mut Gyrometer) -> HRESULT
}}
impl IGyrometerStatics {
    #[inline] pub unsafe fn get_default(&self) -> Result<ComPtr<Gyrometer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefault)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Gyrometer: IGyrometer}
impl RtActivatable<IGyrometerStatics> for Gyrometer {}
impl Gyrometer {
    #[inline] pub fn get_default() -> Result<ComPtr<Gyrometer>> { unsafe {
        <Self as RtActivatable<IGyrometerStatics>>::get_activation_factory().get_default()
    }}
}
DEFINE_CLSID!(Gyrometer(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,71,121,114,111,109,101,116,101,114,0]) [CLSID_Gyrometer]);
DEFINE_IID!(IID_IGyrometer, 4256803268, 33969, 19618, 151, 99, 155, 88, 149, 6, 199, 12);
RT_INTERFACE!{interface IGyrometer(IGyrometerVtbl): IInspectable(IInspectableVtbl) [IID_IGyrometer] {
    fn GetCurrentReading(&self, out: *mut *mut GyrometerReading) -> HRESULT,
    fn get_MinimumReportInterval(&self, out: *mut u32) -> HRESULT,
    fn put_ReportInterval(&self, value: u32) -> HRESULT,
    fn get_ReportInterval(&self, out: *mut u32) -> HRESULT,
    fn add_ReadingChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<Gyrometer, GyrometerReadingChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadingChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IGyrometer {
    #[inline] pub unsafe fn get_current_reading(&self) -> Result<ComPtr<GyrometerReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCurrentReading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_minimum_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinimumReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_report_interval(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReportInterval)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_reading_changed(&self, handler: &super::super::foundation::TypedEventHandler<Gyrometer, GyrometerReadingChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadingChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_reading_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadingChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class GyrometerReading: IGyrometerReading}
RT_CLASS!{class GyrometerReadingChangedEventArgs: IGyrometerReadingChangedEventArgs}
DEFINE_IID!(IID_IGyrometer2, 1675568195, 36072, 16835, 172, 68, 134, 152, 129, 11, 85, 127);
RT_INTERFACE!{interface IGyrometer2(IGyrometer2Vtbl): IInspectable(IInspectableVtbl) [IID_IGyrometer2] {
    #[cfg(feature="windows-graphics")] fn put_ReadingTransform(&self, value: super::super::graphics::display::DisplayOrientations) -> HRESULT,
    #[cfg(feature="windows-graphics")] fn get_ReadingTransform(&self, out: *mut super::super::graphics::display::DisplayOrientations) -> HRESULT
}}
impl IGyrometer2 {
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn set_reading_transform(&self, value: super::super::graphics::display::DisplayOrientations) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReadingTransform)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn get_reading_transform(&self) -> Result<super::super::graphics::display::DisplayOrientations> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadingTransform)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGyrometerReading, 3017203292, 7908, 17775, 157, 231, 226, 73, 59, 92, 142, 3);
RT_INTERFACE!{interface IGyrometerReading(IGyrometerReadingVtbl): IInspectable(IInspectableVtbl) [IID_IGyrometerReading] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_AngularVelocityX(&self, out: *mut f64) -> HRESULT,
    fn get_AngularVelocityY(&self, out: *mut f64) -> HRESULT,
    fn get_AngularVelocityZ(&self, out: *mut f64) -> HRESULT
}}
impl IGyrometerReading {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_angular_velocity_x(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AngularVelocityX)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_angular_velocity_y(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AngularVelocityY)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_angular_velocity_z(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AngularVelocityZ)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IGyrometerReadingChangedEventArgs, 266279061, 28574, 17102, 141, 88, 56, 140, 10, 184, 53, 109);
RT_INTERFACE!{interface IGyrometerReadingChangedEventArgs(IGyrometerReadingChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IGyrometerReadingChangedEventArgs] {
    fn get_Reading(&self, out: *mut *mut GyrometerReading) -> HRESULT
}}
impl IGyrometerReadingChangedEventArgs {
    #[inline] pub unsafe fn get_reading(&self) -> Result<ComPtr<GyrometerReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ICompassDeviceId, 3514944041, 45189, 19229, 135, 10, 79, 245, 123, 167, 79, 212);
RT_INTERFACE!{interface ICompassDeviceId(ICompassDeviceIdVtbl): IInspectable(IInspectableVtbl) [IID_ICompassDeviceId] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl ICompassDeviceId {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ICompassStatics, 2596050911, 22252, 19493, 181, 77, 64, 166, 139, 181, 178, 105);
RT_INTERFACE!{static interface ICompassStatics(ICompassStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ICompassStatics] {
    fn GetDefault(&self, out: *mut *mut Compass) -> HRESULT
}}
impl ICompassStatics {
    #[inline] pub unsafe fn get_default(&self) -> Result<ComPtr<Compass>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefault)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Compass: ICompass}
impl RtActivatable<ICompassStatics> for Compass {}
impl Compass {
    #[inline] pub fn get_default() -> Result<ComPtr<Compass>> { unsafe {
        <Self as RtActivatable<ICompassStatics>>::get_activation_factory().get_default()
    }}
}
DEFINE_CLSID!(Compass(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,67,111,109,112,97,115,115,0]) [CLSID_Compass]);
DEFINE_IID!(IID_ICompass, 691010196, 6981, 16444, 186, 6, 177, 6, 219, 166, 154, 100);
RT_INTERFACE!{interface ICompass(ICompassVtbl): IInspectable(IInspectableVtbl) [IID_ICompass] {
    fn GetCurrentReading(&self, out: *mut *mut CompassReading) -> HRESULT,
    fn get_MinimumReportInterval(&self, out: *mut u32) -> HRESULT,
    fn put_ReportInterval(&self, value: u32) -> HRESULT,
    fn get_ReportInterval(&self, out: *mut u32) -> HRESULT,
    fn add_ReadingChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<Compass, CompassReadingChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadingChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl ICompass {
    #[inline] pub unsafe fn get_current_reading(&self) -> Result<ComPtr<CompassReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCurrentReading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_minimum_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinimumReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_report_interval(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReportInterval)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_reading_changed(&self, handler: &super::super::foundation::TypedEventHandler<Compass, CompassReadingChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadingChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_reading_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadingChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class CompassReading: ICompassReading}
RT_CLASS!{class CompassReadingChangedEventArgs: ICompassReadingChangedEventArgs}
DEFINE_IID!(IID_ICompass2, 921857289, 51159, 17231, 180, 97, 151, 157, 223, 194, 50, 47);
RT_INTERFACE!{interface ICompass2(ICompass2Vtbl): IInspectable(IInspectableVtbl) [IID_ICompass2] {
    #[cfg(feature="windows-graphics")] fn put_ReadingTransform(&self, value: super::super::graphics::display::DisplayOrientations) -> HRESULT,
    #[cfg(feature="windows-graphics")] fn get_ReadingTransform(&self, out: *mut super::super::graphics::display::DisplayOrientations) -> HRESULT
}}
impl ICompass2 {
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn set_reading_transform(&self, value: super::super::graphics::display::DisplayOrientations) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReadingTransform)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn get_reading_transform(&self) -> Result<super::super::graphics::display::DisplayOrientations> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadingTransform)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ICompassReading, 2190545192, 20797, 19913, 183, 129, 94, 237, 251, 240, 45, 12);
RT_INTERFACE!{interface ICompassReading(ICompassReadingVtbl): IInspectable(IInspectableVtbl) [IID_ICompassReading] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_HeadingMagneticNorth(&self, out: *mut f64) -> HRESULT,
    fn get_HeadingTrueNorth(&self, out: *mut *mut super::super::foundation::IReference<f64>) -> HRESULT
}}
impl ICompassReading {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_heading_magnetic_north(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HeadingMagneticNorth)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_heading_true_north(&self) -> Result<ComPtr<super::super::foundation::IReference<f64>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_HeadingTrueNorth)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ICompassReadingHeadingAccuracy, 3881907534, 35089, 16631, 158, 22, 110, 204, 125, 174, 197, 222);
RT_INTERFACE!{interface ICompassReadingHeadingAccuracy(ICompassReadingHeadingAccuracyVtbl): IInspectable(IInspectableVtbl) [IID_ICompassReadingHeadingAccuracy] {
    fn get_HeadingAccuracy(&self, out: *mut MagnetometerAccuracy) -> HRESULT
}}
impl ICompassReadingHeadingAccuracy {
    #[inline] pub unsafe fn get_heading_accuracy(&self) -> Result<MagnetometerAccuracy> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_HeadingAccuracy)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ICompassReadingChangedEventArgs, 2400537008, 59580, 19582, 176, 9, 78, 65, 223, 19, 112, 114);
RT_INTERFACE!{interface ICompassReadingChangedEventArgs(ICompassReadingChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_ICompassReadingChangedEventArgs] {
    fn get_Reading(&self, out: *mut *mut CompassReading) -> HRESULT
}}
impl ICompassReadingChangedEventArgs {
    #[inline] pub unsafe fn get_reading(&self) -> Result<ComPtr<CompassReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ILightSensorDeviceId, 2146322936, 2811, 20305, 135, 240, 108, 38, 55, 92, 233, 79);
RT_INTERFACE!{interface ILightSensorDeviceId(ILightSensorDeviceIdVtbl): IInspectable(IInspectableVtbl) [IID_ILightSensorDeviceId] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl ILightSensorDeviceId {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ILightSensorStatics, 1172016260, 50088, 18206, 154, 83, 100, 87, 250, 216, 124, 14);
RT_INTERFACE!{static interface ILightSensorStatics(ILightSensorStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ILightSensorStatics] {
    fn GetDefault(&self, out: *mut *mut LightSensor) -> HRESULT
}}
impl ILightSensorStatics {
    #[inline] pub unsafe fn get_default(&self) -> Result<ComPtr<LightSensor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefault)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class LightSensor: ILightSensor}
impl RtActivatable<ILightSensorStatics> for LightSensor {}
impl LightSensor {
    #[inline] pub fn get_default() -> Result<ComPtr<LightSensor>> { unsafe {
        <Self as RtActivatable<ILightSensorStatics>>::get_activation_factory().get_default()
    }}
}
DEFINE_CLSID!(LightSensor(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,76,105,103,104,116,83,101,110,115,111,114,0]) [CLSID_LightSensor]);
DEFINE_IID!(IID_ILightSensor, 4165732120, 3156, 18350, 146, 46, 120, 159, 87, 251, 3, 160);
RT_INTERFACE!{interface ILightSensor(ILightSensorVtbl): IInspectable(IInspectableVtbl) [IID_ILightSensor] {
    fn GetCurrentReading(&self, out: *mut *mut LightSensorReading) -> HRESULT,
    fn get_MinimumReportInterval(&self, out: *mut u32) -> HRESULT,
    fn put_ReportInterval(&self, value: u32) -> HRESULT,
    fn get_ReportInterval(&self, out: *mut u32) -> HRESULT,
    fn add_ReadingChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<LightSensor, LightSensorReadingChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadingChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl ILightSensor {
    #[inline] pub unsafe fn get_current_reading(&self) -> Result<ComPtr<LightSensorReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCurrentReading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_minimum_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinimumReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_report_interval(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReportInterval)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_reading_changed(&self, handler: &super::super::foundation::TypedEventHandler<LightSensor, LightSensorReadingChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadingChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_reading_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadingChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class LightSensorReading: ILightSensorReading}
RT_CLASS!{class LightSensorReadingChangedEventArgs: ILightSensorReadingChangedEventArgs}
DEFINE_IID!(IID_ILightSensorReading, 4292829952, 8828, 19755, 179, 2, 252, 1, 66, 72, 92, 104);
RT_INTERFACE!{interface ILightSensorReading(ILightSensorReadingVtbl): IInspectable(IInspectableVtbl) [IID_ILightSensorReading] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_IlluminanceInLux(&self, out: *mut f32) -> HRESULT
}}
impl ILightSensorReading {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_illuminance_in_lux(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IlluminanceInLux)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ILightSensorReadingChangedEventArgs, 2745365711, 9611, 16908, 184, 171, 142, 221, 96, 30, 207, 80);
RT_INTERFACE!{interface ILightSensorReadingChangedEventArgs(ILightSensorReadingChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_ILightSensorReadingChangedEventArgs] {
    fn get_Reading(&self, out: *mut *mut LightSensorReading) -> HRESULT
}}
impl ILightSensorReadingChangedEventArgs {
    #[inline] pub unsafe fn get_reading(&self) -> Result<ComPtr<LightSensorReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISensorRotationMatrix, 171792999, 8948, 17298, 149, 56, 101, 208, 189, 6, 74, 166);
RT_INTERFACE!{interface ISensorRotationMatrix(ISensorRotationMatrixVtbl): IInspectable(IInspectableVtbl) [IID_ISensorRotationMatrix] {
    fn get_M11(&self, out: *mut f32) -> HRESULT,
    fn get_M12(&self, out: *mut f32) -> HRESULT,
    fn get_M13(&self, out: *mut f32) -> HRESULT,
    fn get_M21(&self, out: *mut f32) -> HRESULT,
    fn get_M22(&self, out: *mut f32) -> HRESULT,
    fn get_M23(&self, out: *mut f32) -> HRESULT,
    fn get_M31(&self, out: *mut f32) -> HRESULT,
    fn get_M32(&self, out: *mut f32) -> HRESULT,
    fn get_M33(&self, out: *mut f32) -> HRESULT
}}
impl ISensorRotationMatrix {
    #[inline] pub unsafe fn get_m11(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_M11)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_m12(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_M12)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_m13(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_M13)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_m21(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_M21)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_m22(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_M22)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_m23(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_M23)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_m31(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_M31)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_m32(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_M32)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_m33(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_M33)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISensorQuaternion, 3385182247, 50972, 18151, 157, 163, 54, 161, 147, 178, 50, 188);
RT_INTERFACE!{interface ISensorQuaternion(ISensorQuaternionVtbl): IInspectable(IInspectableVtbl) [IID_ISensorQuaternion] {
    fn get_W(&self, out: *mut f32) -> HRESULT,
    fn get_X(&self, out: *mut f32) -> HRESULT,
    fn get_Y(&self, out: *mut f32) -> HRESULT,
    fn get_Z(&self, out: *mut f32) -> HRESULT
}}
impl ISensorQuaternion {
    #[inline] pub unsafe fn get_w(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_W)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_x(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_X)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_y(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Y)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_z(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Z)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class SensorRotationMatrix: ISensorRotationMatrix}
RT_CLASS!{class SensorQuaternion: ISensorQuaternion}
DEFINE_IID!(IID_IOrientationSensorDeviceId, 1516877384, 19497, 18924, 178, 143, 234, 29, 17, 123, 102, 240);
RT_INTERFACE!{interface IOrientationSensorDeviceId(IOrientationSensorDeviceIdVtbl): IInspectable(IInspectableVtbl) [IID_IOrientationSensorDeviceId] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl IOrientationSensorDeviceId {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IOrientationSensorStatics, 284133138, 64332, 17034, 137, 139, 39, 101, 228, 9, 230, 105);
RT_INTERFACE!{static interface IOrientationSensorStatics(IOrientationSensorStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IOrientationSensorStatics] {
    fn GetDefault(&self, out: *mut *mut OrientationSensor) -> HRESULT
}}
impl IOrientationSensorStatics {
    #[inline] pub unsafe fn get_default(&self) -> Result<ComPtr<OrientationSensor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefault)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class OrientationSensor: IOrientationSensor}
impl RtActivatable<IOrientationSensorStatics3> for OrientationSensor {}
impl RtActivatable<IOrientationSensorStatics> for OrientationSensor {}
impl RtActivatable<IOrientationSensorStatics2> for OrientationSensor {}
impl OrientationSensor {
    #[inline] pub fn get_default_with_sensor_reading_type(sensorReadingtype: SensorReadingType) -> Result<ComPtr<OrientationSensor>> { unsafe {
        <Self as RtActivatable<IOrientationSensorStatics3>>::get_activation_factory().get_default_with_sensor_reading_type(sensorReadingtype)
    }}
    #[inline] pub fn get_default_with_sensor_reading_type_and_sensor_optimization_goal(sensorReadingType: SensorReadingType, optimizationGoal: SensorOptimizationGoal) -> Result<ComPtr<OrientationSensor>> { unsafe {
        <Self as RtActivatable<IOrientationSensorStatics3>>::get_activation_factory().get_default_with_sensor_reading_type_and_sensor_optimization_goal(sensorReadingType, optimizationGoal)
    }}
    #[inline] pub fn get_default() -> Result<ComPtr<OrientationSensor>> { unsafe {
        <Self as RtActivatable<IOrientationSensorStatics>>::get_activation_factory().get_default()
    }}
    #[inline] pub fn get_default_for_relative_readings() -> Result<ComPtr<OrientationSensor>> { unsafe {
        <Self as RtActivatable<IOrientationSensorStatics2>>::get_activation_factory().get_default_for_relative_readings()
    }}
}
DEFINE_CLSID!(OrientationSensor(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,79,114,105,101,110,116,97,116,105,111,110,83,101,110,115,111,114,0]) [CLSID_OrientationSensor]);
DEFINE_IID!(IID_IOrientationSensorStatics2, 1507462411, 54282, 19569, 146, 118, 138, 39, 42, 10, 102, 25);
RT_INTERFACE!{static interface IOrientationSensorStatics2(IOrientationSensorStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IOrientationSensorStatics2] {
    fn GetDefaultForRelativeReadings(&self, out: *mut *mut OrientationSensor) -> HRESULT
}}
impl IOrientationSensorStatics2 {
    #[inline] pub unsafe fn get_default_for_relative_readings(&self) -> Result<ComPtr<OrientationSensor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultForRelativeReadings)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IOrientationSensorStatics3, 3626821920, 10103, 16639, 159, 89, 214, 84, 176, 133, 241, 47);
RT_INTERFACE!{static interface IOrientationSensorStatics3(IOrientationSensorStatics3Vtbl): IInspectable(IInspectableVtbl) [IID_IOrientationSensorStatics3] {
    fn GetDefaultWithSensorReadingType(&self, sensorReadingtype: SensorReadingType, out: *mut *mut OrientationSensor) -> HRESULT,
    fn GetDefaultWithSensorReadingTypeAndSensorOptimizationGoal(&self, sensorReadingType: SensorReadingType, optimizationGoal: SensorOptimizationGoal, out: *mut *mut OrientationSensor) -> HRESULT
}}
impl IOrientationSensorStatics3 {
    #[inline] pub unsafe fn get_default_with_sensor_reading_type(&self, sensorReadingtype: SensorReadingType) -> Result<ComPtr<OrientationSensor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultWithSensorReadingType)(self as *const _ as *mut _, sensorReadingtype, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_with_sensor_reading_type_and_sensor_optimization_goal(&self, sensorReadingType: SensorReadingType, optimizationGoal: SensorOptimizationGoal) -> Result<ComPtr<OrientationSensor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultWithSensorReadingTypeAndSensorOptimizationGoal)(self as *const _ as *mut _, sensorReadingType, optimizationGoal, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IOrientationSensor, 1580549685, 53099, 19555, 171, 216, 16, 37, 43, 11, 246, 236);
RT_INTERFACE!{interface IOrientationSensor(IOrientationSensorVtbl): IInspectable(IInspectableVtbl) [IID_IOrientationSensor] {
    fn GetCurrentReading(&self, out: *mut *mut OrientationSensorReading) -> HRESULT,
    fn get_MinimumReportInterval(&self, out: *mut u32) -> HRESULT,
    fn put_ReportInterval(&self, value: u32) -> HRESULT,
    fn get_ReportInterval(&self, out: *mut u32) -> HRESULT,
    fn add_ReadingChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<OrientationSensor, OrientationSensorReadingChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadingChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IOrientationSensor {
    #[inline] pub unsafe fn get_current_reading(&self) -> Result<ComPtr<OrientationSensorReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCurrentReading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_minimum_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinimumReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_report_interval(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReportInterval)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_reading_changed(&self, handler: &super::super::foundation::TypedEventHandler<OrientationSensor, OrientationSensorReadingChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadingChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_reading_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadingChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class OrientationSensorReading: IOrientationSensorReading}
RT_CLASS!{class OrientationSensorReadingChangedEventArgs: IOrientationSensorReadingChangedEventArgs}
DEFINE_IID!(IID_IOrientationSensor2, 227691769, 12063, 18889, 128, 66, 74, 24, 19, 214, 119, 96);
RT_INTERFACE!{interface IOrientationSensor2(IOrientationSensor2Vtbl): IInspectable(IInspectableVtbl) [IID_IOrientationSensor2] {
    #[cfg(not(feature="windows-graphics"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-graphics")] fn put_ReadingTransform(&self, value: super::super::graphics::display::DisplayOrientations) -> HRESULT,
    #[cfg(not(feature="windows-graphics"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-graphics")] fn get_ReadingTransform(&self, out: *mut super::super::graphics::display::DisplayOrientations) -> HRESULT,
    fn get_ReadingType(&self, out: *mut SensorReadingType) -> HRESULT
}}
impl IOrientationSensor2 {
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn set_reading_transform(&self, value: super::super::graphics::display::DisplayOrientations) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReadingTransform)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn get_reading_transform(&self) -> Result<super::super::graphics::display::DisplayOrientations> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadingTransform)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_reading_type(&self) -> Result<SensorReadingType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadingType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IOrientationSensorReading, 1196870035, 26005, 18583, 188, 198, 213, 55, 238, 117, 117, 100);
RT_INTERFACE!{interface IOrientationSensorReading(IOrientationSensorReadingVtbl): IInspectable(IInspectableVtbl) [IID_IOrientationSensorReading] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_RotationMatrix(&self, out: *mut *mut SensorRotationMatrix) -> HRESULT,
    fn get_Quaternion(&self, out: *mut *mut SensorQuaternion) -> HRESULT
}}
impl IOrientationSensorReading {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_rotation_matrix(&self) -> Result<ComPtr<SensorRotationMatrix>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_RotationMatrix)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_quaternion(&self) -> Result<ComPtr<SensorQuaternion>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Quaternion)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IOrientationSensorReadingYawAccuracy, 3517749284, 16218, 18850, 188, 123, 17, 128, 188, 56, 205, 43);
RT_INTERFACE!{interface IOrientationSensorReadingYawAccuracy(IOrientationSensorReadingYawAccuracyVtbl): IInspectable(IInspectableVtbl) [IID_IOrientationSensorReadingYawAccuracy] {
    fn get_YawAccuracy(&self, out: *mut MagnetometerAccuracy) -> HRESULT
}}
impl IOrientationSensorReadingYawAccuracy {
    #[inline] pub unsafe fn get_yaw_accuracy(&self) -> Result<MagnetometerAccuracy> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_YawAccuracy)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IOrientationSensorReadingChangedEventArgs, 19665286, 50106, 18108, 174, 101, 122, 152, 153, 108, 191, 184);
RT_INTERFACE!{interface IOrientationSensorReadingChangedEventArgs(IOrientationSensorReadingChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IOrientationSensorReadingChangedEventArgs] {
    fn get_Reading(&self, out: *mut *mut OrientationSensorReading) -> HRESULT
}}
impl IOrientationSensorReadingChangedEventArgs {
    #[inline] pub unsafe fn get_reading(&self) -> Result<ComPtr<OrientationSensorReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_ENUM! { enum SimpleOrientation: i32 {
    NotRotated (SimpleOrientation_NotRotated) = 0, Rotated90DegreesCounterclockwise (SimpleOrientation_Rotated90DegreesCounterclockwise) = 1, Rotated180DegreesCounterclockwise (SimpleOrientation_Rotated180DegreesCounterclockwise) = 2, Rotated270DegreesCounterclockwise (SimpleOrientation_Rotated270DegreesCounterclockwise) = 3, Faceup (SimpleOrientation_Faceup) = 4, Facedown (SimpleOrientation_Facedown) = 5,
}}
DEFINE_IID!(IID_ISimpleOrientationSensorDeviceId, 4223666891, 15222, 16886, 128, 145, 48, 239, 230, 70, 211, 207);
RT_INTERFACE!{interface ISimpleOrientationSensorDeviceId(ISimpleOrientationSensorDeviceIdVtbl): IInspectable(IInspectableVtbl) [IID_ISimpleOrientationSensorDeviceId] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl ISimpleOrientationSensorDeviceId {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISimpleOrientationSensorStatics, 1928136303, 28842, 16582, 155, 27, 52, 51, 247, 69, 155, 78);
RT_INTERFACE!{static interface ISimpleOrientationSensorStatics(ISimpleOrientationSensorStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ISimpleOrientationSensorStatics] {
    fn GetDefault(&self, out: *mut *mut SimpleOrientationSensor) -> HRESULT
}}
impl ISimpleOrientationSensorStatics {
    #[inline] pub unsafe fn get_default(&self) -> Result<ComPtr<SimpleOrientationSensor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefault)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SimpleOrientationSensor: ISimpleOrientationSensor}
impl RtActivatable<ISimpleOrientationSensorStatics> for SimpleOrientationSensor {}
impl SimpleOrientationSensor {
    #[inline] pub fn get_default() -> Result<ComPtr<SimpleOrientationSensor>> { unsafe {
        <Self as RtActivatable<ISimpleOrientationSensorStatics>>::get_activation_factory().get_default()
    }}
}
DEFINE_CLSID!(SimpleOrientationSensor(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,83,105,109,112,108,101,79,114,105,101,110,116,97,116,105,111,110,83,101,110,115,111,114,0]) [CLSID_SimpleOrientationSensor]);
DEFINE_IID!(IID_ISimpleOrientationSensor, 1609906262, 8522, 19950, 163, 249, 97, 111, 26, 176, 111, 253);
RT_INTERFACE!{interface ISimpleOrientationSensor(ISimpleOrientationSensorVtbl): IInspectable(IInspectableVtbl) [IID_ISimpleOrientationSensor] {
    fn GetCurrentOrientation(&self, out: *mut SimpleOrientation) -> HRESULT,
    fn add_OrientationChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<SimpleOrientationSensor, SimpleOrientationSensorOrientationChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_OrientationChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl ISimpleOrientationSensor {
    #[inline] pub unsafe fn get_current_orientation(&self) -> Result<SimpleOrientation> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).GetCurrentOrientation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_orientation_changed(&self, handler: &super::super::foundation::TypedEventHandler<SimpleOrientationSensor, SimpleOrientationSensorOrientationChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_OrientationChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_orientation_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_OrientationChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class SimpleOrientationSensorOrientationChangedEventArgs: ISimpleOrientationSensorOrientationChangedEventArgs}
DEFINE_IID!(IID_ISimpleOrientationSensor2, 2725750680, 34928, 17726, 139, 214, 184, 245, 216, 215, 148, 27);
RT_INTERFACE!{interface ISimpleOrientationSensor2(ISimpleOrientationSensor2Vtbl): IInspectable(IInspectableVtbl) [IID_ISimpleOrientationSensor2] {
    #[cfg(feature="windows-graphics")] fn put_ReadingTransform(&self, value: super::super::graphics::display::DisplayOrientations) -> HRESULT,
    #[cfg(feature="windows-graphics")] fn get_ReadingTransform(&self, out: *mut super::super::graphics::display::DisplayOrientations) -> HRESULT
}}
impl ISimpleOrientationSensor2 {
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn set_reading_transform(&self, value: super::super::graphics::display::DisplayOrientations) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReadingTransform)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn get_reading_transform(&self) -> Result<super::super::graphics::display::DisplayOrientations> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadingTransform)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ISimpleOrientationSensorOrientationChangedEventArgs, 3168126560, 9172, 19276, 162, 46, 186, 129, 173, 224, 198, 1);
RT_INTERFACE!{interface ISimpleOrientationSensorOrientationChangedEventArgs(ISimpleOrientationSensorOrientationChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_ISimpleOrientationSensorOrientationChangedEventArgs] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_Orientation(&self, out: *mut SimpleOrientation) -> HRESULT
}}
impl ISimpleOrientationSensorOrientationChangedEventArgs {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_orientation(&self) -> Result<SimpleOrientation> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Orientation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMagnetometerDeviceId, 1488230594, 32331, 16460, 159, 197, 93, 232, 180, 14, 186, 227);
RT_INTERFACE!{interface IMagnetometerDeviceId(IMagnetometerDeviceIdVtbl): IInspectable(IInspectableVtbl) [IID_IMagnetometerDeviceId] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT
}}
impl IMagnetometerDeviceId {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMagnetometerStatics, 2235327692, 1688, 19930, 166, 223, 156, 185, 204, 74, 180, 10);
RT_INTERFACE!{static interface IMagnetometerStatics(IMagnetometerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IMagnetometerStatics] {
    fn GetDefault(&self, out: *mut *mut Magnetometer) -> HRESULT
}}
impl IMagnetometerStatics {
    #[inline] pub unsafe fn get_default(&self) -> Result<ComPtr<Magnetometer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefault)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Magnetometer: IMagnetometer}
impl RtActivatable<IMagnetometerStatics> for Magnetometer {}
impl Magnetometer {
    #[inline] pub fn get_default() -> Result<ComPtr<Magnetometer>> { unsafe {
        <Self as RtActivatable<IMagnetometerStatics>>::get_activation_factory().get_default()
    }}
}
DEFINE_CLSID!(Magnetometer(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,77,97,103,110,101,116,111,109,101,116,101,114,0]) [CLSID_Magnetometer]);
DEFINE_IID!(IID_IMagnetometer, 1213162094, 54217, 16657, 179, 246, 44, 241, 250, 164, 24, 213);
RT_INTERFACE!{interface IMagnetometer(IMagnetometerVtbl): IInspectable(IInspectableVtbl) [IID_IMagnetometer] {
    fn GetCurrentReading(&self, out: *mut *mut MagnetometerReading) -> HRESULT,
    fn get_MinimumReportInterval(&self, out: *mut u32) -> HRESULT,
    fn put_ReportInterval(&self, value: u32) -> HRESULT,
    fn get_ReportInterval(&self, out: *mut u32) -> HRESULT,
    fn add_ReadingChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<Magnetometer, MagnetometerReadingChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadingChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IMagnetometer {
    #[inline] pub unsafe fn get_current_reading(&self) -> Result<ComPtr<MagnetometerReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCurrentReading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_minimum_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinimumReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_report_interval(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReportInterval)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_reading_changed(&self, handler: &super::super::foundation::TypedEventHandler<Magnetometer, MagnetometerReadingChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadingChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_reading_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadingChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class MagnetometerReading: IMagnetometerReading}
RT_CLASS!{class MagnetometerReadingChangedEventArgs: IMagnetometerReadingChangedEventArgs}
DEFINE_IID!(IID_IMagnetometer2, 3026545797, 9974, 17483, 169, 226, 162, 63, 150, 108, 211, 104);
RT_INTERFACE!{interface IMagnetometer2(IMagnetometer2Vtbl): IInspectable(IInspectableVtbl) [IID_IMagnetometer2] {
    #[cfg(feature="windows-graphics")] fn put_ReadingTransform(&self, value: super::super::graphics::display::DisplayOrientations) -> HRESULT,
    #[cfg(feature="windows-graphics")] fn get_ReadingTransform(&self, out: *mut super::super::graphics::display::DisplayOrientations) -> HRESULT
}}
impl IMagnetometer2 {
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn set_reading_transform(&self, value: super::super::graphics::display::DisplayOrientations) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReadingTransform)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn get_reading_transform(&self) -> Result<super::super::graphics::display::DisplayOrientations> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadingTransform)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMagnetometerReading, 204260365, 60413, 20060, 187, 17, 175, 194, 155, 60, 174, 97);
RT_INTERFACE!{interface IMagnetometerReading(IMagnetometerReadingVtbl): IInspectable(IInspectableVtbl) [IID_IMagnetometerReading] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_MagneticFieldX(&self, out: *mut f32) -> HRESULT,
    fn get_MagneticFieldY(&self, out: *mut f32) -> HRESULT,
    fn get_MagneticFieldZ(&self, out: *mut f32) -> HRESULT,
    fn get_DirectionalAccuracy(&self, out: *mut MagnetometerAccuracy) -> HRESULT
}}
impl IMagnetometerReading {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_magnetic_field_x(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MagneticFieldX)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_magnetic_field_y(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MagneticFieldY)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_magnetic_field_z(&self) -> Result<f32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MagneticFieldZ)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_directional_accuracy(&self) -> Result<MagnetometerAccuracy> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DirectionalAccuracy)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IMagnetometerReadingChangedEventArgs, 401270898, 11961, 20199, 138, 208, 49, 39, 83, 125, 148, 155);
RT_INTERFACE!{interface IMagnetometerReadingChangedEventArgs(IMagnetometerReadingChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IMagnetometerReadingChangedEventArgs] {
    fn get_Reading(&self, out: *mut *mut MagnetometerReading) -> HRESULT
}}
impl IMagnetometerReadingChangedEventArgs {
    #[inline] pub unsafe fn get_reading(&self) -> Result<ComPtr<MagnetometerReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IActivitySensorStatics, 2803764893, 61067, 17873, 178, 91, 8, 204, 13, 249, 42, 182);
RT_INTERFACE!{static interface IActivitySensorStatics(IActivitySensorStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IActivitySensorStatics] {
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<ActivitySensor>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<ActivitySensor>) -> HRESULT,
    fn GetSystemHistoryAsync(&self, fromTime: super::super::foundation::DateTime, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<ActivitySensorReading>>) -> HRESULT,
    fn GetSystemHistoryWithDurationAsync(&self, fromTime: super::super::foundation::DateTime, duration: super::super::foundation::TimeSpan, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<ActivitySensorReading>>) -> HRESULT
}}
impl IActivitySensorStatics {
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ActivitySensor>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ActivitySensor>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_system_history_async(&self, fromTime: super::super::foundation::DateTime) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<ActivitySensorReading>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetSystemHistoryAsync)(self as *const _ as *mut _, fromTime, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_system_history_with_duration_async(&self, fromTime: super::super::foundation::DateTime, duration: super::super::foundation::TimeSpan) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<ActivitySensorReading>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetSystemHistoryWithDurationAsync)(self as *const _ as *mut _, fromTime, duration, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class ActivitySensor: IActivitySensor}
impl RtActivatable<IActivitySensorStatics> for ActivitySensor {}
impl ActivitySensor {
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<ActivitySensor>>> { unsafe {
        <Self as RtActivatable<IActivitySensorStatics>>::get_activation_factory().get_default_async()
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IActivitySensorStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ActivitySensor>>> { unsafe {
        <Self as RtActivatable<IActivitySensorStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_system_history_async(fromTime: super::super::foundation::DateTime) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<ActivitySensorReading>>>> { unsafe {
        <Self as RtActivatable<IActivitySensorStatics>>::get_activation_factory().get_system_history_async(fromTime)
    }}
    #[inline] pub fn get_system_history_with_duration_async(fromTime: super::super::foundation::DateTime, duration: super::super::foundation::TimeSpan) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<ActivitySensorReading>>>> { unsafe {
        <Self as RtActivatable<IActivitySensorStatics>>::get_activation_factory().get_system_history_with_duration_async(fromTime, duration)
    }}
}
DEFINE_CLSID!(ActivitySensor(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,65,99,116,105,118,105,116,121,83,101,110,115,111,114,0]) [CLSID_ActivitySensor]);
RT_CLASS!{class ActivitySensorReading: IActivitySensorReading}
DEFINE_IID!(IID_IActivitySensor, 3447350028, 64351, 18667, 176, 155, 162, 112, 141, 28, 97, 239);
RT_INTERFACE!{interface IActivitySensor(IActivitySensorVtbl): IInspectable(IInspectableVtbl) [IID_IActivitySensor] {
    fn GetCurrentReadingAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<ActivitySensorReading>) -> HRESULT,
    fn get_SubscribedActivities(&self, out: *mut *mut super::super::foundation::collections::IVector<ActivityType>) -> HRESULT,
    fn get_PowerInMilliwatts(&self, out: *mut f64) -> HRESULT,
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_SupportedActivities(&self, out: *mut *mut super::super::foundation::collections::IVectorView<ActivityType>) -> HRESULT,
    fn get_MinimumReportInterval(&self, out: *mut u32) -> HRESULT,
    fn add_ReadingChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<ActivitySensor, ActivitySensorReadingChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadingChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IActivitySensor {
    #[inline] pub unsafe fn get_current_reading_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ActivitySensorReading>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCurrentReadingAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_subscribed_activities(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<ActivityType>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SubscribedActivities)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_power_in_milliwatts(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PowerInMilliwatts)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_activities(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<ActivityType>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedActivities)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_minimum_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinimumReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_reading_changed(&self, handler: &super::super::foundation::TypedEventHandler<ActivitySensor, ActivitySensorReadingChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadingChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_reading_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadingChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class ActivitySensorReadingChangedEventArgs: IActivitySensorReadingChangedEventArgs}
DEFINE_IID!(IID_IActivitySensorReading, 2232572566, 5234, 16546, 178, 174, 225, 239, 41, 34, 108, 120);
RT_INTERFACE!{interface IActivitySensorReading(IActivitySensorReadingVtbl): IInspectable(IInspectableVtbl) [IID_IActivitySensorReading] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_Activity(&self, out: *mut ActivityType) -> HRESULT,
    fn get_Confidence(&self, out: *mut ActivitySensorReadingConfidence) -> HRESULT
}}
impl IActivitySensorReading {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_activity(&self) -> Result<ActivityType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Activity)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_confidence(&self) -> Result<ActivitySensorReadingConfidence> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Confidence)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IActivitySensorReadingChangedEventArgs, 3728238359, 44726, 20167, 148, 106, 217, 204, 25, 185, 81, 236);
RT_INTERFACE!{interface IActivitySensorReadingChangedEventArgs(IActivitySensorReadingChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IActivitySensorReadingChangedEventArgs] {
    fn get_Reading(&self, out: *mut *mut ActivitySensorReading) -> HRESULT
}}
impl IActivitySensorReadingChangedEventArgs {
    #[inline] pub unsafe fn get_reading(&self) -> Result<ComPtr<ActivitySensorReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IActivitySensorReadingChangeReport, 1329342741, 55611, 18365, 150, 10, 242, 15, 178, 243, 34, 185);
RT_INTERFACE!{interface IActivitySensorReadingChangeReport(IActivitySensorReadingChangeReportVtbl): IInspectable(IInspectableVtbl) [IID_IActivitySensorReadingChangeReport] {
    fn get_Reading(&self, out: *mut *mut ActivitySensorReading) -> HRESULT
}}
impl IActivitySensorReadingChangeReport {
    #[inline] pub unsafe fn get_reading(&self) -> Result<ComPtr<ActivitySensorReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IActivitySensorTriggerDetails, 748578322, 47562, 18039, 178, 99, 36, 50, 151, 247, 157, 58);
RT_INTERFACE!{interface IActivitySensorTriggerDetails(IActivitySensorTriggerDetailsVtbl): IInspectable(IInspectableVtbl) [IID_IActivitySensorTriggerDetails] {
    fn ReadReports(&self, out: *mut *mut super::super::foundation::collections::IVectorView<ActivitySensorReadingChangeReport>) -> HRESULT
}}
impl IActivitySensorTriggerDetails {
    #[inline] pub unsafe fn read_reports(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<ActivitySensorReadingChangeReport>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ReadReports)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class ActivitySensorReadingChangeReport: IActivitySensorReadingChangeReport}
RT_CLASS!{class ActivitySensorTriggerDetails: IActivitySensorTriggerDetails}
DEFINE_IID!(IID_IBarometerStatics, 678110986, 739, 20358, 132, 252, 253, 216, 146, 181, 148, 15);
RT_INTERFACE!{static interface IBarometerStatics(IBarometerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IBarometerStatics] {
    fn GetDefault(&self, out: *mut *mut Barometer) -> HRESULT
}}
impl IBarometerStatics {
    #[inline] pub unsafe fn get_default(&self) -> Result<ComPtr<Barometer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefault)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Barometer: IBarometer}
impl RtActivatable<IBarometerStatics> for Barometer {}
impl Barometer {
    #[inline] pub fn get_default() -> Result<ComPtr<Barometer>> { unsafe {
        <Self as RtActivatable<IBarometerStatics>>::get_activation_factory().get_default()
    }}
}
DEFINE_CLSID!(Barometer(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,66,97,114,111,109,101,116,101,114,0]) [CLSID_Barometer]);
DEFINE_IID!(IID_IBarometer, 2470737320, 30911, 17711, 176, 23, 240, 32, 156, 230, 218, 180);
RT_INTERFACE!{interface IBarometer(IBarometerVtbl): IInspectable(IInspectableVtbl) [IID_IBarometer] {
    fn GetCurrentReading(&self, out: *mut *mut BarometerReading) -> HRESULT,
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_MinimumReportInterval(&self, out: *mut u32) -> HRESULT,
    fn put_ReportInterval(&self, value: u32) -> HRESULT,
    fn get_ReportInterval(&self, out: *mut u32) -> HRESULT,
    fn add_ReadingChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<Barometer, BarometerReadingChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadingChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IBarometer {
    #[inline] pub unsafe fn get_current_reading(&self) -> Result<ComPtr<BarometerReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCurrentReading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_minimum_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinimumReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_report_interval(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReportInterval)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_reading_changed(&self, handler: &super::super::foundation::TypedEventHandler<Barometer, BarometerReadingChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadingChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_reading_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadingChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class BarometerReading: IBarometerReading}
RT_CLASS!{class BarometerReadingChangedEventArgs: IBarometerReadingChangedEventArgs}
DEFINE_IID!(IID_IBarometerReading, 4122596070, 7670, 18970, 167, 173, 50, 29, 79, 93, 178, 71);
RT_INTERFACE!{interface IBarometerReading(IBarometerReadingVtbl): IInspectable(IInspectableVtbl) [IID_IBarometerReading] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_StationPressureInHectopascals(&self, out: *mut f64) -> HRESULT
}}
impl IBarometerReading {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_station_pressure_in_hectopascals(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_StationPressureInHectopascals)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IBarometerReadingChangedEventArgs, 1032098911, 891, 16463, 155, 187, 98, 50, 214, 149, 67, 195);
RT_INTERFACE!{interface IBarometerReadingChangedEventArgs(IBarometerReadingChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IBarometerReadingChangedEventArgs] {
    fn get_Reading(&self, out: *mut *mut BarometerReading) -> HRESULT
}}
impl IBarometerReadingChangedEventArgs {
    #[inline] pub unsafe fn get_reading(&self) -> Result<ComPtr<BarometerReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_ENUM! { enum PedometerStepKind: i32 {
    Unknown (PedometerStepKind_Unknown) = 0, Walking (PedometerStepKind_Walking) = 1, Running (PedometerStepKind_Running) = 2,
}}
DEFINE_IID!(IID_IPedometerReading, 575003892, 43233, 17199, 137, 106, 190, 13, 217, 176, 45, 36);
RT_INTERFACE!{interface IPedometerReading(IPedometerReadingVtbl): IInspectable(IInspectableVtbl) [IID_IPedometerReading] {
    fn get_StepKind(&self, out: *mut PedometerStepKind) -> HRESULT,
    fn get_CumulativeSteps(&self, out: *mut i32) -> HRESULT,
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_CumulativeStepsDuration(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT
}}
impl IPedometerReading {
    #[inline] pub unsafe fn get_step_kind(&self) -> Result<PedometerStepKind> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_StepKind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cumulative_steps(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CumulativeSteps)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_cumulative_steps_duration(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CumulativeStepsDuration)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPedometerReadingChangedEventArgs, 4166378622, 43964, 17494, 134, 168, 37, 207, 43, 51, 55, 66);
RT_INTERFACE!{interface IPedometerReadingChangedEventArgs(IPedometerReadingChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPedometerReadingChangedEventArgs] {
    fn get_Reading(&self, out: *mut *mut PedometerReading) -> HRESULT
}}
impl IPedometerReadingChangedEventArgs {
    #[inline] pub unsafe fn get_reading(&self) -> Result<ComPtr<PedometerReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PedometerReading: IPedometerReading}
DEFINE_IID!(IID_IPedometerStatics, 2191002159, 16515, 19963, 180, 17, 147, 142, 160, 244, 185, 70);
RT_INTERFACE!{static interface IPedometerStatics(IPedometerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IPedometerStatics] {
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<Pedometer>) -> HRESULT,
    fn GetDefaultAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<Pedometer>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn GetSystemHistoryAsync(&self, fromTime: super::super::foundation::DateTime, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PedometerReading>>) -> HRESULT,
    fn GetSystemHistoryWithDurationAsync(&self, fromTime: super::super::foundation::DateTime, duration: super::super::foundation::TimeSpan, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PedometerReading>>) -> HRESULT
}}
impl IPedometerStatics {
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Pedometer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Pedometer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefaultAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_system_history_async(&self, fromTime: super::super::foundation::DateTime) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PedometerReading>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetSystemHistoryAsync)(self as *const _ as *mut _, fromTime, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_system_history_with_duration_async(&self, fromTime: super::super::foundation::DateTime, duration: super::super::foundation::TimeSpan) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PedometerReading>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetSystemHistoryWithDurationAsync)(self as *const _ as *mut _, fromTime, duration, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Pedometer: IPedometer}
impl RtActivatable<IPedometerStatics> for Pedometer {}
impl RtActivatable<IPedometerStatics2> for Pedometer {}
impl Pedometer {
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<Pedometer>>> { unsafe {
        <Self as RtActivatable<IPedometerStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_default_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<Pedometer>>> { unsafe {
        <Self as RtActivatable<IPedometerStatics>>::get_activation_factory().get_default_async()
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IPedometerStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn get_system_history_async(fromTime: super::super::foundation::DateTime) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PedometerReading>>>> { unsafe {
        <Self as RtActivatable<IPedometerStatics>>::get_activation_factory().get_system_history_async(fromTime)
    }}
    #[inline] pub fn get_system_history_with_duration_async(fromTime: super::super::foundation::DateTime, duration: super::super::foundation::TimeSpan) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<PedometerReading>>>> { unsafe {
        <Self as RtActivatable<IPedometerStatics>>::get_activation_factory().get_system_history_with_duration_async(fromTime, duration)
    }}
    #[inline] pub fn get_readings_from_trigger_details(triggerDetails: &SensorDataThresholdTriggerDetails) -> Result<ComPtr<super::super::foundation::collections::IVectorView<PedometerReading>>> { unsafe {
        <Self as RtActivatable<IPedometerStatics2>>::get_activation_factory().get_readings_from_trigger_details(triggerDetails)
    }}
}
DEFINE_CLSID!(Pedometer(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,80,101,100,111,109,101,116,101,114,0]) [CLSID_Pedometer]);
DEFINE_IID!(IID_IPedometerStatics2, 2046150331, 52750, 16691, 180, 126, 134, 39, 234, 114, 246, 119);
RT_INTERFACE!{static interface IPedometerStatics2(IPedometerStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IPedometerStatics2] {
    fn GetReadingsFromTriggerDetails(&self, triggerDetails: *mut SensorDataThresholdTriggerDetails, out: *mut *mut super::super::foundation::collections::IVectorView<PedometerReading>) -> HRESULT
}}
impl IPedometerStatics2 {
    #[inline] pub unsafe fn get_readings_from_trigger_details(&self, triggerDetails: &SensorDataThresholdTriggerDetails) -> Result<ComPtr<super::super::foundation::collections::IVectorView<PedometerReading>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetReadingsFromTriggerDetails)(self as *const _ as *mut _, triggerDetails as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPedometer2, 3852732127, 11137, 19165, 178, 255, 119, 171, 108, 152, 186, 25);
RT_INTERFACE!{interface IPedometer2(IPedometer2Vtbl): IInspectable(IInspectableVtbl) [IID_IPedometer2] {
    fn GetCurrentReadings(&self, out: *mut *mut super::super::foundation::collections::IMapView<PedometerStepKind, PedometerReading>) -> HRESULT
}}
impl IPedometer2 {
    #[inline] pub unsafe fn get_current_readings(&self) -> Result<ComPtr<super::super::foundation::collections::IMapView<PedometerStepKind, PedometerReading>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCurrentReadings)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPedometer, 2585657661, 15768, 17912, 137, 32, 142, 78, 202, 202, 95, 151);
RT_INTERFACE!{interface IPedometer(IPedometerVtbl): IInspectable(IInspectableVtbl) [IID_IPedometer] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_PowerInMilliwatts(&self, out: *mut f64) -> HRESULT,
    fn get_MinimumReportInterval(&self, out: *mut u32) -> HRESULT,
    fn put_ReportInterval(&self, value: u32) -> HRESULT,
    fn get_ReportInterval(&self, out: *mut u32) -> HRESULT,
    fn add_ReadingChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<Pedometer, PedometerReadingChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadingChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IPedometer {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_power_in_milliwatts(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PowerInMilliwatts)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_minimum_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinimumReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_report_interval(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReportInterval)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_reading_changed(&self, handler: &super::super::foundation::TypedEventHandler<Pedometer, PedometerReadingChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadingChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_reading_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadingChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class PedometerReadingChangedEventArgs: IPedometerReadingChangedEventArgs}
DEFINE_IID!(IID_IPedometerDataThresholdFactory, 3417149264, 31316, 18027, 144, 16, 119, 161, 98, 252, 165, 215);
RT_INTERFACE!{static interface IPedometerDataThresholdFactory(IPedometerDataThresholdFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IPedometerDataThresholdFactory] {
    fn Create(&self, sensor: *mut Pedometer, stepGoal: i32, out: *mut *mut PedometerDataThreshold) -> HRESULT
}}
impl IPedometerDataThresholdFactory {
    #[inline] pub unsafe fn create(&self, sensor: &Pedometer, stepGoal: i32) -> Result<ComPtr<PedometerDataThreshold>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, sensor as *const _ as *mut _, stepGoal, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class PedometerDataThreshold: ISensorDataThreshold}
impl RtActivatable<IPedometerDataThresholdFactory> for PedometerDataThreshold {}
impl PedometerDataThreshold {
    #[inline] pub fn create(sensor: &Pedometer, stepGoal: i32) -> Result<ComPtr<PedometerDataThreshold>> { unsafe {
        <Self as RtActivatable<IPedometerDataThresholdFactory>>::get_activation_factory().create(sensor, stepGoal)
    }}
}
DEFINE_CLSID!(PedometerDataThreshold(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,80,101,100,111,109,101,116,101,114,68,97,116,97,84,104,114,101,115,104,111,108,100,0]) [CLSID_PedometerDataThreshold]);
DEFINE_IID!(IID_IProximitySensorStatics, 689464905, 25193, 20055, 165, 173, 130, 190, 128, 129, 51, 146);
RT_INTERFACE!{static interface IProximitySensorStatics(IProximitySensorStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IProximitySensorStatics] {
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn FromId(&self, sensorId: HSTRING, out: *mut *mut ProximitySensor) -> HRESULT
}}
impl IProximitySensorStatics {
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id(&self, sensorId: &HStringArg) -> Result<ComPtr<ProximitySensor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromId)(self as *const _ as *mut _, sensorId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class ProximitySensor: IProximitySensor}
impl RtActivatable<IProximitySensorStatics> for ProximitySensor {}
impl RtActivatable<IProximitySensorStatics2> for ProximitySensor {}
impl ProximitySensor {
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IProximitySensorStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn from_id(sensorId: &HStringArg) -> Result<ComPtr<ProximitySensor>> { unsafe {
        <Self as RtActivatable<IProximitySensorStatics>>::get_activation_factory().from_id(sensorId)
    }}
    #[inline] pub fn get_readings_from_trigger_details(triggerDetails: &SensorDataThresholdTriggerDetails) -> Result<ComPtr<super::super::foundation::collections::IVectorView<ProximitySensorReading>>> { unsafe {
        <Self as RtActivatable<IProximitySensorStatics2>>::get_activation_factory().get_readings_from_trigger_details(triggerDetails)
    }}
}
DEFINE_CLSID!(ProximitySensor(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,80,114,111,120,105,109,105,116,121,83,101,110,115,111,114,0]) [CLSID_ProximitySensor]);
DEFINE_IID!(IID_IProximitySensor, 1421899448, 60667, 18756, 185, 40, 116, 252, 80, 77, 71, 238);
RT_INTERFACE!{interface IProximitySensor(IProximitySensorVtbl): IInspectable(IInspectableVtbl) [IID_IProximitySensor] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_MaxDistanceInMillimeters(&self, out: *mut *mut super::super::foundation::IReference<u32>) -> HRESULT,
    fn get_MinDistanceInMillimeters(&self, out: *mut *mut super::super::foundation::IReference<u32>) -> HRESULT,
    fn GetCurrentReading(&self, out: *mut *mut ProximitySensorReading) -> HRESULT,
    fn add_ReadingChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<ProximitySensor, ProximitySensorReadingChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadingChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn CreateDisplayOnOffController(&self, out: *mut *mut ProximitySensorDisplayOnOffController) -> HRESULT
}}
impl IProximitySensor {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_distance_in_millimeters(&self) -> Result<ComPtr<super::super::foundation::IReference<u32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_MaxDistanceInMillimeters)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_min_distance_in_millimeters(&self) -> Result<ComPtr<super::super::foundation::IReference<u32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_MinDistanceInMillimeters)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_current_reading(&self) -> Result<ComPtr<ProximitySensorReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCurrentReading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_reading_changed(&self, handler: &super::super::foundation::TypedEventHandler<ProximitySensor, ProximitySensorReadingChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadingChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_reading_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadingChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_display_on_off_controller(&self) -> Result<ComPtr<ProximitySensorDisplayOnOffController>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateDisplayOnOffController)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class ProximitySensorReading: IProximitySensorReading}
RT_CLASS!{class ProximitySensorReadingChangedEventArgs: IProximitySensorReadingChangedEventArgs}
RT_CLASS!{class ProximitySensorDisplayOnOffController: super::super::foundation::IClosable}
DEFINE_IID!(IID_IProximitySensorReadingChangedEventArgs, 3485660006, 50152, 16637, 140, 195, 103, 226, 137, 0, 73, 56);
RT_INTERFACE!{interface IProximitySensorReadingChangedEventArgs(IProximitySensorReadingChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IProximitySensorReadingChangedEventArgs] {
    fn get_Reading(&self, out: *mut *mut ProximitySensorReading) -> HRESULT
}}
impl IProximitySensorReadingChangedEventArgs {
    #[inline] pub unsafe fn get_reading(&self) -> Result<ComPtr<ProximitySensorReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IProximitySensorReading, 1898089817, 4909, 19807, 143, 249, 47, 13, 184, 117, 28, 237);
RT_INTERFACE!{interface IProximitySensorReading(IProximitySensorReadingVtbl): IInspectable(IInspectableVtbl) [IID_IProximitySensorReading] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_IsDetected(&self, out: *mut bool) -> HRESULT,
    fn get_DistanceInMillimeters(&self, out: *mut *mut super::super::foundation::IReference<u32>) -> HRESULT
}}
impl IProximitySensorReading {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_detected(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDetected)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_distance_in_millimeters(&self) -> Result<ComPtr<super::super::foundation::IReference<u32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DistanceInMillimeters)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IProximitySensorDataThresholdFactory, 2421866785, 27943, 19155, 157, 181, 100, 103, 242, 165, 173, 157);
RT_INTERFACE!{static interface IProximitySensorDataThresholdFactory(IProximitySensorDataThresholdFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IProximitySensorDataThresholdFactory] {
    fn Create(&self, sensor: *mut ProximitySensor, out: *mut *mut ProximitySensorDataThreshold) -> HRESULT
}}
impl IProximitySensorDataThresholdFactory {
    #[inline] pub unsafe fn create(&self, sensor: &ProximitySensor) -> Result<ComPtr<ProximitySensorDataThreshold>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Create)(self as *const _ as *mut _, sensor as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class ProximitySensorDataThreshold: ISensorDataThreshold}
impl RtActivatable<IProximitySensorDataThresholdFactory> for ProximitySensorDataThreshold {}
impl ProximitySensorDataThreshold {
    #[inline] pub fn create(sensor: &ProximitySensor) -> Result<ComPtr<ProximitySensorDataThreshold>> { unsafe {
        <Self as RtActivatable<IProximitySensorDataThresholdFactory>>::get_activation_factory().create(sensor)
    }}
}
DEFINE_CLSID!(ProximitySensorDataThreshold(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,80,114,111,120,105,109,105,116,121,83,101,110,115,111,114,68,97,116,97,84,104,114,101,115,104,111,108,100,0]) [CLSID_ProximitySensorDataThreshold]);
DEFINE_IID!(IID_IProximitySensorStatics2, 3421795246, 59850, 16943, 173, 103, 76, 61, 37, 223, 53, 12);
RT_INTERFACE!{static interface IProximitySensorStatics2(IProximitySensorStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IProximitySensorStatics2] {
    fn GetReadingsFromTriggerDetails(&self, triggerDetails: *mut SensorDataThresholdTriggerDetails, out: *mut *mut super::super::foundation::collections::IVectorView<ProximitySensorReading>) -> HRESULT
}}
impl IProximitySensorStatics2 {
    #[inline] pub unsafe fn get_readings_from_trigger_details(&self, triggerDetails: &SensorDataThresholdTriggerDetails) -> Result<ComPtr<super::super::foundation::collections::IVectorView<ProximitySensorReading>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetReadingsFromTriggerDetails)(self as *const _ as *mut _, triggerDetails as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAltimeterStatics, 2662651843, 58796, 18382, 142, 239, 211, 113, 129, 104, 192, 31);
RT_INTERFACE!{static interface IAltimeterStatics(IAltimeterStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IAltimeterStatics] {
    fn GetDefault(&self, out: *mut *mut Altimeter) -> HRESULT
}}
impl IAltimeterStatics {
    #[inline] pub unsafe fn get_default(&self) -> Result<ComPtr<Altimeter>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDefault)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class Altimeter: IAltimeter}
impl RtActivatable<IAltimeterStatics> for Altimeter {}
impl Altimeter {
    #[inline] pub fn get_default() -> Result<ComPtr<Altimeter>> { unsafe {
        <Self as RtActivatable<IAltimeterStatics>>::get_activation_factory().get_default()
    }}
}
DEFINE_CLSID!(Altimeter(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,65,108,116,105,109,101,116,101,114,0]) [CLSID_Altimeter]);
DEFINE_IID!(IID_IAltimeter, 1928353789, 36612, 18929, 180, 167, 244, 227, 99, 183, 1, 162);
RT_INTERFACE!{interface IAltimeter(IAltimeterVtbl): IInspectable(IInspectableVtbl) [IID_IAltimeter] {
    fn GetCurrentReading(&self, out: *mut *mut AltimeterReading) -> HRESULT,
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_MinimumReportInterval(&self, out: *mut u32) -> HRESULT,
    fn put_ReportInterval(&self, value: u32) -> HRESULT,
    fn get_ReportInterval(&self, out: *mut u32) -> HRESULT,
    fn add_ReadingChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<Altimeter, AltimeterReadingChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadingChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IAltimeter {
    #[inline] pub unsafe fn get_current_reading(&self) -> Result<ComPtr<AltimeterReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCurrentReading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_minimum_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinimumReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_report_interval(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReportInterval)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_reading_changed(&self, handler: &super::super::foundation::TypedEventHandler<Altimeter, AltimeterReadingChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadingChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_reading_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadingChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class AltimeterReading: IAltimeterReading}
RT_CLASS!{class AltimeterReadingChangedEventArgs: IAltimeterReadingChangedEventArgs}
DEFINE_IID!(IID_IAltimeterReading, 4226346867, 32606, 18632, 170, 26, 241, 243, 190, 252, 17, 68);
RT_INTERFACE!{interface IAltimeterReading(IAltimeterReadingVtbl): IInspectable(IInspectableVtbl) [IID_IAltimeterReading] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_AltitudeChangeInMeters(&self, out: *mut f64) -> HRESULT
}}
impl IAltimeterReading {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_altitude_change_in_meters(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AltitudeChangeInMeters)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IAltimeterReadingChangedEventArgs, 1885982839, 17517, 18423, 153, 140, 235, 194, 59, 69, 228, 162);
RT_INTERFACE!{interface IAltimeterReadingChangedEventArgs(IAltimeterReadingChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IAltimeterReadingChangedEventArgs] {
    fn get_Reading(&self, out: *mut *mut AltimeterReading) -> HRESULT
}}
impl IAltimeterReadingChangedEventArgs {
    #[inline] pub unsafe fn get_reading(&self) -> Result<ComPtr<AltimeterReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
pub mod custom { // Windows.Devices.Sensors.Custom
use ::prelude::*;
DEFINE_IID!(IID_ICustomSensorStatics, 2569032399, 62498, 19581, 131, 107, 231, 220, 116, 167, 18, 75);
RT_INTERFACE!{static interface ICustomSensorStatics(ICustomSensorStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ICustomSensorStatics] {
    fn GetDeviceSelector(&self, interfaceId: Guid, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, sensorId: HSTRING, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<CustomSensor>) -> HRESULT
}}
impl ICustomSensorStatics {
    #[inline] pub unsafe fn get_device_selector(&self, interfaceId: Guid) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, interfaceId, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, sensorId: &HStringArg) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<CustomSensor>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, sensorId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class CustomSensor: ICustomSensor}
impl RtActivatable<ICustomSensorStatics> for CustomSensor {}
impl CustomSensor {
    #[inline] pub fn get_device_selector(interfaceId: Guid) -> Result<HString> { unsafe {
        <Self as RtActivatable<ICustomSensorStatics>>::get_activation_factory().get_device_selector(interfaceId)
    }}
    #[inline] pub fn from_id_async(sensorId: &HStringArg) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<CustomSensor>>> { unsafe {
        <Self as RtActivatable<ICustomSensorStatics>>::get_activation_factory().from_id_async(sensorId)
    }}
}
DEFINE_CLSID!(CustomSensor(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,110,115,111,114,115,46,67,117,115,116,111,109,46,67,117,115,116,111,109,83,101,110,115,111,114,0]) [CLSID_CustomSensor]);
DEFINE_IID!(IID_ICustomSensor, 2704734637, 16436, 19277, 153, 221, 83, 26, 172, 100, 156, 9);
RT_INTERFACE!{interface ICustomSensor(ICustomSensorVtbl): IInspectable(IInspectableVtbl) [IID_ICustomSensor] {
    fn GetCurrentReading(&self, out: *mut *mut CustomSensorReading) -> HRESULT,
    fn get_MinimumReportInterval(&self, out: *mut u32) -> HRESULT,
    fn put_ReportInterval(&self, value: u32) -> HRESULT,
    fn get_ReportInterval(&self, out: *mut u32) -> HRESULT,
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn add_ReadingChanged(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<CustomSensor, CustomSensorReadingChangedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ReadingChanged(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT
}}
impl ICustomSensor {
    #[inline] pub unsafe fn get_current_reading(&self) -> Result<ComPtr<CustomSensorReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetCurrentReading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_minimum_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinimumReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_report_interval(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReportInterval)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_report_interval(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReportInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_reading_changed(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<CustomSensor, CustomSensorReadingChangedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ReadingChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_reading_changed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ReadingChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class CustomSensorReading: ICustomSensorReading}
RT_CLASS!{class CustomSensorReadingChangedEventArgs: ICustomSensorReadingChangedEventArgs}
DEFINE_IID!(IID_ICustomSensorReading, 1677741901, 17514, 17254, 168, 122, 95, 150, 50, 104, 236, 83);
RT_INTERFACE!{interface ICustomSensorReading(ICustomSensorReadingVtbl): IInspectable(IInspectableVtbl) [IID_ICustomSensorReading] {
    fn get_Timestamp(&self, out: *mut ::rt::gen::windows::foundation::DateTime) -> HRESULT,
    fn get_Properties(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IMapView<HString, IInspectable>) -> HRESULT
}}
impl ICustomSensorReading {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<::rt::gen::windows::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_properties(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IMapView<HString, IInspectable>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Properties)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_ICustomSensorReadingChangedEventArgs, 1797267491, 53245, 19649, 143, 240, 226, 24, 35, 215, 111, 204);
RT_INTERFACE!{interface ICustomSensorReadingChangedEventArgs(ICustomSensorReadingChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_ICustomSensorReadingChangedEventArgs] {
    fn get_Reading(&self, out: *mut *mut CustomSensorReading) -> HRESULT
}}
impl ICustomSensorReadingChangedEventArgs {
    #[inline] pub unsafe fn get_reading(&self) -> Result<ComPtr<CustomSensorReading>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Reading)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
} // Windows.Devices.Sensors.Custom
} // Windows.Devices.Sensors
pub mod serialcommunication { // Windows.Devices.SerialCommunication
use ::prelude::*;
RT_ENUM! { enum SerialParity: i32 {
    None (SerialParity_None) = 0, Odd (SerialParity_Odd) = 1, Even (SerialParity_Even) = 2, Mark (SerialParity_Mark) = 3, Space (SerialParity_Space) = 4,
}}
RT_ENUM! { enum SerialHandshake: i32 {
    None (SerialHandshake_None) = 0, RequestToSend (SerialHandshake_RequestToSend) = 1, XOnXOff (SerialHandshake_XOnXOff) = 2, RequestToSendXOnXOff (SerialHandshake_RequestToSendXOnXOff) = 3,
}}
RT_ENUM! { enum SerialStopBitCount: i32 {
    One (SerialStopBitCount_One) = 0, OnePointFive (SerialStopBitCount_OnePointFive) = 1, Two (SerialStopBitCount_Two) = 2,
}}
RT_ENUM! { enum SerialError: i32 {
    Frame (SerialError_Frame) = 0, BufferOverrun (SerialError_BufferOverrun) = 1, ReceiveFull (SerialError_ReceiveFull) = 2, ReceiveParity (SerialError_ReceiveParity) = 3, TransmitFull (SerialError_TransmitFull) = 4,
}}
RT_ENUM! { enum SerialPinChange: i32 {
    BreakSignal (SerialPinChange_BreakSignal) = 0, CarrierDetect (SerialPinChange_CarrierDetect) = 1, ClearToSend (SerialPinChange_ClearToSend) = 2, DataSetReady (SerialPinChange_DataSetReady) = 3, RingIndicator (SerialPinChange_RingIndicator) = 4,
}}
DEFINE_IID!(IID_ISerialDeviceStatics, 93080176, 2102, 18835, 174, 26, 182, 26, 227, 190, 5, 107);
RT_INTERFACE!{static interface ISerialDeviceStatics(ISerialDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_ISerialDeviceStatics] {
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromPortName(&self, portName: HSTRING, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromUsbVidPid(&self, vendorId: u16, productId: u16, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<SerialDevice>) -> HRESULT
}}
impl ISerialDeviceStatics {
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_port_name(&self, portName: &HStringArg) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromPortName)(self as *const _ as *mut _, portName.get(), &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_usb_vid_pid(&self, vendorId: u16, productId: u16) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromUsbVidPid)(self as *const _ as *mut _, vendorId, productId, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SerialDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class SerialDevice: ISerialDevice}
impl RtActivatable<ISerialDeviceStatics> for SerialDevice {}
impl SerialDevice {
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<ISerialDeviceStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn get_device_selector_from_port_name(portName: &HStringArg) -> Result<HString> { unsafe {
        <Self as RtActivatable<ISerialDeviceStatics>>::get_activation_factory().get_device_selector_from_port_name(portName)
    }}
    #[inline] pub fn get_device_selector_from_usb_vid_pid(vendorId: u16, productId: u16) -> Result<HString> { unsafe {
        <Self as RtActivatable<ISerialDeviceStatics>>::get_activation_factory().get_device_selector_from_usb_vid_pid(vendorId, productId)
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<SerialDevice>>> { unsafe {
        <Self as RtActivatable<ISerialDeviceStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
}
DEFINE_CLSID!(SerialDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,101,114,105,97,108,67,111,109,109,117,110,105,99,97,116,105,111,110,46,83,101,114,105,97,108,68,101,118,105,99,101,0]) [CLSID_SerialDevice]);
DEFINE_IID!(IID_ISerialDevice, 3783773382, 8720, 16719, 182, 90, 245, 85, 58, 3, 55, 42);
RT_INTERFACE!{interface ISerialDevice(ISerialDeviceVtbl): IInspectable(IInspectableVtbl) [IID_ISerialDevice] {
    fn get_BaudRate(&self, out: *mut u32) -> HRESULT,
    fn put_BaudRate(&self, value: u32) -> HRESULT,
    fn get_BreakSignalState(&self, out: *mut bool) -> HRESULT,
    fn put_BreakSignalState(&self, value: bool) -> HRESULT,
    fn get_BytesReceived(&self, out: *mut u32) -> HRESULT,
    fn get_CarrierDetectState(&self, out: *mut bool) -> HRESULT,
    fn get_ClearToSendState(&self, out: *mut bool) -> HRESULT,
    fn get_DataBits(&self, out: *mut u16) -> HRESULT,
    fn put_DataBits(&self, value: u16) -> HRESULT,
    fn get_DataSetReadyState(&self, out: *mut bool) -> HRESULT,
    fn get_Handshake(&self, out: *mut SerialHandshake) -> HRESULT,
    fn put_Handshake(&self, value: SerialHandshake) -> HRESULT,
    fn get_IsDataTerminalReadyEnabled(&self, out: *mut bool) -> HRESULT,
    fn put_IsDataTerminalReadyEnabled(&self, value: bool) -> HRESULT,
    fn get_IsRequestToSendEnabled(&self, out: *mut bool) -> HRESULT,
    fn put_IsRequestToSendEnabled(&self, value: bool) -> HRESULT,
    fn get_Parity(&self, out: *mut SerialParity) -> HRESULT,
    fn put_Parity(&self, value: SerialParity) -> HRESULT,
    fn get_PortName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ReadTimeout(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn put_ReadTimeout(&self, value: super::super::foundation::TimeSpan) -> HRESULT,
    fn get_StopBits(&self, out: *mut SerialStopBitCount) -> HRESULT,
    fn put_StopBits(&self, value: SerialStopBitCount) -> HRESULT,
    fn get_UsbVendorId(&self, out: *mut u16) -> HRESULT,
    fn get_UsbProductId(&self, out: *mut u16) -> HRESULT,
    fn get_WriteTimeout(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn put_WriteTimeout(&self, value: super::super::foundation::TimeSpan) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy27(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_InputStream(&self, out: *mut *mut super::super::storage::streams::IInputStream) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy28(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_OutputStream(&self, out: *mut *mut super::super::storage::streams::IOutputStream) -> HRESULT,
    fn add_ErrorReceived(&self, reportHandler: *mut super::super::foundation::TypedEventHandler<SerialDevice, ErrorReceivedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ErrorReceived(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn add_PinChanged(&self, reportHandler: *mut super::super::foundation::TypedEventHandler<SerialDevice, PinChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_PinChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl ISerialDevice {
    #[inline] pub unsafe fn get_baud_rate(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BaudRate)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_baud_rate(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_BaudRate)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_break_signal_state(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BreakSignalState)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_break_signal_state(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_BreakSignalState)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bytes_received(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BytesReceived)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_carrier_detect_state(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CarrierDetectState)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_clear_to_send_state(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ClearToSendState)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_data_bits(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DataBits)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_data_bits(&self, value: u16) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DataBits)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_data_set_ready_state(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DataSetReadyState)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_handshake(&self) -> Result<SerialHandshake> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Handshake)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_handshake(&self, value: SerialHandshake) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Handshake)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_data_terminal_ready_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsDataTerminalReadyEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_data_terminal_ready_enabled(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsDataTerminalReadyEnabled)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_request_to_send_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsRequestToSendEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_request_to_send_enabled(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsRequestToSendEnabled)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_parity(&self) -> Result<SerialParity> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Parity)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_parity(&self, value: SerialParity) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Parity)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_port_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PortName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_read_timeout(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadTimeout)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_read_timeout(&self, value: super::super::foundation::TimeSpan) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReadTimeout)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_stop_bits(&self) -> Result<SerialStopBitCount> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_StopBits)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_stop_bits(&self, value: SerialStopBitCount) -> Result<()> {
        let hr = ((*self.lpVtbl).put_StopBits)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_usb_vendor_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsbVendorId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_usb_product_id(&self) -> Result<u16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_UsbProductId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_write_timeout(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_WriteTimeout)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_write_timeout(&self, value: super::super::foundation::TimeSpan) -> Result<()> {
        let hr = ((*self.lpVtbl).put_WriteTimeout)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_input_stream(&self) -> Result<ComPtr<super::super::storage::streams::IInputStream>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_InputStream)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_output_stream(&self) -> Result<ComPtr<super::super::storage::streams::IOutputStream>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_OutputStream)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_error_received(&self, reportHandler: &super::super::foundation::TypedEventHandler<SerialDevice, ErrorReceivedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ErrorReceived)(self as *const _ as *mut _, reportHandler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_error_received(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ErrorReceived)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_pin_changed(&self, reportHandler: &super::super::foundation::TypedEventHandler<SerialDevice, PinChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_PinChanged)(self as *const _ as *mut _, reportHandler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_pin_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_PinChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class ErrorReceivedEventArgs: IErrorReceivedEventArgs}
RT_CLASS!{class PinChangedEventArgs: IPinChangedEventArgs}
DEFINE_IID!(IID_IErrorReceivedEventArgs, 4240883545, 4739, 19850, 191, 223, 86, 107, 51, 221, 178, 143);
RT_INTERFACE!{interface IErrorReceivedEventArgs(IErrorReceivedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IErrorReceivedEventArgs] {
    fn get_Error(&self, out: *mut SerialError) -> HRESULT
}}
impl IErrorReceivedEventArgs {
    #[inline] pub unsafe fn get_error(&self) -> Result<SerialError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Error)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IPinChangedEventArgs, 2730433968, 64668, 17927, 147, 208, 250, 94, 131, 67, 238, 34);
RT_INTERFACE!{interface IPinChangedEventArgs(IPinChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IPinChangedEventArgs] {
    fn get_PinChange(&self, out: *mut SerialPinChange) -> HRESULT
}}
impl IPinChangedEventArgs {
    #[inline] pub unsafe fn get_pin_change(&self) -> Result<SerialPinChange> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PinChange)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
} // Windows.Devices.SerialCommunication
pub mod usb { // Windows.Devices.Usb
use ::prelude::*;
RT_ENUM! { enum UsbTransferDirection: i32 {
    Out (UsbTransferDirection_Out) = 0, In (UsbTransferDirection_In) = 1,
}}
RT_ENUM! { enum UsbEndpointType: i32 {
    Control (UsbEndpointType_Control) = 0, Isochronous (UsbEndpointType_Isochronous) = 1, Bulk (UsbEndpointType_Bulk) = 2, Interrupt (UsbEndpointType_Interrupt) = 3,
}}
RT_ENUM! { enum UsbControlRecipient: i32 {
    Device (UsbControlRecipient_Device) = 0, SpecifiedInterface (UsbControlRecipient_SpecifiedInterface) = 1, Endpoint (UsbControlRecipient_Endpoint) = 2, Other (UsbControlRecipient_Other) = 3, DefaultInterface (UsbControlRecipient_DefaultInterface) = 4,
}}
RT_ENUM! { enum UsbControlTransferType: i32 {
    Standard (UsbControlTransferType_Standard) = 0, Class (UsbControlTransferType_Class) = 1, Vendor (UsbControlTransferType_Vendor) = 2,
}}
DEFINE_IID!(IID_IUsbControlRequestType, 2392090022, 55101, 18142, 148, 190, 170, 231, 240, 124, 15, 92);
RT_INTERFACE!{interface IUsbControlRequestType(IUsbControlRequestTypeVtbl): IInspectable(IInspectableVtbl) [IID_IUsbControlRequestType] {
    fn get_Direction(&self, out: *mut UsbTransferDirection) -> HRESULT,
    fn put_Direction(&self, value: UsbTransferDirection) -> HRESULT,
    fn get_ControlTransferType(&self, out: *mut UsbControlTransferType) -> HRESULT,
    fn put_ControlTransferType(&self, value: UsbControlTransferType) -> HRESULT,
    fn get_Recipient(&self, out: *mut UsbControlRecipient) -> HRESULT,
    fn put_Recipient(&self, value: UsbControlRecipient) -> HRESULT,
    fn get_AsByte(&self, out: *mut u8) -> HRESULT,
    fn put_AsByte(&self, value: u8) -> HRESULT
}}
impl IUsbControlRequestType {
    #[inline] pub unsafe fn get_direction(&self) -> Result<UsbTransferDirection> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Direction)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_direction(&self, value: UsbTransferDirection) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Direction)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_control_transfer_type(&self) -> Result<UsbControlTransferType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ControlTransferType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_control_transfer_type(&self, value: UsbControlTransferType) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ControlTransferType)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_recipient(&self) -> Result<UsbControlRecipient> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Recipient)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_recipient(&self, value: UsbControlRecipient) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Recipient)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_as_byte(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AsByte)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_as_byte(&self, value: u8) -> Result<()> {
        let hr = ((*self.lpVtbl).put_AsByte)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class UsbControlRequestType: IUsbControlRequestType}
impl RtActivatable<IActivationFactory> for UsbControlRequestType {}
DEFINE_CLSID!(UsbControlRequestType(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,85,115,98,46,85,115,98,67,111,110,116,114,111,108,82,101,113,117,101,115,116,84,121,112,101,0]) [CLSID_UsbControlRequestType]);
DEFINE_IID!(IID_IUsbSetupPacketFactory, 3374677328, 6958, 19009, 162, 167, 51, 143, 12, 239, 60, 20);
RT_INTERFACE!{static interface IUsbSetupPacketFactory(IUsbSetupPacketFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IUsbSetupPacketFactory] {
    #[cfg(feature="windows-storage")] fn CreateWithEightByteBuffer(&self, eightByteBuffer: *mut super::super::storage::streams::IBuffer, out: *mut *mut UsbSetupPacket) -> HRESULT
}}
impl IUsbSetupPacketFactory {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn create_with_eight_byte_buffer(&self, eightByteBuffer: &super::super::storage::streams::IBuffer) -> Result<ComPtr<UsbSetupPacket>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWithEightByteBuffer)(self as *const _ as *mut _, eightByteBuffer as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class UsbSetupPacket: IUsbSetupPacket}
impl RtActivatable<IUsbSetupPacketFactory> for UsbSetupPacket {}
impl RtActivatable<IActivationFactory> for UsbSetupPacket {}
impl UsbSetupPacket {
    #[cfg(feature="windows-storage")] #[inline] pub fn create_with_eight_byte_buffer(eightByteBuffer: &super::super::storage::streams::IBuffer) -> Result<ComPtr<UsbSetupPacket>> { unsafe {
        <Self as RtActivatable<IUsbSetupPacketFactory>>::get_activation_factory().create_with_eight_byte_buffer(eightByteBuffer)
    }}
}
DEFINE_CLSID!(UsbSetupPacket(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,85,115,98,46,85,115,98,83,101,116,117,112,80,97,99,107,101,116,0]) [CLSID_UsbSetupPacket]);
DEFINE_IID!(IID_IUsbSetupPacket, 273391922, 51087, 19537, 182, 84, 228, 157, 2, 242, 203, 3);
RT_INTERFACE!{interface IUsbSetupPacket(IUsbSetupPacketVtbl): IInspectable(IInspectableVtbl) [IID_IUsbSetupPacket] {
    fn get_RequestType(&self, out: *mut *mut UsbControlRequestType) -> HRESULT,
    fn put_RequestType(&self, value: *mut UsbControlRequestType) -> HRESULT,
    fn get_Request(&self, out: *mut u8) -> HRESULT,
    fn put_Request(&self, value: u8) -> HRESULT,
    fn get_Value(&self, out: *mut u32) -> HRESULT,
    fn put_Value(&self, value: u32) -> HRESULT,
    fn get_Index(&self, out: *mut u32) -> HRESULT,
    fn put_Index(&self, value: u32) -> HRESULT,
    fn get_Length(&self, out: *mut u32) -> HRESULT,
    fn put_Length(&self, value: u32) -> HRESULT
}}
impl IUsbSetupPacket {
    #[inline] pub unsafe fn get_request_type(&self) -> Result<ComPtr<UsbControlRequestType>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_RequestType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_request_type(&self, value: &UsbControlRequestType) -> Result<()> {
        let hr = ((*self.lpVtbl).put_RequestType)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_request(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Request)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_request(&self, value: u8) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Request)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_value(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Value)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_value(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Value)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_index(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Index)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_index(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Index)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_length(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Length)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_length(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Length)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IUsbDeviceClass, 85541625, 33886, 18411, 177, 42, 56, 242, 246, 23, 175, 231);
RT_INTERFACE!{interface IUsbDeviceClass(IUsbDeviceClassVtbl): IInspectable(IInspectableVtbl) [IID_IUsbDeviceClass] {
    fn get_ClassCode(&self, out: *mut u8) -> HRESULT,
    fn put_ClassCode(&self, value: u8) -> HRESULT,
    fn get_SubclassCode(&self, out: *mut *mut super::super::foundation::IReference<u8>) -> HRESULT,
    fn put_SubclassCode(&self, value: *mut super::super::foundation::IReference<u8>) -> HRESULT,
    fn get_ProtocolCode(&self, out: *mut *mut super::super::foundation::IReference<u8>) -> HRESULT,
    fn put_ProtocolCode(&self, value: *mut super::super::foundation::IReference<u8>) -> HRESULT
}}
impl IUsbDeviceClass {
    #[inline] pub unsafe fn get_class_code(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ClassCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_class_code(&self, value: u8) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ClassCode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_subclass_code(&self) -> Result<ComPtr<super::super::foundation::IReference<u8>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SubclassCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_subclass_code(&self, value: &super::super::foundation::IReference<u8>) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SubclassCode)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_protocol_code(&self) -> Result<ComPtr<super::super::foundation::IReference<u8>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ProtocolCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_protocol_code(&self, value: &super::super::foundation::IReference<u8>) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ProtocolCode)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class UsbDeviceClass: IUsbDeviceClass}
impl RtActivatable<IActivationFactory> for UsbDeviceClass {}
DEFINE_CLSID!(UsbDeviceClass(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,85,115,98,46,85,115,98,68,101,118,105,99,101,67,108,97,115,115,0]) [CLSID_UsbDeviceClass]);
DEFINE_IID!(IID_IUsbDeviceClassesStatics, 2987066663, 50560, 17817, 161, 101, 152, 27, 79, 208, 50, 48);
RT_INTERFACE!{static interface IUsbDeviceClassesStatics(IUsbDeviceClassesStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IUsbDeviceClassesStatics] {
    fn get_CdcControl(&self, out: *mut *mut UsbDeviceClass) -> HRESULT,
    fn get_Physical(&self, out: *mut *mut UsbDeviceClass) -> HRESULT,
    fn get_PersonalHealthcare(&self, out: *mut *mut UsbDeviceClass) -> HRESULT,
    fn get_ActiveSync(&self, out: *mut *mut UsbDeviceClass) -> HRESULT,
    fn get_PalmSync(&self, out: *mut *mut UsbDeviceClass) -> HRESULT,
    fn get_DeviceFirmwareUpdate(&self, out: *mut *mut UsbDeviceClass) -> HRESULT,
    fn get_Irda(&self, out: *mut *mut UsbDeviceClass) -> HRESULT,
    fn get_Measurement(&self, out: *mut *mut UsbDeviceClass) -> HRESULT,
    fn get_VendorSpecific(&self, out: *mut *mut UsbDeviceClass) -> HRESULT
}}
impl IUsbDeviceClassesStatics {
    #[inline] pub unsafe fn get_cdc_control(&self) -> Result<ComPtr<UsbDeviceClass>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_CdcControl)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_physical(&self) -> Result<ComPtr<UsbDeviceClass>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Physical)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_personal_healthcare(&self) -> Result<ComPtr<UsbDeviceClass>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PersonalHealthcare)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_active_sync(&self) -> Result<ComPtr<UsbDeviceClass>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ActiveSync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_palm_sync(&self) -> Result<ComPtr<UsbDeviceClass>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PalmSync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_firmware_update(&self) -> Result<ComPtr<UsbDeviceClass>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceFirmwareUpdate)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_irda(&self) -> Result<ComPtr<UsbDeviceClass>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Irda)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_measurement(&self) -> Result<ComPtr<UsbDeviceClass>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Measurement)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_vendor_specific(&self) -> Result<ComPtr<UsbDeviceClass>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_VendorSpecific)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IUsbDeviceClasses, 1752143197, 39826, 19248, 151, 129, 194, 44, 85, 172, 53, 203);
RT_INTERFACE!{interface IUsbDeviceClasses(IUsbDeviceClassesVtbl): IInspectable(IInspectableVtbl) [IID_IUsbDeviceClasses] {
    
}}
RT_CLASS!{class UsbDeviceClasses: IUsbDeviceClasses}
impl RtActivatable<IUsbDeviceClassesStatics> for UsbDeviceClasses {}
impl UsbDeviceClasses {
    #[inline] pub fn get_cdc_control() -> Result<ComPtr<UsbDeviceClass>> { unsafe {
        <Self as RtActivatable<IUsbDeviceClassesStatics>>::get_activation_factory().get_cdc_control()
    }}
    #[inline] pub fn get_physical() -> Result<ComPtr<UsbDeviceClass>> { unsafe {
        <Self as RtActivatable<IUsbDeviceClassesStatics>>::get_activation_factory().get_physical()
    }}
    #[inline] pub fn get_personal_healthcare() -> Result<ComPtr<UsbDeviceClass>> { unsafe {
        <Self as RtActivatable<IUsbDeviceClassesStatics>>::get_activation_factory().get_personal_healthcare()
    }}
    #[inline] pub fn get_active_sync() -> Result<ComPtr<UsbDeviceClass>> { unsafe {
        <Self as RtActivatable<IUsbDeviceClassesStatics>>::get_activation_factory().get_active_sync()
    }}
    #[inline] pub fn get_palm_sync() -> Result<ComPtr<UsbDeviceClass>> { unsafe {
        <Self as RtActivatable<IUsbDeviceClassesStatics>>::get_activation_factory().get_palm_sync()
    }}
    #[inline] pub fn get_device_firmware_update() -> Result<ComPtr<UsbDeviceClass>> { unsafe {
        <Self as RtActivatable<IUsbDeviceClassesStatics>>::get_activation_factory().get_device_firmware_update()
    }}
    #[inline] pub fn get_irda() -> Result<ComPtr<UsbDeviceClass>> { unsafe {
        <Self as RtActivatable<IUsbDeviceClassesStatics>>::get_activation_factory().get_irda()
    }}
    #[inline] pub fn get_measurement() -> Result<ComPtr<UsbDeviceClass>> { unsafe {
        <Self as RtActivatable<IUsbDeviceClassesStatics>>::get_activation_factory().get_measurement()
    }}
    #[inline] pub fn get_vendor_specific() -> Result<ComPtr<UsbDeviceClass>> { unsafe {
        <Self as RtActivatable<IUsbDeviceClassesStatics>>::get_activation_factory().get_vendor_specific()
    }}
}
DEFINE_CLSID!(UsbDeviceClasses(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,85,115,98,46,85,115,98,68,101,118,105,99,101,67,108,97,115,115,101,115,0]) [CLSID_UsbDeviceClasses]);
DEFINE_IID!(IID_IUsbDeviceStatics, 107709858, 2487, 17478, 133, 2, 111, 230, 220, 170, 115, 9);
RT_INTERFACE!{static interface IUsbDeviceStatics(IUsbDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IUsbDeviceStatics] {
    fn GetDeviceSelector(&self, vendorId: u32, productId: u32, winUsbInterfaceClass: Guid, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorGuidOnly(&self, winUsbInterfaceClass: Guid, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorVidPidOnly(&self, vendorId: u32, productId: u32, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceClassSelector(&self, usbClass: *mut UsbDeviceClass, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<UsbDevice>) -> HRESULT
}}
impl IUsbDeviceStatics {
    #[inline] pub unsafe fn get_device_selector(&self, vendorId: u32, productId: u32, winUsbInterfaceClass: Guid) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, vendorId, productId, winUsbInterfaceClass, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_guid_only(&self, winUsbInterfaceClass: Guid) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorGuidOnly)(self as *const _ as *mut _, winUsbInterfaceClass, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_vid_pid_only(&self, vendorId: u32, productId: u32) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorVidPidOnly)(self as *const _ as *mut _, vendorId, productId, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_class_selector(&self, usbClass: &UsbDeviceClass) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceClassSelector)(self as *const _ as *mut _, usbClass as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<UsbDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class UsbDevice: IUsbDevice}
impl RtActivatable<IUsbDeviceStatics> for UsbDevice {}
impl UsbDevice {
    #[inline] pub fn get_device_selector(vendorId: u32, productId: u32, winUsbInterfaceClass: Guid) -> Result<HString> { unsafe {
        <Self as RtActivatable<IUsbDeviceStatics>>::get_activation_factory().get_device_selector(vendorId, productId, winUsbInterfaceClass)
    }}
    #[inline] pub fn get_device_selector_guid_only(winUsbInterfaceClass: Guid) -> Result<HString> { unsafe {
        <Self as RtActivatable<IUsbDeviceStatics>>::get_activation_factory().get_device_selector_guid_only(winUsbInterfaceClass)
    }}
    #[inline] pub fn get_device_selector_vid_pid_only(vendorId: u32, productId: u32) -> Result<HString> { unsafe {
        <Self as RtActivatable<IUsbDeviceStatics>>::get_activation_factory().get_device_selector_vid_pid_only(vendorId, productId)
    }}
    #[inline] pub fn get_device_class_selector(usbClass: &UsbDeviceClass) -> Result<HString> { unsafe {
        <Self as RtActivatable<IUsbDeviceStatics>>::get_activation_factory().get_device_class_selector(usbClass)
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<UsbDevice>>> { unsafe {
        <Self as RtActivatable<IUsbDeviceStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
}
DEFINE_CLSID!(UsbDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,85,115,98,46,85,115,98,68,101,118,105,99,101,0]) [CLSID_UsbDevice]);
DEFINE_IID!(IID_IUsbDevice, 1380563346, 50262, 17621, 173, 94, 36, 245, 160, 137, 246, 59);
RT_INTERFACE!{interface IUsbDevice(IUsbDeviceVtbl): IInspectable(IInspectableVtbl) [IID_IUsbDevice] {
    #[cfg(not(feature="windows-storage"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-storage")] fn SendControlOutTransferAsync(&self, setupPacket: *mut UsbSetupPacket, buffer: *mut super::super::storage::streams::IBuffer, out: *mut *mut super::super::foundation::IAsyncOperation<u32>) -> HRESULT,
    fn SendControlOutTransferAsyncNoBuffer(&self, setupPacket: *mut UsbSetupPacket, out: *mut *mut super::super::foundation::IAsyncOperation<u32>) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy2(&self) -> (),
    #[cfg(feature="windows-storage")] fn SendControlInTransferAsync(&self, setupPacket: *mut UsbSetupPacket, buffer: *mut super::super::storage::streams::IBuffer, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::storage::streams::IBuffer>) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy3(&self) -> (),
    #[cfg(feature="windows-storage")] fn SendControlInTransferAsyncNoBuffer(&self, setupPacket: *mut UsbSetupPacket, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::storage::streams::IBuffer>) -> HRESULT,
    fn get_DefaultInterface(&self, out: *mut *mut UsbInterface) -> HRESULT,
    fn get_DeviceDescriptor(&self, out: *mut *mut UsbDeviceDescriptor) -> HRESULT,
    fn get_Configuration(&self, out: *mut *mut UsbConfiguration) -> HRESULT
}}
impl IUsbDevice {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn send_control_out_transfer_async(&self, setupPacket: &UsbSetupPacket, buffer: &super::super::storage::streams::IBuffer) -> Result<ComPtr<super::super::foundation::IAsyncOperation<u32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).SendControlOutTransferAsync)(self as *const _ as *mut _, setupPacket as *const _ as *mut _, buffer as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn send_control_out_transfer_async_no_buffer(&self, setupPacket: &UsbSetupPacket) -> Result<ComPtr<super::super::foundation::IAsyncOperation<u32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).SendControlOutTransferAsyncNoBuffer)(self as *const _ as *mut _, setupPacket as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn send_control_in_transfer_async(&self, setupPacket: &UsbSetupPacket, buffer: &super::super::storage::streams::IBuffer) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::storage::streams::IBuffer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).SendControlInTransferAsync)(self as *const _ as *mut _, setupPacket as *const _ as *mut _, buffer as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn send_control_in_transfer_async_no_buffer(&self, setupPacket: &UsbSetupPacket) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::storage::streams::IBuffer>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).SendControlInTransferAsyncNoBuffer)(self as *const _ as *mut _, setupPacket as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_interface(&self) -> Result<ComPtr<UsbInterface>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DefaultInterface)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_descriptor(&self) -> Result<ComPtr<UsbDeviceDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceDescriptor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_configuration(&self) -> Result<ComPtr<UsbConfiguration>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Configuration)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class UsbInterface: IUsbInterface}
RT_CLASS!{class UsbDeviceDescriptor: IUsbDeviceDescriptor}
RT_CLASS!{class UsbConfiguration: IUsbConfiguration}
DEFINE_IID!(IID_IUsbDeviceDescriptor, 524866038, 47767, 17186, 185, 44, 181, 177, 137, 33, 101, 136);
RT_INTERFACE!{interface IUsbDeviceDescriptor(IUsbDeviceDescriptorVtbl): IInspectable(IInspectableVtbl) [IID_IUsbDeviceDescriptor] {
    fn get_BcdUsb(&self, out: *mut u32) -> HRESULT,
    fn get_MaxPacketSize0(&self, out: *mut u8) -> HRESULT,
    fn get_VendorId(&self, out: *mut u32) -> HRESULT,
    fn get_ProductId(&self, out: *mut u32) -> HRESULT,
    fn get_BcdDeviceRevision(&self, out: *mut u32) -> HRESULT,
    fn get_NumberOfConfigurations(&self, out: *mut u8) -> HRESULT
}}
impl IUsbDeviceDescriptor {
    #[inline] pub unsafe fn get_bcd_usb(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BcdUsb)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_packet_size0(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxPacketSize0)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_vendor_id(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_VendorId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_product_id(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ProductId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bcd_device_revision(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BcdDeviceRevision)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_number_of_configurations(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_NumberOfConfigurations)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IUsbConfigurationDescriptor, 4061621650, 46146, 16506, 130, 7, 125, 100, 108, 3, 133, 243);
RT_INTERFACE!{interface IUsbConfigurationDescriptor(IUsbConfigurationDescriptorVtbl): IInspectable(IInspectableVtbl) [IID_IUsbConfigurationDescriptor] {
    fn get_ConfigurationValue(&self, out: *mut u8) -> HRESULT,
    fn get_MaxPowerMilliamps(&self, out: *mut u32) -> HRESULT,
    fn get_SelfPowered(&self, out: *mut bool) -> HRESULT,
    fn get_RemoteWakeup(&self, out: *mut bool) -> HRESULT
}}
impl IUsbConfigurationDescriptor {
    #[inline] pub unsafe fn get_configuration_value(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ConfigurationValue)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_power_milliamps(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxPowerMilliamps)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_self_powered(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SelfPowered)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_remote_wakeup(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_RemoteWakeup)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IUsbConfigurationDescriptorStatics, 1112337811, 59200, 16545, 146, 189, 218, 18, 14, 160, 73, 20);
RT_INTERFACE!{static interface IUsbConfigurationDescriptorStatics(IUsbConfigurationDescriptorStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IUsbConfigurationDescriptorStatics] {
    fn TryParse(&self, descriptor: *mut UsbDescriptor, parsed: *mut *mut UsbConfigurationDescriptor, out: *mut bool) -> HRESULT,
    fn Parse(&self, descriptor: *mut UsbDescriptor, out: *mut *mut UsbConfigurationDescriptor) -> HRESULT
}}
impl IUsbConfigurationDescriptorStatics {
    #[inline] pub unsafe fn try_parse(&self, descriptor: &UsbDescriptor) -> Result<(ComPtr<UsbConfigurationDescriptor>, bool)> {
        let mut parsed = null_mut(); let mut out = zeroed();
        let hr = ((*self.lpVtbl).TryParse)(self as *const _ as *mut _, descriptor as *const _ as *mut _, &mut parsed, &mut out);
        if hr == S_OK { Ok((ComPtr::wrap(parsed), out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn parse(&self, descriptor: &UsbDescriptor) -> Result<ComPtr<UsbConfigurationDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Parse)(self as *const _ as *mut _, descriptor as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class UsbDescriptor: IUsbDescriptor}
RT_CLASS!{class UsbConfigurationDescriptor: IUsbConfigurationDescriptor}
impl RtActivatable<IUsbConfigurationDescriptorStatics> for UsbConfigurationDescriptor {}
impl UsbConfigurationDescriptor {
    #[inline] pub fn try_parse(descriptor: &UsbDescriptor) -> Result<(ComPtr<UsbConfigurationDescriptor>, bool)> { unsafe {
        <Self as RtActivatable<IUsbConfigurationDescriptorStatics>>::get_activation_factory().try_parse(descriptor)
    }}
    #[inline] pub fn parse(descriptor: &UsbDescriptor) -> Result<ComPtr<UsbConfigurationDescriptor>> { unsafe {
        <Self as RtActivatable<IUsbConfigurationDescriptorStatics>>::get_activation_factory().parse(descriptor)
    }}
}
DEFINE_CLSID!(UsbConfigurationDescriptor(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,85,115,98,46,85,115,98,67,111,110,102,105,103,117,114,97,116,105,111,110,68,101,115,99,114,105,112,116,111,114,0]) [CLSID_UsbConfigurationDescriptor]);
DEFINE_IID!(IID_IUsbInterfaceDescriptor, 429289671, 47086, 20368, 140, 213, 148, 162, 226, 87, 89, 138);
RT_INTERFACE!{interface IUsbInterfaceDescriptor(IUsbInterfaceDescriptorVtbl): IInspectable(IInspectableVtbl) [IID_IUsbInterfaceDescriptor] {
    fn get_ClassCode(&self, out: *mut u8) -> HRESULT,
    fn get_SubclassCode(&self, out: *mut u8) -> HRESULT,
    fn get_ProtocolCode(&self, out: *mut u8) -> HRESULT,
    fn get_AlternateSettingNumber(&self, out: *mut u8) -> HRESULT,
    fn get_InterfaceNumber(&self, out: *mut u8) -> HRESULT
}}
impl IUsbInterfaceDescriptor {
    #[inline] pub unsafe fn get_class_code(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ClassCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_subclass_code(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SubclassCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_protocol_code(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ProtocolCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_alternate_setting_number(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AlternateSettingNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_interface_number(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InterfaceNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IUsbInterfaceDescriptorStatics, 3813318645, 30678, 18614, 176, 190, 22, 198, 66, 35, 22, 254);
RT_INTERFACE!{static interface IUsbInterfaceDescriptorStatics(IUsbInterfaceDescriptorStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IUsbInterfaceDescriptorStatics] {
    fn TryParse(&self, descriptor: *mut UsbDescriptor, parsed: *mut *mut UsbInterfaceDescriptor, out: *mut bool) -> HRESULT,
    fn Parse(&self, descriptor: *mut UsbDescriptor, out: *mut *mut UsbInterfaceDescriptor) -> HRESULT
}}
impl IUsbInterfaceDescriptorStatics {
    #[inline] pub unsafe fn try_parse(&self, descriptor: &UsbDescriptor) -> Result<(ComPtr<UsbInterfaceDescriptor>, bool)> {
        let mut parsed = null_mut(); let mut out = zeroed();
        let hr = ((*self.lpVtbl).TryParse)(self as *const _ as *mut _, descriptor as *const _ as *mut _, &mut parsed, &mut out);
        if hr == S_OK { Ok((ComPtr::wrap(parsed), out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn parse(&self, descriptor: &UsbDescriptor) -> Result<ComPtr<UsbInterfaceDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Parse)(self as *const _ as *mut _, descriptor as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class UsbInterfaceDescriptor: IUsbInterfaceDescriptor}
impl RtActivatable<IUsbInterfaceDescriptorStatics> for UsbInterfaceDescriptor {}
impl UsbInterfaceDescriptor {
    #[inline] pub fn try_parse(descriptor: &UsbDescriptor) -> Result<(ComPtr<UsbInterfaceDescriptor>, bool)> { unsafe {
        <Self as RtActivatable<IUsbInterfaceDescriptorStatics>>::get_activation_factory().try_parse(descriptor)
    }}
    #[inline] pub fn parse(descriptor: &UsbDescriptor) -> Result<ComPtr<UsbInterfaceDescriptor>> { unsafe {
        <Self as RtActivatable<IUsbInterfaceDescriptorStatics>>::get_activation_factory().parse(descriptor)
    }}
}
DEFINE_CLSID!(UsbInterfaceDescriptor(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,85,115,98,46,85,115,98,73,110,116,101,114,102,97,99,101,68,101,115,99,114,105,112,116,111,114,0]) [CLSID_UsbInterfaceDescriptor]);
DEFINE_IID!(IID_IUsbEndpointDescriptor, 1799906009, 36343, 19264, 172, 131, 87, 143, 19, 159, 5, 117);
RT_INTERFACE!{interface IUsbEndpointDescriptor(IUsbEndpointDescriptorVtbl): IInspectable(IInspectableVtbl) [IID_IUsbEndpointDescriptor] {
    fn get_EndpointNumber(&self, out: *mut u8) -> HRESULT,
    fn get_Direction(&self, out: *mut UsbTransferDirection) -> HRESULT,
    fn get_EndpointType(&self, out: *mut UsbEndpointType) -> HRESULT,
    fn get_AsBulkInEndpointDescriptor(&self, out: *mut *mut UsbBulkInEndpointDescriptor) -> HRESULT,
    fn get_AsInterruptInEndpointDescriptor(&self, out: *mut *mut UsbInterruptInEndpointDescriptor) -> HRESULT,
    fn get_AsBulkOutEndpointDescriptor(&self, out: *mut *mut UsbBulkOutEndpointDescriptor) -> HRESULT,
    fn get_AsInterruptOutEndpointDescriptor(&self, out: *mut *mut UsbInterruptOutEndpointDescriptor) -> HRESULT
}}
impl IUsbEndpointDescriptor {
    #[inline] pub unsafe fn get_endpoint_number(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_EndpointNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_direction(&self) -> Result<UsbTransferDirection> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Direction)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_endpoint_type(&self) -> Result<UsbEndpointType> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_EndpointType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_as_bulk_in_endpoint_descriptor(&self) -> Result<ComPtr<UsbBulkInEndpointDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AsBulkInEndpointDescriptor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_as_interrupt_in_endpoint_descriptor(&self) -> Result<ComPtr<UsbInterruptInEndpointDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AsInterruptInEndpointDescriptor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_as_bulk_out_endpoint_descriptor(&self) -> Result<ComPtr<UsbBulkOutEndpointDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AsBulkOutEndpointDescriptor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_as_interrupt_out_endpoint_descriptor(&self) -> Result<ComPtr<UsbInterruptOutEndpointDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AsInterruptOutEndpointDescriptor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class UsbBulkInEndpointDescriptor: IUsbBulkInEndpointDescriptor}
RT_CLASS!{class UsbInterruptInEndpointDescriptor: IUsbInterruptInEndpointDescriptor}
RT_CLASS!{class UsbBulkOutEndpointDescriptor: IUsbBulkOutEndpointDescriptor}
RT_CLASS!{class UsbInterruptOutEndpointDescriptor: IUsbInterruptOutEndpointDescriptor}
DEFINE_IID!(IID_IUsbEndpointDescriptorStatics, 3364925953, 39530, 18782, 168, 44, 41, 91, 158, 112, 129, 6);
RT_INTERFACE!{static interface IUsbEndpointDescriptorStatics(IUsbEndpointDescriptorStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IUsbEndpointDescriptorStatics] {
    fn TryParse(&self, descriptor: *mut UsbDescriptor, parsed: *mut *mut UsbEndpointDescriptor, out: *mut bool) -> HRESULT,
    fn Parse(&self, descriptor: *mut UsbDescriptor, out: *mut *mut UsbEndpointDescriptor) -> HRESULT
}}
impl IUsbEndpointDescriptorStatics {
    #[inline] pub unsafe fn try_parse(&self, descriptor: &UsbDescriptor) -> Result<(ComPtr<UsbEndpointDescriptor>, bool)> {
        let mut parsed = null_mut(); let mut out = zeroed();
        let hr = ((*self.lpVtbl).TryParse)(self as *const _ as *mut _, descriptor as *const _ as *mut _, &mut parsed, &mut out);
        if hr == S_OK { Ok((ComPtr::wrap(parsed), out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn parse(&self, descriptor: &UsbDescriptor) -> Result<ComPtr<UsbEndpointDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).Parse)(self as *const _ as *mut _, descriptor as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class UsbEndpointDescriptor: IUsbEndpointDescriptor}
impl RtActivatable<IUsbEndpointDescriptorStatics> for UsbEndpointDescriptor {}
impl UsbEndpointDescriptor {
    #[inline] pub fn try_parse(descriptor: &UsbDescriptor) -> Result<(ComPtr<UsbEndpointDescriptor>, bool)> { unsafe {
        <Self as RtActivatable<IUsbEndpointDescriptorStatics>>::get_activation_factory().try_parse(descriptor)
    }}
    #[inline] pub fn parse(descriptor: &UsbDescriptor) -> Result<ComPtr<UsbEndpointDescriptor>> { unsafe {
        <Self as RtActivatable<IUsbEndpointDescriptorStatics>>::get_activation_factory().parse(descriptor)
    }}
}
DEFINE_CLSID!(UsbEndpointDescriptor(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,85,115,98,46,85,115,98,69,110,100,112,111,105,110,116,68,101,115,99,114,105,112,116,111,114,0]) [CLSID_UsbEndpointDescriptor]);
DEFINE_IID!(IID_IUsbDescriptor, 176812566, 24477, 18548, 137, 4, 218, 154, 211, 245, 82, 143);
RT_INTERFACE!{interface IUsbDescriptor(IUsbDescriptorVtbl): IInspectable(IInspectableVtbl) [IID_IUsbDescriptor] {
    fn get_Length(&self, out: *mut u8) -> HRESULT,
    fn get_DescriptorType(&self, out: *mut u8) -> HRESULT,
    #[cfg(feature="windows-storage")] fn ReadDescriptorBuffer(&self, buffer: *mut super::super::storage::streams::IBuffer) -> HRESULT
}}
impl IUsbDescriptor {
    #[inline] pub unsafe fn get_length(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Length)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_descriptor_type(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DescriptorType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn read_descriptor_buffer(&self, buffer: &super::super::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).ReadDescriptorBuffer)(self as *const _ as *mut _, buffer as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IUsbInterruptInEventArgs, 3081781394, 5144, 18742, 130, 9, 41, 156, 245, 96, 85, 131);
RT_INTERFACE!{interface IUsbInterruptInEventArgs(IUsbInterruptInEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IUsbInterruptInEventArgs] {
    #[cfg(feature="windows-storage")] fn get_InterruptData(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT
}}
impl IUsbInterruptInEventArgs {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_interrupt_data(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_InterruptData)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class UsbInterruptInEventArgs: IUsbInterruptInEventArgs}
RT_ENUM! { enum UsbReadOptions: u32 {
    None (UsbReadOptions_None) = 0, AutoClearStall (UsbReadOptions_AutoClearStall) = 1, OverrideAutomaticBufferManagement (UsbReadOptions_OverrideAutomaticBufferManagement) = 2, IgnoreShortPacket (UsbReadOptions_IgnoreShortPacket) = 4, AllowPartialReads (UsbReadOptions_AllowPartialReads) = 8,
}}
RT_ENUM! { enum UsbWriteOptions: u32 {
    None (UsbWriteOptions_None) = 0, AutoClearStall (UsbWriteOptions_AutoClearStall) = 1, ShortPacketTerminate (UsbWriteOptions_ShortPacketTerminate) = 2,
}}
DEFINE_IID!(IID_IUsbBulkInPipe, 4028443963, 17736, 19792, 179, 38, 216, 44, 218, 190, 18, 32);
RT_INTERFACE!{interface IUsbBulkInPipe(IUsbBulkInPipeVtbl): IInspectable(IInspectableVtbl) [IID_IUsbBulkInPipe] {
    fn get_MaxTransferSizeBytes(&self, out: *mut u32) -> HRESULT,
    fn get_EndpointDescriptor(&self, out: *mut *mut UsbBulkInEndpointDescriptor) -> HRESULT,
    fn ClearStallAsync(&self, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn put_ReadOptions(&self, value: UsbReadOptions) -> HRESULT,
    fn get_ReadOptions(&self, out: *mut UsbReadOptions) -> HRESULT,
    fn FlushBuffer(&self) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_InputStream(&self, out: *mut *mut super::super::storage::streams::IInputStream) -> HRESULT
}}
impl IUsbBulkInPipe {
    #[inline] pub unsafe fn get_max_transfer_size_bytes(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxTransferSizeBytes)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_endpoint_descriptor(&self) -> Result<ComPtr<UsbBulkInEndpointDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_EndpointDescriptor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn clear_stall_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ClearStallAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_read_options(&self, value: UsbReadOptions) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ReadOptions)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_read_options(&self) -> Result<UsbReadOptions> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ReadOptions)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn flush_buffer(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).FlushBuffer)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_input_stream(&self) -> Result<ComPtr<super::super::storage::streams::IInputStream>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_InputStream)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IUsbInterruptInPipe, 4194332950, 34007, 18631, 138, 63, 76, 11, 35, 95, 46, 166);
RT_INTERFACE!{interface IUsbInterruptInPipe(IUsbInterruptInPipeVtbl): IInspectable(IInspectableVtbl) [IID_IUsbInterruptInPipe] {
    fn get_EndpointDescriptor(&self, out: *mut *mut UsbInterruptInEndpointDescriptor) -> HRESULT,
    fn ClearStallAsync(&self, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn add_DataReceived(&self, handler: *mut super::super::foundation::TypedEventHandler<UsbInterruptInPipe, UsbInterruptInEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_DataReceived(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IUsbInterruptInPipe {
    #[inline] pub unsafe fn get_endpoint_descriptor(&self) -> Result<ComPtr<UsbInterruptInEndpointDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_EndpointDescriptor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn clear_stall_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ClearStallAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_data_received(&self, handler: &super::super::foundation::TypedEventHandler<UsbInterruptInPipe, UsbInterruptInEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_DataReceived)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_data_received(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_DataReceived)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class UsbInterruptInPipe: IUsbInterruptInPipe}
DEFINE_IID!(IID_IUsbBulkOutPipe, 2833903214, 277, 17834, 139, 33, 55, 178, 37, 188, 206, 231);
RT_INTERFACE!{interface IUsbBulkOutPipe(IUsbBulkOutPipeVtbl): IInspectable(IInspectableVtbl) [IID_IUsbBulkOutPipe] {
    fn get_EndpointDescriptor(&self, out: *mut *mut UsbBulkOutEndpointDescriptor) -> HRESULT,
    fn ClearStallAsync(&self, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn put_WriteOptions(&self, value: UsbWriteOptions) -> HRESULT,
    fn get_WriteOptions(&self, out: *mut UsbWriteOptions) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_OutputStream(&self, out: *mut *mut super::super::storage::streams::IOutputStream) -> HRESULT
}}
impl IUsbBulkOutPipe {
    #[inline] pub unsafe fn get_endpoint_descriptor(&self) -> Result<ComPtr<UsbBulkOutEndpointDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_EndpointDescriptor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn clear_stall_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ClearStallAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_write_options(&self, value: UsbWriteOptions) -> Result<()> {
        let hr = ((*self.lpVtbl).put_WriteOptions)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_write_options(&self) -> Result<UsbWriteOptions> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_WriteOptions)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_output_stream(&self) -> Result<ComPtr<super::super::storage::streams::IOutputStream>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_OutputStream)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IUsbInterruptOutPipe, 3917793449, 43769, 18896, 185, 108, 246, 97, 171, 74, 127, 149);
RT_INTERFACE!{interface IUsbInterruptOutPipe(IUsbInterruptOutPipeVtbl): IInspectable(IInspectableVtbl) [IID_IUsbInterruptOutPipe] {
    fn get_EndpointDescriptor(&self, out: *mut *mut UsbInterruptOutEndpointDescriptor) -> HRESULT,
    fn ClearStallAsync(&self, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn put_WriteOptions(&self, value: UsbWriteOptions) -> HRESULT,
    fn get_WriteOptions(&self, out: *mut UsbWriteOptions) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_OutputStream(&self, out: *mut *mut super::super::storage::streams::IOutputStream) -> HRESULT
}}
impl IUsbInterruptOutPipe {
    #[inline] pub unsafe fn get_endpoint_descriptor(&self) -> Result<ComPtr<UsbInterruptOutEndpointDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_EndpointDescriptor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn clear_stall_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ClearStallAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_write_options(&self, value: UsbWriteOptions) -> Result<()> {
        let hr = ((*self.lpVtbl).put_WriteOptions)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_write_options(&self) -> Result<UsbWriteOptions> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_WriteOptions)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_output_stream(&self) -> Result<ComPtr<super::super::storage::streams::IOutputStream>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_OutputStream)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class UsbBulkInPipe: IUsbBulkInPipe}
RT_CLASS!{class UsbBulkOutPipe: IUsbBulkOutPipe}
RT_CLASS!{class UsbInterruptOutPipe: IUsbInterruptOutPipe}
DEFINE_IID!(IID_IUsbConfiguration, 1746367529, 13993, 18135, 184, 115, 252, 104, 146, 81, 236, 48);
RT_INTERFACE!{interface IUsbConfiguration(IUsbConfigurationVtbl): IInspectable(IInspectableVtbl) [IID_IUsbConfiguration] {
    fn get_UsbInterfaces(&self, out: *mut *mut super::super::foundation::collections::IVectorView<UsbInterface>) -> HRESULT,
    fn get_ConfigurationDescriptor(&self, out: *mut *mut UsbConfigurationDescriptor) -> HRESULT,
    fn get_Descriptors(&self, out: *mut *mut super::super::foundation::collections::IVectorView<UsbDescriptor>) -> HRESULT
}}
impl IUsbConfiguration {
    #[inline] pub unsafe fn get_usb_interfaces(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<UsbInterface>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_UsbInterfaces)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_configuration_descriptor(&self) -> Result<ComPtr<UsbConfigurationDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ConfigurationDescriptor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_descriptors(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<UsbDescriptor>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Descriptors)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IUsbInterface, 2687642517, 32583, 18603, 167, 39, 103, 140, 37, 190, 33, 18);
RT_INTERFACE!{interface IUsbInterface(IUsbInterfaceVtbl): IInspectable(IInspectableVtbl) [IID_IUsbInterface] {
    fn get_BulkInPipes(&self, out: *mut *mut super::super::foundation::collections::IVectorView<UsbBulkInPipe>) -> HRESULT,
    fn get_InterruptInPipes(&self, out: *mut *mut super::super::foundation::collections::IVectorView<UsbInterruptInPipe>) -> HRESULT,
    fn get_BulkOutPipes(&self, out: *mut *mut super::super::foundation::collections::IVectorView<UsbBulkOutPipe>) -> HRESULT,
    fn get_InterruptOutPipes(&self, out: *mut *mut super::super::foundation::collections::IVectorView<UsbInterruptOutPipe>) -> HRESULT,
    fn get_InterfaceSettings(&self, out: *mut *mut super::super::foundation::collections::IVectorView<UsbInterfaceSetting>) -> HRESULT,
    fn get_InterfaceNumber(&self, out: *mut u8) -> HRESULT,
    fn get_Descriptors(&self, out: *mut *mut super::super::foundation::collections::IVectorView<UsbDescriptor>) -> HRESULT
}}
impl IUsbInterface {
    #[inline] pub unsafe fn get_bulk_in_pipes(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<UsbBulkInPipe>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BulkInPipes)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_interrupt_in_pipes(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<UsbInterruptInPipe>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_InterruptInPipes)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bulk_out_pipes(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<UsbBulkOutPipe>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BulkOutPipes)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_interrupt_out_pipes(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<UsbInterruptOutPipe>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_InterruptOutPipes)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_interface_settings(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<UsbInterfaceSetting>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_InterfaceSettings)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_interface_number(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_InterfaceNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_descriptors(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<UsbDescriptor>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Descriptors)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class UsbInterfaceSetting: IUsbInterfaceSetting}
DEFINE_IID!(IID_IUsbInterfaceSetting, 405257127, 36263, 19191, 143, 76, 127, 48, 50, 231, 129, 245);
RT_INTERFACE!{interface IUsbInterfaceSetting(IUsbInterfaceSettingVtbl): IInspectable(IInspectableVtbl) [IID_IUsbInterfaceSetting] {
    fn get_BulkInEndpoints(&self, out: *mut *mut super::super::foundation::collections::IVectorView<UsbBulkInEndpointDescriptor>) -> HRESULT,
    fn get_InterruptInEndpoints(&self, out: *mut *mut super::super::foundation::collections::IVectorView<UsbInterruptInEndpointDescriptor>) -> HRESULT,
    fn get_BulkOutEndpoints(&self, out: *mut *mut super::super::foundation::collections::IVectorView<UsbBulkOutEndpointDescriptor>) -> HRESULT,
    fn get_InterruptOutEndpoints(&self, out: *mut *mut super::super::foundation::collections::IVectorView<UsbInterruptOutEndpointDescriptor>) -> HRESULT,
    fn get_Selected(&self, out: *mut bool) -> HRESULT,
    fn SelectSettingAsync(&self, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn get_InterfaceDescriptor(&self, out: *mut *mut UsbInterfaceDescriptor) -> HRESULT,
    fn get_Descriptors(&self, out: *mut *mut super::super::foundation::collections::IVectorView<UsbDescriptor>) -> HRESULT
}}
impl IUsbInterfaceSetting {
    #[inline] pub unsafe fn get_bulk_in_endpoints(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<UsbBulkInEndpointDescriptor>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BulkInEndpoints)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_interrupt_in_endpoints(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<UsbInterruptInEndpointDescriptor>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_InterruptInEndpoints)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bulk_out_endpoints(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<UsbBulkOutEndpointDescriptor>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_BulkOutEndpoints)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_interrupt_out_endpoints(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<UsbInterruptOutEndpointDescriptor>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_InterruptOutEndpoints)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_selected(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Selected)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn select_setting_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).SelectSettingAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_interface_descriptor(&self) -> Result<ComPtr<UsbInterfaceDescriptor>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_InterfaceDescriptor)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_descriptors(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<UsbDescriptor>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Descriptors)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IUsbBulkInEndpointDescriptor, 1013860422, 1743, 17065, 157, 194, 151, 28, 27, 20, 182, 227);
RT_INTERFACE!{interface IUsbBulkInEndpointDescriptor(IUsbBulkInEndpointDescriptorVtbl): IInspectable(IInspectableVtbl) [IID_IUsbBulkInEndpointDescriptor] {
    fn get_MaxPacketSize(&self, out: *mut u32) -> HRESULT,
    fn get_EndpointNumber(&self, out: *mut u8) -> HRESULT,
    fn get_Pipe(&self, out: *mut *mut UsbBulkInPipe) -> HRESULT
}}
impl IUsbBulkInEndpointDescriptor {
    #[inline] pub unsafe fn get_max_packet_size(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxPacketSize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_endpoint_number(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_EndpointNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pipe(&self) -> Result<ComPtr<UsbBulkInPipe>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Pipe)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IUsbInterruptInEndpointDescriptor, 3226634599, 51473, 19514, 134, 178, 65, 156, 45, 168, 144, 57);
RT_INTERFACE!{interface IUsbInterruptInEndpointDescriptor(IUsbInterruptInEndpointDescriptorVtbl): IInspectable(IInspectableVtbl) [IID_IUsbInterruptInEndpointDescriptor] {
    fn get_MaxPacketSize(&self, out: *mut u32) -> HRESULT,
    fn get_EndpointNumber(&self, out: *mut u8) -> HRESULT,
    fn get_Interval(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn get_Pipe(&self, out: *mut *mut UsbInterruptInPipe) -> HRESULT
}}
impl IUsbInterruptInEndpointDescriptor {
    #[inline] pub unsafe fn get_max_packet_size(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxPacketSize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_endpoint_number(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_EndpointNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_interval(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Interval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pipe(&self) -> Result<ComPtr<UsbInterruptInPipe>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Pipe)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IUsbBulkOutEndpointDescriptor, 673219706, 65518, 20320, 155, 225, 149, 108, 172, 62, 203, 101);
RT_INTERFACE!{interface IUsbBulkOutEndpointDescriptor(IUsbBulkOutEndpointDescriptorVtbl): IInspectable(IInspectableVtbl) [IID_IUsbBulkOutEndpointDescriptor] {
    fn get_MaxPacketSize(&self, out: *mut u32) -> HRESULT,
    fn get_EndpointNumber(&self, out: *mut u8) -> HRESULT,
    fn get_Pipe(&self, out: *mut *mut UsbBulkOutPipe) -> HRESULT
}}
impl IUsbBulkOutEndpointDescriptor {
    #[inline] pub unsafe fn get_max_packet_size(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxPacketSize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_endpoint_number(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_EndpointNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pipe(&self) -> Result<ComPtr<UsbBulkOutPipe>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Pipe)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IUsbInterruptOutEndpointDescriptor, 3433033089, 4298, 17715, 149, 45, 158, 39, 131, 65, 232, 15);
RT_INTERFACE!{interface IUsbInterruptOutEndpointDescriptor(IUsbInterruptOutEndpointDescriptorVtbl): IInspectable(IInspectableVtbl) [IID_IUsbInterruptOutEndpointDescriptor] {
    fn get_MaxPacketSize(&self, out: *mut u32) -> HRESULT,
    fn get_EndpointNumber(&self, out: *mut u8) -> HRESULT,
    fn get_Interval(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn get_Pipe(&self, out: *mut *mut UsbInterruptOutPipe) -> HRESULT
}}
impl IUsbInterruptOutEndpointDescriptor {
    #[inline] pub unsafe fn get_max_packet_size(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxPacketSize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_endpoint_number(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_EndpointNumber)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_interval(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Interval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_pipe(&self) -> Result<ComPtr<UsbInterruptOutPipe>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Pipe)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
} // Windows.Devices.Usb
pub mod wifi { // Windows.Devices.WiFi
use ::prelude::*;
RT_ENUM! { enum WiFiNetworkKind: i32 {
    Any (WiFiNetworkKind_Any) = 0, Infrastructure (WiFiNetworkKind_Infrastructure) = 1, Adhoc (WiFiNetworkKind_Adhoc) = 2,
}}
RT_ENUM! { enum WiFiPhyKind: i32 {
    Unknown (WiFiPhyKind_Unknown) = 0, Fhss (WiFiPhyKind_Fhss) = 1, Dsss (WiFiPhyKind_Dsss) = 2, IRBaseband (WiFiPhyKind_IRBaseband) = 3, Ofdm (WiFiPhyKind_Ofdm) = 4, Hrdsss (WiFiPhyKind_Hrdsss) = 5, Erp (WiFiPhyKind_Erp) = 6, HT (WiFiPhyKind_HT) = 7, Vht (WiFiPhyKind_Vht) = 8, Dmg (WiFiPhyKind_Dmg) = 9,
}}
RT_ENUM! { enum WiFiAccessStatus: i32 {
    Unspecified (WiFiAccessStatus_Unspecified) = 0, Allowed (WiFiAccessStatus_Allowed) = 1, DeniedByUser (WiFiAccessStatus_DeniedByUser) = 2, DeniedBySystem (WiFiAccessStatus_DeniedBySystem) = 3,
}}
RT_ENUM! { enum WiFiReconnectionKind: i32 {
    Automatic (WiFiReconnectionKind_Automatic) = 0, Manual (WiFiReconnectionKind_Manual) = 1,
}}
RT_ENUM! { enum WiFiConnectionStatus: i32 {
    UnspecifiedFailure (WiFiConnectionStatus_UnspecifiedFailure) = 0, Success (WiFiConnectionStatus_Success) = 1, AccessRevoked (WiFiConnectionStatus_AccessRevoked) = 2, InvalidCredential (WiFiConnectionStatus_InvalidCredential) = 3, NetworkNotAvailable (WiFiConnectionStatus_NetworkNotAvailable) = 4, Timeout (WiFiConnectionStatus_Timeout) = 5, UnsupportedAuthenticationProtocol (WiFiConnectionStatus_UnsupportedAuthenticationProtocol) = 6,
}}
DEFINE_IID!(IID_IWiFiAdapterStatics, 3659922909, 53836, 17379, 170, 189, 196, 101, 159, 115, 15, 153);
RT_INTERFACE!{static interface IWiFiAdapterStatics(IWiFiAdapterStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiAdapterStatics] {
    fn FindAllAdaptersAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<WiFiAdapter>>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<WiFiAdapter>) -> HRESULT,
    fn RequestAccessAsync(&self, out: *mut *mut super::super::foundation::IAsyncOperation<WiFiAccessStatus>) -> HRESULT
}}
impl IWiFiAdapterStatics {
    #[inline] pub unsafe fn find_all_adapters_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<WiFiAdapter>>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FindAllAdaptersAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<WiFiAdapter>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn request_access_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncOperation<WiFiAccessStatus>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).RequestAccessAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiAdapter: IWiFiAdapter}
impl RtActivatable<IWiFiAdapterStatics> for WiFiAdapter {}
impl WiFiAdapter {
    #[inline] pub fn find_all_adapters_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<super::super::foundation::collections::IVectorView<WiFiAdapter>>>> { unsafe {
        <Self as RtActivatable<IWiFiAdapterStatics>>::get_activation_factory().find_all_adapters_async()
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IWiFiAdapterStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<WiFiAdapter>>> { unsafe {
        <Self as RtActivatable<IWiFiAdapterStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn request_access_async() -> Result<ComPtr<super::super::foundation::IAsyncOperation<WiFiAccessStatus>>> { unsafe {
        <Self as RtActivatable<IWiFiAdapterStatics>>::get_activation_factory().request_access_async()
    }}
}
DEFINE_CLSID!(WiFiAdapter(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,87,105,70,105,46,87,105,70,105,65,100,97,112,116,101,114,0]) [CLSID_WiFiAdapter]);
DEFINE_IID!(IID_IWiFiAdapter, 2797921315, 15733, 17316, 185, 222, 17, 226, 107, 114, 217, 176);
RT_INTERFACE!{interface IWiFiAdapter(IWiFiAdapterVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiAdapter] {
    #[cfg(not(feature="windows-networking"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-networking")] fn get_NetworkAdapter(&self, out: *mut *mut super::super::networking::connectivity::NetworkAdapter) -> HRESULT,
    fn ScanAsync(&self, out: *mut *mut super::super::foundation::IAsyncAction) -> HRESULT,
    fn get_NetworkReport(&self, out: *mut *mut WiFiNetworkReport) -> HRESULT,
    fn add_AvailableNetworksChanged(&self, args: *mut super::super::foundation::TypedEventHandler<WiFiAdapter, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_AvailableNetworksChanged(&self, eventCookie: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn ConnectAsync(&self, availableNetwork: *mut WiFiAvailableNetwork, reconnectionKind: WiFiReconnectionKind, out: *mut *mut super::super::foundation::IAsyncOperation<WiFiConnectionResult>) -> HRESULT,
    #[cfg(not(feature="windows-security"))] fn __Dummy6(&self) -> (),
    #[cfg(feature="windows-security")] fn ConnectWithPasswordCredentialAsync(&self, availableNetwork: *mut WiFiAvailableNetwork, reconnectionKind: WiFiReconnectionKind, passwordCredential: *mut super::super::security::credentials::PasswordCredential, out: *mut *mut super::super::foundation::IAsyncOperation<WiFiConnectionResult>) -> HRESULT,
    #[cfg(not(feature="windows-security"))] fn __Dummy7(&self) -> (),
    #[cfg(feature="windows-security")] fn ConnectWithPasswordCredentialAndSsidAsync(&self, availableNetwork: *mut WiFiAvailableNetwork, reconnectionKind: WiFiReconnectionKind, passwordCredential: *mut super::super::security::credentials::PasswordCredential, ssid: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<WiFiConnectionResult>) -> HRESULT,
    fn Disconnect(&self) -> HRESULT
}}
impl IWiFiAdapter {
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn get_network_adapter(&self) -> Result<ComPtr<super::super::networking::connectivity::NetworkAdapter>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_NetworkAdapter)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn scan_async(&self) -> Result<ComPtr<super::super::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ScanAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_network_report(&self) -> Result<ComPtr<WiFiNetworkReport>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_NetworkReport)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_available_networks_changed(&self, args: &super::super::foundation::TypedEventHandler<WiFiAdapter, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_AvailableNetworksChanged)(self as *const _ as *mut _, args as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_available_networks_changed(&self, eventCookie: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_AvailableNetworksChanged)(self as *const _ as *mut _, eventCookie);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn connect_async(&self, availableNetwork: &WiFiAvailableNetwork, reconnectionKind: WiFiReconnectionKind) -> Result<ComPtr<super::super::foundation::IAsyncOperation<WiFiConnectionResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ConnectAsync)(self as *const _ as *mut _, availableNetwork as *const _ as *mut _, reconnectionKind, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-security")] #[inline] pub unsafe fn connect_with_password_credential_async(&self, availableNetwork: &WiFiAvailableNetwork, reconnectionKind: WiFiReconnectionKind, passwordCredential: &super::super::security::credentials::PasswordCredential) -> Result<ComPtr<super::super::foundation::IAsyncOperation<WiFiConnectionResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ConnectWithPasswordCredentialAsync)(self as *const _ as *mut _, availableNetwork as *const _ as *mut _, reconnectionKind, passwordCredential as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-security")] #[inline] pub unsafe fn connect_with_password_credential_and_ssid_async(&self, availableNetwork: &WiFiAvailableNetwork, reconnectionKind: WiFiReconnectionKind, passwordCredential: &super::super::security::credentials::PasswordCredential, ssid: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<WiFiConnectionResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ConnectWithPasswordCredentialAndSsidAsync)(self as *const _ as *mut _, availableNetwork as *const _ as *mut _, reconnectionKind, passwordCredential as *const _ as *mut _, ssid.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn disconnect(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Disconnect)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiNetworkReport: IWiFiNetworkReport}
RT_CLASS!{class WiFiAvailableNetwork: IWiFiAvailableNetwork}
RT_CLASS!{class WiFiConnectionResult: IWiFiConnectionResult}
DEFINE_IID!(IID_IWiFiNetworkReport, 2502221522, 22801, 17502, 129, 148, 190, 79, 26, 112, 72, 149);
RT_INTERFACE!{interface IWiFiNetworkReport(IWiFiNetworkReportVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiNetworkReport] {
    fn get_Timestamp(&self, out: *mut super::super::foundation::DateTime) -> HRESULT,
    fn get_AvailableNetworks(&self, out: *mut *mut super::super::foundation::collections::IVectorView<WiFiAvailableNetwork>) -> HRESULT
}}
impl IWiFiNetworkReport {
    #[inline] pub unsafe fn get_timestamp(&self) -> Result<super::super::foundation::DateTime> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Timestamp)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_available_networks(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<WiFiAvailableNetwork>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AvailableNetworks)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IWiFiAvailableNetwork, 652829254, 6206, 18180, 152, 38, 113, 180, 162, 240, 246, 104);
RT_INTERFACE!{interface IWiFiAvailableNetwork(IWiFiAvailableNetworkVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiAvailableNetwork] {
    fn get_Uptime(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn get_Ssid(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Bssid(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ChannelCenterFrequencyInKilohertz(&self, out: *mut i32) -> HRESULT,
    fn get_NetworkRssiInDecibelMilliwatts(&self, out: *mut f64) -> HRESULT,
    fn get_SignalBars(&self, out: *mut u8) -> HRESULT,
    fn get_NetworkKind(&self, out: *mut WiFiNetworkKind) -> HRESULT,
    fn get_PhyKind(&self, out: *mut WiFiPhyKind) -> HRESULT,
    #[cfg(not(feature="windows-networking"))] fn __Dummy8(&self) -> (),
    #[cfg(feature="windows-networking")] fn get_SecuritySettings(&self, out: *mut *mut super::super::networking::connectivity::NetworkSecuritySettings) -> HRESULT,
    fn get_BeaconInterval(&self, out: *mut super::super::foundation::TimeSpan) -> HRESULT,
    fn get_IsWiFiDirect(&self, out: *mut bool) -> HRESULT
}}
impl IWiFiAvailableNetwork {
    #[inline] pub unsafe fn get_uptime(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Uptime)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ssid(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Ssid)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_bssid(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Bssid)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_channel_center_frequency_in_kilohertz(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ChannelCenterFrequencyInKilohertz)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_network_rssi_in_decibel_milliwatts(&self) -> Result<f64> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_NetworkRssiInDecibelMilliwatts)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_signal_bars(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SignalBars)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_network_kind(&self) -> Result<WiFiNetworkKind> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_NetworkKind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_phy_kind(&self) -> Result<WiFiPhyKind> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PhyKind)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn get_security_settings(&self) -> Result<ComPtr<super::super::networking::connectivity::NetworkSecuritySettings>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SecuritySettings)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_beacon_interval(&self) -> Result<super::super::foundation::TimeSpan> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BeaconInterval)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_wi_fi_direct(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsWiFiDirect)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IWiFiConnectionResult, 339468249, 50045, 16574, 165, 200, 133, 123, 206, 133, 169, 49);
RT_INTERFACE!{interface IWiFiConnectionResult(IWiFiConnectionResultVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiConnectionResult] {
    fn get_ConnectionStatus(&self, out: *mut WiFiConnectionStatus) -> HRESULT
}}
impl IWiFiConnectionResult {
    #[inline] pub unsafe fn get_connection_status(&self) -> Result<WiFiConnectionStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ConnectionStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
} // Windows.Devices.WiFi
pub mod wifidirect { // Windows.Devices.WiFiDirect
use ::prelude::*;
RT_ENUM! { enum WiFiDirectConnectionStatus: i32 {
    Disconnected (WiFiDirectConnectionStatus_Disconnected) = 0, Connected (WiFiDirectConnectionStatus_Connected) = 1,
}}
RT_ENUM! { enum WiFiDirectError: i32 {
    Success (WiFiDirectError_Success) = 0, RadioNotAvailable (WiFiDirectError_RadioNotAvailable) = 1, ResourceInUse (WiFiDirectError_ResourceInUse) = 2,
}}
RT_ENUM! { enum WiFiDirectDeviceSelectorType: i32 {
    DeviceInterface (WiFiDirectDeviceSelectorType_DeviceInterface) = 0, AssociationEndpoint (WiFiDirectDeviceSelectorType_AssociationEndpoint) = 1,
}}
RT_ENUM! { enum WiFiDirectAdvertisementListenStateDiscoverability: i32 {
    None (WiFiDirectAdvertisementListenStateDiscoverability_None) = 0, Normal (WiFiDirectAdvertisementListenStateDiscoverability_Normal) = 1, Intensive (WiFiDirectAdvertisementListenStateDiscoverability_Intensive) = 2,
}}
RT_ENUM! { enum WiFiDirectAdvertisementPublisherStatus: i32 {
    Created (WiFiDirectAdvertisementPublisherStatus_Created) = 0, Started (WiFiDirectAdvertisementPublisherStatus_Started) = 1, Stopped (WiFiDirectAdvertisementPublisherStatus_Stopped) = 2, Aborted (WiFiDirectAdvertisementPublisherStatus_Aborted) = 3,
}}
RT_ENUM! { enum WiFiDirectConfigurationMethod: i32 {
    ProvidePin (WiFiDirectConfigurationMethod_ProvidePin) = 0, DisplayPin (WiFiDirectConfigurationMethod_DisplayPin) = 1, PushButton (WiFiDirectConfigurationMethod_PushButton) = 2,
}}
RT_ENUM! { enum WiFiDirectPairingProcedure: i32 {
    GroupOwnerNegotiation (WiFiDirectPairingProcedure_GroupOwnerNegotiation) = 0, Invitation (WiFiDirectPairingProcedure_Invitation) = 1,
}}
DEFINE_IID!(IID_IWiFiDirectDeviceStatics, 3899438460, 15020, 18513, 167, 146, 72, 42, 175, 147, 27, 4);
RT_INTERFACE!{static interface IWiFiDirectDeviceStatics(IWiFiDirectDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectDeviceStatics] {
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<WiFiDirectDevice>) -> HRESULT
}}
impl IWiFiDirectDeviceStatics {
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<WiFiDirectDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectDevice: IWiFiDirectDevice}
impl RtActivatable<IWiFiDirectDeviceStatics2> for WiFiDirectDevice {}
impl RtActivatable<IWiFiDirectDeviceStatics> for WiFiDirectDevice {}
impl WiFiDirectDevice {
    #[inline] pub fn get_device_selector2(type_: WiFiDirectDeviceSelectorType) -> Result<HString> { unsafe {
        <Self as RtActivatable<IWiFiDirectDeviceStatics2>>::get_activation_factory().get_device_selector(type_)
    }}
    #[inline] pub fn from_id_async2(deviceId: &HStringArg, connectionParameters: &WiFiDirectConnectionParameters) -> Result<ComPtr<super::super::foundation::IAsyncOperation<WiFiDirectDevice>>> { unsafe {
        <Self as RtActivatable<IWiFiDirectDeviceStatics2>>::get_activation_factory().from_id_async(deviceId, connectionParameters)
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IWiFiDirectDeviceStatics>>::get_activation_factory().get_device_selector()
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<WiFiDirectDevice>>> { unsafe {
        <Self as RtActivatable<IWiFiDirectDeviceStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
}
DEFINE_CLSID!(WiFiDirectDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,87,105,70,105,68,105,114,101,99,116,46,87,105,70,105,68,105,114,101,99,116,68,101,118,105,99,101,0]) [CLSID_WiFiDirectDevice]);
DEFINE_IID!(IID_IWiFiDirectDeviceStatics2, 445988425, 45315, 17278, 146, 38, 171, 103, 151, 19, 66, 249);
RT_INTERFACE!{static interface IWiFiDirectDeviceStatics2(IWiFiDirectDeviceStatics2Vtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectDeviceStatics2] {
    fn GetDeviceSelector(&self, type_: WiFiDirectDeviceSelectorType, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, connectionParameters: *mut WiFiDirectConnectionParameters, out: *mut *mut super::super::foundation::IAsyncOperation<WiFiDirectDevice>) -> HRESULT
}}
impl IWiFiDirectDeviceStatics2 {
    #[inline] pub unsafe fn get_device_selector(&self, type_: WiFiDirectDeviceSelectorType) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, type_, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg, connectionParameters: &WiFiDirectConnectionParameters) -> Result<ComPtr<super::super::foundation::IAsyncOperation<WiFiDirectDevice>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), connectionParameters as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectConnectionParameters: IWiFiDirectConnectionParameters}
impl RtActivatable<IWiFiDirectConnectionParametersStatics> for WiFiDirectConnectionParameters {}
impl RtActivatable<IActivationFactory> for WiFiDirectConnectionParameters {}
impl WiFiDirectConnectionParameters {
    #[inline] pub fn get_device_pairing_kinds(configurationMethod: WiFiDirectConfigurationMethod) -> Result<super::enumeration::DevicePairingKinds> { unsafe {
        <Self as RtActivatable<IWiFiDirectConnectionParametersStatics>>::get_activation_factory().get_device_pairing_kinds(configurationMethod)
    }}
}
DEFINE_CLSID!(WiFiDirectConnectionParameters(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,87,105,70,105,68,105,114,101,99,116,46,87,105,70,105,68,105,114,101,99,116,67,111,110,110,101,99,116,105,111,110,80,97,114,97,109,101,116,101,114,115,0]) [CLSID_WiFiDirectConnectionParameters]);
DEFINE_IID!(IID_IWiFiDirectDevice, 1927195304, 29419, 19886, 138, 40, 133, 19, 53, 93, 39, 119);
RT_INTERFACE!{interface IWiFiDirectDevice(IWiFiDirectDeviceVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectDevice] {
    fn get_ConnectionStatus(&self, out: *mut WiFiDirectConnectionStatus) -> HRESULT,
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn add_ConnectionStatusChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<WiFiDirectDevice, IInspectable>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ConnectionStatusChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    #[cfg(feature="windows-networking")] fn GetConnectionEndpointPairs(&self, out: *mut *mut super::super::foundation::collections::IVectorView<super::super::networking::EndpointPair>) -> HRESULT
}}
impl IWiFiDirectDevice {
    #[inline] pub unsafe fn get_connection_status(&self) -> Result<WiFiDirectConnectionStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ConnectionStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_connection_status_changed(&self, handler: &super::super::foundation::TypedEventHandler<WiFiDirectDevice, IInspectable>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ConnectionStatusChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_connection_status_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ConnectionStatusChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn get_connection_endpoint_pairs(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<super::super::networking::EndpointPair>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetConnectionEndpointPairs)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IWiFiDirectInformationElementStatics, 3687853846, 4517, 20064, 140, 170, 52, 119, 33, 72, 55, 138);
RT_INTERFACE!{static interface IWiFiDirectInformationElementStatics(IWiFiDirectInformationElementStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectInformationElementStatics] {
    #[cfg(not(feature="windows-storage"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-storage")] fn CreateFromBuffer(&self, buffer: *mut super::super::storage::streams::IBuffer, out: *mut *mut super::super::foundation::collections::IVector<WiFiDirectInformationElement>) -> HRESULT,
    fn CreateFromDeviceInformation(&self, deviceInformation: *mut super::enumeration::DeviceInformation, out: *mut *mut super::super::foundation::collections::IVector<WiFiDirectInformationElement>) -> HRESULT
}}
impl IWiFiDirectInformationElementStatics {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn create_from_buffer(&self, buffer: &super::super::storage::streams::IBuffer) -> Result<ComPtr<super::super::foundation::collections::IVector<WiFiDirectInformationElement>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateFromBuffer)(self as *const _ as *mut _, buffer as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn create_from_device_information(&self, deviceInformation: &super::enumeration::DeviceInformation) -> Result<ComPtr<super::super::foundation::collections::IVector<WiFiDirectInformationElement>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateFromDeviceInformation)(self as *const _ as *mut _, deviceInformation as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectInformationElement: IWiFiDirectInformationElement}
impl RtActivatable<IWiFiDirectInformationElementStatics> for WiFiDirectInformationElement {}
impl RtActivatable<IActivationFactory> for WiFiDirectInformationElement {}
impl WiFiDirectInformationElement {
    #[cfg(feature="windows-storage")] #[inline] pub fn create_from_buffer(buffer: &super::super::storage::streams::IBuffer) -> Result<ComPtr<super::super::foundation::collections::IVector<WiFiDirectInformationElement>>> { unsafe {
        <Self as RtActivatable<IWiFiDirectInformationElementStatics>>::get_activation_factory().create_from_buffer(buffer)
    }}
    #[inline] pub fn create_from_device_information(deviceInformation: &super::enumeration::DeviceInformation) -> Result<ComPtr<super::super::foundation::collections::IVector<WiFiDirectInformationElement>>> { unsafe {
        <Self as RtActivatable<IWiFiDirectInformationElementStatics>>::get_activation_factory().create_from_device_information(deviceInformation)
    }}
}
DEFINE_CLSID!(WiFiDirectInformationElement(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,87,105,70,105,68,105,114,101,99,116,46,87,105,70,105,68,105,114,101,99,116,73,110,102,111,114,109,97,116,105,111,110,69,108,101,109,101,110,116,0]) [CLSID_WiFiDirectInformationElement]);
DEFINE_IID!(IID_IWiFiDirectInformationElement, 2952491734, 30395, 18814, 172, 139, 220, 114, 131, 139, 195, 9);
RT_INTERFACE!{interface IWiFiDirectInformationElement(IWiFiDirectInformationElementVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectInformationElement] {
    #[cfg(feature="windows-storage")] fn get_Oui(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT,
    #[cfg(feature="windows-storage")] fn put_Oui(&self, value: *mut super::super::storage::streams::IBuffer) -> HRESULT,
    fn get_OuiType(&self, out: *mut u8) -> HRESULT,
    fn put_OuiType(&self, value: u8) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_Value(&self, out: *mut *mut super::super::storage::streams::IBuffer) -> HRESULT,
    #[cfg(feature="windows-storage")] fn put_Value(&self, value: *mut super::super::storage::streams::IBuffer) -> HRESULT
}}
impl IWiFiDirectInformationElement {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_oui(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Oui)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_oui(&self, value: &super::super::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Oui)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_oui_type(&self) -> Result<u8> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_OuiType)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_oui_type(&self, value: u8) -> Result<()> {
        let hr = ((*self.lpVtbl).put_OuiType)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_value(&self) -> Result<ComPtr<super::super::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Value)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_value(&self, value: &super::super::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Value)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IWiFiDirectLegacySettings, 2790251450, 62205, 17767, 169, 27, 245, 194, 245, 50, 16, 87);
RT_INTERFACE!{interface IWiFiDirectLegacySettings(IWiFiDirectLegacySettingsVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectLegacySettings] {
    fn get_IsEnabled(&self, out: *mut bool) -> HRESULT,
    fn put_IsEnabled(&self, value: bool) -> HRESULT,
    fn get_Ssid(&self, out: *mut HSTRING) -> HRESULT,
    fn put_Ssid(&self, value: HSTRING) -> HRESULT,
    #[cfg(feature="windows-security")] fn get_Passphrase(&self, out: *mut *mut super::super::security::credentials::PasswordCredential) -> HRESULT,
    #[cfg(feature="windows-security")] fn put_Passphrase(&self, value: *mut super::super::security::credentials::PasswordCredential) -> HRESULT
}}
impl IWiFiDirectLegacySettings {
    #[inline] pub unsafe fn get_is_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_enabled(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsEnabled)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_ssid(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Ssid)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_ssid(&self, value: &HStringArg) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Ssid)(self as *const _ as *mut _, value.get());
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-security")] #[inline] pub unsafe fn get_passphrase(&self) -> Result<ComPtr<super::super::security::credentials::PasswordCredential>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Passphrase)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-security")] #[inline] pub unsafe fn set_passphrase(&self, value: &super::super::security::credentials::PasswordCredential) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Passphrase)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectLegacySettings: IWiFiDirectLegacySettings}
DEFINE_IID!(IID_IWiFiDirectAdvertisement, 2874219053, 10758, 18849, 165, 132, 97, 67, 92, 121, 5, 166);
RT_INTERFACE!{interface IWiFiDirectAdvertisement(IWiFiDirectAdvertisementVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectAdvertisement] {
    fn get_InformationElements(&self, out: *mut *mut super::super::foundation::collections::IVector<WiFiDirectInformationElement>) -> HRESULT,
    fn put_InformationElements(&self, value: *mut super::super::foundation::collections::IVector<WiFiDirectInformationElement>) -> HRESULT,
    fn get_ListenStateDiscoverability(&self, out: *mut WiFiDirectAdvertisementListenStateDiscoverability) -> HRESULT,
    fn put_ListenStateDiscoverability(&self, value: WiFiDirectAdvertisementListenStateDiscoverability) -> HRESULT,
    fn get_IsAutonomousGroupOwnerEnabled(&self, out: *mut bool) -> HRESULT,
    fn put_IsAutonomousGroupOwnerEnabled(&self, value: bool) -> HRESULT,
    fn get_LegacySettings(&self, out: *mut *mut WiFiDirectLegacySettings) -> HRESULT
}}
impl IWiFiDirectAdvertisement {
    #[inline] pub unsafe fn get_information_elements(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<WiFiDirectInformationElement>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_InformationElements)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_information_elements(&self, value: &super::super::foundation::collections::IVector<WiFiDirectInformationElement>) -> Result<()> {
        let hr = ((*self.lpVtbl).put_InformationElements)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_listen_state_discoverability(&self) -> Result<WiFiDirectAdvertisementListenStateDiscoverability> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ListenStateDiscoverability)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_listen_state_discoverability(&self, value: WiFiDirectAdvertisementListenStateDiscoverability) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ListenStateDiscoverability)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_autonomous_group_owner_enabled(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsAutonomousGroupOwnerEnabled)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_is_autonomous_group_owner_enabled(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_IsAutonomousGroupOwnerEnabled)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_legacy_settings(&self) -> Result<ComPtr<WiFiDirectLegacySettings>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_LegacySettings)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IWiFiDirectAdvertisement2, 3076106822, 55318, 18715, 145, 122, 180, 13, 125, 196, 3, 162);
RT_INTERFACE!{interface IWiFiDirectAdvertisement2(IWiFiDirectAdvertisement2Vtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectAdvertisement2] {
    fn get_SupportedConfigurationMethods(&self, out: *mut *mut super::super::foundation::collections::IVector<WiFiDirectConfigurationMethod>) -> HRESULT
}}
impl IWiFiDirectAdvertisement2 {
    #[inline] pub unsafe fn get_supported_configuration_methods(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<WiFiDirectConfigurationMethod>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedConfigurationMethods)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectAdvertisement: IWiFiDirectAdvertisement}
DEFINE_IID!(IID_IWiFiDirectAdvertisementPublisherStatusChangedEventArgs, 2868766012, 21633, 18150, 144, 221, 50, 17, 101, 24, 241, 146);
RT_INTERFACE!{interface IWiFiDirectAdvertisementPublisherStatusChangedEventArgs(IWiFiDirectAdvertisementPublisherStatusChangedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectAdvertisementPublisherStatusChangedEventArgs] {
    fn get_Status(&self, out: *mut WiFiDirectAdvertisementPublisherStatus) -> HRESULT,
    fn get_Error(&self, out: *mut WiFiDirectError) -> HRESULT
}}
impl IWiFiDirectAdvertisementPublisherStatusChangedEventArgs {
    #[inline] pub unsafe fn get_status(&self) -> Result<WiFiDirectAdvertisementPublisherStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_error(&self) -> Result<WiFiDirectError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Error)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectAdvertisementPublisherStatusChangedEventArgs: IWiFiDirectAdvertisementPublisherStatusChangedEventArgs}
DEFINE_IID!(IID_IWiFiDirectAdvertisementPublisher, 3009031450, 39711, 17881, 146, 90, 105, 77, 102, 223, 104, 239);
RT_INTERFACE!{interface IWiFiDirectAdvertisementPublisher(IWiFiDirectAdvertisementPublisherVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectAdvertisementPublisher] {
    fn get_Advertisement(&self, out: *mut *mut WiFiDirectAdvertisement) -> HRESULT,
    fn get_Status(&self, out: *mut WiFiDirectAdvertisementPublisherStatus) -> HRESULT,
    fn add_StatusChanged(&self, handler: *mut super::super::foundation::TypedEventHandler<WiFiDirectAdvertisementPublisher, WiFiDirectAdvertisementPublisherStatusChangedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_StatusChanged(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn Start(&self) -> HRESULT,
    fn Stop(&self) -> HRESULT
}}
impl IWiFiDirectAdvertisementPublisher {
    #[inline] pub unsafe fn get_advertisement(&self) -> Result<ComPtr<WiFiDirectAdvertisement>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Advertisement)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<WiFiDirectAdvertisementPublisherStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_status_changed(&self, handler: &super::super::foundation::TypedEventHandler<WiFiDirectAdvertisementPublisher, WiFiDirectAdvertisementPublisherStatusChangedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_StatusChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_status_changed(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_StatusChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Stop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectAdvertisementPublisher: IWiFiDirectAdvertisementPublisher}
impl RtActivatable<IActivationFactory> for WiFiDirectAdvertisementPublisher {}
DEFINE_CLSID!(WiFiDirectAdvertisementPublisher(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,87,105,70,105,68,105,114,101,99,116,46,87,105,70,105,68,105,114,101,99,116,65,100,118,101,114,116,105,115,101,109,101,110,116,80,117,98,108,105,115,104,101,114,0]) [CLSID_WiFiDirectAdvertisementPublisher]);
DEFINE_IID!(IID_IWiFiDirectConnectionParametersStatics, 1502278803, 30274, 17775, 185, 216, 232, 169, 235, 31, 64, 26);
RT_INTERFACE!{static interface IWiFiDirectConnectionParametersStatics(IWiFiDirectConnectionParametersStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectConnectionParametersStatics] {
    fn GetDevicePairingKinds(&self, configurationMethod: WiFiDirectConfigurationMethod, out: *mut super::enumeration::DevicePairingKinds) -> HRESULT
}}
impl IWiFiDirectConnectionParametersStatics {
    #[inline] pub unsafe fn get_device_pairing_kinds(&self, configurationMethod: WiFiDirectConfigurationMethod) -> Result<super::enumeration::DevicePairingKinds> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).GetDevicePairingKinds)(self as *const _ as *mut _, configurationMethod, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IWiFiDirectConnectionParameters, 3001373701, 22274, 19222, 160, 44, 187, 205, 33, 239, 96, 152);
RT_INTERFACE!{interface IWiFiDirectConnectionParameters(IWiFiDirectConnectionParametersVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectConnectionParameters] {
    fn get_GroupOwnerIntent(&self, out: *mut i16) -> HRESULT,
    fn put_GroupOwnerIntent(&self, value: i16) -> HRESULT
}}
impl IWiFiDirectConnectionParameters {
    #[inline] pub unsafe fn get_group_owner_intent(&self) -> Result<i16> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_GroupOwnerIntent)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_group_owner_intent(&self, value: i16) -> Result<()> {
        let hr = ((*self.lpVtbl).put_GroupOwnerIntent)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IWiFiDirectConnectionParameters2, 2872774590, 43650, 17588, 136, 200, 227, 5, 107, 137, 128, 29);
RT_INTERFACE!{interface IWiFiDirectConnectionParameters2(IWiFiDirectConnectionParameters2Vtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectConnectionParameters2] {
    fn get_PreferenceOrderedConfigurationMethods(&self, out: *mut *mut super::super::foundation::collections::IVector<WiFiDirectConfigurationMethod>) -> HRESULT,
    fn get_PreferredPairingProcedure(&self, out: *mut WiFiDirectPairingProcedure) -> HRESULT,
    fn put_PreferredPairingProcedure(&self, value: WiFiDirectPairingProcedure) -> HRESULT
}}
impl IWiFiDirectConnectionParameters2 {
    #[inline] pub unsafe fn get_preference_ordered_configuration_methods(&self) -> Result<ComPtr<super::super::foundation::collections::IVector<WiFiDirectConfigurationMethod>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PreferenceOrderedConfigurationMethods)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_preferred_pairing_procedure(&self) -> Result<WiFiDirectPairingProcedure> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PreferredPairingProcedure)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_preferred_pairing_procedure(&self, value: WiFiDirectPairingProcedure) -> Result<()> {
        let hr = ((*self.lpVtbl).put_PreferredPairingProcedure)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IWiFiDirectConnectionRequest, 2394527237, 37199, 18883, 166, 20, 209, 141, 197, 177, 155, 67);
RT_INTERFACE!{interface IWiFiDirectConnectionRequest(IWiFiDirectConnectionRequestVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectConnectionRequest] {
    fn get_DeviceInformation(&self, out: *mut *mut super::enumeration::DeviceInformation) -> HRESULT
}}
impl IWiFiDirectConnectionRequest {
    #[inline] pub unsafe fn get_device_information(&self) -> Result<ComPtr<super::enumeration::DeviceInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectConnectionRequest: IWiFiDirectConnectionRequest}
DEFINE_IID!(IID_IWiFiDirectConnectionRequestedEventArgs, 4187824318, 54157, 18511, 130, 21, 231, 182, 90, 191, 36, 76);
RT_INTERFACE!{interface IWiFiDirectConnectionRequestedEventArgs(IWiFiDirectConnectionRequestedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectConnectionRequestedEventArgs] {
    fn GetConnectionRequest(&self, out: *mut *mut WiFiDirectConnectionRequest) -> HRESULT
}}
impl IWiFiDirectConnectionRequestedEventArgs {
    #[inline] pub unsafe fn get_connection_request(&self) -> Result<ComPtr<WiFiDirectConnectionRequest>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetConnectionRequest)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectConnectionRequestedEventArgs: IWiFiDirectConnectionRequestedEventArgs}
DEFINE_IID!(IID_IWiFiDirectConnectionListener, 1771838221, 36115, 20201, 185, 236, 156, 114, 248, 37, 31, 125);
RT_INTERFACE!{interface IWiFiDirectConnectionListener(IWiFiDirectConnectionListenerVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectConnectionListener] {
    fn add_ConnectionRequested(&self, handler: *mut super::super::foundation::TypedEventHandler<WiFiDirectConnectionListener, WiFiDirectConnectionRequestedEventArgs>, out: *mut super::super::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_ConnectionRequested(&self, token: super::super::foundation::EventRegistrationToken) -> HRESULT
}}
impl IWiFiDirectConnectionListener {
    #[inline] pub unsafe fn add_connection_requested(&self, handler: &super::super::foundation::TypedEventHandler<WiFiDirectConnectionListener, WiFiDirectConnectionRequestedEventArgs>) -> Result<super::super::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_ConnectionRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_connection_requested(&self, token: super::super::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_ConnectionRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectConnectionListener: IWiFiDirectConnectionListener}
impl RtActivatable<IActivationFactory> for WiFiDirectConnectionListener {}
DEFINE_CLSID!(WiFiDirectConnectionListener(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,87,105,70,105,68,105,114,101,99,116,46,87,105,70,105,68,105,114,101,99,116,67,111,110,110,101,99,116,105,111,110,76,105,115,116,101,110,101,114,0]) [CLSID_WiFiDirectConnectionListener]);
pub mod services { // Windows.Devices.WiFiDirect.Services
use ::prelude::*;
RT_ENUM! { enum WiFiDirectServiceConfigurationMethod: i32 {
    Default (WiFiDirectServiceConfigurationMethod_Default) = 0, PinDisplay (WiFiDirectServiceConfigurationMethod_PinDisplay) = 1, PinEntry (WiFiDirectServiceConfigurationMethod_PinEntry) = 2,
}}
RT_ENUM! { enum WiFiDirectServiceStatus: i32 {
    Available (WiFiDirectServiceStatus_Available) = 0, Busy (WiFiDirectServiceStatus_Busy) = 1, Custom (WiFiDirectServiceStatus_Custom) = 2,
}}
RT_ENUM! { enum WiFiDirectServiceSessionStatus: i32 {
    Closed (WiFiDirectServiceSessionStatus_Closed) = 0, Initiated (WiFiDirectServiceSessionStatus_Initiated) = 1, Requested (WiFiDirectServiceSessionStatus_Requested) = 2, Open (WiFiDirectServiceSessionStatus_Open) = 3,
}}
RT_ENUM! { enum WiFiDirectServiceSessionErrorStatus: i32 {
    Ok (WiFiDirectServiceSessionErrorStatus_Ok) = 0, Disassociated (WiFiDirectServiceSessionErrorStatus_Disassociated) = 1, LocalClose (WiFiDirectServiceSessionErrorStatus_LocalClose) = 2, RemoteClose (WiFiDirectServiceSessionErrorStatus_RemoteClose) = 3, SystemFailure (WiFiDirectServiceSessionErrorStatus_SystemFailure) = 4, NoResponseFromRemote (WiFiDirectServiceSessionErrorStatus_NoResponseFromRemote) = 5,
}}
RT_ENUM! { enum WiFiDirectServiceAdvertisementStatus: i32 {
    Created (WiFiDirectServiceAdvertisementStatus_Created) = 0, Started (WiFiDirectServiceAdvertisementStatus_Started) = 1, Stopped (WiFiDirectServiceAdvertisementStatus_Stopped) = 2, Aborted (WiFiDirectServiceAdvertisementStatus_Aborted) = 3,
}}
RT_ENUM! { enum WiFiDirectServiceError: i32 {
    Success (WiFiDirectServiceError_Success) = 0, RadioNotAvailable (WiFiDirectServiceError_RadioNotAvailable) = 1, ResourceInUse (WiFiDirectServiceError_ResourceInUse) = 2, UnsupportedHardware (WiFiDirectServiceError_UnsupportedHardware) = 3, NoHardware (WiFiDirectServiceError_NoHardware) = 4,
}}
RT_ENUM! { enum WiFiDirectServiceIPProtocol: i32 {
    Tcp (WiFiDirectServiceIPProtocol_Tcp) = 6, Udp (WiFiDirectServiceIPProtocol_Udp) = 17,
}}
DEFINE_IID!(IID_IWiFiDirectServiceProvisioningInfo, 2346417406, 38873, 17826, 142, 153, 219, 80, 145, 15, 182, 166);
RT_INTERFACE!{interface IWiFiDirectServiceProvisioningInfo(IWiFiDirectServiceProvisioningInfoVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectServiceProvisioningInfo] {
    fn get_SelectedConfigurationMethod(&self, out: *mut WiFiDirectServiceConfigurationMethod) -> HRESULT,
    fn get_IsGroupFormationNeeded(&self, out: *mut bool) -> HRESULT
}}
impl IWiFiDirectServiceProvisioningInfo {
    #[inline] pub unsafe fn get_selected_configuration_method(&self) -> Result<WiFiDirectServiceConfigurationMethod> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SelectedConfigurationMethod)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_is_group_formation_needed(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_IsGroupFormationNeeded)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectServiceProvisioningInfo: IWiFiDirectServiceProvisioningInfo}
DEFINE_IID!(IID_IWiFiDirectServiceAutoAcceptSessionConnectedEventArgs, 3705266206, 33759, 17381, 143, 67, 203, 232, 71, 158, 132, 235);
RT_INTERFACE!{interface IWiFiDirectServiceAutoAcceptSessionConnectedEventArgs(IWiFiDirectServiceAutoAcceptSessionConnectedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectServiceAutoAcceptSessionConnectedEventArgs] {
    fn get_Session(&self, out: *mut *mut WiFiDirectServiceSession) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_SessionInfo(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT
}}
impl IWiFiDirectServiceAutoAcceptSessionConnectedEventArgs {
    #[inline] pub unsafe fn get_session(&self) -> Result<ComPtr<WiFiDirectServiceSession>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_Session)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_session_info(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SessionInfo)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectServiceSession: IWiFiDirectServiceSession}
RT_CLASS!{class WiFiDirectServiceAutoAcceptSessionConnectedEventArgs: IWiFiDirectServiceAutoAcceptSessionConnectedEventArgs}
DEFINE_IID!(IID_IWiFiDirectServiceRemotePortAddedEventArgs, 3570318017, 16339, 20238, 183, 189, 120, 41, 6, 244, 68, 17);
RT_INTERFACE!{interface IWiFiDirectServiceRemotePortAddedEventArgs(IWiFiDirectServiceRemotePortAddedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectServiceRemotePortAddedEventArgs] {
    #[cfg(not(feature="windows-networking"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-networking")] fn get_EndpointPairs(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<::rt::gen::windows::networking::EndpointPair>) -> HRESULT,
    fn get_Protocol(&self, out: *mut WiFiDirectServiceIPProtocol) -> HRESULT
}}
impl IWiFiDirectServiceRemotePortAddedEventArgs {
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn get_endpoint_pairs(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<::rt::gen::windows::networking::EndpointPair>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_EndpointPairs)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_protocol(&self) -> Result<WiFiDirectServiceIPProtocol> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Protocol)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectServiceRemotePortAddedEventArgs: IWiFiDirectServiceRemotePortAddedEventArgs}
DEFINE_IID!(IID_IWiFiDirectServiceSessionDeferredEventArgs, 2382109055, 4609, 20255, 182, 244, 93, 241, 183, 185, 251, 46);
RT_INTERFACE!{interface IWiFiDirectServiceSessionDeferredEventArgs(IWiFiDirectServiceSessionDeferredEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectServiceSessionDeferredEventArgs] {
    #[cfg(feature="windows-storage")] fn get_DeferredSessionInfo(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT
}}
impl IWiFiDirectServiceSessionDeferredEventArgs {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_deferred_session_info(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeferredSessionInfo)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectServiceSessionDeferredEventArgs: IWiFiDirectServiceSessionDeferredEventArgs}
DEFINE_IID!(IID_IWiFiDirectServiceSessionRequestedEventArgs, 1958595601, 21462, 18841, 180, 248, 108, 142, 204, 23, 113, 231);
RT_INTERFACE!{interface IWiFiDirectServiceSessionRequestedEventArgs(IWiFiDirectServiceSessionRequestedEventArgsVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectServiceSessionRequestedEventArgs] {
    fn GetSessionRequest(&self, out: *mut *mut WiFiDirectServiceSessionRequest) -> HRESULT
}}
impl IWiFiDirectServiceSessionRequestedEventArgs {
    #[inline] pub unsafe fn get_session_request(&self) -> Result<ComPtr<WiFiDirectServiceSessionRequest>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetSessionRequest)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectServiceSessionRequest: IWiFiDirectServiceSessionRequest}
RT_CLASS!{class WiFiDirectServiceSessionRequestedEventArgs: IWiFiDirectServiceSessionRequestedEventArgs}
DEFINE_IID!(IID_IWiFiDirectServiceSessionRequest, 2699197579, 20683, 19032, 155, 207, 228, 114, 185, 159, 186, 4);
RT_INTERFACE!{interface IWiFiDirectServiceSessionRequest(IWiFiDirectServiceSessionRequestVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectServiceSessionRequest] {
    fn get_DeviceInformation(&self, out: *mut *mut super::super::enumeration::DeviceInformation) -> HRESULT,
    fn get_ProvisioningInfo(&self, out: *mut *mut WiFiDirectServiceProvisioningInfo) -> HRESULT,
    #[cfg(feature="windows-storage")] fn get_SessionInfo(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT
}}
impl IWiFiDirectServiceSessionRequest {
    #[inline] pub unsafe fn get_device_information(&self) -> Result<ComPtr<super::super::enumeration::DeviceInformation>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceInformation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_provisioning_info(&self) -> Result<ComPtr<WiFiDirectServiceProvisioningInfo>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ProvisioningInfo)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_session_info(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SessionInfo)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IWiFiDirectServiceAdvertiserFactory, 822520845, 46150, 20243, 159, 154, 138, 233, 37, 254, 186, 43);
RT_INTERFACE!{static interface IWiFiDirectServiceAdvertiserFactory(IWiFiDirectServiceAdvertiserFactoryVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectServiceAdvertiserFactory] {
    fn CreateWiFiDirectServiceAdvertiser(&self, serviceName: HSTRING, out: *mut *mut WiFiDirectServiceAdvertiser) -> HRESULT
}}
impl IWiFiDirectServiceAdvertiserFactory {
    #[inline] pub unsafe fn create_wi_fi_direct_service_advertiser(&self, serviceName: &HStringArg) -> Result<ComPtr<WiFiDirectServiceAdvertiser>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).CreateWiFiDirectServiceAdvertiser)(self as *const _ as *mut _, serviceName.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectServiceAdvertiser: IWiFiDirectServiceAdvertiser}
impl RtActivatable<IWiFiDirectServiceAdvertiserFactory> for WiFiDirectServiceAdvertiser {}
impl WiFiDirectServiceAdvertiser {
    #[inline] pub fn create_wi_fi_direct_service_advertiser(serviceName: &HStringArg) -> Result<ComPtr<WiFiDirectServiceAdvertiser>> { unsafe {
        <Self as RtActivatable<IWiFiDirectServiceAdvertiserFactory>>::get_activation_factory().create_wi_fi_direct_service_advertiser(serviceName)
    }}
}
DEFINE_CLSID!(WiFiDirectServiceAdvertiser(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,87,105,70,105,68,105,114,101,99,116,46,83,101,114,118,105,99,101,115,46,87,105,70,105,68,105,114,101,99,116,83,101,114,118,105,99,101,65,100,118,101,114,116,105,115,101,114,0]) [CLSID_WiFiDirectServiceAdvertiser]);
DEFINE_IID!(IID_IWiFiDirectServiceAdvertiser, 2762612449, 40335, 20303, 147, 238, 125, 222, 162, 227, 127, 70);
RT_INTERFACE!{interface IWiFiDirectServiceAdvertiser(IWiFiDirectServiceAdvertiserVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectServiceAdvertiser] {
    fn get_ServiceName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_ServiceNamePrefixes(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVector<HString>) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy2(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_ServiceInfo(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy3(&self) -> (),
    #[cfg(feature="windows-storage")] fn put_ServiceInfo(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    fn get_AutoAcceptSession(&self, out: *mut bool) -> HRESULT,
    fn put_AutoAcceptSession(&self, value: bool) -> HRESULT,
    fn get_PreferGroupOwnerMode(&self, out: *mut bool) -> HRESULT,
    fn put_PreferGroupOwnerMode(&self, value: bool) -> HRESULT,
    fn get_PreferredConfigurationMethods(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVector<WiFiDirectServiceConfigurationMethod>) -> HRESULT,
    fn get_ServiceStatus(&self, out: *mut WiFiDirectServiceStatus) -> HRESULT,
    fn put_ServiceStatus(&self, value: WiFiDirectServiceStatus) -> HRESULT,
    fn get_CustomServiceStatusCode(&self, out: *mut u32) -> HRESULT,
    fn put_CustomServiceStatusCode(&self, value: u32) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy13(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_DeferredSessionInfo(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy14(&self) -> (),
    #[cfg(feature="windows-storage")] fn put_DeferredSessionInfo(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    fn get_AdvertisementStatus(&self, out: *mut WiFiDirectServiceAdvertisementStatus) -> HRESULT,
    fn get_ServiceError(&self, out: *mut WiFiDirectServiceError) -> HRESULT,
    fn add_SessionRequested(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<WiFiDirectServiceAdvertiser, WiFiDirectServiceSessionRequestedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SessionRequested(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn add_AutoAcceptSessionConnected(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<WiFiDirectServiceAdvertiser, WiFiDirectServiceAutoAcceptSessionConnectedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_AutoAcceptSessionConnected(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn add_AdvertisementStatusChanged(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<WiFiDirectServiceAdvertiser, IInspectable>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_AdvertisementStatusChanged(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn ConnectAsync(&self, deviceInfo: *mut super::super::enumeration::DeviceInformation, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<WiFiDirectServiceSession>) -> HRESULT,
    fn ConnectAsyncWithPin(&self, deviceInfo: *mut super::super::enumeration::DeviceInformation, pin: HSTRING, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<WiFiDirectServiceSession>) -> HRESULT,
    fn Start(&self) -> HRESULT,
    fn Stop(&self) -> HRESULT
}}
impl IWiFiDirectServiceAdvertiser {
    #[inline] pub unsafe fn get_service_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ServiceName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_name_prefixes(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVector<HString>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ServiceNamePrefixes)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_service_info(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ServiceInfo)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_service_info(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ServiceInfo)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_auto_accept_session(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AutoAcceptSession)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_auto_accept_session(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_AutoAcceptSession)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_prefer_group_owner_mode(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PreferGroupOwnerMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_prefer_group_owner_mode(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_PreferGroupOwnerMode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_preferred_configuration_methods(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVector<WiFiDirectServiceConfigurationMethod>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_PreferredConfigurationMethods)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_status(&self) -> Result<WiFiDirectServiceStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ServiceStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_service_status(&self, value: WiFiDirectServiceStatus) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ServiceStatus)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_custom_service_status_code(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CustomServiceStatusCode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_custom_service_status_code(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_CustomServiceStatusCode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_deferred_session_info(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeferredSessionInfo)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_deferred_session_info(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DeferredSessionInfo)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_advertisement_status(&self) -> Result<WiFiDirectServiceAdvertisementStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AdvertisementStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_error(&self) -> Result<WiFiDirectServiceError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ServiceError)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_session_requested(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<WiFiDirectServiceAdvertiser, WiFiDirectServiceSessionRequestedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SessionRequested)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_session_requested(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SessionRequested)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_auto_accept_session_connected(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<WiFiDirectServiceAdvertiser, WiFiDirectServiceAutoAcceptSessionConnectedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_AutoAcceptSessionConnected)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_auto_accept_session_connected(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_AutoAcceptSessionConnected)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_advertisement_status_changed(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<WiFiDirectServiceAdvertiser, IInspectable>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_AdvertisementStatusChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_advertisement_status_changed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_AdvertisementStatusChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn connect_async(&self, deviceInfo: &super::super::enumeration::DeviceInformation) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<WiFiDirectServiceSession>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ConnectAsync)(self as *const _ as *mut _, deviceInfo as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn connect_async_with_pin(&self, deviceInfo: &super::super::enumeration::DeviceInformation, pin: &HStringArg) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<WiFiDirectServiceSession>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ConnectAsyncWithPin)(self as *const _ as *mut _, deviceInfo as *const _ as *mut _, pin.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn start(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Start)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn stop(&self) -> Result<()> {
        let hr = ((*self.lpVtbl).Stop)(self as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IWiFiDirectServiceStatics, 2108948549, 64884, 18056, 183, 37, 93, 206, 134, 172, 242, 51);
RT_INTERFACE!{static interface IWiFiDirectServiceStatics(IWiFiDirectServiceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectServiceStatics] {
    fn GetSelector(&self, serviceName: HSTRING, out: *mut HSTRING) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy1(&self) -> (),
    #[cfg(feature="windows-storage")] fn GetSelectorWithFilter(&self, serviceName: HSTRING, serviceInfoFilter: *mut ::rt::gen::windows::storage::streams::IBuffer, out: *mut HSTRING) -> HRESULT,
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<WiFiDirectService>) -> HRESULT
}}
impl IWiFiDirectServiceStatics {
    #[inline] pub unsafe fn get_selector(&self, serviceName: &HStringArg) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetSelector)(self as *const _ as *mut _, serviceName.get(), &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_selector_with_filter(&self, serviceName: &HStringArg, serviceInfoFilter: &::rt::gen::windows::storage::streams::IBuffer) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetSelectorWithFilter)(self as *const _ as *mut _, serviceName.get(), serviceInfoFilter as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<WiFiDirectService>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class WiFiDirectService: IWiFiDirectService}
impl RtActivatable<IWiFiDirectServiceStatics> for WiFiDirectService {}
impl WiFiDirectService {
    #[inline] pub fn get_selector(serviceName: &HStringArg) -> Result<HString> { unsafe {
        <Self as RtActivatable<IWiFiDirectServiceStatics>>::get_activation_factory().get_selector(serviceName)
    }}
    #[cfg(feature="windows-storage")] #[inline] pub fn get_selector_with_filter(serviceName: &HStringArg, serviceInfoFilter: &::rt::gen::windows::storage::streams::IBuffer) -> Result<HString> { unsafe {
        <Self as RtActivatable<IWiFiDirectServiceStatics>>::get_activation_factory().get_selector_with_filter(serviceName, serviceInfoFilter)
    }}
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<WiFiDirectService>>> { unsafe {
        <Self as RtActivatable<IWiFiDirectServiceStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
}
DEFINE_CLSID!(WiFiDirectService(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,87,105,70,105,68,105,114,101,99,116,46,83,101,114,118,105,99,101,115,46,87,105,70,105,68,105,114,101,99,116,83,101,114,118,105,99,101,0]) [CLSID_WiFiDirectService]);
DEFINE_IID!(IID_IWiFiDirectService, 1353366456, 24433, 17900, 132, 241, 161, 228, 252, 120, 121, 163);
RT_INTERFACE!{interface IWiFiDirectService(IWiFiDirectServiceVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectService] {
    #[cfg(not(feature="windows-storage"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_RemoteServiceInfo(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    fn get_SupportedConfigurationMethods(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<WiFiDirectServiceConfigurationMethod>) -> HRESULT,
    fn get_PreferGroupOwnerMode(&self, out: *mut bool) -> HRESULT,
    fn put_PreferGroupOwnerMode(&self, value: bool) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy4(&self) -> (),
    #[cfg(feature="windows-storage")] fn get_SessionInfo(&self, out: *mut *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    #[cfg(not(feature="windows-storage"))] fn __Dummy5(&self) -> (),
    #[cfg(feature="windows-storage")] fn put_SessionInfo(&self, value: *mut ::rt::gen::windows::storage::streams::IBuffer) -> HRESULT,
    fn get_ServiceError(&self, out: *mut WiFiDirectServiceError) -> HRESULT,
    fn add_SessionDeferred(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<WiFiDirectService, WiFiDirectServiceSessionDeferredEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SessionDeferred(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn GetProvisioningInfoAsync(&self, selectedConfigurationMethod: WiFiDirectServiceConfigurationMethod, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<WiFiDirectServiceProvisioningInfo>) -> HRESULT,
    fn ConnectAsync(&self, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<WiFiDirectServiceSession>) -> HRESULT,
    fn ConnectAsyncWithPin(&self, pin: HSTRING, out: *mut *mut ::rt::gen::windows::foundation::IAsyncOperation<WiFiDirectServiceSession>) -> HRESULT
}}
impl IWiFiDirectService {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_remote_service_info(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_RemoteServiceInfo)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_supported_configuration_methods(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<WiFiDirectServiceConfigurationMethod>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SupportedConfigurationMethods)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_prefer_group_owner_mode(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PreferGroupOwnerMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_prefer_group_owner_mode(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_PreferGroupOwnerMode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_session_info(&self) -> Result<ComPtr<::rt::gen::windows::storage::streams::IBuffer>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SessionInfo)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn set_session_info(&self, value: &::rt::gen::windows::storage::streams::IBuffer) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SessionInfo)(self as *const _ as *mut _, value as *const _ as *mut _);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_error(&self) -> Result<WiFiDirectServiceError> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ServiceError)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_session_deferred(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<WiFiDirectService, WiFiDirectServiceSessionDeferredEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SessionDeferred)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_session_deferred(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SessionDeferred)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_provisioning_info_async(&self, selectedConfigurationMethod: WiFiDirectServiceConfigurationMethod) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<WiFiDirectServiceProvisioningInfo>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetProvisioningInfoAsync)(self as *const _ as *mut _, selectedConfigurationMethod, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn connect_async(&self) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<WiFiDirectServiceSession>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ConnectAsync)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn connect_async_with_pin(&self, pin: &HStringArg) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncOperation<WiFiDirectServiceSession>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ConnectAsyncWithPin)(self as *const _ as *mut _, pin.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IWiFiDirectServiceSession, 2165580131, 58406, 18379, 134, 64, 225, 179, 88, 139, 242, 111);
RT_INTERFACE!{interface IWiFiDirectServiceSession(IWiFiDirectServiceSessionVtbl): IInspectable(IInspectableVtbl) [IID_IWiFiDirectServiceSession] {
    fn get_ServiceName(&self, out: *mut HSTRING) -> HRESULT,
    fn get_Status(&self, out: *mut WiFiDirectServiceSessionStatus) -> HRESULT,
    fn get_ErrorStatus(&self, out: *mut WiFiDirectServiceSessionErrorStatus) -> HRESULT,
    fn get_SessionId(&self, out: *mut u32) -> HRESULT,
    fn get_AdvertisementId(&self, out: *mut u32) -> HRESULT,
    fn get_ServiceAddress(&self, out: *mut HSTRING) -> HRESULT,
    fn get_SessionAddress(&self, out: *mut HSTRING) -> HRESULT,
    #[cfg(not(feature="windows-networking"))] fn __Dummy7(&self) -> (),
    #[cfg(feature="windows-networking")] fn GetConnectionEndpointPairs(&self, out: *mut *mut ::rt::gen::windows::foundation::collections::IVectorView<::rt::gen::windows::networking::EndpointPair>) -> HRESULT,
    fn add_SessionStatusChanged(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<WiFiDirectServiceSession, IInspectable>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_SessionStatusChanged(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    #[cfg(not(feature="windows-networking"))] fn __Dummy10(&self) -> (),
    #[cfg(feature="windows-networking")] fn AddStreamSocketListenerAsync(&self, value: *mut ::rt::gen::windows::networking::sockets::StreamSocketListener, out: *mut *mut ::rt::gen::windows::foundation::IAsyncAction) -> HRESULT,
    #[cfg(not(feature="windows-networking"))] fn __Dummy11(&self) -> (),
    #[cfg(feature="windows-networking")] fn AddDatagramSocketAsync(&self, value: *mut ::rt::gen::windows::networking::sockets::DatagramSocket, out: *mut *mut ::rt::gen::windows::foundation::IAsyncAction) -> HRESULT,
    fn add_RemotePortAdded(&self, handler: *mut ::rt::gen::windows::foundation::TypedEventHandler<WiFiDirectServiceSession, WiFiDirectServiceRemotePortAddedEventArgs>, out: *mut ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT,
    fn remove_RemotePortAdded(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> HRESULT
}}
impl IWiFiDirectServiceSession {
    #[inline] pub unsafe fn get_service_name(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ServiceName)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_status(&self) -> Result<WiFiDirectServiceSessionStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Status)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_error_status(&self) -> Result<WiFiDirectServiceSessionErrorStatus> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ErrorStatus)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_session_id(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SessionId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_advertisement_id(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AdvertisementId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_service_address(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ServiceAddress)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_session_address(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_SessionAddress)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn get_connection_endpoint_pairs(&self) -> Result<ComPtr<::rt::gen::windows::foundation::collections::IVectorView<::rt::gen::windows::networking::EndpointPair>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetConnectionEndpointPairs)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_session_status_changed(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<WiFiDirectServiceSession, IInspectable>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_SessionStatusChanged)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_session_status_changed(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_SessionStatusChanged)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn add_stream_socket_listener_async(&self, value: &::rt::gen::windows::networking::sockets::StreamSocketListener) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).AddStreamSocketListenerAsync)(self as *const _ as *mut _, value as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-networking")] #[inline] pub unsafe fn add_datagram_socket_async(&self, value: &::rt::gen::windows::networking::sockets::DatagramSocket) -> Result<ComPtr<::rt::gen::windows::foundation::IAsyncAction>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).AddDatagramSocketAsync)(self as *const _ as *mut _, value as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn add_remote_port_added(&self, handler: &::rt::gen::windows::foundation::TypedEventHandler<WiFiDirectServiceSession, WiFiDirectServiceRemotePortAddedEventArgs>) -> Result<::rt::gen::windows::foundation::EventRegistrationToken> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).add_RemotePortAdded)(self as *const _ as *mut _, handler as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn remove_remote_port_added(&self, token: ::rt::gen::windows::foundation::EventRegistrationToken) -> Result<()> {
        let hr = ((*self.lpVtbl).remove_RemotePortAdded)(self as *const _ as *mut _, token);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
} // Windows.Devices.WiFiDirect.Services
} // Windows.Devices.WiFiDirect
pub mod portable { // Windows.Devices.Portable
use ::prelude::*;
RT_ENUM! { enum ServiceDeviceType: i32 {
    CalendarService (ServiceDeviceType_CalendarService) = 0, ContactsService (ServiceDeviceType_ContactsService) = 1, DeviceStatusService (ServiceDeviceType_DeviceStatusService) = 2, NotesService (ServiceDeviceType_NotesService) = 3, RingtonesService (ServiceDeviceType_RingtonesService) = 4, SmsService (ServiceDeviceType_SmsService) = 5, TasksService (ServiceDeviceType_TasksService) = 6,
}}
DEFINE_IID!(IID_IStorageDeviceStatics, 1590576366, 6947, 19922, 134, 82, 188, 22, 79, 0, 49, 40);
RT_INTERFACE!{static interface IStorageDeviceStatics(IStorageDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IStorageDeviceStatics] {
    #[cfg(not(feature="windows-storage"))] fn __Dummy0(&self) -> (),
    #[cfg(feature="windows-storage")] fn FromId(&self, deviceId: HSTRING, out: *mut *mut super::super::storage::StorageFolder) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT
}}
impl IStorageDeviceStatics {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn from_id(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::storage::StorageFolder>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromId)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IServiceDeviceStatics, 2827097313, 22983, 18976, 171, 166, 159, 103, 7, 147, 114, 48);
RT_INTERFACE!{static interface IServiceDeviceStatics(IServiceDeviceStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IServiceDeviceStatics] {
    fn GetDeviceSelector(&self, serviceType: ServiceDeviceType, out: *mut HSTRING) -> HRESULT,
    fn GetDeviceSelectorFromServiceId(&self, serviceId: Guid, out: *mut HSTRING) -> HRESULT
}}
impl IServiceDeviceStatics {
    #[inline] pub unsafe fn get_device_selector(&self, serviceType: ServiceDeviceType) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, serviceType, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector_from_service_id(&self, serviceId: Guid) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelectorFromServiceId)(self as *const _ as *mut _, serviceId, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{static class StorageDevice}
impl RtActivatable<IStorageDeviceStatics> for StorageDevice {}
impl StorageDevice {
    #[cfg(feature="windows-storage")] #[inline] pub fn from_id(deviceId: &HStringArg) -> Result<ComPtr<super::super::storage::StorageFolder>> { unsafe {
        <Self as RtActivatable<IStorageDeviceStatics>>::get_activation_factory().from_id(deviceId)
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IStorageDeviceStatics>>::get_activation_factory().get_device_selector()
    }}
}
DEFINE_CLSID!(StorageDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,111,114,116,97,98,108,101,46,83,116,111,114,97,103,101,68,101,118,105,99,101,0]) [CLSID_StorageDevice]);
RT_CLASS!{static class ServiceDevice}
impl RtActivatable<IServiceDeviceStatics> for ServiceDevice {}
impl ServiceDevice {
    #[inline] pub fn get_device_selector(serviceType: ServiceDeviceType) -> Result<HString> { unsafe {
        <Self as RtActivatable<IServiceDeviceStatics>>::get_activation_factory().get_device_selector(serviceType)
    }}
    #[inline] pub fn get_device_selector_from_service_id(serviceId: Guid) -> Result<HString> { unsafe {
        <Self as RtActivatable<IServiceDeviceStatics>>::get_activation_factory().get_device_selector_from_service_id(serviceId)
    }}
}
DEFINE_CLSID!(ServiceDevice(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,80,111,114,116,97,98,108,101,46,83,101,114,118,105,99,101,68,101,118,105,99,101,0]) [CLSID_ServiceDevice]);
} // Windows.Devices.Portable
pub mod scanners { // Windows.Devices.Scanners
use ::prelude::*;
RT_ENUM! { enum ImageScannerFormat: i32 {
    Jpeg (ImageScannerFormat_Jpeg) = 0, Png (ImageScannerFormat_Png) = 1, DeviceIndependentBitmap (ImageScannerFormat_DeviceIndependentBitmap) = 2, Tiff (ImageScannerFormat_Tiff) = 3, Xps (ImageScannerFormat_Xps) = 4, OpenXps (ImageScannerFormat_OpenXps) = 5, Pdf (ImageScannerFormat_Pdf) = 6,
}}
DEFINE_IID!(IID_IImageScannerFormatConfiguration, 2921815313, 56031, 16400, 191, 16, 204, 165, 200, 61, 203, 176);
RT_INTERFACE!{interface IImageScannerFormatConfiguration(IImageScannerFormatConfigurationVtbl): IInspectable(IInspectableVtbl) [IID_IImageScannerFormatConfiguration] {
    fn get_DefaultFormat(&self, out: *mut ImageScannerFormat) -> HRESULT,
    fn get_Format(&self, out: *mut ImageScannerFormat) -> HRESULT,
    fn put_Format(&self, value: ImageScannerFormat) -> HRESULT,
    fn IsFormatSupported(&self, value: ImageScannerFormat, out: *mut bool) -> HRESULT
}}
impl IImageScannerFormatConfiguration {
    #[inline] pub unsafe fn get_default_format(&self) -> Result<ImageScannerFormat> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DefaultFormat)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_format(&self) -> Result<ImageScannerFormat> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Format)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_format(&self, value: ImageScannerFormat) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Format)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_format_supported(&self, value: ImageScannerFormat) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsFormatSupported)(self as *const _ as *mut _, value, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class ImageScannerAutoConfiguration: IImageScannerFormatConfiguration}
RT_ENUM! { enum ImageScannerAutoCroppingMode: i32 {
    Disabled (ImageScannerAutoCroppingMode_Disabled) = 0, SingleRegion (ImageScannerAutoCroppingMode_SingleRegion) = 1, MultipleRegion (ImageScannerAutoCroppingMode_MultipleRegion) = 2,
}}
RT_ENUM! { enum ImageScannerColorMode: i32 {
    Color (ImageScannerColorMode_Color) = 0, Grayscale (ImageScannerColorMode_Grayscale) = 1, Monochrome (ImageScannerColorMode_Monochrome) = 2, AutoColor (ImageScannerColorMode_AutoColor) = 3,
}}
RT_STRUCT! { struct ImageScannerResolution {
    DpiX: f32, DpiY: f32,
}}
DEFINE_IID!(IID_IImageScannerSourceConfiguration, 3216310357, 2884, 19586, 158, 137, 32, 95, 156, 35, 78, 89);
RT_INTERFACE!{interface IImageScannerSourceConfiguration(IImageScannerSourceConfigurationVtbl): IInspectable(IInspectableVtbl) [IID_IImageScannerSourceConfiguration] {
    fn get_MinScanArea(&self, out: *mut super::super::foundation::Size) -> HRESULT,
    fn get_MaxScanArea(&self, out: *mut super::super::foundation::Size) -> HRESULT,
    fn get_SelectedScanRegion(&self, out: *mut super::super::foundation::Rect) -> HRESULT,
    fn put_SelectedScanRegion(&self, value: super::super::foundation::Rect) -> HRESULT,
    fn get_AutoCroppingMode(&self, out: *mut ImageScannerAutoCroppingMode) -> HRESULT,
    fn put_AutoCroppingMode(&self, value: ImageScannerAutoCroppingMode) -> HRESULT,
    fn IsAutoCroppingModeSupported(&self, value: ImageScannerAutoCroppingMode, out: *mut bool) -> HRESULT,
    fn get_MinResolution(&self, out: *mut ImageScannerResolution) -> HRESULT,
    fn get_MaxResolution(&self, out: *mut ImageScannerResolution) -> HRESULT,
    fn get_OpticalResolution(&self, out: *mut ImageScannerResolution) -> HRESULT,
    fn get_DesiredResolution(&self, out: *mut ImageScannerResolution) -> HRESULT,
    fn put_DesiredResolution(&self, value: ImageScannerResolution) -> HRESULT,
    fn get_ActualResolution(&self, out: *mut ImageScannerResolution) -> HRESULT,
    fn get_DefaultColorMode(&self, out: *mut ImageScannerColorMode) -> HRESULT,
    fn get_ColorMode(&self, out: *mut ImageScannerColorMode) -> HRESULT,
    fn put_ColorMode(&self, value: ImageScannerColorMode) -> HRESULT,
    fn IsColorModeSupported(&self, value: ImageScannerColorMode, out: *mut bool) -> HRESULT,
    fn get_MinBrightness(&self, out: *mut i32) -> HRESULT,
    fn get_MaxBrightness(&self, out: *mut i32) -> HRESULT,
    fn get_BrightnessStep(&self, out: *mut u32) -> HRESULT,
    fn get_DefaultBrightness(&self, out: *mut i32) -> HRESULT,
    fn get_Brightness(&self, out: *mut i32) -> HRESULT,
    fn put_Brightness(&self, value: i32) -> HRESULT,
    fn get_MinContrast(&self, out: *mut i32) -> HRESULT,
    fn get_MaxContrast(&self, out: *mut i32) -> HRESULT,
    fn get_ContrastStep(&self, out: *mut u32) -> HRESULT,
    fn get_DefaultContrast(&self, out: *mut i32) -> HRESULT,
    fn get_Contrast(&self, out: *mut i32) -> HRESULT,
    fn put_Contrast(&self, value: i32) -> HRESULT
}}
impl IImageScannerSourceConfiguration {
    #[inline] pub unsafe fn get_min_scan_area(&self) -> Result<super::super::foundation::Size> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinScanArea)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_scan_area(&self) -> Result<super::super::foundation::Size> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxScanArea)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_selected_scan_region(&self) -> Result<super::super::foundation::Rect> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_SelectedScanRegion)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_selected_scan_region(&self, value: super::super::foundation::Rect) -> Result<()> {
        let hr = ((*self.lpVtbl).put_SelectedScanRegion)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_auto_cropping_mode(&self) -> Result<ImageScannerAutoCroppingMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AutoCroppingMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_auto_cropping_mode(&self, value: ImageScannerAutoCroppingMode) -> Result<()> {
        let hr = ((*self.lpVtbl).put_AutoCroppingMode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_auto_cropping_mode_supported(&self, value: ImageScannerAutoCroppingMode) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsAutoCroppingModeSupported)(self as *const _ as *mut _, value, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_min_resolution(&self) -> Result<ImageScannerResolution> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinResolution)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_resolution(&self) -> Result<ImageScannerResolution> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxResolution)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_optical_resolution(&self) -> Result<ImageScannerResolution> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_OpticalResolution)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_desired_resolution(&self) -> Result<ImageScannerResolution> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DesiredResolution)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_desired_resolution(&self, value: ImageScannerResolution) -> Result<()> {
        let hr = ((*self.lpVtbl).put_DesiredResolution)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_actual_resolution(&self) -> Result<ImageScannerResolution> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ActualResolution)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_color_mode(&self) -> Result<ImageScannerColorMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DefaultColorMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_color_mode(&self) -> Result<ImageScannerColorMode> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ColorMode)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_color_mode(&self, value: ImageScannerColorMode) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ColorMode)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_color_mode_supported(&self, value: ImageScannerColorMode) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsColorModeSupported)(self as *const _ as *mut _, value, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_min_brightness(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinBrightness)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_brightness(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxBrightness)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_brightness_step(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_BrightnessStep)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_brightness(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DefaultBrightness)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_brightness(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Brightness)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_brightness(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Brightness)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_min_contrast(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MinContrast)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_contrast(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxContrast)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_contrast_step(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ContrastStep)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_contrast(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DefaultContrast)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_contrast(&self) -> Result<i32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Contrast)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_contrast(&self, value: i32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Contrast)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class ImageScannerFlatbedConfiguration: IImageScannerFormatConfiguration}
DEFINE_IID!(IID_IImageScannerFeederConfiguration, 1958587630, 64151, 19479, 130, 128, 64, 227, 156, 109, 204, 103);
RT_INTERFACE!{interface IImageScannerFeederConfiguration(IImageScannerFeederConfigurationVtbl): IInspectable(IInspectableVtbl) [IID_IImageScannerFeederConfiguration] {
    fn get_CanAutoDetectPageSize(&self, out: *mut bool) -> HRESULT,
    fn get_AutoDetectPageSize(&self, out: *mut bool) -> HRESULT,
    fn put_AutoDetectPageSize(&self, value: bool) -> HRESULT,
    #[cfg(not(feature="windows-graphics"))] fn __Dummy3(&self) -> (),
    #[cfg(feature="windows-graphics")] fn get_PageSize(&self, out: *mut super::super::graphics::printing::PrintMediaSize) -> HRESULT,
    #[cfg(not(feature="windows-graphics"))] fn __Dummy4(&self) -> (),
    #[cfg(feature="windows-graphics")] fn put_PageSize(&self, value: super::super::graphics::printing::PrintMediaSize) -> HRESULT,
    #[cfg(not(feature="windows-graphics"))] fn __Dummy5(&self) -> (),
    #[cfg(feature="windows-graphics")] fn get_PageOrientation(&self, out: *mut super::super::graphics::printing::PrintOrientation) -> HRESULT,
    #[cfg(not(feature="windows-graphics"))] fn __Dummy6(&self) -> (),
    #[cfg(feature="windows-graphics")] fn put_PageOrientation(&self, value: super::super::graphics::printing::PrintOrientation) -> HRESULT,
    fn get_PageSizeDimensions(&self, out: *mut super::super::foundation::Size) -> HRESULT,
    #[cfg(not(feature="windows-graphics"))] fn __Dummy8(&self) -> (),
    #[cfg(feature="windows-graphics")] fn IsPageSizeSupported(&self, pageSize: super::super::graphics::printing::PrintMediaSize, pageOrientation: super::super::graphics::printing::PrintOrientation, out: *mut bool) -> HRESULT,
    fn get_MaxNumberOfPages(&self, out: *mut u32) -> HRESULT,
    fn put_MaxNumberOfPages(&self, value: u32) -> HRESULT,
    fn get_CanScanDuplex(&self, out: *mut bool) -> HRESULT,
    fn get_Duplex(&self, out: *mut bool) -> HRESULT,
    fn put_Duplex(&self, value: bool) -> HRESULT,
    fn get_CanScanAhead(&self, out: *mut bool) -> HRESULT,
    fn get_ScanAhead(&self, out: *mut bool) -> HRESULT,
    fn put_ScanAhead(&self, value: bool) -> HRESULT
}}
impl IImageScannerFeederConfiguration {
    #[inline] pub unsafe fn get_can_auto_detect_page_size(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanAutoDetectPageSize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_auto_detect_page_size(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_AutoDetectPageSize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_auto_detect_page_size(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_AutoDetectPageSize)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn get_page_size(&self) -> Result<super::super::graphics::printing::PrintMediaSize> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PageSize)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn set_page_size(&self, value: super::super::graphics::printing::PrintMediaSize) -> Result<()> {
        let hr = ((*self.lpVtbl).put_PageSize)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn get_page_orientation(&self) -> Result<super::super::graphics::printing::PrintOrientation> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PageOrientation)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn set_page_orientation(&self, value: super::super::graphics::printing::PrintOrientation) -> Result<()> {
        let hr = ((*self.lpVtbl).put_PageOrientation)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_page_size_dimensions(&self) -> Result<super::super::foundation::Size> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_PageSizeDimensions)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-graphics")] #[inline] pub unsafe fn is_page_size_supported(&self, pageSize: super::super::graphics::printing::PrintMediaSize, pageOrientation: super::super::graphics::printing::PrintOrientation) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsPageSizeSupported)(self as *const _ as *mut _, pageSize, pageOrientation, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_max_number_of_pages(&self) -> Result<u32> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_MaxNumberOfPages)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_max_number_of_pages(&self, value: u32) -> Result<()> {
        let hr = ((*self.lpVtbl).put_MaxNumberOfPages)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_can_scan_duplex(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanScanDuplex)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_duplex(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Duplex)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_duplex(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_Duplex)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_can_scan_ahead(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_CanScanAhead)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_scan_ahead(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_ScanAhead)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn set_scan_ahead(&self, value: bool) -> Result<()> {
        let hr = ((*self.lpVtbl).put_ScanAhead)(self as *const _ as *mut _, value);
        if hr == S_OK { Ok(()) } else { err(hr) }
    }
}
RT_CLASS!{class ImageScannerFeederConfiguration: IImageScannerFormatConfiguration}
DEFINE_IID!(IID_IImageScannerScanResult, 3373671629, 36919, 20040, 132, 193, 172, 9, 117, 7, 107, 197);
RT_INTERFACE!{interface IImageScannerScanResult(IImageScannerScanResultVtbl): IInspectable(IInspectableVtbl) [IID_IImageScannerScanResult] {
    #[cfg(feature="windows-storage")] fn get_ScannedFiles(&self, out: *mut *mut super::super::foundation::collections::IVectorView<super::super::storage::StorageFile>) -> HRESULT
}}
impl IImageScannerScanResult {
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn get_scanned_files(&self) -> Result<ComPtr<super::super::foundation::collections::IVectorView<super::super::storage::StorageFile>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_ScannedFiles)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class ImageScannerScanResult: IImageScannerScanResult}
DEFINE_IID!(IID_IImageScannerPreviewResult, 146275982, 34961, 17437, 190, 156, 23, 111, 161, 9, 200, 187);
RT_INTERFACE!{interface IImageScannerPreviewResult(IImageScannerPreviewResultVtbl): IInspectable(IInspectableVtbl) [IID_IImageScannerPreviewResult] {
    fn get_Succeeded(&self, out: *mut bool) -> HRESULT,
    fn get_Format(&self, out: *mut ImageScannerFormat) -> HRESULT
}}
impl IImageScannerPreviewResult {
    #[inline] pub unsafe fn get_succeeded(&self) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Succeeded)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_format(&self) -> Result<ImageScannerFormat> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_Format)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
}
RT_CLASS!{class ImageScannerPreviewResult: IImageScannerPreviewResult}
RT_ENUM! { enum ImageScannerScanSource: i32 {
    Default (ImageScannerScanSource_Default) = 0, Flatbed (ImageScannerScanSource_Flatbed) = 1, Feeder (ImageScannerScanSource_Feeder) = 2, AutoConfigured (ImageScannerScanSource_AutoConfigured) = 3,
}}
DEFINE_IID!(IID_IImageScanner, 1403555704, 21144, 18592, 141, 163, 128, 135, 81, 150, 101, 224);
RT_INTERFACE!{interface IImageScanner(IImageScannerVtbl): IInspectable(IInspectableVtbl) [IID_IImageScanner] {
    fn get_DeviceId(&self, out: *mut HSTRING) -> HRESULT,
    fn get_DefaultScanSource(&self, out: *mut ImageScannerScanSource) -> HRESULT,
    fn IsScanSourceSupported(&self, value: ImageScannerScanSource, out: *mut bool) -> HRESULT,
    fn get_FlatbedConfiguration(&self, out: *mut *mut ImageScannerFlatbedConfiguration) -> HRESULT,
    fn get_FeederConfiguration(&self, out: *mut *mut ImageScannerFeederConfiguration) -> HRESULT,
    fn get_AutoConfiguration(&self, out: *mut *mut ImageScannerAutoConfiguration) -> HRESULT,
    fn IsPreviewSupported(&self, scanSource: ImageScannerScanSource, out: *mut bool) -> HRESULT,
    #[cfg(feature="windows-storage")] fn ScanPreviewToStreamAsync(&self, scanSource: ImageScannerScanSource, targetStream: *mut super::super::storage::streams::IRandomAccessStream, out: *mut *mut super::super::foundation::IAsyncOperation<ImageScannerPreviewResult>) -> HRESULT,
    #[cfg(feature="windows-storage")] fn ScanFilesToFolderAsync(&self, scanSource: ImageScannerScanSource, storageFolder: *mut super::super::storage::StorageFolder, out: *mut *mut super::super::foundation::IAsyncOperationWithProgress<ImageScannerScanResult, u32>) -> HRESULT
}}
impl IImageScanner {
    #[inline] pub unsafe fn get_device_id(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_DeviceId)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_default_scan_source(&self) -> Result<ImageScannerScanSource> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).get_DefaultScanSource)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_scan_source_supported(&self, value: ImageScannerScanSource) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsScanSourceSupported)(self as *const _ as *mut _, value, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_flatbed_configuration(&self) -> Result<ComPtr<ImageScannerFlatbedConfiguration>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FlatbedConfiguration)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_feeder_configuration(&self) -> Result<ComPtr<ImageScannerFeederConfiguration>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_FeederConfiguration)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_auto_configuration(&self) -> Result<ComPtr<ImageScannerAutoConfiguration>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).get_AutoConfiguration)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn is_preview_supported(&self, scanSource: ImageScannerScanSource) -> Result<bool> {
        let mut out = zeroed();
        let hr = ((*self.lpVtbl).IsPreviewSupported)(self as *const _ as *mut _, scanSource, &mut out);
        if hr == S_OK { Ok(out) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn scan_preview_to_stream_async(&self, scanSource: ImageScannerScanSource, targetStream: &super::super::storage::streams::IRandomAccessStream) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ImageScannerPreviewResult>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ScanPreviewToStreamAsync)(self as *const _ as *mut _, scanSource, targetStream as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[cfg(feature="windows-storage")] #[inline] pub unsafe fn scan_files_to_folder_async(&self, scanSource: ImageScannerScanSource, storageFolder: &super::super::storage::StorageFolder) -> Result<ComPtr<super::super::foundation::IAsyncOperationWithProgress<ImageScannerScanResult, u32>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).ScanFilesToFolderAsync)(self as *const _ as *mut _, scanSource, storageFolder as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
}
DEFINE_IID!(IID_IImageScannerStatics, 3159877390, 55300, 17527, 159, 181, 185, 17, 181, 71, 56, 151);
RT_INTERFACE!{static interface IImageScannerStatics(IImageScannerStaticsVtbl): IInspectable(IInspectableVtbl) [IID_IImageScannerStatics] {
    fn FromIdAsync(&self, deviceId: HSTRING, out: *mut *mut super::super::foundation::IAsyncOperation<ImageScanner>) -> HRESULT,
    fn GetDeviceSelector(&self, out: *mut HSTRING) -> HRESULT
}}
impl IImageScannerStatics {
    #[inline] pub unsafe fn from_id_async(&self, deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ImageScanner>>> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).FromIdAsync)(self as *const _ as *mut _, deviceId.get(), &mut out);
        if hr == S_OK { Ok(ComPtr::wrap(out)) } else { err(hr) }
    }
    #[inline] pub unsafe fn get_device_selector(&self) -> Result<HString> {
        let mut out = null_mut();
        let hr = ((*self.lpVtbl).GetDeviceSelector)(self as *const _ as *mut _, &mut out);
        if hr == S_OK { Ok(HString::wrap(out)) } else { err(hr) }
    }
}
RT_CLASS!{class ImageScanner: IImageScanner}
impl RtActivatable<IImageScannerStatics> for ImageScanner {}
impl ImageScanner {
    #[inline] pub fn from_id_async(deviceId: &HStringArg) -> Result<ComPtr<super::super::foundation::IAsyncOperation<ImageScanner>>> { unsafe {
        <Self as RtActivatable<IImageScannerStatics>>::get_activation_factory().from_id_async(deviceId)
    }}
    #[inline] pub fn get_device_selector() -> Result<HString> { unsafe {
        <Self as RtActivatable<IImageScannerStatics>>::get_activation_factory().get_device_selector()
    }}
}
DEFINE_CLSID!(ImageScanner(&[87,105,110,100,111,119,115,46,68,101,118,105,99,101,115,46,83,99,97,110,110,101,114,115,46,73,109,97,103,101,83,99,97,110,110,101,114,0]) [CLSID_ImageScanner]);
} // Windows.Devices.Scanners
